#include "sbalgorithmidentifier.h"

zend_class_entry *TElAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAlgorithmIdentifier_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, Equals)
{
	zval *oAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithm, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithm TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateFromBuffer_Inst)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAlgorithmIdentifier_CreateFromBuffer_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAlgorithmIdentifier_CreateFromBuffer(piBuffer.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateFromTag_Inst)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAlgorithmIdentifier_CreateFromTag_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateFromTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAlgorithmIdentifier_CreateFromTag(SBGetObjectHandle(oTag TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateByAlgorithm_Inst)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAlgorithmIdentifier_CreateByAlgorithm_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateByAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAlgorithmIdentifier_CreateByAlgorithm((int32_t)l4Algorithm, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateByAlgorithmOID_Inst)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAlgorithmIdentifier_CreateByAlgorithmOID_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, CreateByAlgorithmOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAlgorithmIdentifier_CreateByAlgorithmOID(aiOID.data, aiOID.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, IsAlgorithmSupported)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAlgorithmIdentifier_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElAlgorithmIdentifier_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, LoadFromTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAlgorithmIdentifier_LoadFromTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, SaveToTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAlgorithmIdentifier_SaveToTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, WriteParameters)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAlgorithmIdentifier_WriteParameters(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-329172269, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_AlgorithmOID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAlgorithmIdentifier_get_AlgorithmOID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1017562010, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, set_AlgorithmOID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAlgorithmIdentifier_set_AlgorithmOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, set_Algorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElAlgorithmIdentifier_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_SignatureHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_get_SignatureHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_IsSignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_get_IsSignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_IsPublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_get_IsPublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_IsEncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_get_IsEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, get_IsHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAlgorithmIdentifier_get_IsHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_Equals, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Algorithm, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateFromBuffer_Inst, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateFromTag_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateFromTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateByAlgorithm_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateByAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateByAlgorithmOID_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_CreateByAlgorithmOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_IsAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_LoadFromTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_SaveToTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_WriteParameters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_AlgorithmOID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_set_AlgorithmOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_SignatureHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_IsSignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_IsPublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_IsEncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier_get_IsHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElAlgorithmIdentifier_methods[] = {
	PHP_ME(TElAlgorithmIdentifier, Assign, arginfo_TElAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, Clone, arginfo_TElAlgorithmIdentifier_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, Equals, arginfo_TElAlgorithmIdentifier_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, CreateFromBuffer_Inst, arginfo_TElAlgorithmIdentifier_CreateFromBuffer_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, CreateFromBuffer, arginfo_TElAlgorithmIdentifier_CreateFromBuffer, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAlgorithmIdentifier, CreateFromTag_Inst, arginfo_TElAlgorithmIdentifier_CreateFromTag_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, CreateFromTag, arginfo_TElAlgorithmIdentifier_CreateFromTag, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAlgorithmIdentifier, CreateByAlgorithm_Inst, arginfo_TElAlgorithmIdentifier_CreateByAlgorithm_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, CreateByAlgorithm, arginfo_TElAlgorithmIdentifier_CreateByAlgorithm, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAlgorithmIdentifier, CreateByAlgorithmOID_Inst, arginfo_TElAlgorithmIdentifier_CreateByAlgorithmOID_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, CreateByAlgorithmOID, arginfo_TElAlgorithmIdentifier_CreateByAlgorithmOID, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAlgorithmIdentifier, IsAlgorithmSupported, arginfo_TElAlgorithmIdentifier_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, LoadFromBuffer, arginfo_TElAlgorithmIdentifier_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, SaveToBuffer, arginfo_TElAlgorithmIdentifier_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, LoadFromTag, arginfo_TElAlgorithmIdentifier_LoadFromTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, SaveToTag, arginfo_TElAlgorithmIdentifier_SaveToTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, WriteParameters, arginfo_TElAlgorithmIdentifier_WriteParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_AlgorithmOID, arginfo_TElAlgorithmIdentifier_get_AlgorithmOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, set_AlgorithmOID, arginfo_TElAlgorithmIdentifier_set_AlgorithmOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_Algorithm, arginfo_TElAlgorithmIdentifier_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, set_Algorithm, arginfo_TElAlgorithmIdentifier_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_SignatureHashAlgorithm, arginfo_TElAlgorithmIdentifier_get_SignatureHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_IsSignatureAlgorithm, arginfo_TElAlgorithmIdentifier_get_IsSignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_IsPublicKeyAlgorithm, arginfo_TElAlgorithmIdentifier_get_IsPublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_IsEncryptionAlgorithm, arginfo_TElAlgorithmIdentifier_get_IsEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, get_IsHashAlgorithm, arginfo_TElAlgorithmIdentifier_get_IsHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAlgorithmIdentifier, __construct, arginfo_TElAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAlgorithmIdentifier", TElAlgorithmIdentifier_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRSAAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElRSAAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAlgorithmIdentifier, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAAlgorithmIdentifier_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAlgorithmIdentifier, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAAlgorithmIdentifier_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAlgorithmIdentifier_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAlgorithmIdentifier_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRSAAlgorithmIdentifier_methods[] = {
	PHP_ME(TElRSAAlgorithmIdentifier, Assign, arginfo_TElRSAAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAlgorithmIdentifier, get_HashAlgorithm, arginfo_TElRSAAlgorithmIdentifier_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAlgorithmIdentifier, set_HashAlgorithm, arginfo_TElRSAAlgorithmIdentifier_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAlgorithmIdentifier, __construct, arginfo_TElRSAAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRSAAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRSAAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRSAAlgorithmIdentifier", TElRSAAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElRSAAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRSAPSSAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAPSSAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPSSAlgorithmIdentifier_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPSSAlgorithmIdentifier_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, get_SaltSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPSSAlgorithmIdentifier_get_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, set_SaltSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPSSAlgorithmIdentifier_set_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, get_TrailerField)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPSSAlgorithmIdentifier_get_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, set_TrailerField)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPSSAlgorithmIdentifier_set_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, get_MGF)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPSSAlgorithmIdentifier_get_MGF(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, set_MGF)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPSSAlgorithmIdentifier_set_MGF(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, get_MGFHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPSSAlgorithmIdentifier_get_MGFHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, set_MGFHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPSSAlgorithmIdentifier_set_MGFHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPSSAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAPSSAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_get_SaltSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_set_SaltSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_get_TrailerField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_set_TrailerField, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_get_MGF, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_set_MGF, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_get_MGFHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier_set_MGFHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPSSAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRSAPSSAlgorithmIdentifier_methods[] = {
	PHP_ME(TElRSAPSSAlgorithmIdentifier, Assign, arginfo_TElRSAPSSAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, get_HashAlgorithm, arginfo_TElRSAPSSAlgorithmIdentifier_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, set_HashAlgorithm, arginfo_TElRSAPSSAlgorithmIdentifier_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, get_SaltSize, arginfo_TElRSAPSSAlgorithmIdentifier_get_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, set_SaltSize, arginfo_TElRSAPSSAlgorithmIdentifier_set_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, get_TrailerField, arginfo_TElRSAPSSAlgorithmIdentifier_get_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, set_TrailerField, arginfo_TElRSAPSSAlgorithmIdentifier_set_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, get_MGF, arginfo_TElRSAPSSAlgorithmIdentifier_get_MGF, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, set_MGF, arginfo_TElRSAPSSAlgorithmIdentifier_set_MGF, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, get_MGFHashAlgorithm, arginfo_TElRSAPSSAlgorithmIdentifier_get_MGFHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, set_MGFHashAlgorithm, arginfo_TElRSAPSSAlgorithmIdentifier_set_MGFHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPSSAlgorithmIdentifier, __construct, arginfo_TElRSAPSSAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRSAPSSAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRSAPSSAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRSAPSSAlgorithmIdentifier", TElRSAPSSAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElRSAPSSAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRSAOAEPAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, get_MGF)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_get_MGF(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, set_MGF)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_set_MGF(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, get_MGFHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_get_MGFHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, set_MGFHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_set_MGFHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, get_StrLabel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRSAOAEPAlgorithmIdentifier_get_StrLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2097319921, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, set_StrLabel)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_set_StrLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, get_WriteDefaults)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_get_WriteDefaults(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, set_WriteDefaults)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_set_WriteDefaults(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAOAEPAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAOAEPAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_get_MGF, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_set_MGF, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_get_MGFHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_set_MGFHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_get_StrLabel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_set_StrLabel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_get_WriteDefaults, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier_set_WriteDefaults, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAOAEPAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRSAOAEPAlgorithmIdentifier_methods[] = {
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, Assign, arginfo_TElRSAOAEPAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, get_HashAlgorithm, arginfo_TElRSAOAEPAlgorithmIdentifier_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, set_HashAlgorithm, arginfo_TElRSAOAEPAlgorithmIdentifier_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, get_MGF, arginfo_TElRSAOAEPAlgorithmIdentifier_get_MGF, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, set_MGF, arginfo_TElRSAOAEPAlgorithmIdentifier_set_MGF, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, get_MGFHashAlgorithm, arginfo_TElRSAOAEPAlgorithmIdentifier_get_MGFHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, set_MGFHashAlgorithm, arginfo_TElRSAOAEPAlgorithmIdentifier_set_MGFHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, get_StrLabel, arginfo_TElRSAOAEPAlgorithmIdentifier_get_StrLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, set_StrLabel, arginfo_TElRSAOAEPAlgorithmIdentifier_set_StrLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, get_WriteDefaults, arginfo_TElRSAOAEPAlgorithmIdentifier_get_WriteDefaults, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, set_WriteDefaults, arginfo_TElRSAOAEPAlgorithmIdentifier_set_WriteDefaults, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAOAEPAlgorithmIdentifier, __construct, arginfo_TElRSAOAEPAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRSAOAEPAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRSAOAEPAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRSAOAEPAlgorithmIdentifier", TElRSAOAEPAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElRSAOAEPAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDSAAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAAlgorithmIdentifier_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-139438250, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, set_P)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAAlgorithmIdentifier_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAAlgorithmIdentifier_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2135464000, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, set_Q)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAAlgorithmIdentifier_set_Q(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAAlgorithmIdentifier_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1952699025, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, set_G)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAAlgorithmIdentifier_set_G(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_set_P, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_set_Q, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier_set_G, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDSAAlgorithmIdentifier_methods[] = {
	PHP_ME(TElDSAAlgorithmIdentifier, Assign, arginfo_TElDSAAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, get_P, arginfo_TElDSAAlgorithmIdentifier_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, set_P, arginfo_TElDSAAlgorithmIdentifier_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, get_Q, arginfo_TElDSAAlgorithmIdentifier_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, set_Q, arginfo_TElDSAAlgorithmIdentifier_set_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, get_G, arginfo_TElDSAAlgorithmIdentifier_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, set_G, arginfo_TElDSAAlgorithmIdentifier_set_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAAlgorithmIdentifier, __construct, arginfo_TElDSAAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDSAAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDSAAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDSAAlgorithmIdentifier", TElDSAAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElDSAAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDHAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElDHAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHAlgorithmIdentifier_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-311385559, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, set_P)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHAlgorithmIdentifier_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHAlgorithmIdentifier_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1703439681, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, set_Q)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHAlgorithmIdentifier_set_Q(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHAlgorithmIdentifier_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1856186350, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, set_G)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHAlgorithmIdentifier_set_G(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_set_P, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_set_Q, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier_set_G, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDHAlgorithmIdentifier_methods[] = {
	PHP_ME(TElDHAlgorithmIdentifier, Assign, arginfo_TElDHAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, get_P, arginfo_TElDHAlgorithmIdentifier_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, set_P, arginfo_TElDHAlgorithmIdentifier_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, get_Q, arginfo_TElDHAlgorithmIdentifier_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, set_Q, arginfo_TElDHAlgorithmIdentifier_set_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, get_G, arginfo_TElDHAlgorithmIdentifier_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, set_G, arginfo_TElDHAlgorithmIdentifier_set_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHAlgorithmIdentifier, __construct, arginfo_TElDHAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDHAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDHAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDHAlgorithmIdentifier", TElDHAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElDHAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElECAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElECAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_Version)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_Curve)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-333768924, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_Curve)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_FieldID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_FieldID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-390364506, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_FieldID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_FieldID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_FieldType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_FieldType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_FieldType)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_FieldType(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_Basis)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_Basis(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(910962596, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_Basis)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_Basis(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_M)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_M(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_M)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_M(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_K1)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_K1(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_K1)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_K1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_K2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_K2(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_K2)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_K2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_K3)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_K3(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_K3)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_K3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_SpecifiedCurve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_SpecifiedCurve(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_SpecifiedCurve)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_SpecifiedCurve(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_CompressPoints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_CompressPoints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_CompressPoints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_CompressPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_HybridPoints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_HybridPoints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_HybridPoints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_HybridPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_ImplicitCurve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_ImplicitCurve(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_ImplicitCurve)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_ImplicitCurve(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_Seed)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1025506411, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_Seed)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(612530476, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_P)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_N)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_N(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-561167281, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_N)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_N(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_H)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECAlgorithmIdentifier_get_H(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_H)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECAlgorithmIdentifier_set_H(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_A)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_A(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1311922654, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_A)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_A(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_B)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_B(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-683997084, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_B)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_B(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(710537502, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_X)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_X(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1566491016, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_Y)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_Y(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, get_Base)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECAlgorithmIdentifier_get_Base(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1188241138, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, set_Base)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECAlgorithmIdentifier_set_Base(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_Curve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_Curve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_FieldID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_FieldID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_FieldType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_FieldType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_Basis, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_Basis, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_M, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_M, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_K1, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_K1, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_K2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_K2, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_K3, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_K3, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_SpecifiedCurve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_SpecifiedCurve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_CompressPoints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_CompressPoints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_HybridPoints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_HybridPoints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_ImplicitCurve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_ImplicitCurve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_Seed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_Seed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_P, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_N, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_N, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_H, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_H, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_A, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_A, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_B, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_B, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_X, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_Y, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_get_Base, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier_set_Base, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElECAlgorithmIdentifier_methods[] = {
	PHP_ME(TElECAlgorithmIdentifier, Assign, arginfo_TElECAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_Version, arginfo_TElECAlgorithmIdentifier_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_Version, arginfo_TElECAlgorithmIdentifier_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_Curve, arginfo_TElECAlgorithmIdentifier_get_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_Curve, arginfo_TElECAlgorithmIdentifier_set_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_FieldID, arginfo_TElECAlgorithmIdentifier_get_FieldID, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_FieldID, arginfo_TElECAlgorithmIdentifier_set_FieldID, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_FieldType, arginfo_TElECAlgorithmIdentifier_get_FieldType, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_FieldType, arginfo_TElECAlgorithmIdentifier_set_FieldType, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_Basis, arginfo_TElECAlgorithmIdentifier_get_Basis, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_Basis, arginfo_TElECAlgorithmIdentifier_set_Basis, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_M, arginfo_TElECAlgorithmIdentifier_get_M, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_M, arginfo_TElECAlgorithmIdentifier_set_M, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_K1, arginfo_TElECAlgorithmIdentifier_get_K1, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_K1, arginfo_TElECAlgorithmIdentifier_set_K1, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_K2, arginfo_TElECAlgorithmIdentifier_get_K2, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_K2, arginfo_TElECAlgorithmIdentifier_set_K2, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_K3, arginfo_TElECAlgorithmIdentifier_get_K3, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_K3, arginfo_TElECAlgorithmIdentifier_set_K3, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_HashAlgorithm, arginfo_TElECAlgorithmIdentifier_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_HashAlgorithm, arginfo_TElECAlgorithmIdentifier_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_SpecifiedCurve, arginfo_TElECAlgorithmIdentifier_get_SpecifiedCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_SpecifiedCurve, arginfo_TElECAlgorithmIdentifier_set_SpecifiedCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_CompressPoints, arginfo_TElECAlgorithmIdentifier_get_CompressPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_CompressPoints, arginfo_TElECAlgorithmIdentifier_set_CompressPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_HybridPoints, arginfo_TElECAlgorithmIdentifier_get_HybridPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_HybridPoints, arginfo_TElECAlgorithmIdentifier_set_HybridPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_ImplicitCurve, arginfo_TElECAlgorithmIdentifier_get_ImplicitCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_ImplicitCurve, arginfo_TElECAlgorithmIdentifier_set_ImplicitCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_Seed, arginfo_TElECAlgorithmIdentifier_get_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_Seed, arginfo_TElECAlgorithmIdentifier_set_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_P, arginfo_TElECAlgorithmIdentifier_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_P, arginfo_TElECAlgorithmIdentifier_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_N, arginfo_TElECAlgorithmIdentifier_get_N, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_N, arginfo_TElECAlgorithmIdentifier_set_N, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_H, arginfo_TElECAlgorithmIdentifier_get_H, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_H, arginfo_TElECAlgorithmIdentifier_set_H, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_A, arginfo_TElECAlgorithmIdentifier_get_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_A, arginfo_TElECAlgorithmIdentifier_set_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_B, arginfo_TElECAlgorithmIdentifier_get_B, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_B, arginfo_TElECAlgorithmIdentifier_set_B, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_X, arginfo_TElECAlgorithmIdentifier_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_X, arginfo_TElECAlgorithmIdentifier_set_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_Y, arginfo_TElECAlgorithmIdentifier_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_Y, arginfo_TElECAlgorithmIdentifier_set_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, get_Base, arginfo_TElECAlgorithmIdentifier_get_Base, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, set_Base, arginfo_TElECAlgorithmIdentifier_set_Base, ZEND_ACC_PUBLIC)
	PHP_ME(TElECAlgorithmIdentifier, __construct, arginfo_TElECAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElECAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElECAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElECAlgorithmIdentifier", TElECAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElECAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElECDSAAlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElECDSAAlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECDSAAlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAAlgorithmIdentifier, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECDSAAlgorithmIdentifier_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAAlgorithmIdentifier, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECDSAAlgorithmIdentifier_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAAlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDSAAlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAAlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAAlgorithmIdentifier_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAAlgorithmIdentifier_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAAlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElECDSAAlgorithmIdentifier_methods[] = {
	PHP_ME(TElECDSAAlgorithmIdentifier, Assign, arginfo_TElECDSAAlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAAlgorithmIdentifier, get_HashAlgorithm, arginfo_TElECDSAAlgorithmIdentifier_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAAlgorithmIdentifier, set_HashAlgorithm, arginfo_TElECDSAAlgorithmIdentifier_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAAlgorithmIdentifier, __construct, arginfo_TElECDSAAlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElECDSAAlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElECDSAAlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElECDSAAlgorithmIdentifier", TElECDSAAlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElECDSAAlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST3411AlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST3411AlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST3411AlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3411AlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST3411AlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3411AlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3411AlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST3411AlgorithmIdentifier_methods[] = {
	PHP_ME(TElGOST3411AlgorithmIdentifier, Assign, arginfo_TElGOST3411AlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3411AlgorithmIdentifier, __construct, arginfo_TElGOST3411AlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST3411AlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST3411AlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST3411AlgorithmIdentifier", TElGOST3411AlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElGOST3411AlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST3410AlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST3410AlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, get_PublicKeyParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST3410AlgorithmIdentifier_get_PublicKeyParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1381064254, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, set_PublicKeyParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST3410AlgorithmIdentifier_set_PublicKeyParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, get_DigestParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST3410AlgorithmIdentifier_get_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1900207370, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, set_DigestParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST3410AlgorithmIdentifier_set_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, get_EncryptionParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST3410AlgorithmIdentifier_get_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(169018850, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, set_EncryptionParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST3410AlgorithmIdentifier_set_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3410AlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST3410AlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_get_PublicKeyParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_set_PublicKeyParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_get_DigestParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_set_DigestParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_get_EncryptionParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier_set_EncryptionParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3410AlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST3410AlgorithmIdentifier_methods[] = {
	PHP_ME(TElGOST3410AlgorithmIdentifier, Assign, arginfo_TElGOST3410AlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, get_PublicKeyParamSet, arginfo_TElGOST3410AlgorithmIdentifier_get_PublicKeyParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, set_PublicKeyParamSet, arginfo_TElGOST3410AlgorithmIdentifier_set_PublicKeyParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, get_DigestParamSet, arginfo_TElGOST3410AlgorithmIdentifier_get_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, set_DigestParamSet, arginfo_TElGOST3410AlgorithmIdentifier_set_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, get_EncryptionParamSet, arginfo_TElGOST3410AlgorithmIdentifier_get_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, set_EncryptionParamSet, arginfo_TElGOST3410AlgorithmIdentifier_set_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3410AlgorithmIdentifier, __construct, arginfo_TElGOST3410AlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST3410AlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST3410AlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST3410AlgorithmIdentifier", TElGOST3410AlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElGOST3410AlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST3411WithGOST3410AlgorithmIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST3411WithGOST3410AlgorithmIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST3411WithGOST3410AlgorithmIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST3411WithGOST3410AlgorithmIdentifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST3411WithGOST3410AlgorithmIdentifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3411WithGOST3410AlgorithmIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST3411WithGOST3410AlgorithmIdentifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST3411WithGOST3410AlgorithmIdentifier_methods[] = {
	PHP_ME(TElGOST3411WithGOST3410AlgorithmIdentifier, Assign, arginfo_TElGOST3411WithGOST3410AlgorithmIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST3411WithGOST3410AlgorithmIdentifier, __construct, arginfo_TElGOST3411WithGOST3410AlgorithmIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST3411WithGOST3410AlgorithmIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST3411WithGOST3410AlgorithmIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST3411WithGOST3410AlgorithmIdentifier", TElGOST3411WithGOST3410AlgorithmIdentifier_methods);
	if (NULL == TElAlgorithmIdentifier_ce_ptr)
		Register_TElAlgorithmIdentifier(TSRMLS_C);
	TElGOST3411WithGOST3410AlgorithmIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAlgorithmIdentifier_ce_ptr, NULL TSRMLS_CC);
}

