#include "sbascommon.h"

zend_class_entry *TSBASSignatureDigestAlgorithm_ce_ptr = NULL;

zend_class_entry *TSBASCharsetMode_ce_ptr = NULL;

zend_class_entry *TSBASHeaderTransferEncoding_ce_ptr = NULL;

zend_class_entry *TSBASDataTransferEncoding_ce_ptr = NULL;

zend_class_entry *TSBASEncryptionTransferEncoding_ce_ptr = NULL;

zend_class_entry *TSBASSignatureTransferEncoding_ce_ptr = NULL;

zend_class_entry *TSBASCompressionTransferEncoding_ce_ptr = NULL;

zend_class_entry *TSBASDispositionActionMode_ce_ptr = NULL;

zend_class_entry *TSBASDispositionSendingMode_ce_ptr = NULL;

zend_class_entry *TSBASDispositionStatus_ce_ptr = NULL;

zend_class_entry *TSBASDispositionModifier_ce_ptr = NULL;

zend_class_entry *TSBASMessageProcessingStep_ce_ptr = NULL;

zend_class_entry *TSBASHeaderScope_ce_ptr = NULL;

zend_class_entry *TSBASHeaderScopes_ce_ptr = NULL;

zend_class_entry *TSBASSMIMEVerificationOption_ce_ptr = NULL;

zend_class_entry *TSBASSMIMEVerificationOptions_ce_ptr = NULL;

void SB_CALLBACK TSBASErrorNotifyEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Code, const char * pcDescription, int32_t szDescription, int8_t Critical, TSBASDispositionModifierRaw Modifier)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCode;
	zval * zDescription;
	zval * zCritical;
	zval * zModifier;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCode);
	ZVAL_LONG(zCode, (long)Code);
	MAKE_STD_ZVAL(zDescription);
	ZVAL_STRINGL(zDescription, pcDescription, szDescription, 1);
	MAKE_STD_ZVAL(zCritical);
	ZVAL_BOOL(zCritical, (zend_bool)Critical);
	MAKE_STD_ZVAL(zModifier);
	ZVAL_LONG(zModifier, (long)Modifier);

	params[0] = &zSender;
	params[1] = &zCode;
	params[2] = &zDescription;
	params[3] = &zCritical;
	params[4] = &zModifier;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCode);
	zval_ptr_dtor(&zDescription);
	zval_ptr_dtor(&zCritical);
	zval_ptr_dtor(&zModifier);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASMessageDecryptEventRaw(void * _ObjectData, TObjectHandle Sender, TElASMessageDecryptorHandle Decryptor)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zDecryptor;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDecryptor);
	SBInitObject(zDecryptor, TElASMessageDecryptor_ce_ptr, Decryptor TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zDecryptor;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDecryptor);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASMessageEncryptEventRaw(void * _ObjectData, TObjectHandle Sender, TElASMessageEncryptorHandle Encryptor)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zEncryptor;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEncryptor);
	SBInitObject(zEncryptor, TElASMessageEncryptor_ce_ptr, Encryptor TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEncryptor;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEncryptor);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASMessageSignEventRaw(void * _ObjectData, TObjectHandle Sender, TElASMessageSignerHandle Signer)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSigner;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSigner);
	SBInitObject(zSigner, TElASMessageSigner_ce_ptr, Signer TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSigner;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSigner);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASMessageVerifyEventRaw(void * _ObjectData, TObjectHandle Sender, TElASMessageVerifierHandle Verifier)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zVerifier;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zVerifier);
	SBInitObject(zVerifier, TElASMessageVerifier_ce_ptr, Verifier TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zVerifier;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zVerifier);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASHeaderEventRaw(void * _ObjectData, TObjectHandle Sender, TElMessageHeaderHandle Header, TSBASHeaderScopesRaw Scopes)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zHeader;
	zval * zScopes;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHeader);
	SBInitObject(zHeader, TElMessageHeader_ce_ptr, Header TSRMLS_CC);
	MAKE_STD_ZVAL(zScopes);
	ZVAL_LONG(zScopes, (long)Scopes);

	params[0] = &zSender;
	params[1] = &zHeader;
	params[2] = &zScopes;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHeader);
	zval_ptr_dtor(&zScopes);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASStreamRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream, int8_t * FreeOnFinish)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStream;
	zval * zFreeOnFinish;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	ZVAL_NULL(zStream);
	MAKE_STD_ZVAL(zFreeOnFinish);
	ZVAL_FALSE(zFreeOnFinish);

	params[0] = &zSender;
	params[1] = &zStream;
	params[2] = &zFreeOnFinish;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	*FreeOnFinish = (int8_t)Z_BVAL_P(zFreeOnFinish);
	zval_ptr_dtor(&zFreeOnFinish);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASStreamReleaseEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASMessageErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Code, const char * pcDescription, int32_t szDescription, int8_t Critical, TSBASDispositionModifierRaw * Modifier, char * pcReportTag, int32_t * szReportTag, int8_t * Ignore)
{
	zval *retval_ptr;
	zval **params[7];
	zval * zSender;
	zval * zCode;
	zval * zDescription;
	zval * zCritical;
	zval * zModifier;
	zval * zReportTag;
	zval * zIgnore;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCode);
	ZVAL_LONG(zCode, (long)Code);
	MAKE_STD_ZVAL(zDescription);
	ZVAL_STRINGL(zDescription, pcDescription, szDescription, 1);
	MAKE_STD_ZVAL(zCritical);
	ZVAL_BOOL(zCritical, (zend_bool)Critical);
	MAKE_STD_ZVAL(zModifier);
	ZVAL_LONG(zModifier, (long)*Modifier);
	MAKE_STD_ZVAL(zReportTag);
	ZVAL_STRINGL(zReportTag, pcReportTag, *szReportTag, 1);
	MAKE_STD_ZVAL(zIgnore);
	ZVAL_BOOL(zIgnore, (zend_bool)*Ignore);

	params[0] = &zSender;
	params[1] = &zCode;
	params[2] = &zDescription;
	params[3] = &zCritical;
	params[4] = &zModifier;
	params[5] = &zReportTag;
	params[6] = &zIgnore;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 7, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCode);
	zval_ptr_dtor(&zDescription);
	zval_ptr_dtor(&zCritical);
	*Modifier = (TSBASDispositionModifierRaw)Z_LVAL_P(zModifier);
	zval_ptr_dtor(&zModifier);
	SBCheckError(SBSetEventReturnStringA(6, Z_STRVAL_P(zReportTag), (int32_t)Z_STRLEN_P(zReportTag)) TSRMLS_CC);
	zval_ptr_dtor(&zReportTag);
	*Ignore = (int8_t)Z_BVAL_P(zIgnore);
	zval_ptr_dtor(&zIgnore);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASProcessingStepStartRaw(void * _ObjectData, TObjectHandle Sender, TSBASMessageProcessingStepRaw Step, int8_t ProgressAvailable)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStep;
	zval * zProgressAvailable;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStep);
	ZVAL_LONG(zStep, (long)Step);
	MAKE_STD_ZVAL(zProgressAvailable);
	ZVAL_BOOL(zProgressAvailable, (zend_bool)ProgressAvailable);

	params[0] = &zSender;
	params[1] = &zStep;
	params[2] = &zProgressAvailable;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStep);
	zval_ptr_dtor(&zProgressAvailable);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBASReceiptErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Code, const char * pcMessage, int32_t szMessage, int8_t Critical, int8_t * Ignore)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCode;
	zval * zMessage;
	zval * zCritical;
	zval * zIgnore;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCode);
	ZVAL_LONG(zCode, (long)Code);
	MAKE_STD_ZVAL(zMessage);
	ZVAL_STRINGL(zMessage, pcMessage, szMessage, 1);
	MAKE_STD_ZVAL(zCritical);
	ZVAL_BOOL(zCritical, (zend_bool)Critical);
	MAKE_STD_ZVAL(zIgnore);
	ZVAL_BOOL(zIgnore, (zend_bool)*Ignore);

	params[0] = &zSender;
	params[1] = &zCode;
	params[2] = &zMessage;
	params[3] = &zCritical;
	params[4] = &zIgnore;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCode);
	zval_ptr_dtor(&zMessage);
	zval_ptr_dtor(&zCritical);
	*Ignore = (int8_t)Z_BVAL_P(zIgnore);
	zval_ptr_dtor(&zIgnore);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElASReceiptRequest_ce_ptr = NULL;

SB_PHP_METHOD(TElASReceiptRequest, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASReceiptRequest_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceiptRequest, GetDigestAlgorithmPriority)
{
	long fAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASReceiptRequest_GetDigestAlgorithmPriority(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASSignatureDigestAlgorithmRaw)fAlgorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceiptRequest, SetDigestAlgorithmPriority)
{
	long fAlgorithm;
	long l4Priority;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &fAlgorithm, &l4Priority) == SUCCESS)
	{
		SBCheckError(TElASReceiptRequest_SetDigestAlgorithmPriority(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASSignatureDigestAlgorithmRaw)fAlgorithm, (int32_t)l4Priority) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceiptRequest, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASReceiptRequest_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceiptRequest_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceiptRequest_GetDigestAlgorithmPriority, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceiptRequest_SetDigestAlgorithmPriority, 0, 0, 2)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, Priority)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceiptRequest___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASReceiptRequest_methods[] = {
	PHP_ME(TElASReceiptRequest, Assign, arginfo_TElASReceiptRequest_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceiptRequest, GetDigestAlgorithmPriority, arginfo_TElASReceiptRequest_GetDigestAlgorithmPriority, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceiptRequest, SetDigestAlgorithmPriority, arginfo_TElASReceiptRequest_SetDigestAlgorithmPriority, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceiptRequest, __construct, arginfo_TElASReceiptRequest___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASReceiptRequest(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASReceiptRequest_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASReceiptRequest", TElASReceiptRequest_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASReceiptRequest_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageDecryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageDecryptor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageDecryptor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageDecryptor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageDecryptor_methods[] = {
	PHP_ME(TElASMessageDecryptor, __construct, arginfo_TElASMessageDecryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageDecryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageDecryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageDecryptor", TElASMessageDecryptor_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASMessageDecryptor_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageEncryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageEncryptor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageEncryptor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageEncryptor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageEncryptor_methods[] = {
	PHP_ME(TElASMessageEncryptor, __construct, arginfo_TElASMessageEncryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageEncryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageEncryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageEncryptor", TElASMessageEncryptor_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASMessageEncryptor_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASEncryption_ce_ptr = NULL;

SB_PHP_METHOD(TElASEncryption, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASEncryption_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASEncryption, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASEncryption_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASEncryption, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASEncryption_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASEncryption_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASEncryption_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASEncryption___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASEncryption_methods[] = {
	PHP_ME(TElASEncryption, Assign, arginfo_TElASEncryption_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASEncryption, Clear, arginfo_TElASEncryption_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASEncryption, __construct, arginfo_TElASEncryption___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASEncryption(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASEncryption_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASEncryption", TElASEncryption_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASEncryption_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMEMessageDecryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMEMessageDecryptor, get_Decryptor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageDecryptor_get_Decryptor(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMessageDecryptor_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMEMessageDecryptor, __construct)
{
	zval *oADecryptor;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oADecryptor, TElMessageDecryptor_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageDecryptor_Create(SBGetObjectHandle(oADecryptor TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElMessageDecryptor)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageDecryptor_get_Decryptor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageDecryptor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ADecryptor, TElMessageDecryptor, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMEMessageDecryptor_methods[] = {
	PHP_ME(TElASSMIMEMessageDecryptor, get_Decryptor, arginfo_TElASSMIMEMessageDecryptor_get_Decryptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMEMessageDecryptor, __construct, arginfo_TElASSMIMEMessageDecryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMEMessageDecryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMEMessageDecryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMEMessageDecryptor", TElASSMIMEMessageDecryptor_methods);
	if (NULL == TElASMessageDecryptor_ce_ptr)
		Register_TElASMessageDecryptor(TSRMLS_C);
	TElASSMIMEMessageDecryptor_ce_ptr = zend_register_internal_class_ex(&ce, TElASMessageDecryptor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMEMessageEncryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMEMessageEncryptor, get_Encryptor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageEncryptor_get_Encryptor(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMessageEncryptor_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMEMessageEncryptor, __construct)
{
	zval *oAEncryptor;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAEncryptor, TElMessageEncryptor_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageEncryptor_Create(SBGetObjectHandle(oAEncryptor TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElMessageEncryptor)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageEncryptor_get_Encryptor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageEncryptor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AEncryptor, TElMessageEncryptor, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMEMessageEncryptor_methods[] = {
	PHP_ME(TElASSMIMEMessageEncryptor, get_Encryptor, arginfo_TElASSMIMEMessageEncryptor_get_Encryptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMEMessageEncryptor, __construct, arginfo_TElASSMIMEMessageEncryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMEMessageEncryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMEMessageEncryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMEMessageEncryptor", TElASSMIMEMessageEncryptor_methods);
	if (NULL == TElASMessageEncryptor_ce_ptr)
		Register_TElASMessageEncryptor(TSRMLS_C);
	TElASSMIMEMessageEncryptor_ce_ptr = zend_register_internal_class_ex(&ce, TElASMessageEncryptor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMEEncryption_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMEEncryption, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASSMIMEEncryption_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMEEncryption, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEEncryption_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEEncryption_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEEncryption___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMEEncryption_methods[] = {
	PHP_ME(TElASSMIMEEncryption, Assign, arginfo_TElASSMIMEEncryption_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMEEncryption, __construct, arginfo_TElASSMIMEEncryption___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMEEncryption(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMEEncryption_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMEEncryption", TElASSMIMEEncryption_methods);
	if (NULL == TElASEncryption_ce_ptr)
		Register_TElASEncryption(TSRMLS_C);
	TElASSMIMEEncryption_ce_ptr = zend_register_internal_class_ex(&ce, TElASEncryption_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageSigner, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageSigner_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageSigner___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageSigner_methods[] = {
	PHP_ME(TElASMessageSigner, __construct, arginfo_TElASMessageSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageSigner", TElASMessageSigner_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASMessageSigner_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageVerifier_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageVerifier, get_Result)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASMessageVerifier_get_Result(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageVerifier, set_Result)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElASMessageVerifier_set_Result(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageVerifier, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageVerifier_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageVerifier_get_Result, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageVerifier_set_Result, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageVerifier___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageVerifier_methods[] = {
	PHP_ME(TElASMessageVerifier, get_Result, arginfo_TElASMessageVerifier_get_Result, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageVerifier, set_Result, arginfo_TElASMessageVerifier_set_Result, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageVerifier, __construct, arginfo_TElASMessageVerifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageVerifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageVerifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageVerifier", TElASMessageVerifier_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASMessageVerifier_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSignature_ce_ptr = NULL;

SB_PHP_METHOD(TElASSignature, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASSignature_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSignature, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASSignature_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSignature, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSignature_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSignature_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSignature_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSignature___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSignature_methods[] = {
	PHP_ME(TElASSignature, Assign, arginfo_TElASSignature_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSignature, Clear, arginfo_TElASSignature_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSignature, __construct, arginfo_TElASSignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSignature", TElASSignature_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASSignature_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMEMessageSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMEMessageSigner, get_Signer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageSigner_get_Signer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMessageSigner_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMEMessageSigner, __construct)
{
	zval *oASigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oASigner, TElMessageSigner_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageSigner_Create(SBGetObjectHandle(oASigner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElMessageSigner)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageSigner_get_Signer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageSigner___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ASigner, TElMessageSigner, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMEMessageSigner_methods[] = {
	PHP_ME(TElASSMIMEMessageSigner, get_Signer, arginfo_TElASSMIMEMessageSigner_get_Signer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMEMessageSigner, __construct, arginfo_TElASSMIMEMessageSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMEMessageSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMEMessageSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMEMessageSigner", TElASSMIMEMessageSigner_methods);
	if (NULL == TElASMessageSigner_ce_ptr)
		Register_TElASMessageSigner(TSRMLS_C);
	TElASSMIMEMessageSigner_ce_ptr = zend_register_internal_class_ex(&ce, TElASMessageSigner_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMEMessageVerifier_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMEMessageVerifier, get_Verifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageVerifier_get_Verifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMessageVerifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMEMessageVerifier, __construct)
{
	long l4AResult;
	zval *oAVerifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4AResult, &oAVerifier, TElMessageVerifier_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMEMessageVerifier_Create((int32_t)l4AResult, SBGetObjectHandle(oAVerifier TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElMessageVerifier)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageVerifier_get_Verifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMEMessageVerifier___construct, 0, 0, 2)
	ZEND_ARG_INFO(0, AResult)
	ZEND_ARG_OBJ_INFO(0, AVerifier, TElMessageVerifier, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMEMessageVerifier_methods[] = {
	PHP_ME(TElASSMIMEMessageVerifier, get_Verifier, arginfo_TElASSMIMEMessageVerifier_get_Verifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMEMessageVerifier, __construct, arginfo_TElASSMIMEMessageVerifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMEMessageVerifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMEMessageVerifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMEMessageVerifier", TElASSMIMEMessageVerifier_methods);
	if (NULL == TElASMessageVerifier_ce_ptr)
		Register_TElASMessageVerifier(TSRMLS_C);
	TElASSMIMEMessageVerifier_ce_ptr = zend_register_internal_class_ex(&ce, TElASMessageVerifier_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMESignature_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMESignature, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASSMIMESignature_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMESignature, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASSMIMESignature_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMESignature, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMESignature_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMESignature_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMESignature_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMESignature___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMESignature_methods[] = {
	PHP_ME(TElASSMIMESignature, Assign, arginfo_TElASSMIMESignature_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMESignature, Clear, arginfo_TElASSMIMESignature_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMESignature, __construct, arginfo_TElASSMIMESignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMESignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMESignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMESignature", TElASSMIMESignature_methods);
	if (NULL == TElASSignature_ce_ptr)
		Register_TElASSignature(TSRMLS_C);
	TElASSMIMESignature_ce_ptr = zend_register_internal_class_ex(&ce, TElASSignature_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASCompression_ce_ptr = NULL;

SB_PHP_METHOD(TElASCompression, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASCompression_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASCompression, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASCompression_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASCompression, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASCompression_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASCompression_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASCompression_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASCompression___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASCompression_methods[] = {
	PHP_ME(TElASCompression, Assign, arginfo_TElASCompression_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASCompression, Clear, arginfo_TElASCompression_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASCompression, __construct, arginfo_TElASCompression___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASCompression(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASCompression_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASCompression", TElASCompression_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASCompression_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASSMIMECompression_ce_ptr = NULL;

SB_PHP_METHOD(TElASSMIMECompression, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASSMIMECompression_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASSMIMECompression, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASSMIMECompression_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMECompression_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASSMIMECompression___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASSMIMECompression_methods[] = {
	PHP_ME(TElASSMIMECompression, Assign, arginfo_TElASSMIMECompression_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASSMIMECompression, __construct, arginfo_TElASSMIMECompression___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASSMIMECompression(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASSMIMECompression_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASSMIMECompression", TElASSMIMECompression_methods);
	if (NULL == TElASCompression_ce_ptr)
		Register_TElASCompression(TSRMLS_C);
	TElASSMIMECompression_ce_ptr = zend_register_internal_class_ex(&ce, TElASCompression_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageError_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageError, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessageError_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, get_Code)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASMessageError_get_Code(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, set_Code)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElASMessageError_set_Code(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElASMessageError_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(815009424, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElASMessageError_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, get_Modifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASDispositionModifierRaw fOutResultRaw = 0;
		SBCheckError(TElASMessageError_get_Modifier(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, get_Summary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElASMessageError_get_Summary(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1357308635, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageError, __construct)
{
	char *sADescription;
	char *sASummary;
	int sADescription_len;
	int sASummary_len;
	long fAModifier;
	long l4ACode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageError_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lssl", &l4ACode, &sASummary, &sASummary_len, &sADescription, &sADescription_len, &fAModifier) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageError_Create_1((int32_t)l4ACode, sASummary, (int32_t)sASummary_len, sADescription, (int32_t)sADescription_len, (TSBASDispositionModifierRaw)fAModifier, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer, string, string, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_get_Code, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_set_Code, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_get_Modifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError_get_Summary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageError___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, ACode)
	ZEND_ARG_INFO(0, ASummary)
	ZEND_ARG_INFO(0, ADescription)
	ZEND_ARG_INFO(0, AModifier)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageError_methods[] = {
	PHP_ME(TElASMessageError, Assign, arginfo_TElASMessageError_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, get_Code, arginfo_TElASMessageError_get_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, set_Code, arginfo_TElASMessageError_set_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, get_Description, arginfo_TElASMessageError_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, set_Description, arginfo_TElASMessageError_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, get_Modifier, arginfo_TElASMessageError_get_Modifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, get_Summary, arginfo_TElASMessageError_get_Summary, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageError, __construct, arginfo_TElASMessageError___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageError(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageError_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageError", TElASMessageError_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASMessageError_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageErrorList_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageErrorList, Add)
{
	char *sADescription;
	char *sASummary;
	int sADescription_len;
	int sASummary_len;
	long fAModifier;
	long l4ACode;
	zend_bool bAdjust;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsslb", &l4ACode, &sASummary, &sASummary_len, &sADescription, &sADescription_len, &fAModifier, &bAdjust) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASMessageErrorList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ACode, sASummary, (int32_t)sASummary_len, sADescription, (int32_t)sADescription_len, (TSBASDispositionModifierRaw)fAModifier, (int8_t)bAdjust, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, First)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageErrorList_First(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASMessageError_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, IndexOf)
{
	long l4Code;
	zval *oError;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oError, TElASMessageError_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASMessageErrorList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oError TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Code) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASMessageErrorList_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Code, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASMessageError) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, Last)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageErrorList_Last(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASMessageError_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, Sort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_Sort(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASMessageErrorList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageErrorList_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASMessageError_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, set_Items)
{
	long l4Index;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oValue, TElASMessageError_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_set_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElASMessageError)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, get_Modifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASDispositionModifierRaw fOutResultRaw = 0;
		SBCheckError(TElASMessageErrorList_get_Modifier(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, set_Modifier)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_set_Modifier(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASDispositionModifierRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, get_Status)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASDispositionStatusRaw fOutResultRaw = 0;
		SBCheckError(TElASMessageErrorList_get_Status(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, set_Status)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElASMessageErrorList_set_Status(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASDispositionStatusRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageErrorList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageErrorList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_Add, 0, 0, 5)
	ZEND_ARG_INFO(0, ACode)
	ZEND_ARG_INFO(0, ASummary)
	ZEND_ARG_INFO(0, ADescription)
	ZEND_ARG_INFO(0, AModifier)
	ZEND_ARG_INFO(0, Adjust)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_First, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Error_or_Code, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_Last, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_Sort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_set_Items, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Value, TElASMessageError, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_get_Modifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_set_Modifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_get_Status, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList_set_Status, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageErrorList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageErrorList_methods[] = {
	PHP_ME(TElASMessageErrorList, Add, arginfo_TElASMessageErrorList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, Assign, arginfo_TElASMessageErrorList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, Clear, arginfo_TElASMessageErrorList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, Delete, arginfo_TElASMessageErrorList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, First, arginfo_TElASMessageErrorList_First, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, IndexOf, arginfo_TElASMessageErrorList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, Last, arginfo_TElASMessageErrorList_Last, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, Sort, arginfo_TElASMessageErrorList_Sort, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, get_Count, arginfo_TElASMessageErrorList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, get_Items, arginfo_TElASMessageErrorList_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, set_Items, arginfo_TElASMessageErrorList_set_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, get_Modifier, arginfo_TElASMessageErrorList_get_Modifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, set_Modifier, arginfo_TElASMessageErrorList_set_Modifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, get_Status, arginfo_TElASMessageErrorList_get_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, set_Status, arginfo_TElASMessageErrorList_set_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageErrorList, __construct, arginfo_TElASMessageErrorList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageErrorList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageErrorList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageErrorList", TElASMessageErrorList_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElASMessageErrorList_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessageContentDigests_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessageContentDigests, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElASMessageContentDigests_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessageContentDigests_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASMessageContentDigests)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageContentDigests, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASMessageContentDigests_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageContentDigests, Finish)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASMessageContentDigests_Finish(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageContentDigests, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASMessageContentDigests_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageContentDigests, Update)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASMessageContentDigests_Update(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageContentDigests, get_Value)
{
	long fAlgorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElASMessageContentDigests_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASSignatureDigestAlgorithmRaw)fAlgorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(274128804, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessageContentDigests, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessageContentDigests_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElASMessageContentDigests, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests_Finish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests_Update, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests_get_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessageContentDigests___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessageContentDigests_methods[] = {
	PHP_ME(TElASMessageContentDigests, Assign, arginfo_TElASMessageContentDigests_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageContentDigests, Clear, arginfo_TElASMessageContentDigests_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageContentDigests, Finish, arginfo_TElASMessageContentDigests_Finish, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageContentDigests, Init, arginfo_TElASMessageContentDigests_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageContentDigests, Update, arginfo_TElASMessageContentDigests_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageContentDigests, get_Value, arginfo_TElASMessageContentDigests_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessageContentDigests, __construct, arginfo_TElASMessageContentDigests___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessageContentDigests(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessageContentDigests_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessageContentDigests", TElASMessageContentDigests_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElASMessageContentDigests_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASReceipt_ce_ptr = NULL;

SB_PHP_METHOD(TElASReceipt, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASReceipt_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceipt, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASReceipt_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceipt, Load)
{
	char *sFileName;
	int sFileName_len;
	zval *oReceiptBody;
	zval *oReceiptHeaders;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASReceipt_Load(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oReceiptHeaders, TStream_ce_ptr, &oReceiptBody, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASReceipt_Load_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oReceiptHeaders TSRMLS_CC), SBGetObjectHandle(oReceiptBody TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASReceipt_Load_2(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceipt, Save)
{
	char *sFileName;
	int sFileName_len;
	zval *oBodyStream;
	zval *oHeadersStream;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASReceipt_Save(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHeadersStream, TStream_ce_ptr, &oBodyStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASReceipt_Save_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHeadersStream TSRMLS_CC), SBGetObjectHandle(oBodyStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElASReceipt_Save_2(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASReceipt, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASReceipt_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceipt_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceipt_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceipt_Load, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_ReceiptHeaders_or_FileName, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ReceiptBody, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceipt_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_HeadersStream_or_FileName, 0, 1)
	ZEND_ARG_OBJ_INFO(0, BodyStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASReceipt___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASReceipt_methods[] = {
	PHP_ME(TElASReceipt, Assign, arginfo_TElASReceipt_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceipt, Clear, arginfo_TElASReceipt_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceipt, Load, arginfo_TElASReceipt_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceipt, Save, arginfo_TElASReceipt_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElASReceipt, __construct, arginfo_TElASReceipt___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASReceipt(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASReceipt_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASReceipt", TElASReceipt_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElASReceipt_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElASMessage, GetContentDigest)
{
	long fAlgorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAlgorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElASMessage_GetContentDigest(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASSignatureDigestAlgorithmRaw)fAlgorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1241842650, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASMessage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, GetFileOptions)
{
	char *sFilePath;
	int sFilePath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilePath, &sFilePath_len) == SUCCESS)
	{
		SBCheckError(TElASMessage_GetFileOptions(SBGetObjectHandle(getThis() TSRMLS_CC), sFilePath, (int32_t)sFilePath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, SetFileOptions)
{
	char *sFilePath;
	int sFilePath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilePath, &sFilePath_len) == SUCCESS)
	{
		SBCheckError(TElASMessage_SetFileOptions(SBGetObjectHandle(getThis() TSRMLS_CC), sFilePath, (int32_t)sFilePath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, Load)
{
	char *sDataFile;
	char *sFileName;
	int sDataFile_len;
	int sFileName_len;
	zval *oData;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFileName, &sFileName_len, &sDataFile, &sDataFile_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASMessage_Load(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, sDataFile, (int32_t)sDataFile_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSource, TStream_ce_ptr, &oData, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASMessage_Load_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (TStream, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, Save)
{
	char *sDataFile;
	char *sFileName;
	int sDataFile_len;
	int sFileName_len;
	zval *oData;
	zval *oDest;
	zval *oDestBody;
	zval *oDestHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sDataFile, &sDataFile_len, &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElASMessage_Save(SBGetObjectHandle(getThis() TSRMLS_CC), sDataFile, (int32_t)sDataFile_len, sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oData, TStream_ce_ptr, &oDest, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessage_Save_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oData, TStream_ce_ptr, &oDestHeaders, TStream_ce_ptr, &oDestBody, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASMessage_Save_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oDestHeaders TSRMLS_CC), SBGetObjectHandle(oDestBody TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (TStream, TStream) or (TStream, TStream, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASMessage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASMessage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_GetContentDigest, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_GetFileOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, FilePath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_SetFileOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, FilePath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Source, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DataFile_or_Data, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage_Save, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, DataFile_or_Data, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Dest_or_DestHeaders, 0, 1)
	ZEND_ARG_OBJ_INFO(0, DestBody, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASMessage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElASMessage_methods[] = {
	PHP_ME(TElASMessage, GetContentDigest, arginfo_TElASMessage_GetContentDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, Assign, arginfo_TElASMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, Clear, arginfo_TElASMessage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, GetFileOptions, arginfo_TElASMessage_GetFileOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, SetFileOptions, arginfo_TElASMessage_SetFileOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, Load, arginfo_TElASMessage_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, Save, arginfo_TElASMessage_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElASMessage, __construct, arginfo_TElASMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASMessage", TElASMessage_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElASMessage_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBASCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBASSignatureDigestAlgorithm", NULL);
	TSBASSignatureDigestAlgorithm_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASSignatureDigestAlgorithm_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureDigestAlgorithm_ce_ptr, "sdaSHA1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureDigestAlgorithm_ce_ptr, "sdaMD5", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureDigestAlgorithm_ce_ptr, "sdaSHA224", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureDigestAlgorithm_ce_ptr, "sdaSHA256", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureDigestAlgorithm_ce_ptr, "sdaSHA384", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureDigestAlgorithm_ce_ptr, "sdaSHA512", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBASCharsetMode", NULL);
	TSBASCharsetMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASCharsetMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASCharsetMode_ce_ptr, "cmMessageDefined", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASCharsetMode_ce_ptr, "cmUserDefined", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBASHeaderTransferEncoding", NULL);
	TSBASHeaderTransferEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASHeaderTransferEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderTransferEncoding_ce_ptr, "hteAuto", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderTransferEncoding_ce_ptr, "hte7Bit", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderTransferEncoding_ce_ptr, "hte8Bit", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderTransferEncoding_ce_ptr, "hteBase64", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderTransferEncoding_ce_ptr, "hteQuotedPrintable", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBASDataTransferEncoding", NULL);
	TSBASDataTransferEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASDataTransferEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASDataTransferEncoding_ce_ptr, "dteAuto", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDataTransferEncoding_ce_ptr, "dte7Bit", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDataTransferEncoding_ce_ptr, "dte8Bit", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDataTransferEncoding_ce_ptr, "dteBinary", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDataTransferEncoding_ce_ptr, "dteBase64", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBASEncryptionTransferEncoding", NULL);
	TSBASEncryptionTransferEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASEncryptionTransferEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASEncryptionTransferEncoding_ce_ptr, "dteBinary", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASEncryptionTransferEncoding_ce_ptr, "dteBase64", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBASSignatureTransferEncoding", NULL);
	TSBASSignatureTransferEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASSignatureTransferEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureTransferEncoding_ce_ptr, "dteBinary", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSignatureTransferEncoding_ce_ptr, "dteBase64", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBASCompressionTransferEncoding", NULL);
	TSBASCompressionTransferEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASCompressionTransferEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASCompressionTransferEncoding_ce_ptr, "dteBinary", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASCompressionTransferEncoding_ce_ptr, "dteBase64", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBASDispositionActionMode", NULL);
	TSBASDispositionActionMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASDispositionActionMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionActionMode_ce_ptr, "damManual", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionActionMode_ce_ptr, "damAutomatic", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBASDispositionSendingMode", NULL);
	TSBASDispositionSendingMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASDispositionSendingMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionSendingMode_ce_ptr, "dsmSentManually", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionSendingMode_ce_ptr, "dsmSentAutomatically", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBASDispositionStatus", NULL);
	TSBASDispositionStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASDispositionStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionStatus_ce_ptr, "dsProcessed", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionStatus_ce_ptr, "dsFailed", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBASDispositionModifier", NULL);
	TSBASDispositionModifier_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASDispositionModifier_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionModifier_ce_ptr, "dmWarning", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionModifier_ce_ptr, "dmError", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASDispositionModifier_ce_ptr, "dmFailure", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBASMessageProcessingStep", NULL);
	TSBASMessageProcessingStep_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASMessageProcessingStep_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsEncoding", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsSigning", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsEncrypting", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsDecodingEncrypted", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsDecrypting", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsDecodingSignature", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsDecodingData", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsVerifying", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsCompressing", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsDecodingCompressed", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBASMessageProcessingStep_ce_ptr, "mpsDecompressing", 10)
	
	INIT_CLASS_ENTRY(ce, "TSBASHeaderScope", NULL);
	TSBASHeaderScope_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASHeaderScope_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsMessage", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsEncryption", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsEncrypted", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsSignature", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsSigned", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsData", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsReceipt", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsText", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsDisposition", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsSignatureData", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsCompression", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScope_ce_ptr, "hsCompressed", 11)
	
	INIT_CLASS_ENTRY(ce, "TSBASHeaderScopes", NULL);
	TSBASHeaderScopes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBASHeaderScopes_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsMessage", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsEncryption", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsEncrypted", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsSignature", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsSigned", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsData", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsReceipt", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsText", 128)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsDisposition", 256)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsSignatureData", 512)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsCompression", 1024)
	SB_DECLARE_CLASS_LONG_CONST(TSBASHeaderScopes_ce_ptr, "hsCompressed", 2048)
	
	INIT_CLASS_ENTRY(ce, "TSBASSMIMEVerificationOption", NULL);
	TSBASSMIMEVerificationOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASSMIMEVerificationOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOption_ce_ptr, "voUseEmbeddedCerts", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOption_ce_ptr, "voUseLocalCerts", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOption_ce_ptr, "voVerifyMessageDigests", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOption_ce_ptr, "voVerifyTimestamps", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOption_ce_ptr, "voNoOuterContentInfo", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOption_ce_ptr, "voLiberalMode", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBASSMIMEVerificationOptions", NULL);
	TSBASSMIMEVerificationOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBASSMIMEVerificationOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOptions_ce_ptr, "voUseEmbeddedCerts", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOptions_ce_ptr, "voUseLocalCerts", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOptions_ce_ptr, "voVerifyMessageDigests", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOptions_ce_ptr, "voVerifyTimestamps", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOptions_ce_ptr, "voNoOuterContentInfo", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBASSMIMEVerificationOptions_ce_ptr, "voLiberalMode", 32)
}

