#include "sbasn1tree.h"

zend_class_entry *TSBASN1DataSourceType_ce_ptr = NULL;

void SB_CALLBACK TSBASN1VirtualDataNeededEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t StartIndex, void * Buffer, int32_t MaxSize, int32_t * Read)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zStartIndex;
	zval * zBuffer;
	zval * zMaxSize;
	zval * zRead;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStartIndex);
	ZVAL_LONG(zStartIndex, (long)StartIndex);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zMaxSize);
	ZVAL_LONG(zMaxSize, (long)MaxSize);
	MAKE_STD_ZVAL(zRead);
	ZVAL_LONG(zRead, (long)*Read);

	params[0] = &zSender;
	params[1] = &zStartIndex;
	params[2] = &zBuffer;
	params[3] = &zMaxSize;
	params[4] = &zRead;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStartIndex);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zMaxSize);
	*Read = (int32_t)Z_LVAL_P(zRead);
	zval_ptr_dtor(&zRead);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBASN1StreamAccess_ce_ptr = NULL;

zend_class_entry *TElASN1CustomTag_ce_ptr = NULL;

SB_PHP_METHOD(TElASN1CustomTag, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1CustomTag_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElASN1CustomTag_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, CheckType)
{
	long u1TagId;
	zend_bool bConstrained;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1TagId, &bConstrained) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_CheckType(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1TagId, (int8_t)bConstrained, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, LoadFromStream)
{
	long l8Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASN1CustomTag_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_TagId)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_TagId(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, set_TagId)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElASN1CustomTag_set_TagId(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_UndefSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_UndefSize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, set_UndefSize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElASN1CustomTag_set_UndefSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_WriteHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_WriteHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, set_WriteHeader)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElASN1CustomTag_set_WriteHeader(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_IsConstrained)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_IsConstrained(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_TagNum)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_TagNum(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_TagOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_TagOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_TagSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_TagSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_TagHeaderSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_TagHeaderSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_TagContentSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_TagContentSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, get_Depth)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1CustomTag_get_Depth(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1CustomTag, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1CustomTag_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_CheckType, 0, 0, 2)
	ZEND_ARG_INFO(0, TagId)
	ZEND_ARG_INFO(0, Constrained)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_TagId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_set_TagId, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_UndefSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_set_UndefSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_WriteHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_set_WriteHeader, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_IsConstrained, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_TagNum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_TagOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_TagSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_TagHeaderSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_TagContentSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag_get_Depth, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1CustomTag___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASN1CustomTag_methods[] = {
	PHP_ME(TElASN1CustomTag, LoadFromBuffer, arginfo_TElASN1CustomTag_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, SaveToBuffer, arginfo_TElASN1CustomTag_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, CheckType, arginfo_TElASN1CustomTag_CheckType, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, LoadFromStream, arginfo_TElASN1CustomTag_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, SaveToStream, arginfo_TElASN1CustomTag_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_TagId, arginfo_TElASN1CustomTag_get_TagId, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, set_TagId, arginfo_TElASN1CustomTag_set_TagId, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_UndefSize, arginfo_TElASN1CustomTag_get_UndefSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, set_UndefSize, arginfo_TElASN1CustomTag_set_UndefSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_WriteHeader, arginfo_TElASN1CustomTag_get_WriteHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, set_WriteHeader, arginfo_TElASN1CustomTag_set_WriteHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_IsConstrained, arginfo_TElASN1CustomTag_get_IsConstrained, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_TagNum, arginfo_TElASN1CustomTag_get_TagNum, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_TagOffset, arginfo_TElASN1CustomTag_get_TagOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_TagSize, arginfo_TElASN1CustomTag_get_TagSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_TagHeaderSize, arginfo_TElASN1CustomTag_get_TagHeaderSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_TagContentSize, arginfo_TElASN1CustomTag_get_TagContentSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, get_Depth, arginfo_TElASN1CustomTag_get_Depth, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1CustomTag, __construct, arginfo_TElASN1CustomTag___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASN1CustomTag(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASN1CustomTag_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASN1CustomTag", TElASN1CustomTag_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElASN1CustomTag_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASN1DataSource_ce_ptr = NULL;

SB_PHP_METHOD(TElASN1DataSource, Init)
{
	long l4Size;
	long l8Offset;
	long l8Size;
	SBArrayZValInfo aiValue;
	SBArrayZValInfo piBuffer;
	zend_bool bUnknownSize;
	zval *oStream;
	zval *zaValue;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1DataSource_Init(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oStream, TStream_ce_ptr, &l8Offset, &l8Size) == SUCCESS)
	{
		SBCheckError(TElASN1DataSource_Init_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bUnknownSize) == SUCCESS)
	{
		SBCheckError(TElASN1DataSource_Init_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bUnknownSize) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1DataSource_Init_3(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TStream, integer, integer) or (TStream, bool) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, InitVirtual)
{
	long l8Size;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Size) == SUCCESS)
	{
		SBCheckError(TElASN1DataSource_InitVirtual(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Size) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, Read)
{
	long l4Size;
	long l8Offset;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zpBuffer, &l4Size, &l8Offset) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1DataSource_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, (int64_t)l8Offset, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, Clone)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElASN1DataSource_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASN1DataSource_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1DataSource)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, CloneVirtual)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElASN1DataSource_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASN1DataSource_CloneVirtual(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1DataSource)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, ToBuffer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElASN1DataSource_ToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(226961468, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElASN1DataSource_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, get_UnknownSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1DataSource_get_UnknownSize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, get_SkipVirtualData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1DataSource_get_SkipVirtualData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, set_SkipVirtualData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElASN1DataSource_set_SkipVirtualData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, get_SourceType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1DataSourceTypeRaw fOutResultRaw = 0;
		SBCheckError(TElASN1DataSource_get_SourceType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, get_OnVirtualDataNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1VirtualDataNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1DataSource_get_OnVirtualDataNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, set_OnVirtualDataNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1DataSource_set_OnVirtualDataNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBASN1VirtualDataNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBASN1VirtualDataNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1DataSource, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1DataSource_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_Init, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value_or_Stream_or_Buffer, 0, 1)
	ZEND_ARG_INFO(0, Offset_or_UnknownSize_or_Size)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_InitVirtual, 0, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_Read, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(0, Offset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElASN1DataSource, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_CloneVirtual, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElASN1DataSource, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_ToBuffer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_get_UnknownSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_get_SkipVirtualData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_set_SkipVirtualData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_get_SourceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_get_OnVirtualDataNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource_set_OnVirtualDataNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1DataSource___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASN1DataSource_methods[] = {
	PHP_ME(TElASN1DataSource, Init, arginfo_TElASN1DataSource_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, InitVirtual, arginfo_TElASN1DataSource_InitVirtual, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, Read, arginfo_TElASN1DataSource_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, Clone, arginfo_TElASN1DataSource_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, CloneVirtual, arginfo_TElASN1DataSource_CloneVirtual, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, ToBuffer, arginfo_TElASN1DataSource_ToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, get_Size, arginfo_TElASN1DataSource_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, get_UnknownSize, arginfo_TElASN1DataSource_get_UnknownSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, get_SkipVirtualData, arginfo_TElASN1DataSource_get_SkipVirtualData, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, set_SkipVirtualData, arginfo_TElASN1DataSource_set_SkipVirtualData, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, get_SourceType, arginfo_TElASN1DataSource_get_SourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, get_OnVirtualDataNeeded, arginfo_TElASN1DataSource_get_OnVirtualDataNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, set_OnVirtualDataNeeded, arginfo_TElASN1DataSource_set_OnVirtualDataNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1DataSource, __construct, arginfo_TElASN1DataSource___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASN1DataSource(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASN1DataSource_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASN1DataSource", TElASN1DataSource_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElASN1DataSource_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASN1SimpleTag_ce_ptr = NULL;

SB_PHP_METHOD(TElASN1SimpleTag, CreateInstance_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1SimpleTag_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1SimpleTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, CreateInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1SimpleTag_CreateInstance(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1SimpleTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1SimpleTag_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElASN1SimpleTag_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, LoadFromStream)
{
	long l8Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1SimpleTag_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASN1SimpleTag_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, get_Content)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElASN1SimpleTag_get_Content(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1627703137, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, set_Content)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1SimpleTag_set_Content(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, get_DataSource)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1SimpleTag_get_DataSource(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1DataSource_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, get_FragmentSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1SimpleTag_get_FragmentSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, set_FragmentSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElASN1SimpleTag_set_FragmentSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, get_OnContentWriteBegin)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1SimpleTag_get_OnContentWriteBegin(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, set_OnContentWriteBegin)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1SimpleTag_set_OnContentWriteBegin(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, get_OnContentWriteEnd)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElASN1SimpleTag_get_OnContentWriteEnd(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, set_OnContentWriteEnd)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElASN1SimpleTag_set_OnContentWriteEnd(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1SimpleTag, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1SimpleTag_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_CreateInstance_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_CreateInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_get_Content, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_set_Content, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_get_DataSource, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_get_FragmentSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_set_FragmentSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_get_OnContentWriteBegin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_set_OnContentWriteBegin, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_get_OnContentWriteEnd, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag_set_OnContentWriteEnd, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1SimpleTag___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASN1SimpleTag_methods[] = {
	PHP_ME(TElASN1SimpleTag, CreateInstance_Inst, arginfo_TElASN1SimpleTag_CreateInstance_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, CreateInstance, arginfo_TElASN1SimpleTag_CreateInstance, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElASN1SimpleTag, LoadFromBuffer, arginfo_TElASN1SimpleTag_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, SaveToBuffer, arginfo_TElASN1SimpleTag_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, LoadFromStream, arginfo_TElASN1SimpleTag_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, SaveToStream, arginfo_TElASN1SimpleTag_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, get_Content, arginfo_TElASN1SimpleTag_get_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, set_Content, arginfo_TElASN1SimpleTag_set_Content, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, get_DataSource, arginfo_TElASN1SimpleTag_get_DataSource, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, get_FragmentSize, arginfo_TElASN1SimpleTag_get_FragmentSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, set_FragmentSize, arginfo_TElASN1SimpleTag_set_FragmentSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, get_OnContentWriteBegin, arginfo_TElASN1SimpleTag_get_OnContentWriteBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, set_OnContentWriteBegin, arginfo_TElASN1SimpleTag_set_OnContentWriteBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, get_OnContentWriteEnd, arginfo_TElASN1SimpleTag_get_OnContentWriteEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, set_OnContentWriteEnd, arginfo_TElASN1SimpleTag_set_OnContentWriteEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1SimpleTag, __construct, arginfo_TElASN1SimpleTag___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASN1SimpleTag(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASN1SimpleTag_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASN1SimpleTag", TElASN1SimpleTag_methods);
	if (NULL == TElASN1CustomTag_ce_ptr)
		Register_TElASN1CustomTag(TSRMLS_C);
	TElASN1SimpleTag_ce_ptr = zend_register_internal_class_ex(&ce, TElASN1CustomTag_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElASN1ConstrainedTag_ce_ptr = NULL;

SB_PHP_METHOD(TElASN1ConstrainedTag, CreateInstance_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1ConstrainedTag_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1ConstrainedTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, CreateInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1ConstrainedTag_CreateInstance(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1ConstrainedTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1ConstrainedTag_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, LoadFromBufferSingle)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElASN1ConstrainedTag_LoadFromBufferSingle(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElASN1ConstrainedTag_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, SaveContentToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElASN1ConstrainedTag_SaveContentToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, LoadFromStream)
{
	long l8Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, LoadFromStreamSingle)
{
	long l8Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_LoadFromStreamSingle(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElASN1ConstrainedTag_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, AddField)
{
	zend_bool bConstrained;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bConstrained) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_AddField(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bConstrained, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, RemoveField)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_RemoveField(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, GetField)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1ConstrainedTag_GetField(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElASN1CustomTag_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElASN1ConstrainedTag_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, get_MaxSimpleTagLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_get_MaxSimpleTagLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, set_MaxSimpleTagLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElASN1ConstrainedTag_set_MaxSimpleTagLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, get_StreamAccess)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBASN1StreamAccessRaw fOutResultRaw = 0;
		SBCheckError(TElASN1ConstrainedTag_get_StreamAccess(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, set_StreamAccess)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElASN1ConstrainedTag_set_StreamAccess(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBASN1StreamAccessRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElASN1ConstrainedTag, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElASN1ConstrainedTag_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_CreateInstance_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_CreateInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_LoadFromBufferSingle, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_SaveContentToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_LoadFromStreamSingle, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_AddField, 0, 0, 1)
	ZEND_ARG_INFO(0, Constrained)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_RemoveField, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_GetField, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_get_MaxSimpleTagLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_set_MaxSimpleTagLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_get_StreamAccess, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag_set_StreamAccess, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElASN1ConstrainedTag___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElASN1ConstrainedTag_methods[] = {
	PHP_ME(TElASN1ConstrainedTag, CreateInstance_Inst, arginfo_TElASN1ConstrainedTag_CreateInstance_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, CreateInstance, arginfo_TElASN1ConstrainedTag_CreateInstance, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElASN1ConstrainedTag, LoadFromBuffer, arginfo_TElASN1ConstrainedTag_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, LoadFromBufferSingle, arginfo_TElASN1ConstrainedTag_LoadFromBufferSingle, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, SaveToBuffer, arginfo_TElASN1ConstrainedTag_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, SaveContentToBuffer, arginfo_TElASN1ConstrainedTag_SaveContentToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, LoadFromStream, arginfo_TElASN1ConstrainedTag_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, LoadFromStreamSingle, arginfo_TElASN1ConstrainedTag_LoadFromStreamSingle, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, SaveToStream, arginfo_TElASN1ConstrainedTag_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, AddField, arginfo_TElASN1ConstrainedTag_AddField, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, RemoveField, arginfo_TElASN1ConstrainedTag_RemoveField, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, GetField, arginfo_TElASN1ConstrainedTag_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, Clear, arginfo_TElASN1ConstrainedTag_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, get_Count, arginfo_TElASN1ConstrainedTag_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, get_MaxSimpleTagLength, arginfo_TElASN1ConstrainedTag_get_MaxSimpleTagLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, set_MaxSimpleTagLength, arginfo_TElASN1ConstrainedTag_set_MaxSimpleTagLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, get_StreamAccess, arginfo_TElASN1ConstrainedTag_get_StreamAccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, set_StreamAccess, arginfo_TElASN1ConstrainedTag_set_StreamAccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElASN1ConstrainedTag, __construct, arginfo_TElASN1ConstrainedTag___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElASN1ConstrainedTag(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElASN1ConstrainedTag_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElASN1ConstrainedTag", TElASN1ConstrainedTag_methods);
	if (NULL == TElASN1CustomTag_ce_ptr)
		Register_TElASN1CustomTag(TSRMLS_C);
	TElASN1ConstrainedTag_ce_ptr = zend_register_internal_class_ex(&ce, TElASN1CustomTag_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBASN1Tree, asymWriteInteger)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oTag;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zl", &oTag, TElASN1SimpleTag_ce_ptr, &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBASN1Tree_asymWriteInteger(SBGetObjectHandle(oTag TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1ReadInteger)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1SimpleTag_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBASN1Tree_ASN1ReadInteger(SBGetObjectHandle(oTag TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1ReadInteger64)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1SimpleTag_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBASN1Tree_ASN1ReadInteger64(SBGetObjectHandle(oTag TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1WriteInteger)
{
	long l4Value;
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oTag, TElASN1SimpleTag_ce_ptr, &l4Value) == SUCCESS)
	{
		SBCheckError(SBASN1Tree_ASN1WriteInteger(SBGetObjectHandle(oTag TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1WriteInteger64)
{
	long l8Value;
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oTag, TElASN1SimpleTag_ce_ptr, &l8Value) == SUCCESS)
	{
		SBCheckError(SBASN1Tree_ASN1WriteInteger64(SBGetObjectHandle(oTag TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1ReadSimpleValue)
{
	int32_t l4TagIDRaw;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	zval *zl4TagID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaData, &zl4TagID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))) && PZVAL_IS_REF(zl4TagID) && (IS_LONG == Z_TYPE_P(zl4TagID)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		l4TagIDRaw = (int32_t)Z_LVAL_P(zl4TagID);
		_err = SBASN1Tree_ASN1ReadSimpleValue(aiData.data, aiData.len, &l4TagIDRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-457708827, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		ZVAL_LONG(zl4TagID, (long)l4TagIDRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1WriteTagAndLength)
{
	long l4Tag;
	long l8Len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Tag, &l8Len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBASN1Tree_ASN1WriteTagAndLength((int32_t)l4Tag, (int64_t)l8Len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1772507958, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1ReadBoolean)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1SimpleTag_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBASN1Tree_ASN1ReadBoolean(SBGetObjectHandle(oTag TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1WriteBoolean)
{
	zend_bool bValue;
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oTag, TElASN1SimpleTag_ce_ptr, &bValue) == SUCCESS)
	{
		SBCheckError(SBASN1Tree_ASN1WriteBoolean(SBGetObjectHandle(oTag TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1SimpleTag, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1ReadString)
{
	long l4TagId;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaData, &l4TagId) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1Tree_ASN1ReadString(aiData.data, aiData.len, (int32_t)l4TagId, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1327107858, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, ASN1ReadStringAnsi)
{
	long l4TagId;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaData, &l4TagId) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1Tree_ASN1ReadStringAnsi(aiData.data, aiData.len, (int32_t)l4TagId, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2139646446, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiData);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, FormatAttributeValue)
{
	long l4TagID;
	SBArrayZValInfo aiValue;
	uint32_t _err;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4TagID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1Tree_FormatAttributeValue((int32_t)l4TagID, aiValue.data, aiValue.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1563218394, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiValue);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, UnformatAttributeValue)
{
	int32_t l4TagIDRaw = 0;
	SBArrayZValInfo aiValue;
	uint32_t _err;
	zval *zaValue;
	zval *zl4TagID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaValue, &zl4TagID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))) && PZVAL_IS_REF(zl4TagID) && (IS_LONG == Z_TYPE_P(zl4TagID)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		_err = SBASN1Tree_UnformatAttributeValue(aiValue.data, aiValue.len, &l4TagIDRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-705886238, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiValue);
		ZVAL_LONG(zl4TagID, (long)l4TagIDRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, GetMaxASN1TreeDepth)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBASN1Tree_GetMaxASN1TreeDepth(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, SetMaxASN1TreeDepth)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(SBASN1Tree_SetMaxASN1TreeDepth((int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, GetMaxASN1BufferLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBASN1Tree_GetMaxASN1BufferLength(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASN1Tree, SetMaxASN1BufferLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(SBASN1Tree_SetMaxASN1BufferLength((int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBASN1Tree_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_BOOLEAN, SB_ASN1_BOOLEAN, SB_ASN1_BOOLEAN);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_INTEGER, SB_ASN1_INTEGER, SB_ASN1_INTEGER);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_BITSTRING, SB_ASN1_BITSTRING, SB_ASN1_BITSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_OCTETSTRING, SB_ASN1_OCTETSTRING, SB_ASN1_OCTETSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_NULL, SB_ASN1_NULL, SB_ASN1_NULL);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_OBJECT, SB_ASN1_OBJECT, SB_ASN1_OBJECT);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_REAL, SB_ASN1_REAL, SB_ASN1_REAL);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_ENUMERATED, SB_ASN1_ENUMERATED, SB_ASN1_ENUMERATED);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_UTF8STRING, SB_ASN1_UTF8STRING, SB_ASN1_UTF8STRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_NUMERICSTR, SB_ASN1_NUMERICSTR, SB_ASN1_NUMERICSTR);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_PRINTABLESTRING, SB_ASN1_PRINTABLESTRING, SB_ASN1_PRINTABLESTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_T61STRING, SB_ASN1_T61STRING, SB_ASN1_T61STRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_TELETEXSTRING, SB_ASN1_TELETEXSTRING, SB_ASN1_TELETEXSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_VIDEOTEXSTRING, SB_ASN1_VIDEOTEXSTRING, SB_ASN1_VIDEOTEXSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_IA5STRING, SB_ASN1_IA5STRING, SB_ASN1_IA5STRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_UTCTIME, SB_ASN1_UTCTIME, SB_ASN1_UTCTIME);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_GENERALIZEDTIME, SB_ASN1_GENERALIZEDTIME, SB_ASN1_GENERALIZEDTIME);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_GRAPHICSTRING, SB_ASN1_GRAPHICSTRING, SB_ASN1_GRAPHICSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_VISIBLESTRING, SB_ASN1_VISIBLESTRING, SB_ASN1_VISIBLESTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_GENERALSTRING, SB_ASN1_GENERALSTRING, SB_ASN1_GENERALSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_UNIVERSALSTRING, SB_ASN1_UNIVERSALSTRING, SB_ASN1_UNIVERSALSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_BMPSTRING, SB_ASN1_BMPSTRING, SB_ASN1_BMPSTRING);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_SEQUENCE, SB_ASN1_SEQUENCE, SB_ASN1_SEQUENCE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_SET, SB_ASN1_SET, SB_ASN1_SET);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A0_PRIMITIVE, SB_ASN1_A0_PRIMITIVE, SB_ASN1_A0_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A0, SB_ASN1_A0, SB_ASN1_A0);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A1_PRIMITIVE, SB_ASN1_A1_PRIMITIVE, SB_ASN1_A1_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A1, SB_ASN1_A1, SB_ASN1_A1);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A2_PRIMITIVE, SB_ASN1_A2_PRIMITIVE, SB_ASN1_A2_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A2, SB_ASN1_A2, SB_ASN1_A2);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A3_PRIMITIVE, SB_ASN1_A3_PRIMITIVE, SB_ASN1_A3_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A3, SB_ASN1_A3, SB_ASN1_A3);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A4_PRIMITIVE, SB_ASN1_A4_PRIMITIVE, SB_ASN1_A4_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A4, SB_ASN1_A4, SB_ASN1_A4);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A5_PRIMITIVE, SB_ASN1_A5_PRIMITIVE, SB_ASN1_A5_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A5, SB_ASN1_A5, SB_ASN1_A5);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A6_PRIMITIVE, SB_ASN1_A6_PRIMITIVE, SB_ASN1_A6_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A6, SB_ASN1_A6, SB_ASN1_A6);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A7_PRIMITIVE, SB_ASN1_A7_PRIMITIVE, SB_ASN1_A7_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A7, SB_ASN1_A7, SB_ASN1_A7);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A8_PRIMITIVE, SB_ASN1_A8_PRIMITIVE, SB_ASN1_A8_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A8, SB_ASN1_A8, SB_ASN1_A8);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A9_PRIMITIVE, SB_ASN1_A9_PRIMITIVE, SB_ASN1_A9_PRIMITIVE);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_A9, SB_ASN1_A9, SB_ASN1_A9);
	SB_REGISTER_LONG_CONSTANT(SBASN1Tree, SB_ASN1_CONSTRAINED_FLAG, SB_ASN1_CONSTRAINED_FLAG, SB_ASN1_CONSTRAINED_FLAG);
}

void Register_SBASN1Tree_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBASN1DataSourceType", NULL);
	TSBASN1DataSourceType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASN1DataSourceType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DataSourceType_ce_ptr, "dstBuffer", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DataSourceType_ce_ptr, "dstStream", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1DataSourceType_ce_ptr, "dstVirtual", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBASN1StreamAccess", NULL);
	TSBASN1StreamAccess_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBASN1StreamAccess_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBASN1StreamAccess_ce_ptr, "saStoreStream", 0)
}

