#include "sbasutils.h"

SB_PHP_FUNCTION(SBASUtils, CopyStream)
{
	long l8Count;
	long l8Offset;
	void *pzProgressEvent;
	zend_bool bPreservePosition;
	zval *oDest;
	zval *oSource;
	zval *zProgressEvent;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llbz", &oSource, TStream_ce_ptr, &oDest, TStream_ce_ptr, &l8Offset, &l8Count, &bPreservePosition, &zProgressEvent) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressEvent)) || (IS_ARRAY == Z_TYPE_P(zProgressEvent)) || (IS_CALLABLE == Z_TYPE_P(zProgressEvent)) || (IS_NULL == Z_TYPE_P(zProgressEvent))))
	{
		int64_t l8OutResultRaw = 0;
		pzProgressEvent = SBSetEventData(zProgressEvent TSRMLS_CC);
		SBCheckError(SBASUtils_CopyStream(SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Count, (int8_t)bPreservePosition, pzProgressEvent ? &TSBProgressEventRaw : NULL, pzProgressEvent, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer, integer, bool, TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASUtils, QuoteMessageID)
{
	char *sMessageID;
	int sMessageID_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMessageID, &sMessageID_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBASUtils_QuoteMessageID(sMessageID, (int32_t)sMessageID_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-771850497, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASUtils, WriteField)
{
	char *sName;
	char *sValue;
	int sName_len;
	int sValue_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oStream, TStream_ce_ptr, &sName, &sName_len, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBASUtils_WriteField(SBGetObjectHandle(oStream TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASUtils, WriteLineA)
{
	char *sLine;
	int sLine_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sLine, &sLine_len) == SUCCESS)
	{
		SBCheckError(SBASUtils_WriteLineA(SBGetObjectHandle(oStream TSRMLS_CC), sLine, (int32_t)sLine_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBASUtils, WriteLine)
{
	char *sLine;
	int sLine_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sLine, &sLine_len) == SUCCESS)
	{
		SBCheckError(SBASUtils_WriteLine(SBGetObjectHandle(oStream TSRMLS_CC), sLine, (int32_t)sLine_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string)" TSRMLS_CC);
	}
}

