#include "sbauthdatastream.h"

zend_class_entry *TSBAuthenticatedDataDigestsLocation_ce_ptr = NULL;

zend_class_entry *TElAuthenticatedDataWriteStream_ce_ptr = NULL;

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthenticatedDataWriteStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthenticatedDataWriteStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticatedDataWriteStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElAuthenticatedDataWriteStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, get_CachedDigests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticatedDataWriteStream_get_CachedDigests(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElByteArrayList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElAuthenticatedDataWriteStream_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElAuthenticatedDataWriteStream_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataWriteStream, __construct)
{
	long fDigestsLocation;
	long l4Algorithm;
	long l4DigestSize;
	long l8BlockSize;
	long l8Count;
	long l8StartBlockNumber;
	SBArrayZValInfo aiKey;
	zval *oManager;
	zval *oSourceStream;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llllzllO!", &oSourceStream, TStream_ce_ptr, &l4Algorithm, &l8BlockSize, &l4DigestSize, &fDigestsLocation, &zaKey, &l8StartBlockNumber, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthenticatedDataWriteStream_Create(SBGetObjectHandle(oSourceStream TSRMLS_CC), (int32_t)l4Algorithm, (int64_t)l8BlockSize, (int32_t)l4DigestSize, (TSBAuthenticatedDataDigestsLocationRaw)fDigestsLocation, aiKey.data, aiKey.len, (int64_t)l8StartBlockNumber, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, integer, integer, array of byte|string|NULL, integer, integer, TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream_get_CachedDigests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataWriteStream___construct, 0, 0, 9)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, BlockSize)
	ZEND_ARG_INFO(0, DigestSize)
	ZEND_ARG_INFO(0, DigestsLocation)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_INFO(0, StartBlockNumber)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAuthenticatedDataWriteStream_methods[] = {
	PHP_ME(TElAuthenticatedDataWriteStream, Read, arginfo_TElAuthenticatedDataWriteStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataWriteStream, Write, arginfo_TElAuthenticatedDataWriteStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataWriteStream, Seek, arginfo_TElAuthenticatedDataWriteStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataWriteStream, get_CachedDigests, arginfo_TElAuthenticatedDataWriteStream_get_CachedDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataWriteStream, get_OnProgress, arginfo_TElAuthenticatedDataWriteStream_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataWriteStream, set_OnProgress, arginfo_TElAuthenticatedDataWriteStream_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataWriteStream, __construct, arginfo_TElAuthenticatedDataWriteStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAuthenticatedDataWriteStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAuthenticatedDataWriteStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAuthenticatedDataWriteStream", TElAuthenticatedDataWriteStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElAuthenticatedDataWriteStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAuthenticatedDataReadStream_ce_ptr = NULL;

SB_PHP_METHOD(TElAuthenticatedDataReadStream, FinalizeOutput)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAuthenticatedDataReadStream_FinalizeOutput(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthenticatedDataReadStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthenticatedDataReadStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticatedDataReadStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElAuthenticatedDataReadStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, get_ExpectFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAuthenticatedDataReadStream_get_ExpectFinalize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, set_ExpectFinalize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAuthenticatedDataReadStream_set_ExpectFinalize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, get_CachedDigests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticatedDataReadStream_get_CachedDigests(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElByteArrayList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElAuthenticatedDataReadStream_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElAuthenticatedDataReadStream_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticatedDataReadStream, __construct)
{
	long fDigestsLocation;
	long l4Algorithm;
	long l4DigestSize;
	long l8BlockSize;
	long l8StartBlockNumber;
	SBArrayZValInfo aiKey;
	zval *oDestStream;
	zval *oManager;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llllzlO!", &oDestStream, TStream_ce_ptr, &l4Algorithm, &l8BlockSize, &l4DigestSize, &fDigestsLocation, &zaKey, &l8StartBlockNumber, &oManager, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthenticatedDataReadStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), (int32_t)l4Algorithm, (int64_t)l8BlockSize, (int32_t)l4DigestSize, (TSBAuthenticatedDataDigestsLocationRaw)fDigestsLocation, aiKey.data, aiKey.len, (int64_t)l8StartBlockNumber, SBGetObjectHandle(oManager TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, integer, integer, array of byte|string|NULL, integer, TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_FinalizeOutput, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_get_ExpectFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_set_ExpectFinalize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_get_CachedDigests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticatedDataReadStream___construct, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, BlockSize)
	ZEND_ARG_INFO(0, DigestSize)
	ZEND_ARG_INFO(0, DigestsLocation)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_INFO(0, StartBlockNumber)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAuthenticatedDataReadStream_methods[] = {
	PHP_ME(TElAuthenticatedDataReadStream, FinalizeOutput, arginfo_TElAuthenticatedDataReadStream_FinalizeOutput, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, Read, arginfo_TElAuthenticatedDataReadStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, Write, arginfo_TElAuthenticatedDataReadStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, Seek, arginfo_TElAuthenticatedDataReadStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, get_ExpectFinalize, arginfo_TElAuthenticatedDataReadStream_get_ExpectFinalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, set_ExpectFinalize, arginfo_TElAuthenticatedDataReadStream_set_ExpectFinalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, get_CachedDigests, arginfo_TElAuthenticatedDataReadStream_get_CachedDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, get_OnProgress, arginfo_TElAuthenticatedDataReadStream_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, set_OnProgress, arginfo_TElAuthenticatedDataReadStream_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticatedDataReadStream, __construct, arginfo_TElAuthenticatedDataReadStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAuthenticatedDataReadStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAuthenticatedDataReadStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAuthenticatedDataReadStream", TElAuthenticatedDataReadStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElAuthenticatedDataReadStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBAuthDataStream_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBAuthenticatedDataDigestsLocation", NULL);
	TSBAuthenticatedDataDigestsLocation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAuthenticatedDataDigestsLocation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticatedDataDigestsLocation_ce_ptr, "addlNoDigests", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticatedDataDigestsLocation_ce_ptr, "addlExternal", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticatedDataDigestsLocation_ce_ptr, "addlEmbedded", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticatedDataDigestsLocation_ce_ptr, "addlAppended", 3)
}

