#include "sbbzip2utils.h"

zend_class_entry *TSBDataArray_ce_ptr = NULL;

SB_PHP_METHOD(TSBDataArray, GetArrayData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TSBDataArray_GetArrayData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBDataArray, SetArrayData)
{
	long l4Index;
	long l8Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBDataArray_SetArrayData(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBDataArray, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBDataArray_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBDataArray_GetArrayData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBDataArray_SetArrayData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBDataArray___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBDataArray_methods[] = {
	PHP_ME(TSBDataArray, GetArrayData, arginfo_TSBDataArray_GetArrayData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBDataArray, SetArrayData, arginfo_TSBDataArray_SetArrayData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBDataArray, __construct, arginfo_TSBDataArray___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBDataArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBDataArray_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBDataArray", TSBDataArray_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBDataArray_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBByteDataArray_ce_ptr = NULL;

SB_PHP_METHOD(TSBByteDataArray, GetArrayData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TSBByteDataArray_GetArrayData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteDataArray, SetArrayData)
{
	long l4Index;
	long u1Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBByteDataArray_SetArrayData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteDataArray, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBByteDataArray_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteDataArray_GetArrayData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteDataArray_SetArrayData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteDataArray___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBByteDataArray_methods[] = {
	PHP_ME(TSBByteDataArray, GetArrayData, arginfo_TSBByteDataArray_GetArrayData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteDataArray, SetArrayData, arginfo_TSBByteDataArray_SetArrayData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteDataArray, __construct, arginfo_TSBByteDataArray___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBByteDataArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBByteDataArray_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBByteDataArray", TSBByteDataArray_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBByteDataArray_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBByteArray_ce_ptr = NULL;

SB_PHP_METHOD(TSBByteArray, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TSBByteArray_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteArray, SetData)
{
	long l4Index;
	long u1Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBByteArray_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteArray, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBByteArray_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArray_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArray_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArray___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBByteArray_methods[] = {
	PHP_ME(TSBByteArray, GetData, arginfo_TSBByteArray_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteArray, SetData, arginfo_TSBByteArray_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteArray, __construct, arginfo_TSBByteArray___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBByteArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBByteArray_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBByteArray", TSBByteArray_methods);
	if (NULL == TSBDataArray_ce_ptr)
		Register_TSBDataArray(TSRMLS_C);
	TSBByteArray_ce_ptr = zend_register_internal_class_ex(&ce, TSBDataArray_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBInt16Array_ce_ptr = NULL;

SB_PHP_METHOD(TSBInt16Array, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int16_t l2OutResultRaw = 0;
		SBCheckError(TSBInt16Array_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt16Array, SetData)
{
	long l2Data;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l2Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBInt16Array_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int16_t)l2Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt16Array, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBInt16Array_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt16Array_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt16Array_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt16Array___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBInt16Array_methods[] = {
	PHP_ME(TSBInt16Array, GetData, arginfo_TSBInt16Array_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt16Array, SetData, arginfo_TSBInt16Array_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt16Array, __construct, arginfo_TSBInt16Array___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBInt16Array(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBInt16Array_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBInt16Array", TSBInt16Array_methods);
	if (NULL == TSBDataArray_ce_ptr)
		Register_TSBDataArray(TSRMLS_C);
	TSBInt16Array_ce_ptr = zend_register_internal_class_ex(&ce, TSBDataArray_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBUInt16Array_ce_ptr = NULL;

SB_PHP_METHOD(TSBUInt16Array, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TSBUInt16Array_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt16Array, SetData)
{
	long l4Index;
	long u2Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u2Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBUInt16Array_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt16Array, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBUInt16Array_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16Array_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16Array_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16Array___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBUInt16Array_methods[] = {
	PHP_ME(TSBUInt16Array, GetData, arginfo_TSBUInt16Array_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt16Array, SetData, arginfo_TSBUInt16Array_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt16Array, __construct, arginfo_TSBUInt16Array___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBUInt16Array(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBUInt16Array_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBUInt16Array", TSBUInt16Array_methods);
	if (NULL == TSBDataArray_ce_ptr)
		Register_TSBDataArray(TSRMLS_C);
	TSBUInt16Array_ce_ptr = zend_register_internal_class_ex(&ce, TSBDataArray_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBInt32Array_ce_ptr = NULL;

SB_PHP_METHOD(TSBInt32Array, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBInt32Array_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt32Array, SetData)
{
	long l4Data;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBInt32Array_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt32Array, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBInt32Array_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32Array_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32Array_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32Array___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBInt32Array_methods[] = {
	PHP_ME(TSBInt32Array, GetData, arginfo_TSBInt32Array_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt32Array, SetData, arginfo_TSBInt32Array_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt32Array, __construct, arginfo_TSBInt32Array___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBInt32Array(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBInt32Array_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBInt32Array", TSBInt32Array_methods);
	if (NULL == TSBDataArray_ce_ptr)
		Register_TSBDataArray(TSRMLS_C);
	TSBInt32Array_ce_ptr = zend_register_internal_class_ex(&ce, TSBDataArray_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBUInt32Array_ce_ptr = NULL;

SB_PHP_METHOD(TSBUInt32Array, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TSBUInt32Array_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt32Array, SetData)
{
	long l4Index;
	long u4Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBUInt32Array_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt32Array, __construct)
{
	long l4Len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBUInt32Array_Create((int32_t)l4Len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32Array_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32Array_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32Array___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Len)
ZEND_END_ARG_INFO()

static zend_function_entry TSBUInt32Array_methods[] = {
	PHP_ME(TSBUInt32Array, GetData, arginfo_TSBUInt32Array_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32Array, SetData, arginfo_TSBUInt32Array_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32Array, __construct, arginfo_TSBUInt32Array___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBUInt32Array(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBUInt32Array_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBUInt32Array", TSBUInt32Array_methods);
	if (NULL == TSBDataArray_ce_ptr)
		Register_TSBDataArray(TSRMLS_C);
	TSBUInt32Array_ce_ptr = zend_register_internal_class_ex(&ce, TSBDataArray_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBUInt16onByteArray_ce_ptr = NULL;

SB_PHP_METHOD(TSBUInt16onByteArray, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TSBUInt16onByteArray_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt16onByteArray, SetData)
{
	long l4Index;
	long u2Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u2Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBUInt16onByteArray_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt16onByteArray, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBByteArray_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBUInt16onByteArray_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBByteArray, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16onByteArray_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16onByteArray_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16onByteArray___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBByteArray, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBUInt16onByteArray_methods[] = {
	PHP_ME(TSBUInt16onByteArray, GetData, arginfo_TSBUInt16onByteArray_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt16onByteArray, SetData, arginfo_TSBUInt16onByteArray_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt16onByteArray, __construct, arginfo_TSBUInt16onByteArray___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBUInt16onByteArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBUInt16onByteArray_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBUInt16onByteArray", TSBUInt16onByteArray_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBUInt16onByteArray_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBByteonUInt32Array_ce_ptr = NULL;

SB_PHP_METHOD(TSBByteonUInt32Array, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TSBByteonUInt32Array_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteonUInt32Array, SetData)
{
	long l4Index;
	long u1Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBByteonUInt32Array_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteonUInt32Array, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBUInt32Array_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBByteonUInt32Array_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBUInt32Array, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteonUInt32Array_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteonUInt32Array_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteonUInt32Array___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBUInt32Array, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBByteonUInt32Array_methods[] = {
	PHP_ME(TSBByteonUInt32Array, GetData, arginfo_TSBByteonUInt32Array_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteonUInt32Array, SetData, arginfo_TSBByteonUInt32Array_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteonUInt32Array, __construct, arginfo_TSBByteonUInt32Array___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBByteonUInt32Array(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBByteonUInt32Array_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBByteonUInt32Array", TSBByteonUInt32Array_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBByteonUInt32Array_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBUInt16onUInt32Array_ce_ptr = NULL;

SB_PHP_METHOD(TSBUInt16onUInt32Array, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TSBUInt16onUInt32Array_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt16onUInt32Array, SetData)
{
	long l4Index;
	long u2Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u2Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBUInt16onUInt32Array_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint16_t)u2Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt16onUInt32Array, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBUInt32Array_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBUInt16onUInt32Array_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBUInt32Array, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16onUInt32Array_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16onUInt32Array_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt16onUInt32Array___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBUInt32Array, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBUInt16onUInt32Array_methods[] = {
	PHP_ME(TSBUInt16onUInt32Array, GetData, arginfo_TSBUInt16onUInt32Array_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt16onUInt32Array, SetData, arginfo_TSBUInt16onUInt32Array_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt16onUInt32Array, __construct, arginfo_TSBUInt16onUInt32Array___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBUInt16onUInt32Array(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBUInt16onUInt32Array_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBUInt16onUInt32Array", TSBUInt16onUInt32Array_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBUInt16onUInt32Array_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBArrayPointer_ce_ptr = NULL;

SB_PHP_METHOD(TSBArrayPointer, SetData)
{
	long l4Index;
	long l8Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBArrayPointer_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBArrayPointer, IncOffset)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TSBArrayPointer_IncOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBArrayPointer, SetOffset)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TSBArrayPointer_SetOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBArrayPointer, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TSBArrayPointer_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBArrayPointer, GetAtPtr)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TSBArrayPointer_GetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBArrayPointer, SetAtPtr)
{
	long l8Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Data) == SUCCESS)
	{
		SBCheckError(TSBArrayPointer_SetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBArrayPointer, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBDataArray_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBArrayPointer_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDataArray, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer_IncOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer_SetOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer_GetAtPtr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer_SetAtPtr, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBArrayPointer___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBDataArray, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBArrayPointer_methods[] = {
	PHP_ME(TSBArrayPointer, SetData, arginfo_TSBArrayPointer_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBArrayPointer, IncOffset, arginfo_TSBArrayPointer_IncOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TSBArrayPointer, SetOffset, arginfo_TSBArrayPointer_SetOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TSBArrayPointer, GetData, arginfo_TSBArrayPointer_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBArrayPointer, GetAtPtr, arginfo_TSBArrayPointer_GetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBArrayPointer, SetAtPtr, arginfo_TSBArrayPointer_SetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBArrayPointer, __construct, arginfo_TSBArrayPointer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBArrayPointer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBArrayPointer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBArrayPointer", TSBArrayPointer_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBArrayPointer_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBInt32ArrayPointer_ce_ptr = NULL;

SB_PHP_METHOD(TSBInt32ArrayPointer, SetData)
{
	long l4Data;
	long l4Index;
	long l8Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBInt32ArrayPointer_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBInt32ArrayPointer_SetData_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt32ArrayPointer, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBInt32ArrayPointer_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt32ArrayPointer, GetAtPtr)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBInt32ArrayPointer_GetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt32ArrayPointer, SetAtPtr)
{
	long l4Data;
	long l8Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Data) == SUCCESS)
	{
		SBCheckError(TSBInt32ArrayPointer_SetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Data) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Data) == SUCCESS)
	{
		SBCheckError(TSBInt32ArrayPointer_SetAtPtr_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBInt32ArrayPointer, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBDataArray_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBInt32ArrayPointer_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDataArray, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32ArrayPointer_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32ArrayPointer_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32ArrayPointer_GetAtPtr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32ArrayPointer_SetAtPtr, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBInt32ArrayPointer___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBDataArray, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBInt32ArrayPointer_methods[] = {
	PHP_ME(TSBInt32ArrayPointer, SetData, arginfo_TSBInt32ArrayPointer_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt32ArrayPointer, GetData, arginfo_TSBInt32ArrayPointer_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt32ArrayPointer, GetAtPtr, arginfo_TSBInt32ArrayPointer_GetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt32ArrayPointer, SetAtPtr, arginfo_TSBInt32ArrayPointer_SetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBInt32ArrayPointer, __construct, arginfo_TSBInt32ArrayPointer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBInt32ArrayPointer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBInt32ArrayPointer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBInt32ArrayPointer", TSBInt32ArrayPointer_methods);
	if (NULL == TSBArrayPointer_ce_ptr)
		Register_TSBArrayPointer(TSRMLS_C);
	TSBInt32ArrayPointer_ce_ptr = zend_register_internal_class_ex(&ce, TSBArrayPointer_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBUInt32ArrayPointer_ce_ptr = NULL;

SB_PHP_METHOD(TSBUInt32ArrayPointer, SetData)
{
	long l4Index;
	long l8Data;
	long u4Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBUInt32ArrayPointer_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBUInt32ArrayPointer_SetData_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt32ArrayPointer, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TSBUInt32ArrayPointer_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt32ArrayPointer, GetAtPtr)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TSBUInt32ArrayPointer_GetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt32ArrayPointer, SetAtPtr)
{
	long l8Data;
	long u4Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Data) == SUCCESS)
	{
		SBCheckError(TSBUInt32ArrayPointer_SetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Data) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Data) == SUCCESS)
	{
		SBCheckError(TSBUInt32ArrayPointer_SetAtPtr_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBUInt32ArrayPointer, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBDataArray_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBUInt32ArrayPointer_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDataArray, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32ArrayPointer_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32ArrayPointer_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32ArrayPointer_GetAtPtr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32ArrayPointer_SetAtPtr, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBUInt32ArrayPointer___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBDataArray, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBUInt32ArrayPointer_methods[] = {
	PHP_ME(TSBUInt32ArrayPointer, SetData, arginfo_TSBUInt32ArrayPointer_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32ArrayPointer, GetData, arginfo_TSBUInt32ArrayPointer_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32ArrayPointer, GetAtPtr, arginfo_TSBUInt32ArrayPointer_GetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32ArrayPointer, SetAtPtr, arginfo_TSBUInt32ArrayPointer_SetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBUInt32ArrayPointer, __construct, arginfo_TSBUInt32ArrayPointer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBUInt32ArrayPointer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBUInt32ArrayPointer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBUInt32ArrayPointer", TSBUInt32ArrayPointer_methods);
	if (NULL == TSBArrayPointer_ce_ptr)
		Register_TSBArrayPointer(TSRMLS_C);
	TSBUInt32ArrayPointer_ce_ptr = zend_register_internal_class_ex(&ce, TSBArrayPointer_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBByteArrayPointer_ce_ptr = NULL;

SB_PHP_METHOD(TSBByteArrayPointer, SetData)
{
	long l4Index;
	long l8Data;
	long u1Data;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBByteArrayPointer_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Data, &l4Index) == SUCCESS)
	{
		SBCheckError(TSBByteArrayPointer_SetData_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Data, (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteArrayPointer, GetData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TSBByteArrayPointer_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteArrayPointer, GetAtPtr)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TSBByteArrayPointer_GetAtPtr(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBByteArrayPointer, __construct)
{
	char *sParentName;
	int sParentName_len;
	zval *oBase;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBase, TSBDataArray_ce_ptr, &sParentName, &sParentName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBByteArrayPointer_Create(SBGetObjectHandle(oBase TSRMLS_CC), sParentName, (int32_t)sParentName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDataArray, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArrayPointer_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArrayPointer_GetData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArrayPointer_GetAtPtr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBByteArrayPointer___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Base, TSBDataArray, 1)
	ZEND_ARG_INFO(0, ParentName)
ZEND_END_ARG_INFO()

static zend_function_entry TSBByteArrayPointer_methods[] = {
	PHP_ME(TSBByteArrayPointer, SetData, arginfo_TSBByteArrayPointer_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteArrayPointer, GetData, arginfo_TSBByteArrayPointer_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteArrayPointer, GetAtPtr, arginfo_TSBByteArrayPointer_GetAtPtr, ZEND_ACC_PUBLIC)
	PHP_ME(TSBByteArrayPointer, __construct, arginfo_TSBByteArrayPointer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBByteArrayPointer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBByteArrayPointer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBByteArrayPointer", TSBByteArrayPointer_methods);
	if (NULL == TSBArrayPointer_ce_ptr)
		Register_TSBArrayPointer(TSRMLS_C);
	TSBByteArrayPointer_ce_ptr = zend_register_internal_class_ex(&ce, TSBArrayPointer_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBBzip2Utils, IfThenInt)
{
	long l4AFalse;
	long l4ATrue;
	zend_bool bAValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bll", &bAValue, &l4ATrue, &l4AFalse) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBBzip2Utils_IfThenInt((int8_t)bAValue, (int32_t)l4ATrue, (int32_t)l4AFalse, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBzip2Utils, IfThenInt64)
{
	long l8AFalse;
	long l8ATrue;
	zend_bool bAValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bll", &bAValue, &l8ATrue, &l8AFalse) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBBzip2Utils_IfThenInt64((int8_t)bAValue, (int64_t)l8ATrue, (int64_t)l8AFalse, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBzip2Utils, IfThenDouble)
{
	double dAFalse;
	double dATrue;
	zend_bool bAValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bdd", &bAValue, &dATrue, &dAFalse) == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(SBBzip2Utils_IfThenDouble((int8_t)bAValue, (double)dATrue, (double)dAFalse, &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("(bool, double, double)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBzip2Utils, IfThenUInt32)
{
	long u4AFalse;
	long u4ATrue;
	zend_bool bAValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bll", &bAValue, &u4ATrue, &u4AFalse) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBBzip2Utils_IfThenUInt32((int8_t)bAValue, (uint32_t)u4ATrue, (uint32_t)u4AFalse, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool, integer, integer)" TSRMLS_CC);
	}
}

