#include "sbcomprstream.h"

zend_class_entry *TElCustomCompressingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCompressingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCompressingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCompressingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomCompressingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCompressingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomCompressingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomCompressingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomCompressingStream, __construct)
{
	long l8Count;
	zend_bool bReleaseSourceStream;
	zval *oSourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oSourceStream, TStream_ce_ptr, &l8Count, &bReleaseSourceStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCompressingStream_Create(SBGetObjectHandle(oSourceStream TSRMLS_CC), (int64_t)l8Count, (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCompressingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCompressingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCompressingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCompressingStream___construct, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCompressingStream_methods[] = {
	PHP_ME(TElCustomCompressingStream, Read, arginfo_TElCustomCompressingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCompressingStream, Write, arginfo_TElCustomCompressingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCompressingStream, Seek, arginfo_TElCustomCompressingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomCompressingStream, __construct, arginfo_TElCustomCompressingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCompressingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCompressingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCompressingStream", TElCustomCompressingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElCustomCompressingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomDecompressingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomDecompressingStream, FinalizeOutput)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomDecompressingStream_FinalizeOutput(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomDecompressingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomDecompressingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomDecompressingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomDecompressingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomDecompressingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomDecompressingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomDecompressingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomDecompressingStream, get_DestStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomDecompressingStream_get_DestStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomDecompressingStream, __construct)
{
	zend_bool bReleaseDestStream;
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oDestStream, TStream_ce_ptr, &bReleaseDestStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomDecompressingStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomDecompressingStream_FinalizeOutput, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomDecompressingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomDecompressingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomDecompressingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomDecompressingStream_get_DestStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomDecompressingStream___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, ReleaseDestStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomDecompressingStream_methods[] = {
	PHP_ME(TElCustomDecompressingStream, FinalizeOutput, arginfo_TElCustomDecompressingStream_FinalizeOutput, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomDecompressingStream, Read, arginfo_TElCustomDecompressingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomDecompressingStream, Write, arginfo_TElCustomDecompressingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomDecompressingStream, Seek, arginfo_TElCustomDecompressingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomDecompressingStream, get_DestStream, arginfo_TElCustomDecompressingStream_get_DestStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomDecompressingStream, __construct, arginfo_TElCustomDecompressingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomDecompressingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomDecompressingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomDecompressingStream", TElCustomDecompressingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElCustomDecompressingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZlibCompressingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElZlibCompressingStream, __construct)
{
	long l4CompressionLevel;
	long l8Count;
	zend_bool bReleaseSourceStream;
	zval *oSourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!lb", &l4CompressionLevel, &oSourceStream, TStream_ce_ptr, &l8Count, &bReleaseSourceStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZlibCompressingStream_Create((int32_t)l4CompressionLevel, SBGetObjectHandle(oSourceStream TSRMLS_CC), (int64_t)l8Count, (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TStream, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZlibCompressingStream___construct, 0, 0, 4)
	ZEND_ARG_INFO(0, CompressionLevel)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElZlibCompressingStream_methods[] = {
	PHP_ME(TElZlibCompressingStream, __construct, arginfo_TElZlibCompressingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZlibCompressingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZlibCompressingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZlibCompressingStream", TElZlibCompressingStream_methods);
	if (NULL == TElCustomCompressingStream_ce_ptr)
		Register_TElCustomCompressingStream(TSRMLS_C);
	TElZlibCompressingStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCompressingStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElZlibDecompressingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElZlibDecompressingStream, __construct)
{
	zend_bool bReleaseDestStream;
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oDestStream, TStream_ce_ptr, &bReleaseDestStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElZlibDecompressingStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElZlibDecompressingStream___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, ReleaseDestStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElZlibDecompressingStream_methods[] = {
	PHP_ME(TElZlibDecompressingStream, __construct, arginfo_TElZlibDecompressingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElZlibDecompressingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElZlibDecompressingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElZlibDecompressingStream", TElZlibDecompressingStream_methods);
	if (NULL == TElCustomDecompressingStream_ce_ptr)
		Register_TElCustomDecompressingStream(TSRMLS_C);
	TElZlibDecompressingStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDecompressingStream_ce_ptr, NULL TSRMLS_CC);
}

