#include "sbconstants.h"

SB_PHP_FUNCTION(SBConstants, GetPBEAlgorithmByOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBConstants_GetPBEAlgorithmByOID(aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetOIDByPBEAlgorithm)
{
	long l4Algorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBConstants_GetOIDByPBEAlgorithm((int32_t)l4Algorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1815167678, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetPKAlgorithmByOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBConstants_GetPKAlgorithmByOID(aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetOIDByPKAlgorithm)
{
	long l4Algorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBConstants_GetOIDByPKAlgorithm((int32_t)l4Algorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1286390345, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetSigAlgorithmByOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBConstants_GetSigAlgorithmByOID(aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetOIDBySigAlgorithm)
{
	long l4Algorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBConstants_GetOIDBySigAlgorithm((int32_t)l4Algorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1066365765, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetHashAlgorithmByOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBConstants_GetHashAlgorithmByOID(aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetOIDByHashAlgorithm)
{
	long l4Algorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBConstants_GetOIDByHashAlgorithm((int32_t)l4Algorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1390522277, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetAlgorithmByOID)
{
	SBArrayZValInfo aiOID;
	zend_bool bUseCryptoProvConstants;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaOID, &bUseCryptoProvConstants) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBConstants_GetAlgorithmByOID(aiOID.data, aiOID.len, (int8_t)bUseCryptoProvConstants, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetOIDByAlgorithm)
{
	long l4Algorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBConstants_GetOIDByAlgorithm((int32_t)l4Algorithm, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1119177741, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetAlgorithmNameByAlgorithm)
{
	long l4Algorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBConstants_GetAlgorithmNameByAlgorithm((int32_t)l4Algorithm, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1166610951, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetAlgorithmNameByOID)
{
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = SBConstants_GetAlgorithmNameByOID(aiOID.data, aiOID.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-811215565, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetHashAlgorithmBySigAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_GetHashAlgorithmBySigAlgorithm((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetHMACAlgorithmByHashAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_GetHMACAlgorithmByHashAlgorithm((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetHashAlgorithmByHMACAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_GetHashAlgorithmByHMACAlgorithm((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetSigAlgorithmByHashAlgorithm)
{
	long l4BasePKAlg;
	long l4HashAlg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4BasePKAlg, &l4HashAlg) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_GetSigAlgorithmByHashAlgorithm((int32_t)l4BasePKAlg, (int32_t)l4HashAlg, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetKeyAlgorithmBySigAlgorithm)
{
	long l4SigAlg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4SigAlg) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_GetKeyAlgorithmBySigAlgorithm((int32_t)l4SigAlg, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, GetSigAlgorithmByKeyAlgorithm)
{
	long l4KeyAlg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4KeyAlg) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_GetSigAlgorithmByKeyAlgorithm((int32_t)l4KeyAlg, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, IsSymmetricKeyAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBConstants_IsSymmetricKeyAlgorithm((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, IsHashAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBConstants_IsHashAlgorithm((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, IsMACAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBConstants_IsMACAlgorithm((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, IsPublicKeyAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBConstants_IsPublicKeyAlgorithm((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, NormalizeAlgorithmConstant)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_NormalizeAlgorithmConstant((int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, MGF1AlgorithmByHash)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_MGF1AlgorithmByHash((int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBConstants, HashAlgorithmByMGF1)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBConstants_HashAlgorithmByMGF1((int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBConstants_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFStr, SB_CRLFStr, SB_CRLFStr);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, CRStr, SB_CRStr, "" + SB_CRStr, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, LFStr, SB_LFStr, "" + SB_LFStr, 1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, LFLFStr, SB_LFLFStr, SB_LFLFStr);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFCRLFStr, SB_CRLFCRLFStr, SB_CRLFCRLFStr);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFCRLFZeroStr, SB_CRLFCRLFZeroStr, SB_CRLFCRLFZeroStr);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFTABStr, SB_CRLFTABStr, SB_CRLFTABStr);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFSPACEStr, SB_CRLFSPACEStr, SB_CRLFSPACEStr);
	SB_REGISTER_STRING_CONSTANT(SBConstants, TwoDashesStr, SB_TwoDashesStr, SB_TwoDashesStr);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, SpaceStr, SB_SpaceStr, "" + SB_SpaceStr, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, EqualCharStr, SB_EqualCharStr, "" + SB_EqualCharStr, 1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, TabByte, SB_TabByte, SB_TabByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, CRByte, SB_CRByte, SB_CRByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, LFByte, SB_LFByte, SB_LFByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SpaceByte, SB_SpaceByte, SB_SpaceByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, DoubleQuoteByte, SB_DoubleQuoteByte, SB_DoubleQuoteByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ColonByte, SB_ColonByte, SB_ColonByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, BackslashByte, SB_BackslashByte, SB_BackslashByte);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SecondsInDay, SB_SecondsInDay, SB_SecondsInDay);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SecondsInHour, SB_SecondsInHour, SB_SecondsInHour);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SecondsInMinute, SB_SecondsInMinute, SB_SecondsInMinute);
	SB_REGISTER_LONG_CONSTANT(SBConstants, HoursInDay, SB_HoursInDay, SB_HoursInDay);
	SB_REGISTER_LONG_CONSTANT(SBConstants, MinutesInHour, SB_MinutesInHour, SB_MinutesInHour);
	SB_REGISTER_LONG_CONSTANT(SBConstants, MinutesInDay, SB_MinutesInDay, SB_MinutesInDay);
	SB_REGISTER_LONG_CONSTANT(SBConstants, AnsiStrStartOffset, SB_AnsiStrStartOffset, SB_AnsiStrStartOffset);
	SB_REGISTER_LONG_CONSTANT(SBConstants, AnsiStrStartInvOffset, SB_AnsiStrStartInvOffset, SB_AnsiStrStartInvOffset);
	SB_REGISTER_LONG_CONSTANT(SBConstants, StringStartOffset, SB_StringStartOffset, SB_StringStartOffset);
	SB_REGISTER_LONG_CONSTANT(SBConstants, StringStartInvOffset, SB_StringStartInvOffset, SB_StringStartInvOffset);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, cSBPathSeparator, SB_cSBPathSeparator, "" + SB_cSBPathSeparator, 1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION, SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION, SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_MD2_RSA_ENCRYPTION, SB_CERT_ALGORITHM_MD2_RSA_ENCRYPTION, SB_CERT_ALGORITHM_MD2_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_MD5_RSA_ENCRYPTION, SB_CERT_ALGORITHM_MD5_RSA_ENCRYPTION, SB_CERT_ALGORITHM_MD5_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA1_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA1_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA1_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_DSA, SB_CERT_ALGORITHM_ID_DSA, SB_CERT_ALGORITHM_ID_DSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_DSA_SHA1, SB_CERT_ALGORITHM_ID_DSA_SHA1, SB_CERT_ALGORITHM_ID_DSA_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_DH_PUBLIC, SB_CERT_ALGORITHM_DH_PUBLIC, SB_CERT_ALGORITHM_DH_PUBLIC);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA224_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA224_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA224_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA256_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA256_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA256_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA384_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA384_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA384_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA512_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA512_RSA_ENCRYPTION, SB_CERT_ALGORITHM_SHA512_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_RSAPSS, SB_CERT_ALGORITHM_ID_RSAPSS, SB_CERT_ALGORITHM_ID_RSAPSS);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_RSAOAEP, SB_CERT_ALGORITHM_ID_RSAOAEP, SB_CERT_ALGORITHM_ID_RSAOAEP);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_RSASIGNATURE_RIPEMD160, SB_CERT_ALGORITHM_RSASIGNATURE_RIPEMD160, SB_CERT_ALGORITHM_RSASIGNATURE_RIPEMD160);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_ELGAMAL, SB_CERT_ALGORITHM_ID_ELGAMAL, SB_CERT_ALGORITHM_ID_ELGAMAL);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA1_ECDSA, SB_CERT_ALGORITHM_SHA1_ECDSA, SB_CERT_ALGORITHM_SHA1_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_RECOMMENDED_ECDSA, SB_CERT_ALGORITHM_RECOMMENDED_ECDSA, SB_CERT_ALGORITHM_RECOMMENDED_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA224_ECDSA, SB_CERT_ALGORITHM_SHA224_ECDSA, SB_CERT_ALGORITHM_SHA224_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA256_ECDSA, SB_CERT_ALGORITHM_SHA256_ECDSA, SB_CERT_ALGORITHM_SHA256_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA384_ECDSA, SB_CERT_ALGORITHM_SHA384_ECDSA, SB_CERT_ALGORITHM_SHA384_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA512_ECDSA, SB_CERT_ALGORITHM_SHA512_ECDSA, SB_CERT_ALGORITHM_SHA512_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_EC, SB_CERT_ALGORITHM_EC, SB_CERT_ALGORITHM_EC);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SPECIFIED_ECDSA, SB_CERT_ALGORITHM_SPECIFIED_ECDSA, SB_CERT_ALGORITHM_SPECIFIED_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_GOST_R3410_1994, SB_CERT_ALGORITHM_GOST_R3410_1994, SB_CERT_ALGORITHM_GOST_R3410_1994);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_GOST_R3410_2001, SB_CERT_ALGORITHM_GOST_R3410_2001, SB_CERT_ALGORITHM_GOST_R3410_2001);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_GOST_R3411_WITH_R3410_1994, SB_CERT_ALGORITHM_GOST_R3411_WITH_R3410_1994, SB_CERT_ALGORITHM_GOST_R3411_WITH_R3410_1994);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_GOST_R3411_WITH_R3410_2001, SB_CERT_ALGORITHM_GOST_R3411_WITH_R3410_2001, SB_CERT_ALGORITHM_GOST_R3411_WITH_R3410_2001);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA1_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA1_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA1_ECDSA_PLAIN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA224_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA224_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA224_ECDSA_PLAIN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA256_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA256_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA256_ECDSA_PLAIN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA384_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA384_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA384_ECDSA_PLAIN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_SHA512_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA512_ECDSA_PLAIN, SB_CERT_ALGORITHM_SHA512_ECDSA_PLAIN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_RIPEMD160_ECDSA_PLAIN, SB_CERT_ALGORITHM_RIPEMD160_ECDSA_PLAIN, SB_CERT_ALGORITHM_RIPEMD160_ECDSA_PLAIN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_WHIRLPOOL_RSA_ENCRYPTION, SB_CERT_ALGORITHM_WHIRLPOOL_RSA_ENCRYPTION, SB_CERT_ALGORITHM_WHIRLPOOL_RSA_ENCRYPTION);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_DSA_SHA224, SB_CERT_ALGORITHM_ID_DSA_SHA224, SB_CERT_ALGORITHM_ID_DSA_SHA224);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_ID_DSA_SHA256, SB_CERT_ALGORITHM_ID_DSA_SHA256, SB_CERT_ALGORITHM_ID_DSA_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1, SB_CERT_MGF1, SB_CERT_MGF1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_SHA1, SB_CERT_MGF1_SHA1, SB_CERT_MGF1_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_SHA224, SB_CERT_MGF1_SHA224, SB_CERT_MGF1_SHA224);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_SHA256, SB_CERT_MGF1_SHA256, SB_CERT_MGF1_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_SHA384, SB_CERT_MGF1_SHA384, SB_CERT_MGF1_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_SHA512, SB_CERT_MGF1_SHA512, SB_CERT_MGF1_SHA512);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_RIPEMD160, SB_CERT_MGF1_RIPEMD160, SB_CERT_MGF1_RIPEMD160);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_MGF1_WHIRLPOOL, SB_CERT_MGF1_WHIRLPOOL, SB_CERT_MGF1_WHIRLPOOL);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_CERT_ALGORITHM_UNKNOWN, SB_CERT_ALGORITHM_UNKNOWN, SB_CERT_ALGORITHM_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_BASE, SB_ALGORITHM_CNT_BASE, SB_ALGORITHM_CNT_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_RC4, SB_ALGORITHM_CNT_RC4, SB_ALGORITHM_CNT_RC4);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_DES, SB_ALGORITHM_CNT_DES, SB_ALGORITHM_CNT_DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_3DES, SB_ALGORITHM_CNT_3DES, SB_ALGORITHM_CNT_3DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_RC2, SB_ALGORITHM_CNT_RC2, SB_ALGORITHM_CNT_RC2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_AES128, SB_ALGORITHM_CNT_AES128, SB_ALGORITHM_CNT_AES128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_AES192, SB_ALGORITHM_CNT_AES192, SB_ALGORITHM_CNT_AES192);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_AES256, SB_ALGORITHM_CNT_AES256, SB_ALGORITHM_CNT_AES256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_IDENTITY, SB_ALGORITHM_CNT_IDENTITY, SB_ALGORITHM_CNT_IDENTITY);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_BLOWFISH, SB_ALGORITHM_CNT_BLOWFISH, SB_ALGORITHM_CNT_BLOWFISH);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_TWOFISH, SB_ALGORITHM_CNT_TWOFISH, SB_ALGORITHM_CNT_TWOFISH);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_CAMELLIA, SB_ALGORITHM_CNT_CAMELLIA, SB_ALGORITHM_CNT_CAMELLIA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_CAST128, SB_ALGORITHM_CNT_CAST128, SB_ALGORITHM_CNT_CAST128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_IDEA, SB_ALGORITHM_CNT_IDEA, SB_ALGORITHM_CNT_IDEA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_SERPENT, SB_ALGORITHM_CNT_SERPENT, SB_ALGORITHM_CNT_SERPENT);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_TWOFISH128, SB_ALGORITHM_CNT_TWOFISH128, SB_ALGORITHM_CNT_TWOFISH128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_TWOFISH192, SB_ALGORITHM_CNT_TWOFISH192, SB_ALGORITHM_CNT_TWOFISH192);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_TWOFISH256, SB_ALGORITHM_CNT_TWOFISH256, SB_ALGORITHM_CNT_TWOFISH256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_CAMELLIA128, SB_ALGORITHM_CNT_CAMELLIA128, SB_ALGORITHM_CNT_CAMELLIA128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_CAMELLIA192, SB_ALGORITHM_CNT_CAMELLIA192, SB_ALGORITHM_CNT_CAMELLIA192);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_CAMELLIA256, SB_ALGORITHM_CNT_CAMELLIA256, SB_ALGORITHM_CNT_CAMELLIA256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_SERPENT128, SB_ALGORITHM_CNT_SERPENT128, SB_ALGORITHM_CNT_SERPENT128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_SERPENT192, SB_ALGORITHM_CNT_SERPENT192, SB_ALGORITHM_CNT_SERPENT192);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_SERPENT256, SB_ALGORITHM_CNT_SERPENT256, SB_ALGORITHM_CNT_SERPENT256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_SEED, SB_ALGORITHM_CNT_SEED, SB_ALGORITHM_CNT_SEED);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_RABBIT, SB_ALGORITHM_CNT_RABBIT, SB_ALGORITHM_CNT_RABBIT);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_SYMMETRIC, SB_ALGORITHM_CNT_SYMMETRIC, SB_ALGORITHM_CNT_SYMMETRIC);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_GOST_28147_1989, SB_ALGORITHM_CNT_GOST_28147_1989, SB_ALGORITHM_CNT_GOST_28147_1989);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_CNT_CHACHA20, SB_ALGORITHM_CNT_CHACHA20, SB_ALGORITHM_CNT_CHACHA20);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_BASE, SB_ALGORITHM_PK_BASE, SB_ALGORITHM_PK_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_RSA, SB_ALGORITHM_PK_RSA, SB_ALGORITHM_PK_RSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_DSA, SB_ALGORITHM_PK_DSA, SB_ALGORITHM_PK_DSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_ELGAMAL, SB_ALGORITHM_PK_ELGAMAL, SB_ALGORITHM_PK_ELGAMAL);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_GOST_R3410_1994, SB_ALGORITHM_PK_GOST_R3410_1994, SB_ALGORITHM_PK_GOST_R3410_1994);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_EC, SB_ALGORITHM_PK_EC, SB_ALGORITHM_PK_EC);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_ECDSA, SB_ALGORITHM_PK_ECDSA, SB_ALGORITHM_PK_ECDSA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_DH, SB_ALGORITHM_PK_DH, SB_ALGORITHM_PK_DH);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_SRP, SB_ALGORITHM_PK_SRP, SB_ALGORITHM_PK_SRP);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_ECDH, SB_ALGORITHM_PK_ECDH, SB_ALGORITHM_PK_ECDH);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PK_GOST_R3410_2001, SB_ALGORITHM_PK_GOST_R3410_2001, SB_ALGORITHM_PK_GOST_R3410_2001);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_BASE, SB_ALGORITHM_DGST_BASE, SB_ALGORITHM_DGST_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_SHA1, SB_ALGORITHM_DGST_SHA1, SB_ALGORITHM_DGST_SHA1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_MD5, SB_ALGORITHM_DGST_MD5, SB_ALGORITHM_DGST_MD5);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_MD2, SB_ALGORITHM_DGST_MD2, SB_ALGORITHM_DGST_MD2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_SHA256, SB_ALGORITHM_DGST_SHA256, SB_ALGORITHM_DGST_SHA256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_SHA384, SB_ALGORITHM_DGST_SHA384, SB_ALGORITHM_DGST_SHA384);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_SHA512, SB_ALGORITHM_DGST_SHA512, SB_ALGORITHM_DGST_SHA512);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_SHA224, SB_ALGORITHM_DGST_SHA224, SB_ALGORITHM_DGST_SHA224);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_MD4, SB_ALGORITHM_DGST_MD4, SB_ALGORITHM_DGST_MD4);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_RIPEMD160, SB_ALGORITHM_DGST_RIPEMD160, SB_ALGORITHM_DGST_RIPEMD160);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_CRC32, SB_ALGORITHM_DGST_CRC32, SB_ALGORITHM_DGST_CRC32);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_SSL3, SB_ALGORITHM_DGST_SSL3, SB_ALGORITHM_DGST_SSL3);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_GOST_R3411_1994, SB_ALGORITHM_DGST_GOST_R3411_1994, SB_ALGORITHM_DGST_GOST_R3411_1994);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_WHIRLPOOL, SB_ALGORITHM_DGST_WHIRLPOOL, SB_ALGORITHM_DGST_WHIRLPOOL);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_DGST_POLY1305, SB_ALGORITHM_DGST_POLY1305, SB_ALGORITHM_DGST_POLY1305);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PBE_BASE, SB_ALGORITHM_PBE_BASE, SB_ALGORITHM_PBE_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PBE_SHA1_RC4_128, SB_ALGORITHM_PBE_SHA1_RC4_128, SB_ALGORITHM_PBE_SHA1_RC4_128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PBE_SHA1_RC4_40, SB_ALGORITHM_PBE_SHA1_RC4_40, SB_ALGORITHM_PBE_SHA1_RC4_40);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PBE_SHA1_3DES, SB_ALGORITHM_PBE_SHA1_3DES, SB_ALGORITHM_PBE_SHA1_3DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PBE_SHA1_RC2_128, SB_ALGORITHM_PBE_SHA1_RC2_128, SB_ALGORITHM_PBE_SHA1_RC2_128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_PBE_SHA1_RC2_40, SB_ALGORITHM_PBE_SHA1_RC2_40, SB_ALGORITHM_PBE_SHA1_RC2_40);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBE_MD2_DES, SB_ALGORITHM_P5_PBE_MD2_DES, SB_ALGORITHM_P5_PBE_MD2_DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBE_MD2_RC2, SB_ALGORITHM_P5_PBE_MD2_RC2, SB_ALGORITHM_P5_PBE_MD2_RC2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBE_MD5_DES, SB_ALGORITHM_P5_PBE_MD5_DES, SB_ALGORITHM_P5_PBE_MD5_DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBE_MD5_RC2, SB_ALGORITHM_P5_PBE_MD5_RC2, SB_ALGORITHM_P5_PBE_MD5_RC2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBE_SHA1_DES, SB_ALGORITHM_P5_PBE_SHA1_DES, SB_ALGORITHM_P5_PBE_SHA1_DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBE_SHA1_RC2, SB_ALGORITHM_P5_PBE_SHA1_RC2, SB_ALGORITHM_P5_PBE_SHA1_RC2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBES1, SB_ALGORITHM_P5_PBES1, SB_ALGORITHM_P5_PBES1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBES2, SB_ALGORITHM_P5_PBES2, SB_ALGORITHM_P5_PBES2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBKDF1, SB_ALGORITHM_P5_PBKDF1, SB_ALGORITHM_P5_PBKDF1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBKDF2, SB_ALGORITHM_P5_PBKDF2, SB_ALGORITHM_P5_PBKDF2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_P5_PBMAC1, SB_ALGORITHM_P5_PBMAC1, SB_ALGORITHM_P5_PBMAC1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_BASE, SB_ALGORITHM_MAC_BASE, SB_ALGORITHM_MAC_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACSHA1, SB_ALGORITHM_MAC_HMACSHA1, SB_ALGORITHM_MAC_HMACSHA1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACSHA224, SB_ALGORITHM_MAC_HMACSHA224, SB_ALGORITHM_MAC_HMACSHA224);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACSHA256, SB_ALGORITHM_MAC_HMACSHA256, SB_ALGORITHM_MAC_HMACSHA256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACSHA384, SB_ALGORITHM_MAC_HMACSHA384, SB_ALGORITHM_MAC_HMACSHA384);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACSHA512, SB_ALGORITHM_MAC_HMACSHA512, SB_ALGORITHM_MAC_HMACSHA512);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACMD5, SB_ALGORITHM_MAC_HMACMD5, SB_ALGORITHM_MAC_HMACMD5);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_HMACRIPEMD, SB_ALGORITHM_MAC_HMACRIPEMD, SB_ALGORITHM_MAC_HMACRIPEMD);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_HMAC, SB_ALGORITHM_HMAC, SB_ALGORITHM_HMAC);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_UMAC32, SB_ALGORITHM_UMAC32, SB_ALGORITHM_UMAC32);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_UMAC64, SB_ALGORITHM_UMAC64, SB_ALGORITHM_UMAC64);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_UMAC96, SB_ALGORITHM_UMAC96, SB_ALGORITHM_UMAC96);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_UMAC128, SB_ALGORITHM_UMAC128, SB_ALGORITHM_UMAC128);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_GOST_28147_1989, SB_ALGORITHM_MAC_GOST_28147_1989, SB_ALGORITHM_MAC_GOST_28147_1989);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_HMAC_GOST_R3411_1994, SB_ALGORITHM_HMAC_GOST_R3411_1994, SB_ALGORITHM_HMAC_GOST_R3411_1994);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_MAC_POLY1305, SB_ALGORITHM_MAC_POLY1305, SB_ALGORITHM_MAC_POLY1305);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_AEAD_BASE, SB_ALGORITHM_AEAD_BASE, SB_ALGORITHM_AEAD_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_AEAD_CHACHA20_POLY1305, SB_ALGORITHM_AEAD_CHACHA20_POLY1305, SB_ALGORITHM_AEAD_CHACHA20_POLY1305);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ALGORITHM_UNKNOWN, SB_ALGORITHM_UNKNOWN, SB_ALGORITHM_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_CLASS_DATA_ENCRYPT, SB_ALG_CLASS_DATA_ENCRYPT, SB_ALG_CLASS_DATA_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_TYPE_BLOCK, SB_ALG_TYPE_BLOCK, SB_ALG_TYPE_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_TYPE_STREAM, SB_ALG_TYPE_STREAM, SB_ALG_TYPE_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_SID_DES, SB_ALG_SID_DES, SB_ALG_SID_DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_SID_3DES, SB_ALG_SID_3DES, SB_ALG_SID_3DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_SID_RC2, SB_ALG_SID_RC2, SB_ALG_SID_RC2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, ALG_SID_RC4, SB_ALG_SID_RC4, SB_ALG_SID_RC4);
	SB_REGISTER_LONG_CONSTANT(SBConstants, CALG_DES, SB_CALG_DES, SB_CALG_DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, CALG_3DES, SB_CALG_3DES, SB_CALG_3DES);
	SB_REGISTER_LONG_CONSTANT(SBConstants, CALG_RC2, SB_CALG_RC2, SB_CALG_RC2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, CALG_RC4, SB_CALG_RC4, SB_CALG_RC4);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_TYPE_BASE, SB_EC_FLD_TYPE_BASE, SB_EC_FLD_TYPE_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_TYPE_UNKNOWN, SB_EC_FLD_TYPE_UNKNOWN, SB_EC_FLD_TYPE_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_TYPE_FP, SB_EC_FLD_TYPE_FP, SB_EC_FLD_TYPE_FP);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_TYPE_F2MP, SB_EC_FLD_TYPE_F2MP, SB_EC_FLD_TYPE_F2MP);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_TYPE_F2MN, SB_EC_FLD_TYPE_F2MN, SB_EC_FLD_TYPE_F2MN);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_BASE, SB_EC_FLD_BASE, SB_EC_FLD_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_FIRST, SB_EC_FLD_FIRST, SB_EC_FLD_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_CUSTOM, SB_EC_FLD_CUSTOM, SB_EC_FLD_CUSTOM);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_P192S, SB_EC_FLD_NIST_P192S, SB_EC_FLD_NIST_P192S);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_P224S, SB_EC_FLD_NIST_P224S, SB_EC_FLD_NIST_P224S);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_P256S, SB_EC_FLD_NIST_P256S, SB_EC_FLD_NIST_P256S);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_P384, SB_EC_FLD_NIST_P384, SB_EC_FLD_NIST_P384);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_P521, SB_EC_FLD_NIST_P521, SB_EC_FLD_NIST_P521);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_B163, SB_EC_FLD_NIST_B163, SB_EC_FLD_NIST_B163);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_B233, SB_EC_FLD_NIST_B233, SB_EC_FLD_NIST_B233);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_B283, SB_EC_FLD_NIST_B283, SB_EC_FLD_NIST_B283);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_B409, SB_EC_FLD_NIST_B409, SB_EC_FLD_NIST_B409);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_NIST_B571, SB_EC_FLD_NIST_B571, SB_EC_FLD_NIST_B571);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FLD_LAST, SB_EC_FLD_LAST, SB_EC_FLD_LAST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ECDSA_WRAP_SHIFT, SB_ECDSA_WRAP_SHIFT, SB_ECDSA_WRAP_SHIFT);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_ECDSA_WRAP_MOD_N, SB_ECDSA_WRAP_MOD_N, SB_ECDSA_WRAP_MOD_N);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BASE, SB_EC_BASE, SB_EC_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_FIRST, SB_EC_FIRST, SB_EC_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_CUSTOM, SB_EC_CUSTOM, SB_EC_CUSTOM);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP112R1, SB_EC_SECP112R1, SB_EC_SECP112R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP112R2, SB_EC_SECP112R2, SB_EC_SECP112R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP128R1, SB_EC_SECP128R1, SB_EC_SECP128R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP128R2, SB_EC_SECP128R2, SB_EC_SECP128R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP160K1, SB_EC_SECP160K1, SB_EC_SECP160K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP160R1, SB_EC_SECP160R1, SB_EC_SECP160R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP160R2, SB_EC_SECP160R2, SB_EC_SECP160R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP192K1, SB_EC_SECP192K1, SB_EC_SECP192K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP192R1, SB_EC_SECP192R1, SB_EC_SECP192R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP224K1, SB_EC_SECP224K1, SB_EC_SECP224K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP224R1, SB_EC_SECP224R1, SB_EC_SECP224R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP256K1, SB_EC_SECP256K1, SB_EC_SECP256K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP256R1, SB_EC_SECP256R1, SB_EC_SECP256R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP384R1, SB_EC_SECP384R1, SB_EC_SECP384R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECP521R1, SB_EC_SECP521R1, SB_EC_SECP521R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT113R1, SB_EC_SECT113R1, SB_EC_SECT113R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT113R2, SB_EC_SECT113R2, SB_EC_SECT113R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT131R1, SB_EC_SECT131R1, SB_EC_SECT131R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT131R2, SB_EC_SECT131R2, SB_EC_SECT131R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT163K1, SB_EC_SECT163K1, SB_EC_SECT163K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT163R1, SB_EC_SECT163R1, SB_EC_SECT163R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT163R2, SB_EC_SECT163R2, SB_EC_SECT163R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT193R1, SB_EC_SECT193R1, SB_EC_SECT193R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT193R2, SB_EC_SECT193R2, SB_EC_SECT193R2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT233K1, SB_EC_SECT233K1, SB_EC_SECT233K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT233R1, SB_EC_SECT233R1, SB_EC_SECT233R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT239K1, SB_EC_SECT239K1, SB_EC_SECT239K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT283K1, SB_EC_SECT283K1, SB_EC_SECT283K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT283R1, SB_EC_SECT283R1, SB_EC_SECT283R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT409K1, SB_EC_SECT409K1, SB_EC_SECT409K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT409R1, SB_EC_SECT409R1, SB_EC_SECT409R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT571K1, SB_EC_SECT571K1, SB_EC_SECT571K1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_SECT571R1, SB_EC_SECT571R1, SB_EC_SECT571R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME192V1, SB_EC_PRIME192V1, SB_EC_PRIME192V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME192V2, SB_EC_PRIME192V2, SB_EC_PRIME192V2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME192V3, SB_EC_PRIME192V3, SB_EC_PRIME192V3);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME239V1, SB_EC_PRIME239V1, SB_EC_PRIME239V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME239V2, SB_EC_PRIME239V2, SB_EC_PRIME239V2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME239V3, SB_EC_PRIME239V3, SB_EC_PRIME239V3);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_PRIME256V1, SB_EC_PRIME256V1, SB_EC_PRIME256V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB163V1, SB_EC_C2PNB163V1, SB_EC_C2PNB163V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB163V2, SB_EC_C2PNB163V2, SB_EC_C2PNB163V2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB163V3, SB_EC_C2PNB163V3, SB_EC_C2PNB163V3);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB176W1, SB_EC_C2PNB176W1, SB_EC_C2PNB176W1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB191V1, SB_EC_C2TNB191V1, SB_EC_C2TNB191V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB191V2, SB_EC_C2TNB191V2, SB_EC_C2TNB191V2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB191V3, SB_EC_C2TNB191V3, SB_EC_C2TNB191V3);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2ONB191V4, SB_EC_C2ONB191V4, SB_EC_C2ONB191V4);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2ONB191V5, SB_EC_C2ONB191V5, SB_EC_C2ONB191V5);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB208W1, SB_EC_C2PNB208W1, SB_EC_C2PNB208W1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB239V1, SB_EC_C2TNB239V1, SB_EC_C2TNB239V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB239V2, SB_EC_C2TNB239V2, SB_EC_C2TNB239V2);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB239V3, SB_EC_C2TNB239V3, SB_EC_C2TNB239V3);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2ONB239V4, SB_EC_C2ONB239V4, SB_EC_C2ONB239V4);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2ONB239V5, SB_EC_C2ONB239V5, SB_EC_C2ONB239V5);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB272W1, SB_EC_C2PNB272W1, SB_EC_C2PNB272W1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB304W1, SB_EC_C2PNB304W1, SB_EC_C2PNB304W1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB359V1, SB_EC_C2TNB359V1, SB_EC_C2TNB359V1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2PNB368W1, SB_EC_C2PNB368W1, SB_EC_C2PNB368W1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_C2TNB431R1, SB_EC_C2TNB431R1, SB_EC_C2TNB431R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_P192, SB_EC_NIST_P192, SB_EC_NIST_P192);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_P224, SB_EC_NIST_P224, SB_EC_NIST_P224);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_P256, SB_EC_NIST_P256, SB_EC_NIST_P256);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_P384, SB_EC_NIST_P384, SB_EC_NIST_P384);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_P521, SB_EC_NIST_P521, SB_EC_NIST_P521);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_B163, SB_EC_NIST_B163, SB_EC_NIST_B163);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_B233, SB_EC_NIST_B233, SB_EC_NIST_B233);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_B283, SB_EC_NIST_B283, SB_EC_NIST_B283);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_B409, SB_EC_NIST_B409, SB_EC_NIST_B409);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_B571, SB_EC_NIST_B571, SB_EC_NIST_B571);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_K163, SB_EC_NIST_K163, SB_EC_NIST_K163);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_K233, SB_EC_NIST_K233, SB_EC_NIST_K233);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_K283, SB_EC_NIST_K283, SB_EC_NIST_K283);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_K409, SB_EC_NIST_K409, SB_EC_NIST_K409);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_NIST_K571, SB_EC_NIST_K571, SB_EC_NIST_K571);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_GOST_CP_TEST, SB_EC_GOST_CP_TEST, SB_EC_GOST_CP_TEST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_GOST_CP_A, SB_EC_GOST_CP_A, SB_EC_GOST_CP_A);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_GOST_CP_B, SB_EC_GOST_CP_B, SB_EC_GOST_CP_B);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_GOST_CP_C, SB_EC_GOST_CP_C, SB_EC_GOST_CP_C);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_GOST_CP_XCHA, SB_EC_GOST_CP_XCHA, SB_EC_GOST_CP_XCHA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_GOST_CP_XCHB, SB_EC_GOST_CP_XCHB, SB_EC_GOST_CP_XCHB);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP160R1, SB_EC_BRAINPOOLP160R1, SB_EC_BRAINPOOLP160R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP160T1, SB_EC_BRAINPOOLP160T1, SB_EC_BRAINPOOLP160T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP192R1, SB_EC_BRAINPOOLP192R1, SB_EC_BRAINPOOLP192R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP192T1, SB_EC_BRAINPOOLP192T1, SB_EC_BRAINPOOLP192T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP224R1, SB_EC_BRAINPOOLP224R1, SB_EC_BRAINPOOLP224R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP224T1, SB_EC_BRAINPOOLP224T1, SB_EC_BRAINPOOLP224T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP256R1, SB_EC_BRAINPOOLP256R1, SB_EC_BRAINPOOLP256R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP256T1, SB_EC_BRAINPOOLP256T1, SB_EC_BRAINPOOLP256T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP320R1, SB_EC_BRAINPOOLP320R1, SB_EC_BRAINPOOLP320R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP320T1, SB_EC_BRAINPOOLP320T1, SB_EC_BRAINPOOLP320T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP384R1, SB_EC_BRAINPOOLP384R1, SB_EC_BRAINPOOLP384R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP384T1, SB_EC_BRAINPOOLP384T1, SB_EC_BRAINPOOLP384T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP512R1, SB_EC_BRAINPOOLP512R1, SB_EC_BRAINPOOLP512R1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_BRAINPOOLP512T1, SB_EC_BRAINPOOLP512T1, SB_EC_BRAINPOOLP512T1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_CURVE25519, SB_EC_CURVE25519, SB_EC_CURVE25519);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_EC_LAST, SB_EC_LAST, SB_EC_LAST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_PARAM_BASE, SB_GOST_PARAM_BASE, SB_GOST_PARAM_BASE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_PARAM_NONE, SB_GOST_PARAM_NONE, SB_GOST_PARAM_NONE);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_PARAM_CUSTOM, SB_GOST_PARAM_CUSTOM, SB_GOST_PARAM_CUSTOM);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_TEST, SB_GOST_28147_1989_PARAM_CP_TEST, SB_GOST_28147_1989_PARAM_CP_TEST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_A, SB_GOST_28147_1989_PARAM_CP_A, SB_GOST_28147_1989_PARAM_CP_A);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_B, SB_GOST_28147_1989_PARAM_CP_B, SB_GOST_28147_1989_PARAM_CP_B);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_C, SB_GOST_28147_1989_PARAM_CP_C, SB_GOST_28147_1989_PARAM_CP_C);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_D, SB_GOST_28147_1989_PARAM_CP_D, SB_GOST_28147_1989_PARAM_CP_D);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_OSCAR_11, SB_GOST_28147_1989_PARAM_CP_OSCAR_11, SB_GOST_28147_1989_PARAM_CP_OSCAR_11);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_OSCAR_10, SB_GOST_28147_1989_PARAM_CP_OSCAR_10, SB_GOST_28147_1989_PARAM_CP_OSCAR_10);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_28147_1989_PARAM_CP_RIC_1, SB_GOST_28147_1989_PARAM_CP_RIC_1, SB_GOST_28147_1989_PARAM_CP_RIC_1);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3411_1994_PARAM_CP_TEST, SB_GOST_R3411_1994_PARAM_CP_TEST, SB_GOST_R3411_1994_PARAM_CP_TEST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3411_1994_PARAM_CP, SB_GOST_R3411_1994_PARAM_CP, SB_GOST_R3411_1994_PARAM_CP);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_TEST, SB_GOST_R3410_1994_PARAM_CP_TEST, SB_GOST_R3410_1994_PARAM_CP_TEST);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_A, SB_GOST_R3410_1994_PARAM_CP_A, SB_GOST_R3410_1994_PARAM_CP_A);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_B, SB_GOST_R3410_1994_PARAM_CP_B, SB_GOST_R3410_1994_PARAM_CP_B);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_C, SB_GOST_R3410_1994_PARAM_CP_C, SB_GOST_R3410_1994_PARAM_CP_C);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_D, SB_GOST_R3410_1994_PARAM_CP_D, SB_GOST_R3410_1994_PARAM_CP_D);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_XCHA, SB_GOST_R3410_1994_PARAM_CP_XCHA, SB_GOST_R3410_1994_PARAM_CP_XCHA);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_XCHB, SB_GOST_R3410_1994_PARAM_CP_XCHB, SB_GOST_R3410_1994_PARAM_CP_XCHB);
	SB_REGISTER_LONG_CONSTANT(SBConstants, SB_GOST_R3410_1994_PARAM_CP_XCHC, SB_GOST_R3410_1994_PARAM_CP_XCHC, SB_GOST_R3410_1994_PARAM_CP_XCHC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, LowerAlphabet, SB_LowerAlphabet, SB_LowerAlphabet);
	SB_REGISTER_STRING_CONSTANT(SBConstants, UpperAlphabet, SB_UpperAlphabet, SB_UpperAlphabet);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SAddressNotSet, SB_SAddressNotSet, SB_SAddressNotSet);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SConnAlreadyEstablished, SB_SConnAlreadyEstablished, SB_SConnAlreadyEstablished);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SConnNotPresent, SB_SConnNotPresent, SB_SConnNotPresent);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SConnLost, SB_SConnLost, SB_SConnLost);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SConnTimeout, SB_SConnTimeout, SB_SConnTimeout);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SConnFailed, SB_SConnFailed, SB_SConnFailed);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SConnError, SB_SConnError, SB_SConnError);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RC4, SB_OID_RC4, SB_OID_RC4);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RSAENCRYPTION, SB_OID_RSAENCRYPTION, SB_OID_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EA_RSA, SB_OID_EA_RSA, SB_OID_EA_RSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RSAPSS, SB_OID_RSAPSS, SB_OID_RSAPSS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RSAOAEP, SB_OID_RSAOAEP, SB_OID_RSAOAEP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DSA, SB_OID_DSA, SB_OID_DSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DSA_SHA1, SB_OID_DSA_SHA1, SB_OID_DSA_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DSA_SHA224, SB_OID_DSA_SHA224, SB_OID_DSA_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DSA_SHA256, SB_OID_DSA_SHA256, SB_OID_DSA_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DSA_ALT, SB_OID_DSA_ALT, SB_OID_DSA_ALT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DSA_SHA1_ALT, SB_OID_DSA_SHA1_ALT, SB_OID_DSA_SHA1_ALT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DH, SB_OID_DH, SB_OID_DH);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DES_EDE3_CBC, SB_OID_DES_EDE3_CBC, SB_OID_DES_EDE3_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PKCS7_DATA, SBConstants_SB_OID_PKCS7_DATA, SBConstants_SB_OID_PKCS7_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RC2_CBC, SB_OID_RC2_CBC, SB_OID_RC2_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DES_CBC, SB_OID_DES_CBC, SB_OID_DES_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA1_RSAENCRYPTION, SB_OID_SHA1_RSAENCRYPTION, SB_OID_SHA1_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA1_RSAENCRYPTION2, SB_OID_SHA1_RSAENCRYPTION2, SB_OID_SHA1_RSAENCRYPTION2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA224_RSAENCRYPTION, SB_OID_SHA224_RSAENCRYPTION, SB_OID_SHA224_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA256_RSAENCRYPTION, SB_OID_SHA256_RSAENCRYPTION, SB_OID_SHA256_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA384_RSAENCRYPTION, SB_OID_SHA384_RSAENCRYPTION, SB_OID_SHA384_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA512_RSAENCRYPTION, SB_OID_SHA512_RSAENCRYPTION, SB_OID_SHA512_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RSASIGNATURE_RIPEMD160, SB_OID_RSASIGNATURE_RIPEMD160, SB_OID_RSASIGNATURE_RIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_TSTINFO, SB_OID_TSTINFO, SB_OID_TSTINFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_AES128_CBC, SB_OID_AES128_CBC, SB_OID_AES128_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_AES192_CBC, SB_OID_AES192_CBC, SB_OID_AES192_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_AES256_CBC, SB_OID_AES256_CBC, SB_OID_AES256_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SERPENT128_CBC, SB_OID_SERPENT128_CBC, SB_OID_SERPENT128_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SERPENT192_CBC, SB_OID_SERPENT192_CBC, SB_OID_SERPENT192_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SERPENT256_CBC, SB_OID_SERPENT256_CBC, SB_OID_SERPENT256_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CAST5_CBC, SB_OID_CAST5_CBC, SB_OID_CAST5_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_BLOWFISH_CBC, SB_OID_BLOWFISH_CBC, SB_OID_BLOWFISH_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CAMELLIA128_CBC, SB_OID_CAMELLIA128_CBC, SB_OID_CAMELLIA128_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CAMELLIA192_CBC, SB_OID_CAMELLIA192_CBC, SB_OID_CAMELLIA192_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CAMELLIA256_CBC, SB_OID_CAMELLIA256_CBC, SB_OID_CAMELLIA256_CBC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SEED, SB_OID_SEED, SB_OID_SEED);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, SB_OID_RABBIT, SB_OID_RABBIT, "" + SB_OID_RABBIT, 1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_IDENTITY, SB_OID_IDENTITY, SB_OID_IDENTITY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_IDENTITY_ELDOS, SB_OID_IDENTITY_ELDOS, SB_OID_IDENTITY_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_TWOFISH128_ELDOS, SB_OID_TWOFISH128_ELDOS, SB_OID_TWOFISH128_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_TWOFISH256_ELDOS, SB_OID_TWOFISH256_ELDOS, SB_OID_TWOFISH256_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_TWOFISH192_ELDOS, SB_OID_TWOFISH192_ELDOS, SB_OID_TWOFISH192_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CHACHA20_ELDOS, SB_OID_CHACHA20_ELDOS, SB_OID_CHACHA20_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RSASIGNATURE_RIPEMD160_ISO9796, SB_OID_RSASIGNATURE_RIPEMD160_ISO9796, SB_OID_RSASIGNATURE_RIPEMD160_ISO9796);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_WHIRLPOOL_RSAENCRYPTION_ELDOS, SB_OID_WHIRLPOOL_RSAENCRYPTION_ELDOS, SB_OID_WHIRLPOOL_RSAENCRYPTION_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1, SB_OID_MGF1, SB_OID_MGF1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_SHA1, SB_OID_MGF1_SHA1, SB_OID_MGF1_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_SHA224, SB_OID_MGF1_SHA224, SB_OID_MGF1_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_SHA256, SB_OID_MGF1_SHA256, SB_OID_MGF1_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_SHA384, SB_OID_MGF1_SHA384, SB_OID_MGF1_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_SHA512, SB_OID_MGF1_SHA512, SB_OID_MGF1_SHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_RIPEMD160, SB_OID_MGF1_RIPEMD160, SB_OID_MGF1_RIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MGF1_WHIRLPOOL, SB_OID_MGF1_WHIRLPOOL, SB_OID_MGF1_WHIRLPOOL);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_OAEP_SRC_SPECIFIED, SB_OID_OAEP_SRC_SPECIFIED, SB_OID_OAEP_SRC_SPECIFIED);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_MD2_DES, SB_OID_PBE_MD2_DES, SB_OID_PBE_MD2_DES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_MD2_RC2, SB_OID_PBE_MD2_RC2, SB_OID_PBE_MD2_RC2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_MD5_DES, SB_OID_PBE_MD5_DES, SB_OID_PBE_MD5_DES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_MD5_RC2, SB_OID_PBE_MD5_RC2, SB_OID_PBE_MD5_RC2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_DES, SB_OID_PBE_SHA1_DES, SB_OID_PBE_SHA1_DES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_RC2, SB_OID_PBE_SHA1_RC2, SB_OID_PBE_SHA1_RC2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBES2, SB_OID_PBES2, SB_OID_PBES2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBKDF2, SB_OID_PBKDF2, SB_OID_PBKDF2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBMAC1, SB_OID_PBMAC1, SB_OID_PBMAC1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_RC4_128, SB_OID_PBE_SHA1_RC4_128, SB_OID_PBE_SHA1_RC4_128);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_RC4_40, SB_OID_PBE_SHA1_RC4_40, SB_OID_PBE_SHA1_RC4_40);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_3DES, SB_OID_PBE_SHA1_3DES, SB_OID_PBE_SHA1_3DES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_RC2_128, SB_OID_PBE_SHA1_RC2_128, SB_OID_PBE_SHA1_RC2_128);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PBE_SHA1_RC2_40, SB_OID_PBE_SHA1_RC2_40, SB_OID_PBE_SHA1_RC2_40);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MD2_RSAENCRYPTION, SB_OID_MD2_RSAENCRYPTION, SB_OID_MD2_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MD4_RSAENCRYPTION, SB_OID_MD4_RSAENCRYPTION, SB_OID_MD4_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MD5_RSAENCRYPTION, SB_OID_MD5_RSAENCRYPTION, SB_OID_MD5_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA1_RSA, SB_OID_SHA1_RSA, SB_OID_SHA1_RSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA1_DSA, SB_OID_SHA1_DSA, SB_OID_SHA1_DSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PKCS15, SB_OID_PKCS15, SB_OID_PKCS15);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_PWRI_KEK, SB_OID_PWRI_KEK, SB_OID_PWRI_KEK);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_DATA, SB_OID_DATA, SB_OID_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MD2, SB_OID_MD2, SB_OID_MD2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MD4, SB_OID_MD4, SB_OID_MD4);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MD5, SB_OID_MD5, SB_OID_MD5);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA1, SB_OID_SHA1, SB_OID_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA224, SB_OID_SHA224, SB_OID_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA256, SB_OID_SHA256, SB_OID_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA384, SB_OID_SHA384, SB_OID_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SHA512, SB_OID_SHA512, SB_OID_SHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RIPEMD160, SB_OID_RIPEMD160, SB_OID_RIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SSL3, SB_OID_SSL3, SB_OID_SSL3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_WHIRLPOOL, SB_OID_WHIRLPOOL, SB_OID_WHIRLPOOL);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_POLY1305_ELDOS, SB_OID_POLY1305_ELDOS, SB_OID_POLY1305_ELDOS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_HMACSHA1, SB_OID_HMACSHA1, SB_OID_HMACSHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_HMACSHA1_PKCS, SB_OID_HMACSHA1_PKCS, SB_OID_HMACSHA1_PKCS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_HMACSHA224, SB_OID_HMACSHA224, SB_OID_HMACSHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_HMACSHA256, SB_OID_HMACSHA256, SB_OID_HMACSHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_HMACSHA384, SB_OID_HMACSHA384, SB_OID_HMACSHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_HMACSHA512, SB_OID_HMACSHA512, SB_OID_HMACSHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_RSA_HMACSHA1, SB_OID_RSA_HMACSHA1, SB_OID_RSA_HMACSHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_UMAC32, SB_OID_UMAC32, SB_OID_UMAC32);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_UMAC64, SB_OID_UMAC64, SB_OID_UMAC64);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_UMAC96, SB_OID_UMAC96, SB_OID_UMAC96);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_UMAC128, SB_OID_UMAC128, SB_OID_UMAC128);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CONTENT_TYPE, SB_OID_CONTENT_TYPE, SB_OID_CONTENT_TYPE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MESSAGE_DIGEST, SB_OID_MESSAGE_DIGEST, SB_OID_MESSAGE_DIGEST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNING_TIME, SB_OID_SIGNING_TIME, SB_OID_SIGNING_TIME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_COUNTER_SIGNATURE, SB_OID_COUNTER_SIGNATURE, SB_OID_COUNTER_SIGNATURE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SMIME_CAPABILITIES, SB_OID_SMIME_CAPABILITIES, SB_OID_SMIME_CAPABILITIES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_TIMESTAMP_TOKEN, SB_OID_TIMESTAMP_TOKEN, SB_OID_TIMESTAMP_TOKEN);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNING_CERTIFICATE, SB_OID_SIGNING_CERTIFICATE, SB_OID_SIGNING_CERTIFICATE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNING_CERTIFICATEV2, SB_OID_SIGNING_CERTIFICATEV2, SB_OID_SIGNING_CERTIFICATEV2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CONTENT_HINTS, SB_OID_CONTENT_HINTS, SB_OID_CONTENT_HINTS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_MIME_TYPE, SB_OID_MIME_TYPE, SB_OID_MIME_TYPE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CONTENT_IDENTIFIER, SB_OID_CONTENT_IDENTIFIER, SB_OID_CONTENT_IDENTIFIER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CONTENT_REFERENCE, SB_OID_CONTENT_REFERENCE, SB_OID_CONTENT_REFERENCE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNATURE_POLICY, SB_OID_SIGNATURE_POLICY, SB_OID_SIGNATURE_POLICY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_COMMITMENT_TYPE, SB_OID_COMMITMENT_TYPE, SB_OID_COMMITMENT_TYPE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNER_LOCATION, SB_OID_SIGNER_LOCATION, SB_OID_SIGNER_LOCATION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNER_ATTRIBUTES, SB_OID_SIGNER_ATTRIBUTES, SB_OID_SIGNER_ATTRIBUTES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNER_ATTRIBUTESV2, SB_OID_SIGNER_ATTRIBUTESV2, SB_OID_SIGNER_ATTRIBUTESV2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CONTENT_TIMESTAMP, SB_OID_CONTENT_TIMESTAMP, SB_OID_CONTENT_TIMESTAMP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CERTIFICATE_REFS, SB_OID_CERTIFICATE_REFS, SB_OID_CERTIFICATE_REFS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_REVOCATION_REFS, SB_OID_REVOCATION_REFS, SB_OID_REVOCATION_REFS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CERTIFICATE_VALUES, SB_OID_CERTIFICATE_VALUES, SB_OID_CERTIFICATE_VALUES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_REVOCATION_VALUES, SB_OID_REVOCATION_VALUES, SB_OID_REVOCATION_VALUES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ESCTIMESTAMP, SB_OID_ESCTIMESTAMP, SB_OID_ESCTIMESTAMP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CERTCRLTIMESTAMP, SB_OID_CERTCRLTIMESTAMP, SB_OID_CERTCRLTIMESTAMP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ARCHIVETIMESTAMP, SB_OID_ARCHIVETIMESTAMP, SB_OID_ARCHIVETIMESTAMP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ARCHIVETIMESTAMP2, SB_OID_ARCHIVETIMESTAMP2, SB_OID_ARCHIVETIMESTAMP2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ARCHIVETIMESTAMP3, SB_OID_ARCHIVETIMESTAMP3, SB_OID_ARCHIVETIMESTAMP3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ATSHASHINDEX, SB_OID_ATSHASHINDEX, SB_OID_ATSHASHINDEX);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SIGNATURE_POLICY_STORE, SB_OID_SIGNATURE_POLICY_STORE, SB_OID_SIGNATURE_POLICY_STORE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ATSHASHINDEXV2, SB_OID_ATSHASHINDEXV2, SB_OID_ATSHASHINDEXV2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_INDIRECT_DATA, SB_OID_SPC_INDIRECT_DATA, SB_OID_SPC_INDIRECT_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_SP_AGENCY_INFO, SB_OID_SPC_SP_AGENCY_INFO, SB_OID_SPC_SP_AGENCY_INFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_STATEMENT_TYPE_OBJID, SB_OID_SPC_STATEMENT_TYPE_OBJID, SB_OID_SPC_STATEMENT_TYPE_OBJID);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_STATEMENT_TYPE, SB_OID_SPC_STATEMENT_TYPE, SB_OID_SPC_STATEMENT_TYPE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_SP_OPUS_INFO, SB_OID_SPC_SP_OPUS_INFO, SB_OID_SPC_SP_OPUS_INFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_PE_IMAGE_DATA, SB_OID_SPC_PE_IMAGE_DATA, SB_OID_SPC_PE_IMAGE_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_MINIMAL_CRITERIA, SB_OID_SPC_MINIMAL_CRITERIA, SB_OID_SPC_MINIMAL_CRITERIA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_FINANCIAL_CRITERIA, SB_OID_SPC_FINANCIAL_CRITERIA, SB_OID_SPC_FINANCIAL_CRITERIA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_LINK, SB_OID_SPC_LINK, SB_OID_SPC_LINK);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_HASH_INFO, SB_OID_SPC_HASH_INFO, SB_OID_SPC_HASH_INFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_SIPINFO, SB_OID_SPC_SIPINFO, SB_OID_SPC_SIPINFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_CERT_EXTENSIONS, SB_OID_SPC_CERT_EXTENSIONS, SB_OID_SPC_CERT_EXTENSIONS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_RAW_FILE_DATA, SB_OID_SPC_RAW_FILE_DATA, SB_OID_SPC_RAW_FILE_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_STRUCTURED_STORAGE_DATA, SB_OID_SPC_STRUCTURED_STORAGE_DATA, SB_OID_SPC_STRUCTURED_STORAGE_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_JAVA_CLASS_DATA, SB_OID_SPC_JAVA_CLASS_DATA, SB_OID_SPC_JAVA_CLASS_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_INDIVIDUAL_SP_KEY_PURPOSE, SB_OID_SPC_INDIVIDUAL_SP_KEY_PURPOSE, SB_OID_SPC_INDIVIDUAL_SP_KEY_PURPOSE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_COMMERCIAL_SP_KEY_PURPOSE, SB_OID_SPC_COMMERCIAL_SP_KEY_PURPOSE, SB_OID_SPC_COMMERCIAL_SP_KEY_PURPOSE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SPC_CAB_DATA, SB_OID_SPC_CAB_DATA, SB_OID_SPC_CAB_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_QT_CPS, SB_OID_QT_CPS, SB_OID_QT_CPS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_QT_UNOTICE, SB_OID_QT_UNOTICE, SB_OID_QT_UNOTICE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_SERVER_AUTH, SB_OID_SERVER_AUTH, SB_OID_SERVER_AUTH);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CLIENT_AUTH, SB_OID_CLIENT_AUTH, SB_OID_CLIENT_AUTH);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CODE_SIGNING, SB_OID_CODE_SIGNING, SB_OID_CODE_SIGNING);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EMAIL_PROT, SB_OID_EMAIL_PROT, SB_OID_EMAIL_PROT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_TIME_STAMPING, SB_OID_TIME_STAMPING, SB_OID_TIME_STAMPING);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_OCSP_SIGNING, SB_OID_OCSP_SIGNING, SB_OID_OCSP_SIGNING);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ACCESS_METHOD_OCSP, SB_OID_ACCESS_METHOD_OCSP, SB_OID_ACCESS_METHOD_OCSP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ACCESS_METHOD_CAISSUER, SB_OID_ACCESS_METHOD_CAISSUER, SB_OID_ACCESS_METHOD_CAISSUER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_UNSTRUCTURED_NAME, SB_OID_UNSTRUCTURED_NAME, SB_OID_UNSTRUCTURED_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CERT_EXTENSIONS, SB_OID_CERT_EXTENSIONS, SB_OID_CERT_EXTENSIONS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_CERT_EXTENSIONS_MS, SB_OID_CERT_EXTENSIONS_MS, SB_OID_CERT_EXTENSIONS_MS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989, SB_OID_GOST_28147_1989, SB_OID_GOST_28147_1989);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_MAC, SB_OID_GOST_28147_1989_MAC, SB_OID_GOST_28147_1989_MAC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_2001, SB_OID_GOST_R3410_2001, SB_OID_GOST_R3410_2001);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994, SB_OID_GOST_R3410_1994, SB_OID_GOST_R3410_1994);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_DH, SB_OID_GOST_R3410_1994_DH, SB_OID_GOST_R3410_1994_DH);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3411_1994_WITH_GOST_R3410_2001, SB_OID_GOST_R3411_1994_WITH_GOST_R3410_2001, SB_OID_GOST_R3411_1994_WITH_GOST_R3410_2001);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3411_1994_WITH_GOST_R3410_1994, SB_OID_GOST_R3411_1994_WITH_GOST_R3410_1994, SB_OID_GOST_R3411_1994_WITH_GOST_R3410_1994);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3411_1994, SB_OID_GOST_R3411_1994, SB_OID_GOST_R3411_1994);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3411_1994_HMAC, SB_OID_GOST_R3411_1994_HMAC, SB_OID_GOST_R3411_1994_HMAC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_TEST, SB_OID_GOST_28147_1989_PARAM_CP_TEST, SB_OID_GOST_28147_1989_PARAM_CP_TEST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_A, SB_OID_GOST_28147_1989_PARAM_CP_A, SB_OID_GOST_28147_1989_PARAM_CP_A);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_B, SB_OID_GOST_28147_1989_PARAM_CP_B, SB_OID_GOST_28147_1989_PARAM_CP_B);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_C, SB_OID_GOST_28147_1989_PARAM_CP_C, SB_OID_GOST_28147_1989_PARAM_CP_C);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_D, SB_OID_GOST_28147_1989_PARAM_CP_D, SB_OID_GOST_28147_1989_PARAM_CP_D);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_OSCAR_11, SB_OID_GOST_28147_1989_PARAM_CP_OSCAR_11, SB_OID_GOST_28147_1989_PARAM_CP_OSCAR_11);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_OSCAR_10, SB_OID_GOST_28147_1989_PARAM_CP_OSCAR_10, SB_OID_GOST_28147_1989_PARAM_CP_OSCAR_10);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_28147_1989_PARAM_CP_RIC_1, SB_OID_GOST_28147_1989_PARAM_CP_RIC_1, SB_OID_GOST_28147_1989_PARAM_CP_RIC_1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3411_1994_PARAM_CP_TEST, SB_OID_GOST_R3411_1994_PARAM_CP_TEST, SB_OID_GOST_R3411_1994_PARAM_CP_TEST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3411_1994_PARAM_CP, SB_OID_GOST_R3411_1994_PARAM_CP, SB_OID_GOST_R3411_1994_PARAM_CP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_TEST, SB_OID_GOST_R3410_1994_PARAM_CP_TEST, SB_OID_GOST_R3410_1994_PARAM_CP_TEST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_A, SB_OID_GOST_R3410_1994_PARAM_CP_A, SB_OID_GOST_R3410_1994_PARAM_CP_A);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_B, SB_OID_GOST_R3410_1994_PARAM_CP_B, SB_OID_GOST_R3410_1994_PARAM_CP_B);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_C, SB_OID_GOST_R3410_1994_PARAM_CP_C, SB_OID_GOST_R3410_1994_PARAM_CP_C);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_D, SB_OID_GOST_R3410_1994_PARAM_CP_D, SB_OID_GOST_R3410_1994_PARAM_CP_D);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_XCHA, SB_OID_GOST_R3410_1994_PARAM_CP_XCHA, SB_OID_GOST_R3410_1994_PARAM_CP_XCHA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_XCHB, SB_OID_GOST_R3410_1994_PARAM_CP_XCHB, SB_OID_GOST_R3410_1994_PARAM_CP_XCHB);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_GOST_R3410_1994_PARAM_CP_XCHC, SB_OID_GOST_R3410_1994_PARAM_CP_XCHC, SB_OID_GOST_R3410_1994_PARAM_CP_XCHC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_FLD_CUSTOM, SB_OID_FLD_CUSTOM, SB_OID_FLD_CUSTOM);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_FLD_TYPE_FP, SB_OID_FLD_TYPE_FP, SB_OID_FLD_TYPE_FP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_FLD_TYPE_F2M, SB_OID_FLD_TYPE_F2M, SB_OID_FLD_TYPE_F2M);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_FLD_BASIS_N, SB_OID_FLD_BASIS_N, SB_OID_FLD_BASIS_N);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_FLD_BASIS_T, SB_OID_FLD_BASIS_T, SB_OID_FLD_BASIS_T);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_FLD_BASIS_P, SB_OID_FLD_BASIS_P, SB_OID_FLD_BASIS_P);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_KEY, SB_OID_EC_KEY, SB_OID_EC_KEY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDH, SB_OID_ECDH, SB_OID_ECDH);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECMQV, SB_OID_ECMQV, SB_OID_ECMQV);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_SHA1, SB_OID_ECDSA_SHA1, SB_OID_ECDSA_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_RECOMMENDED, SB_OID_ECDSA_RECOMMENDED, SB_OID_ECDSA_RECOMMENDED);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_SHA224, SB_OID_ECDSA_SHA224, SB_OID_ECDSA_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_SHA256, SB_OID_ECDSA_SHA256, SB_OID_ECDSA_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_SHA384, SB_OID_ECDSA_SHA384, SB_OID_ECDSA_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_SHA512, SB_OID_ECDSA_SHA512, SB_OID_ECDSA_SHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_SPECIFIED, SB_OID_ECDSA_SPECIFIED, SB_OID_ECDSA_SPECIFIED);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_PLAIN_SHA1, SB_OID_ECDSA_PLAIN_SHA1, SB_OID_ECDSA_PLAIN_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_PLAIN_SHA224, SB_OID_ECDSA_PLAIN_SHA224, SB_OID_ECDSA_PLAIN_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_PLAIN_SHA256, SB_OID_ECDSA_PLAIN_SHA256, SB_OID_ECDSA_PLAIN_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_PLAIN_SHA384, SB_OID_ECDSA_PLAIN_SHA384, SB_OID_ECDSA_PLAIN_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_PLAIN_SHA512, SB_OID_ECDSA_PLAIN_SHA512, SB_OID_ECDSA_PLAIN_SHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ECDSA_PLAIN_RIPEMD160, SB_OID_ECDSA_PLAIN_RIPEMD160, SB_OID_ECDSA_PLAIN_RIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_CUSTOM, SB_OID_EC_CUSTOM, SB_OID_EC_CUSTOM);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB163V1, SB_OID_EC_C2PNB163V1, SB_OID_EC_C2PNB163V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB163V2, SB_OID_EC_C2PNB163V2, SB_OID_EC_C2PNB163V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB163V3, SB_OID_EC_C2PNB163V3, SB_OID_EC_C2PNB163V3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB176W1, SB_OID_EC_C2PNB176W1, SB_OID_EC_C2PNB176W1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB191V1, SB_OID_EC_C2TNB191V1, SB_OID_EC_C2TNB191V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB191V2, SB_OID_EC_C2TNB191V2, SB_OID_EC_C2TNB191V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB191V3, SB_OID_EC_C2TNB191V3, SB_OID_EC_C2TNB191V3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2ONB191V4, SB_OID_EC_C2ONB191V4, SB_OID_EC_C2ONB191V4);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2ONB191V5, SB_OID_EC_C2ONB191V5, SB_OID_EC_C2ONB191V5);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB208W1, SB_OID_EC_C2PNB208W1, SB_OID_EC_C2PNB208W1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB239V1, SB_OID_EC_C2TNB239V1, SB_OID_EC_C2TNB239V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB239V2, SB_OID_EC_C2TNB239V2, SB_OID_EC_C2TNB239V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB239V3, SB_OID_EC_C2TNB239V3, SB_OID_EC_C2TNB239V3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2ONB239V4, SB_OID_EC_C2ONB239V4, SB_OID_EC_C2ONB239V4);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2ONB239V5, SB_OID_EC_C2ONB239V5, SB_OID_EC_C2ONB239V5);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB272W1, SB_OID_EC_C2PNB272W1, SB_OID_EC_C2PNB272W1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB304W1, SB_OID_EC_C2PNB304W1, SB_OID_EC_C2PNB304W1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB359V1, SB_OID_EC_C2TNB359V1, SB_OID_EC_C2TNB359V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2PNB368W1, SB_OID_EC_C2PNB368W1, SB_OID_EC_C2PNB368W1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_C2TNB431R1, SB_OID_EC_C2TNB431R1, SB_OID_EC_C2TNB431R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME192V1, SB_OID_EC_PRIME192V1, SB_OID_EC_PRIME192V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME192V2, SB_OID_EC_PRIME192V2, SB_OID_EC_PRIME192V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME192V3, SB_OID_EC_PRIME192V3, SB_OID_EC_PRIME192V3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME239V1, SB_OID_EC_PRIME239V1, SB_OID_EC_PRIME239V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME239V2, SB_OID_EC_PRIME239V2, SB_OID_EC_PRIME239V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME239V3, SB_OID_EC_PRIME239V3, SB_OID_EC_PRIME239V3);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_PRIME256V1, SB_OID_EC_PRIME256V1, SB_OID_EC_PRIME256V1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP112R1, SB_OID_EC_SECP112R1, SB_OID_EC_SECP112R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP112R2, SB_OID_EC_SECP112R2, SB_OID_EC_SECP112R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP128R1, SB_OID_EC_SECP128R1, SB_OID_EC_SECP128R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP128R2, SB_OID_EC_SECP128R2, SB_OID_EC_SECP128R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP160K1, SB_OID_EC_SECP160K1, SB_OID_EC_SECP160K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP160R1, SB_OID_EC_SECP160R1, SB_OID_EC_SECP160R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP160R2, SB_OID_EC_SECP160R2, SB_OID_EC_SECP160R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP192K1, SB_OID_EC_SECP192K1, SB_OID_EC_SECP192K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP192R1, SB_OID_EC_SECP192R1, SB_OID_EC_SECP192R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP224K1, SB_OID_EC_SECP224K1, SB_OID_EC_SECP224K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP224R1, SB_OID_EC_SECP224R1, SB_OID_EC_SECP224R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP256K1, SB_OID_EC_SECP256K1, SB_OID_EC_SECP256K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP256R1, SB_OID_EC_SECP256R1, SB_OID_EC_SECP256R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP384R1, SB_OID_EC_SECP384R1, SB_OID_EC_SECP384R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECP521R1, SB_OID_EC_SECP521R1, SB_OID_EC_SECP521R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT113R1, SB_OID_EC_SECT113R1, SB_OID_EC_SECT113R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT113R2, SB_OID_EC_SECT113R2, SB_OID_EC_SECT113R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT131R1, SB_OID_EC_SECT131R1, SB_OID_EC_SECT131R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT131R2, SB_OID_EC_SECT131R2, SB_OID_EC_SECT131R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT163K1, SB_OID_EC_SECT163K1, SB_OID_EC_SECT163K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT163R1, SB_OID_EC_SECT163R1, SB_OID_EC_SECT163R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT163R2, SB_OID_EC_SECT163R2, SB_OID_EC_SECT163R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT193R1, SB_OID_EC_SECT193R1, SB_OID_EC_SECT193R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT193R2, SB_OID_EC_SECT193R2, SB_OID_EC_SECT193R2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT233K1, SB_OID_EC_SECT233K1, SB_OID_EC_SECT233K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT233R1, SB_OID_EC_SECT233R1, SB_OID_EC_SECT233R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT239K1, SB_OID_EC_SECT239K1, SB_OID_EC_SECT239K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT283K1, SB_OID_EC_SECT283K1, SB_OID_EC_SECT283K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT283R1, SB_OID_EC_SECT283R1, SB_OID_EC_SECT283R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT409K1, SB_OID_EC_SECT409K1, SB_OID_EC_SECT409K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT409R1, SB_OID_EC_SECT409R1, SB_OID_EC_SECT409R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT571K1, SB_OID_EC_SECT571K1, SB_OID_EC_SECT571K1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_SECT571R1, SB_OID_EC_SECT571R1, SB_OID_EC_SECT571R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_GOST_CP_TEST, SB_OID_EC_GOST_CP_TEST, SB_OID_EC_GOST_CP_TEST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_GOST_CP_A, SB_OID_EC_GOST_CP_A, SB_OID_EC_GOST_CP_A);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_GOST_CP_B, SB_OID_EC_GOST_CP_B, SB_OID_EC_GOST_CP_B);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_GOST_CP_C, SB_OID_EC_GOST_CP_C, SB_OID_EC_GOST_CP_C);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_GOST_CP_XCHA, SB_OID_EC_GOST_CP_XCHA, SB_OID_EC_GOST_CP_XCHA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_GOST_CP_XCHB, SB_OID_EC_GOST_CP_XCHB, SB_OID_EC_GOST_CP_XCHB);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP160R1, SB_OID_EC_BRAINPOOLP160R1, SB_OID_EC_BRAINPOOLP160R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP160T1, SB_OID_EC_BRAINPOOLP160T1, SB_OID_EC_BRAINPOOLP160T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP192R1, SB_OID_EC_BRAINPOOLP192R1, SB_OID_EC_BRAINPOOLP192R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP192T1, SB_OID_EC_BRAINPOOLP192T1, SB_OID_EC_BRAINPOOLP192T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP224R1, SB_OID_EC_BRAINPOOLP224R1, SB_OID_EC_BRAINPOOLP224R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP224T1, SB_OID_EC_BRAINPOOLP224T1, SB_OID_EC_BRAINPOOLP224T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP256R1, SB_OID_EC_BRAINPOOLP256R1, SB_OID_EC_BRAINPOOLP256R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP256T1, SB_OID_EC_BRAINPOOLP256T1, SB_OID_EC_BRAINPOOLP256T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP320R1, SB_OID_EC_BRAINPOOLP320R1, SB_OID_EC_BRAINPOOLP320R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP320T1, SB_OID_EC_BRAINPOOLP320T1, SB_OID_EC_BRAINPOOLP320T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP384R1, SB_OID_EC_BRAINPOOLP384R1, SB_OID_EC_BRAINPOOLP384R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP384T1, SB_OID_EC_BRAINPOOLP384T1, SB_OID_EC_BRAINPOOLP384T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP512R1, SB_OID_EC_BRAINPOOLP512R1, SB_OID_EC_BRAINPOOLP512R1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_BRAINPOOLP512T1, SB_OID_EC_BRAINPOOLP512T1, SB_OID_EC_BRAINPOOLP512T1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_EC_CURVE25519, SB_OID_EC_CURVE25519, SB_OID_EC_CURVE25519);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOSCORP_BASE, SB_OID_ELDOSCORP_BASE, SB_OID_ELDOSCORP_BASE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_PKI, SB_OID_ELDOS_PKI, SB_OID_ELDOS_PKI);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS, SB_OID_ELDOS_ALGS, SB_OID_ELDOS_ALGS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_DATASTORAGE, SB_OID_ELDOS_DATASTORAGE, SB_OID_ELDOS_DATASTORAGE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_NULL, SB_OID_ELDOS_ALGS_NULL, SB_OID_ELDOS_ALGS_NULL);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_PKEY, SB_OID_ELDOS_ALGS_PKEY, SB_OID_ELDOS_ALGS_PKEY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_SKEY, SB_OID_ELDOS_ALGS_SKEY, SB_OID_ELDOS_ALGS_SKEY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_SKEY_AEAD, SB_OID_ELDOS_ALGS_SKEY_AEAD, SB_OID_ELDOS_ALGS_SKEY_AEAD);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_DGST, SB_OID_ELDOS_ALGS_DGST, SB_OID_ELDOS_ALGS_DGST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_HMAC, SB_OID_ELDOS_ALGS_HMAC, SB_OID_ELDOS_ALGS_HMAC);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_ELDOS_ALGS_COMPR, SB_OID_ELDOS_ALGS_COMPR, SB_OID_ELDOS_ALGS_COMPR);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_COMMON_NAME, SB_CERT_OID_COMMON_NAME, SB_CERT_OID_COMMON_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SURNAME, SB_CERT_OID_SURNAME, SB_CERT_OID_SURNAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_COUNTRY, SB_CERT_OID_COUNTRY, SB_CERT_OID_COUNTRY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_LOCALITY, SB_CERT_OID_LOCALITY, SB_CERT_OID_LOCALITY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_STATE_OR_PROVINCE, SB_CERT_OID_STATE_OR_PROVINCE, SB_CERT_OID_STATE_OR_PROVINCE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ORGANIZATION, SB_CERT_OID_ORGANIZATION, SB_CERT_OID_ORGANIZATION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ORGANIZATION_UNIT, SB_CERT_OID_ORGANIZATION_UNIT, SB_CERT_OID_ORGANIZATION_UNIT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_TITLE, SB_CERT_OID_TITLE, SB_CERT_OID_TITLE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_NAME, SB_CERT_OID_NAME, SB_CERT_OID_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_GIVEN_NAME, SB_CERT_OID_GIVEN_NAME, SB_CERT_OID_GIVEN_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_INITIALS, SB_CERT_OID_INITIALS, SB_CERT_OID_INITIALS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_GENERATION_QUALIFIER, SB_CERT_OID_GENERATION_QUALIFIER, SB_CERT_OID_GENERATION_QUALIFIER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DN_QUALIFIER, SB_CERT_OID_DN_QUALIFIER, SB_CERT_OID_DN_QUALIFIER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_EMAIL, SB_CERT_OID_EMAIL, SB_CERT_OID_EMAIL);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_STREET_ADDRESS, SB_CERT_OID_STREET_ADDRESS, SB_CERT_OID_STREET_ADDRESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_POSTAL_ADDRESS, SB_CERT_OID_POSTAL_ADDRESS, SB_CERT_OID_POSTAL_ADDRESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_POSTAL_CODE, SB_CERT_OID_POSTAL_CODE, SB_CERT_OID_POSTAL_CODE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_POST_OFFICE_BOX, SB_CERT_OID_POST_OFFICE_BOX, SB_CERT_OID_POST_OFFICE_BOX);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_PHYSICAL_DELIVERY_OFFICE_NAME, SB_CERT_OID_PHYSICAL_DELIVERY_OFFICE_NAME, SB_CERT_OID_PHYSICAL_DELIVERY_OFFICE_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_TELEPHONE_NUMBER, SB_CERT_OID_TELEPHONE_NUMBER, SB_CERT_OID_TELEPHONE_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_TELEX_NUMBER, SB_CERT_OID_TELEX_NUMBER, SB_CERT_OID_TELEX_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_TELEX_TERMINAL_ID, SB_CERT_OID_TELEX_TERMINAL_ID, SB_CERT_OID_TELEX_TERMINAL_ID);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_FACIMILE_PHONE_NUMBER, SB_CERT_OID_FACIMILE_PHONE_NUMBER, SB_CERT_OID_FACIMILE_PHONE_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_X12_ADDRESS, SB_CERT_OID_X12_ADDRESS, SB_CERT_OID_X12_ADDRESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_INTERNATIONAL_ISDN_NUMBER, SB_CERT_OID_INTERNATIONAL_ISDN_NUMBER, SB_CERT_OID_INTERNATIONAL_ISDN_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_REGISTERED_ADDRESS, SB_CERT_OID_REGISTERED_ADDRESS, SB_CERT_OID_REGISTERED_ADDRESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DESTINATION_INDICATOR, SB_CERT_OID_DESTINATION_INDICATOR, SB_CERT_OID_DESTINATION_INDICATOR);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_PREFERRED_DELIVERY_METHOD, SB_CERT_OID_PREFERRED_DELIVERY_METHOD, SB_CERT_OID_PREFERRED_DELIVERY_METHOD);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_PRESENTATION_ADDRESS, SB_CERT_OID_PRESENTATION_ADDRESS, SB_CERT_OID_PRESENTATION_ADDRESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SUPPORTED_APPLICATION_CONTEXT, SB_CERT_OID_SUPPORTED_APPLICATION_CONTEXT, SB_CERT_OID_SUPPORTED_APPLICATION_CONTEXT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_MEMBER, SB_CERT_OID_MEMBER, SB_CERT_OID_MEMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_OWNER, SB_CERT_OID_OWNER, SB_CERT_OID_OWNER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ROLE_OCCUPENT, SB_CERT_OID_ROLE_OCCUPENT, SB_CERT_OID_ROLE_OCCUPENT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SEE_ALSO, SB_CERT_OID_SEE_ALSO, SB_CERT_OID_SEE_ALSO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_USER_PASSWORD, SB_CERT_OID_USER_PASSWORD, SB_CERT_OID_USER_PASSWORD);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_USER_CERTIFICATE, SB_CERT_OID_USER_CERTIFICATE, SB_CERT_OID_USER_CERTIFICATE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_CA_CERTIFICATE, SB_CERT_OID_CA_CERTIFICATE, SB_CERT_OID_CA_CERTIFICATE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_AUTHORITY_REVOCATION_LIST, SB_CERT_OID_AUTHORITY_REVOCATION_LIST, SB_CERT_OID_AUTHORITY_REVOCATION_LIST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_CERTIFICATE_REVOCATION_LIST, SB_CERT_OID_CERTIFICATE_REVOCATION_LIST, SB_CERT_OID_CERTIFICATE_REVOCATION_LIST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_CERTIFICATE_PAIR, SB_CERT_OID_CERTIFICATE_PAIR, SB_CERT_OID_CERTIFICATE_PAIR);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_UNIQUE_IDENTIFIER, SB_CERT_OID_UNIQUE_IDENTIFIER, SB_CERT_OID_UNIQUE_IDENTIFIER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ENHANCED_SEARCH_GUIDE, SB_CERT_OID_ENHANCED_SEARCH_GUIDE, SB_CERT_OID_ENHANCED_SEARCH_GUIDE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_OBJECT_CLASS, SB_CERT_OID_OBJECT_CLASS, SB_CERT_OID_OBJECT_CLASS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ALIASED_ENTRY_NAME, SB_CERT_OID_ALIASED_ENTRY_NAME, SB_CERT_OID_ALIASED_ENTRY_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_KNOWLEDGE_INFORMATION, SB_CERT_OID_KNOWLEDGE_INFORMATION, SB_CERT_OID_KNOWLEDGE_INFORMATION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SERIAL_NUMBER, SB_CERT_OID_SERIAL_NUMBER, SB_CERT_OID_SERIAL_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DESCRIPTION, SB_CERT_OID_DESCRIPTION, SB_CERT_OID_DESCRIPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SEARCH_GUIDE, SB_CERT_OID_SEARCH_GUIDE, SB_CERT_OID_SEARCH_GUIDE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_BUSINESS_CATEGORY, SB_CERT_OID_BUSINESS_CATEGORY, SB_CERT_OID_BUSINESS_CATEGORY);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_PROTOCOL_INFORMATION, SB_CERT_OID_PROTOCOL_INFORMATION, SB_CERT_OID_PROTOCOL_INFORMATION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DISTINGUISHED_NAME, SB_CERT_OID_DISTINGUISHED_NAME, SB_CERT_OID_DISTINGUISHED_NAME);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_UNIQUE_MEMBER, SB_CERT_OID_UNIQUE_MEMBER, SB_CERT_OID_UNIQUE_MEMBER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_HOUSE_IDENTIFIER, SB_CERT_OID_HOUSE_IDENTIFIER, SB_CERT_OID_HOUSE_IDENTIFIER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SUPPORTED_ALGORITHMS, SB_CERT_OID_SUPPORTED_ALGORITHMS, SB_CERT_OID_SUPPORTED_ALGORITHMS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DELTA_REVOCATION_LIST, SB_CERT_OID_DELTA_REVOCATION_LIST, SB_CERT_OID_DELTA_REVOCATION_LIST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ATTRIBUTE_CERTIFICATE, SB_CERT_OID_ATTRIBUTE_CERTIFICATE, SB_CERT_OID_ATTRIBUTE_CERTIFICATE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_PSEUDONYM, SB_CERT_OID_PSEUDONYM, SB_CERT_OID_PSEUDONYM);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_PERMANENT_IDENTIFIER, SB_CERT_OID_PERMANENT_IDENTIFIER, SB_CERT_OID_PERMANENT_IDENTIFIER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_USER_ID, SB_CERT_OID_USER_ID, SB_CERT_OID_USER_ID);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DOMAIN_COMPONENT, SB_CERT_OID_DOMAIN_COMPONENT, SB_CERT_OID_DOMAIN_COMPONENT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_CA_OCSP, SB_CERT_OID_CA_OCSP, SB_CERT_OID_CA_OCSP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_CA_ISSUER, SB_CERT_OID_CA_ISSUER, SB_CERT_OID_CA_ISSUER);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_RSAENCRYPTION, SB_CERT_OID_RSAENCRYPTION, SB_CERT_OID_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_RSAOAEP, SB_CERT_OID_RSAOAEP, SB_CERT_OID_RSAOAEP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_RSAPSS, SB_CERT_OID_RSAPSS, SB_CERT_OID_RSAPSS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DSA, SB_CERT_OID_DSA, SB_CERT_OID_DSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DH, SB_CERT_OID_DH, SB_CERT_OID_DH);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DSA_SHA1, SB_CERT_OID_DSA_SHA1, SB_CERT_OID_DSA_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DSA_SHA224, SB_CERT_OID_DSA_SHA224, SB_CERT_OID_DSA_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_DSA_SHA256, SB_CERT_OID_DSA_SHA256, SB_CERT_OID_DSA_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_MD2_RSAENCRYPTION, SB_CERT_OID_MD2_RSAENCRYPTION, SB_CERT_OID_MD2_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_MD5_RSAENCRYPTION, SB_CERT_OID_MD5_RSAENCRYPTION, SB_CERT_OID_MD5_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA1_RSAENCRYPTION, SB_CERT_OID_SHA1_RSAENCRYPTION, SB_CERT_OID_SHA1_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA224_RSAENCRYPTION, SB_CERT_OID_SHA224_RSAENCRYPTION, SB_CERT_OID_SHA224_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA256_RSAENCRYPTION, SB_CERT_OID_SHA256_RSAENCRYPTION, SB_CERT_OID_SHA256_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA384_RSAENCRYPTION, SB_CERT_OID_SHA384_RSAENCRYPTION, SB_CERT_OID_SHA384_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA512_RSAENCRYPTION, SB_CERT_OID_SHA512_RSAENCRYPTION, SB_CERT_OID_SHA512_RSAENCRYPTION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_SHA1, SB_CERT_OID_ECDSA_SHA1, SB_CERT_OID_ECDSA_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_RECOMMENDED, SB_CERT_OID_ECDSA_RECOMMENDED, SB_CERT_OID_ECDSA_RECOMMENDED);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_SHA224, SB_CERT_OID_ECDSA_SHA224, SB_CERT_OID_ECDSA_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_SHA256, SB_CERT_OID_ECDSA_SHA256, SB_CERT_OID_ECDSA_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_SHA384, SB_CERT_OID_ECDSA_SHA384, SB_CERT_OID_ECDSA_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_SHA512, SB_CERT_OID_ECDSA_SHA512, SB_CERT_OID_ECDSA_SHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_SPECIFIED, SB_CERT_OID_ECDSA_SPECIFIED, SB_CERT_OID_ECDSA_SPECIFIED);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_PLAIN_SHA1, SB_CERT_OID_ECDSA_PLAIN_SHA1, SB_CERT_OID_ECDSA_PLAIN_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_PLAIN_SHA224, SB_CERT_OID_ECDSA_PLAIN_SHA224, SB_CERT_OID_ECDSA_PLAIN_SHA224);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_PLAIN_SHA256, SB_CERT_OID_ECDSA_PLAIN_SHA256, SB_CERT_OID_ECDSA_PLAIN_SHA256);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_PLAIN_SHA384, SB_CERT_OID_ECDSA_PLAIN_SHA384, SB_CERT_OID_ECDSA_PLAIN_SHA384);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_PLAIN_SHA512, SB_CERT_OID_ECDSA_PLAIN_SHA512, SB_CERT_OID_ECDSA_PLAIN_SHA512);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_ECDSA_PLAIN_RIPEMD160, SB_CERT_OID_ECDSA_PLAIN_RIPEMD160, SB_CERT_OID_ECDSA_PLAIN_RIPEMD160);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_GOST_R3410_1994, SB_CERT_OID_GOST_R3410_1994, SB_CERT_OID_GOST_R3410_1994);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_GOST_R3410_2001, SB_CERT_OID_GOST_R3410_2001, SB_CERT_OID_GOST_R3410_2001);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_GOST_R3411_WITH_GOST3410_1994, SB_CERT_OID_GOST_R3411_WITH_GOST3410_1994, SB_CERT_OID_GOST_R3411_WITH_GOST3410_1994);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_GOST_R3411_WITH_GOST3410_2001, SB_CERT_OID_GOST_R3411_WITH_GOST3410_2001, SB_CERT_OID_GOST_R3411_WITH_GOST3410_2001);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA1_RSA, SB_CERT_OID_SHA1_RSA, SB_CERT_OID_SHA1_RSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA1_DSA, SB_CERT_OID_SHA1_DSA, SB_CERT_OID_SHA1_DSA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_SHA1, SB_CERT_OID_SHA1, SB_CERT_OID_SHA1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_MD2, SB_CERT_OID_MD2, SB_CERT_OID_MD2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CERT_OID_MD5, SB_CERT_OID_MD5, SB_CERT_OID_MD5);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_PKI_DATA, SB_CMC_OID_PKI_DATA, SB_CMC_OID_PKI_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_PKI_RESPONSE, SB_CMC_OID_PKI_RESPONSE, SB_CMC_OID_PKI_RESPONSE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_STATUS_INFO, SB_CMC_OID_STATUS_INFO, SB_CMC_OID_STATUS_INFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_IDENTIFICATION, SB_CMC_OID_IDENTIFICATION, SB_CMC_OID_IDENTIFICATION);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_IDENTITY_PROOF, SB_CMC_OID_IDENTITY_PROOF, SB_CMC_OID_IDENTITY_PROOF);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_DATA_RETURN, SB_CMC_OID_DATA_RETURN, SB_CMC_OID_DATA_RETURN);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_TRANSACTION_ID, SB_CMC_OID_TRANSACTION_ID, SB_CMC_OID_TRANSACTION_ID);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_SENDER_NONCE, SB_CMC_OID_SENDER_NONCE, SB_CMC_OID_SENDER_NONCE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_RECIPIENT_NONCE, SB_CMC_OID_RECIPIENT_NONCE, SB_CMC_OID_RECIPIENT_NONCE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_ADD_EXTENSIONS, SB_CMC_OID_ADD_EXTENSIONS, SB_CMC_OID_ADD_EXTENSIONS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_ENCRYPTED_POP, SB_CMC_OID_ENCRYPTED_POP, SB_CMC_OID_ENCRYPTED_POP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_DECRYPTED_POP, SB_CMC_OID_DECRYPTED_POP, SB_CMC_OID_DECRYPTED_POP);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_LRA_POP_WITNESS, SB_CMC_OID_LRA_POP_WITNESS, SB_CMC_OID_LRA_POP_WITNESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_GET_CERT, SB_CMC_OID_GET_CERT, SB_CMC_OID_GET_CERT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_GET_CRL, SB_CMC_OID_GET_CRL, SB_CMC_OID_GET_CRL);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_REVOKE_REQUEST, SB_CMC_OID_REVOKE_REQUEST, SB_CMC_OID_REVOKE_REQUEST);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_REG_INFO, SB_CMC_OID_REG_INFO, SB_CMC_OID_REG_INFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_RESPONSE_INFO, SB_CMC_OID_RESPONSE_INFO, SB_CMC_OID_RESPONSE_INFO);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_QUERY_PENDING, SB_CMC_OID_QUERY_PENDING, SB_CMC_OID_QUERY_PENDING);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_POP_LINK_RANDOM, SB_CMC_OID_POP_LINK_RANDOM, SB_CMC_OID_POP_LINK_RANDOM);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_POP_LINK_WITNESS, SB_CMC_OID_POP_LINK_WITNESS, SB_CMC_OID_POP_LINK_WITNESS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_POP_LINK_WITNESS_V2, SB_CMC_OID_POP_LINK_WITNESS_V2, SB_CMC_OID_POP_LINK_WITNESS_V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_CONFIRM_CERT_ACCEPTANCE, SB_CMC_OID_CONFIRM_CERT_ACCEPTANCE, SB_CMC_OID_CONFIRM_CERT_ACCEPTANCE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_STATUS_INFO_V2, SB_CMC_OID_STATUS_INFO_V2, SB_CMC_OID_STATUS_INFO_V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_TRUSTED_ANCHORS, SB_CMC_OID_TRUSTED_ANCHORS, SB_CMC_OID_TRUSTED_ANCHORS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_AUTH_DATA, SB_CMC_OID_AUTH_DATA, SB_CMC_OID_AUTH_DATA);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_BATCH_REQUESTS, SB_CMC_OID_BATCH_REQUESTS, SB_CMC_OID_BATCH_REQUESTS);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_BATCH_RESPONSES, SB_CMC_OID_BATCH_RESPONSES, SB_CMC_OID_BATCH_RESPONSES);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_PUBLISH_CERT, SB_CMC_OID_PUBLISH_CERT, SB_CMC_OID_PUBLISH_CERT);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_MOD_CERT_TEMPLATE, SB_CMC_OID_MOD_CERT_TEMPLATE, SB_CMC_OID_MOD_CERT_TEMPLATE);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_CONTROL_PROCESSED, SB_CMC_OID_CONTROL_PROCESSED, SB_CMC_OID_CONTROL_PROCESSED);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_CMC_OID_IDENTITY_PROOF_V2, SB_CMC_OID_IDENTITY_PROOF_V2, SB_CMC_OID_IDENTITY_PROOF_V2);
	SB_REGISTER_STRING_CONSTANT(SBConstants, SB_OID_AEAD_CHACHA20_POLY1305_ELDOS, SB_OID_AEAD_CHACHA20_POLY1305_ELDOS, SB_OID_AEAD_CHACHA20_POLY1305_ELDOS);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, SpaceByteArray, SB_SpaceByteArray, "" + SB_SpaceByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, CommaByteArray, SB_CommaByteArray, "" + SB_CommaByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, SlashByteArray, SB_SlashByteArray, "" + SB_SlashByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, ColonByteArray, SB_ColonByteArray, "" + SB_ColonByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, EqualCharByteArray, SB_EqualCharByteArray, "" + SB_EqualCharByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, DashByteArray, SB_DashByteArray, "" + SB_DashByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, LFByteArray, SB_LFByteArray, "" + SB_LFByteArray, 1);
	SB_REGISTER_STRINGL_CONSTANT(SBConstants, CRByteArray, SB_CRByteArray, "" + SB_CRByteArray, 1);
	SB_REGISTER_STRING_CONSTANT(SBConstants, LFLFByteArray, SB_LFLFByteArray, SB_LFLFByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFByteArray, SB_CRLFByteArray, SB_CRLFByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFCRLFByteArray, SB_CRLFCRLFByteArray, SB_CRLFCRLFByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRCRLFByteArray, SB_CRCRLFByteArray, SB_CRCRLFByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFTABByteArray, SB_CRLFTABByteArray, SB_CRLFTABByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRLFSPACEByteArray, SB_CRLFSPACEByteArray, SB_CRLFSPACEByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CRCRLFCRCRLFByteArray, SB_CRCRLFCRCRLFByteArray, SB_CRCRLFCRCRLFByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, TwoDashesByteArray, SB_TwoDashesByteArray, SB_TwoDashesByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, FiveDashesByteArray, SB_FiveDashesByteArray, SB_FiveDashesByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, BeginLineByteArray, SB_BeginLineByteArray, SB_BeginLineByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, LFEndLineByteArray, SB_LFEndLineByteArray, SB_LFEndLineByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, CREndLineByteArray, SB_CREndLineByteArray, SB_CREndLineByteArray);
	SB_REGISTER_STRING_CONSTANT(SBConstants, UTF8BOMByteArray, SB_UTF8BOMByteArray, SB_UTF8BOMByteArray);
}

