#include "sbcookiemgr.h"

zend_class_entry *TElCookie_ce_ptr = NULL;

SB_PHP_METHOD(TElCookie, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookie_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, AssembleClientCookie)
{
	long l4Format;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Format) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_AssembleClientCookie(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Format, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2083405678, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, ParseServerCookie)
{
	char *sACookie;
	int sACookie_len;
	int8_t bDiscardCookieRaw;
	zval *dtReceivedAt;
	zval *zbDiscardCookie;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sOz", &sACookie, &sACookie_len, &dtReceivedAt, php_date_get_date_ce(), &zbDiscardCookie) == SUCCESS) && PZVAL_IS_REF(zbDiscardCookie) && (IS_BOOL == Z_TYPE_P(zbDiscardCookie)))
	{
		bDiscardCookieRaw = (int8_t)Z_BVAL_P(zbDiscardCookie);
		SBCheckError(TElCookie_ParseServerCookie(SBGetObjectHandle(getThis() TSRMLS_CC), sACookie, (int32_t)sACookie_len, SBGetDateTime(dtReceivedAt TSRMLS_CC), &bDiscardCookieRaw) TSRMLS_CC);
		ZVAL_BOOL(zbDiscardCookie, (zend_bool)bDiscardCookieRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, DateTime, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCookie_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Persistent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCookie_get_Persistent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Persistent)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Persistent(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1024245402, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2107963682, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Comment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-34621398, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Comment)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_CommentURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_CommentURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1260140892, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_CommentURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_CommentURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(904648382, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Domain)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCookie_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Expires)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Format)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCookie_get_Format(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Format)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Format(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_HostOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCookie_get_HostOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_HostOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCookie_set_HostOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_HTTPOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCookie_get_HTTPOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_HTTPOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCookie_set_HTTPOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Path)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_Path(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1752910737, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Path)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Path(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Port)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookie_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-549363028, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Port)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Secure)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCookie_get_Secure(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Secure)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Secure(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCookie_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, set_Version)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCookie_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookie, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCookie_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_AssembleClientCookie, 0, 0, 1)
	ZEND_ARG_INFO(0, Format)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_ParseServerCookie, 0, 0, 3)
	ZEND_ARG_INFO(0, ACookie)
	ZEND_ARG_OBJ_INFO(0, ReceivedAt, DateTime, 0)
	ZEND_ARG_INFO(1, DiscardCookie)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Persistent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Persistent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Comment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Comment, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_CommentURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_CommentURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Domain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Expires, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Format, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Format, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_HostOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_HostOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_HTTPOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_HTTPOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Path, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Path, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Secure, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Secure, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookie___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCookie_methods[] = {
	PHP_ME(TElCookie, Assign, arginfo_TElCookie_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, AssembleClientCookie, arginfo_TElCookie_AssembleClientCookie, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, ParseServerCookie, arginfo_TElCookie_ParseServerCookie, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Included, arginfo_TElCookie_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Persistent, arginfo_TElCookie_get_Persistent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Persistent, arginfo_TElCookie_set_Persistent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Name, arginfo_TElCookie_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Name, arginfo_TElCookie_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Value, arginfo_TElCookie_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Value, arginfo_TElCookie_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Comment, arginfo_TElCookie_get_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Comment, arginfo_TElCookie_set_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_CommentURL, arginfo_TElCookie_get_CommentURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_CommentURL, arginfo_TElCookie_set_CommentURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Domain, arginfo_TElCookie_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Domain, arginfo_TElCookie_set_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Expires, arginfo_TElCookie_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Expires, arginfo_TElCookie_set_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Format, arginfo_TElCookie_get_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Format, arginfo_TElCookie_set_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_HostOnly, arginfo_TElCookie_get_HostOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_HostOnly, arginfo_TElCookie_set_HostOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_HTTPOnly, arginfo_TElCookie_get_HTTPOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_HTTPOnly, arginfo_TElCookie_set_HTTPOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Path, arginfo_TElCookie_get_Path, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Path, arginfo_TElCookie_set_Path, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Port, arginfo_TElCookie_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Port, arginfo_TElCookie_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Secure, arginfo_TElCookie_get_Secure, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Secure, arginfo_TElCookie_set_Secure, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, get_Version, arginfo_TElCookie_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, set_Version, arginfo_TElCookie_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookie, __construct, arginfo_TElCookie___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCookie(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCookie_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCookie", TElCookie_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElCookie_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCookieDomain_ce_ptr = NULL;

SB_PHP_METHOD(TElCookieDomain, AddCookie)
{
	zval *oACookie;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACookie, TElCookie_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookieDomain_AddCookie(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACookie TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCookie)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCookieDomain_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, RemoveCookie)
{
	zval *oACookie;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACookie, TElCookie_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookieDomain_RemoveCookie(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACookie TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCookie)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, DeleteCookie)
{
	long l4index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4index) == SUCCESS)
	{
		SBCheckError(TElCookieDomain_DeleteCookie(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, FindSameCookie)
{
	zval *oCookie;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCookie, TElCookie_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCookieDomain_FindSameCookie(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCookie TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCookie_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCookie)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, get_Cookies)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCookieDomain_get_Cookies(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCookie_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, get_CookieCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCookieDomain_get_CookieCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, get_Domain)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookieDomain_get_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-367614429, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, set_Domain)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCookieDomain_set_Domain(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieDomain, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCookieDomain_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_AddCookie, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACookie, TElCookie, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_RemoveCookie, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACookie, TElCookie, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_DeleteCookie, 0, 0, 1)
	ZEND_ARG_INFO(0, index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_FindSameCookie, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cookie, TElCookie, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_get_Cookies, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_get_CookieCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_get_Domain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain_set_Domain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieDomain___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCookieDomain_methods[] = {
	PHP_ME(TElCookieDomain, AddCookie, arginfo_TElCookieDomain_AddCookie, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, Clear, arginfo_TElCookieDomain_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, RemoveCookie, arginfo_TElCookieDomain_RemoveCookie, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, DeleteCookie, arginfo_TElCookieDomain_DeleteCookie, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, FindSameCookie, arginfo_TElCookieDomain_FindSameCookie, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, get_Cookies, arginfo_TElCookieDomain_get_Cookies, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, get_CookieCount, arginfo_TElCookieDomain_get_CookieCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, get_Domain, arginfo_TElCookieDomain_get_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, set_Domain, arginfo_TElCookieDomain_set_Domain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieDomain, __construct, arginfo_TElCookieDomain___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCookieDomain(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCookieDomain_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCookieDomain", TElCookieDomain_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCookieDomain_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCookieManager_ce_ptr = NULL;

SB_PHP_METHOD(TElCookieManager, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCookieManager_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, AddDomain)
{
	zval *oDomain;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDomain, TElCookieDomain_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookieManager_AddDomain(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDomain TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCookieDomain)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, DeleteDomain)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCookieManager_DeleteDomain(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, RemoveDomain)
{
	zval *oDomain;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDomain, TElCookieDomain_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookieManager_RemoveDomain(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDomain TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCookieDomain)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookieManager_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCookieManager_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, GetCookiesForURL)
{
	char *sURL;
	int sURL_len;
	int32_t l4FormatRaw = 0;
	uint32_t _err;
	zend_bool bSecureSession;
	zval *zl4Format;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbz", &sURL, &sURL_len, &bSecureSession, &zl4Format) == SUCCESS) && PZVAL_IS_REF(zl4Format) && (IS_LONG == Z_TYPE_P(zl4Format)))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCookieManager_GetCookiesForURL(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, (int8_t)bSecureSession, &l4FormatRaw, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1704515702, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl4Format, (long)l4FormatRaw);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, SetCookiesForURL)
{
	char *sURL;
	int sURL_len;
	long l4ForceFormat;
	zval *dtReceivedAt;
	zval *oCookieList;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!Ol", &sURL, &sURL_len, &oCookieList, TStringList_ce_ptr, &dtReceivedAt, php_date_get_date_ce(), &l4ForceFormat) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!Ol", &sURL, &sURL_len, &oCookieList, TElStringList_ce_ptr, &dtReceivedAt, php_date_get_date_ce(), &l4ForceFormat) == SUCCESS)
#endif
	{
		SBCheckError(TElCookieManager_SetCookiesForURL(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oCookieList TSRMLS_CC), SBGetDateTime(dtReceivedAt TSRMLS_CC), (int32_t)l4ForceFormat) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList, DateTime, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList, DateTime, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElCookieManager, get_DomainCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCookieManager_get_DomainCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, get_Domains)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCookieManager_get_Domains(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCookieDomain_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCookieManager, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCookieManager_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_AddDomain, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Domain, TElCookieDomain, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_DeleteDomain, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_RemoveDomain, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Domain, TElCookieDomain, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_GetCookiesForURL, 0, 0, 3)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, SecureSession)
	ZEND_ARG_INFO(1, Format)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_SetCookiesForURL, 0, 0, 4)
	ZEND_ARG_INFO(0, URL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, CookieList, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, CookieList, TElStringList, 1)
#endif
	ZEND_ARG_OBJ_INFO(0, ReceivedAt, DateTime, 0)
	ZEND_ARG_INFO(0, ForceFormat)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_get_DomainCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager_get_Domains, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCookieManager___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCookieManager_methods[] = {
	PHP_ME(TElCookieManager, Clear, arginfo_TElCookieManager_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, AddDomain, arginfo_TElCookieManager_AddDomain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, DeleteDomain, arginfo_TElCookieManager_DeleteDomain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, RemoveDomain, arginfo_TElCookieManager_RemoveDomain, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, LoadFromStream, arginfo_TElCookieManager_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, SaveToStream, arginfo_TElCookieManager_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, GetCookiesForURL, arginfo_TElCookieManager_GetCookiesForURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, SetCookiesForURL, arginfo_TElCookieManager_SetCookiesForURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, get_DomainCount, arginfo_TElCookieManager_get_DomainCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, get_Domains, arginfo_TElCookieManager_get_Domains, ZEND_ACC_PUBLIC)
	PHP_ME(TElCookieManager, __construct, arginfo_TElCookieManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCookieManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCookieManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCookieManager", TElCookieManager_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCookieManager_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCookieMgr_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpComment, SB_cpComment, SB_cpComment);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpCommentURL, SB_cpCommentURL, SB_cpCommentURL);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpExpires, SB_cpExpires, SB_cpExpires);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpDiscard, SB_cpDiscard, SB_cpDiscard);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpDomain, SB_cpDomain, SB_cpDomain);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpPath, SB_cpPath, SB_cpPath);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpPort, SB_cpPort, SB_cpPort);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpSecure, SB_cpSecure, SB_cpSecure);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpVersion, SB_cpVersion, SB_cpVersion);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpHostOnly, SB_cpHostOnly, SB_cpHostOnly);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpHttpOnly, SB_cpHttpOnly, SB_cpHttpOnly);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cpFormat, SB_cpFormat, SB_cpFormat);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cfUndefined, SB_cfUndefined, SB_cfUndefined);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cfNetscape, SB_cfNetscape, SB_cfNetscape);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cfRFC2109, SB_cfRFC2109, SB_cfRFC2109);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cfRFC2965, SB_cfRFC2965, SB_cfRFC2965);
	SB_REGISTER_LONG_CONSTANT(SBCookieMgr, cfRFC6265, SB_cfRFC6265, SB_cfRFC6265);
}

void Register_SBCookieMgr_Aliases(TSRMLS_D)
{
	if (NULL == TElCookieManager_ce_ptr)
		Register_TElCookieManager(TSRMLS_C);
	zend_register_class_alias("ElCookieManager", TElCookieManager_ce_ptr);
}
