#include "sbcrl.h"

zend_class_entry *TSBCRLFileFormat_ce_ptr = NULL;

zend_class_entry *TElInstructionCode_ce_ptr = NULL;

zend_class_entry *TSBCRLExtension_ce_ptr = NULL;

zend_class_entry *TSBCRLExtensions_ce_ptr = NULL;

zend_class_entry *TSBCRLEntryExtension_ce_ptr = NULL;

zend_class_entry *TSBCRLEntryExtensions_ce_ptr = NULL;

zend_class_entry *TElAuthorityKeyIdentifierCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, get_KeyIdentifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAuthorityKeyIdentifierCRLExtension_get_KeyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-587054883, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, set_KeyIdentifier)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthorityKeyIdentifierCRLExtension_set_KeyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, get_AuthorityCertIssuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthorityKeyIdentifierCRLExtension_get_AuthorityCertIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralNames_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, get_AuthorityCertSerial)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAuthorityKeyIdentifierCRLExtension_get_AuthorityCertSerial(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(279879362, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, set_AuthorityCertSerial)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAuthorityKeyIdentifierCRLExtension_set_AuthorityCertSerial(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, get_IssuerSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAuthorityKeyIdentifierCRLExtension_get_IssuerSet(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, set_IssuerSet)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAuthorityKeyIdentifierCRLExtension_set_IssuerSet(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthorityKeyIdentifierCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthorityKeyIdentifierCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_get_KeyIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_set_KeyIdentifier, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_get_AuthorityCertIssuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_get_AuthorityCertSerial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_set_AuthorityCertSerial, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_get_IssuerSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension_set_IssuerSet, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthorityKeyIdentifierCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElAuthorityKeyIdentifierCRLExtension_methods[] = {
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, get_KeyIdentifier, arginfo_TElAuthorityKeyIdentifierCRLExtension_get_KeyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, set_KeyIdentifier, arginfo_TElAuthorityKeyIdentifierCRLExtension_set_KeyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, get_AuthorityCertIssuer, arginfo_TElAuthorityKeyIdentifierCRLExtension_get_AuthorityCertIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, get_AuthorityCertSerial, arginfo_TElAuthorityKeyIdentifierCRLExtension_get_AuthorityCertSerial, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, set_AuthorityCertSerial, arginfo_TElAuthorityKeyIdentifierCRLExtension_set_AuthorityCertSerial, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, get_IssuerSet, arginfo_TElAuthorityKeyIdentifierCRLExtension_get_IssuerSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, set_IssuerSet, arginfo_TElAuthorityKeyIdentifierCRLExtension_set_IssuerSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthorityKeyIdentifierCRLExtension, __construct, arginfo_TElAuthorityKeyIdentifierCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAuthorityKeyIdentifierCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAuthorityKeyIdentifierCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAuthorityKeyIdentifierCRLExtension", TElAuthorityKeyIdentifierCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElAuthorityKeyIdentifierCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCRLNumberCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElCRLNumberCRLExtension, get_Number)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCRLNumberCRLExtension_get_Number(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLNumberCRLExtension, set_Number)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCRLNumberCRLExtension_set_Number(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLNumberCRLExtension, get_BinaryNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCRLNumberCRLExtension_get_BinaryNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1831432506, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLNumberCRLExtension, set_BinaryNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCRLNumberCRLExtension_set_BinaryNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLNumberCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLNumberCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLNumberCRLExtension_get_Number, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLNumberCRLExtension_set_Number, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLNumberCRLExtension_get_BinaryNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLNumberCRLExtension_set_BinaryNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLNumberCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCRLNumberCRLExtension_methods[] = {
	PHP_ME(TElCRLNumberCRLExtension, get_Number, arginfo_TElCRLNumberCRLExtension_get_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLNumberCRLExtension, set_Number, arginfo_TElCRLNumberCRLExtension_set_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLNumberCRLExtension, get_BinaryNumber, arginfo_TElCRLNumberCRLExtension_get_BinaryNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLNumberCRLExtension, set_BinaryNumber, arginfo_TElCRLNumberCRLExtension_set_BinaryNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLNumberCRLExtension, __construct, arginfo_TElCRLNumberCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCRLNumberCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCRLNumberCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCRLNumberCRLExtension", TElCRLNumberCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElCRLNumberCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDeltaCRLIndicatorCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElDeltaCRLIndicatorCRLExtension, get_Number)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDeltaCRLIndicatorCRLExtension_get_Number(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDeltaCRLIndicatorCRLExtension, set_Number)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDeltaCRLIndicatorCRLExtension_set_Number(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDeltaCRLIndicatorCRLExtension, get_BinaryNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDeltaCRLIndicatorCRLExtension_get_BinaryNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1954288120, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDeltaCRLIndicatorCRLExtension, set_BinaryNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDeltaCRLIndicatorCRLExtension_set_BinaryNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDeltaCRLIndicatorCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDeltaCRLIndicatorCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDeltaCRLIndicatorCRLExtension_get_Number, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDeltaCRLIndicatorCRLExtension_set_Number, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDeltaCRLIndicatorCRLExtension_get_BinaryNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDeltaCRLIndicatorCRLExtension_set_BinaryNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDeltaCRLIndicatorCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDeltaCRLIndicatorCRLExtension_methods[] = {
	PHP_ME(TElDeltaCRLIndicatorCRLExtension, get_Number, arginfo_TElDeltaCRLIndicatorCRLExtension_get_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElDeltaCRLIndicatorCRLExtension, set_Number, arginfo_TElDeltaCRLIndicatorCRLExtension_set_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElDeltaCRLIndicatorCRLExtension, get_BinaryNumber, arginfo_TElDeltaCRLIndicatorCRLExtension_get_BinaryNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElDeltaCRLIndicatorCRLExtension, set_BinaryNumber, arginfo_TElDeltaCRLIndicatorCRLExtension_set_BinaryNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElDeltaCRLIndicatorCRLExtension, __construct, arginfo_TElDeltaCRLIndicatorCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDeltaCRLIndicatorCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDeltaCRLIndicatorCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDeltaCRLIndicatorCRLExtension", TElDeltaCRLIndicatorCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElDeltaCRLIndicatorCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElReasonCodeCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElReasonCodeCRLExtension, get_Reason)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLReasonFlagRaw fOutResultRaw = 0;
		SBCheckError(TElReasonCodeCRLExtension_get_Reason(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElReasonCodeCRLExtension, set_Reason)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElReasonCodeCRLExtension_set_Reason(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLReasonFlagRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElReasonCodeCRLExtension, get_RemoveFromCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElReasonCodeCRLExtension_get_RemoveFromCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElReasonCodeCRLExtension, set_RemoveFromCRL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElReasonCodeCRLExtension_set_RemoveFromCRL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElReasonCodeCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElReasonCodeCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElReasonCodeCRLExtension_get_Reason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElReasonCodeCRLExtension_set_Reason, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElReasonCodeCRLExtension_get_RemoveFromCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElReasonCodeCRLExtension_set_RemoveFromCRL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElReasonCodeCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElReasonCodeCRLExtension_methods[] = {
	PHP_ME(TElReasonCodeCRLExtension, get_Reason, arginfo_TElReasonCodeCRLExtension_get_Reason, ZEND_ACC_PUBLIC)
	PHP_ME(TElReasonCodeCRLExtension, set_Reason, arginfo_TElReasonCodeCRLExtension_set_Reason, ZEND_ACC_PUBLIC)
	PHP_ME(TElReasonCodeCRLExtension, get_RemoveFromCRL, arginfo_TElReasonCodeCRLExtension_get_RemoveFromCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElReasonCodeCRLExtension, set_RemoveFromCRL, arginfo_TElReasonCodeCRLExtension_set_RemoveFromCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElReasonCodeCRLExtension, __construct, arginfo_TElReasonCodeCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElReasonCodeCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElReasonCodeCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElReasonCodeCRLExtension", TElReasonCodeCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElReasonCodeCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHoldInstructionCodeCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElHoldInstructionCodeCRLExtension, get_Code)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElInstructionCodeRaw fOutResultRaw = 0;
		SBCheckError(TElHoldInstructionCodeCRLExtension_get_Code(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHoldInstructionCodeCRLExtension, set_Code)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElHoldInstructionCodeCRLExtension_set_Code(SBGetObjectHandle(getThis() TSRMLS_CC), (TElInstructionCodeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHoldInstructionCodeCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHoldInstructionCodeCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHoldInstructionCodeCRLExtension_get_Code, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHoldInstructionCodeCRLExtension_set_Code, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHoldInstructionCodeCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHoldInstructionCodeCRLExtension_methods[] = {
	PHP_ME(TElHoldInstructionCodeCRLExtension, get_Code, arginfo_TElHoldInstructionCodeCRLExtension_get_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElHoldInstructionCodeCRLExtension, set_Code, arginfo_TElHoldInstructionCodeCRLExtension_set_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElHoldInstructionCodeCRLExtension, __construct, arginfo_TElHoldInstructionCodeCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHoldInstructionCodeCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHoldInstructionCodeCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHoldInstructionCodeCRLExtension", TElHoldInstructionCodeCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElHoldInstructionCodeCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElInvalidityDateCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElInvalidityDateCRLExtension, get_InvalidityDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElInvalidityDateCRLExtension_get_InvalidityDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElInvalidityDateCRLExtension, set_InvalidityDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElInvalidityDateCRLExtension_set_InvalidityDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElInvalidityDateCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElInvalidityDateCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElInvalidityDateCRLExtension_get_InvalidityDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElInvalidityDateCRLExtension_set_InvalidityDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElInvalidityDateCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElInvalidityDateCRLExtension_methods[] = {
	PHP_ME(TElInvalidityDateCRLExtension, get_InvalidityDate, arginfo_TElInvalidityDateCRLExtension_get_InvalidityDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElInvalidityDateCRLExtension, set_InvalidityDate, arginfo_TElInvalidityDateCRLExtension_set_InvalidityDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElInvalidityDateCRLExtension, __construct, arginfo_TElInvalidityDateCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElInvalidityDateCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElInvalidityDateCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElInvalidityDateCRLExtension", TElInvalidityDateCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElInvalidityDateCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCertificateIssuerCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElCertificateIssuerCRLExtension, get_Issuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateIssuerCRLExtension_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralNames_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateIssuerCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateIssuerCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateIssuerCRLExtension_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateIssuerCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCertificateIssuerCRLExtension_methods[] = {
	PHP_ME(TElCertificateIssuerCRLExtension, get_Issuer, arginfo_TElCertificateIssuerCRLExtension_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateIssuerCRLExtension, __construct, arginfo_TElCertificateIssuerCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCertificateIssuerCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCertificateIssuerCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCertificateIssuerCRLExtension", TElCertificateIssuerCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElCertificateIssuerCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIssuingDistributionPointCRLExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_DistributionPoint)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_DistributionPoint(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralNames_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_OnlySomeReasons)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLReasonFlagsRaw fOutResultRaw = 0;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_OnlySomeReasons(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, set_OnlySomeReasons)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElIssuingDistributionPointCRLExtension_set_OnlySomeReasons(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLReasonFlagsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_OnlyContainsUserCerts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_OnlyContainsUserCerts(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, set_OnlyContainsUserCerts)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIssuingDistributionPointCRLExtension_set_OnlyContainsUserCerts(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_OnlyContainsCACerts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_OnlyContainsCACerts(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, set_OnlyContainsCACerts)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIssuingDistributionPointCRLExtension_set_OnlyContainsCACerts(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_OnlyContainsAttributeCerts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_OnlyContainsAttributeCerts(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, set_OnlyContainsAttributeCerts)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIssuingDistributionPointCRLExtension_set_OnlyContainsAttributeCerts(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_IndirectCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_IndirectCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, set_IndirectCRL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIssuingDistributionPointCRLExtension_set_IndirectCRL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, get_ReasonFlagsIncluded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIssuingDistributionPointCRLExtension_get_ReasonFlagsIncluded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, set_ReasonFlagsIncluded)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIssuingDistributionPointCRLExtension_set_ReasonFlagsIncluded(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIssuingDistributionPointCRLExtension, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIssuingDistributionPointCRLExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_DistributionPoint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_OnlySomeReasons, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_set_OnlySomeReasons, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_OnlyContainsUserCerts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_set_OnlyContainsUserCerts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_OnlyContainsCACerts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_set_OnlyContainsCACerts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_OnlyContainsAttributeCerts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_set_OnlyContainsAttributeCerts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_IndirectCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_set_IndirectCRL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_get_ReasonFlagsIncluded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension_set_ReasonFlagsIncluded, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIssuingDistributionPointCRLExtension___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElIssuingDistributionPointCRLExtension_methods[] = {
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_DistributionPoint, arginfo_TElIssuingDistributionPointCRLExtension_get_DistributionPoint, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_OnlySomeReasons, arginfo_TElIssuingDistributionPointCRLExtension_get_OnlySomeReasons, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, set_OnlySomeReasons, arginfo_TElIssuingDistributionPointCRLExtension_set_OnlySomeReasons, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_OnlyContainsUserCerts, arginfo_TElIssuingDistributionPointCRLExtension_get_OnlyContainsUserCerts, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, set_OnlyContainsUserCerts, arginfo_TElIssuingDistributionPointCRLExtension_set_OnlyContainsUserCerts, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_OnlyContainsCACerts, arginfo_TElIssuingDistributionPointCRLExtension_get_OnlyContainsCACerts, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, set_OnlyContainsCACerts, arginfo_TElIssuingDistributionPointCRLExtension_set_OnlyContainsCACerts, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_OnlyContainsAttributeCerts, arginfo_TElIssuingDistributionPointCRLExtension_get_OnlyContainsAttributeCerts, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, set_OnlyContainsAttributeCerts, arginfo_TElIssuingDistributionPointCRLExtension_set_OnlyContainsAttributeCerts, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_IndirectCRL, arginfo_TElIssuingDistributionPointCRLExtension_get_IndirectCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, set_IndirectCRL, arginfo_TElIssuingDistributionPointCRLExtension_set_IndirectCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, get_ReasonFlagsIncluded, arginfo_TElIssuingDistributionPointCRLExtension_get_ReasonFlagsIncluded, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, set_ReasonFlagsIncluded, arginfo_TElIssuingDistributionPointCRLExtension_set_ReasonFlagsIncluded, ZEND_ACC_PUBLIC)
	PHP_ME(TElIssuingDistributionPointCRLExtension, __construct, arginfo_TElIssuingDistributionPointCRLExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIssuingDistributionPointCRLExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIssuingDistributionPointCRLExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIssuingDistributionPointCRLExtension", TElIssuingDistributionPointCRLExtension_methods);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	TElIssuingDistributionPointCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCRLExtensions_ce_ptr = NULL;

SB_PHP_METHOD(TElCRLExtensions, get_AuthorityKeyIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_get_AuthorityKeyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAuthorityKeyIdentifierCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_IssuerAlternativeName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_get_IssuerAlternativeName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlternativeNameExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_CRLNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_get_CRLNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCRLNumberCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_DeltaCRLIndicator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_get_DeltaCRLIndicator(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDeltaCRLIndicatorCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_IssuingDistributionPoint)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_get_IssuingDistributionPoint(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIssuingDistributionPointCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_OtherExtensions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_get_OtherExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_OtherCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCRLExtensions_get_OtherCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, set_OtherCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCRLExtensions_set_OtherCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLExtensionsRaw fOutResultRaw = 0;
		SBCheckError(TElCRLExtensions_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, set_Included)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCRLExtensions_set_Included(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLExtensionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, get_SaveDefaultASN1Tags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCRLExtensions_get_SaveDefaultASN1Tags(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, set_SaveDefaultASN1Tags)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCRLExtensions_set_SaveDefaultASN1Tags(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLExtensions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLExtensions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_AuthorityKeyIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_IssuerAlternativeName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_CRLNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_DeltaCRLIndicator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_IssuingDistributionPoint, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_OtherExtensions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_OtherCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_set_OtherCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_set_Included, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_get_SaveDefaultASN1Tags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions_set_SaveDefaultASN1Tags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLExtensions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCRLExtensions_methods[] = {
	PHP_ME(TElCRLExtensions, get_AuthorityKeyIdentifier, arginfo_TElCRLExtensions_get_AuthorityKeyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_IssuerAlternativeName, arginfo_TElCRLExtensions_get_IssuerAlternativeName, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_CRLNumber, arginfo_TElCRLExtensions_get_CRLNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_DeltaCRLIndicator, arginfo_TElCRLExtensions_get_DeltaCRLIndicator, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_IssuingDistributionPoint, arginfo_TElCRLExtensions_get_IssuingDistributionPoint, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_OtherExtensions, arginfo_TElCRLExtensions_get_OtherExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_OtherCount, arginfo_TElCRLExtensions_get_OtherCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, set_OtherCount, arginfo_TElCRLExtensions_set_OtherCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_Included, arginfo_TElCRLExtensions_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, set_Included, arginfo_TElCRLExtensions_set_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, get_SaveDefaultASN1Tags, arginfo_TElCRLExtensions_get_SaveDefaultASN1Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, set_SaveDefaultASN1Tags, arginfo_TElCRLExtensions_set_SaveDefaultASN1Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLExtensions, __construct, arginfo_TElCRLExtensions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCRLExtensions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCRLExtensions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCRLExtensions", TElCRLExtensions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCRLExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCRLEntryExtensions_ce_ptr = NULL;

SB_PHP_METHOD(TElCRLEntryExtensions, get_ReasonCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLEntryExtensions_get_ReasonCode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElReasonCodeCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_HoldInstructionCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLEntryExtensions_get_HoldInstructionCode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHoldInstructionCodeCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_InvalidityDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLEntryExtensions_get_InvalidityDate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElInvalidityDateCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_CertificateIssuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLEntryExtensions_get_CertificateIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateIssuerCRLExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_OtherExtensions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLEntryExtensions_get_OtherExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_OtherCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCRLEntryExtensions_get_OtherCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, set_OtherCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCRLEntryExtensions_set_OtherCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLEntryExtensionsRaw fOutResultRaw = 0;
		SBCheckError(TElCRLEntryExtensions_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, set_Included)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCRLEntryExtensions_set_Included(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCRLEntryExtensionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, get_SaveDefaultASN1Tags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCRLEntryExtensions_get_SaveDefaultASN1Tags(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, set_SaveDefaultASN1Tags)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCRLEntryExtensions_set_SaveDefaultASN1Tags(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCRLEntryExtensions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCRLEntryExtensions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_ReasonCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_HoldInstructionCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_InvalidityDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_CertificateIssuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_OtherExtensions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_OtherCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_set_OtherCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_set_Included, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_get_SaveDefaultASN1Tags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions_set_SaveDefaultASN1Tags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCRLEntryExtensions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCRLEntryExtensions_methods[] = {
	PHP_ME(TElCRLEntryExtensions, get_ReasonCode, arginfo_TElCRLEntryExtensions_get_ReasonCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_HoldInstructionCode, arginfo_TElCRLEntryExtensions_get_HoldInstructionCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_InvalidityDate, arginfo_TElCRLEntryExtensions_get_InvalidityDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_CertificateIssuer, arginfo_TElCRLEntryExtensions_get_CertificateIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_OtherExtensions, arginfo_TElCRLEntryExtensions_get_OtherExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_OtherCount, arginfo_TElCRLEntryExtensions_get_OtherCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, set_OtherCount, arginfo_TElCRLEntryExtensions_set_OtherCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_Included, arginfo_TElCRLEntryExtensions_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, set_Included, arginfo_TElCRLEntryExtensions_set_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, get_SaveDefaultASN1Tags, arginfo_TElCRLEntryExtensions_get_SaveDefaultASN1Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, set_SaveDefaultASN1Tags, arginfo_TElCRLEntryExtensions_set_SaveDefaultASN1Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElCRLEntryExtensions, __construct, arginfo_TElCRLEntryExtensions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCRLEntryExtensions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCRLEntryExtensions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCRLEntryExtensions", TElCRLEntryExtensions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCRLEntryExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRevocationItem_ce_ptr = NULL;

SB_PHP_METHOD(TElRevocationItem, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRevocationItem_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1315761355, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRevocationItem, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRevocationItem_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRevocationItem, get_RevocationDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElRevocationItem_get_RevocationDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRevocationItem, set_RevocationDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElRevocationItem_set_RevocationDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRevocationItem, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRevocationItem_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCRLEntryExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRevocationItem, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRevocationItem_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRevocationItem_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRevocationItem_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRevocationItem_get_RevocationDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRevocationItem_set_RevocationDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRevocationItem_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRevocationItem___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRevocationItem_methods[] = {
	PHP_ME(TElRevocationItem, get_SerialNumber, arginfo_TElRevocationItem_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElRevocationItem, set_SerialNumber, arginfo_TElRevocationItem_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElRevocationItem, get_RevocationDate, arginfo_TElRevocationItem_get_RevocationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElRevocationItem, set_RevocationDate, arginfo_TElRevocationItem_set_RevocationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElRevocationItem, get_Extensions, arginfo_TElRevocationItem_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElRevocationItem, __construct, arginfo_TElRevocationItem___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRevocationItem(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRevocationItem_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRevocationItem", TElRevocationItem_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElRevocationItem_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCertificateRevocationList_ce_ptr = NULL;

SB_PHP_METHOD(TElCertificateRevocationList, DetectCRLFileFormat_Inst)
{
	char *sFileName;
	int sFileName_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		TSBCRLFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_DetectCRLFileFormat_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		TSBCRLFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_DetectCRLFileFormat_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TSBCRLFileFormatRaw fOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRevocationList_DetectCRLFileFormat_5(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &fOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, DetectCRLFileFormat)
{
	char *sFileName;
	int sFileName_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		TSBCRLFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_DetectCRLFileFormat(sFileName, (int32_t)sFileName_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		TSBCRLFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_DetectCRLFileFormat_2(SBGetObjectHandle(oStream TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TSBCRLFileFormatRaw fOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRevocationList_DetectCRLFileFormat_4(piBuffer.data, (int32_t)l4Size, &fOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, Add)
{
	SBArrayZValInfo aiSerialNumber;
	zval *oCertificate;
	zval *zaSerialNumber;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSerialNumber) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSerialNumber)) || (IS_ARRAY == Z_TYPE_P(zaSerialNumber)) || (IS_NULL == Z_TYPE_P(zaSerialNumber))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSerialNumber, &aiSerialNumber TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRevocationList_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiSerialNumber.data, aiSerialNumber.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSerialNumber);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRevocationList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, Remove)
{
	long l4Index;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_Remove_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, IsPresent)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_IsPresent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, IndexOf)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCertificateRevocationList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRevocationList_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRevocationList_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, LoadFromBufferPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zls", &zpBuffer, &l4Size, &sPassphrase, &sPassphrase_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRevocationList_LoadFromBufferPEM(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, sPassphrase, (int32_t)sPassphrase_len, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, SaveToBufferPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzs", &zpBuffer, &zl4Size, &sPassphrase, &sPassphrase_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRevocationList_SaveToBufferPEM(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, sPassphrase, (int32_t)sPassphrase_len, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, LoadFromStream)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, LoadFromStreamPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oStream, TStream_ce_ptr, &sPassphrase, &sPassphrase_len, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_LoadFromStreamPEM(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassphrase, (int32_t)sPassphrase_len, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, SameCRL)
{
	zend_bool bCheckUpdateTime;
	zval *oCRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCRL, TElCertificateRevocationList_ce_ptr, &bCheckUpdateTime) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_SameCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRL TSRMLS_CC), (int8_t)bCheckUpdateTime, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, Validate)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, GetCRLHash)
{
	long l4Alg;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCertificateRevocationList_GetCRLHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-45266315, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_Location)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCertificateRevocationList_get_Location(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-963183332, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, set_Location)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCertificateRevocationList_set_Location(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_Issuer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRevocationList_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_ThisUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_get_ThisUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, set_ThisUpdate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCertificateRevocationList_set_ThisUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_NextUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_get_NextUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, set_NextUpdate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElCertificateRevocationList_set_NextUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_SignatureAlgorithmIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRevocationList_get_SignatureAlgorithmIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_Signature)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCertificateRevocationList_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1688576463, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_TBS)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCertificateRevocationList_get_TBS(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1262721457, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRevocationList_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRevocationItem_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRevocationList_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCRLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, get_CRLSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRevocationList_get_CRLSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRevocationList, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRevocationList_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_DetectCRLFileFormat_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream_or_Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_DetectCRLFileFormat, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream_or_Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_SerialNumber, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_Remove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_Index, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_IsPresent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_LoadFromBufferPEM, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(0, Passphrase)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_SaveToBufferPEM, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(1, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_INFO(0, Passphrase)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_LoadFromStreamPEM, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Passphrase)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_SameCRL, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRL, TElCertificateRevocationList, 1)
	ZEND_ARG_INFO(0, CheckUpdateTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_Validate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_GetCRLHash, 0, 0, 1)
	ZEND_ARG_INFO(0, Alg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_Location, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_set_Location, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_ThisUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_set_ThisUpdate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_NextUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_set_NextUpdate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_SignatureAlgorithmIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_TBS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList_get_CRLSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRevocationList___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCertificateRevocationList_methods[] = {
	PHP_ME(TElCertificateRevocationList, DetectCRLFileFormat_Inst, arginfo_TElCertificateRevocationList_DetectCRLFileFormat_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, DetectCRLFileFormat, arginfo_TElCertificateRevocationList_DetectCRLFileFormat, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCertificateRevocationList, Add, arginfo_TElCertificateRevocationList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, Assign, arginfo_TElCertificateRevocationList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, Remove, arginfo_TElCertificateRevocationList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, IsPresent, arginfo_TElCertificateRevocationList_IsPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, IndexOf, arginfo_TElCertificateRevocationList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, Clear, arginfo_TElCertificateRevocationList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, LoadFromBuffer, arginfo_TElCertificateRevocationList_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, SaveToBuffer, arginfo_TElCertificateRevocationList_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, LoadFromBufferPEM, arginfo_TElCertificateRevocationList_LoadFromBufferPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, SaveToBufferPEM, arginfo_TElCertificateRevocationList_SaveToBufferPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, LoadFromStream, arginfo_TElCertificateRevocationList_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, LoadFromStreamPEM, arginfo_TElCertificateRevocationList_LoadFromStreamPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, SameCRL, arginfo_TElCertificateRevocationList_SameCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, Validate, arginfo_TElCertificateRevocationList_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, GetCRLHash, arginfo_TElCertificateRevocationList_GetCRLHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_Location, arginfo_TElCertificateRevocationList_get_Location, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, set_Location, arginfo_TElCertificateRevocationList_set_Location, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_Issuer, arginfo_TElCertificateRevocationList_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_ThisUpdate, arginfo_TElCertificateRevocationList_get_ThisUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, set_ThisUpdate, arginfo_TElCertificateRevocationList_set_ThisUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_NextUpdate, arginfo_TElCertificateRevocationList_get_NextUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, set_NextUpdate, arginfo_TElCertificateRevocationList_set_NextUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_SignatureAlgorithm, arginfo_TElCertificateRevocationList_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_SignatureAlgorithmIdentifier, arginfo_TElCertificateRevocationList_get_SignatureAlgorithmIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_Signature, arginfo_TElCertificateRevocationList_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_TBS, arginfo_TElCertificateRevocationList_get_TBS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_Items, arginfo_TElCertificateRevocationList_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_Count, arginfo_TElCertificateRevocationList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_Extensions, arginfo_TElCertificateRevocationList_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, get_CRLSize, arginfo_TElCertificateRevocationList_get_CRLSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRevocationList, __construct, arginfo_TElCertificateRevocationList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCertificateRevocationList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCertificateRevocationList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCertificateRevocationList", TElCertificateRevocationList_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCertificateRevocationList_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCRL_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_INVALID_FORMAT, SB_CRL_ERROR_INVALID_FORMAT, SB_CRL_ERROR_INVALID_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_BAD_SIGNATURE_ALGORITHM, SB_CRL_ERROR_BAD_SIGNATURE_ALGORITHM, SB_CRL_ERROR_BAD_SIGNATURE_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_INVALID_ISSUER, SB_CRL_ERROR_INVALID_ISSUER, SB_CRL_ERROR_INVALID_ISSUER);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_INVALID_SIGNATURE, SB_CRL_ERROR_INVALID_SIGNATURE, SB_CRL_ERROR_INVALID_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_UNSUPPORTED_VERSION, SB_CRL_ERROR_UNSUPPORTED_VERSION, SB_CRL_ERROR_UNSUPPORTED_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_UNSUPPORTED_ALGORITHM, SB_CRL_ERROR_UNSUPPORTED_ALGORITHM, SB_CRL_ERROR_UNSUPPORTED_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_INVALID_CERTIFICATE, SB_CRL_ERROR_INVALID_CERTIFICATE, SB_CRL_ERROR_INVALID_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_ALREADY_EXISTS, SB_CRL_ERROR_ALREADY_EXISTS, SB_CRL_ERROR_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_NOT_FOUND, SB_CRL_ERROR_NOT_FOUND, SB_CRL_ERROR_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_PRIVATE_KEY_NOT_FOUND, SB_CRL_ERROR_PRIVATE_KEY_NOT_FOUND, SB_CRL_ERROR_PRIVATE_KEY_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_UNSUPPORTED_CERTIFICATE, SB_CRL_ERROR_UNSUPPORTED_CERTIFICATE, SB_CRL_ERROR_UNSUPPORTED_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_INTERNAL_ERROR, SB_CRL_ERROR_INTERNAL_ERROR, SB_CRL_ERROR_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_BUFFER_TOO_SMALL, SB_CRL_ERROR_BUFFER_TOO_SMALL, SB_CRL_ERROR_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_NOTHING_TO_VERIFY, SB_CRL_ERROR_NOTHING_TO_VERIFY, SB_CRL_ERROR_NOTHING_TO_VERIFY);
	SB_REGISTER_LONG_CONSTANT(SBCRL, SB_CRL_ERROR_NO_SIGNED_CRL_FOUND, SB_CRL_ERROR_NO_SIGNED_CRL_FOUND, SB_CRL_ERROR_NO_SIGNED_CRL_FOUND);
}

void Register_SBCRL_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBCRLFileFormat", NULL);
	TSBCRLFileFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCRLFileFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLFileFormat_ce_ptr, "crlfUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLFileFormat_ce_ptr, "crlfDER", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLFileFormat_ce_ptr, "crlfPEM", 2)
	
	INIT_CLASS_ENTRY(ce, "TElInstructionCode", NULL);
	TElInstructionCode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElInstructionCode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElInstructionCode_ce_ptr, "icNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElInstructionCode_ce_ptr, "icCallIssuer", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElInstructionCode_ce_ptr, "icReject", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLExtension", NULL);
	TSBCRLExtension_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCRLExtension_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtension_ce_ptr, "crlAuthorityKeyIdentifier", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtension_ce_ptr, "crlIssuerAlternativeName", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtension_ce_ptr, "crlCRLNumber", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtension_ce_ptr, "crlDeltaCRLIndicator", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtension_ce_ptr, "crlIssuingDistributionPoint", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLExtensions", NULL);
	TSBCRLExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBCRLExtensions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtensions_ce_ptr, "crlAuthorityKeyIdentifier", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtensions_ce_ptr, "crlIssuerAlternativeName", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtensions_ce_ptr, "crlCRLNumber", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtensions_ce_ptr, "crlDeltaCRLIndicator", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLExtensions_ce_ptr, "crlIssuingDistributionPoint", 16)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLEntryExtension", NULL);
	TSBCRLEntryExtension_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCRLEntryExtension_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtension_ce_ptr, "crlReasonCode", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtension_ce_ptr, "crlHoldInstructionCode", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtension_ce_ptr, "crlInvalidityDate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtension_ce_ptr, "crlCertificateIssuer", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBCRLEntryExtensions", NULL);
	TSBCRLEntryExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBCRLEntryExtensions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtensions_ce_ptr, "crlReasonCode", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtensions_ce_ptr, "crlHoldInstructionCode", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtensions_ce_ptr, "crlInvalidityDate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBCRLEntryExtensions_ce_ptr, "crlCertificateIssuer", 8)
}

void Register_SBCRL_Aliases(TSRMLS_D)
{
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	zend_register_class_alias("TElCRLExtension", TElCustomExtension_ce_ptr);
	if (NULL == TElCustomExtension_ce_ptr)
		Register_TElCustomExtension(TSRMLS_C);
	zend_register_class_alias("ElCRLExtension", TElCustomExtension_ce_ptr);
	if (NULL == TElAuthorityKeyIdentifierCRLExtension_ce_ptr)
		Register_TElAuthorityKeyIdentifierCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElAuthorityKeyIdentifierCRLExtension", TElAuthorityKeyIdentifierCRLExtension_ce_ptr);
	if (NULL == TElCRLNumberCRLExtension_ce_ptr)
		Register_TElCRLNumberCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElCRLNumberCRLExtension", TElCRLNumberCRLExtension_ce_ptr);
	if (NULL == TElDeltaCRLIndicatorCRLExtension_ce_ptr)
		Register_TElDeltaCRLIndicatorCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElDeltaCRLIndicatorCRLExtension", TElDeltaCRLIndicatorCRLExtension_ce_ptr);
	if (NULL == TElReasonCodeCRLExtension_ce_ptr)
		Register_TElReasonCodeCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElReasonCodeCRLExtension", TElReasonCodeCRLExtension_ce_ptr);
	if (NULL == TElHoldInstructionCodeCRLExtension_ce_ptr)
		Register_TElHoldInstructionCodeCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElHoldInstructionCodeCRLExtension", TElHoldInstructionCodeCRLExtension_ce_ptr);
	if (NULL == TElInvalidityDateCRLExtension_ce_ptr)
		Register_TElInvalidityDateCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElInvalidityDateCRLExtension", TElInvalidityDateCRLExtension_ce_ptr);
	if (NULL == TElCertificateIssuerCRLExtension_ce_ptr)
		Register_TElCertificateIssuerCRLExtension(TSRMLS_C);
	zend_register_class_alias("ElCertificateIssuerCRLExtension", TElCertificateIssuerCRLExtension_ce_ptr);
	if (NULL == TElCRLExtensions_ce_ptr)
		Register_TElCRLExtensions(TSRMLS_C);
	zend_register_class_alias("ElCRLExtensions", TElCRLExtensions_ce_ptr);
	if (NULL == TElCRLEntryExtensions_ce_ptr)
		Register_TElCRLEntryExtensions(TSRMLS_C);
	zend_register_class_alias("ElCRLEntryExtensions", TElCRLEntryExtensions_ce_ptr);
	if (NULL == TElRevocationItem_ce_ptr)
		Register_TElRevocationItem(TSRMLS_C);
	zend_register_class_alias("ElRevocationItem", TElRevocationItem_ce_ptr);
	if (NULL == TElCertificateRevocationList_ce_ptr)
		Register_TElCertificateRevocationList(TSRMLS_C);
	zend_register_class_alias("ElCertificateRevocationList", TElCertificateRevocationList_ce_ptr);
}

