#include "sbcryptoprovbuiltinhash.h"

zend_class_entry *TElBuiltInHashFunction_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInHashFunction, SetHashFunctionProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_SetHashFunctionProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, GetHashFunctionProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElBuiltInHashFunction_GetHashFunctionProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1862334944, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInHashFunction_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, Update)
{
	long l4Size;
	long l8Count;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_Update(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		SBCheckError(TElBuiltInHashFunction_Update_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, Finish)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElBuiltInHashFunction_Finish(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1498020764, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInHashFunction_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBuiltInHashFunction_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, IsAlgorithmSupported_Inst)
{
	long l4Algorithm;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInHashFunction_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_IsAlgorithmSupported_3(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, IsAlgorithmSupported)
{
	long l4Algorithm;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInHashFunction_IsAlgorithmSupported((int32_t)l4Algorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_IsAlgorithmSupported_2(aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, GetDigestSizeBits_Inst)
{
	long l4Algorithm;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInHashFunction_GetDigestSizeBits_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_GetDigestSizeBits_3(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, GetDigestSizeBits)
{
	long l4Algorithm;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInHashFunction_GetDigestSizeBits((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_GetDigestSizeBits_2(aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBuiltInHashFunction_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInHashFunction_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, set_KeyMaterial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBuiltInHashFunction_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInHashFunction, __construct)
{
	long l4Algorithm;
	SBArrayZValInfo aiOID;
	zval *oKey;
	zval *oParameters;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Algorithm, &oParameters, TElRelativeDistinguishedName_ce_ptr, &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInHashFunction_Create((int32_t)l4Algorithm, SBGetObjectHandle(oParameters TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oParameters, TElRelativeDistinguishedName_ce_ptr, &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInHashFunction_Create_1(aiOID.data, aiOID.len, SBGetObjectHandle(oParameters TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElRelativeDistinguishedName, TElCustomCryptoKey) or (array of byte|string|NULL, TElRelativeDistinguishedName, TElCustomCryptoKey)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_SetHashFunctionProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_GetHashFunctionProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_Update, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_Finish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_IsAlgorithmSupported_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_IsAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_GetDigestSizeBits_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_GetDigestSizeBits, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction_set_KeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInHashFunction___construct, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_OID, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Parameters, TElRelativeDistinguishedName, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInHashFunction_methods[] = {
	PHP_ME(TElBuiltInHashFunction, SetHashFunctionProp, arginfo_TElBuiltInHashFunction_SetHashFunctionProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, GetHashFunctionProp, arginfo_TElBuiltInHashFunction_GetHashFunctionProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, Reset, arginfo_TElBuiltInHashFunction_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, Update, arginfo_TElBuiltInHashFunction_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, Finish, arginfo_TElBuiltInHashFunction_Finish, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, Clone, arginfo_TElBuiltInHashFunction_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, IsAlgorithmSupported_Inst, arginfo_TElBuiltInHashFunction_IsAlgorithmSupported_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, IsAlgorithmSupported, arginfo_TElBuiltInHashFunction_IsAlgorithmSupported, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInHashFunction, GetDigestSizeBits_Inst, arginfo_TElBuiltInHashFunction_GetDigestSizeBits_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, GetDigestSizeBits, arginfo_TElBuiltInHashFunction_GetDigestSizeBits, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBuiltInHashFunction, get_Algorithm, arginfo_TElBuiltInHashFunction_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, get_KeyMaterial, arginfo_TElBuiltInHashFunction_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, set_KeyMaterial, arginfo_TElBuiltInHashFunction_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInHashFunction, __construct, arginfo_TElBuiltInHashFunction___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInHashFunction(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInHashFunction_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInHashFunction", TElBuiltInHashFunction_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBuiltInHashFunction_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBuiltInMACKey_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInMACKey, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInMACKey_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, Generate)
{
	long l4Bits;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zz", &l4Bits, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInMACKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ImportPublic)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInMACKey_ImportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ImportSecret)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInMACKey_ImportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ExportPublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElBuiltInMACKey_ExportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ExportSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElBuiltInMACKey_ExportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInMACKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ClonePublic)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInMACKey_ClonePublic(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInMACKey_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInMACKey_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, GetKeyProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElBuiltInMACKey_GetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(446231977, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, SetKeyProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBuiltInMACKey_SetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, ChangeAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElBuiltInMACKey_ChangeAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, Equals)
{
	zend_bool bPublicOnly;
	zval *oParams;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bO!", &oSource, TElCustomCryptoKey_ce_ptr, &bPublicOnly, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInMACKey_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey, bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInMACKey, __construct)
{
	zval *oCryptoProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInMACKey_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_Generate, 0, 0, 4)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ImportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ImportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ExportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ExportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ClonePublic, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_GetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_SetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_ChangeAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey_Equals, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomCryptoKey, 1)
	ZEND_ARG_INFO(0, PublicOnly)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInMACKey___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInMACKey_methods[] = {
	PHP_ME(TElBuiltInMACKey, Reset, arginfo_TElBuiltInMACKey_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, Generate, arginfo_TElBuiltInMACKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ImportPublic, arginfo_TElBuiltInMACKey_ImportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ImportSecret, arginfo_TElBuiltInMACKey_ImportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ExportPublic, arginfo_TElBuiltInMACKey_ExportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ExportSecret, arginfo_TElBuiltInMACKey_ExportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, Clone, arginfo_TElBuiltInMACKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ClonePublic, arginfo_TElBuiltInMACKey_ClonePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ClearPublic, arginfo_TElBuiltInMACKey_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ClearSecret, arginfo_TElBuiltInMACKey_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, GetKeyProp, arginfo_TElBuiltInMACKey_GetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, SetKeyProp, arginfo_TElBuiltInMACKey_SetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, ChangeAlgorithm, arginfo_TElBuiltInMACKey_ChangeAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, Equals, arginfo_TElBuiltInMACKey_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInMACKey, __construct, arginfo_TElBuiltInMACKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInMACKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInMACKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInMACKey", TElBuiltInMACKey_methods);
	if (NULL == TElBuiltInCryptoKey_ce_ptr)
		Register_TElBuiltInCryptoKey(TSRMLS_C);
	TElBuiltInMACKey_ce_ptr = zend_register_internal_class_ex(&ce, TElBuiltInCryptoKey_ce_ptr, NULL TSRMLS_CC);
}

