#include "sbcryptoprovmanager.h"

zend_class_entry *TSBCryptoEngineType_ce_ptr = NULL;

zend_class_entry *TElBuiltInCryptoProviderManager_ce_ptr = NULL;

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderManager_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderManager_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, IsProviderAllowed)
{
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderManager_IsProviderAllowed(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, get_EngineType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCryptoEngineTypeRaw fOutResultRaw = 0;
		SBCheckError(TElBuiltInCryptoProviderManager_get_EngineType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, set_EngineType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBuiltInCryptoProviderManager_set_EngineType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCryptoEngineTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, get_BuiltInCryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProviderManager_get_BuiltInCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, get_Win32CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProviderManager_get_Win32CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBuiltInCryptoProviderManager, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBuiltInCryptoProviderManager_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_IsProviderAllowed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_get_EngineType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_set_EngineType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_get_BuiltInCryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager_get_Win32CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBuiltInCryptoProviderManager___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBuiltInCryptoProviderManager_methods[] = {
	PHP_ME(TElBuiltInCryptoProviderManager, Init, arginfo_TElBuiltInCryptoProviderManager_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, Deinit, arginfo_TElBuiltInCryptoProviderManager_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, IsProviderAllowed, arginfo_TElBuiltInCryptoProviderManager_IsProviderAllowed, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, get_EngineType, arginfo_TElBuiltInCryptoProviderManager_get_EngineType, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, set_EngineType, arginfo_TElBuiltInCryptoProviderManager_set_EngineType, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, get_BuiltInCryptoProvider, arginfo_TElBuiltInCryptoProviderManager_get_BuiltInCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, get_Win32CryptoProvider, arginfo_TElBuiltInCryptoProviderManager_get_Win32CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElBuiltInCryptoProviderManager, __construct, arginfo_TElBuiltInCryptoProviderManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBuiltInCryptoProviderManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBuiltInCryptoProviderManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBuiltInCryptoProviderManager", TElBuiltInCryptoProviderManager_methods);
	if (NULL == TElCustomCryptoProviderManager_ce_ptr)
		Register_TElCustomCryptoProviderManager(TSRMLS_C);
	TElBuiltInCryptoProviderManager_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoProviderManager_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFIPSCompliantCryptoProviderManager_ce_ptr = NULL;

SB_PHP_METHOD(TElFIPSCompliantCryptoProviderManager, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFIPSCompliantCryptoProviderManager_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFIPSCompliantCryptoProviderManager, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFIPSCompliantCryptoProviderManager_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFIPSCompliantCryptoProviderManager, IsProviderAllowed)
{
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFIPSCompliantCryptoProviderManager_IsProviderAllowed(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFIPSCompliantCryptoProviderManager, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFIPSCompliantCryptoProviderManager_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFIPSCompliantCryptoProviderManager_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFIPSCompliantCryptoProviderManager_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFIPSCompliantCryptoProviderManager_IsProviderAllowed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFIPSCompliantCryptoProviderManager___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFIPSCompliantCryptoProviderManager_methods[] = {
	PHP_ME(TElFIPSCompliantCryptoProviderManager, Init, arginfo_TElFIPSCompliantCryptoProviderManager_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElFIPSCompliantCryptoProviderManager, Deinit, arginfo_TElFIPSCompliantCryptoProviderManager_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFIPSCompliantCryptoProviderManager, IsProviderAllowed, arginfo_TElFIPSCompliantCryptoProviderManager_IsProviderAllowed, ZEND_ACC_PUBLIC)
	PHP_ME(TElFIPSCompliantCryptoProviderManager, __construct, arginfo_TElFIPSCompliantCryptoProviderManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFIPSCompliantCryptoProviderManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFIPSCompliantCryptoProviderManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFIPSCompliantCryptoProviderManager", TElFIPSCompliantCryptoProviderManager_methods);
	if (NULL == TElCustomCryptoProviderManager_ce_ptr)
		Register_TElCustomCryptoProviderManager(TSRMLS_C);
	TElFIPSCompliantCryptoProviderManager_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoProviderManager_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCryptoProvManager, DefaultCryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCryptoProvManager_DefaultCryptoProviderManager(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBuiltInCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_FUNCTION(SBCryptoProvManager, FIPSCompliantCryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCryptoProvManager_FIPSCompliantCryptoProviderManager(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFIPSCompliantCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

void Register_SBCryptoProvManager_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBCryptoEngineType", NULL);
	TSBCryptoEngineType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCryptoEngineType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCryptoEngineType_ce_ptr, "cetDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCryptoEngineType_ce_ptr, "cetFIPS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCryptoEngineType_ce_ptr, "cetCustom", 2)
}
