#include "sbdc.h"

zend_class_entry *TElDCMessageClass_ce_ptr = NULL;

zend_class_entry *TSBDCOperation_ce_ptr = NULL;

zend_class_entry *TSBDCAsyncSignMethod_ce_ptr = NULL;

zend_class_entry *TElDCBaseMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDCBaseMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, InitializeMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_InitializeMessage(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, Clone)
{
	zend_bool bRenegerateID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRenegerateID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_Clone_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRenegerateID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, SaveToNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_SaveToNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, LoadFromNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_LoadFromNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, SaveToStream)
{
	char *sRootNodeName;
	int sRootNodeName_len;
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!s", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr, &sRootNodeName, &sRootNodeName_len) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC), sRootNodeName, (int32_t)sRootNodeName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, LoadFromStream)
{
	long l4Count;
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCBaseMessage_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(953916284, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCBaseMessage_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1433569182, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCBaseMessage_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, get_Pars)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_get_Pars(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, get_OriginalMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_get_OriginalMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBaseMessage, __construct)
{
	zval *oOrigMessage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOrigMessage, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBaseMessage_Create_1(SBGetObjectHandle(oOrigMessage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElDCBaseMessage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_InitializeMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_Clone, 0, 0, 0)
	ZEND_ARG_INFO(0, RenegerateID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_SaveToNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElDCNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_LoadFromNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElDCNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_SaveToStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
	ZEND_ARG_INFO(0, RootNodeName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_LoadFromStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_get_Pars, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage_get_OriginalMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBaseMessage___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, OrigMessage, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCBaseMessage_methods[] = {
	PHP_ME(TElDCBaseMessage, Assign, arginfo_TElDCBaseMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, InitializeMessage, arginfo_TElDCBaseMessage_InitializeMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, Clone, arginfo_TElDCBaseMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, SaveToNode, arginfo_TElDCBaseMessage_SaveToNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, LoadFromNode, arginfo_TElDCBaseMessage_LoadFromNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, SaveToStream, arginfo_TElDCBaseMessage_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, LoadFromStream, arginfo_TElDCBaseMessage_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, ClassType, arginfo_TElDCBaseMessage_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDCBaseMessage, get_ID, arginfo_TElDCBaseMessage_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, set_ID, arginfo_TElDCBaseMessage_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, get_Name, arginfo_TElDCBaseMessage_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, set_Name, arginfo_TElDCBaseMessage_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, get_Pars, arginfo_TElDCBaseMessage_get_Pars, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, get_OriginalMessage, arginfo_TElDCBaseMessage_get_OriginalMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBaseMessage, __construct, arginfo_TElDCBaseMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCBaseMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCBaseMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCBaseMessage", TElDCBaseMessage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCBaseMessage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCUnsupportedMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDCUnsupportedMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCUnsupportedMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCUnsupportedMessage, Clone)
{
	zend_bool bRenegerateID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCUnsupportedMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRenegerateID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCUnsupportedMessage_Clone_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRenegerateID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCUnsupportedMessage, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCUnsupportedMessage_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCUnsupportedMessage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCUnsupportedMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCUnsupportedMessage_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCUnsupportedMessage_Clone, 0, 0, 0)
	ZEND_ARG_INFO(0, RenegerateID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCUnsupportedMessage_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCUnsupportedMessage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCUnsupportedMessage_methods[] = {
	PHP_ME(TElDCUnsupportedMessage, Assign, arginfo_TElDCUnsupportedMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCUnsupportedMessage, Clone, arginfo_TElDCUnsupportedMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCUnsupportedMessage, ClassType, arginfo_TElDCUnsupportedMessage_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDCUnsupportedMessage, __construct, arginfo_TElDCUnsupportedMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCUnsupportedMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCUnsupportedMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCUnsupportedMessage", TElDCUnsupportedMessage_methods);
	if (NULL == TElDCBaseMessage_ce_ptr)
		Register_TElDCBaseMessage(TSRMLS_C);
	TElDCUnsupportedMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElDCBaseMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCErrorMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDCErrorMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCErrorMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, Clone)
{
	zend_bool bRenegerateID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCErrorMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRenegerateID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCErrorMessage_Clone_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRenegerateID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCErrorMessage_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, get_Code)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCErrorMessage_get_Code(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, set_Code)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDCErrorMessage_set_Code(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, get_ErrorMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCErrorMessage_get_ErrorMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1945208040, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, set_ErrorMessage)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCErrorMessage_set_ErrorMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCErrorMessage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCErrorMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_Clone, 0, 0, 0)
	ZEND_ARG_INFO(0, RenegerateID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_get_Code, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_set_Code, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_get_ErrorMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage_set_ErrorMessage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCErrorMessage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCErrorMessage_methods[] = {
	PHP_ME(TElDCErrorMessage, Assign, arginfo_TElDCErrorMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCErrorMessage, Clone, arginfo_TElDCErrorMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCErrorMessage, ClassType, arginfo_TElDCErrorMessage_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDCErrorMessage, get_Code, arginfo_TElDCErrorMessage_get_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCErrorMessage, set_Code, arginfo_TElDCErrorMessage_set_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCErrorMessage, get_ErrorMessage, arginfo_TElDCErrorMessage_get_ErrorMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCErrorMessage, set_ErrorMessage, arginfo_TElDCErrorMessage_set_ErrorMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCErrorMessage, __construct, arginfo_TElDCErrorMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCErrorMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCErrorMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCErrorMessage", TElDCErrorMessage_methods);
	if (NULL == TElDCBaseMessage_ce_ptr)
		Register_TElDCBaseMessage(TSRMLS_C);
	TElDCErrorMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElDCBaseMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCOperationRequestMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDCOperationRequestMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCOperationRequestMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, Clone)
{
	zend_bool bRenegerateID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationRequestMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRenegerateID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationRequestMessage_Clone_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRenegerateID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationRequestMessage_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, get_Operation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDCOperationRaw fOutResultRaw = 0;
		SBCheckError(TElDCOperationRequestMessage_get_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, set_Operation)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDCOperationRequestMessage_set_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDCOperationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, get_OperationID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCOperationRequestMessage_get_OperationID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-679929423, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, set_OperationID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCOperationRequestMessage_set_OperationID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, get_Source)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCOperationRequestMessage_get_Source(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-593133734, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, set_Source)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCOperationRequestMessage_set_Source(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, get_HashAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCOperationRequestMessage_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-951433435, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, set_HashAlgorithm)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCOperationRequestMessage_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, get_IncludeKeysInResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCOperationRequestMessage_get_IncludeKeysInResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, set_IncludeKeysInResponse)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCOperationRequestMessage_set_IncludeKeysInResponse(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationRequestMessage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationRequestMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_Clone, 0, 0, 0)
	ZEND_ARG_INFO(0, RenegerateID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_get_Operation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_set_Operation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_get_OperationID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_set_OperationID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_get_Source, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_set_Source, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_get_IncludeKeysInResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage_set_IncludeKeysInResponse, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationRequestMessage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCOperationRequestMessage_methods[] = {
	PHP_ME(TElDCOperationRequestMessage, Assign, arginfo_TElDCOperationRequestMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, Clone, arginfo_TElDCOperationRequestMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, ClassType, arginfo_TElDCOperationRequestMessage_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDCOperationRequestMessage, get_Operation, arginfo_TElDCOperationRequestMessage_get_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, set_Operation, arginfo_TElDCOperationRequestMessage_set_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, get_OperationID, arginfo_TElDCOperationRequestMessage_get_OperationID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, set_OperationID, arginfo_TElDCOperationRequestMessage_set_OperationID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, get_Source, arginfo_TElDCOperationRequestMessage_get_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, set_Source, arginfo_TElDCOperationRequestMessage_set_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, get_HashAlgorithm, arginfo_TElDCOperationRequestMessage_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, set_HashAlgorithm, arginfo_TElDCOperationRequestMessage_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, get_IncludeKeysInResponse, arginfo_TElDCOperationRequestMessage_get_IncludeKeysInResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, set_IncludeKeysInResponse, arginfo_TElDCOperationRequestMessage_set_IncludeKeysInResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationRequestMessage, __construct, arginfo_TElDCOperationRequestMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCOperationRequestMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCOperationRequestMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCOperationRequestMessage", TElDCOperationRequestMessage_methods);
	if (NULL == TElDCBaseMessage_ce_ptr)
		Register_TElDCBaseMessage(TSRMLS_C);
	TElDCOperationRequestMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElDCBaseMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCOperationResponseMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDCOperationResponseMessage, InitializeMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDCOperationResponseMessage_InitializeMessage(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCOperationResponseMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, Clone)
{
	zend_bool bRenegerateID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationResponseMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRenegerateID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationResponseMessage_Clone_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRenegerateID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationResponseMessage_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, get_Operation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDCOperationRaw fOutResultRaw = 0;
		SBCheckError(TElDCOperationResponseMessage_get_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, set_Operation)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDCOperationResponseMessage_set_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDCOperationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, get_OperationResult)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCOperationResponseMessage_get_OperationResult(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1053847581, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, set_OperationResult)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCOperationResponseMessage_set_OperationResult(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, get_KeysRDN)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationResponseMessage_get_KeysRDN(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationResponseMessage, __construct)
{
	zval *oOrigMessage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationResponseMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOrigMessage, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationResponseMessage_Create_1(SBGetObjectHandle(oOrigMessage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElDCBaseMessage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_InitializeMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_Clone, 0, 0, 0)
	ZEND_ARG_INFO(0, RenegerateID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_get_Operation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_set_Operation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_get_OperationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_set_OperationResult, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage_get_KeysRDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationResponseMessage___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, OrigMessage, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCOperationResponseMessage_methods[] = {
	PHP_ME(TElDCOperationResponseMessage, InitializeMessage, arginfo_TElDCOperationResponseMessage_InitializeMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, Assign, arginfo_TElDCOperationResponseMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, Clone, arginfo_TElDCOperationResponseMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, ClassType, arginfo_TElDCOperationResponseMessage_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDCOperationResponseMessage, get_Operation, arginfo_TElDCOperationResponseMessage_get_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, set_Operation, arginfo_TElDCOperationResponseMessage_set_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, get_OperationResult, arginfo_TElDCOperationResponseMessage_get_OperationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, set_OperationResult, arginfo_TElDCOperationResponseMessage_set_OperationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, get_KeysRDN, arginfo_TElDCOperationResponseMessage_get_KeysRDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationResponseMessage, __construct, arginfo_TElDCOperationResponseMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCOperationResponseMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCOperationResponseMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCOperationResponseMessage", TElDCOperationResponseMessage_methods);
	if (NULL == TElDCBaseMessage_ce_ptr)
		Register_TElDCBaseMessage(TSRMLS_C);
	TElDCOperationResponseMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElDCBaseMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCBatchMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElDCBatchMessage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElDCBaseMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCBatchMessage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, Clone)
{
	zend_bool bRenegerateID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBatchMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRenegerateID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBatchMessage_Clone_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRenegerateID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, Add)
{
	zend_bool bCreateCopy;
	zval *oMessage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oMessage, TElDCBaseMessage_ce_ptr, &bCreateCopy) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCBatchMessage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMessage TSRMLS_CC), (int8_t)bCreateCopy, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCBaseMessage, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDCBatchMessage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDCBatchMessage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBatchMessage_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, get_Messages)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBatchMessage_get_Messages(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCBatchMessage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCBatchMessage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCBatchMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElDCBaseMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_Clone, 0, 0, 0)
	ZEND_ARG_INFO(0, RenegerateID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_Add, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Message, TElDCBaseMessage, 1)
	ZEND_ARG_INFO(0, CreateCopy)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_get_Messages, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCBatchMessage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCBatchMessage_methods[] = {
	PHP_ME(TElDCBatchMessage, Assign, arginfo_TElDCBatchMessage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, Clone, arginfo_TElDCBatchMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, Add, arginfo_TElDCBatchMessage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, Remove, arginfo_TElDCBatchMessage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, Clear, arginfo_TElDCBatchMessage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, ClassType, arginfo_TElDCBatchMessage_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDCBatchMessage, get_Messages, arginfo_TElDCBatchMessage_get_Messages, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, get_Count, arginfo_TElDCBatchMessage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCBatchMessage, __construct, arginfo_TElDCBatchMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCBatchMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCBatchMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCBatchMessage", TElDCBatchMessage_methods);
	if (NULL == TElDCBaseMessage_ce_ptr)
		Register_TElDCBaseMessage(TSRMLS_C);
	TElDCBatchMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElDCBaseMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCMessageFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElDCMessageFactory, CreateInstance)
{
	zval *oEncoding;
	zval *oNode;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCMessageFactory_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCMessageFactory_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding) or (TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCMessageFactory, RegisterClass)
{
	zval *oCls;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCls, TElDCMessageClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCMessageFactory_RegisterClass(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCls TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCMessageClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCMessageFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCMessageFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCMessageFactory_CreateInstance, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Node, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCMessageFactory_RegisterClass, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cls, TElDCMessageClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCMessageFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCMessageFactory_methods[] = {
	PHP_ME(TElDCMessageFactory, CreateInstance, arginfo_TElDCMessageFactory_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCMessageFactory, RegisterClass, arginfo_TElDCMessageFactory_RegisterClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCMessageFactory, __construct, arginfo_TElDCMessageFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCMessageFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCMessageFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCMessageFactory", TElDCMessageFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCMessageFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCAsyncState_ce_ptr = NULL;

SB_PHP_METHOD(TElDCAsyncState, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, SaveToNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncState_SaveToNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, SaveToStream)
{
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncState_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, LoadFromNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncState_LoadFromNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, LoadFromStream)
{
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncState_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, SubtypePresent)
{
	char *sSubtype;
	int sSubtype_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSubtype, &sSubtype_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCAsyncState_SubtypePresent(SBGetObjectHandle(getThis() TSRMLS_CC), sSubtype, (int32_t)sSubtype_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, FindMessageByType)
{
	zval *oMsgType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMsgType, TElDCMessageClass_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_FindMessageByType(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMsgType TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCMessageClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, FindMessageByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_FindMessageByName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBaseMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, get_Messages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_get_Messages(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCBatchMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, get_StateType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCAsyncState_get_StateType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1751964859, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, set_StateType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCAsyncState_set_StateType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, get_StateSubtypes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_get_StateSubtypes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, get_UserData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCAsyncState_get_UserData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1128690327, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, set_UserData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCAsyncState_set_UserData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, get_Generator)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCAsyncState_get_Generator(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1157039279, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, get_InnerState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_get_InnerState(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncState, __construct)
{
	zend_bool bReleaseOnDestruction;
	zval *oInnerState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oInnerState, TElDCAsyncState_ce_ptr, &bReleaseOnDestruction) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncState_Create_1(SBGetObjectHandle(oInnerState TSRMLS_CC), (int8_t)bReleaseOnDestruction, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElDCAsyncState, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_SaveToNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElDCNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_LoadFromNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElDCNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_SubtypePresent, 0, 0, 1)
	ZEND_ARG_INFO(0, Subtype)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_FindMessageByType, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, MsgType, TElDCMessageClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_FindMessageByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_get_Messages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_get_StateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_set_StateType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_get_StateSubtypes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_get_UserData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_set_UserData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_get_Generator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState_get_InnerState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncState___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, InnerState, TElDCAsyncState, 1)
	ZEND_ARG_INFO(0, ReleaseOnDestruction)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCAsyncState_methods[] = {
	PHP_ME(TElDCAsyncState, Clone, arginfo_TElDCAsyncState_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, SaveToNode, arginfo_TElDCAsyncState_SaveToNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, SaveToStream, arginfo_TElDCAsyncState_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, LoadFromNode, arginfo_TElDCAsyncState_LoadFromNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, LoadFromStream, arginfo_TElDCAsyncState_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, SubtypePresent, arginfo_TElDCAsyncState_SubtypePresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, FindMessageByType, arginfo_TElDCAsyncState_FindMessageByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, FindMessageByName, arginfo_TElDCAsyncState_FindMessageByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, get_Messages, arginfo_TElDCAsyncState_get_Messages, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, get_StateType, arginfo_TElDCAsyncState_get_StateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, set_StateType, arginfo_TElDCAsyncState_set_StateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, get_StateSubtypes, arginfo_TElDCAsyncState_get_StateSubtypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, get_UserData, arginfo_TElDCAsyncState_get_UserData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, set_UserData, arginfo_TElDCAsyncState_set_UserData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, get_Generator, arginfo_TElDCAsyncState_get_Generator, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, get_InnerState, arginfo_TElDCAsyncState_get_InnerState, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncState, __construct, arginfo_TElDCAsyncState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCAsyncState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCAsyncState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCAsyncState", TElDCAsyncState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCAsyncState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCAsyncStateCollection_ce_ptr = NULL;

SB_PHP_METHOD(TElDCAsyncStateCollection, Add)
{
	zend_bool bClone;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oState, TElDCAsyncState_ce_ptr, &bClone) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCAsyncStateCollection_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), (int8_t)bClone, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCAsyncState, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDCAsyncStateCollection_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDCAsyncStateCollection_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, FindState)
{
	SBArrayZValInfo aiUserData;
	zval *zaUserData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaUserData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaUserData)) || (IS_ARRAY == Z_TYPE_P(zaUserData)) || (IS_NULL == Z_TYPE_P(zaUserData))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaUserData, &aiUserData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCAsyncStateCollection_FindState(SBGetObjectHandle(getThis() TSRMLS_CC), aiUserData.data, aiUserData.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiUserData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, SaveToNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncStateCollection_SaveToNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, SaveToStream)
{
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncStateCollection_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, LoadFromNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElDCNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncStateCollection_LoadFromNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, LoadFromStream)
{
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCAsyncStateCollection_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, get_UserData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCAsyncStateCollection_get_UserData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1539652359, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, set_UserData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCAsyncStateCollection_set_UserData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, get_States)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncStateCollection_get_States(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCAsyncStateCollection_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCAsyncStateCollection, __construct)
{
	zend_bool bOwnsObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnsObjects) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCAsyncStateCollection_Create((int8_t)bOwnsObjects, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_Add, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
	ZEND_ARG_INFO(0, Clone)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_FindState, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, UserData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_SaveToNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElDCNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_LoadFromNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElDCNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_get_UserData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_set_UserData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_get_States, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCAsyncStateCollection___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, OwnsObjects)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCAsyncStateCollection_methods[] = {
	PHP_ME(TElDCAsyncStateCollection, Add, arginfo_TElDCAsyncStateCollection_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, Remove, arginfo_TElDCAsyncStateCollection_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, Clear, arginfo_TElDCAsyncStateCollection_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, FindState, arginfo_TElDCAsyncStateCollection_FindState, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, SaveToNode, arginfo_TElDCAsyncStateCollection_SaveToNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, SaveToStream, arginfo_TElDCAsyncStateCollection_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, LoadFromNode, arginfo_TElDCAsyncStateCollection_LoadFromNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, LoadFromStream, arginfo_TElDCAsyncStateCollection_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, get_UserData, arginfo_TElDCAsyncStateCollection_get_UserData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, set_UserData, arginfo_TElDCAsyncStateCollection_set_UserData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, get_States, arginfo_TElDCAsyncStateCollection_get_States, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, get_Count, arginfo_TElDCAsyncStateCollection_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCAsyncStateCollection, __construct, arginfo_TElDCAsyncStateCollection___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCAsyncStateCollection(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCAsyncStateCollection_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCAsyncStateCollection", TElDCAsyncStateCollection_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCAsyncStateCollection_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBDC, DCBoolToStr)
{
	uint32_t _err;
	zend_bool bB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bB) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBDC_DCBoolToStr((int8_t)bB, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1188342131, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDC, DCStrToBool)
{
	char *sS;
	int sS_len;
	zend_bool bDef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sS, &sS_len, &bDef) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBDC_DCStrToBool(sS, (int32_t)sS_len, (int8_t)bDef, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDC, DCBoolToByteArray)
{
	uint32_t _err;
	zend_bool bB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bB) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBDC_DCBoolToByteArray((int8_t)bB, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1929707623, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDC, DCByteArrayToBool)
{
	SBArrayZValInfo aiS;
	zend_bool bDef;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaS, &bDef) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBDC_DCByteArrayToBool(aiS.data, aiS.len, (int8_t)bDef, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

void Register_SBDC_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBDC, ERROR_FACILITY_DC, SB_ERROR_FACILITY_DC, SB_ERROR_FACILITY_DC);
	SB_REGISTER_LONG_CONSTANT(SBDC, SB_DC_ERROR_BAD_ASYNC_STATE, SB_DC_ERROR_BAD_ASYNC_STATE, SB_DC_ERROR_BAD_ASYNC_STATE);
	SB_REGISTER_LONG_CONSTANT(SBDC, SB_DC_ERROR_BAD_ASYNC_DATA, SB_DC_ERROR_BAD_ASYNC_DATA, SB_DC_ERROR_BAD_ASYNC_DATA);
	SB_REGISTER_LONG_CONSTANT(SBDC, SB_DC_ERROR_REMOTE_ERROR, SB_DC_ERROR_REMOTE_ERROR, SB_DC_ERROR_REMOTE_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBDC, SB_DC_ERROR_DC_MODULE_UNAVAILABLE, SB_DC_ERROR_DC_MODULE_UNAVAILABLE, SB_DC_ERROR_DC_MODULE_UNAVAILABLE);
	SB_REGISTER_STRING_CONSTANT(SBDC, SB_AST_STANDARD, SB_AST_STANDARD, SB_AST_STANDARD);
	SB_REGISTER_STRING_CONSTANT(SBDC, SB_ASST_PKCS1SIG, SB_ASST_PKCS1SIG, SB_ASST_PKCS1SIG);
	SB_REGISTER_STRING_CONSTANT(SBDC, SB_ASST_PKCS7SIG, SB_ASST_PKCS7SIG, SB_ASST_PKCS7SIG);
}

void Register_SBDC_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBDCOperation", NULL);
	TSBDCOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDCOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDCOperation_ce_ptr, "dcUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDCOperation_ce_ptr, "dcRawSign", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBDCOperation_ce_ptr, "dcPKCS7Sign", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBDCAsyncSignMethod", NULL);
	TSBDCAsyncSignMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDCAsyncSignMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDCAsyncSignMethod_ce_ptr, "asmPKCS1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDCAsyncSignMethod_ce_ptr, "asmPKCS7", 1)
}

void Register_SBDC_Aliases(TSRMLS_D)
{
	TElDCMessageClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElDCMessageClass", TElDCMessageClass_ce_ptr);
}
