#include "sbdccms.h"

void SB_CALLBACK TSBDCCMSPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElSignedCMSMessageHandle Msg)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMsg;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMsg);
	SBInitObject(zMsg, TElSignedCMSMessage_ce_ptr, Msg TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zMsg;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMsg);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBDCCMSTSPClientNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pTSPServiceID[], int32_t szTSPServiceID, TElCustomTSPClientHandle * TSPClient, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zTSPServiceID;
	zval * zTSPClient;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTSPServiceID);
	ZVAL_STRINGL(zTSPServiceID, pTSPServiceID, szTSPServiceID, 1);
	MAKE_STD_ZVAL(zTSPClient);
	SBInitObject(zTSPClient, TElCustomTSPClient_ce_ptr, *TSPClient TSRMLS_CC);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zTSPServiceID;
	params[2] = &zTSPClient;
	params[3] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTSPServiceID);
	*TSPClient = SBGetObjectHandleCE(zTSPClient, TElCustomTSPClient_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zTSPClient TSRMLS_CC);
	zval_ptr_dtor(&zTSPClient);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElDCCMSSignOperationHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElDCCMSSignOperationHandler, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCCMSSignOperationHandler_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCCMSSignOperationHandler, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCCMSSignOperationHandler_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCCMSSignOperationHandler, get_OnTSPClientNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDCCMSTSPClientNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDCCMSSignOperationHandler_get_OnTSPClientNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCCMSSignOperationHandler, set_OnTSPClientNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDCCMSSignOperationHandler_set_OnTSPClientNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDCCMSTSPClientNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDCCMSTSPClientNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCCMSSignOperationHandler, get_OnCMSPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDCCMSPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDCCMSSignOperationHandler_get_OnCMSPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCCMSSignOperationHandler, set_OnCMSPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDCCMSSignOperationHandler_set_OnCMSPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDCCMSPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDCCMSPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCCMSSignOperationHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCCMSSignOperationHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler_get_OnTSPClientNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler_set_OnTSPClientNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler_get_OnCMSPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler_set_OnCMSPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCCMSSignOperationHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCCMSSignOperationHandler_methods[] = {
	PHP_ME(TElDCCMSSignOperationHandler, get_CertStorage, arginfo_TElDCCMSSignOperationHandler_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCCMSSignOperationHandler, set_CertStorage, arginfo_TElDCCMSSignOperationHandler_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCCMSSignOperationHandler, get_OnTSPClientNeeded, arginfo_TElDCCMSSignOperationHandler_get_OnTSPClientNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCCMSSignOperationHandler, set_OnTSPClientNeeded, arginfo_TElDCCMSSignOperationHandler_set_OnTSPClientNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCCMSSignOperationHandler, get_OnCMSPrepared, arginfo_TElDCCMSSignOperationHandler_get_OnCMSPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCCMSSignOperationHandler, set_OnCMSPrepared, arginfo_TElDCCMSSignOperationHandler_set_OnCMSPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCCMSSignOperationHandler, __construct, arginfo_TElDCCMSSignOperationHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCCMSSignOperationHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCCMSSignOperationHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCCMSSignOperationHandler", TElDCCMSSignOperationHandler_methods);
	if (NULL == TElDCSignOperationHandler_ce_ptr)
		Register_TElDCSignOperationHandler(TSRMLS_C);
	TElDCCMSSignOperationHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElDCSignOperationHandler_ce_ptr, NULL TSRMLS_CC);
}

