#include "sbdcserver.h"

void SB_CALLBACK TSBDCSignRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pData[], int32_t szData, const uint8_t pHashAlg[], int32_t szHashAlg, int8_t IncludeKeys, TElRelativeDistinguishedNameHandle InputPars, TElRelativeDistinguishedNameHandle Keys, TElRelativeDistinguishedNameHandle OutputPars, uint8_t pSignResult[], int32_t * szSignResult)
{
	zval *retval_ptr;
	zval **params[8];
	zval * zSender;
	zval * zData;
	zval * zHashAlg;
	zval * zIncludeKeys;
	zval * zInputPars;
	zval * zKeys;
	zval * zOutputPars;
	zval * zSignResult;
	SBArrayZValInfo aiSignResult;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zData);
	ZVAL_STRINGL(zData, pData, szData, 1);
	MAKE_STD_ZVAL(zHashAlg);
	ZVAL_STRINGL(zHashAlg, pHashAlg, szHashAlg, 1);
	MAKE_STD_ZVAL(zIncludeKeys);
	ZVAL_BOOL(zIncludeKeys, (zend_bool)IncludeKeys);
	MAKE_STD_ZVAL(zInputPars);
	SBInitObject(zInputPars, TElRelativeDistinguishedName_ce_ptr, InputPars TSRMLS_CC);
	MAKE_STD_ZVAL(zKeys);
	SBInitObject(zKeys, TElRelativeDistinguishedName_ce_ptr, Keys TSRMLS_CC);
	MAKE_STD_ZVAL(zOutputPars);
	SBInitObject(zOutputPars, TElRelativeDistinguishedName_ce_ptr, OutputPars TSRMLS_CC);
	MAKE_STD_ZVAL(zSignResult);
	ZVAL_STRINGL(zSignResult, pSignResult, *szSignResult, 1);

	params[0] = &zSender;
	params[1] = &zData;
	params[2] = &zHashAlg;
	params[3] = &zIncludeKeys;
	params[4] = &zInputPars;
	params[5] = &zKeys;
	params[6] = &zOutputPars;
	params[7] = &zSignResult;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 8, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zData);
	zval_ptr_dtor(&zHashAlg);
	zval_ptr_dtor(&zIncludeKeys);
	zval_ptr_dtor(&zInputPars);
	zval_ptr_dtor(&zKeys);
	zval_ptr_dtor(&zOutputPars);
	if (SBGetByteArrayFromZVal(zSignResult, &aiSignResult TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(8, aiSignResult.data, aiSignResult.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiSignResult);
	zval_ptr_dtor(&zSignResult);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElDCOperationHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElDCOperationHandler, get_AcceptedOperationIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationHandler_get_AcceptedOperationIDs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCOperationHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCOperationHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationHandler_get_AcceptedOperationIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCOperationHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCOperationHandler_methods[] = {
	PHP_ME(TElDCOperationHandler, get_AcceptedOperationIDs, arginfo_TElDCOperationHandler_get_AcceptedOperationIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCOperationHandler, __construct, arginfo_TElDCOperationHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCOperationHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCOperationHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCOperationHandler", TElDCOperationHandler_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCOperationHandler_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCSignOperationHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElDCSignOperationHandler, get_OnSignRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDCSignRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElDCSignOperationHandler_get_OnSignRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCSignOperationHandler, set_OnSignRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElDCSignOperationHandler_set_OnSignRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDCSignRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDCSignRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCSignOperationHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCSignOperationHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCSignOperationHandler_get_OnSignRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCSignOperationHandler_set_OnSignRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCSignOperationHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCSignOperationHandler_methods[] = {
	PHP_ME(TElDCSignOperationHandler, get_OnSignRequest, arginfo_TElDCSignOperationHandler_get_OnSignRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCSignOperationHandler, set_OnSignRequest, arginfo_TElDCSignOperationHandler_set_OnSignRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCSignOperationHandler, __construct, arginfo_TElDCSignOperationHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCSignOperationHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCSignOperationHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCSignOperationHandler", TElDCSignOperationHandler_methods);
	if (NULL == TElDCOperationHandler_ce_ptr)
		Register_TElDCOperationHandler(TSRMLS_C);
	TElDCSignOperationHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElDCOperationHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCGenericSignOperationHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElDCGenericSignOperationHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCGenericSignOperationHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCGenericSignOperationHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCGenericSignOperationHandler_methods[] = {
	PHP_ME(TElDCGenericSignOperationHandler, __construct, arginfo_TElDCGenericSignOperationHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCGenericSignOperationHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCGenericSignOperationHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCGenericSignOperationHandler", TElDCGenericSignOperationHandler_methods);
	if (NULL == TElDCSignOperationHandler_ce_ptr)
		Register_TElDCSignOperationHandler(TSRMLS_C);
	TElDCGenericSignOperationHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElDCSignOperationHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCStandardServer_ce_ptr = NULL;

SB_PHP_METHOD(TElDCStandardServer, Process)
{
	zval *oInEncoding;
	zval *oInStream;
	zval *oOutEncoding;
	zval *oOutStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &oInEncoding, TElDCEncoding_ce_ptr, &oOutEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCStandardServer_Process(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), SBGetObjectHandle(oInEncoding TSRMLS_CC), SBGetObjectHandle(oOutEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, TElDCEncoding, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCStandardServer, AddOperationHandler)
{
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElDCOperationHandler_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCStandardServer_AddOperationHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCOperationHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCStandardServer, RemoveOperationHandler)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDCStandardServer_RemoveOperationHandler(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCStandardServer, ClearOperationHandlers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDCStandardServer_ClearOperationHandlers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCStandardServer, get_OperationHandlers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCStandardServer_get_OperationHandlers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCOperationHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCStandardServer, get_OperationHandlerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCStandardServer_get_OperationHandlerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCStandardServer, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCStandardServer_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer_Process, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, InStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, OutStream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, InEncoding, TElDCEncoding, 1)
	ZEND_ARG_OBJ_INFO(0, OutEncoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer_AddOperationHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElDCOperationHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer_RemoveOperationHandler, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer_ClearOperationHandlers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer_get_OperationHandlers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer_get_OperationHandlerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCStandardServer___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCStandardServer_methods[] = {
	PHP_ME(TElDCStandardServer, Process, arginfo_TElDCStandardServer_Process, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCStandardServer, AddOperationHandler, arginfo_TElDCStandardServer_AddOperationHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCStandardServer, RemoveOperationHandler, arginfo_TElDCStandardServer_RemoveOperationHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCStandardServer, ClearOperationHandlers, arginfo_TElDCStandardServer_ClearOperationHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCStandardServer, get_OperationHandlers, arginfo_TElDCStandardServer_get_OperationHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCStandardServer, get_OperationHandlerCount, arginfo_TElDCStandardServer_get_OperationHandlerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCStandardServer, __construct, arginfo_TElDCStandardServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCStandardServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCStandardServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCStandardServer", TElDCStandardServer_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCStandardServer_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}
