#include "sbdcxmlenc.h"

zend_class_entry *TElDCXMLEncoding_ce_ptr = NULL;

SB_PHP_METHOD(TElDCXMLEncoding, Encode)
{
	zval *oRoot;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oRoot, TElDCNode_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCXMLEncoding_Encode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRoot TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCXMLEncoding, Decode)
{
	long l4Count;
	zval *oRoot;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oRoot, TElDCNode_ce_ptr, &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDCXMLEncoding_Decode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRoot TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCXMLEncoding, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCXMLEncoding_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(4086254, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCXMLEncoding, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCXMLEncoding_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(550083170, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCXMLEncoding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCXMLEncoding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCXMLEncoding_Encode, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Root, TElDCNode, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCXMLEncoding_Decode, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Root, TElDCNode, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCXMLEncoding_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCXMLEncoding_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCXMLEncoding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCXMLEncoding_methods[] = {
	PHP_ME(TElDCXMLEncoding, Encode, arginfo_TElDCXMLEncoding_Encode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCXMLEncoding, Decode, arginfo_TElDCXMLEncoding_Decode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCXMLEncoding, GetName, arginfo_TElDCXMLEncoding_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCXMLEncoding, GetDescription, arginfo_TElDCXMLEncoding_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCXMLEncoding, __construct, arginfo_TElDCXMLEncoding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCXMLEncoding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCXMLEncoding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCXMLEncoding", TElDCXMLEncoding_methods);
	if (NULL == TElDCEncoding_ce_ptr)
		Register_TElDCEncoding(TSRMLS_C);
	TElDCXMLEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TElDCEncoding_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBDCXMLEnc, DCXMLEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBDCXMLEnc_DCXMLEncoding(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCEncoding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

