#include "sbecmath.h"

SB_PHP_FUNCTION(SBECMath, GetFieldByP)
{
	int32_t l4FieldRaw;
	int32_t l4FldTypeRaw;
	TLInt * proP;
	zval *oP;
	zval *zl4Field;
	zval *zl4FldType;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oP, TLInt_ce_ptr, &zl4Field, &zl4FldType) == SUCCESS) && PZVAL_IS_REF(oP) && PZVAL_IS_REF(zl4Field) && (IS_LONG == Z_TYPE_P(zl4Field)) && PZVAL_IS_REF(zl4FldType) && (IS_LONG == Z_TYPE_P(zl4FldType)))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		l4FieldRaw = (int32_t)Z_LVAL_P(zl4Field);
		l4FldTypeRaw = (int32_t)Z_LVAL_P(zl4FldType);
		SBCheckError(SBECMath_GetFieldByP(&proP, &l4FieldRaw, &l4FldTypeRaw) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
		ZVAL_LONG(zl4Field, (long)l4FieldRaw);
		ZVAL_LONG(zl4FldType, (long)l4FldTypeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, GetBinaryFieldK)
{
	int32_t l4K1Raw;
	int32_t l4K2Raw;
	int32_t l4K3Raw;
	int32_t l4MRaw;
	zval *oP;
	zval *zl4K1;
	zval *zl4K2;
	zval *zl4K3;
	zval *zl4M;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzzz", &oP, TLInt_ce_ptr, &zl4M, &zl4K1, &zl4K2, &zl4K3) == SUCCESS) && PZVAL_IS_REF(zl4M) && (IS_LONG == Z_TYPE_P(zl4M)) && PZVAL_IS_REF(zl4K1) && (IS_LONG == Z_TYPE_P(zl4K1)) && PZVAL_IS_REF(zl4K2) && (IS_LONG == Z_TYPE_P(zl4K2)) && PZVAL_IS_REF(zl4K3) && (IS_LONG == Z_TYPE_P(zl4K3)))
	{
		l4MRaw = (int32_t)Z_LVAL_P(zl4M);
		l4K1Raw = (int32_t)Z_LVAL_P(zl4K1);
		l4K2Raw = (int32_t)Z_LVAL_P(zl4K2);
		l4K3Raw = (int32_t)Z_LVAL_P(zl4K3);
		SBCheckError(SBECMath_GetBinaryFieldK((TLInt *)SBGetStructPointer(oP TSRMLS_CC), &l4MRaw, &l4K1Raw, &l4K2Raw, &l4K3Raw) TSRMLS_CC);
		ZVAL_LONG(zl4M, (long)l4MRaw);
		ZVAL_LONG(zl4K1, (long)l4K1Raw);
		ZVAL_LONG(zl4K2, (long)l4K2Raw);
		ZVAL_LONG(zl4K3, (long)l4K3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, &integer, &integer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, SetBinaryFieldK)
{
	long l4K1;
	long l4K2;
	long l4K3;
	long l4M;
	TLInt * proP;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ollll", &oP, TLInt_ce_ptr, &l4M, &l4K1, &l4K2, &l4K3) == SUCCESS) && PZVAL_IS_REF(oP))
	{
		proP = (TLInt *)SBGetStructPointer(oP TSRMLS_CC);
		SBCheckError(SBECMath_SetBinaryFieldK(&proP, (int32_t)l4M, (int32_t)l4K1, (int32_t)l4K2, (int32_t)l4K3) TSRMLS_CC);
		SBSetStructPointer(oP, proP, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpDecompress)
{
	long l4Field;
	long l4yp;
	TLInt * proY;
	zval *oA;
	zval *oB;
	zval *oP;
	zval *oX;
	zval *oY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!O!Ol", &l4yp, &oX, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oY))
	{
		int8_t bOutResultRaw = 0;
		proY = (TLInt *)SBGetStructPointer(oY TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpDecompress((int32_t)l4yp, (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proY, (int32_t)l4Field, &bOutResultRaw) TSRMLS_CC);
		SBSetStructPointer(oY, proY, sizeof(TLInt) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TLInt, TLInt, TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPDecompress)
{
	long l4Field;
	long l4yp;
	TLInt * proY;
	zval *oA;
	zval *oB;
	zval *oP;
	zval *oX;
	zval *oY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!O!Ol", &l4yp, &oX, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oY))
	{
		int8_t bOutResultRaw = 0;
		proY = (TLInt *)SBGetStructPointer(oY TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPDecompress((int32_t)l4yp, (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proY, (int32_t)l4Field, &bOutResultRaw) TSRMLS_CC);
		SBSetStructPointer(oY, proY, sizeof(TLInt) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TLInt, TLInt, TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPGetYpBit)
{
	long l4Field;
	zval *oP;
	zval *oX;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!l", &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &l4Field) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBECMath_ECPF2mPGetYpBit((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (int32_t)l4Field, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpZero)
{
	TLInt * proA;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_FpZero(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC)) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpOne)
{
	TLInt * proA;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_FpOne(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC)) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpInt)
{
	long u4C;
	TLInt * proA;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!l", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &u4C) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_FpInt(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (uint32_t)u4C) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpCmp)
{
	zval *oA;
	zval *oB;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBECMath_FpCmp((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpAdd)
{
	TLInt * proC;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpAdd((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpSub)
{
	TLInt * proC;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpSub((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpIsOne)
{
	zval *oA;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBECMath_FpIsOne((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpIsZero)
{
	zval *oA;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBECMath_FpIsZero((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpReduce)
{
	long l4Field;
	TLInt * proA;
	zval *oA;
	zval *oP;
	zval *oT1;
	zval *oT2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!O!O!l", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oT1, TLInt_ce_ptr, &oT2, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_FpReduce(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oT1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oT2 TSRMLS_CC), (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt, TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpMul)
{
	long l4Field;
	TLInt * proC;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	zval *oT1;
	zval *oT2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!Ol", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oT1, TLInt_ce_ptr, &oT2, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpMul((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oT1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oT2 TSRMLS_CC), &proC, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpSqr)
{
	long l4Field;
	TLInt * proC;
	zval *oA;
	zval *oC;
	zval *oP;
	zval *oT1;
	zval *oT2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!Ol", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oT1, TLInt_ce_ptr, &oT2, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpSqr((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oT1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oT2 TSRMLS_CC), &proC, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpDiv2)
{
	TLInt * proC;
	zval *oA;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpDiv2((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpInv)
{
	long l4Field;
	TLInt * proC;
	zval *oA;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!Ol", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpInv((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, FpDiv)
{
	long l4Field;
	TLInt * proC;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!Ol", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_FpDiv((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPZero)
{
	TLInt * proA;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_F2mPZero(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC)) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPOne)
{
	TLInt * proA;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_F2mPOne(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC)) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPIsZero)
{
	zval *oA;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBECMath_F2mPIsZero((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPIsOne)
{
	zval *oA;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBECMath_F2mPIsOne((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPCmp)
{
	zval *oA;
	zval *oB;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBECMath_F2mPCmp((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPAdd)
{
	TLInt * proC;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_F2mPAdd((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPReduce)
{
	long l4Field;
	TLInt * proA;
	zval *oA;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!l", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		proA = (TLInt *)SBGetStructPointer(oA TSRMLS_CC);
		SBCheckError(SBECMath_F2mPReduce(&proA, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oA, proA, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPMul)
{
	long l4Field;
	TLInt * proC;
	TLInt * proT1;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	zval *oT1;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!OOl", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oT1, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oT1) && PZVAL_IS_REF(oC))
	{
		proT1 = (TLInt *)SBGetStructPointer(oT1 TSRMLS_CC);
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_F2mPMul((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proT1, &proC, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oT1, proT1, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPSqr)
{
	long l4Field;
	TLInt * proC;
	zval *oA;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!Ol", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_F2mPSqr((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPDivX)
{
	TLInt * proC;
	zval *oA;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_F2mPDivX((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPDiv)
{
	TLInt * proC;
	zval *oA;
	zval *oB;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O", &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_F2mPDiv((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, F2mPInv)
{
	TLInt * proC;
	zval *oA;
	zval *oC;
	zval *oP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O", &oA, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oC, TLInt_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oC))
	{
		proC = (TLInt *)SBGetStructPointer(oC TSRMLS_CC);
		SBCheckError(SBECMath_F2mPInv((TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proC) TSRMLS_CC);
		SBSetStructPointer(oC, proC, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, &TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpDouble)
{
	long l4Field;
	TLInt * prox3;
	TLInt * proy3;
	zval *oA;
	zval *oP;
	zval *ox1;
	zval *ox3;
	zval *oy1;
	zval *oy3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &ox3, TLInt_ce_ptr, &oy3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(ox3) && PZVAL_IS_REF(oy3))
	{
		prox3 = (TLInt *)SBGetStructPointer(ox3 TSRMLS_CC);
		proy3 = (TLInt *)SBGetStructPointer(oy3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpDouble((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), &prox3, &proy3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(ox3, prox3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oy3, proy3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpAdd)
{
	long l4Field;
	TLInt * prox3;
	TLInt * proy3;
	zval *oA;
	zval *oP;
	zval *ox1;
	zval *ox2;
	zval *ox3;
	zval *oy1;
	zval *oy2;
	zval *oy3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &ox2, TLInt_ce_ptr, &oy2, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &ox3, TLInt_ce_ptr, &oy3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(ox3) && PZVAL_IS_REF(oy3))
	{
		prox3 = (TLInt *)SBGetStructPointer(ox3 TSRMLS_CC);
		proy3 = (TLInt *)SBGetStructPointer(oy3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpAdd((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(ox2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), &prox3, &proy3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(ox3, prox3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oy3, proy3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpJDouble)
{
	long l4Field;
	TLInt * proX3;
	TLInt * proY3;
	TLInt * proZ3;
	zval *oA;
	zval *oP;
	zval *oX1;
	zval *oX3;
	zval *oY1;
	zval *oY3;
	zval *oZ1;
	zval *oZ3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!OOOl", &oX1, TLInt_ce_ptr, &oY1, TLInt_ce_ptr, &oZ1, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oX3, TLInt_ce_ptr, &oY3, TLInt_ce_ptr, &oZ3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oX3) && PZVAL_IS_REF(oY3) && PZVAL_IS_REF(oZ3))
	{
		proX3 = (TLInt *)SBGetStructPointer(oX3 TSRMLS_CC);
		proY3 = (TLInt *)SBGetStructPointer(oY3 TSRMLS_CC);
		proZ3 = (TLInt *)SBGetStructPointer(oZ3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpJDouble((TLInt *)SBGetStructPointer(oX1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oY1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proX3, &proY3, &proZ3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oX3, proX3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oY3, proY3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oZ3, proZ3, sizeof(TLInt) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!OOOl", &oX1, TLInt_ce_ptr, &oY1, TLInt_ce_ptr, &oZ1, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oX3, TLInt_ce_ptr, &oY3, TLInt_ce_ptr, &oZ3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oX3) && PZVAL_IS_REF(oY3) && PZVAL_IS_REF(oZ3))
	{
		proX3 = (TLInt *)SBGetStructPointer(oX3 TSRMLS_CC);
		proY3 = (TLInt *)SBGetStructPointer(oY3 TSRMLS_CC);
		proZ3 = (TLInt *)SBGetStructPointer(oZ3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpJDouble_1((TLInt *)SBGetStructPointer(oX1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oY1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), &proX3, &proY3, &proZ3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oX3, proX3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oY3, proY3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oZ3, proZ3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, &TLInt, integer) or (TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpJAAdd)
{
	long l4Field;
	TLInt * proX3;
	TLInt * proY3;
	TLInt * proZ3;
	zval *oP;
	zval *oX1;
	zval *ox2;
	zval *oX3;
	zval *oY1;
	zval *oy2;
	zval *oY3;
	zval *oZ1;
	zval *oZ3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!OOOl", &oX1, TLInt_ce_ptr, &oY1, TLInt_ce_ptr, &oZ1, TLInt_ce_ptr, &ox2, TLInt_ce_ptr, &oy2, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oX3, TLInt_ce_ptr, &oY3, TLInt_ce_ptr, &oZ3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oX3) && PZVAL_IS_REF(oY3) && PZVAL_IS_REF(oZ3))
	{
		proX3 = (TLInt *)SBGetStructPointer(oX3 TSRMLS_CC);
		proY3 = (TLInt *)SBGetStructPointer(oY3 TSRMLS_CC);
		proZ3 = (TLInt *)SBGetStructPointer(oZ3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpJAAdd((TLInt *)SBGetStructPointer(oX1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oY1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ1 TSRMLS_CC), (TLInt *)SBGetStructPointer(ox2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proX3, &proY3, &proZ3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oX3, proX3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oY3, proY3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oZ3, proZ3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpExpJA)
{
	long l4Field;
	TLInt * proxr;
	TLInt * proyr;
	zval *oA;
	zval *on;
	zval *oP;
	zval *ox1;
	zval *oxr;
	zval *oy1;
	zval *oyr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &on, TLInt_ce_ptr, &oxr, TLInt_ce_ptr, &oyr, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oxr) && PZVAL_IS_REF(oyr))
	{
		proxr = (TLInt *)SBGetStructPointer(oxr TSRMLS_CC);
		proyr = (TLInt *)SBGetStructPointer(oyr TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpExpJA((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(on TSRMLS_CC), &proxr, &proyr, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oxr, proxr, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oyr, proyr, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpExp)
{
	long l4Field;
	TLInt * proxr;
	TLInt * proyr;
	zval *oA;
	zval *on;
	zval *oP;
	zval *ox1;
	zval *oxr;
	zval *oy1;
	zval *oyr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &on, TLInt_ce_ptr, &oxr, TLInt_ce_ptr, &oyr, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oxr) && PZVAL_IS_REF(oyr))
	{
		proxr = (TLInt *)SBGetStructPointer(oxr TSRMLS_CC);
		proyr = (TLInt *)SBGetStructPointer(oyr TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpExp((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(on TSRMLS_CC), &proxr, &proyr, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oxr, proxr, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oyr, proyr, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpJ2A)
{
	long l4Field;
	TLInt * proxr;
	TLInt * proyr;
	zval *oP;
	zval *oX;
	zval *oxr;
	zval *oY;
	zval *oyr;
	zval *oZ;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!OOl", &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oZ, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oxr, TLInt_ce_ptr, &oyr, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oxr) && PZVAL_IS_REF(oyr))
	{
		proxr = (TLInt *)SBGetStructPointer(oxr TSRMLS_CC);
		proyr = (TLInt *)SBGetStructPointer(oyr TSRMLS_CC);
		SBCheckError(SBECMath_ECPFpJ2A((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proxr, &proyr, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oxr, proxr, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oyr, proyr, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPFpPointOnCurve)
{
	long l4Field;
	zval *oA;
	zval *oB;
	zval *oP;
	zval *oX;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!l", &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &l4Field) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBECMath_ECPFpPointOnCurve((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (int32_t)l4Field, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPDouble)
{
	long l4Field;
	TLInt * prox3;
	TLInt * proy3;
	zval *oa;
	zval *ob;
	zval *oP;
	zval *ox1;
	zval *ox3;
	zval *oy1;
	zval *oy3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &oa, TLInt_ce_ptr, &ob, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &ox3, TLInt_ce_ptr, &oy3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(ox3) && PZVAL_IS_REF(oy3))
	{
		prox3 = (TLInt *)SBGetStructPointer(ox3 TSRMLS_CC);
		proy3 = (TLInt *)SBGetStructPointer(oy3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPDouble((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oa TSRMLS_CC), (TLInt *)SBGetStructPointer(ob TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &prox3, &proy3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(ox3, prox3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oy3, proy3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPAdd)
{
	long l4Field;
	TLInt * prox3;
	TLInt * proy3;
	zval *oa;
	zval *ob;
	zval *oP;
	zval *ox1;
	zval *ox2;
	zval *ox3;
	zval *oy1;
	zval *oy2;
	zval *oy3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &ox2, TLInt_ce_ptr, &oy2, TLInt_ce_ptr, &oa, TLInt_ce_ptr, &ob, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &ox3, TLInt_ce_ptr, &oy3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(ox3) && PZVAL_IS_REF(oy3))
	{
		prox3 = (TLInt *)SBGetStructPointer(ox3 TSRMLS_CC);
		proy3 = (TLInt *)SBGetStructPointer(oy3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPAdd((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(ox2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oa TSRMLS_CC), (TLInt *)SBGetStructPointer(ob TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &prox3, &proy3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(ox3, prox3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oy3, proy3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPLDDouble)
{
	long l4Field;
	TLInt * proX3;
	TLInt * proY3;
	TLInt * proZ3;
	zval *oa;
	zval *ob;
	zval *oP;
	zval *oX1;
	zval *oX3;
	zval *oY1;
	zval *oY3;
	zval *oZ1;
	zval *oZ3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!OOOl", &oX1, TLInt_ce_ptr, &oY1, TLInt_ce_ptr, &oZ1, TLInt_ce_ptr, &oa, TLInt_ce_ptr, &ob, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oX3, TLInt_ce_ptr, &oY3, TLInt_ce_ptr, &oZ3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oX3) && PZVAL_IS_REF(oY3) && PZVAL_IS_REF(oZ3))
	{
		proX3 = (TLInt *)SBGetStructPointer(oX3 TSRMLS_CC);
		proY3 = (TLInt *)SBGetStructPointer(oY3 TSRMLS_CC);
		proZ3 = (TLInt *)SBGetStructPointer(oZ3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPLDDouble((TLInt *)SBGetStructPointer(oX1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oY1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oa TSRMLS_CC), (TLInt *)SBGetStructPointer(ob TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proX3, &proY3, &proZ3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oX3, proX3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oY3, proY3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oZ3, proZ3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPLDAAdd)
{
	long l4Field;
	TLInt * proX3;
	TLInt * proY3;
	TLInt * proZ3;
	zval *oa;
	zval *ob;
	zval *oP;
	zval *oX1;
	zval *ox2;
	zval *oX3;
	zval *oY1;
	zval *oy2;
	zval *oY3;
	zval *oZ1;
	zval *oZ3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!O!O!OOOl", &oX1, TLInt_ce_ptr, &oY1, TLInt_ce_ptr, &oZ1, TLInt_ce_ptr, &ox2, TLInt_ce_ptr, &oy2, TLInt_ce_ptr, &oa, TLInt_ce_ptr, &ob, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oX3, TLInt_ce_ptr, &oY3, TLInt_ce_ptr, &oZ3, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oX3) && PZVAL_IS_REF(oY3) && PZVAL_IS_REF(oZ3))
	{
		proX3 = (TLInt *)SBGetStructPointer(oX3 TSRMLS_CC);
		proY3 = (TLInt *)SBGetStructPointer(oY3 TSRMLS_CC);
		proZ3 = (TLInt *)SBGetStructPointer(oZ3 TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPLDAAdd((TLInt *)SBGetStructPointer(oX1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oY1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ1 TSRMLS_CC), (TLInt *)SBGetStructPointer(ox2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oa TSRMLS_CC), (TLInt *)SBGetStructPointer(ob TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proX3, &proY3, &proZ3, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oX3, proX3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oY3, proY3, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oZ3, proZ3, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPExpLDA)
{
	long l4Field;
	TLInt * proxr;
	TLInt * proyr;
	zval *oa;
	zval *ob;
	zval *on;
	zval *oP;
	zval *ox1;
	zval *oxr;
	zval *oy1;
	zval *oyr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &oa, TLInt_ce_ptr, &ob, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &on, TLInt_ce_ptr, &oxr, TLInt_ce_ptr, &oyr, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oxr) && PZVAL_IS_REF(oyr))
	{
		proxr = (TLInt *)SBGetStructPointer(oxr TSRMLS_CC);
		proyr = (TLInt *)SBGetStructPointer(oyr TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPExpLDA((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oa TSRMLS_CC), (TLInt *)SBGetStructPointer(ob TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(on TSRMLS_CC), &proxr, &proyr, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oxr, proxr, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oyr, proyr, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPExp)
{
	long l4Field;
	TLInt * proxr;
	TLInt * proyr;
	zval *oa;
	zval *ob;
	zval *on;
	zval *oP;
	zval *ox1;
	zval *oxr;
	zval *oy1;
	zval *oyr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!OOl", &ox1, TLInt_ce_ptr, &oy1, TLInt_ce_ptr, &oa, TLInt_ce_ptr, &ob, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &on, TLInt_ce_ptr, &oxr, TLInt_ce_ptr, &oyr, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oxr) && PZVAL_IS_REF(oyr))
	{
		proxr = (TLInt *)SBGetStructPointer(oxr TSRMLS_CC);
		proyr = (TLInt *)SBGetStructPointer(oyr TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPExp((TLInt *)SBGetStructPointer(ox1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oy1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oa TSRMLS_CC), (TLInt *)SBGetStructPointer(ob TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(on TSRMLS_CC), &proxr, &proyr, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oxr, proxr, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oyr, proyr, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPLD2A)
{
	long l4Field;
	TLInt * proxr;
	TLInt * proyr;
	zval *oP;
	zval *oX;
	zval *oxr;
	zval *oY;
	zval *oyr;
	zval *oZ;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!OOl", &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oZ, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oxr, TLInt_ce_ptr, &oyr, TLInt_ce_ptr, &l4Field) == SUCCESS) && PZVAL_IS_REF(oxr) && PZVAL_IS_REF(oyr))
	{
		proxr = (TLInt *)SBGetStructPointer(oxr TSRMLS_CC);
		proyr = (TLInt *)SBGetStructPointer(oyr TSRMLS_CC);
		SBCheckError(SBECMath_ECPF2mPLD2A((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oZ TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), &proxr, &proyr, (int32_t)l4Field) TSRMLS_CC);
		SBSetStructPointer(oxr, proxr, sizeof(TLInt) TSRMLS_CC);
		SBSetStructPointer(oyr, proyr, sizeof(TLInt) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, &TLInt, &TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, ECPF2mPPointOnCurve)
{
	long l4Field;
	zval *oA;
	zval *oB;
	zval *oP;
	zval *oX;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!l", &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &l4Field) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBECMath_ECPF2mPPointOnCurve((TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (int32_t)l4Field, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBECMath, CryptoScalarMult)
{
	SBArrayZValInfo aiN;
	SBArrayZValInfo aiP;
	SBArrayZValInfo aiQ;
	zval *zaN;
	zval *zaP;
	zval *zaQ;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zaN, &zaP, &zaQ) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaN)) || (IS_ARRAY == Z_TYPE_P(zaN)) || (IS_NULL == Z_TYPE_P(zaN))) && ((IS_STRING == Z_TYPE_P(zaP)) || (IS_ARRAY == Z_TYPE_P(zaP)) || (IS_NULL == Z_TYPE_P(zaP))) && ((IS_STRING == Z_TYPE_P(zaQ)) || (IS_ARRAY == Z_TYPE_P(zaQ)) || (IS_NULL == Z_TYPE_P(zaQ))))
	{
		if (!SBGetByteArrayFromZVal(zaN, &aiN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaP, &aiP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaQ, &aiQ TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBECMath_CryptoScalarMult(aiN.data, aiN.len, aiP.data, aiP.len, aiQ.data, aiQ.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiN);
		SBFreeArrayZValInfo(&aiP);
		SBFreeArrayZValInfo(&aiQ);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

