#include "sbgost2814789.h"

zend_class_entry *TElGOSTMode_ce_ptr = NULL;

zend_class_entry *TElGOST_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST, BlockSize_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGOST_BlockSize_1(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, BlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGOST_BlockSize(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, KeySize_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGOST_KeySize_1(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGOST_KeySize(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, Clone)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGOSTBase_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGOSTBase)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, Encrypt_Block)
{
	int32_t l4Out_LenRaw = 0;
	long l4In_Len;
	long l4In_StartIdx;
	long l4Out_StartIdx;
	SBArrayZValInfo aiInBuf;
	SBArrayZValInfo aiOutBuf;
	uint32_t _err;
	zval *zaInBuf;
	zval *zaOutBuf;
	zval *zl4Out_Len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzzl", &zaInBuf, &l4In_StartIdx, &l4In_Len, &zaOutBuf, &zl4Out_Len, &l4Out_StartIdx) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4Out_Len) && (IS_LONG == Z_TYPE_P(zl4Out_Len)))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_Encrypt_Block(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, (int32_t)l4In_StartIdx, (int32_t)l4In_Len, aiOutBuf.data, &aiOutBuf.len, &l4Out_LenRaw, (int32_t)l4Out_StartIdx);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(78299221, 4, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
		ZVAL_LONG(zl4Out_Len, (long)l4Out_LenRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &array of byte|string, &integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, Decrypt_Block)
{
	int32_t l4Out_LenRaw = 0;
	long l4In_Len;
	long l4In_StartIdx;
	long l4Out_StartIdx;
	SBArrayZValInfo aiInBuf;
	SBArrayZValInfo aiOutBuf;
	uint32_t _err;
	zval *zaInBuf;
	zval *zaOutBuf;
	zval *zl4Out_Len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzzl", &zaInBuf, &l4In_StartIdx, &l4In_Len, &zaOutBuf, &zl4Out_Len, &l4Out_StartIdx) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4Out_Len) && (IS_LONG == Z_TYPE_P(zl4Out_Len)))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_Decrypt_Block(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, (int32_t)l4In_StartIdx, (int32_t)l4In_Len, aiOutBuf.data, &aiOutBuf.len, &l4Out_LenRaw, (int32_t)l4Out_StartIdx);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1442324031, 4, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
		ZVAL_LONG(zl4Out_Len, (long)l4Out_LenRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &array of byte|string, &integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, Encrypt_Finalize)
{
	int32_t l4Out_LenRaw = 0;
	long l4Out_StartIdx;
	SBArrayZValInfo aiOutBuf;
	uint32_t _err;
	zval *zaOutBuf;
	zval *zl4Out_Len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaOutBuf, &zl4Out_Len, &l4Out_StartIdx) == SUCCESS) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4Out_Len) && (IS_LONG == Z_TYPE_P(zl4Out_Len)))
	{
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_Encrypt_Finalize(SBGetObjectHandle(getThis() TSRMLS_CC), aiOutBuf.data, &aiOutBuf.len, &l4Out_LenRaw, (int32_t)l4Out_StartIdx);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-2106255286, 1, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
		ZVAL_LONG(zl4Out_Len, (long)l4Out_LenRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, Decrypt_Finalize)
{
	int32_t l4Out_LenRaw = 0;
	long l4Out_StartIdx;
	SBArrayZValInfo aiOutBuf;
	uint32_t _err;
	zval *zaOutBuf;
	zval *zl4Out_Len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaOutBuf, &zl4Out_Len, &l4Out_StartIdx) == SUCCESS) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4Out_Len) && (IS_LONG == Z_TYPE_P(zl4Out_Len)))
	{
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_Decrypt_Finalize(SBGetObjectHandle(getThis() TSRMLS_CC), aiOutBuf.data, &aiOutBuf.len, &l4Out_LenRaw, (int32_t)l4Out_StartIdx);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-314958895, 1, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
		ZVAL_LONG(zl4Out_Len, (long)l4Out_LenRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, EncryptBuf)
{
	int32_t l4Out_LenRaw = 0;
	long l4In_Len;
	long l4In_StartIdx;
	long l4Out_StartIdx;
	SBArrayZValInfo aiInBuf;
	SBArrayZValInfo aiOutBuf;
	uint32_t _err;
	zval *zaInBuf;
	zval *zaOutBuf;
	zval *zl4Out_Len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzzl", &zaInBuf, &l4In_StartIdx, &l4In_Len, &zaOutBuf, &zl4Out_Len, &l4Out_StartIdx) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4Out_Len) && (IS_LONG == Z_TYPE_P(zl4Out_Len)))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_EncryptBuf(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, (int32_t)l4In_StartIdx, (int32_t)l4In_Len, aiOutBuf.data, &aiOutBuf.len, &l4Out_LenRaw, (int32_t)l4Out_StartIdx);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-202440874, 4, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
		ZVAL_LONG(zl4Out_Len, (long)l4Out_LenRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaInBuf, &zaOutBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_EncryptBuf_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, aiOutBuf.data, &aiOutBuf.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1005220696, 2, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &array of byte|string, &integer, integer) or (array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, DecryptBuf)
{
	int32_t l4Out_LenRaw = 0;
	long l4In_Len;
	long l4In_StartIdx;
	long l4Out_StartIdx;
	SBArrayZValInfo aiInBuf;
	SBArrayZValInfo aiOutBuf;
	uint32_t _err;
	zval *zaInBuf;
	zval *zaOutBuf;
	zval *zl4Out_Len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzzl", &zaInBuf, &l4In_StartIdx, &l4In_Len, &zaOutBuf, &zl4Out_Len, &l4Out_StartIdx) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))) && PZVAL_IS_REF(zl4Out_Len) && (IS_LONG == Z_TYPE_P(zl4Out_Len)))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_DecryptBuf(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, (int32_t)l4In_StartIdx, (int32_t)l4In_Len, aiOutBuf.data, &aiOutBuf.len, &l4Out_LenRaw, (int32_t)l4Out_StartIdx);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(275298653, 4, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
		ZVAL_LONG(zl4Out_Len, (long)l4Out_LenRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaInBuf, &zaOutBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))) && PZVAL_IS_REF(zaOutBuf) && ((IS_STRING == Z_TYPE_P(zaOutBuf)) || (IS_ARRAY == Z_TYPE_P(zaOutBuf))))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutBuf, &aiOutBuf TSRMLS_CC)) RETURN_FALSE;
		_err = TElGOST_DecryptBuf_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, aiOutBuf.data, &aiOutBuf.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutBuf, &aiOutBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(816127140, 2, aiOutBuf.data, &aiOutBuf.len) TSRMLS_CC);
			((char *)aiOutBuf.data)[aiOutBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInBuf);
		SBSetByteArrayToZVal(&aiOutBuf, zaOutBuf);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &array of byte|string, &integer, integer) or (array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, EncryptStream)
{
	long u4Count;
	zval *oDest;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oSource, TStream_ce_ptr, &u4Count, &oDest, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST_EncryptStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (uint32_t)u4Count, SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, DecryptStream)
{
	long u4Count;
	zval *oDest;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oSource, TStream_ce_ptr, &u4Count, &oDest, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST_DecryptStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (uint32_t)u4Count, SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, MAC_Block)
{
	long l4In_Len;
	long l4In_StartIdx;
	SBArrayZValInfo aiInBuf;
	SBArrayZValInfo piInBuf;
	zval *zaInBuf;
	zval *zpInBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpInBuf, &l4In_Len) == SUCCESS) && ((Z_TYPE_P(zpInBuf) == IS_STRING) || (Z_TYPE_P(zpInBuf) == IS_ARRAY) || (Z_TYPE_P(zpInBuf) == IS_NULL) || ((Z_TYPE_P(zpInBuf) == IS_OBJECT) && (Z_OBJCE_P(zpInBuf) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuf, &piInBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST_MAC_Block(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuf.data, (int32_t)l4In_Len) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuf);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaInBuf, &l4In_StartIdx, &l4In_Len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInBuf)) || (IS_ARRAY == Z_TYPE_P(zaInBuf)) || (IS_NULL == Z_TYPE_P(zaInBuf))))
	{
		if (!SBGetByteArrayFromZVal(zaInBuf, &aiInBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST_MAC_Block_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiInBuf.data, aiInBuf.len, (int32_t)l4In_StartIdx, (int32_t)l4In_Len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiInBuf);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, MAC_Finalize)
{
	long l4Qnt_Bits;
	SBArrayZValInfo aiMAC;
	uint32_t _err;
	zval *zaMAC;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Qnt_Bits, &zaMAC) == SUCCESS) && PZVAL_IS_REF(zaMAC) && ((IS_STRING == Z_TYPE_P(zaMAC)) || (IS_ARRAY == Z_TYPE_P(zaMAC))))
	{
		SBInitArrayZValInfo(&aiMAC);
		_err = TElGOST_MAC_Finalize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Qnt_Bits, aiMAC.data, &aiMAC.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMAC, &aiMAC TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(709150818, 2, aiMAC.data, &aiMAC.len) TSRMLS_CC);
			((char *)aiMAC.data)[aiMAC.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMAC);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiMAC, zaMAC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, MAC_Stream)
{
	long l4Qnt_Bits;
	long u4Count;
	SBArrayZValInfo aiMAC;
	uint32_t _err;
	zval *oSource;
	zval *zaMAC;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llz", &oSource, TStream_ce_ptr, &u4Count, &l4Qnt_Bits, &zaMAC) == SUCCESS) && PZVAL_IS_REF(zaMAC) && ((IS_STRING == Z_TYPE_P(zaMAC)) || (IS_ARRAY == Z_TYPE_P(zaMAC))))
	{
		SBInitArrayZValInfo(&aiMAC);
		_err = TElGOST_MAC_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (uint32_t)u4Count, (int32_t)l4Qnt_Bits, aiMAC.data, &aiMAC.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMAC, &aiMAC TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1559102780, 4, aiMAC.data, &aiMAC.len) TSRMLS_CC);
			((char *)aiMAC.data)[aiMAC.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMAC);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiMAC, zaMAC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, get_Key)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST_get_Key(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(284135723, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, set_Key)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST_set_Key(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, get_IV)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST_get_IV(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1207078281, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, set_IV)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST_set_IV(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElGOSTModeRaw fOutResultRaw = 0;
		SBCheckError(TElGOST_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, set_Mode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGOST_set_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (TElGOSTModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST, __construct)
{
	zval *oSubstBlock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oSubstBlock, TElGostSubstBlock_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST_Create_1((TElGostSubstBlock *)SBGetStructPointer(oSubstBlock TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElGostSubstBlock)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_BlockSize_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_BlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_KeySize_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGOSTBase, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_Encrypt_Block, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, InBuf, 0, 1)
	ZEND_ARG_INFO(0, In_StartIdx)
	ZEND_ARG_INFO(0, In_Len)
	ZEND_ARG_INFO(1, OutBuf)
	ZEND_ARG_INFO(1, Out_Len)
	ZEND_ARG_INFO(0, Out_StartIdx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_Decrypt_Block, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, InBuf, 0, 1)
	ZEND_ARG_INFO(0, In_StartIdx)
	ZEND_ARG_INFO(0, In_Len)
	ZEND_ARG_INFO(1, OutBuf)
	ZEND_ARG_INFO(1, Out_Len)
	ZEND_ARG_INFO(0, Out_StartIdx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_Encrypt_Finalize, 0, 0, 3)
	ZEND_ARG_INFO(1, OutBuf)
	ZEND_ARG_INFO(1, Out_Len)
	ZEND_ARG_INFO(0, Out_StartIdx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_Decrypt_Finalize, 0, 0, 3)
	ZEND_ARG_INFO(1, OutBuf)
	ZEND_ARG_INFO(1, Out_Len)
	ZEND_ARG_INFO(0, Out_StartIdx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_EncryptBuf, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuf, 0, 1)
	ZEND_ARG_INFO(1, In_StartIdx_or_OutBuf)
	ZEND_ARG_INFO(0, In_Len)
	ZEND_ARG_INFO(1, OutBuf)
	ZEND_ARG_INFO(1, Out_Len)
	ZEND_ARG_INFO(0, Out_StartIdx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_DecryptBuf, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuf, 0, 1)
	ZEND_ARG_INFO(1, In_StartIdx_or_OutBuf)
	ZEND_ARG_INFO(0, In_Len)
	ZEND_ARG_INFO(1, OutBuf)
	ZEND_ARG_INFO(1, Out_Len)
	ZEND_ARG_INFO(0, Out_StartIdx)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_EncryptStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Source, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_OBJ_INFO(0, Dest, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_DecryptStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Source, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_OBJ_INFO(0, Dest, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_MAC_Block, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuf, 0, 1)
	ZEND_ARG_INFO(0, In_Len_or_In_StartIdx)
	ZEND_ARG_INFO(0, In_Len)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_MAC_Finalize, 0, 0, 2)
	ZEND_ARG_INFO(0, Qnt_Bits)
	ZEND_ARG_INFO(1, MAC)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_MAC_Stream, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Source, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, Qnt_Bits)
	ZEND_ARG_INFO(1, MAC)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_get_Key, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_set_Key, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_get_IV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_set_IV, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST_set_Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, SubstBlock, TElGostSubstBlock, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST_methods[] = {
	PHP_ME(TElGOST, BlockSize_Inst, arginfo_TElGOST_BlockSize_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, BlockSize, arginfo_TElGOST_BlockSize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOST, KeySize_Inst, arginfo_TElGOST_KeySize_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, KeySize, arginfo_TElGOST_KeySize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOST, Reset, arginfo_TElGOST_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, Clone, arginfo_TElGOST_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, Encrypt_Block, arginfo_TElGOST_Encrypt_Block, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, Decrypt_Block, arginfo_TElGOST_Decrypt_Block, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, Encrypt_Finalize, arginfo_TElGOST_Encrypt_Finalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, Decrypt_Finalize, arginfo_TElGOST_Decrypt_Finalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, EncryptBuf, arginfo_TElGOST_EncryptBuf, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, DecryptBuf, arginfo_TElGOST_DecryptBuf, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, EncryptStream, arginfo_TElGOST_EncryptStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, DecryptStream, arginfo_TElGOST_DecryptStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, MAC_Block, arginfo_TElGOST_MAC_Block, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, MAC_Finalize, arginfo_TElGOST_MAC_Finalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, MAC_Stream, arginfo_TElGOST_MAC_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, get_Key, arginfo_TElGOST_get_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, set_Key, arginfo_TElGOST_set_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, get_IV, arginfo_TElGOST_get_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, set_IV, arginfo_TElGOST_set_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, get_Mode, arginfo_TElGOST_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, set_Mode, arginfo_TElGOST_set_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST, __construct, arginfo_TElGOST___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST", TElGOST_methods);
	if (NULL == TElGOSTBase_ce_ptr)
		Register_TElGOSTBase(TSRMLS_C);
	TElGOST_ce_ptr = zend_register_internal_class_ex(&ce, TElGOSTBase_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBGOST2814789, KeyWrap28147)
{
	int32_t l4CEKMACSizeRaw;
	int32_t l4WCEKSizeRaw;
	SBArrayZValInfo aiCEK;
	SBArrayZValInfo aiCEK_MAC;
	SBArrayZValInfo aiKEK;
	SBArrayZValInfo aiUKM;
	SBArrayZValInfo aiWCEK;
	uint32_t _err;
	zval *zaCEK;
	zval *zaCEK_MAC;
	zval *zaKEK;
	zval *zaUKM;
	zval *zaWCEK;
	zval *zl4CEKMACSize;
	zval *zl4WCEKSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzzzz", &zaUKM, &zaCEK, &zaKEK, &zaWCEK, &zl4WCEKSize, &zaCEK_MAC, &zl4CEKMACSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaUKM)) || (IS_ARRAY == Z_TYPE_P(zaUKM)) || (IS_NULL == Z_TYPE_P(zaUKM))) && ((IS_STRING == Z_TYPE_P(zaCEK)) || (IS_ARRAY == Z_TYPE_P(zaCEK)) || (IS_NULL == Z_TYPE_P(zaCEK))) && ((IS_STRING == Z_TYPE_P(zaKEK)) || (IS_ARRAY == Z_TYPE_P(zaKEK)) || (IS_NULL == Z_TYPE_P(zaKEK))) && PZVAL_IS_REF(zaWCEK) && ((IS_STRING == Z_TYPE_P(zaWCEK)) || (IS_ARRAY == Z_TYPE_P(zaWCEK))) && PZVAL_IS_REF(zl4WCEKSize) && (IS_LONG == Z_TYPE_P(zl4WCEKSize)) && PZVAL_IS_REF(zaCEK_MAC) && ((IS_STRING == Z_TYPE_P(zaCEK_MAC)) || (IS_ARRAY == Z_TYPE_P(zaCEK_MAC))) && PZVAL_IS_REF(zl4CEKMACSize) && (IS_LONG == Z_TYPE_P(zl4CEKMACSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaUKM, &aiUKM TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaCEK, &aiCEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKEK, &aiKEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWCEK, &aiWCEK TSRMLS_CC)) RETURN_FALSE;
		l4WCEKSizeRaw = (int32_t)Z_LVAL_P(zl4WCEKSize);
		if (!SBGetByteArrayFromZVal(zaCEK_MAC, &aiCEK_MAC TSRMLS_CC)) RETURN_FALSE;
		l4CEKMACSizeRaw = (int32_t)Z_LVAL_P(zl4CEKMACSize);
		_err = SBGOST2814789_KeyWrap28147(aiUKM.data, aiUKM.len, aiCEK.data, aiCEK.len, aiKEK.data, aiKEK.len, aiWCEK.data, &aiWCEK.len, &l4WCEKSizeRaw, aiCEK_MAC.data, &aiCEK_MAC.len, &l4CEKMACSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaWCEK, &aiWCEK TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(32356514, 3, aiWCEK.data, &aiWCEK.len) TSRMLS_CC);
			((char *)aiWCEK.data)[aiWCEK.len] = 0;
			SBDetachDataFromZValAndResize(zaCEK_MAC, &aiCEK_MAC TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(32356514, 5, aiCEK_MAC.data, &aiCEK_MAC.len) TSRMLS_CC);
			((char *)aiCEK_MAC.data)[aiCEK_MAC.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiWCEK);
			SBFreeArrayZValInfo(&aiCEK_MAC);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiUKM);
		SBFreeArrayZValInfo(&aiCEK);
		SBFreeArrayZValInfo(&aiKEK);
		SBSetByteArrayToZVal(&aiWCEK, zaWCEK);
		ZVAL_LONG(zl4WCEKSize, (long)l4WCEKSizeRaw);
		SBSetByteArrayToZVal(&aiCEK_MAC, zaCEK_MAC);
		ZVAL_LONG(zl4CEKMACSize, (long)l4CEKMACSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, &array of byte|string, &integer, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST2814789, KeyUnwrap28147)
{
	int32_t l4CEKSizeRaw;
	SBArrayZValInfo aiCEK;
	SBArrayZValInfo aiCEK_MAC;
	SBArrayZValInfo aiKEK;
	SBArrayZValInfo aiUKM;
	SBArrayZValInfo aiWCEK;
	uint32_t _err;
	zval *zaCEK;
	zval *zaCEK_MAC;
	zval *zaKEK;
	zval *zaUKM;
	zval *zaWCEK;
	zval *zl4CEKSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzzz", &zaUKM, &zaWCEK, &zaKEK, &zaCEK_MAC, &zaCEK, &zl4CEKSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaUKM)) || (IS_ARRAY == Z_TYPE_P(zaUKM)) || (IS_NULL == Z_TYPE_P(zaUKM))) && ((IS_STRING == Z_TYPE_P(zaWCEK)) || (IS_ARRAY == Z_TYPE_P(zaWCEK)) || (IS_NULL == Z_TYPE_P(zaWCEK))) && ((IS_STRING == Z_TYPE_P(zaKEK)) || (IS_ARRAY == Z_TYPE_P(zaKEK)) || (IS_NULL == Z_TYPE_P(zaKEK))) && ((IS_STRING == Z_TYPE_P(zaCEK_MAC)) || (IS_ARRAY == Z_TYPE_P(zaCEK_MAC)) || (IS_NULL == Z_TYPE_P(zaCEK_MAC))) && PZVAL_IS_REF(zaCEK) && ((IS_STRING == Z_TYPE_P(zaCEK)) || (IS_ARRAY == Z_TYPE_P(zaCEK))) && PZVAL_IS_REF(zl4CEKSize) && (IS_LONG == Z_TYPE_P(zl4CEKSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaUKM, &aiUKM TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWCEK, &aiWCEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKEK, &aiKEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaCEK_MAC, &aiCEK_MAC TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaCEK, &aiCEK TSRMLS_CC)) RETURN_FALSE;
		l4CEKSizeRaw = (int32_t)Z_LVAL_P(zl4CEKSize);
		_err = SBGOST2814789_KeyUnwrap28147(aiUKM.data, aiUKM.len, aiWCEK.data, aiWCEK.len, aiKEK.data, aiKEK.len, aiCEK_MAC.data, aiCEK_MAC.len, aiCEK.data, &aiCEK.len, &l4CEKSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaCEK, &aiCEK TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1839010316, 4, aiCEK.data, &aiCEK.len) TSRMLS_CC);
			((char *)aiCEK.data)[aiCEK.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiCEK);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiUKM);
		SBFreeArrayZValInfo(&aiWCEK);
		SBFreeArrayZValInfo(&aiKEK);
		SBFreeArrayZValInfo(&aiCEK_MAC);
		SBSetByteArrayToZVal(&aiCEK, zaCEK);
		ZVAL_LONG(zl4CEKSize, (long)l4CEKSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST2814789, KeyWrapCryptoPro)
{
	int32_t l4CEKMACSizeRaw;
	int32_t l4WCEKSizeRaw;
	SBArrayZValInfo aiCEK;
	SBArrayZValInfo aiCEK_MAC;
	SBArrayZValInfo aiKEK;
	SBArrayZValInfo aiUKM;
	SBArrayZValInfo aiWCEK;
	uint32_t _err;
	zval *zaCEK;
	zval *zaCEK_MAC;
	zval *zaKEK;
	zval *zaUKM;
	zval *zaWCEK;
	zval *zl4CEKMACSize;
	zval *zl4WCEKSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzzzz", &zaUKM, &zaCEK, &zaKEK, &zaWCEK, &zl4WCEKSize, &zaCEK_MAC, &zl4CEKMACSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaUKM)) || (IS_ARRAY == Z_TYPE_P(zaUKM)) || (IS_NULL == Z_TYPE_P(zaUKM))) && ((IS_STRING == Z_TYPE_P(zaCEK)) || (IS_ARRAY == Z_TYPE_P(zaCEK)) || (IS_NULL == Z_TYPE_P(zaCEK))) && ((IS_STRING == Z_TYPE_P(zaKEK)) || (IS_ARRAY == Z_TYPE_P(zaKEK)) || (IS_NULL == Z_TYPE_P(zaKEK))) && PZVAL_IS_REF(zaWCEK) && ((IS_STRING == Z_TYPE_P(zaWCEK)) || (IS_ARRAY == Z_TYPE_P(zaWCEK))) && PZVAL_IS_REF(zl4WCEKSize) && (IS_LONG == Z_TYPE_P(zl4WCEKSize)) && PZVAL_IS_REF(zaCEK_MAC) && ((IS_STRING == Z_TYPE_P(zaCEK_MAC)) || (IS_ARRAY == Z_TYPE_P(zaCEK_MAC))) && PZVAL_IS_REF(zl4CEKMACSize) && (IS_LONG == Z_TYPE_P(zl4CEKMACSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaUKM, &aiUKM TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaCEK, &aiCEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKEK, &aiKEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWCEK, &aiWCEK TSRMLS_CC)) RETURN_FALSE;
		l4WCEKSizeRaw = (int32_t)Z_LVAL_P(zl4WCEKSize);
		if (!SBGetByteArrayFromZVal(zaCEK_MAC, &aiCEK_MAC TSRMLS_CC)) RETURN_FALSE;
		l4CEKMACSizeRaw = (int32_t)Z_LVAL_P(zl4CEKMACSize);
		_err = SBGOST2814789_KeyWrapCryptoPro(aiUKM.data, aiUKM.len, aiCEK.data, aiCEK.len, aiKEK.data, aiKEK.len, aiWCEK.data, &aiWCEK.len, &l4WCEKSizeRaw, aiCEK_MAC.data, &aiCEK_MAC.len, &l4CEKMACSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaWCEK, &aiWCEK TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-994546735, 3, aiWCEK.data, &aiWCEK.len) TSRMLS_CC);
			((char *)aiWCEK.data)[aiWCEK.len] = 0;
			SBDetachDataFromZValAndResize(zaCEK_MAC, &aiCEK_MAC TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-994546735, 5, aiCEK_MAC.data, &aiCEK_MAC.len) TSRMLS_CC);
			((char *)aiCEK_MAC.data)[aiCEK_MAC.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiWCEK);
			SBFreeArrayZValInfo(&aiCEK_MAC);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiUKM);
		SBFreeArrayZValInfo(&aiCEK);
		SBFreeArrayZValInfo(&aiKEK);
		SBSetByteArrayToZVal(&aiWCEK, zaWCEK);
		ZVAL_LONG(zl4WCEKSize, (long)l4WCEKSizeRaw);
		SBSetByteArrayToZVal(&aiCEK_MAC, zaCEK_MAC);
		ZVAL_LONG(zl4CEKMACSize, (long)l4CEKMACSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, &array of byte|string, &integer, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST2814789, KeyUnwrapCryptoPro)
{
	int32_t l4CEKSizeRaw;
	SBArrayZValInfo aiCEK;
	SBArrayZValInfo aiCEK_MAC;
	SBArrayZValInfo aiKEK;
	SBArrayZValInfo aiUKM;
	SBArrayZValInfo aiWCEK;
	uint32_t _err;
	zval *zaCEK;
	zval *zaCEK_MAC;
	zval *zaKEK;
	zval *zaUKM;
	zval *zaWCEK;
	zval *zl4CEKSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzzz", &zaUKM, &zaWCEK, &zaKEK, &zaCEK_MAC, &zaCEK, &zl4CEKSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaUKM)) || (IS_ARRAY == Z_TYPE_P(zaUKM)) || (IS_NULL == Z_TYPE_P(zaUKM))) && ((IS_STRING == Z_TYPE_P(zaWCEK)) || (IS_ARRAY == Z_TYPE_P(zaWCEK)) || (IS_NULL == Z_TYPE_P(zaWCEK))) && ((IS_STRING == Z_TYPE_P(zaKEK)) || (IS_ARRAY == Z_TYPE_P(zaKEK)) || (IS_NULL == Z_TYPE_P(zaKEK))) && ((IS_STRING == Z_TYPE_P(zaCEK_MAC)) || (IS_ARRAY == Z_TYPE_P(zaCEK_MAC)) || (IS_NULL == Z_TYPE_P(zaCEK_MAC))) && PZVAL_IS_REF(zaCEK) && ((IS_STRING == Z_TYPE_P(zaCEK)) || (IS_ARRAY == Z_TYPE_P(zaCEK))) && PZVAL_IS_REF(zl4CEKSize) && (IS_LONG == Z_TYPE_P(zl4CEKSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaUKM, &aiUKM TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWCEK, &aiWCEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKEK, &aiKEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaCEK_MAC, &aiCEK_MAC TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaCEK, &aiCEK TSRMLS_CC)) RETURN_FALSE;
		l4CEKSizeRaw = (int32_t)Z_LVAL_P(zl4CEKSize);
		_err = SBGOST2814789_KeyUnwrapCryptoPro(aiUKM.data, aiUKM.len, aiWCEK.data, aiWCEK.len, aiKEK.data, aiKEK.len, aiCEK_MAC.data, aiCEK_MAC.len, aiCEK.data, &aiCEK.len, &l4CEKSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaCEK, &aiCEK TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1611021255, 4, aiCEK.data, &aiCEK.len) TSRMLS_CC);
			((char *)aiCEK.data)[aiCEK.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiCEK);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiUKM);
		SBFreeArrayZValInfo(&aiWCEK);
		SBFreeArrayZValInfo(&aiKEK);
		SBFreeArrayZValInfo(&aiCEK_MAC);
		SBSetByteArrayToZVal(&aiCEK, zaCEK);
		ZVAL_LONG(zl4CEKSize, (long)l4CEKSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST2814789, gost28147IMIT)
{
	SBArrayZValInfo aiD;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiK;
	uint32_t _err;
	zval *zaD;
	zval *zaIV;
	zval *zaK;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zaIV, &zaK, &zaD) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))) && ((IS_STRING == Z_TYPE_P(zaK)) || (IS_ARRAY == Z_TYPE_P(zaK)) || (IS_NULL == Z_TYPE_P(zaK))) && ((IS_STRING == Z_TYPE_P(zaD)) || (IS_ARRAY == Z_TYPE_P(zaD)) || (IS_NULL == Z_TYPE_P(zaD))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaK, &aiK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaD, &aiD TSRMLS_CC)) RETURN_FALSE;
		_err = SBGOST2814789_gost28147IMIT(aiIV.data, aiIV.len, aiK.data, aiK.len, aiD.data, aiD.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-265326610, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiIV);
		SBFreeArrayZValInfo(&aiK);
		SBFreeArrayZValInfo(&aiD);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBGOST2814789, KeyDiversifyCryptoPro)
{
	int32_t l4DKEKSizeRaw;
	SBArrayZValInfo aiDKEK;
	SBArrayZValInfo aiKEK;
	SBArrayZValInfo aiUKM;
	uint32_t _err;
	zval *zaDKEK;
	zval *zaKEK;
	zval *zaUKM;
	zval *zl4DKEKSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaUKM, &zaKEK, &zaDKEK, &zl4DKEKSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaUKM)) || (IS_ARRAY == Z_TYPE_P(zaUKM)) || (IS_NULL == Z_TYPE_P(zaUKM))) && ((IS_STRING == Z_TYPE_P(zaKEK)) || (IS_ARRAY == Z_TYPE_P(zaKEK)) || (IS_NULL == Z_TYPE_P(zaKEK))) && PZVAL_IS_REF(zaDKEK) && ((IS_STRING == Z_TYPE_P(zaDKEK)) || (IS_ARRAY == Z_TYPE_P(zaDKEK))) && PZVAL_IS_REF(zl4DKEKSize) && (IS_LONG == Z_TYPE_P(zl4DKEKSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaUKM, &aiUKM TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKEK, &aiKEK TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDKEK, &aiDKEK TSRMLS_CC)) RETURN_FALSE;
		l4DKEKSizeRaw = (int32_t)Z_LVAL_P(zl4DKEKSize);
		_err = SBGOST2814789_KeyDiversifyCryptoPro(aiUKM.data, aiUKM.len, aiKEK.data, aiKEK.len, aiDKEK.data, &aiDKEK.len, &l4DKEKSizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDKEK, &aiDKEK TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(808986503, 2, aiDKEK.data, &aiDKEK.len) TSRMLS_CC);
			((char *)aiDKEK.data)[aiDKEK.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDKEK);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiUKM);
		SBFreeArrayZValInfo(&aiKEK);
		SBSetByteArrayToZVal(&aiDKEK, zaDKEK);
		ZVAL_LONG(zl4DKEKSize, (long)l4DKEKSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

void Register_SBGOST2814789_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElGOSTMode", NULL);
	TElGOSTMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElGOSTMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElGOSTMode_ce_ptr, "GOSTMode_ECB", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElGOSTMode_ce_ptr, "GOSTMode_OFB", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElGOSTMode_ce_ptr, "GOSTMode_CFB", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElGOSTMode_ce_ptr, "GOSTMode_CBC", 3)
}

