#include "sbgostcommon.h"

SB_PHP_METHOD(TElGostSubstBlock, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TElGostSubstBlock));
		intern->len = sizeof(TElGostSubstBlock);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TElGostSubstBlock, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TElGostSubstBlock));
}

zend_class_entry *TElGostSubstBlock_ce_ptr = NULL;

static zend_function_entry TElGostSubstBlock_methods[] = {
	PHP_ME(TElGostSubstBlock, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGostSubstBlock, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElGostSubstBlock(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGostSubstBlock_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TElGostSubstBlock", TElGostSubstBlock_methods);
	TElGostSubstBlock_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TElBlockConvert_procRaw(void * _ObjectData, const uint8_t pInBuf[], int32_t szInBuf, int32_t In_StartIdx, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t Out_StartIdx, int8_t Flag)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zInBuf;
	zval * zIn_StartIdx;
	zval * zOutBuf;
	SBArrayZValInfo aiOutBuf;
	zval * zOut_StartIdx;
	zval * zFlag;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zInBuf);
	ZVAL_STRINGL(zInBuf, pInBuf, szInBuf, 1);
	MAKE_STD_ZVAL(zIn_StartIdx);
	ZVAL_LONG(zIn_StartIdx, (long)In_StartIdx);
	MAKE_STD_ZVAL(zOutBuf);
	ZVAL_STRINGL(zOutBuf, pOutBuf, *szOutBuf, 1);
	MAKE_STD_ZVAL(zOut_StartIdx);
	ZVAL_LONG(zOut_StartIdx, (long)Out_StartIdx);
	MAKE_STD_ZVAL(zFlag);
	ZVAL_BOOL(zFlag, (zend_bool)Flag);

	params[0] = &zInBuf;
	params[1] = &zIn_StartIdx;
	params[2] = &zOutBuf;
	params[3] = &zOut_StartIdx;
	params[4] = &zFlag;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zInBuf);
	zval_ptr_dtor(&zIn_StartIdx);
	if (SBGetByteArrayFromZVal(zOutBuf, &aiOutBuf TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiOutBuf.data, aiOutBuf.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiOutBuf);
	zval_ptr_dtor(&zOutBuf);
	zval_ptr_dtor(&zOut_StartIdx);
	zval_ptr_dtor(&zFlag);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TElBlockProcess_procRaw(void * _ObjectData, const uint8_t pInBuf[], int32_t szInBuf, int32_t StartIdx)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zInBuf;
	zval * zStartIdx;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zInBuf);
	ZVAL_STRINGL(zInBuf, pInBuf, szInBuf, 1);
	MAKE_STD_ZVAL(zStartIdx);
	ZVAL_LONG(zStartIdx, (long)StartIdx);

	params[0] = &zInBuf;
	params[1] = &zStartIdx;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zInBuf);
	zval_ptr_dtor(&zStartIdx);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElGOSTBase_ce_ptr = NULL;

SB_PHP_METHOD(TElGOSTBase, Init)
{
	zval *oSubstBlock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oSubstBlock, TElGostSubstBlock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTBase_Init(SBGetObjectHandle(getThis() TSRMLS_CC), (TElGostSubstBlock *)SBGetStructPointer(oSubstBlock TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGostSubstBlock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOSTBase_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, Clone)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGOSTBase_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOSTBase_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGOSTBase)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, EncryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	zval *zu4B0;
	zval *zu4B1;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zu4B0, &zu4B1) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		SBCheckError(TElGOSTBase_EncryptBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &u4B0Raw, &u4B1Raw) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, DecryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	zval *zu4B0;
	zval *zu4B1;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zu4B0, &zu4B1) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		SBCheckError(TElGOSTBase_DecryptBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &u4B0Raw, &u4B1Raw) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, MakeSubstBlock_Inst)
{
	char *sGostSubstBlockHex;
	int sGostSubstBlockHex_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sGostSubstBlockHex, &sGostSubstBlockHex_len) == SUCCESS)
	{
		TElGostSubstBlock roOutResult;
		SBCheckError(TElGOSTBase_MakeSubstBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), sGostSubstBlockHex, (int32_t)sGostSubstBlockHex_len, &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElGostSubstBlock_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TElGostSubstBlock) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, MakeSubstBlock)
{
	char *sGostSubstBlockHex;
	int sGostSubstBlockHex_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sGostSubstBlockHex, &sGostSubstBlockHex_len) == SUCCESS)
	{
		TElGostSubstBlock roOutResult;
		SBCheckError(TElGOSTBase_MakeSubstBlock(sGostSubstBlockHex, (int32_t)sGostSubstBlockHex_len, &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElGostSubstBlock_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TElGostSubstBlock) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOSTBase, __construct)
{
	zval *oSubstBlock;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOSTBase_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oSubstBlock, TElGostSubstBlock_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOSTBase_Create_1((TElGostSubstBlock *)SBGetStructPointer(oSubstBlock TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElGostSubstBlock)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_Init, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, SubstBlock, TElGostSubstBlock, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGOSTBase, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_EncryptBlock, 0, 0, 2)
	ZEND_ARG_INFO(1, B0)
	ZEND_ARG_INFO(1, B1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_DecryptBlock, 0, 0, 2)
	ZEND_ARG_INFO(1, B0)
	ZEND_ARG_INFO(1, B1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_MakeSubstBlock_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, GostSubstBlockHex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase_MakeSubstBlock, 0, 0, 1)
	ZEND_ARG_INFO(0, GostSubstBlockHex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOSTBase___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, SubstBlock, TElGostSubstBlock, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOSTBase_methods[] = {
	PHP_ME(TElGOSTBase, Init, arginfo_TElGOSTBase_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTBase, Reset, arginfo_TElGOSTBase_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTBase, Clone, arginfo_TElGOSTBase_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTBase, EncryptBlock, arginfo_TElGOSTBase_EncryptBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTBase, DecryptBlock, arginfo_TElGOSTBase_DecryptBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTBase, MakeSubstBlock_Inst, arginfo_TElGOSTBase_MakeSubstBlock_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOSTBase, MakeSubstBlock, arginfo_TElGOSTBase_MakeSubstBlock, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOSTBase, __construct, arginfo_TElGOSTBase___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOSTBase(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOSTBase_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOSTBase", TElGOSTBase_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGOSTBase_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBGOSTCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBGOSTCommon, c_GOST_BlockSize, SB_c_GOST_BlockSize, SB_c_GOST_BlockSize);
	SB_REGISTER_LONG_CONSTANT(SBGOSTCommon, c_GOST_KeySize, SB_c_GOST_KeySize, SB_c_GOST_KeySize);
}

