#include "sbhttpcrl.h"

zend_class_entry *TElHTTPCRLRetriever_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPCRLRetriever, Supports)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPCRLRetriever_Supports(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCRLRetriever, GetCRL)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	zval *oCACertificate;
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ls", &oCertificate, TElX509Certificate_ce_ptr, &oCACertificate, TElX509Certificate_ce_ptr, &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCRLRetriever_GetCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), SBGetObjectHandle(oCACertificate TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElX509Certificate, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCRLRetriever, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCRLRetriever_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCRLRetriever, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCRLRetriever_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetriever_Supports, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetriever_GetCRL, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, CACertificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetriever_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetriever___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPCRLRetriever_methods[] = {
	PHP_ME(TElHTTPCRLRetriever, Supports, arginfo_TElHTTPCRLRetriever_Supports, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCRLRetriever, GetCRL, arginfo_TElHTTPCRLRetriever_GetCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCRLRetriever, get_HTTPClient, arginfo_TElHTTPCRLRetriever_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCRLRetriever, __construct, arginfo_TElHTTPCRLRetriever___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPCRLRetriever(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPCRLRetriever_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPCRLRetriever", TElHTTPCRLRetriever_methods);
	if (NULL == TElCustomCRLRetriever_ce_ptr)
		Register_TElCustomCRLRetriever(TSRMLS_C);
	TElHTTPCRLRetriever_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCRLRetriever_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPCRLRetrieverFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPCRLRetrieverFactory, Supports)
{
	char *sLocation;
	int sLocation_len;
	long fNameType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fNameType, &sLocation, &sLocation_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPCRLRetrieverFactory_Supports(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGeneralNameRaw)fNameType, sLocation, (int32_t)sLocation_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCRLRetrieverFactory, GetRetrieverInstance)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCRLRetrieverFactory_GetRetrieverInstance(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCRLRetriever_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCRLRetrieverFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCRLRetrieverFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetrieverFactory_Supports, 0, 0, 2)
	ZEND_ARG_INFO(0, NameType)
	ZEND_ARG_INFO(0, Location)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetrieverFactory_GetRetrieverInstance, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCRLRetrieverFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPCRLRetrieverFactory_methods[] = {
	PHP_ME(TElHTTPCRLRetrieverFactory, Supports, arginfo_TElHTTPCRLRetrieverFactory_Supports, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCRLRetrieverFactory, GetRetrieverInstance, arginfo_TElHTTPCRLRetrieverFactory_GetRetrieverInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCRLRetrieverFactory, __construct, arginfo_TElHTTPCRLRetrieverFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPCRLRetrieverFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPCRLRetrieverFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPCRLRetrieverFactory", TElHTTPCRLRetrieverFactory_methods);
	if (NULL == TElCustomCRLRetrieverFactory_ce_ptr)
		Register_TElCustomCRLRetrieverFactory(TSRMLS_C);
	TElHTTPCRLRetrieverFactory_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCRLRetrieverFactory_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBHTTPCRL, RegisterHTTPCRLRetrieverFactory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBHTTPCRL_RegisterHTTPCRLRetrieverFactory() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

