#include "sbhttptspclient.h"

void SB_CALLBACK TSBHTTPTSPErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ResponseCode)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zResponseCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zResponseCode);
	ZVAL_LONG(zResponseCode, (long)ResponseCode);

	params[0] = &zSender;
	params[1] = &zResponseCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zResponseCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElHTTPTSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPTSPClient, Timestamp)
{
	int32_t l4FailureInfoRaw = 0;
	SBArrayZValInfo aiHashedData;
	SBArrayZValInfo aiReplyCMS;
	TSBPKIStatusRaw fServerResultRaw = 0;
	uint32_t _err;
	zval *zaHashedData;
	zval *zaReplyCMS;
	zval *zfServerResult;
	zval *zl4FailureInfo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaHashedData, &zfServerResult, &zl4FailureInfo, &zaReplyCMS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zl4FailureInfo) && (IS_LONG == Z_TYPE_P(zl4FailureInfo)) && PZVAL_IS_REF(zaReplyCMS) && ((IS_STRING == Z_TYPE_P(zaReplyCMS)) || (IS_ARRAY == Z_TYPE_P(zaReplyCMS))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiReplyCMS);
		_err = TElHTTPTSPClient_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), aiHashedData.data, aiHashedData.len, &fServerResultRaw, &l4FailureInfoRaw, aiReplyCMS.data, &aiReplyCMS.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReplyCMS, &aiReplyCMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1617160327, 4, aiReplyCMS.data, &aiReplyCMS.len) TSRMLS_CC);
			((char *)aiReplyCMS.data)[aiReplyCMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReplyCMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHashedData);
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		ZVAL_LONG(zl4FailureInfo, (long)l4FailureInfoRaw);
		SBSetByteArrayToZVal(&aiReplyCMS, zaReplyCMS);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer, &integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPTSPClient_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPTSPClient_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPTSPClient_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(821609747, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPTSPClient_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, get_OnHTTPError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBHTTPTSPErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElHTTPTSPClient_get_OnHTTPError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, set_OnHTTPError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElHTTPTSPClient_set_OnHTTPError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBHTTPTSPErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBHTTPTSPErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPTSPClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPTSPClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_Timestamp, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, HashedData, 0, 1)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, FailureInfo)
	ZEND_ARG_INFO(1, ReplyCMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_get_OnHTTPError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient_set_OnHTTPError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPTSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPTSPClient_methods[] = {
	PHP_ME(TElHTTPTSPClient, Timestamp, arginfo_TElHTTPTSPClient_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, get_HTTPClient, arginfo_TElHTTPTSPClient_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, set_HTTPClient, arginfo_TElHTTPTSPClient_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, get_URL, arginfo_TElHTTPTSPClient_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, set_URL, arginfo_TElHTTPTSPClient_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, get_OnHTTPError, arginfo_TElHTTPTSPClient_get_OnHTTPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, set_OnHTTPError, arginfo_TElHTTPTSPClient_set_OnHTTPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPTSPClient, __construct, arginfo_TElHTTPTSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPTSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPTSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPTSPClient", TElHTTPTSPClient_methods);
	if (NULL == TElCustomTSPClient_ce_ptr)
		Register_TElCustomTSPClient(TSRMLS_C);
	TElHTTPTSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomTSPClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBHTTPTSPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElHTTPTSPClient_ce_ptr)
		Register_TElHTTPTSPClient(TSRMLS_C);
	zend_register_class_alias("ElHTTPTSPClient", TElHTTPTSPClient_ce_ptr);
}

