#include "sbpades.h"

zend_class_entry *TSBPAdESSignatureType_ce_ptr = NULL;

void SB_CALLBACK TSBPDFSignEventRaw(void * _ObjectData, TObjectHandle Sender, TElSignedCMSMessageHandle CMS)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCMS;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCMS);
	SBInitObject(zCMS, TElSignedCMSMessage_ce_ptr, CMS TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCMS;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCMS);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPDFCertValidatorPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateValidatorHandle * CertValidator, TElX509CertificateHandle Cert)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCertValidator;
	zval * zCert;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertValidator);
	SBInitObject(zCertValidator, TElX509CertificateValidator_ce_ptr, *CertValidator TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertValidator;
	params[2] = &zCert;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*CertValidator = SBGetObjectHandleCE(zCertValidator, TElX509CertificateValidator_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCertValidator TSRMLS_CC);
	zval_ptr_dtor(&zCertValidator);
	zval_ptr_dtor(&zCert);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPDFCertValidatorFinishedEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateValidatorHandle CertValidator, TElX509CertificateHandle Cert, TSBCertificateValidityRaw Validity, TSBCertificateValidityReasonRaw Reason)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertValidator;
	zval * zCert;
	zval * zValidity;
	zval * zReason;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertValidator);
	SBInitObject(zCertValidator, TElX509CertificateValidator_ce_ptr, CertValidator TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zValidity);
	ZVAL_LONG(zValidity, (long)Validity);
	MAKE_STD_ZVAL(zReason);
	ZVAL_LONG(zReason, (long)Reason);

	params[0] = &zSender;
	params[1] = &zCertValidator;
	params[2] = &zCert;
	params[3] = &zValidity;
	params[4] = &zReason;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertValidator);
	zval_ptr_dtor(&zCert);
	zval_ptr_dtor(&zValidity);
	zval_ptr_dtor(&zReason);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPDFRemoteSignEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pHash[], int32_t szHash, uint8_t pSignedHash[], int32_t * szSignedHash)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zHash;
	zval * zSignedHash;
	SBArrayZValInfo aiSignedHash;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHash);
	ZVAL_STRINGL(zHash, pHash, szHash, 1);
	MAKE_STD_ZVAL(zSignedHash);
	ZVAL_STRINGL(zSignedHash, pSignedHash, *szSignedHash, 1);

	params[0] = &zSender;
	params[1] = &zHash;
	params[2] = &zSignedHash;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHash);
	if (SBGetByteArrayFromZVal(zSignedHash, &aiSignedHash TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiSignedHash.data, aiSignedHash.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiSignedHash);
	zval_ptr_dtor(&zSignedHash);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBPAdESOption_ce_ptr = NULL;

zend_class_entry *TSBPAdESOptions_ce_ptr = NULL;

zend_class_entry *TSBPAdESSignatureSizeEstimationStrategy_ce_ptr = NULL;

zend_class_entry *TSBPAdESExtensionIdentifierMode_ce_ptr = NULL;

zend_class_entry *TElPDFAdvancedPublicKeySecurityHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFAdvancedPublicKeySecurityHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-668996102, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFAdvancedPublicKeySecurityHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-668996102, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, GetDescription_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFAdvancedPublicKeySecurityHandler_GetDescription_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1776527630, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFAdvancedPublicKeySecurityHandler_GetDescription(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1776527630, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, GetSignerCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_GetSignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_DSSRevocationInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_DSSRevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFPublicKeyRevocationInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_CustomRevocationInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_CustomRevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFPublicKeyRevocationInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_CMS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_CMS(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSignedCMSMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_ValidationDetails)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCMSAdvancedSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_ValidationDetails(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_ValidationMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFAdvancedPublicKeySecurityHandler_get_ValidationMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(320871271, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_DocumentTimestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_DocumentTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_PAdESSignatureType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPAdESSignatureTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_PAdESSignatureType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_PAdESSignatureType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_PAdESSignatureType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPAdESSignatureTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_DeepValidation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_DeepValidation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_DeepValidation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_DeepValidation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_AutoCollectRevocationInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_AutoCollectRevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_AutoCollectRevocationInfo)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_AutoCollectRevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_IgnoreChainValidationErrors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_IgnoreChainValidationErrors(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_IgnoreChainValidationErrors)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_IgnoreChainValidationErrors(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_ForceCompleteChainValidation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_ForceCompleteChainValidation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_ForceCompleteChainValidation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_ForceCompleteChainValidation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_IncludeRevocationInfoToAdbeAttribute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_IncludeRevocationInfoToAdbeAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_IncludeRevocationInfoToAdbeAttribute)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_IncludeRevocationInfoToAdbeAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_ValidationMoment)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_ValidationMoment(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_ValidationMoment)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_ValidationMoment(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_PAdESOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPAdESOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_PAdESOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_PAdESOptions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_PAdESOptions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPAdESOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_SignatureSizeEstimationStrategy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPAdESSignatureSizeEstimationStrategyRaw fOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_SignatureSizeEstimationStrategy(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_SignatureSizeEstimationStrategy)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_SignatureSizeEstimationStrategy(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPAdESSignatureSizeEstimationStrategyRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_PredefinedSignatureSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_PredefinedSignatureSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_PredefinedSignatureSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_PredefinedSignatureSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_RemoteSigningMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_RemoteSigningMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_RemoteSigningMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_RemoteSigningParams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningParams(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRemoteSigningParams_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_RemoteSigningCertIndex)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningCertIndex(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_RemoteSigningCertIndex)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_RemoteSigningCertIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_ExtensionIdentifierMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPAdESExtensionIdentifierModeRaw fOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_ExtensionIdentifierMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_ExtensionIdentifierMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_ExtensionIdentifierMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPAdESExtensionIdentifierModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_ReuseCollectedRevocationInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_ReuseCollectedRevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_ReuseCollectedRevocationInfo)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_ReuseCollectedRevocationInfo(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_OnBeforeSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_OnBeforeSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_OnAfterSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_OnAfterSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_OnAfterSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_OnAfterSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_OnCertValidatorPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFCertValidatorPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_OnCertValidatorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_OnCertValidatorPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_OnCertValidatorPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFCertValidatorPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFCertValidatorPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_OnCertValidatorFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFCertValidatorFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_OnCertValidatorFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_OnCertValidatorFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_OnCertValidatorFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFCertValidatorFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFCertValidatorFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, get_OnRemoteSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFRemoteSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_get_OnRemoteSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, set_OnRemoteSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_set_OnRemoteSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFRemoteSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFRemoteSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFAdvancedPublicKeySecurityHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFAdvancedPublicKeySecurityHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetDescription_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetSignerCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_DSSRevocationInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_CustomRevocationInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_CMS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ValidationDetails, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ValidationMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_DocumentTimestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_PAdESSignatureType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_PAdESSignatureType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_DeepValidation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_DeepValidation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_AutoCollectRevocationInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_AutoCollectRevocationInfo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_IgnoreChainValidationErrors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_IgnoreChainValidationErrors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ForceCompleteChainValidation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ForceCompleteChainValidation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_IncludeRevocationInfoToAdbeAttribute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_IncludeRevocationInfoToAdbeAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ValidationMoment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ValidationMoment, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_PAdESOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_PAdESOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_SignatureSizeEstimationStrategy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_SignatureSizeEstimationStrategy, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_PredefinedSignatureSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_PredefinedSignatureSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_RemoteSigningMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningParams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningCertIndex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_RemoteSigningCertIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ExtensionIdentifierMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ExtensionIdentifierMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ReuseCollectedRevocationInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ReuseCollectedRevocationInfo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnBeforeSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnBeforeSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnAfterSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnAfterSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnCertValidatorPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnCertValidatorPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnCertValidatorFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnCertValidatorFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnRemoteSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnRemoteSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFAdvancedPublicKeySecurityHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFAdvancedPublicKeySecurityHandler_methods[] = {
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, GetName_Inst, arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, GetName, arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, GetDescription_Inst, arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetDescription_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, GetDescription, arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetDescription, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, GetSignerCertificate, arginfo_TElPDFAdvancedPublicKeySecurityHandler_GetSignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, Reset, arginfo_TElPDFAdvancedPublicKeySecurityHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, ClassType, arginfo_TElPDFAdvancedPublicKeySecurityHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_DSSRevocationInfo, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_DSSRevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_CustomRevocationInfo, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_CustomRevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_CMS, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_CMS, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_ValidationDetails, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ValidationDetails, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_ValidationMessage, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ValidationMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_DocumentTimestamp, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_DocumentTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_PAdESSignatureType, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_PAdESSignatureType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_PAdESSignatureType, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_PAdESSignatureType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_DeepValidation, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_DeepValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_DeepValidation, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_DeepValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_AutoCollectRevocationInfo, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_AutoCollectRevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_AutoCollectRevocationInfo, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_AutoCollectRevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_IgnoreChainValidationErrors, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_IgnoreChainValidationErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_IgnoreChainValidationErrors, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_IgnoreChainValidationErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_ForceCompleteChainValidation, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ForceCompleteChainValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_ForceCompleteChainValidation, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ForceCompleteChainValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_IncludeRevocationInfoToAdbeAttribute, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_IncludeRevocationInfoToAdbeAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_IncludeRevocationInfoToAdbeAttribute, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_IncludeRevocationInfoToAdbeAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_ValidationMoment, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ValidationMoment, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_ValidationMoment, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ValidationMoment, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_PAdESOptions, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_PAdESOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_PAdESOptions, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_PAdESOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_SignatureSizeEstimationStrategy, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_SignatureSizeEstimationStrategy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_SignatureSizeEstimationStrategy, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_SignatureSizeEstimationStrategy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_PredefinedSignatureSize, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_PredefinedSignatureSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_PredefinedSignatureSize, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_PredefinedSignatureSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_RemoteSigningMode, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_RemoteSigningMode, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_RemoteSigningMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_RemoteSigningParams, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_RemoteSigningCertIndex, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_RemoteSigningCertIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_RemoteSigningCertIndex, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_RemoteSigningCertIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_ExtensionIdentifierMode, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ExtensionIdentifierMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_ExtensionIdentifierMode, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ExtensionIdentifierMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_ReuseCollectedRevocationInfo, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_ReuseCollectedRevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_ReuseCollectedRevocationInfo, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_ReuseCollectedRevocationInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_OnBeforeSign, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_OnBeforeSign, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_OnAfterSign, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnAfterSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_OnAfterSign, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnAfterSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_OnCertValidatorPrepared, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnCertValidatorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_OnCertValidatorPrepared, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnCertValidatorPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_OnCertValidatorFinished, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnCertValidatorFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_OnCertValidatorFinished, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnCertValidatorFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, get_OnRemoteSign, arginfo_TElPDFAdvancedPublicKeySecurityHandler_get_OnRemoteSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, set_OnRemoteSign, arginfo_TElPDFAdvancedPublicKeySecurityHandler_set_OnRemoteSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFAdvancedPublicKeySecurityHandler, __construct, arginfo_TElPDFAdvancedPublicKeySecurityHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFAdvancedPublicKeySecurityHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFAdvancedPublicKeySecurityHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFAdvancedPublicKeySecurityHandler", TElPDFAdvancedPublicKeySecurityHandler_methods);
	if (NULL == TElPDFPublicKeySecurityHandler_ce_ptr)
		Register_TElPDFPublicKeySecurityHandler(TSRMLS_C);
	TElPDFAdvancedPublicKeySecurityHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFPublicKeySecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPAdES_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPAdESSignatureType", NULL);
	TSBPAdESSignatureType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPAdESSignatureType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureType_ce_ptr, "pastBasic", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureType_ce_ptr, "pastEnhanced", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureType_ce_ptr, "pastDocumentTimestamp", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPAdESOption", NULL);
	TSBPAdESOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPAdESOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOption_ce_ptr, "poUseSigningCertificateV2", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOption_ce_ptr, "poIncludeAllRevInfoToDSS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOption_ce_ptr, "poCreateVRIDictionaries", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOption_ce_ptr, "poUseUndefBEREncoding", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOption_ce_ptr, "poTolerateMissingSigningCertificate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOption_ce_ptr, "poCompressDSS", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBPAdESOptions", NULL);
	TSBPAdESOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBPAdESOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOptions_ce_ptr, "poUseSigningCertificateV2", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOptions_ce_ptr, "poIncludeAllRevInfoToDSS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOptions_ce_ptr, "poCreateVRIDictionaries", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOptions_ce_ptr, "poUseUndefBEREncoding", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOptions_ce_ptr, "poTolerateMissingSigningCertificate", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESOptions_ce_ptr, "poCompressDSS", 32)
	
	INIT_CLASS_ENTRY(ce, "TSBPAdESSignatureSizeEstimationStrategy", NULL);
	TSBPAdESSignatureSizeEstimationStrategy_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPAdESSignatureSizeEstimationStrategy_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureSizeEstimationStrategy_ce_ptr, "psesBasic", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureSizeEstimationStrategy_ce_ptr, "psesSmart", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureSizeEstimationStrategy_ce_ptr, "psesSmartAndTrialTimestamp", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESSignatureSizeEstimationStrategy_ce_ptr, "psesPredefinedSize", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPAdESExtensionIdentifierMode", NULL);
	TSBPAdESExtensionIdentifierMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPAdESExtensionIdentifierMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESExtensionIdentifierMode_ce_ptr, "peimNoExtensionIdentifier", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESExtensionIdentifierMode_ce_ptr, "peimESIC", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESExtensionIdentifierMode_ce_ptr, "peimADBE", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESExtensionIdentifierMode_ce_ptr, "peimADBEIfNotPresent", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPAdESExtensionIdentifierMode_ce_ptr, "peimBoth", 4)
}

