#include "sbpgpssh.h"

zend_class_entry *TElSSHPGPKey_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHPGPKey, Copy)
{
	TElClassHandle hoDest;
	zval *oDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDest, TElSSHKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oDest) && (IS_OBJECT == Z_TYPE_P(oDest)))
	{
		hoDest = SBGetObjectHandle(oDest TSRMLS_CC);
		SBCheckError(TElSSHPGPKey_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoDest) TSRMLS_CC);
		SBUpdateObjectHandle(oDest, hoDest TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPKey, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPGPKey_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPKey, Import)
{
	zval *oCertificate;
	zval *oPubKey;
	zval *oSecKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPubKey, TElPGPPublicKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPGPKey_Import(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPubKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSecKey, TElPGPSecretKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPGPKey_Import_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSecKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPGPKey_Import_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicKey) or (TElPGPSecretKey) or (TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPKey, get_PGPPublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPGPKey_get_PGPPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPKey, get_PGPSecretKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPGPKey_get_PGPSecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSecretKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPGPKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPKey_Copy, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Dest, TElSSHKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPKey_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPKey_Import, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PubKey_or_SecKey_or_Certificate, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPKey_get_PGPPublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPKey_get_PGPSecretKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHPGPKey_methods[] = {
	PHP_ME(TElSSHPGPKey, Copy, arginfo_TElSSHPGPKey_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPKey, Clear, arginfo_TElSSHPGPKey_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPKey, Import, arginfo_TElSSHPGPKey_Import, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPKey, get_PGPPublicKey, arginfo_TElSSHPGPKey_get_PGPPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPKey, get_PGPSecretKey, arginfo_TElSSHPGPKey_get_PGPSecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPKey, __construct, arginfo_TElSSHPGPKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHPGPKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHPGPKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHPGPKey", TElSSHPGPKey_methods);
	if (NULL == TElSSHKey_ce_ptr)
		Register_TElSSHKey(TSRMLS_C);
	TElSSHPGPKey_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHPGPAuthHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHPGPAuthHandler, GetAlgorithmFromClientKexDHReply)
{
	SBArrayZValInfo aiHostAlg;
	zval *zaHostAlg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHostAlg) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHostAlg)) || (IS_ARRAY == Z_TYPE_P(zaHostAlg)) || (IS_NULL == Z_TYPE_P(zaHostAlg))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHostAlg, &aiHostAlg TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHPGPAuthHandler_GetAlgorithmFromClientKexDHReply(SBGetObjectHandle(getThis() TSRMLS_CC), aiHostAlg.data, aiHostAlg.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHostAlg);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, ValidateServerSignature)
{
	char *sErrMessage;
	int32_t l4ErrCodeRaw;
	int32_t sErrMessage_len;
	long l4Algorithm;
	long l4HashAlg;
	SBArrayZValInfo aiHash;
	SBArrayZValInfo aiPubKeyStr;
	SBArrayZValInfo aiSignature;
	uint32_t _err;
	zval *zaHash;
	zval *zaPubKeyStr;
	zval *zaSignature;
	zval *zl4ErrCode;
	zval *zsErrMessage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzlzz", &l4Algorithm, &zaPubKeyStr, &zaSignature, &zaHash, &l4HashAlg, &zl4ErrCode, &zsErrMessage) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPubKeyStr)) || (IS_ARRAY == Z_TYPE_P(zaPubKeyStr)) || (IS_NULL == Z_TYPE_P(zaPubKeyStr))) && ((IS_STRING == Z_TYPE_P(zaSignature)) || (IS_ARRAY == Z_TYPE_P(zaSignature)) || (IS_NULL == Z_TYPE_P(zaSignature))) && ((IS_STRING == Z_TYPE_P(zaHash)) || (IS_ARRAY == Z_TYPE_P(zaHash)) || (IS_NULL == Z_TYPE_P(zaHash))) && PZVAL_IS_REF(zl4ErrCode) && (IS_LONG == Z_TYPE_P(zl4ErrCode)) && PZVAL_IS_REF(zsErrMessage) && (IS_STRING == Z_TYPE_P(zsErrMessage)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaPubKeyStr, &aiPubKeyStr TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSignature, &aiSignature TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaHash, &aiHash TSRMLS_CC)) RETURN_FALSE;
		l4ErrCodeRaw = (int32_t)Z_LVAL_P(zl4ErrCode);
		sErrMessage = Z_STRVAL_P(zsErrMessage);
		sErrMessage_len = (int32_t)Z_STRLEN_P(zsErrMessage);
		_err = TElSSHPGPAuthHandler_ValidateServerSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, aiPubKeyStr.data, aiPubKeyStr.len, aiSignature.data, aiSignature.len, aiHash.data, aiHash.len, (int32_t)l4HashAlg, &l4ErrCodeRaw, sErrMessage, &sErrMessage_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sErrMessage = emalloc(sErrMessage_len + 1);
			SBCheckError(SBGetLastReturnStringA(-914459643, 7, sErrMessage, &sErrMessage_len) TSRMLS_CC);
			zval_dtor(zsErrMessage);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPubKeyStr);
		SBFreeArrayZValInfo(&aiSignature);
		SBFreeArrayZValInfo(&aiHash);
		ZVAL_LONG(zl4ErrCode, (long)l4ErrCodeRaw);
		sErrMessage[sErrMessage_len] = 0;
		ZVAL_STRINGL(zsErrMessage, sErrMessage, sErrMessage_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, integer, &integer, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, FindKeyByAlgorithm)
{
	long l4Algorithm;
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStorage, TElSSHCustomKeyStorage_ce_ptr, &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPGPAuthHandler_FindKeyByAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomKeyStorage, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, GetKeyBlob)
{
	uint32_t _err;
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSSHPGPAuthHandler_GetKeyBlob(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1518270032, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, KeyBlobToKey)
{
	char *sAlgName;
	int sAlgName_len;
	SBArrayZValInfo aiBlob;
	zval *zaBlob;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sAlgName, &sAlgName_len, &zaBlob) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBlob)) || (IS_ARRAY == Z_TYPE_P(zaBlob)) || (IS_NULL == Z_TYPE_P(zaBlob))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaBlob, &aiBlob TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHPGPAuthHandler_KeyBlobToKey(SBGetObjectHandle(getThis() TSRMLS_CC), sAlgName, (int32_t)sAlgName_len, aiBlob.data, aiBlob.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBlob);
		SBInitObject(return_value, TElSSHKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, HashAlgFromKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPGPAuthHandler_HashAlgFromKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, CalculateServerSignature)
{
	SBArrayZValInfo aiaHash;
	uint32_t _err;
	zval *oKey;
	zval *zaaHash;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oKey, TElSSHKey_ce_ptr, &zaaHash) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaaHash)) || (IS_ARRAY == Z_TYPE_P(zaaHash)) || (IS_NULL == Z_TYPE_P(zaaHash))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaaHash, &aiaHash TSRMLS_CC)) RETURN_FALSE;
		_err = TElSSHPGPAuthHandler_CalculateServerSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), aiaHash.data, aiaHash.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1820050846, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiaHash);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, ServerValidateClientSignature)
{
	int8_t bValidRaw;
	SBArrayZValInfo aiAlgName;
	SBArrayZValInfo aiHash;
	SBArrayZValInfo aiKeyBlob;
	SBArrayZValInfo aiSignature;
	zval *zaAlgName;
	zval *zaHash;
	zval *zaKeyBlob;
	zval *zaSignature;
	zval *zbValid;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzz", &zaAlgName, &zaKeyBlob, &zaSignature, &zaHash, &zbValid) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgName)) || (IS_ARRAY == Z_TYPE_P(zaAlgName)) || (IS_NULL == Z_TYPE_P(zaAlgName))) && ((IS_STRING == Z_TYPE_P(zaKeyBlob)) || (IS_ARRAY == Z_TYPE_P(zaKeyBlob)) || (IS_NULL == Z_TYPE_P(zaKeyBlob))) && ((IS_STRING == Z_TYPE_P(zaSignature)) || (IS_ARRAY == Z_TYPE_P(zaSignature)) || (IS_NULL == Z_TYPE_P(zaSignature))) && ((IS_STRING == Z_TYPE_P(zaHash)) || (IS_ARRAY == Z_TYPE_P(zaHash)) || (IS_NULL == Z_TYPE_P(zaHash))) && PZVAL_IS_REF(zbValid) && (IS_BOOL == Z_TYPE_P(zbValid)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgName, &aiAlgName TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyBlob, &aiKeyBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSignature, &aiSignature TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaHash, &aiHash TSRMLS_CC)) RETURN_FALSE;
		bValidRaw = (int8_t)Z_BVAL_P(zbValid);
		SBCheckError(TElSSHPGPAuthHandler_ServerValidateClientSignature(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgName.data, aiAlgName.len, aiKeyBlob.data, aiKeyBlob.len, aiSignature.data, aiSignature.len, aiHash.data, aiHash.len, &bValidRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgName);
		SBFreeArrayZValInfo(&aiKeyBlob);
		SBFreeArrayZValInfo(&aiSignature);
		SBFreeArrayZValInfo(&aiHash);
		ZVAL_BOOL(zbValid, (zend_bool)bValidRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPGPAuthHandler, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPGPAuthHandler_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_GetAlgorithmFromClientKexDHReply, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, HostAlg, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_ValidateServerSignature, 0, 0, 7)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_TYPE_INFO(0, PubKeyStr, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Signature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Hash, 0, 1)
	ZEND_ARG_INFO(0, HashAlg)
	ZEND_ARG_INFO(1, ErrCode)
	ZEND_ARG_INFO(1, ErrMessage)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_FindKeyByAlgorithm, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Storage, TElSSHCustomKeyStorage, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_GetKeyBlob, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_KeyBlobToKey, 0, 0, 2)
	ZEND_ARG_INFO(0, AlgName)
	ZEND_ARG_TYPE_INFO(0, Blob, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_HashAlgFromKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_CalculateServerSignature, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
	ZEND_ARG_TYPE_INFO(0, aHash, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler_ServerValidateClientSignature, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, AlgName, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyBlob, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Signature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Hash, 0, 1)
	ZEND_ARG_INFO(1, Valid)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPGPAuthHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHPGPAuthHandler_methods[] = {
	PHP_ME(TElSSHPGPAuthHandler, GetAlgorithmFromClientKexDHReply, arginfo_TElSSHPGPAuthHandler_GetAlgorithmFromClientKexDHReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, ValidateServerSignature, arginfo_TElSSHPGPAuthHandler_ValidateServerSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, FindKeyByAlgorithm, arginfo_TElSSHPGPAuthHandler_FindKeyByAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, GetKeyBlob, arginfo_TElSSHPGPAuthHandler_GetKeyBlob, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, KeyBlobToKey, arginfo_TElSSHPGPAuthHandler_KeyBlobToKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, HashAlgFromKey, arginfo_TElSSHPGPAuthHandler_HashAlgFromKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, CalculateServerSignature, arginfo_TElSSHPGPAuthHandler_CalculateServerSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, ServerValidateClientSignature, arginfo_TElSSHPGPAuthHandler_ServerValidateClientSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPGPAuthHandler, __construct, arginfo_TElSSHPGPAuthHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHPGPAuthHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHPGPAuthHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHPGPAuthHandler", TElSSHPGPAuthHandler_methods);
	if (NULL == TElSSHAuthHandler_ce_ptr)
		Register_TElSSHAuthHandler(TSRMLS_C);
	TElSSHPGPAuthHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHAuthHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPGPSSH_Aliases(TSRMLS_D)
{
	if (NULL == TElSSHPGPKey_ce_ptr)
		Register_TElSSHPGPKey(TSRMLS_C);
	zend_register_class_alias("ElSSHPGPKey", TElSSHPGPKey_ce_ptr);
	if (NULL == TElSSHPGPAuthHandler_ce_ptr)
		Register_TElSSHPGPAuthHandler(TSRMLS_C);
	zend_register_class_alias("ElSSHPGPAuthHandler", TElSSHPGPAuthHandler_ce_ptr);
}

