#include "sbpgptls.h"

zend_class_entry *TSBPGPKeyDescriptorType_ce_ptr = NULL;

zend_class_entry *TSBPGPKeyAlgorithmType_ce_ptr = NULL;

void SB_CALLBACK TElPGPSSLKeyFindEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pKeyFP[], int32_t szKeyFP, TElPGPPublicKeyHandle * Key)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zKeyFP;
	zval * zKey;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKeyFP);
	ZVAL_STRINGL(zKeyFP, pKeyFP, szKeyFP, 1);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElPGPPublicKey_ce_ptr, *Key TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zKeyFP;
	params[2] = &zKey;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKeyFP);
	*Key = SBGetObjectHandleCE(zKey, TElPGPPublicKey_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zKey TSRMLS_CC);
	zval_ptr_dtor(&zKey);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TElPGPSSLKeyValidateEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPPublicKeyHandle Key, TSBPGPSignatureValidityRaw * Validity)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zKey;
	zval * zValidity;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElPGPPublicKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zValidity);
	ZVAL_LONG(zValidity, (long)*Validity);

	params[0] = &zSender;
	params[1] = &zKey;
	params[2] = &zValidity;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKey);
	*Validity = (TSBPGPSignatureValidityRaw)Z_LVAL_P(zValidity);
	zval_ptr_dtor(&zValidity);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSSLPGPCertificateTypeHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, GetCertificateType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSSLCertificateTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSSLPGPCertificateTypeHandler_GetCertificateType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, ValidateRemoteCert)
{
	long l4Optional;
	SBArrayZValInfo aiData;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaData, &l4Optional) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSLPGPCertificateTypeHandler_ValidateRemoteCert(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, (int32_t)l4Optional, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, GetRemoteKeyMaterial)
{
	int32_t l4KeyAlgorithmRaw;
	int32_t l4PKTypeRaw;
	long l4KeyType;
	SBArrayZValInfo aiData;
	TElClassHandle hoKeyMaterial;
	zval *oKeyMaterial;
	zval *zaData;
	zval *zl4KeyAlgorithm;
	zval *zl4PKType;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO", &zaData, &l4KeyType, &zl4PKType, &zl4KeyAlgorithm, &oKeyMaterial, TElKeyMaterial_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))) && PZVAL_IS_REF(zl4PKType) && (IS_LONG == Z_TYPE_P(zl4PKType)) && PZVAL_IS_REF(zl4KeyAlgorithm) && (IS_LONG == Z_TYPE_P(zl4KeyAlgorithm)) && PZVAL_IS_REF(oKeyMaterial) && (IS_OBJECT == Z_TYPE_P(oKeyMaterial)))
	{
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		l4PKTypeRaw = (int32_t)Z_LVAL_P(zl4PKType);
		l4KeyAlgorithmRaw = (int32_t)Z_LVAL_P(zl4KeyAlgorithm);
		hoKeyMaterial = SBGetObjectHandle(oKeyMaterial TSRMLS_CC);
		SBCheckError(TElSSLPGPCertificateTypeHandler_GetRemoteKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, (int32_t)l4KeyType, &l4PKTypeRaw, &l4KeyAlgorithmRaw, &hoKeyMaterial) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		ZVAL_LONG(zl4PKType, (long)l4PKTypeRaw);
		ZVAL_LONG(zl4KeyAlgorithm, (long)l4KeyAlgorithmRaw);
		SBUpdateObjectHandle(oKeyMaterial, hoKeyMaterial TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &integer, &integer, &TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, GetKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLPGPCertificateTypeHandler_GetKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, GetPublicKeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSLPGPCertificateTypeHandler_GetPublicKeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, GetDataForRemote)
{
	long fKeyExchange;
	long l4CipherSuite;
	long l4Optional;
	SBArrayZValInfo aiData;
	uint32_t _err;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzl", &l4CipherSuite, &fKeyExchange, &zaData, &l4Optional) == SUCCESS) && PZVAL_IS_REF(zaData) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		_err = TElSSLPGPCertificateTypeHandler_GetDataForRemote(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4CipherSuite, (TSBKeyExchangeAlgorithmRaw)fKeyExchange, aiData.data, &aiData.len, (int32_t)l4Optional, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaData, &aiData TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2083141646, 3, aiData.data, &aiData.len) TSRMLS_CC);
			((char *)aiData.data)[aiData.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiData);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiData, zaData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, GetPublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSLPGPCertificateTypeHandler_GetPublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, get_Keyring)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLPGPCertificateTypeHandler_get_Keyring(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPKeyring_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, set_Keyring)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPGPKeyring_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSLPGPCertificateTypeHandler_set_Keyring(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPKeyring)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, get_OnKeyFind)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPGPSSLKeyFindEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLPGPCertificateTypeHandler_get_OnKeyFind(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, set_OnKeyFind)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLPGPCertificateTypeHandler_set_OnKeyFind(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPGPSSLKeyFindEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSSLKeyFindEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, get_OnKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElPGPSSLKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSLPGPCertificateTypeHandler_get_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, set_OnKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSLPGPCertificateTypeHandler_set_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElPGPSSLKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSSLKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLPGPCertificateTypeHandler, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLPGPCertificateTypeHandler_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_GetCertificateType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_ValidateRemoteCert, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, Optional)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_GetRemoteKeyMaterial, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, KeyType)
	ZEND_ARG_INFO(1, PKType)
	ZEND_ARG_INFO(1, KeyAlgorithm)
	ZEND_ARG_OBJ_INFO(1, KeyMaterial, TElKeyMaterial, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_GetKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_GetPublicKeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_GetDataForRemote, 0, 0, 4)
	ZEND_ARG_INFO(0, CipherSuite)
	ZEND_ARG_INFO(0, KeyExchange)
	ZEND_ARG_INFO(1, Data)
	ZEND_ARG_INFO(0, Optional)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_GetPublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_get_Keyring, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_set_Keyring, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPKeyring, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_get_OnKeyFind, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_set_OnKeyFind, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_get_OnKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler_set_OnKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLPGPCertificateTypeHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSLPGPCertificateTypeHandler_methods[] = {
	PHP_ME(TElSSLPGPCertificateTypeHandler, GetCertificateType, arginfo_TElSSLPGPCertificateTypeHandler_GetCertificateType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, ValidateRemoteCert, arginfo_TElSSLPGPCertificateTypeHandler_ValidateRemoteCert, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, GetRemoteKeyMaterial, arginfo_TElSSLPGPCertificateTypeHandler_GetRemoteKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, GetKeyMaterial, arginfo_TElSSLPGPCertificateTypeHandler_GetKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, GetPublicKeySize, arginfo_TElSSLPGPCertificateTypeHandler_GetPublicKeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, GetDataForRemote, arginfo_TElSSLPGPCertificateTypeHandler_GetDataForRemote, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, GetPublicKeyAlgorithm, arginfo_TElSSLPGPCertificateTypeHandler_GetPublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, get_Keyring, arginfo_TElSSLPGPCertificateTypeHandler_get_Keyring, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, set_Keyring, arginfo_TElSSLPGPCertificateTypeHandler_set_Keyring, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, get_OnKeyFind, arginfo_TElSSLPGPCertificateTypeHandler_get_OnKeyFind, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, set_OnKeyFind, arginfo_TElSSLPGPCertificateTypeHandler_set_OnKeyFind, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, get_OnKeyValidate, arginfo_TElSSLPGPCertificateTypeHandler_get_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, set_OnKeyValidate, arginfo_TElSSLPGPCertificateTypeHandler_set_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLPGPCertificateTypeHandler, __construct, arginfo_TElSSLPGPCertificateTypeHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSLPGPCertificateTypeHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSLPGPCertificateTypeHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSLPGPCertificateTypeHandler", TElSSLPGPCertificateTypeHandler_methods);
	if (NULL == TElSSLCertificateTypeHandler_ce_ptr)
		Register_TElSSLCertificateTypeHandler(TSRMLS_C);
	TElSSLPGPCertificateTypeHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLCertificateTypeHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSLClientPGPCertificateTypeHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSSLClientPGPCertificateTypeHandler, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLClientPGPCertificateTypeHandler_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLClientPGPCertificateTypeHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSLClientPGPCertificateTypeHandler_methods[] = {
	PHP_ME(TElSSLClientPGPCertificateTypeHandler, __construct, arginfo_TElSSLClientPGPCertificateTypeHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSLClientPGPCertificateTypeHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSLClientPGPCertificateTypeHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSLClientPGPCertificateTypeHandler", TElSSLClientPGPCertificateTypeHandler_methods);
	if (NULL == TElSSLPGPCertificateTypeHandler_ce_ptr)
		Register_TElSSLPGPCertificateTypeHandler(TSRMLS_C);
	TElSSLClientPGPCertificateTypeHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLPGPCertificateTypeHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSLServerPGPCertificateTypeHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSSLServerPGPCertificateTypeHandler, get_KeyDescriptorType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPKeyDescriptorTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSSLServerPGPCertificateTypeHandler_get_KeyDescriptorType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServerPGPCertificateTypeHandler, set_KeyDescriptorType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSLServerPGPCertificateTypeHandler_set_KeyDescriptorType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPKeyDescriptorTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSLServerPGPCertificateTypeHandler, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSLServerPGPCertificateTypeHandler_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServerPGPCertificateTypeHandler_get_KeyDescriptorType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServerPGPCertificateTypeHandler_set_KeyDescriptorType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSLServerPGPCertificateTypeHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSLServerPGPCertificateTypeHandler_methods[] = {
	PHP_ME(TElSSLServerPGPCertificateTypeHandler, get_KeyDescriptorType, arginfo_TElSSLServerPGPCertificateTypeHandler_get_KeyDescriptorType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServerPGPCertificateTypeHandler, set_KeyDescriptorType, arginfo_TElSSLServerPGPCertificateTypeHandler_set_KeyDescriptorType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSLServerPGPCertificateTypeHandler, __construct, arginfo_TElSSLServerPGPCertificateTypeHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSLServerPGPCertificateTypeHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSLServerPGPCertificateTypeHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSLServerPGPCertificateTypeHandler", TElSSLServerPGPCertificateTypeHandler_methods);
	if (NULL == TElSSLPGPCertificateTypeHandler_ce_ptr)
		Register_TElSSLPGPCertificateTypeHandler(TSRMLS_C);
	TElSSLServerPGPCertificateTypeHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElSSLPGPCertificateTypeHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPGPTLS_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPGPKeyDescriptorType", NULL);
	TSBPGPKeyDescriptorType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPKeyDescriptorType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyDescriptorType_ce_ptr, "kdtFingerprint", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyDescriptorType_ce_ptr, "kdtKey", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPKeyAlgorithmType", NULL);
	TSBPGPKeyAlgorithmType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPKeyAlgorithmType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyAlgorithmType_ce_ptr, "katRSA", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyAlgorithmType_ce_ptr, "katDHE_DSS", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyAlgorithmType_ce_ptr, "katDHE_RSA", 2)
}

