#include "sbpkcs10.h"

zend_class_entry *TSBCertReqFileFormat_ce_ptr = NULL;

zend_class_entry *TSBCertificateRequestOption_ce_ptr = NULL;

zend_class_entry *TSBCertificateRequestOptions_ce_ptr = NULL;

zend_class_entry *TElCertificateRequest_ce_ptr = NULL;

SB_PHP_METHOD(TElCertificateRequest, DetectCertReqFileFormat_Inst)
{
	char *sFileName;
	int sFileName_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		TSBCertReqFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_DetectCertReqFileFormat_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		TSBCertReqFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_DetectCertReqFileFormat_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, DetectCertReqFileFormat)
{
	char *sFileName;
	int sFileName_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		TSBCertReqFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_DetectCertReqFileFormat(sFileName, (int32_t)sFileName_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		TSBCertReqFileFormatRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_DetectCertReqFileFormat_2(SBGetObjectHandle(oStream TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRequest_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadFromBufferPEM)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRequest_LoadFromBufferPEM(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadFromStream)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadFromStreamPEM)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_LoadFromStreamPEM(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, Generate)
{
	long l4Bits;
	long l4PublicKeyAlgorithm;
	long l4SignatureAlgorithm;
	zval *oPublicKeyAlgorithm;
	zval *oSignatureAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lll", &l4PublicKeyAlgorithm, &l4Bits, &l4SignatureAlgorithm) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4PublicKeyAlgorithm, (int32_t)l4Bits, (int32_t)l4SignatureAlgorithm) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oPublicKeyAlgorithm, TElAlgorithmIdentifier_ce_ptr, &l4Bits, &oSignatureAlgorithm, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_Generate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPublicKeyAlgorithm TSRMLS_CC), (int32_t)l4Bits, SBGetObjectHandle(oSignatureAlgorithm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer) or (TElAlgorithmIdentifier, integer, TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveKeyToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_SaveKeyToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveToBufferPEM)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_SaveToBufferPEM(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveToStreamPEM)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_SaveToStreamPEM(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveKeyToStreamPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	long fEncryptionMode;
	long l4EncryptionAlgorithm;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sPassphrase, &sPassphrase_len) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_SaveKeyToStreamPEM(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassphrase, (int32_t)sPassphrase_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lls", &oStream, TStream_ce_ptr, &l4EncryptionAlgorithm, &fEncryptionMode, &sPassphrase, &sPassphrase_len) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_SaveKeyToStreamPEM_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4EncryptionAlgorithm, (TSBSymmetricCryptoModeRaw)fEncryptionMode, sPassphrase, (int32_t)sPassphrase_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string) or (TStream, integer, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveKeyToBufferPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	int32_t l4SizeRaw;
	long fEncryptionMode;
	long l4EncryptionAlgorithm;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzs", &zpBuffer, &zl4Size, &sPassphrase, &sPassphrase_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_SaveKeyToBufferPEM(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, sPassphrase, (int32_t)sPassphrase_len, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzs", &zpBuffer, &l4EncryptionAlgorithm, &fEncryptionMode, &zl4Size, &sPassphrase, &sPassphrase_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_SaveKeyToBufferPEM_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4EncryptionAlgorithm, (TSBSymmetricCryptoModeRaw)fEncryptionMode, &l4SizeRaw, sPassphrase, (int32_t)sPassphrase_len, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, string) or (TSBPointer|array of byte|string|NULL, integer, integer, &integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveKeyToBufferPVK)
{
	char *sPassword;
	int sPassword_len;
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zend_bool bUseStrongEncryption;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzsb", &zpBuffer, &zl4Size, &sPassword, &sPassword_len, &bUseStrongEncryption) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_SaveKeyToBufferPVK(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, sPassword, (int32_t)sPassword_len, (int8_t)bUseStrongEncryption, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveKeyToStreamPVK)
{
	char *sPassword;
	int sPassword_len;
	zend_bool bUseStrongEncryption;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oStream, TStream_ce_ptr, &sPassword, &sPassword_len, &bUseStrongEncryption) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_SaveKeyToStreamPVK(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int8_t)bUseStrongEncryption, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadKeyFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRequest_LoadKeyFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadKeyFromBufferPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zls", &zpBuffer, &l4Size, &sPassphrase, &sPassphrase_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCertificateRequest_LoadKeyFromBufferPEM(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, sPassphrase, (int32_t)sPassphrase_len, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadKeyFromStream)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_LoadKeyFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, LoadKeyFromStreamPEM)
{
	char *sPassphrase;
	int sPassphrase_len;
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oStream, TStream_ce_ptr, &sPassphrase, &sPassphrase_len, &l4Count) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_LoadKeyFromStreamPEM(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassphrase, (int32_t)sPassphrase_len, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, ValidateSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_ValidateSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, GetRSAParams)
{
	int32_t l4PublicExponentSizeRaw;
	int32_t l4PublicModulusSizeRaw;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	zval *zl4PublicExponentSize;
	zval *zl4PublicModulusSize;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		SBCheckError(TElCertificateRequest_GetRSAParams(SBGetObjectHandle(getThis() TSRMLS_CC), piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, GetDSAParams)
{
	int32_t l4GSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4YSizeRaw;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piY;
	zval *zl4GSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4YSize;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzzzzz", &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		SBCheckError(TElCertificateRequest_GetDSAParams(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SaveKeyToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_SaveKeyToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, GetPrivateKey)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCertificateRequest_GetPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, SetKeyMaterial)
{
	zval *oKeyMaterial;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyMaterial, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_SetKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_Subject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, set_Version)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_SignatureAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_get_SignatureAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_PublicKeyAlgorithmIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_get_PublicKeyAlgorithmIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_SignatureAlgorithmIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_get_SignatureAlgorithmIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAlgorithmIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_PublicKeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCertificateRequest_get_PublicKeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateRequestOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_get_Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, set_Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_set_Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCertificateRequestOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_PreserveKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCertificateRequest_get_PreserveKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, set_PreserveKeyMaterial)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCertificateRequest_set_PreserveKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCertificateRequest, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCertificateRequest_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_DetectCertReqFileFormat_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_DetectCertReqFileFormat, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadFromBufferPEM, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadFromStreamPEM, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_Generate, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, PublicKeyAlgorithm, 0, 1)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_TYPE_INFO(0, SignatureAlgorithm, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveKeyToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveToBufferPEM, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveToStreamPEM, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveKeyToStreamPEM, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Passphrase_or_EncryptionAlgorithm)
	ZEND_ARG_INFO(0, EncryptionMode)
	ZEND_ARG_INFO(0, Passphrase)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveKeyToBufferPEM, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size_or_EncryptionAlgorithm)
	ZEND_ARG_INFO(0, Passphrase_or_EncryptionMode)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_INFO(0, Passphrase)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveKeyToBufferPVK, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, UseStrongEncryption)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveKeyToStreamPVK, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, UseStrongEncryption)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadKeyFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadKeyFromBufferPEM, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(0, Passphrase)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadKeyFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_LoadKeyFromStreamPEM, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Passphrase)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_ValidateSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_GetRSAParams, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, PublicModulus, 0, 1)
	ZEND_ARG_INFO(1, PublicModulusSize)
	ZEND_ARG_TYPE_INFO(0, PublicExponent, 0, 1)
	ZEND_ARG_INFO(1, PublicExponentSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_GetDSAParams, 0, 0, 8)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_INFO(1, PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(1, QSize)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(1, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(1, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SaveKeyToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_GetPrivateKey, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_SetKeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, KeyMaterial, TElPublicKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_SignatureAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_PublicKeyAlgorithmIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_SignatureAlgorithmIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_PublicKeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_set_Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_PreserveKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_set_PreserveKeyMaterial, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCertificateRequest___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCertificateRequest_methods[] = {
	PHP_ME(TElCertificateRequest, DetectCertReqFileFormat_Inst, arginfo_TElCertificateRequest_DetectCertReqFileFormat_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, DetectCertReqFileFormat, arginfo_TElCertificateRequest_DetectCertReqFileFormat, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCertificateRequest, LoadFromBuffer, arginfo_TElCertificateRequest_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadFromBufferPEM, arginfo_TElCertificateRequest_LoadFromBufferPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadFromStream, arginfo_TElCertificateRequest_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadFromStreamPEM, arginfo_TElCertificateRequest_LoadFromStreamPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, Generate, arginfo_TElCertificateRequest_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveToStream, arginfo_TElCertificateRequest_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveKeyToStream, arginfo_TElCertificateRequest_SaveKeyToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveToBuffer, arginfo_TElCertificateRequest_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveToBufferPEM, arginfo_TElCertificateRequest_SaveToBufferPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveToStreamPEM, arginfo_TElCertificateRequest_SaveToStreamPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveKeyToStreamPEM, arginfo_TElCertificateRequest_SaveKeyToStreamPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveKeyToBufferPEM, arginfo_TElCertificateRequest_SaveKeyToBufferPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveKeyToBufferPVK, arginfo_TElCertificateRequest_SaveKeyToBufferPVK, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveKeyToStreamPVK, arginfo_TElCertificateRequest_SaveKeyToStreamPVK, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadKeyFromBuffer, arginfo_TElCertificateRequest_LoadKeyFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadKeyFromBufferPEM, arginfo_TElCertificateRequest_LoadKeyFromBufferPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadKeyFromStream, arginfo_TElCertificateRequest_LoadKeyFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, LoadKeyFromStreamPEM, arginfo_TElCertificateRequest_LoadKeyFromStreamPEM, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, ValidateSignature, arginfo_TElCertificateRequest_ValidateSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, GetRSAParams, arginfo_TElCertificateRequest_GetRSAParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, GetDSAParams, arginfo_TElCertificateRequest_GetDSAParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SaveKeyToBuffer, arginfo_TElCertificateRequest_SaveKeyToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, GetPrivateKey, arginfo_TElCertificateRequest_GetPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, SetKeyMaterial, arginfo_TElCertificateRequest_SetKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_Subject, arginfo_TElCertificateRequest_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_Attributes, arginfo_TElCertificateRequest_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_Version, arginfo_TElCertificateRequest_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, set_Version, arginfo_TElCertificateRequest_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_PublicKeyAlgorithm, arginfo_TElCertificateRequest_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_SignatureAlgorithm, arginfo_TElCertificateRequest_get_SignatureAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_PublicKeyAlgorithmIdentifier, arginfo_TElCertificateRequest_get_PublicKeyAlgorithmIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_SignatureAlgorithmIdentifier, arginfo_TElCertificateRequest_get_SignatureAlgorithmIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_Extensions, arginfo_TElCertificateRequest_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_PublicKeySize, arginfo_TElCertificateRequest_get_PublicKeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_Options, arginfo_TElCertificateRequest_get_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, set_Options, arginfo_TElCertificateRequest_set_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_PreserveKeyMaterial, arginfo_TElCertificateRequest_get_PreserveKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, set_PreserveKeyMaterial, arginfo_TElCertificateRequest_set_PreserveKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, get_KeyMaterial, arginfo_TElCertificateRequest_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElCertificateRequest, __construct, arginfo_TElCertificateRequest___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCertificateRequest(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCertificateRequest_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCertificateRequest", TElCertificateRequest_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCertificateRequest_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPKCS10_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBCertReqFileFormat", NULL);
	TSBCertReqFileFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCertReqFileFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCertReqFileFormat_ce_ptr, "crfUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertReqFileFormat_ce_ptr, "crfDER", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertReqFileFormat_ce_ptr, "crfPEM", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBCertificateRequestOption", NULL);
	TSBCertificateRequestOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBCertificateRequestOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateRequestOption_ce_ptr, "croGenerateKeyIdentifier", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateRequestOption_ce_ptr, "croUseMSExtensionIdentifier", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateRequestOption_ce_ptr, "croAutoAdjustTagTypes", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBCertificateRequestOptions", NULL);
	TSBCertificateRequestOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBCertificateRequestOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateRequestOptions_ce_ptr, "croGenerateKeyIdentifier", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateRequestOptions_ce_ptr, "croUseMSExtensionIdentifier", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBCertificateRequestOptions_ce_ptr, "croAutoAdjustTagTypes", 4)
}

void Register_SBPKCS10_Aliases(TSRMLS_D)
{
	if (NULL == TElCertificateRequest_ce_ptr)
		Register_TElCertificateRequest(TSRMLS_C);
	zend_register_class_alias("ElCertificateRequest", TElCertificateRequest_ce_ptr);
}

