#include "sbpkiasync.h"

zend_class_entry *TSBPublicKeyComputationTokenType_ce_ptr = NULL;

zend_class_entry *TElPublicKeyAsyncCalculator_ce_ptr = NULL;

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginElgamalEncryption)
{
	zval *oG;
	zval *oP;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oY, TLInt_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginElgamalEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndElgamalEncryption)
{
	zval *oA;
	zval *oB;
	zval *oSrc;
	zval *oToken;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oSrc, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_EndElgamalEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginElgamalSigning)
{
	zval *oG;
	zval *oP;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginElgamalSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndElgamalSigning)
{
	zval *oA;
	zval *oB;
	zval *oSrc;
	zval *oToken;
	zval *oX;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oX, TLInt_ce_ptr, &oSrc, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_EndElgamalSigning(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginPrimeGeneration)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginPrimeGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndPrimeGeneration)
{
	zval *oPrime;
	zval *oToken;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oPrime, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_EndPrimeGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oPrime TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginDSASigning)
{
	zval *oG;
	zval *oP;
	zval *oQ;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oG, TLInt_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginDSASigning(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndDSASigning)
{
	long l4HashSize;
	SBArrayZValInfo piHash;
	zval *oR;
	zval *oS;
	zval *oToken;
	zval *oX;
	zval *zpHash;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zlO!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oX, TLInt_ce_ptr, &zpHash, &l4HashSize, &oR, TLInt_ce_ptr, &oS, TLInt_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyAsyncCalculator_EndDSASigning(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), piHash.data, (int32_t)l4HashSize, (TLInt *)SBGetStructPointer(oR TSRMLS_CC), (TLInt *)SBGetStructPointer(oS TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt, TSBPointer|array of byte|string|NULL, integer, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginRSAGeneration)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginRSAGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndRSAGeneration)
{
	int32_t l4BlobSizeRaw;
	SBArrayZValInfo piBlob;
	zval *oCoeff;
	zval *oExp1;
	zval *oExp2;
	zval *oM;
	zval *oPrime1;
	zval *oPrime2;
	zval *oPrivE;
	zval *oPubE;
	zval *oToken;
	zval *zl4BlobSize;
	zval *zpBlob;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!O!O!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oM, TLInt_ce_ptr, &oPrivE, TLInt_ce_ptr, &oPubE, TLInt_ce_ptr, &oPrime1, TLInt_ce_ptr, &oPrime2, TLInt_ce_ptr, &oExp1, TLInt_ce_ptr, &oExp2, TLInt_ce_ptr, &oCoeff, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_EndRSAGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oM TSRMLS_CC), (TLInt *)SBGetStructPointer(oPrivE TSRMLS_CC), (TLInt *)SBGetStructPointer(oPubE TSRMLS_CC), (TLInt *)SBGetStructPointer(oPrime1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oPrime2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oExp1 TSRMLS_CC), (TLInt *)SBGetStructPointer(oExp2 TSRMLS_CC), (TLInt *)SBGetStructPointer(oCoeff TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oToken, TElPublicKeyComputationToken_ce_ptr, &zpBlob, &zl4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BlobSize) && (IS_LONG == Z_TYPE_P(zl4BlobSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		l4BlobSizeRaw = (int32_t)Z_LVAL_P(zl4BlobSize);
		SBCheckError(TElPublicKeyAsyncCalculator_EndRSAGeneration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), piBlob.data, &l4BlobSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		ZVAL_LONG(zl4BlobSize, (long)l4BlobSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt) or (TElPublicKeyComputationToken, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginDSAGeneration)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginDSAGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndDSAGeneration)
{
	int32_t l4BlobSizeRaw;
	SBArrayZValInfo piBlob;
	zval *oG;
	zval *oP;
	zval *oQ;
	zval *oToken;
	zval *oX;
	zval *oY;
	zval *zl4BlobSize;
	zval *zpBlob;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_EndDSAGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oToken, TElPublicKeyComputationToken_ce_ptr, &zpBlob, &zl4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BlobSize) && (IS_LONG == Z_TYPE_P(zl4BlobSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		l4BlobSizeRaw = (int32_t)Z_LVAL_P(zl4BlobSize);
		SBCheckError(TElPublicKeyAsyncCalculator_EndDSAGeneration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), piBlob.data, &l4BlobSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		ZVAL_LONG(zl4BlobSize, (long)l4BlobSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt, TLInt, TLInt, TLInt, TLInt) or (TElPublicKeyComputationToken, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, BeginElgamalGeneration)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_BeginElgamalGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyComputationToken_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, EndElgamalGeneration)
{
	zval *oG;
	zval *oP;
	zval *oToken;
	zval *oX;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!", &oToken, TElPublicKeyComputationToken_ce_ptr, &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_EndElgamalGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oToken TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyComputationToken, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPublicKeyAsyncCalculator, get_Priority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TThreadPriorityRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyAsyncCalculator_get_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, set_Priority)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPublicKeyAsyncCalculator_set_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), (TThreadPriorityRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPublicKeyAsyncCalculator, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyAsyncCalculator_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginElgamalEncryption, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, G, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Y, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndElgamalEncryption, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_OBJ_INFO(0, Src, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, B, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginElgamalSigning, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, G, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndElgamalSigning, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_OBJ_INFO(0, X, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Src, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, A, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, B, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginPrimeGeneration, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndPrimeGeneration, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_OBJ_INFO(0, Prime, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginDSASigning, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Q, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, G, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndDSASigning, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_OBJ_INFO(0, X, TLInt, 1)
	ZEND_ARG_TYPE_INFO(0, Hash, 0, 1)
	ZEND_ARG_INFO(0, HashSize)
	ZEND_ARG_OBJ_INFO(0, R, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, S, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginRSAGeneration, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndRSAGeneration, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_TYPE_INFO(0, M_or_Blob, 0, 1)
	ZEND_ARG_TYPE_INFO(1, PrivE_or_BlobSize, 0, 1)
	ZEND_ARG_OBJ_INFO(0, PubE, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Prime1, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Prime2, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Exp1, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Exp2, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Coeff, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginDSAGeneration, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndDSAGeneration, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_TYPE_INFO(0, P_or_Blob, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Q_or_BlobSize, 0, 1)
	ZEND_ARG_OBJ_INFO(0, G, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, X, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Y, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_BeginElgamalGeneration, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_EndElgamalGeneration, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Token, TElPublicKeyComputationToken, 1)
	ZEND_ARG_OBJ_INFO(0, P, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, G, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, X, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, Y, TLInt, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_get_Priority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator_set_Priority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyAsyncCalculator___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPublicKeyAsyncCalculator_methods[] = {
	PHP_ME(TElPublicKeyAsyncCalculator, BeginElgamalEncryption, arginfo_TElPublicKeyAsyncCalculator_BeginElgamalEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndElgamalEncryption, arginfo_TElPublicKeyAsyncCalculator_EndElgamalEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, BeginElgamalSigning, arginfo_TElPublicKeyAsyncCalculator_BeginElgamalSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndElgamalSigning, arginfo_TElPublicKeyAsyncCalculator_EndElgamalSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, BeginPrimeGeneration, arginfo_TElPublicKeyAsyncCalculator_BeginPrimeGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndPrimeGeneration, arginfo_TElPublicKeyAsyncCalculator_EndPrimeGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, BeginDSASigning, arginfo_TElPublicKeyAsyncCalculator_BeginDSASigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndDSASigning, arginfo_TElPublicKeyAsyncCalculator_EndDSASigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, BeginRSAGeneration, arginfo_TElPublicKeyAsyncCalculator_BeginRSAGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndRSAGeneration, arginfo_TElPublicKeyAsyncCalculator_EndRSAGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, BeginDSAGeneration, arginfo_TElPublicKeyAsyncCalculator_BeginDSAGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndDSAGeneration, arginfo_TElPublicKeyAsyncCalculator_EndDSAGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, BeginElgamalGeneration, arginfo_TElPublicKeyAsyncCalculator_BeginElgamalGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, EndElgamalGeneration, arginfo_TElPublicKeyAsyncCalculator_EndElgamalGeneration, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPublicKeyAsyncCalculator, get_Priority, arginfo_TElPublicKeyAsyncCalculator_get_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyAsyncCalculator, set_Priority, arginfo_TElPublicKeyAsyncCalculator_set_Priority, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPublicKeyAsyncCalculator, __construct, arginfo_TElPublicKeyAsyncCalculator___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPublicKeyAsyncCalculator(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPublicKeyAsyncCalculator_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPublicKeyAsyncCalculator", TElPublicKeyAsyncCalculator_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElPublicKeyAsyncCalculator_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPublicKeyComputationToken_ce_ptr = NULL;

SB_PHP_METHOD(TElPublicKeyComputationToken, Cancel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyComputationToken_Cancel(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyComputationToken, get_TokenType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPublicKeyComputationTokenTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyComputationToken_get_TokenType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyComputationToken, get_Finished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyComputationToken_get_Finished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyComputationToken, get_Data)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TElPublicKeyComputationToken_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyComputationToken, set_Data)
{
	SBArrayZValInfo piValue;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpValue) == SUCCESS) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyComputationToken_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), piValue.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piValue);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyComputationToken, __construct)
{
	long fTokenType;
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fTokenType, &oOwner, TElPublicKeyAsyncCalculator_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyComputationToken_Create((TSBPublicKeyComputationTokenTypeRaw)fTokenType, SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElPublicKeyAsyncCalculator)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyComputationToken_Cancel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyComputationToken_get_TokenType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyComputationToken_get_Finished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyComputationToken_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyComputationToken_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyComputationToken___construct, 0, 0, 2)
	ZEND_ARG_INFO(0, TokenType)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPublicKeyAsyncCalculator, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPublicKeyComputationToken_methods[] = {
	PHP_ME(TElPublicKeyComputationToken, Cancel, arginfo_TElPublicKeyComputationToken_Cancel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyComputationToken, get_TokenType, arginfo_TElPublicKeyComputationToken_get_TokenType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyComputationToken, get_Finished, arginfo_TElPublicKeyComputationToken_get_Finished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyComputationToken, get_Data, arginfo_TElPublicKeyComputationToken_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyComputationToken, set_Data, arginfo_TElPublicKeyComputationToken_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyComputationToken, __construct, arginfo_TElPublicKeyComputationToken___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPublicKeyComputationToken(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPublicKeyComputationToken_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPublicKeyComputationToken", TElPublicKeyComputationToken_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPublicKeyComputationToken_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPKIAsync, GetGlobalAsyncCalculator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPKIAsync_GetGlobalAsyncCalculator(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyAsyncCalculator_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBPKIAsync_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPublicKeyComputationTokenType", NULL);
	TSBPublicKeyComputationTokenType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPublicKeyComputationTokenType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttElgamalEncrypt", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttElgamalSign", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttDSASign", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttPrimeGeneration", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttDSAGeneration", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttRSAGeneration", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyComputationTokenType_ce_ptr, "ttElgamalGeneration", 6)
}
