#include "sbpop3client.h"

zend_class_entry *TSBPOP3Authorization_ce_ptr = NULL;

zend_class_entry *TSBPOP3Authorizations_ce_ptr = NULL;

zend_class_entry *TSBPOP3AutoCAPAMode_ce_ptr = NULL;

zend_class_entry *TSBPOP3LogDirection_ce_ptr = NULL;

void SB_CALLBACK TSBPOP3LogEventRaw(void * _ObjectData, TObjectHandle Sender, TSBPOP3LogDirectionRaw Direction, const char * pcInfo, int32_t szInfo)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zDirection;
	zval * zInfo;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDirection);
	ZVAL_LONG(zDirection, (long)Direction);
	MAKE_STD_ZVAL(zInfo);
	ZVAL_STRINGL(zInfo, pcInfo, szInfo, 1);

	params[0] = &zSender;
	params[1] = &zDirection;
	params[2] = &zInfo;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDirection);
	zval_ptr_dtor(&zInfo);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPOP3TextLineEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcInfo, int32_t szInfo)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zInfo;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zInfo);
	ZVAL_STRINGL(zInfo, pcInfo, szInfo, 1);

	params[0] = &zSender;
	params[1] = &zInfo;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zInfo);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPOP3MessageIdEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Index, const char * pcID, int32_t szID)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zIndex;
	zval * zID;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zIndex);
	ZVAL_LONG(zIndex, (long)Index);
	MAKE_STD_ZVAL(zID);
	ZVAL_STRINGL(zID, pcID, szID, 1);

	params[0] = &zSender;
	params[1] = &zIndex;
	params[2] = &zID;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zIndex);
	zval_ptr_dtor(&zID);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPOP3MessageSizeEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Index, int64_t Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zIndex;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zIndex);
	ZVAL_LONG(zIndex, (long)Index);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zIndex;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zIndex);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBPOP3State_ce_ptr = NULL;

SB_PHP_METHOD(TSBPOP3MessageID, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPOP3MessageID));
		intern->len = sizeof(TSBPOP3MessageID);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPOP3MessageID, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPOP3MessageID));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBPOP3MessageID, get_Index)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBPOP3MessageID, set_Index)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBPOP3MessageID, get_ID)
{
	SBStuctGetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TSBPOP3MessageID, set_ID)
{
	SBStuctSetFieldStringA(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *TSBPOP3MessageID_ce_ptr = NULL;

static zend_function_entry TSBPOP3MessageID_methods[] = {
	PHP_ME(TSBPOP3MessageID, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageID, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBPOP3MessageID, get_Index, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageID, set_Index, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageID, get_ID, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageID, set_ID, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBPOP3MessageID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPOP3MessageID_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPOP3MessageID", TSBPOP3MessageID_methods);
	TSBPOP3MessageID_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBPOP3MessageSize, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPOP3MessageSize));
		intern->len = sizeof(TSBPOP3MessageSize);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPOP3MessageSize, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPOP3MessageSize));
}

SB_PHP_METHOD(TSBPOP3MessageSize, get_Index)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBPOP3MessageSize, set_Index)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBPOP3MessageSize, get_Size)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TSBPOP3MessageSize, set_Size)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *TSBPOP3MessageSize_ce_ptr = NULL;

static zend_function_entry TSBPOP3MessageSize_methods[] = {
	PHP_ME(TSBPOP3MessageSize, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageSize, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBPOP3MessageSize, get_Index, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageSize, set_Index, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageSize, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPOP3MessageSize, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBPOP3MessageSize(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPOP3MessageSize_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPOP3MessageSize", TSBPOP3MessageSize_methods);
	TSBPOP3MessageSize_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPOP3Client_ce_ptr = NULL;

SB_PHP_METHOD(TElPOP3Client, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, DeleteMessage)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_DeleteMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, GetCapabilities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_GetCapabilities(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, GetMailboxInfo)
{
	int32_t l4MessagesRaw = 0;
	int64_t l8TotalSizeRaw = 0;
	zval *zl4Messages;
	zval *zl8TotalSize;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zl4Messages, &zl8TotalSize) == SUCCESS) && PZVAL_IS_REF(zl4Messages) && (IS_LONG == Z_TYPE_P(zl4Messages)) && PZVAL_IS_REF(zl8TotalSize) && (IS_LONG == Z_TYPE_P(zl8TotalSize)))
	{
		SBCheckError(TElPOP3Client_GetMailboxInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &l4MessagesRaw, &l8TotalSizeRaw) TSRMLS_CC);
		ZVAL_LONG(zl4Messages, (long)l4MessagesRaw);
		ZVAL_LONG(zl8TotalSize, (long)l8TotalSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, GetMailboxSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPOP3Client_GetMailboxSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, GetMessageCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_GetMessageCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, GetMessageID)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPOP3Client_GetMessageID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1842305015, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, GetMessageSize)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPOP3Client_GetMessageSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, Login)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Login(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, Noop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Noop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, Ping)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Ping(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, ReceiveMessage)
{
	char *sBodyCharset;
	char *sHeaderCharset;
	int sBodyCharset_len;
	int sHeaderCharset_len;
	long fOptions;
	long l4Count;
	long l4Index;
	long l4Offset;
	SBArrayZValInfo aiBuffer;
	TElClassHandle hoMessage = SB_NULL_HANDLE;
	zend_bool bActivatePartHandlers;
	zend_bool bIgnoreBodyNativeCharset;
	zend_bool bIgnoreHeaderNativeCharset;
	zval *oMessage;
	zval *oStream;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_ReceiveMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzll", &l4Index, &zaBuffer, &l4Offset, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPOP3Client_ReceiveMessage_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiBuffer.data, aiBuffer.len, (int32_t)l4Offset, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_ReceiveMessage_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsslbbbO", &l4Index, &sHeaderCharset, &sHeaderCharset_len, &sBodyCharset, &sBodyCharset_len, &fOptions, &bIgnoreHeaderNativeCharset, &bIgnoreBodyNativeCharset, &bActivatePartHandlers, &oMessage, TElMessage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oMessage) && (IS_OBJECT == Z_TYPE_P(oMessage)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_ReceiveMessage_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sHeaderCharset, (int32_t)sHeaderCharset_len, sBodyCharset, (int32_t)sBodyCharset_len, (TElMessageParsingOptionsRaw)fOptions, (int8_t)bIgnoreHeaderNativeCharset, (int8_t)bIgnoreBodyNativeCharset, (int8_t)bActivatePartHandlers, &hoMessage, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oMessage, hoMessage TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer, integer) or (integer, TStream) or (integer, string, string, integer, bool, bool, bool, &TElMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, ReceiveMessageHeader)
{
	char *sCharset;
	int32_t sCharset_len;
	long l4Index;
	TElClassHandle hoHeader = SB_NULL_HANDLE;
	uint32_t _err;
	zend_bool bIgnoreNativeCharset;
	zval *oHeader;
	zval *zsCharset;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzbO", &l4Index, &zsCharset, &bIgnoreNativeCharset, &oHeader, TElMessageHeader_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsCharset) && (IS_STRING == Z_TYPE_P(zsCharset)) && PZVAL_IS_REF(oHeader) && (IS_OBJECT == Z_TYPE_P(oHeader)))
	{
		int32_t l4OutResultRaw = 0;
		sCharset = Z_STRVAL_P(zsCharset);
		sCharset_len = (int32_t)Z_STRLEN_P(zsCharset);
		_err = TElPOP3Client_ReceiveMessageHeader(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sCharset, &sCharset_len, (int8_t)bIgnoreNativeCharset, &hoHeader, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sCharset = emalloc(sCharset_len + 1);
			SBCheckError(SBGetLastReturnStringA(311591661, 2, sCharset, &sCharset_len) TSRMLS_CC);
			zval_dtor(zsCharset);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sCharset[sCharset_len] = 0;
		ZVAL_STRINGL(zsCharset, sCharset, sCharset_len, 0);
		SBUpdateObjectHandle(oHeader, hoHeader TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &string, bool, &TElMessageHeader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, ReceiveMessageIDList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_ReceiveMessageIDList(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, ReceiveMessageLines)
{
	long l4Count;
	long l4Index;
	long l4LineCount;
	long l4Offset;
	SBArrayZValInfo aiBuffer;
	zval *oStream;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4LineCount) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_ReceiveMessageLines(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4LineCount) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llzll", &l4Index, &l4LineCount, &zaBuffer, &l4Offset, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPOP3Client_ReceiveMessageLines_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4LineCount, aiBuffer.data, aiBuffer.len, (int32_t)l4Offset, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4Index, &l4LineCount, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_ReceiveMessageLines_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4LineCount, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer, array of byte|string|NULL, integer, integer) or (integer, integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, ReceiveMessageList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_ReceiveMessageList(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, Undelete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPOP3Client_Undelete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_SASLMechanism)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_SASLMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_SASLMechanism)
{
	char *sName;
	int sName_len;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sName, &sName_len, &bValue) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_SASLMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_SASLMechanismPriorities)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_SASLMechanismPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_SASLMechanismPriorities)
{
	char *sName;
	int sName_len;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sName, &sName_len, &l4Value) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_SASLMechanismPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_AuthorizationPriorities)
{
	long fAuth;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAuth) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_AuthorizationPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPOP3AuthorizationRaw)fAuth, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_AuthorizationPriorities)
{
	long fAuth;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &fAuth, &l4Value) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_AuthorizationPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPOP3AuthorizationRaw)fAuth, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_Authorization)
{
	long fAuth;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAuth) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_Authorization(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPOP3AuthorizationRaw)fAuth, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_Authorization)
{
	long fAuth;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fAuth, &bValue) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_Authorization(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPOP3AuthorizationRaw)fAuth, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtAPOPSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtAPOPSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtUIDLSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtUIDLSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtUSERSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtUSERSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtTOPSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtTOPSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtRESP_CODESSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtRESP_CODESSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtLOGIN_DELAYSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtLOGIN_DELAYSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtEXPIRESupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtEXPIRESupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtIMPLEMENTATIONSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtIMPLEMENTATIONSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtSASLSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtSASLSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtSASLMechanisms)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStringList_Create(&hoOutResult) TSRMLS_CC);
		SBCheckError(TElPOP3Client_get_ExtSASLMechanisms(SBGetObjectHandle(getThis() TSRMLS_CC), hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TStringList_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtExpire)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtExpire(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtExpireUserChangeable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtExpireUserChangeable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtLoginDelay)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_ExtLoginDelay(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_ExtImplementation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPOP3Client_get_ExtImplementation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2002267818, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_SSLActive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_SSLActive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPOP3Client_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-61109148, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_AutoCAPA)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPOP3AutoCAPAModeRaw fOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_AutoCAPA(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_AutoCAPA)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_AutoCAPA(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPOP3AutoCAPAModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_MaxLineLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_MaxLineLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_MaxLineLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_MaxLineLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_SSLMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSLModeRaw fOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_SSLMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSLModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPOP3Client, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPOP3Client, get_UseSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPOP3Client_get_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_UseSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPOP3Client_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-87168274, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPOP3Client_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(928098892, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPOP3Client_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCapability)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPOP3TextLineEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCapability(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCapability)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCapability(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPOP3TextLineEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPOP3TextLineEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnLog)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPOP3LogEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnLog(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnLog)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnLog(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPOP3LogEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPOP3LogEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnMessageLine)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPOP3TextLineEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnMessageLine(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnMessageLine)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnMessageLine(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPOP3TextLineEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPOP3TextLineEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnMessageID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPOP3MessageIdEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnMessageID(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnMessageID)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnMessageID(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPOP3MessageIdEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPOP3MessageIdEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnMessageSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPOP3MessageSizeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnMessageSize(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnMessageSize)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnMessageSize(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPOP3MessageSizeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPOP3MessageSizeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCertificateChoose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBChooseCertificateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCertificateChoose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBChooseCertificateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBChooseCertificateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCertificateNeededEx)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateNeededExEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCertificateNeededEx)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateNeededExEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateNeededExEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCiphersNegotiated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCiphersNegotiated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnExtensionsReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnExtensionsReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnExtensionsPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnExtensionsPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnExtensionsPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnExtensionsPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnCertificateStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateStatusEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnCertificateStatus)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateStatusEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateStatusEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBClientKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBClientKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBClientKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnRenegotiationRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnRenegotiationRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBRenegotiationRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBRenegotiationRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPOP3Client, get_OnDNSKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnDNSKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnDNSKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnDNSKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, get_OnDNSResolve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPOP3Client_get_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPOP3Client, set_OnDNSResolve)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPOP3Client_set_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolveEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPOP3Client, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPOP3Client_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_DeleteMessage, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_GetCapabilities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_GetMailboxInfo, 0, 0, 2)
	ZEND_ARG_INFO(1, Messages)
	ZEND_ARG_INFO(1, TotalSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_GetMailboxSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_GetMessageCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_GetMessageID, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_GetMessageSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Login, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Noop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Ping, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_ReceiveMessage, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream_or_HeaderCharset, 0, 1)
	ZEND_ARG_INFO(0, Offset_or_BodyCharset)
	ZEND_ARG_INFO(0, Count_or_Options)
	ZEND_ARG_INFO(0, IgnoreHeaderNativeCharset)
	ZEND_ARG_INFO(0, IgnoreBodyNativeCharset)
	ZEND_ARG_INFO(0, ActivatePartHandlers)
	ZEND_ARG_OBJ_INFO(1, Message, TElMessage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_ReceiveMessageHeader, 0, 0, 4)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Charset)
	ZEND_ARG_INFO(0, IgnoreNativeCharset)
	ZEND_ARG_OBJ_INFO(1, Header, TElMessageHeader, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_ReceiveMessageIDList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_ReceiveMessageLines, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, LineCount)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_ReceiveMessageList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_Undelete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_SASLMechanism, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_SASLMechanism, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_SASLMechanismPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_SASLMechanismPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_AuthorizationPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Auth)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_AuthorizationPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Auth)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_Authorization, 0, 0, 1)
	ZEND_ARG_INFO(0, Auth)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_Authorization, 0, 0, 2)
	ZEND_ARG_INFO(0, Auth)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtAPOPSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtUIDLSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtUSERSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtTOPSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtRESP_CODESSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtLOGIN_DELAYSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtEXPIRESupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtIMPLEMENTATIONSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtSASLSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtSASLMechanisms, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtExpire, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtExpireUserChangeable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtLoginDelay, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_ExtImplementation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_SSLActive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_AutoCAPA, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_AutoCAPA, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_MaxLineLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_MaxLineLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_SSLMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_SSLMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_UseSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_UseSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCapability, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCapability, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnLog, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnLog, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnMessageLine, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnMessageLine, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnMessageID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnMessageID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnMessageSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnMessageSize, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCertificateChoose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCertificateChoose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCertificateNeededEx, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCertificateNeededEx, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCiphersNegotiated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCiphersNegotiated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnExtensionsReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnExtensionsReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnExtensionsPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnExtensionsPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnCertificateStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnCertificateStatus, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnRenegotiationRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnRenegotiationRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnDNSKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnDNSKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnDNSKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnDNSKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_get_OnDNSResolve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client_set_OnDNSResolve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPOP3Client___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPOP3Client_methods[] = {
	PHP_ME(TElPOP3Client, Close, arginfo_TElPOP3Client_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, DeleteMessage, arginfo_TElPOP3Client_DeleteMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, GetCapabilities, arginfo_TElPOP3Client_GetCapabilities, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, GetMailboxInfo, arginfo_TElPOP3Client_GetMailboxInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, GetMailboxSize, arginfo_TElPOP3Client_GetMailboxSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, GetMessageCount, arginfo_TElPOP3Client_GetMessageCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, GetMessageID, arginfo_TElPOP3Client_GetMessageID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, GetMessageSize, arginfo_TElPOP3Client_GetMessageSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, Login, arginfo_TElPOP3Client_Login, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, Open, arginfo_TElPOP3Client_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, Noop, arginfo_TElPOP3Client_Noop, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, Ping, arginfo_TElPOP3Client_Ping, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, ReceiveMessage, arginfo_TElPOP3Client_ReceiveMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, ReceiveMessageHeader, arginfo_TElPOP3Client_ReceiveMessageHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, ReceiveMessageIDList, arginfo_TElPOP3Client_ReceiveMessageIDList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, ReceiveMessageLines, arginfo_TElPOP3Client_ReceiveMessageLines, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, ReceiveMessageList, arginfo_TElPOP3Client_ReceiveMessageList, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, Reset, arginfo_TElPOP3Client_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, Undelete, arginfo_TElPOP3Client_Undelete, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_SASLMechanism, arginfo_TElPOP3Client_get_SASLMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_SASLMechanism, arginfo_TElPOP3Client_set_SASLMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_SASLMechanismPriorities, arginfo_TElPOP3Client_get_SASLMechanismPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_SASLMechanismPriorities, arginfo_TElPOP3Client_set_SASLMechanismPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_AuthorizationPriorities, arginfo_TElPOP3Client_get_AuthorizationPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_AuthorizationPriorities, arginfo_TElPOP3Client_set_AuthorizationPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_Authorization, arginfo_TElPOP3Client_get_Authorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_Authorization, arginfo_TElPOP3Client_set_Authorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtAPOPSupported, arginfo_TElPOP3Client_get_ExtAPOPSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtUIDLSupported, arginfo_TElPOP3Client_get_ExtUIDLSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtUSERSupported, arginfo_TElPOP3Client_get_ExtUSERSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtTOPSupported, arginfo_TElPOP3Client_get_ExtTOPSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtRESP_CODESSupported, arginfo_TElPOP3Client_get_ExtRESP_CODESSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtLOGIN_DELAYSupported, arginfo_TElPOP3Client_get_ExtLOGIN_DELAYSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtEXPIRESupported, arginfo_TElPOP3Client_get_ExtEXPIRESupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtIMPLEMENTATIONSupported, arginfo_TElPOP3Client_get_ExtIMPLEMENTATIONSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtSASLSupported, arginfo_TElPOP3Client_get_ExtSASLSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtSASLMechanisms, arginfo_TElPOP3Client_get_ExtSASLMechanisms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtExpire, arginfo_TElPOP3Client_get_ExtExpire, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtExpireUserChangeable, arginfo_TElPOP3Client_get_ExtExpireUserChangeable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtLoginDelay, arginfo_TElPOP3Client_get_ExtLoginDelay, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_ExtImplementation, arginfo_TElPOP3Client_get_ExtImplementation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_SSLActive, arginfo_TElPOP3Client_get_SSLActive, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_Address, arginfo_TElPOP3Client_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_Address, arginfo_TElPOP3Client_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_AutoCAPA, arginfo_TElPOP3Client_get_AutoCAPA, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_AutoCAPA, arginfo_TElPOP3Client_set_AutoCAPA, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_MaxLineLength, arginfo_TElPOP3Client_get_MaxLineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_MaxLineLength, arginfo_TElPOP3Client_set_MaxLineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_Port, arginfo_TElPOP3Client_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_Port, arginfo_TElPOP3Client_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_SSLMode, arginfo_TElPOP3Client_get_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_SSLMode, arginfo_TElPOP3Client_set_SSLMode, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPOP3Client, get_UseIPv6, arginfo_TElPOP3Client_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_UseIPv6, arginfo_TElPOP3Client_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPOP3Client, get_UseSSL, arginfo_TElPOP3Client_get_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_UseSSL, arginfo_TElPOP3Client_set_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_Username, arginfo_TElPOP3Client_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_Username, arginfo_TElPOP3Client_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_Password, arginfo_TElPOP3Client_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_Password, arginfo_TElPOP3Client_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCapability, arginfo_TElPOP3Client_get_OnCapability, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCapability, arginfo_TElPOP3Client_set_OnCapability, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnLog, arginfo_TElPOP3Client_get_OnLog, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnLog, arginfo_TElPOP3Client_set_OnLog, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnMessageLine, arginfo_TElPOP3Client_get_OnMessageLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnMessageLine, arginfo_TElPOP3Client_set_OnMessageLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnMessageID, arginfo_TElPOP3Client_get_OnMessageID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnMessageID, arginfo_TElPOP3Client_set_OnMessageID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnMessageSize, arginfo_TElPOP3Client_get_OnMessageSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnMessageSize, arginfo_TElPOP3Client_set_OnMessageSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnProgress, arginfo_TElPOP3Client_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnProgress, arginfo_TElPOP3Client_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCertificateChoose, arginfo_TElPOP3Client_get_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCertificateChoose, arginfo_TElPOP3Client_set_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCertificateNeededEx, arginfo_TElPOP3Client_get_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCertificateNeededEx, arginfo_TElPOP3Client_set_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCertificateValidate, arginfo_TElPOP3Client_get_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCertificateValidate, arginfo_TElPOP3Client_set_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCiphersNegotiated, arginfo_TElPOP3Client_get_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCiphersNegotiated, arginfo_TElPOP3Client_set_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCloseConnection, arginfo_TElPOP3Client_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCloseConnection, arginfo_TElPOP3Client_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnError, arginfo_TElPOP3Client_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnError, arginfo_TElPOP3Client_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnExtensionsReceived, arginfo_TElPOP3Client_get_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnExtensionsReceived, arginfo_TElPOP3Client_set_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnExtensionsPrepared, arginfo_TElPOP3Client_get_OnExtensionsPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnExtensionsPrepared, arginfo_TElPOP3Client_set_OnExtensionsPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnCertificateStatus, arginfo_TElPOP3Client_get_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnCertificateStatus, arginfo_TElPOP3Client_set_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnKeyNeeded, arginfo_TElPOP3Client_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnKeyNeeded, arginfo_TElPOP3Client_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnRenegotiationRequest, arginfo_TElPOP3Client_get_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnRenegotiationRequest, arginfo_TElPOP3Client_set_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPOP3Client, get_OnDNSKeyNeeded, arginfo_TElPOP3Client_get_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnDNSKeyNeeded, arginfo_TElPOP3Client_set_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnDNSKeyValidate, arginfo_TElPOP3Client_get_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnDNSKeyValidate, arginfo_TElPOP3Client_set_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, get_OnDNSResolve, arginfo_TElPOP3Client_get_OnDNSResolve, ZEND_ACC_PUBLIC)
	PHP_ME(TElPOP3Client, set_OnDNSResolve, arginfo_TElPOP3Client_set_OnDNSResolve, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPOP3Client, __construct, arginfo_TElPOP3Client___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPOP3Client(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPOP3Client_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPOP3Client", TElPOP3Client_methods);
	if (NULL == TElCustomSimpleSSLClient_ce_ptr)
		Register_TElCustomSimpleSSLClient(TSRMLS_C);
	TElPOP3Client_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSimpleSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPOP3Client_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, ERROR_FACILITY_POP3, SB_ERROR_FACILITY_POP3, SB_ERROR_FACILITY_POP3);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, ERROR_POP3_PROTOCOL_ERROR_FLAG, SB_ERROR_POP3_PROTOCOL_ERROR_FLAG, SB_ERROR_POP3_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_NOT_CONNECTED, SB_POP3_ERROR_NOT_CONNECTED, SB_POP3_ERROR_NOT_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_ALREADY_CONNECTED, SB_POP3_ERROR_ALREADY_CONNECTED, SB_POP3_ERROR_ALREADY_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_INVALID_STATE, SB_POP3_ERROR_INVALID_STATE, SB_POP3_ERROR_INVALID_STATE);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_INVALID_LENGTH, SB_POP3_ERROR_INVALID_LENGTH, SB_POP3_ERROR_INVALID_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_SMALL_LENGTH, SB_POP3_ERROR_SMALL_LENGTH, SB_POP3_ERROR_SMALL_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_NO_ADDRESS, SB_POP3_ERROR_NO_ADDRESS, SB_POP3_ERROR_NO_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_EMPTY_REPLY, SB_POP3_ERROR_EMPTY_REPLY, SB_POP3_ERROR_EMPTY_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_INVALID_REPLY, SB_POP3_ERROR_INVALID_REPLY, SB_POP3_ERROR_INVALID_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_INSUFFICIENT_BUFFER, SB_POP3_ERROR_INSUFFICIENT_BUFFER, SB_POP3_ERROR_INSUFFICIENT_BUFFER);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_TOO_LONG_LINE, SB_POP3_ERROR_TOO_LONG_LINE, SB_POP3_ERROR_TOO_LONG_LINE);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_AUTHORIZATION_FAILED, SB_POP3_ERROR_AUTHORIZATION_FAILED, SB_POP3_ERROR_AUTHORIZATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_MESSAGE_FAILED, SB_POP3_ERROR_MESSAGE_FAILED, SB_POP3_ERROR_MESSAGE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_DELETE_FAILED, SB_POP3_ERROR_DELETE_FAILED, SB_POP3_ERROR_DELETE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_MAILBOX_INFO_FAILED, SB_POP3_ERROR_MAILBOX_INFO_FAILED, SB_POP3_ERROR_MAILBOX_INFO_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_CAPABILITIES_FAILED, SB_POP3_ERROR_CAPABILITIES_FAILED, SB_POP3_ERROR_CAPABILITIES_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_SSL_SESSION_FAILURE, SB_POP3_ERROR_SSL_SESSION_FAILURE, SB_POP3_ERROR_SSL_SESSION_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_ID_INFO_FAILED, SB_POP3_ERROR_ID_INFO_FAILED, SB_POP3_ERROR_ID_INFO_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_ALLID_INFO_FAILED, SB_POP3_ERROR_ALLID_INFO_FAILED, SB_POP3_ERROR_ALLID_INFO_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_TOP_INFO_FAILED, SB_POP3_ERROR_TOP_INFO_FAILED, SB_POP3_ERROR_TOP_INFO_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPOP3Client, SB_POP3_ERROR_SIZE_INFO_FAILED, SB_POP3_ERROR_SIZE_INFO_FAILED, SB_POP3_ERROR_SIZE_INFO_FAILED);
}

void Register_SBPOP3Client_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPOP3Authorization", NULL);
	TSBPOP3Authorization_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPOP3Authorization_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3Authorization_ce_ptr, "popUSER", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3Authorization_ce_ptr, "popAPOP", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3Authorization_ce_ptr, "popSASL", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPOP3Authorizations", NULL);
	TSBPOP3Authorizations_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBPOP3Authorizations_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3Authorizations_ce_ptr, "popUSER", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3Authorizations_ce_ptr, "popAPOP", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3Authorizations_ce_ptr, "popSASL", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBPOP3AutoCAPAMode", NULL);
	TSBPOP3AutoCAPAMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPOP3AutoCAPAMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3AutoCAPAMode_ce_ptr, "capaNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3AutoCAPAMode_ce_ptr, "capaOnConnect", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3AutoCAPAMode_ce_ptr, "capaOnLogin", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3AutoCAPAMode_ce_ptr, "capaBoth", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPOP3LogDirection", NULL);
	TSBPOP3LogDirection_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPOP3LogDirection_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3LogDirection_ce_ptr, "popSent", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3LogDirection_ce_ptr, "popReceived", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBPOP3State", NULL);
	TSBPOP3State_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPOP3State_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3State_ce_ptr, "popAuthorization", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3State_ce_ptr, "popTransaction", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPOP3State_ce_ptr, "popUpdate", 2)
}

void Register_SBPOP3Client_Aliases(TSRMLS_D)
{
	if (NULL == TElPOP3Client_ce_ptr)
		Register_TElPOP3Client(TSRMLS_C);
	zend_register_class_alias("ElPOP3Client", TElPOP3Client_ce_ptr);
}
