#include "sbrdn.h"

zend_class_entry *TElRelativeDistinguishedName_ce_ptr = NULL;

SB_PHP_METHOD(TElRelativeDistinguishedName, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, LoadFromTag)
{
	zend_bool bIgnoreTopSequence;
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oTag, TElASN1ConstrainedTag_ce_ptr, &bIgnoreTopSequence) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_LoadFromTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC), (int8_t)bIgnoreTopSequence, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, LoadFromDNString)
{
	char *sS;
	int sS_len;
	zend_bool bLiberalMode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sS, &sS_len, &bLiberalMode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_LoadFromDNString(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, (int8_t)bLiberalMode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, SaveToTag)
{
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_SaveToTag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTag TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, SaveToDNString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRelativeDistinguishedName_SaveToDNString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1835934418, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, Add)
{
	long u1Tag;
	SBArrayZValInfo aiOID;
	SBArrayZValInfo aiValue;
	zval *zaOID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaOID, &zaValue, &u1Tag) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRelativeDistinguishedName_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, aiValue.data, aiValue.len, (uint8_t)u1Tag, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, IndexOf)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRelativeDistinguishedName_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, GetValuesByOID)
{
	SBArrayZValInfo aiOID;
	zval *oValues;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oValues, TElByteArrayList_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRelativeDistinguishedName_GetValuesByOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, SBGetObjectHandle(oValues TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElByteArrayList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, GetFirstValueByOID)
{
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = TElRelativeDistinguishedName_GetFirstValueByOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(287711376, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, GetStringValuesByOID)
{
	char *sValueSeparator;
	int sValueSeparator_len;
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zend_bool bEncodeSpecialChars;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = TElRelativeDistinguishedName_GetStringValuesByOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-803822683, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsb", &zaOID, &sValueSeparator, &sValueSeparator_len, &bEncodeSpecialChars) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = TElRelativeDistinguishedName_GetStringValuesByOID_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, sValueSeparator, (int32_t)sValueSeparator_len, (int8_t)bEncodeSpecialChars, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1259119586, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, GetFirstStringValueByOID)
{
	SBArrayZValInfo aiOID;
	uint32_t _err;
	zend_bool bEncodeSpecialChars;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = TElRelativeDistinguishedName_GetFirstStringValueByOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1801065931, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaOID, &bEncodeSpecialChars) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		_err = TElRelativeDistinguishedName_GetFirstStringValueByOID_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, (int8_t)bEncodeSpecialChars, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1813611091, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiOID);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, Contains)
{
	zend_bool bIgnoreTags;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oRDN, TElRelativeDistinguishedName_ce_ptr, &bIgnoreTags) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_Contains(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRDN TSRMLS_CC), (int8_t)bIgnoreTags, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, get_Values)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRelativeDistinguishedName_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1387381064, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, set_Values)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRelativeDistinguishedName_set_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, get_NormValues)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRelativeDistinguishedName_get_NormValues(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-936642720, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, set_NormValues)
{
	char *sValue;
	int sValue_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_set_NormValues(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, get_OIDs)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRelativeDistinguishedName_get_OIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(607574137, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, set_OIDs)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRelativeDistinguishedName_set_OIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, get_Tags)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_get_Tags(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, set_Tags)
{
	long l4Index;
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &u1Value) == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_set_Tags(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, get_Groups)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_get_Groups(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, set_Groups)
{
	long l4Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_set_Groups(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRelativeDistinguishedName_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, set_Count)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRelativeDistinguishedName_set_Count(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRelativeDistinguishedName, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRelativeDistinguishedName_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_LoadFromTag, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
	ZEND_ARG_INFO(0, IgnoreTopSequence)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_LoadFromDNString, 0, 0, 2)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, LiberalMode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_SaveToTag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tag, TElASN1ConstrainedTag, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_SaveToDNString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_Add, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
	ZEND_ARG_INFO(0, Tag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_GetValuesByOID, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Values, TElByteArrayList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_GetFirstValueByOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_GetStringValuesByOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
	ZEND_ARG_INFO(0, ValueSeparator)
	ZEND_ARG_INFO(0, EncodeSpecialChars)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_GetFirstStringValueByOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
	ZEND_ARG_INFO(0, EncodeSpecialChars)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_Contains, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, RDN, TElRelativeDistinguishedName, 1)
	ZEND_ARG_INFO(0, IgnoreTags)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_set_Values, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_get_NormValues, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_set_NormValues, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_get_OIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_set_OIDs, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_get_Tags, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_set_Tags, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_get_Groups, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_set_Groups, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName_set_Count, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRelativeDistinguishedName___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRelativeDistinguishedName_methods[] = {
	PHP_ME(TElRelativeDistinguishedName, Assign, arginfo_TElRelativeDistinguishedName_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, LoadFromTag, arginfo_TElRelativeDistinguishedName_LoadFromTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, LoadFromDNString, arginfo_TElRelativeDistinguishedName_LoadFromDNString, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, SaveToTag, arginfo_TElRelativeDistinguishedName_SaveToTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, SaveToDNString, arginfo_TElRelativeDistinguishedName_SaveToDNString, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, Add, arginfo_TElRelativeDistinguishedName_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, Remove, arginfo_TElRelativeDistinguishedName_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, IndexOf, arginfo_TElRelativeDistinguishedName_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, Clear, arginfo_TElRelativeDistinguishedName_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, GetValuesByOID, arginfo_TElRelativeDistinguishedName_GetValuesByOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, GetFirstValueByOID, arginfo_TElRelativeDistinguishedName_GetFirstValueByOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, GetStringValuesByOID, arginfo_TElRelativeDistinguishedName_GetStringValuesByOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, GetFirstStringValueByOID, arginfo_TElRelativeDistinguishedName_GetFirstStringValueByOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, Contains, arginfo_TElRelativeDistinguishedName_Contains, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, get_Values, arginfo_TElRelativeDistinguishedName_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, set_Values, arginfo_TElRelativeDistinguishedName_set_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, get_NormValues, arginfo_TElRelativeDistinguishedName_get_NormValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, set_NormValues, arginfo_TElRelativeDistinguishedName_set_NormValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, get_OIDs, arginfo_TElRelativeDistinguishedName_get_OIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, set_OIDs, arginfo_TElRelativeDistinguishedName_set_OIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, get_Tags, arginfo_TElRelativeDistinguishedName_get_Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, set_Tags, arginfo_TElRelativeDistinguishedName_set_Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, get_Groups, arginfo_TElRelativeDistinguishedName_get_Groups, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, set_Groups, arginfo_TElRelativeDistinguishedName_set_Groups, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, get_Count, arginfo_TElRelativeDistinguishedName_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, set_Count, arginfo_TElRelativeDistinguishedName_set_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElRelativeDistinguishedName, __construct, arginfo_TElRelativeDistinguishedName___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRelativeDistinguishedName(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRelativeDistinguishedName_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRelativeDistinguishedName", TElRelativeDistinguishedName_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElRelativeDistinguishedName_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRDNConverter_ce_ptr = NULL;

SB_PHP_METHOD(TElRDNConverter, SaveToDNString)
{
	uint32_t _err;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRDN, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRDNConverter_SaveToDNString(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRDN TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1737738368, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRDNConverter, LoadFromDNString)
{
	char *sS;
	int sS_len;
	zend_bool bLiberalMode;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oRDN, TElRelativeDistinguishedName_ce_ptr, &sS, &sS_len, &bLiberalMode) == SUCCESS)
	{
		SBCheckError(TElRDNConverter_LoadFromDNString(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRDN TSRMLS_CC), sS, (int32_t)sS_len, (int8_t)bLiberalMode) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRDNConverter, get_Separator)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRDNConverter_get_Separator(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-637289994, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRDNConverter, set_Separator)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRDNConverter_set_Separator(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRDNConverter, get_InsertSeparatorPrefix)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRDNConverter_get_InsertSeparatorPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRDNConverter, set_InsertSeparatorPrefix)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElRDNConverter_set_InsertSeparatorPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRDNConverter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRDNConverter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter_SaveToDNString, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, RDN, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter_LoadFromDNString, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, RDN, TElRelativeDistinguishedName, 1)
	ZEND_ARG_INFO(0, S)
	ZEND_ARG_INFO(0, LiberalMode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter_get_Separator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter_set_Separator, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter_get_InsertSeparatorPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter_set_InsertSeparatorPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRDNConverter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRDNConverter_methods[] = {
	PHP_ME(TElRDNConverter, SaveToDNString, arginfo_TElRDNConverter_SaveToDNString, ZEND_ACC_PUBLIC)
	PHP_ME(TElRDNConverter, LoadFromDNString, arginfo_TElRDNConverter_LoadFromDNString, ZEND_ACC_PUBLIC)
	PHP_ME(TElRDNConverter, get_Separator, arginfo_TElRDNConverter_get_Separator, ZEND_ACC_PUBLIC)
	PHP_ME(TElRDNConverter, set_Separator, arginfo_TElRDNConverter_set_Separator, ZEND_ACC_PUBLIC)
	PHP_ME(TElRDNConverter, get_InsertSeparatorPrefix, arginfo_TElRDNConverter_get_InsertSeparatorPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElRDNConverter, set_InsertSeparatorPrefix, arginfo_TElRDNConverter_set_InsertSeparatorPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElRDNConverter, __construct, arginfo_TElRDNConverter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRDNConverter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRDNConverter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRDNConverter", TElRDNConverter_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElRDNConverter_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBRDN, FormatRDN)
{
	uint32_t _err;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRDN, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRDN_FormatRDN(SBGetObjectHandle(oRDN TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1619204522, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, MapUnicodeString)
{
	char *sstr;
	int sstr_len;
	uint32_t _err;
	zend_bool bCaseIgnore;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sstr, &sstr_len, &bCaseIgnore) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRDN_MapUnicodeString(sstr, (int32_t)sstr_len, (int8_t)bCaseIgnore, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1789814043, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, InsignificantSpaceHandling)
{
	char *sstr;
	int sstr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sstr, &sstr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRDN_InsignificantSpaceHandling(sstr, (int32_t)sstr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1413898460, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, GetRDNStringValue)
{
	long l4Index;
	uint32_t _err;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oRDN, TElRelativeDistinguishedName_ce_ptr, &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRDN_GetRDNStringValue(SBGetObjectHandle(oRDN TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1651981216, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, GetNormalizedRDNStringValue)
{
	long l4Index;
	uint32_t _err;
	zval *oRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oRDN, TElRelativeDistinguishedName_ce_ptr, &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRDN_GetNormalizedRDNStringValue(SBGetObjectHandle(oRDN TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1033659806, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, GetNormalizedRDNString)
{
	char *sValue;
	int sValue_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBRDN_GetNormalizedRDNString(sValue, (int32_t)sValue_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-987387093, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, CompareRDN)
{
	zval *oName1;
	zval *oName2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oName1, TElRelativeDistinguishedName_ce_ptr, &oName2, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRDN_CompareRDN(SBGetObjectHandle(oName1 TSRMLS_CC), SBGetObjectHandle(oName2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, CompareRDNAsStrings)
{
	zval *oName1;
	zval *oName2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oName1, TElRelativeDistinguishedName_ce_ptr, &oName2, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRDN_CompareRDNAsStrings(SBGetObjectHandle(oName1 TSRMLS_CC), SBGetObjectHandle(oName2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, NonstrictCompareRDN)
{
	zval *oInnerRDN;
	zval *oOuterRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oInnerRDN, TElRelativeDistinguishedName_ce_ptr, &oOuterRDN, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRDN_NonstrictCompareRDN(SBGetObjectHandle(oInnerRDN TSRMLS_CC), SBGetObjectHandle(oOuterRDN TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, NonstrictCompareRDNAsStrings)
{
	zval *oInnerRDN;
	zval *oOuterRDN;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oInnerRDN, TElRelativeDistinguishedName_ce_ptr, &oOuterRDN, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRDN_NonstrictCompareRDNAsStrings(SBGetObjectHandle(oInnerRDN TSRMLS_CC), SBGetObjectHandle(oOuterRDN TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, GetIgnoreTagsWhenComparingRDNs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRDN_GetIgnoreTagsWhenComparingRDNs(&bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRDN, SetIgnoreTagsWhenComparingRDNs)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(SBRDN_SetIgnoreTagsWhenComparingRDNs((int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

void Register_SBRDN_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBRDN, NullCharsCount, SB_NullCharsCount, SB_NullCharsCount);
	SB_REGISTER_LONG_CONSTANT(SBRDN, SpaceCharsCount, SB_SpaceCharsCount, SB_SpaceCharsCount);
}

void Register_SBRDN_Aliases(TSRMLS_D)
{
	if (NULL == TElRelativeDistinguishedName_ce_ptr)
		Register_TElRelativeDistinguishedName(TSRMLS_C);
	zend_register_class_alias("ElRelativeDistinguishedName", TElRelativeDistinguishedName_ce_ptr);
}

