#include "sbripemd.h"

SB_PHP_METHOD(TRMD160Buffer, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TRMD160Buffer));
		intern->len = sizeof(TRMD160Buffer);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TRMD160Buffer, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TRMD160Buffer));
}

zend_class_entry *TRMD160Buffer_ce_ptr = NULL;

static zend_function_entry TRMD160Buffer_methods[] = {
	PHP_ME(TRMD160Buffer, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Buffer, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TRMD160Buffer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TRMD160Buffer_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TRMD160Buffer", TRMD160Buffer_methods);
	TRMD160Buffer_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TRMD160Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TRMD160Context));
		intern->len = sizeof(TRMD160Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TRMD160Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TRMD160Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TRMD160Context, get_BufSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TRMD160Context, set_BufSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(TRMD160Context, get_h1)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TRMD160Context, set_h1)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(TRMD160Context, get_h2)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TRMD160Context, set_h2)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(TRMD160Context, get_h3)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TRMD160Context, set_h3)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(TRMD160Context, get_h4)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(TRMD160Context, set_h4)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(TRMD160Context, get_h5)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(TRMD160Context, set_h5)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(TRMD160Context, get_MessageSizeLo)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(TRMD160Context, set_MessageSizeLo)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(TRMD160Context, get_MessageSizeHi)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(TRMD160Context, set_MessageSizeHi)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

zend_class_entry *TRMD160Context_ce_ptr = NULL;

static zend_function_entry TRMD160Context_methods[] = {
	PHP_ME(TRMD160Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TRMD160Context, get_BufSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_BufSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_h1, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_h1, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_h2, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_h2, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_h3, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_h3, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_h4, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_h4, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_h5, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_h5, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_MessageSizeLo, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_MessageSizeLo, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, get_MessageSizeHi, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRMD160Context, set_MessageSizeHi, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TRMD160Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TRMD160Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TRMD160Context", TRMD160Context_methods);
	TRMD160Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBRIPEMD, InitializeRMD160)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TRMD160Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBRIPEMD_InitializeRMD160((TRMD160Context *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TRMD160Context)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRIPEMD, HashRMD160)
{
	char *sBuffer;
	int sBuffer_len;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zpBuffer;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TRMD160Context_ce_ptr, &zpChunk, &l4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRIPEMD_HashRMD160((TRMD160Context *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TMessageDigest160 roOutResult;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRIPEMD_HashRMD160_1(piBuffer.data, (int32_t)l4Size, &roOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBuffer, &sBuffer_len) == SUCCESS)
	{
		TMessageDigest160 roOutResult;
		SBCheckError(SBRIPEMD_HashRMD160_2(sBuffer, (int32_t)sBuffer_len, &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TRMD160Context, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRIPEMD, FinalizeRMD160)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TRMD160Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest160 roOutResult;
		SBCheckError(SBRIPEMD_FinalizeRMD160((TRMD160Context *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest160_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest160) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TRMD160Context)" TSRMLS_CC);
	}
}

