#include "sbsftphandler.h"

zend_class_entry *TElSFTPSSHSubsystemHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, HandlerType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHSubsystemHandlerTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSFTPSSHSubsystemHandler_HandlerType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPSSHSubsystemHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSFTPSSHSubsystemHandler_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSFTPSSHSubsystemHandler_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSFTPSSHSubsystemHandler_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSftpVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, get_NewLineConvention)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSFTPSSHSubsystemHandler_get_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(602595569, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, set_NewLineConvention)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSFTPSSHSubsystemHandler_set_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, get_Server)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPSSHSubsystemHandler_get_Server(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSFTPServer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, set_Server)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSFTPServer_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSFTPSSHSubsystemHandler_set_Server(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, __construct)
{
	zval *oConnection;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oConnection, TElSSHTunnelConnection_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPSSHSubsystemHandler_Create(SBGetObjectHandle(oConnection TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPSSHSubsystemHandler, CreateDelayed)
{
	zval *oConnection;
	zval *oServer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oConnection, TElSSHTunnelConnection_ce_ptr, &oServer, TElSFTPServer_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPSSHSubsystemHandler_CreateDelayed(SBGetObjectHandle(oConnection TSRMLS_CC), SBGetObjectHandle(oServer TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElSFTPSSHSubsystemHandler_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHTunnelConnection, TElSFTPServer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_HandlerType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_get_NewLineConvention, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_set_NewLineConvention, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_get_Server, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_set_Server, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSFTPServer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPSSHSubsystemHandler_CreateDelayed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Connection, TElSSHTunnelConnection, 1)
	ZEND_ARG_OBJ_INFO(0, Server, TElSFTPServer, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSFTPSSHSubsystemHandler_methods[] = {
	PHP_ME(TElSFTPSSHSubsystemHandler, HandlerType, arginfo_TElSFTPSSHSubsystemHandler_HandlerType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, ClassType, arginfo_TElSFTPSSHSubsystemHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, get_Version, arginfo_TElSFTPSSHSubsystemHandler_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, get_Versions, arginfo_TElSFTPSSHSubsystemHandler_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, set_Versions, arginfo_TElSFTPSSHSubsystemHandler_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, get_NewLineConvention, arginfo_TElSFTPSSHSubsystemHandler_get_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, set_NewLineConvention, arginfo_TElSFTPSSHSubsystemHandler_set_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, get_Server, arginfo_TElSFTPSSHSubsystemHandler_get_Server, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, set_Server, arginfo_TElSFTPSSHSubsystemHandler_set_Server, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, __construct, arginfo_TElSFTPSSHSubsystemHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPSSHSubsystemHandler, CreateDelayed, arginfo_TElSFTPSSHSubsystemHandler_CreateDelayed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElSFTPSSHSubsystemHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSFTPSSHSubsystemHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSFTPSSHSubsystemHandler", TElSFTPSSHSubsystemHandler_methods);
	if (NULL == TElCustomSSHSubsystemHandler_ce_ptr)
		Register_TElCustomSSHSubsystemHandler(TSRMLS_C);
	TElSFTPSSHSubsystemHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSSHSubsystemHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSftpHandler_Aliases(TSRMLS_D)
{
	if (NULL == TElSFTPSSHSubsystemHandler_ce_ptr)
		Register_TElSFTPSSHSubsystemHandler(TSRMLS_C);
	zend_register_class_alias("ElSFTPSSHSubsystemHandler", TElSFTPSSHSubsystemHandler_ce_ptr);
}

