#include "sbsftpserver.h"

zend_class_entry *TSBSftpHandle_ce_ptr = NULL;

SB_PHP_METHOD(TSBSftpHandle, get_Allocated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TSBSftpHandle_get_Allocated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_Allocated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TSBSftpHandle_set_Allocated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TSBSftpHandle_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1300510984, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TSBSftpHandle_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, get_Info)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBSftpHandle_get_Info(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpFileInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_Info)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSftpFileInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TSBSftpHandle_set_Info(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpFileInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, get_InfoUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TSBSftpHandle_get_InfoUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_InfoUsed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TSBSftpHandle_set_InfoUsed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, get_Eof)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TSBSftpHandle_get_Eof(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_Eof)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TSBSftpHandle_set_Eof(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, get_Data)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TSBSftpHandle_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_Data)
{
	SBArrayZValInfo piValue;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpValue) == SUCCESS) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TSBSftpHandle_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), piValue.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piValue);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, get_Directory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TSBSftpHandle_get_Directory(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, set_Directory)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TSBSftpHandle_set_Directory(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBSftpHandle, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBSftpHandle_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_Allocated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_Allocated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_Info, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_Info, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSftpFileInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_InfoUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_InfoUsed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_Eof, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_Eof, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_get_Directory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle_set_Directory, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBSftpHandle___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TSBSftpHandle_methods[] = {
	PHP_ME(TSBSftpHandle, get_Allocated, arginfo_TSBSftpHandle_get_Allocated, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_Allocated, arginfo_TSBSftpHandle_set_Allocated, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, get_Name, arginfo_TSBSftpHandle_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_Name, arginfo_TSBSftpHandle_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, get_Info, arginfo_TSBSftpHandle_get_Info, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_Info, arginfo_TSBSftpHandle_set_Info, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, get_InfoUsed, arginfo_TSBSftpHandle_get_InfoUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_InfoUsed, arginfo_TSBSftpHandle_set_InfoUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, get_Eof, arginfo_TSBSftpHandle_get_Eof, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_Eof, arginfo_TSBSftpHandle_set_Eof, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, get_Data, arginfo_TSBSftpHandle_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_Data, arginfo_TSBSftpHandle_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, get_Directory, arginfo_TSBSftpHandle_get_Directory, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, set_Directory, arginfo_TSBSftpHandle_set_Directory, ZEND_ACC_PUBLIC)
	PHP_ME(TSBSftpHandle, __construct, arginfo_TSBSftpHandle___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBSftpHandle(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBSftpHandle_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBSftpHandle", TSBSftpHandle_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TSBSftpHandle_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSFTPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElSFTPServer, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSFTPServer_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSFTPServer_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSFTPServer_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_ServerVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_ServerVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_ServerVersion)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_ServerVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_NewLineConvention)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSFTPServer_get_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1281203486, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_NewLineConvention)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSFTPServer_set_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_NegotiatedCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSFTPServer_get_NegotiatedCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-145528164, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_UseUTF8OnSFTP3)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_UseUTF8OnSFTP3(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_UseUTF8OnSFTP3)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_UseUTF8OnSFTP3(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_RemoteCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSFTPServer_get_RemoteCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-300772317, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_RemoteCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_RemoteCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_LocalCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSFTPServer_get_LocalCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1686752018, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_LocalCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_LocalCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_NoCharacterEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_NoCharacterEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_NoCharacterEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_NoCharacterEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_Supported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPServer_get_Supported(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpSupportedExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_ClientVendorID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPServer_get_ClientVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpVendorIDExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_FilenameCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSFTPServer_get_FilenameCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1764326096, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_FilenameCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_FilenameCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSFTPServer_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSFTPServer_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSftpVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerBlockEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnBlock)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnBlock(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerBlockEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerBlockEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnUnblock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerUnblockEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnUnblock(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnUnblock)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnUnblock(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerUnblockEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerUnblockEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnCloseHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCloseHandleEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnCloseHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnCloseHandle)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnCloseHandle(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCloseHandleEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCloseHandleEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnCreateDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCreateDirectoryEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnCreateDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnCreateDirectory)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnCreateDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCreateDirectoryEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCreateDirectoryEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnCreateSymLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCreateSymLinkEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnCreateSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnCreateSymLink)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnCreateSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCreateSymLinkEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCreateSymLinkEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnCreateHardLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCreateHardLinkEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnCreateHardLink(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnCreateHardLink)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnCreateHardLink(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCreateHardLinkEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCreateHardLinkEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnFindClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerFindCloseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnFindClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnFindClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnFindClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerFindCloseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerFindCloseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnFindFirst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerFindFirstEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnFindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnFindFirst)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnFindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerFindFirstEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerFindFirstEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnFindNext)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerFindNextEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnFindNext(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnFindNext)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnFindNext(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerFindNextEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerFindNextEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnOpenFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerOpenFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnOpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnOpenFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnOpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerOpenFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerOpenFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnReadFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnReadFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnReadFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnReadFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnReadSymLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReadSymLinkEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnReadSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnReadSymLink)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnReadSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReadSymLinkEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReadSymLinkEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRemove)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRemoveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRemove(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRemove)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRemove(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRemoveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRemoveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRenameFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRenameFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRenameFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRenameFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRenameFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRenameFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRenameFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestAbsolutePath)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAbsolutePathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestAbsolutePath)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAbsolutePathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAbsolutePathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAttributesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestAttributes)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAttributesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAttributesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestAttributes2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAttributes2Event pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestAttributes2)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAttributes2EventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAttributes2Event|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnSetAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSetAttributesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnSetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnSetAttributes)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnSetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSetAttributesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSetAttributesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnSetAttributes2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSetAttributes2Event pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnSetAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnSetAttributes2)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnSetAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSetAttributes2EventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSetAttributes2Event|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnTextSeek)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerTextSeekEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnTextSeek(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnTextSeek)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnTextSeek(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerTextSeekEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerTextSeekEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnWriteFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnWriteFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnWriteFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnWriteFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnExtendedRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerExtendedRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnExtendedRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnExtendedRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnExtendedRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerExtendedRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerExtendedRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnVersionChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSftpServerVersionChangeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnVersionChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnVersionChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnVersionChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSftpServerVersionChangeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpServerVersionChangeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnSendVendorID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSendVendorIDEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnSendVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnSendVendorID)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnSendVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSendVendorIDEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSendVendorIDEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestFileHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestFileHashEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestFileHash)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestFileHashEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestFileHashEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestFileHashByHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestFileHashByHandleEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestFileHashByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestFileHashByHandle)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestFileHashByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestFileHashByHandleEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestFileHashByHandleEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestAvailableSpace)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAvailableSpaceEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestAvailableSpace)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAvailableSpaceEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAvailableSpaceEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestStatVFS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestStatVFSEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestStatVFS)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestStatVFSEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestStatVFSEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestHomeDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestHomeDirectoryEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestHomeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestHomeDirectory)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestHomeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestHomeDirectoryEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestHomeDirectoryEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnCopyRemoteFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCopyRemoteFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnCopyRemoteFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnCopyRemoteFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnCopyRemoteFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCopyRemoteFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCopyRemoteFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnCopyRemoteData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCopyRemoteDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnCopyRemoteData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnCopyRemoteData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnCopyRemoteData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCopyRemoteDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCopyRemoteDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnMakeTempFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReturnPathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnMakeTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnMakeTempFolder)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnMakeTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReturnPathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReturnPathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, get_OnRequestTempFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReturnPathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSFTPServer_get_OnRequestTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, set_OnRequestTempFolder)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSFTPServer_set_OnRequestTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReturnPathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReturnPathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSFTPServer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSFTPServer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_ServerVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_ServerVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_NewLineConvention, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_NewLineConvention, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_NegotiatedCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_UseUTF8OnSFTP3, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_UseUTF8OnSFTP3, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_RemoteCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_RemoteCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_LocalCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_LocalCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_NoCharacterEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_NoCharacterEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_Supported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_ClientVendorID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_FilenameCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_FilenameCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnBlock, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnUnblock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnUnblock, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnCloseHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnCloseHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnCreateDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnCreateDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnCreateSymLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnCreateSymLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnCreateHardLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnCreateHardLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnFindClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnFindClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnFindFirst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnFindFirst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnFindNext, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnFindNext, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnOpenFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnOpenFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnReadFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnReadFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnReadSymLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnReadSymLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRemove, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRemove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRenameFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRenameFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestAbsolutePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestAbsolutePath, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestAttributes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestAttributes2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestAttributes2, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnSetAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnSetAttributes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnSetAttributes2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnSetAttributes2, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnTextSeek, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnTextSeek, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnWriteFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnWriteFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnExtendedRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnExtendedRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnVersionChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnVersionChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnSendVendorID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnSendVendorID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestFileHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestFileHash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestFileHashByHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestFileHashByHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestAvailableSpace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestAvailableSpace, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestStatVFS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestStatVFS, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestHomeDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestHomeDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnCopyRemoteFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnCopyRemoteFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnCopyRemoteData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnCopyRemoteData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnMakeTempFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnMakeTempFolder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_get_OnRequestTempFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer_set_OnRequestTempFolder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSFTPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSFTPServer_methods[] = {
	PHP_ME(TElSFTPServer, Close, arginfo_TElSFTPServer_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, DataAvailable, arginfo_TElSFTPServer_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, Open, arginfo_TElSFTPServer_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_Active, arginfo_TElSFTPServer_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_ServerVersion, arginfo_TElSFTPServer_get_ServerVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_ServerVersion, arginfo_TElSFTPServer_set_ServerVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_NewLineConvention, arginfo_TElSFTPServer_get_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_NewLineConvention, arginfo_TElSFTPServer_set_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_NegotiatedCharset, arginfo_TElSFTPServer_get_NegotiatedCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_Version, arginfo_TElSFTPServer_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_UseUTF8, arginfo_TElSFTPServer_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_UseUTF8, arginfo_TElSFTPServer_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_UseUTF8OnSFTP3, arginfo_TElSFTPServer_get_UseUTF8OnSFTP3, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_UseUTF8OnSFTP3, arginfo_TElSFTPServer_set_UseUTF8OnSFTP3, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_RemoteCharset, arginfo_TElSFTPServer_get_RemoteCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_RemoteCharset, arginfo_TElSFTPServer_set_RemoteCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_LocalCharset, arginfo_TElSFTPServer_get_LocalCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_LocalCharset, arginfo_TElSFTPServer_set_LocalCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_NoCharacterEncoding, arginfo_TElSFTPServer_get_NoCharacterEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_NoCharacterEncoding, arginfo_TElSFTPServer_set_NoCharacterEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_Supported, arginfo_TElSFTPServer_get_Supported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_ClientVendorID, arginfo_TElSFTPServer_get_ClientVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_FilenameCharset, arginfo_TElSFTPServer_get_FilenameCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_FilenameCharset, arginfo_TElSFTPServer_set_FilenameCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_Versions, arginfo_TElSFTPServer_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_Versions, arginfo_TElSFTPServer_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnBlock, arginfo_TElSFTPServer_get_OnBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnBlock, arginfo_TElSFTPServer_set_OnBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnUnblock, arginfo_TElSFTPServer_get_OnUnblock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnUnblock, arginfo_TElSFTPServer_set_OnUnblock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnClose, arginfo_TElSFTPServer_get_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnClose, arginfo_TElSFTPServer_set_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnCloseHandle, arginfo_TElSFTPServer_get_OnCloseHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnCloseHandle, arginfo_TElSFTPServer_set_OnCloseHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnCreateDirectory, arginfo_TElSFTPServer_get_OnCreateDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnCreateDirectory, arginfo_TElSFTPServer_set_OnCreateDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnCreateSymLink, arginfo_TElSFTPServer_get_OnCreateSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnCreateSymLink, arginfo_TElSFTPServer_set_OnCreateSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnCreateHardLink, arginfo_TElSFTPServer_get_OnCreateHardLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnCreateHardLink, arginfo_TElSFTPServer_set_OnCreateHardLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnError, arginfo_TElSFTPServer_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnError, arginfo_TElSFTPServer_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnFindClose, arginfo_TElSFTPServer_get_OnFindClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnFindClose, arginfo_TElSFTPServer_set_OnFindClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnFindFirst, arginfo_TElSFTPServer_get_OnFindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnFindFirst, arginfo_TElSFTPServer_set_OnFindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnFindNext, arginfo_TElSFTPServer_get_OnFindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnFindNext, arginfo_TElSFTPServer_set_OnFindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnOpen, arginfo_TElSFTPServer_get_OnOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnOpen, arginfo_TElSFTPServer_set_OnOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnOpenFile, arginfo_TElSFTPServer_get_OnOpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnOpenFile, arginfo_TElSFTPServer_set_OnOpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnReadFile, arginfo_TElSFTPServer_get_OnReadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnReadFile, arginfo_TElSFTPServer_set_OnReadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnReadSymLink, arginfo_TElSFTPServer_get_OnReadSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnReadSymLink, arginfo_TElSFTPServer_set_OnReadSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnReceive, arginfo_TElSFTPServer_get_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnReceive, arginfo_TElSFTPServer_set_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRemove, arginfo_TElSFTPServer_get_OnRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRemove, arginfo_TElSFTPServer_set_OnRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRenameFile, arginfo_TElSFTPServer_get_OnRenameFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRenameFile, arginfo_TElSFTPServer_set_OnRenameFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestAbsolutePath, arginfo_TElSFTPServer_get_OnRequestAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestAbsolutePath, arginfo_TElSFTPServer_set_OnRequestAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestAttributes, arginfo_TElSFTPServer_get_OnRequestAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestAttributes, arginfo_TElSFTPServer_set_OnRequestAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestAttributes2, arginfo_TElSFTPServer_get_OnRequestAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestAttributes2, arginfo_TElSFTPServer_set_OnRequestAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnSend, arginfo_TElSFTPServer_get_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnSend, arginfo_TElSFTPServer_set_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnSetAttributes, arginfo_TElSFTPServer_get_OnSetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnSetAttributes, arginfo_TElSFTPServer_set_OnSetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnSetAttributes2, arginfo_TElSFTPServer_get_OnSetAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnSetAttributes2, arginfo_TElSFTPServer_set_OnSetAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnTextSeek, arginfo_TElSFTPServer_get_OnTextSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnTextSeek, arginfo_TElSFTPServer_set_OnTextSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnWriteFile, arginfo_TElSFTPServer_get_OnWriteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnWriteFile, arginfo_TElSFTPServer_set_OnWriteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnExtendedRequest, arginfo_TElSFTPServer_get_OnExtendedRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnExtendedRequest, arginfo_TElSFTPServer_set_OnExtendedRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnVersionChange, arginfo_TElSFTPServer_get_OnVersionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnVersionChange, arginfo_TElSFTPServer_set_OnVersionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnSendVendorID, arginfo_TElSFTPServer_get_OnSendVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnSendVendorID, arginfo_TElSFTPServer_set_OnSendVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestFileHash, arginfo_TElSFTPServer_get_OnRequestFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestFileHash, arginfo_TElSFTPServer_set_OnRequestFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestFileHashByHandle, arginfo_TElSFTPServer_get_OnRequestFileHashByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestFileHashByHandle, arginfo_TElSFTPServer_set_OnRequestFileHashByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestAvailableSpace, arginfo_TElSFTPServer_get_OnRequestAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestAvailableSpace, arginfo_TElSFTPServer_set_OnRequestAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestStatVFS, arginfo_TElSFTPServer_get_OnRequestStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestStatVFS, arginfo_TElSFTPServer_set_OnRequestStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestHomeDirectory, arginfo_TElSFTPServer_get_OnRequestHomeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestHomeDirectory, arginfo_TElSFTPServer_set_OnRequestHomeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnCopyRemoteFile, arginfo_TElSFTPServer_get_OnCopyRemoteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnCopyRemoteFile, arginfo_TElSFTPServer_set_OnCopyRemoteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnCopyRemoteData, arginfo_TElSFTPServer_get_OnCopyRemoteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnCopyRemoteData, arginfo_TElSFTPServer_set_OnCopyRemoteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnMakeTempFolder, arginfo_TElSFTPServer_get_OnMakeTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnMakeTempFolder, arginfo_TElSFTPServer_set_OnMakeTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, get_OnRequestTempFolder, arginfo_TElSFTPServer_get_OnRequestTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, set_OnRequestTempFolder, arginfo_TElSFTPServer_set_OnRequestTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSFTPServer, __construct, arginfo_TElSFTPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSFTPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSFTPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSFTPServer", TElSFTPServer_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSFTPServer_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSftpServer_Aliases(TSRMLS_D)
{
	if (NULL == TElSFTPServer_ce_ptr)
		Register_TElSFTPServer(TSRMLS_C);
	zend_register_class_alias("ElSFTPServer", TElSFTPServer_ce_ptr);
}

