#include "sbsimplessl.h"

zend_class_entry *TElCustomSimpleSSLClient_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomSimpleSSLClient, Interrupt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_Interrupt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, SendText)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_SendText(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, Join)
{
	zval *oClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oClient, TElCustomSimpleSSLClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_Join(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oClient TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomSimpleSSLClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, SendData)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomSimpleSSLClient_SendData(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, ReceiveData)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zend_bool bReadAll;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzb", &zpBuffer, &zl4Size, &bReadAll) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElCustomSimpleSSLClient_ReceiveData(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, (int8_t)bReadAll) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, SendKeepAlive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_SendKeepAlive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, InternalValidate)
{
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElCustomSimpleSSLClient_InternalValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, CanReceive)
{
	long l4Timeout;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Timeout) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_CanReceive(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Timeout, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, RenegotiateCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_RenegotiateCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_RemoteHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_RemoteHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(7800994, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_RemoteIP)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_RemoteIP(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1594884594, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CipherSuite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_CipherSuite(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CipherSuites)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_CipherSuites(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_CipherSuites)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_CipherSuites(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CipherSuitePriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_CipherSuitePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_CipherSuitePriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_CipherSuitePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CompressionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_CompressionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CompressionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_CompressionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CurrentVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_CurrentVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_PeerExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_PeerExtensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomSSLExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_TotalBytesSent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_TotalBytesSent(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_TotalBytesReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_TotalBytesReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_ProxyResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_ProxyResult(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElCustomSimpleSSLClient, get_UsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_UsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_InternalSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_InternalSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_Control)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_Control(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSLClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocketSettings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_SocketSettings(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocketSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_ConnectionInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_ConnectionInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSLConnectionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_ClientCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_ClientCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_Client)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_Client(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSLClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocketTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocketTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SSLOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSLOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SSLOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SSLOptions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SSLOptions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSLOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_LocalAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_LocalAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1204568907, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_LocalAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_LocalAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_LocalPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_LocalPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_LocalPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_LocalPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_UseSSLSessionResumption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_UseSSLSessionResumption(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_UseSSLSessionResumption)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_UseSSLSessionResumption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_ForceResumeIfDestinationChanges)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_ForceResumeIfDestinationChanges(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_ForceResumeIfDestinationChanges)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_ForceResumeIfDestinationChanges(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(837635768, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksResolveAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksResolveAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksServer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-985440113, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksServer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksUserCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1970663354, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksUserCode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksVersionRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocksUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocksUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_UseSocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_UseSocks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_UseWebTunneling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_UseWebTunneling)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-738511725, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_WebTunnelAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElWebTunnelAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_WebTunnelAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElWebTunnelAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(346516811, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_WebTunnelPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_WebTunnelPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelUserId)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1696197127, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_WebTunnelUserId)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelRequestHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_WebTunnelRequestHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelResponseHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_WebTunnelResponseHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_WebTunnelResponseBody)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_WebTunnelResponseBody(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(924977259, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SocketBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_SocketBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SocketBinding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SocketBinding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SRPUserName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_SRPUserName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(935888478, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SRPUserName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SRPUserName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_SRPPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomSimpleSSLClient_get_SRPPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1516661186, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_SRPPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_SRPPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_RenegotiationAttackPreventionMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationAttackPreventionModeRaw fOutResultRaw = 0;
		SBCheckError(TElCustomSimpleSSLClient_get_RenegotiationAttackPreventionMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_RenegotiationAttackPreventionMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_RenegotiationAttackPreventionMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBRenegotiationAttackPreventionModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_PortKnock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_PortKnock(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPortKnock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_PortKnock)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPortKnock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_PortKnock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPortKnock)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElCustomSimpleSSLClient, get_DNS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_DNS)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSSettings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSimpleSSLClient_set_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSSettings)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_MessageLoop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElMessageLoopEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_MessageLoop(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_MessageLoop)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomSimpleSSLClient_set_MessageLoop(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElMessageLoopEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElMessageLoopEvent|callable|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElCustomSimpleSSLClient, get_OnDNSKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_OnDNSKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomSimpleSSLClient_set_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_OnDNSKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_OnDNSKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomSimpleSSLClient_set_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, get_OnDNSResolve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_get_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSimpleSSLClient, set_OnDNSResolve)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElCustomSimpleSSLClient_set_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolveEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElCustomSimpleSSLClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSimpleSSLClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_Interrupt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_SendText, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_Join, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Client, TElCustomSimpleSSLClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_SendData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_ReceiveData, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_INFO(0, ReadAll)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_SendKeepAlive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_InternalValidate, 0, 0, 2)
	ZEND_ARG_INFO(1, Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_CanReceive, 0, 0, 1)
	ZEND_ARG_INFO(0, Timeout)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_RenegotiateCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_RemoteHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_RemoteIP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CipherSuite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CipherSuites, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_CipherSuites, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CipherSuitePriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_CipherSuitePriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CompressionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CompressionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_CompressionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CurrentVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_PeerExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_TotalBytesSent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_TotalBytesReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_ProxyResult, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_UsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_InternalSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_Control, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocketSettings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_ConnectionInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_ClientCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_ClientCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_Client, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocketTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocketTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SSLOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SSLOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_LocalAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_LocalAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_LocalPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_LocalPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_UseSSLSessionResumption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_UseSSLSessionResumption, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_ForceResumeIfDestinationChanges, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_ForceResumeIfDestinationChanges, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksResolveAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksResolveAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksServer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksUserCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksUserCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocksUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocksUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_UseSocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_UseSocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_UseWebTunneling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_UseWebTunneling, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_WebTunnelAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_WebTunnelAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_WebTunnelPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_WebTunnelPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelUserId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_WebTunnelUserId, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelRequestHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelResponseHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_WebTunnelResponseBody, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SocketBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SocketBinding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SRPUserName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SRPUserName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_SRPPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_SRPPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_RenegotiationAttackPreventionMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_RenegotiationAttackPreventionMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_PortKnock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_PortKnock, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPortKnock, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_DNS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_DNS, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSSettings, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_MessageLoop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_MessageLoop, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_OnDNSKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_OnDNSKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_OnDNSKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_OnDNSKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_get_OnDNSResolve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient_set_OnDNSResolve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSimpleSSLClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomSimpleSSLClient_methods[] = {
	PHP_ME(TElCustomSimpleSSLClient, Interrupt, arginfo_TElCustomSimpleSSLClient_Interrupt, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, Close, arginfo_TElCustomSimpleSSLClient_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, Open, arginfo_TElCustomSimpleSSLClient_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, SendText, arginfo_TElCustomSimpleSSLClient_SendText, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, Join, arginfo_TElCustomSimpleSSLClient_Join, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, SendData, arginfo_TElCustomSimpleSSLClient_SendData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, ReceiveData, arginfo_TElCustomSimpleSSLClient_ReceiveData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, SendKeepAlive, arginfo_TElCustomSimpleSSLClient_SendKeepAlive, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, InternalValidate, arginfo_TElCustomSimpleSSLClient_InternalValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, CanReceive, arginfo_TElCustomSimpleSSLClient_CanReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, RenegotiateCiphers, arginfo_TElCustomSimpleSSLClient_RenegotiateCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_RemoteHost, arginfo_TElCustomSimpleSSLClient_get_RemoteHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_RemoteIP, arginfo_TElCustomSimpleSSLClient_get_RemoteIP, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_Active, arginfo_TElCustomSimpleSSLClient_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CipherSuite, arginfo_TElCustomSimpleSSLClient_get_CipherSuite, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CipherSuites, arginfo_TElCustomSimpleSSLClient_get_CipherSuites, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_CipherSuites, arginfo_TElCustomSimpleSSLClient_set_CipherSuites, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CipherSuitePriorities, arginfo_TElCustomSimpleSSLClient_get_CipherSuitePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_CipherSuitePriorities, arginfo_TElCustomSimpleSSLClient_set_CipherSuitePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CompressionAlgorithm, arginfo_TElCustomSimpleSSLClient_get_CompressionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CompressionAlgorithms, arginfo_TElCustomSimpleSSLClient_get_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_CompressionAlgorithms, arginfo_TElCustomSimpleSSLClient_set_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CurrentVersion, arginfo_TElCustomSimpleSSLClient_get_CurrentVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_Extensions, arginfo_TElCustomSimpleSSLClient_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_PeerExtensions, arginfo_TElCustomSimpleSSLClient_get_PeerExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_TotalBytesSent, arginfo_TElCustomSimpleSSLClient_get_TotalBytesSent, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_TotalBytesReceived, arginfo_TElCustomSimpleSSLClient_get_TotalBytesReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_ProxyResult, arginfo_TElCustomSimpleSSLClient_get_ProxyResult, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElCustomSimpleSSLClient, get_UsingIPv6, arginfo_TElCustomSimpleSSLClient_get_UsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElCustomSimpleSSLClient, get_InternalSocket, arginfo_TElCustomSimpleSSLClient_get_InternalSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_Control, arginfo_TElCustomSimpleSSLClient_get_Control, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocketSettings, arginfo_TElCustomSimpleSSLClient_get_SocketSettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_ConnectionInfo, arginfo_TElCustomSimpleSSLClient_get_ConnectionInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_CertStorage, arginfo_TElCustomSimpleSSLClient_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_CertStorage, arginfo_TElCustomSimpleSSLClient_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_ClientCertStorage, arginfo_TElCustomSimpleSSLClient_get_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_ClientCertStorage, arginfo_TElCustomSimpleSSLClient_set_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_Client, arginfo_TElCustomSimpleSSLClient_get_Client, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocketTimeout, arginfo_TElCustomSimpleSSLClient_get_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocketTimeout, arginfo_TElCustomSimpleSSLClient_set_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_Versions, arginfo_TElCustomSimpleSSLClient_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_Versions, arginfo_TElCustomSimpleSSLClient_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SSLOptions, arginfo_TElCustomSimpleSSLClient_get_SSLOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SSLOptions, arginfo_TElCustomSimpleSSLClient_set_SSLOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_LocalAddress, arginfo_TElCustomSimpleSSLClient_get_LocalAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_LocalAddress, arginfo_TElCustomSimpleSSLClient_set_LocalAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_LocalPort, arginfo_TElCustomSimpleSSLClient_get_LocalPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_LocalPort, arginfo_TElCustomSimpleSSLClient_set_LocalPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_IncomingSpeedLimit, arginfo_TElCustomSimpleSSLClient_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_IncomingSpeedLimit, arginfo_TElCustomSimpleSSLClient_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_OutgoingSpeedLimit, arginfo_TElCustomSimpleSSLClient_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_OutgoingSpeedLimit, arginfo_TElCustomSimpleSSLClient_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_UseSSLSessionResumption, arginfo_TElCustomSimpleSSLClient_get_UseSSLSessionResumption, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_UseSSLSessionResumption, arginfo_TElCustomSimpleSSLClient_set_UseSSLSessionResumption, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_ForceResumeIfDestinationChanges, arginfo_TElCustomSimpleSSLClient_get_ForceResumeIfDestinationChanges, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_ForceResumeIfDestinationChanges, arginfo_TElCustomSimpleSSLClient_set_ForceResumeIfDestinationChanges, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksAuthentication, arginfo_TElCustomSimpleSSLClient_get_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksAuthentication, arginfo_TElCustomSimpleSSLClient_set_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksPassword, arginfo_TElCustomSimpleSSLClient_get_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksPassword, arginfo_TElCustomSimpleSSLClient_set_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksPort, arginfo_TElCustomSimpleSSLClient_get_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksPort, arginfo_TElCustomSimpleSSLClient_set_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksResolveAddress, arginfo_TElCustomSimpleSSLClient_get_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksResolveAddress, arginfo_TElCustomSimpleSSLClient_set_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksServer, arginfo_TElCustomSimpleSSLClient_get_SocksServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksServer, arginfo_TElCustomSimpleSSLClient_set_SocksServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksUserCode, arginfo_TElCustomSimpleSSLClient_get_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksUserCode, arginfo_TElCustomSimpleSSLClient_set_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocksVersion, arginfo_TElCustomSimpleSSLClient_get_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksVersion, arginfo_TElCustomSimpleSSLClient_set_SocksVersion, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElCustomSimpleSSLClient, get_SocksUseIPv6, arginfo_TElCustomSimpleSSLClient_get_SocksUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocksUseIPv6, arginfo_TElCustomSimpleSSLClient_set_SocksUseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElCustomSimpleSSLClient, get_UseSocks, arginfo_TElCustomSimpleSSLClient_get_UseSocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_UseSocks, arginfo_TElCustomSimpleSSLClient_set_UseSocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_UseWebTunneling, arginfo_TElCustomSimpleSSLClient_get_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_UseWebTunneling, arginfo_TElCustomSimpleSSLClient_set_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelAddress, arginfo_TElCustomSimpleSSLClient_get_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_WebTunnelAddress, arginfo_TElCustomSimpleSSLClient_set_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelAuthentication, arginfo_TElCustomSimpleSSLClient_get_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_WebTunnelAuthentication, arginfo_TElCustomSimpleSSLClient_set_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelPassword, arginfo_TElCustomSimpleSSLClient_get_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_WebTunnelPassword, arginfo_TElCustomSimpleSSLClient_set_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelPort, arginfo_TElCustomSimpleSSLClient_get_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_WebTunnelPort, arginfo_TElCustomSimpleSSLClient_set_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelUserId, arginfo_TElCustomSimpleSSLClient_get_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_WebTunnelUserId, arginfo_TElCustomSimpleSSLClient_set_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelRequestHeaders, arginfo_TElCustomSimpleSSLClient_get_WebTunnelRequestHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelResponseHeaders, arginfo_TElCustomSimpleSSLClient_get_WebTunnelResponseHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_WebTunnelResponseBody, arginfo_TElCustomSimpleSSLClient_get_WebTunnelResponseBody, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SocketBinding, arginfo_TElCustomSimpleSSLClient_get_SocketBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SocketBinding, arginfo_TElCustomSimpleSSLClient_set_SocketBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SRPUserName, arginfo_TElCustomSimpleSSLClient_get_SRPUserName, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SRPUserName, arginfo_TElCustomSimpleSSLClient_set_SRPUserName, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_SRPPassword, arginfo_TElCustomSimpleSSLClient_get_SRPPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_SRPPassword, arginfo_TElCustomSimpleSSLClient_set_SRPPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_RenegotiationAttackPreventionMode, arginfo_TElCustomSimpleSSLClient_get_RenegotiationAttackPreventionMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_RenegotiationAttackPreventionMode, arginfo_TElCustomSimpleSSLClient_set_RenegotiationAttackPreventionMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_PortKnock, arginfo_TElCustomSimpleSSLClient_get_PortKnock, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_PortKnock, arginfo_TElCustomSimpleSSLClient_set_PortKnock, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElCustomSimpleSSLClient, get_DNS, arginfo_TElCustomSimpleSSLClient_get_DNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_DNS, arginfo_TElCustomSimpleSSLClient_set_DNS, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElCustomSimpleSSLClient, get_MessageLoop, arginfo_TElCustomSimpleSSLClient_get_MessageLoop, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_MessageLoop, arginfo_TElCustomSimpleSSLClient_set_MessageLoop, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElCustomSimpleSSLClient, get_OnDNSKeyNeeded, arginfo_TElCustomSimpleSSLClient_get_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_OnDNSKeyNeeded, arginfo_TElCustomSimpleSSLClient_set_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_OnDNSKeyValidate, arginfo_TElCustomSimpleSSLClient_get_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_OnDNSKeyValidate, arginfo_TElCustomSimpleSSLClient_set_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, get_OnDNSResolve, arginfo_TElCustomSimpleSSLClient_get_OnDNSResolve, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSimpleSSLClient, set_OnDNSResolve, arginfo_TElCustomSimpleSSLClient_set_OnDNSResolve, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElCustomSimpleSSLClient, __construct, arginfo_TElCustomSimpleSSLClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomSimpleSSLClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomSimpleSSLClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomSimpleSSLClient", TElCustomSimpleSSLClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElCustomSimpleSSLClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleSSLClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSSLClient, StartTLS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_StartTLS(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, StopTLS)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_StopTLS(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSSLClient_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1174393719, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSSLClient_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSSLClient_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSimpleSSLClient, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSSLClient_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSimpleSSLClient, get_UseInternalSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSSLClient_get_UseInternalSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_UseInternalSocket)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSSLClient_set_UseInternalSocket(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnCertificateChoose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBChooseCertificateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnCertificateChoose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBChooseCertificateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBChooseCertificateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnCertificateNeededEx)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateNeededExEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnCertificateNeededEx)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateNeededExEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateNeededExEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnCiphersNegotiated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnCiphersNegotiated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnExtensionsReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnExtensionsReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnExtensionsPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnExtensionsPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnExtensionsPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnExtensionsPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnCertificateStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateStatusEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnCertificateStatus)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateStatusEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateStatusEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBClientKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBClientKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBClientKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, get_OnRenegotiationRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_get_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, set_OnRenegotiationRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSSLClient_set_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBRenegotiationRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBRenegotiationRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSLClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSSLClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_StartTLS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_StopTLS, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_UseInternalSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_UseInternalSocket, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnCertificateChoose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnCertificateChoose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnCertificateNeededEx, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnCertificateNeededEx, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnCiphersNegotiated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnCiphersNegotiated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnExtensionsReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnExtensionsReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnExtensionsPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnExtensionsPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnCertificateStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnCertificateStatus, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_get_OnRenegotiationRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient_set_OnRenegotiationRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSLClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSSLClient_methods[] = {
	PHP_ME(TElSimpleSSLClient, StartTLS, arginfo_TElSimpleSSLClient_StartTLS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, StopTLS, arginfo_TElSimpleSSLClient_StopTLS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_Address, arginfo_TElSimpleSSLClient_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_Address, arginfo_TElSimpleSSLClient_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_Enabled, arginfo_TElSimpleSSLClient_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_Enabled, arginfo_TElSimpleSSLClient_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_Port, arginfo_TElSimpleSSLClient_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_Port, arginfo_TElSimpleSSLClient_set_Port, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSimpleSSLClient, get_UseIPv6, arginfo_TElSimpleSSLClient_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_UseIPv6, arginfo_TElSimpleSSLClient_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSimpleSSLClient, get_UseInternalSocket, arginfo_TElSimpleSSLClient_get_UseInternalSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_UseInternalSocket, arginfo_TElSimpleSSLClient_set_UseInternalSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnCertificateChoose, arginfo_TElSimpleSSLClient_get_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnCertificateChoose, arginfo_TElSimpleSSLClient_set_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnCertificateNeededEx, arginfo_TElSimpleSSLClient_get_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnCertificateNeededEx, arginfo_TElSimpleSSLClient_set_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnCertificateValidate, arginfo_TElSimpleSSLClient_get_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnCertificateValidate, arginfo_TElSimpleSSLClient_set_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnCiphersNegotiated, arginfo_TElSimpleSSLClient_get_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnCiphersNegotiated, arginfo_TElSimpleSSLClient_set_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnCloseConnection, arginfo_TElSimpleSSLClient_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnCloseConnection, arginfo_TElSimpleSSLClient_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnError, arginfo_TElSimpleSSLClient_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnError, arginfo_TElSimpleSSLClient_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnReceive, arginfo_TElSimpleSSLClient_get_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnReceive, arginfo_TElSimpleSSLClient_set_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnSend, arginfo_TElSimpleSSLClient_get_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnSend, arginfo_TElSimpleSSLClient_set_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnExtensionsReceived, arginfo_TElSimpleSSLClient_get_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnExtensionsReceived, arginfo_TElSimpleSSLClient_set_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnExtensionsPrepared, arginfo_TElSimpleSSLClient_get_OnExtensionsPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnExtensionsPrepared, arginfo_TElSimpleSSLClient_set_OnExtensionsPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnCertificateStatus, arginfo_TElSimpleSSLClient_get_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnCertificateStatus, arginfo_TElSimpleSSLClient_set_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnKeyNeeded, arginfo_TElSimpleSSLClient_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnKeyNeeded, arginfo_TElSimpleSSLClient_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, get_OnRenegotiationRequest, arginfo_TElSimpleSSLClient_get_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, set_OnRenegotiationRequest, arginfo_TElSimpleSSLClient_set_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSLClient, __construct, arginfo_TElSimpleSSLClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSSLClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSSLClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSSLClient", TElSimpleSSLClient_methods);
	if (NULL == TElCustomSimpleSSLClient_ce_ptr)
		Register_TElCustomSimpleSSLClient(TSRMLS_C);
	TElSimpleSSLClient_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSimpleSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSimpleSSL_Aliases(TSRMLS_D)
{
	if (NULL == TElCustomSimpleSSLClient_ce_ptr)
		Register_TElCustomSimpleSSLClient(TSRMLS_C);
	zend_register_class_alias("ElCustomSimpleSSLClient", TElCustomSimpleSSLClient_ce_ptr);
	if (NULL == TElSimpleSSLClient_ce_ptr)
		Register_TElSimpleSSLClient(TSRMLS_C);
	zend_register_class_alias("ElSimpleSSLClient", TElSimpleSSLClient_ce_ptr);
}
