#include "sbsmtpclient.h"

zend_class_entry *TSBSMTPState_ce_ptr = NULL;

zend_class_entry *TSBSMTPDSNOption_ce_ptr = NULL;

zend_class_entry *TSBSMTPDSNOptions_ce_ptr = NULL;

zend_class_entry *TSBSMTPDSNReturnType_ce_ptr = NULL;

#ifdef SB_WINDOWS
void SB_CALLBACK TSBSMTPDSNEnvIDGenerateEventRaw(void * _ObjectData, TObjectHandle Sender, TStringListHandle RcptTo, char * pcEnvID, int32_t * szEnvID)
#else
void SB_CALLBACK TSBSMTPDSNEnvIDGenerateEventRaw(void * _ObjectData, TObjectHandle Sender, TElStringListHandle RcptTo, char * pcEnvID, int32_t * szEnvID)
#endif
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zRcptTo;
	zval * zEnvID;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRcptTo);
#ifdef SB_WINDOWS
	SBInitObject(zRcptTo, TStringList_ce_ptr, RcptTo TSRMLS_CC);
#else
	SBInitObject(zRcptTo, TElStringList_ce_ptr, RcptTo TSRMLS_CC);
#endif
	MAKE_STD_ZVAL(zEnvID);
	ZVAL_STRINGL(zEnvID, pcEnvID, *szEnvID, 1);

	params[0] = &zSender;
	params[1] = &zRcptTo;
	params[2] = &zEnvID;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRcptTo);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zEnvID), (int32_t)Z_STRLEN_P(zEnvID)) TSRMLS_CC);
	zval_ptr_dtor(&zEnvID);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSMTPDSNOptionsEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcRcptTo, int32_t szRcptTo, TSBSMTPDSNOptionsRaw * Options)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zRcptTo;
	zval * zOptions;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRcptTo);
	ZVAL_STRINGL(zRcptTo, pcRcptTo, szRcptTo, 1);
	MAKE_STD_ZVAL(zOptions);
	ZVAL_LONG(zOptions, (long)*Options);

	params[0] = &zSender;
	params[1] = &zRcptTo;
	params[2] = &zOptions;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRcptTo);
	*Options = (TSBSMTPDSNOptionsRaw)Z_LVAL_P(zOptions);
	zval_ptr_dtor(&zOptions);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSMTPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSMTPClient, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSMTPClient_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, EstablishSSLSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSMTPClient_EstablishSSLSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, Login)
{
	char *sDomain;
	int sDomain_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDomain, &sDomain_len) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_Login(SBGetObjectHandle(getThis() TSRMLS_CC), sDomain, (int32_t)sDomain_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, Send)
{
	char *sMailFrom;
	int sMailFrom_len;
	zval *oMessage;
	zval *oRcptTo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMessage, TElMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_Send(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMessage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMessage, TElSimpleMIMEMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_Send_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMessage TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sMailFrom, &sMailFrom_len, &oRcptTo, TStringList_ce_ptr, &oMessage, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sMailFrom, &sMailFrom_len, &oRcptTo, TElStringList_ce_ptr, &oMessage, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElSMTPClient_Send_2(SBGetObjectHandle(getThis() TSRMLS_CC), sMailFrom, (int32_t)sMailFrom_len, SBGetObjectHandle(oRcptTo TSRMLS_CC), SBGetObjectHandle(oMessage TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sMailFrom, &sMailFrom_len, &oRcptTo, TStringList_ce_ptr, &oMessage, TStream_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sMailFrom, &sMailFrom_len, &oRcptTo, TElStringList_ce_ptr, &oMessage, TStream_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElSMTPClient_Send_3(SBGetObjectHandle(getThis() TSRMLS_CC), sMailFrom, (int32_t)sMailFrom_len, SBGetObjectHandle(oRcptTo TSRMLS_CC), SBGetObjectHandle(oMessage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMessage, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_Send_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMessage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TElMessage) or (TElSimpleMIMEMessage) or (string, TStringList, TStringList) or (string, TStringList, TStream) or (TStream)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElMessage) or (TElSimpleMIMEMessage) or (string, TElStringList, TElStringList) or (string, TElStringList, TStream) or (TStream)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElSMTPClient, get_SASLMechanism)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_SASLMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_SASLMechanism)
{
	char *sName;
	int sName_len;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sName, &sName_len, &bValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_SASLMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_SASLMechanismPriorities)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_SASLMechanismPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_SASLMechanismPriorities)
{
	char *sName;
	int sName_len;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sName, &sName_len, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_SASLMechanismPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtSASLMechanisms)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TStringList_Create(&hoOutResult) TSRMLS_CC);
		SBCheckError(TElSMTPClient_get_ExtSASLMechanisms(SBGetObjectHandle(getThis() TSRMLS_CC), hoOutResult) TSRMLS_CC);
		object_init_ex(return_value, TStringList_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionChunkingSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionChunkingSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionBinarySupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionBinarySupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionAuthPlainSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionAuthPlainSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionAuthLoginSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionAuthLoginSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionSASLLoginSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionSASLLoginSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionSizeSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionSizeSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_ExtensionDSNSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_ExtensionDSNSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_SSLActive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_SSLActive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSMTPClient_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-146115816, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_AllowAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_AllowAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_AllowAuthentication)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_AllowAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_AllowBinaryMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_AllowBinaryMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_AllowBinaryMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_AllowBinaryMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_BinaryChunkSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_BinaryChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_BinaryChunkSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_BinaryChunkSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSMTPClient_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1860798116, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_RemoveBCC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_RemoveBCC(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_RemoveBCC)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_RemoveBCC(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_SendBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_SendBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_SSLMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSLModeRaw fOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_SSLMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSLModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_UseSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_UseSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSMTPClient_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1552562682, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_DSNOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSMTPDSNOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_DSNOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_DSNOptions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_DSNOptions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSMTPDSNOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_DSNReturnType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSMTPDSNReturnTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSMTPClient_get_DSNReturnType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_DSNReturnType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSMTPClient_set_DSNReturnType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSMTPDSNReturnTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSMTPClient_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSMTPClient_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_OnDSNEnvIDGenerate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSMTPDSNEnvIDGenerateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSMTPClient_get_OnDSNEnvIDGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_OnDSNEnvIDGenerate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSMTPClient_set_OnDSNEnvIDGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSMTPDSNEnvIDGenerateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSMTPDSNEnvIDGenerateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, get_OnDSNOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSMTPDSNOptionsEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSMTPClient_get_OnDSNOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, set_OnDSNOptions)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSMTPClient_set_OnDSNOptions(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSMTPDSNOptionsEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSMTPDSNOptionsEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMTPClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSMTPClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_EstablishSSLSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_Login, 0, 0, 1)
	ZEND_ARG_INFO(0, Domain)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_Send, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Message_or_MailFrom, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, RcptTo, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, RcptTo, TElStringList, 1)
#endif
	ZEND_ARG_TYPE_INFO(0, Message, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_SASLMechanism, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_SASLMechanism, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_SASLMechanismPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_SASLMechanismPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtSASLMechanisms, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionChunkingSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionBinarySupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionAuthPlainSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionAuthLoginSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionSASLLoginSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionSizeSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_ExtensionDSNSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_SSLActive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_AllowAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_AllowAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_AllowBinaryMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_AllowBinaryMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_BinaryChunkSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_BinaryChunkSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_RemoveBCC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_RemoveBCC, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_SendBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_SendBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_SSLMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_SSLMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_UseSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_UseSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_DSNOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_DSNOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_DSNReturnType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_DSNReturnType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_OnDSNEnvIDGenerate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_OnDSNEnvIDGenerate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_get_OnDSNOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient_set_OnDSNOptions, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMTPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSMTPClient_methods[] = {
	PHP_ME(TElSMTPClient, Close, arginfo_TElSMTPClient_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, Open, arginfo_TElSMTPClient_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, EstablishSSLSession, arginfo_TElSMTPClient_EstablishSSLSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, Login, arginfo_TElSMTPClient_Login, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, Send, arginfo_TElSMTPClient_Send, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_SASLMechanism, arginfo_TElSMTPClient_get_SASLMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_SASLMechanism, arginfo_TElSMTPClient_set_SASLMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_SASLMechanismPriorities, arginfo_TElSMTPClient_get_SASLMechanismPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_SASLMechanismPriorities, arginfo_TElSMTPClient_set_SASLMechanismPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtSASLMechanisms, arginfo_TElSMTPClient_get_ExtSASLMechanisms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionChunkingSupported, arginfo_TElSMTPClient_get_ExtensionChunkingSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionBinarySupported, arginfo_TElSMTPClient_get_ExtensionBinarySupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionAuthPlainSupported, arginfo_TElSMTPClient_get_ExtensionAuthPlainSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionAuthLoginSupported, arginfo_TElSMTPClient_get_ExtensionAuthLoginSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionSASLLoginSupported, arginfo_TElSMTPClient_get_ExtensionSASLLoginSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionSizeSupported, arginfo_TElSMTPClient_get_ExtensionSizeSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_ExtensionDSNSupported, arginfo_TElSMTPClient_get_ExtensionDSNSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_SSLActive, arginfo_TElSMTPClient_get_SSLActive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_Address, arginfo_TElSMTPClient_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_Address, arginfo_TElSMTPClient_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_AllowAuthentication, arginfo_TElSMTPClient_get_AllowAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_AllowAuthentication, arginfo_TElSMTPClient_set_AllowAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_AllowBinaryMode, arginfo_TElSMTPClient_get_AllowBinaryMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_AllowBinaryMode, arginfo_TElSMTPClient_set_AllowBinaryMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_BinaryChunkSize, arginfo_TElSMTPClient_get_BinaryChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_BinaryChunkSize, arginfo_TElSMTPClient_set_BinaryChunkSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_Password, arginfo_TElSMTPClient_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_Password, arginfo_TElSMTPClient_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_Port, arginfo_TElSMTPClient_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_Port, arginfo_TElSMTPClient_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_RemoveBCC, arginfo_TElSMTPClient_get_RemoveBCC, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_RemoveBCC, arginfo_TElSMTPClient_set_RemoveBCC, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_SendBufferSize, arginfo_TElSMTPClient_get_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_SendBufferSize, arginfo_TElSMTPClient_set_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_SSLMode, arginfo_TElSMTPClient_get_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_SSLMode, arginfo_TElSMTPClient_set_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_UseSSL, arginfo_TElSMTPClient_get_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_UseSSL, arginfo_TElSMTPClient_set_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_Username, arginfo_TElSMTPClient_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_Username, arginfo_TElSMTPClient_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_DSNOptions, arginfo_TElSMTPClient_get_DSNOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_DSNOptions, arginfo_TElSMTPClient_set_DSNOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_DSNReturnType, arginfo_TElSMTPClient_get_DSNReturnType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_DSNReturnType, arginfo_TElSMTPClient_set_DSNReturnType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_OnProgress, arginfo_TElSMTPClient_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_OnProgress, arginfo_TElSMTPClient_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_OnDSNEnvIDGenerate, arginfo_TElSMTPClient_get_OnDSNEnvIDGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_OnDSNEnvIDGenerate, arginfo_TElSMTPClient_set_OnDSNEnvIDGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, get_OnDSNOptions, arginfo_TElSMTPClient_get_OnDSNOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, set_OnDSNOptions, arginfo_TElSMTPClient_set_OnDSNOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMTPClient, __construct, arginfo_TElSMTPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSMTPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSMTPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSMTPClient", TElSMTPClient_methods);
	if (NULL == TElCommandSSLClient_ce_ptr)
		Register_TElCommandSSLClient(TSRMLS_C);
	TElSMTPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElCommandSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSMTPClient_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSMTPClient, DefaultChunkSize, SB_DefaultChunkSize, SB_DefaultChunkSize);
	SB_REGISTER_LONG_CONSTANT(SBSMTPClient, DefaultBufferSize, SB_DefaultBufferSize, SB_DefaultBufferSize);
}

void Register_SBSMTPClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSMTPState", NULL);
	TSBSMTPState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSMTPState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPState_ce_ptr, "ssPlain", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPState_ce_ptr, "ssEncrypted", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBSMTPDSNOption", NULL);
	TSBSMTPDSNOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSMTPDSNOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNOption_ce_ptr, "sdnSuccess", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNOption_ce_ptr, "sdnFailure", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNOption_ce_ptr, "sdnDelay", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBSMTPDSNOptions", NULL);
	TSBSMTPDSNOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBSMTPDSNOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNOptions_ce_ptr, "sdnSuccess", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNOptions_ce_ptr, "sdnFailure", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNOptions_ce_ptr, "sdnDelay", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBSMTPDSNReturnType", NULL);
	TSBSMTPDSNReturnType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSMTPDSNReturnType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNReturnType_ce_ptr, "srtFull", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSMTPDSNReturnType_ce_ptr, "srtHeaders", 1)
}

void Register_SBSMTPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElSMTPClient_ce_ptr)
		Register_TElSMTPClient(TSRMLS_C);
	zend_register_class_alias("ElSMTPClient", TElSMTPClient_ce_ptr);
}
