#include "sbsockettspclient.h"

zend_class_entry *TElSocketTSPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSocketTSPClient, Timestamp)
{
	int32_t l4FailureInfoRaw = 0;
	SBArrayZValInfo aiHashedData;
	SBArrayZValInfo aiReplyCMS;
	TSBPKIStatusRaw fServerResultRaw = 0;
	uint32_t _err;
	zval *zaHashedData;
	zval *zaReplyCMS;
	zval *zfServerResult;
	zval *zl4FailureInfo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaHashedData, &zfServerResult, &zl4FailureInfo, &zaReplyCMS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))) && PZVAL_IS_REF(zfServerResult) && (IS_LONG == Z_TYPE_P(zfServerResult)) && PZVAL_IS_REF(zl4FailureInfo) && (IS_LONG == Z_TYPE_P(zl4FailureInfo)) && PZVAL_IS_REF(zaReplyCMS) && ((IS_STRING == Z_TYPE_P(zaReplyCMS)) || (IS_ARRAY == Z_TYPE_P(zaReplyCMS))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		SBInitArrayZValInfo(&aiReplyCMS);
		_err = TElSocketTSPClient_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), aiHashedData.data, aiHashedData.len, &fServerResultRaw, &l4FailureInfoRaw, aiReplyCMS.data, &aiReplyCMS.len, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaReplyCMS, &aiReplyCMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1644788189, 4, aiReplyCMS.data, &aiReplyCMS.len) TSRMLS_CC);
			((char *)aiReplyCMS.data)[aiReplyCMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiReplyCMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHashedData);
		ZVAL_LONG(zfServerResult, (long)fServerResultRaw);
		ZVAL_LONG(zl4FailureInfo, (long)l4FailureInfoRaw);
		SBSetByteArrayToZVal(&aiReplyCMS, zaReplyCMS);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &integer, &integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, get_Socket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocketTSPClient_get_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, get_ErrorMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocketTSPClient_get_ErrorMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1652496563, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSocketTSPClient_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1790801784, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSocketTSPClient_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocketTSPClient_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocketTSPClient_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, get_SocketTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSocketTSPClient_get_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, set_SocketTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSocketTSPClient_set_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSocketTSPClient, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSocketTSPClient_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_Timestamp, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, HashedData, 0, 1)
	ZEND_ARG_INFO(1, ServerResult)
	ZEND_ARG_INFO(1, FailureInfo)
	ZEND_ARG_INFO(1, ReplyCMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_get_Socket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_get_ErrorMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_get_SocketTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient_set_SocketTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSocketTSPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSocketTSPClient_methods[] = {
	PHP_ME(TElSocketTSPClient, Timestamp, arginfo_TElSocketTSPClient_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, get_Socket, arginfo_TElSocketTSPClient_get_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, get_ErrorMessage, arginfo_TElSocketTSPClient_get_ErrorMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, get_Address, arginfo_TElSocketTSPClient_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, set_Address, arginfo_TElSocketTSPClient_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, get_Port, arginfo_TElSocketTSPClient_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, set_Port, arginfo_TElSocketTSPClient_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, get_SocketTimeout, arginfo_TElSocketTSPClient_get_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, set_SocketTimeout, arginfo_TElSocketTSPClient_set_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSocketTSPClient, __construct, arginfo_TElSocketTSPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSocketTSPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSocketTSPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSocketTSPClient", TElSocketTSPClient_methods);
	if (NULL == TElCustomTSPClient_ce_ptr)
		Register_TElCustomTSPClient(TSRMLS_C);
	TElSocketTSPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomTSPClient_ce_ptr, NULL TSRMLS_CC);
}

