#include "sbsshserver.h"

zend_class_entry *TSSHServerState_ce_ptr = NULL;

zend_class_entry *TSSHServerProtService_ce_ptr = NULL;

void SB_CALLBACK TSSHAuthAttemptEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, int32_t AuthType, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zUsername;
	zval * zAuthType;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zAuthType);
	ZVAL_LONG(zAuthType, (long)AuthType);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zAuthType;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zAuthType);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthPublicKeyEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, TElSSHKeyHandle Key, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zUsername;
	zval * zKey;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElSSHKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zKey;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zKey);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthHostbasedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, const char * pcClientUsername, int32_t szClientUsername, const char * pcClientHostname, int32_t szClientHostname, TElSSHKeyHandle Key, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zUsername;
	zval * zClientUsername;
	zval * zClientHostname;
	zval * zKey;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zClientUsername);
	ZVAL_STRINGL(zClientUsername, pcClientUsername, szClientUsername, 1);
	MAKE_STD_ZVAL(zClientHostname);
	ZVAL_STRINGL(zClientHostname, pcClientHostname, szClientHostname, 1);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElSSHKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zClientUsername;
	params[3] = &zClientHostname;
	params[4] = &zKey;
	params[5] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zClientUsername);
	zval_ptr_dtor(&zClientHostname);
	zval_ptr_dtor(&zKey);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthBannerEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, int32_t AuthType, char * pcBanner, int32_t * szBanner, uint8_t pLanguageTag[], int32_t * szLanguageTag)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zUsername;
	zval * zAuthType;
	zval * zBanner;
	zval * zLanguageTag;
	SBArrayZValInfo aiLanguageTag;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zAuthType);
	ZVAL_LONG(zAuthType, (long)AuthType);
	MAKE_STD_ZVAL(zBanner);
	ZVAL_STRINGL(zBanner, pcBanner, *szBanner, 1);
	MAKE_STD_ZVAL(zLanguageTag);
	ZVAL_STRINGL(zLanguageTag, pLanguageTag, *szLanguageTag, 1);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zAuthType;
	params[3] = &zBanner;
	params[4] = &zLanguageTag;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zAuthType);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zBanner), (int32_t)Z_STRLEN_P(zBanner)) TSRMLS_CC);
	zval_ptr_dtor(&zBanner);
	if (SBGetByteArrayFromZVal(zLanguageTag, &aiLanguageTag TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(5, aiLanguageTag.data, aiLanguageTag.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiLanguageTag);
	zval_ptr_dtor(&zLanguageTag);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthPasswordEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, const char * pcPassword, int32_t szPassword, int8_t * Accept, int8_t * ForceChangePassword)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zUsername;
	zval * zPassword;
	zval * zAccept;
	zval * zForceChangePassword;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, szPassword, 1);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);
	MAKE_STD_ZVAL(zForceChangePassword);
	ZVAL_BOOL(zForceChangePassword, (zend_bool)*ForceChangePassword);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zPassword;
	params[3] = &zAccept;
	params[4] = &zForceChangePassword;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zPassword);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	*ForceChangePassword = (int8_t)Z_BVAL_P(zForceChangePassword);
	zval_ptr_dtor(&zForceChangePassword);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthPasswordChangeEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, const char * pcOldPassword, int32_t szOldPassword, const char * pcNewPassword, int32_t szNewPassword, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zUsername;
	zval * zOldPassword;
	zval * zNewPassword;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zOldPassword);
	ZVAL_STRINGL(zOldPassword, pcOldPassword, szOldPassword, 1);
	MAKE_STD_ZVAL(zNewPassword);
	ZVAL_STRINGL(zNewPassword, pcNewPassword, szNewPassword, 1);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zOldPassword;
	params[3] = &zNewPassword;
	params[4] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zOldPassword);
	zval_ptr_dtor(&zNewPassword);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthKeyboardEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, TStringListHandle Submethods, char * pcName, int32_t * szName, char * pcInstruction, int32_t * szInstruction, TStringListHandle Requests, TBitsHandle Echoes)
{
	zval *retval_ptr;
	zval **params[7];
	zval * zSender;
	zval * zUsername;
	zval * zSubmethods;
	zval * zName;
	zval * zInstruction;
	zval * zRequests;
	zval * zEchoes;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zSubmethods);
	SBInitObject(zSubmethods, TStringList_ce_ptr, Submethods TSRMLS_CC);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, *szName, 1);
	MAKE_STD_ZVAL(zInstruction);
	ZVAL_STRINGL(zInstruction, pcInstruction, *szInstruction, 1);
	MAKE_STD_ZVAL(zRequests);
	SBInitObject(zRequests, TStringList_ce_ptr, Requests TSRMLS_CC);
	MAKE_STD_ZVAL(zEchoes);
	SBInitObject(zEchoes, TBits_ce_ptr, Echoes TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zSubmethods;
	params[3] = &zName;
	params[4] = &zInstruction;
	params[5] = &zRequests;
	params[6] = &zEchoes;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 7, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zSubmethods);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zName), (int32_t)Z_STRLEN_P(zName)) TSRMLS_CC);
	zval_ptr_dtor(&zName);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zInstruction), (int32_t)Z_STRLEN_P(zInstruction)) TSRMLS_CC);
	zval_ptr_dtor(&zInstruction);
	zval_ptr_dtor(&zRequests);
	zval_ptr_dtor(&zEchoes);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHAuthKeyboardResponseEventRaw(void * _ObjectData, TObjectHandle Sender, TStringListHandle Requests, TStringListHandle Responses, char * pcName, int32_t * szName, char * pcInstruction, int32_t * szInstruction, TStringListHandle NewRequests, TBitsHandle Echoes, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[8];
	zval * zSender;
	zval * zRequests;
	zval * zResponses;
	zval * zName;
	zval * zInstruction;
	zval * zNewRequests;
	zval * zEchoes;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequests);
	SBInitObject(zRequests, TStringList_ce_ptr, Requests TSRMLS_CC);
	MAKE_STD_ZVAL(zResponses);
	SBInitObject(zResponses, TStringList_ce_ptr, Responses TSRMLS_CC);
	MAKE_STD_ZVAL(zName);
	ZVAL_STRINGL(zName, pcName, *szName, 1);
	MAKE_STD_ZVAL(zInstruction);
	ZVAL_STRINGL(zInstruction, pcInstruction, *szInstruction, 1);
	MAKE_STD_ZVAL(zNewRequests);
	SBInitObject(zNewRequests, TStringList_ce_ptr, NewRequests TSRMLS_CC);
	MAKE_STD_ZVAL(zEchoes);
	SBInitObject(zEchoes, TBits_ce_ptr, Echoes TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zRequests;
	params[2] = &zResponses;
	params[3] = &zName;
	params[4] = &zInstruction;
	params[5] = &zNewRequests;
	params[6] = &zEchoes;
	params[7] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 8, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequests);
	zval_ptr_dtor(&zResponses);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zName), (int32_t)Z_STRLEN_P(zName)) TSRMLS_CC);
	zval_ptr_dtor(&zName);
	SBCheckError(SBSetEventReturnStringA(5, Z_STRVAL_P(zInstruction), (int32_t)Z_STRLEN_P(zInstruction)) TSRMLS_CC);
	zval_ptr_dtor(&zInstruction);
	zval_ptr_dtor(&zNewRequests);
	zval_ptr_dtor(&zEchoes);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHFurtherAuthNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, int8_t * Needed)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zUsername;
	zval * zNeeded;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zNeeded);
	ZVAL_BOOL(zNeeded, (zend_bool)*Needed);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zNeeded;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	*Needed = (int8_t)Z_BVAL_P(zNeeded);
	zval_ptr_dtor(&zNeeded);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHBeforeOpenSessionEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHBeforeOpenShellEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zConnection;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHBeforeOpenCommandEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, const char * pcCommand, int32_t szCommand, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zConnection;
	zval * zCommand;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zCommand);
	ZVAL_STRINGL(zCommand, pcCommand, szCommand, 1);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zCommand;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	zval_ptr_dtor(&zCommand);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHBeforeOpenSubsystemEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcSubsystem, int32_t szSubsystem, TElSSHTunnelConnectionHandle Connection, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zSubsystem;
	zval * zConnection;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSubsystem);
	ZVAL_STRINGL(zSubsystem, pcSubsystem, szSubsystem, 1);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zSubsystem;
	params[2] = &zConnection;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSubsystem);
	zval_ptr_dtor(&zConnection);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHBeforeOpenClientForwardingEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcDestHost, int32_t szDestHost, int32_t DestPort, const char * pcSrcHost, int32_t szSrcHost, int32_t SrcPort, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zDestHost;
	zval * zDestPort;
	zval * zSrcHost;
	zval * zSrcPort;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDestHost);
	ZVAL_STRINGL(zDestHost, pcDestHost, szDestHost, 1);
	MAKE_STD_ZVAL(zDestPort);
	ZVAL_LONG(zDestPort, (long)DestPort);
	MAKE_STD_ZVAL(zSrcHost);
	ZVAL_STRINGL(zSrcHost, pcSrcHost, szSrcHost, 1);
	MAKE_STD_ZVAL(zSrcPort);
	ZVAL_LONG(zSrcPort, (long)SrcPort);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zDestHost;
	params[2] = &zDestPort;
	params[3] = &zSrcHost;
	params[4] = &zSrcPort;
	params[5] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDestHost);
	zval_ptr_dtor(&zDestPort);
	zval_ptr_dtor(&zSrcHost);
	zval_ptr_dtor(&zSrcPort);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHBeforeOpenX11ForwardingEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOrigIP, int32_t szOrigIP, int32_t OrigPort, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zOrigIP;
	zval * zOrigPort;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOrigIP);
	ZVAL_STRINGL(zOrigIP, pcOrigIP, szOrigIP, 1);
	MAKE_STD_ZVAL(zOrigPort);
	ZVAL_LONG(zOrigPort, (long)OrigPort);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zOrigIP;
	params[2] = &zOrigPort;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOrigIP);
	zval_ptr_dtor(&zOrigPort);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenSessionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zConnection;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zConnection;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenShellEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zConnection;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zConnection;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenCommandEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, const char * pcCommand, int32_t szCommand)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zConnection;
	zval * zCommand;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zCommand);
	ZVAL_STRINGL(zCommand, pcCommand, szCommand, 1);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zCommand;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	zval_ptr_dtor(&zCommand);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenSubsystemEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, const char * pcSubsystem, int32_t szSubsystem)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zConnection;
	zval * zSubsystem;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zSubsystem);
	ZVAL_STRINGL(zSubsystem, pcSubsystem, szSubsystem, 1);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zSubsystem;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	zval_ptr_dtor(&zSubsystem);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenClientForwardingEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, const char * pcDestHost, int32_t szDestHost, int32_t DestPort, const char * pcSrcHost, int32_t szSrcHost, int32_t SrcPort)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zConnection;
	zval * zDestHost;
	zval * zDestPort;
	zval * zSrcHost;
	zval * zSrcPort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zDestHost);
	ZVAL_STRINGL(zDestHost, pcDestHost, szDestHost, 1);
	MAKE_STD_ZVAL(zDestPort);
	ZVAL_LONG(zDestPort, (long)DestPort);
	MAKE_STD_ZVAL(zSrcHost);
	ZVAL_STRINGL(zSrcHost, pcSrcHost, szSrcHost, 1);
	MAKE_STD_ZVAL(zSrcPort);
	ZVAL_LONG(zSrcPort, (long)SrcPort);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zDestHost;
	params[3] = &zDestPort;
	params[4] = &zSrcHost;
	params[5] = &zSrcPort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	zval_ptr_dtor(&zDestHost);
	zval_ptr_dtor(&zDestPort);
	zval_ptr_dtor(&zSrcHost);
	zval_ptr_dtor(&zSrcPort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenServerForwardingEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zConnection;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zConnection;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHOpenX11ForwardingEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, const char * pcOrigIP, int32_t szOrigIP, int32_t OrigPort)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zConnection;
	zval * zOrigIP;
	zval * zOrigPort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zOrigIP);
	ZVAL_STRINGL(zOrigIP, pcOrigIP, szOrigIP, 1);
	MAKE_STD_ZVAL(zOrigPort);
	ZVAL_LONG(zOrigPort, (long)OrigPort);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zOrigIP;
	params[3] = &zOrigPort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	zval_ptr_dtor(&zOrigIP);
	zval_ptr_dtor(&zOrigPort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHServerForwardingFailedEventRaw(void * _ObjectData, TObjectHandle Sender, void * Data)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zData;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zData);
	SBInitPointerObject(zData, Data TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zData;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zData);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHServerForwardingRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcAddress, int32_t szAddress, int32_t Port, int8_t * Accept, int32_t * RealPort)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zAddress;
	zval * zPort;
	zval * zAccept;
	zval * zRealPort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAddress);
	ZVAL_STRINGL(zAddress, pcAddress, szAddress, 1);
	MAKE_STD_ZVAL(zPort);
	ZVAL_LONG(zPort, (long)Port);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);
	MAKE_STD_ZVAL(zRealPort);
	ZVAL_LONG(zRealPort, (long)*RealPort);

	params[0] = &zSender;
	params[1] = &zAddress;
	params[2] = &zPort;
	params[3] = &zAccept;
	params[4] = &zRealPort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAddress);
	zval_ptr_dtor(&zPort);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	*RealPort = (int32_t)Z_LVAL_P(zRealPort);
	zval_ptr_dtor(&zRealPort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHServerForwardingCancelEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcAddress, int32_t szAddress, int32_t Port)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zAddress;
	zval * zPort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAddress);
	ZVAL_STRINGL(zAddress, pcAddress, szAddress, 1);
	MAKE_STD_ZVAL(zPort);
	ZVAL_LONG(zPort, (long)Port);

	params[0] = &zSender;
	params[1] = &zAddress;
	params[2] = &zPort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAddress);
	zval_ptr_dtor(&zPort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHX11ForwardingRequestEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t SingleConnection, const char * pcAuthProtocol, int32_t szAuthProtocol, const char * pcAuthCookie, int32_t szAuthCookie, int32_t ScreenNumber, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zSingleConnection;
	zval * zAuthProtocol;
	zval * zAuthCookie;
	zval * zScreenNumber;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSingleConnection);
	ZVAL_BOOL(zSingleConnection, (zend_bool)SingleConnection);
	MAKE_STD_ZVAL(zAuthProtocol);
	ZVAL_STRINGL(zAuthProtocol, pcAuthProtocol, szAuthProtocol, 1);
	MAKE_STD_ZVAL(zAuthCookie);
	ZVAL_STRINGL(zAuthCookie, pcAuthCookie, szAuthCookie, 1);
	MAKE_STD_ZVAL(zScreenNumber);
	ZVAL_LONG(zScreenNumber, (long)ScreenNumber);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zSingleConnection;
	params[2] = &zAuthProtocol;
	params[3] = &zAuthCookie;
	params[4] = &zScreenNumber;
	params[5] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSingleConnection);
	zval_ptr_dtor(&zAuthProtocol);
	zval_ptr_dtor(&zAuthCookie);
	zval_ptr_dtor(&zScreenNumber);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHTerminalRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHTunnelConnectionHandle Connection, TElTerminalInfoHandle Info, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zConnection;
	zval * zInfo;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConnection);
	SBInitObject(zConnection, TElSSHTunnelConnection_ce_ptr, Connection TSRMLS_CC);
	MAKE_STD_ZVAL(zInfo);
	SBInitObject(zInfo, TElTerminalInfo_ce_ptr, Info TSRMLS_CC);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zConnection;
	params[2] = &zInfo;
	params[3] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConnection);
	zval_ptr_dtor(&zInfo);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSSHSpecialMessageEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Code, void * Buffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCode;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCode);
	ZVAL_LONG(zCode, (long)Code);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zCode;
	params[2] = &zBuffer;
	params[3] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCode);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBSSHBannerSendStage_ce_ptr = NULL;

zend_class_entry *TElSSHUser_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHUser, GetData)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElSSHUser_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, &l4SizeRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2044160758, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, SetData)
{
	long l4Size;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaValue, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHUser_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, SetBasePath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHUser_SetBasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, SetSSHKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHUser_SetSSHKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, AddUser_Inst)
{
	char *sBasePath;
	char *sPassword;
	char *sUserName;
	int sBasePath_len;
	int sPassword_len;
	int sUserName_len;
	zval *oKey;
	zval *oUsers;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHUser_AddUser_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!s", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &oKey, TElSSHKey_ce_ptr, &sBasePath, &sBasePath_len) == SUCCESS)
	{
		SBCheckError(TElSSHUser_AddUser_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, SBGetObjectHandle(oKey TSRMLS_CC), sBasePath, (int32_t)sBasePath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElUsers, string, string, TElSSHKey) or (TElUsers, string, string, TElSSHKey, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, AddUser)
{
	char *sBasePath;
	char *sPassword;
	char *sUserName;
	int sBasePath_len;
	int sPassword_len;
	int sUserName_len;
	zval *oKey;
	zval *oUsers;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHUser_AddUser(SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!s", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &oKey, TElSSHKey_ce_ptr, &sBasePath, &sBasePath_len) == SUCCESS)
	{
		SBCheckError(TElSSHUser_AddUser_2(SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, SBGetObjectHandle(oKey TSRMLS_CC), sBasePath, (int32_t)sBasePath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElUsers, string, string, TElSSHKey) or (TElUsers, string, string, TElSSHKey, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, IsValidSSHKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHUser_IsValidSSHKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHUser_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, get_SSHKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHUser_get_SSHKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, set_SSHKey)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHUser_set_SSHKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, get_BasePath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHUser_get_BasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(336649201, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, set_BasePath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHUser_set_BasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHUser, __construct)
{
	char *sUserName;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserName, &sUserName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHUser_Create(sUserName, (int32_t)sUserName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_GetData, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_SetData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_SetBasePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_SetSSHKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_AddUser_Inst, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Users, TElUsers, 1)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
	ZEND_ARG_INFO(0, BasePath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_AddUser, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Users, TElUsers, 1)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
	ZEND_ARG_INFO(0, BasePath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_IsValidSSHKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_get_SSHKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_set_SSHKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_get_BasePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser_set_BasePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHUser___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, UserName)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHUser_methods[] = {
	PHP_ME(TElSSHUser, GetData, arginfo_TElSSHUser_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, SetData, arginfo_TElSSHUser_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, SetBasePath, arginfo_TElSSHUser_SetBasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, SetSSHKey, arginfo_TElSSHUser_SetSSHKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, AddUser_Inst, arginfo_TElSSHUser_AddUser_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, AddUser, arginfo_TElSSHUser_AddUser, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSSHUser, IsValidSSHKey, arginfo_TElSSHUser_IsValidSSHKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, ClassType, arginfo_TElSSHUser_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSSHUser, get_SSHKey, arginfo_TElSSHUser_get_SSHKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, set_SSHKey, arginfo_TElSSHUser_set_SSHKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, get_BasePath, arginfo_TElSSHUser_get_BasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, set_BasePath, arginfo_TElSSHUser_set_BasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHUser, __construct, arginfo_TElSSHUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHUser", TElSSHUser_methods);
	if (NULL == TElCustomUser_ce_ptr)
		Register_TElCustomUser(TSRMLS_C);
	TElSSHUser_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomUser_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHServerTunnelConnection_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHServerTunnelConnection, SendData)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHServerTunnelConnection_SendData(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerTunnelConnection, SendExtendedData)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHServerTunnelConnection_SendExtendedData(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerTunnelConnection, CanSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHServerTunnelConnection_CanSend(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerTunnelConnection, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHServerTunnelConnection_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerTunnelConnection_SendData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerTunnelConnection_SendExtendedData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerTunnelConnection_CanSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerTunnelConnection___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHServerTunnelConnection_methods[] = {
	PHP_ME(TElSSHServerTunnelConnection, SendData, arginfo_TElSSHServerTunnelConnection_SendData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerTunnelConnection, SendExtendedData, arginfo_TElSSHServerTunnelConnection_SendExtendedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerTunnelConnection, CanSend, arginfo_TElSSHServerTunnelConnection_CanSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerTunnelConnection, __construct, arginfo_TElSSHServerTunnelConnection___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHServerTunnelConnection(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHServerTunnelConnection_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHServerTunnelConnection", TElSSHServerTunnelConnection_methods);
	if (NULL == TElSSHTunnelConnection_ce_ptr)
		Register_TElSSHTunnelConnection(TSRMLS_C);
	TElSSHServerTunnelConnection_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHTunnelConnection_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHServerAdditionalSettings_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHServerAdditionalSettings, get_OperationStatusCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHServerAdditionalSettings_get_OperationStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerAdditionalSettings, set_OperationStatusCode)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHServerAdditionalSettings_set_OperationStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerAdditionalSettings, get_OperationStatusString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHServerAdditionalSettings_get_OperationStatusString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-174126538, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerAdditionalSettings, set_OperationStatusString)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHServerAdditionalSettings_set_OperationStatusString(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServerAdditionalSettings, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHServerAdditionalSettings_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerAdditionalSettings_get_OperationStatusCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerAdditionalSettings_set_OperationStatusCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerAdditionalSettings_get_OperationStatusString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerAdditionalSettings_set_OperationStatusString, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServerAdditionalSettings___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHServerAdditionalSettings_methods[] = {
	PHP_ME(TElSSHServerAdditionalSettings, get_OperationStatusCode, arginfo_TElSSHServerAdditionalSettings_get_OperationStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerAdditionalSettings, set_OperationStatusCode, arginfo_TElSSHServerAdditionalSettings_set_OperationStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerAdditionalSettings, get_OperationStatusString, arginfo_TElSSHServerAdditionalSettings_get_OperationStatusString, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerAdditionalSettings, set_OperationStatusString, arginfo_TElSSHServerAdditionalSettings_set_OperationStatusString, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServerAdditionalSettings, __construct, arginfo_TElSSHServerAdditionalSettings___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHServerAdditionalSettings(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHServerAdditionalSettings_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHServerAdditionalSettings", TElSSHServerAdditionalSettings_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSHServerAdditionalSettings_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHServer_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHServer, Close)
{
	char *sReason;
	int sReason_len;
	long l4ErrorCode;
	zend_bool bForced;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bForced) == SUCCESS)
	{
		SBCheckError(TElSSHServer_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bForced) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4ErrorCode, &sReason, &sReason_len) == SUCCESS)
	{
		SBCheckError(TElSSHServer_Close_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ErrorCode, sReason, (int32_t)sReason_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHServer_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHServer_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, OpenServerForwarding)
{
	char *sAddress;
	char *sSrcHost;
	int sAddress_len;
	int sSrcHost_len;
	long l4Port;
	long l4SrcPort;
	SBArrayZValInfo piData;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slslz", &sAddress, &sAddress_len, &l4Port, &sSrcHost, &sSrcHost_len, &l4SrcPort, &zpData) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHServer_OpenServerForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), sAddress, (int32_t)sAddress_len, (int32_t)l4Port, sSrcHost, (int32_t)sSrcHost_len, (int32_t)l4SrcPort, piData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, string, integer, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, RenegotiateCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHServer_RenegotiateCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_ClientCloseReason)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHServer_get_ClientCloseReason(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1195811431, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHServer_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1229872270, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_ChangePwdPrompt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSSHServer_get_ChangePwdPrompt(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(473760028, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_ChangePwdPrompt)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHServer_set_ChangePwdPrompt(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_AuthTypePriorities)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHServer_get_AuthTypePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_AuthTypePriorities)
{
	long l4Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_AuthTypePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_DefaultWindowSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHServer_get_DefaultWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_DefaultWindowSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_DefaultWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_MinWindowSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHServer_get_MinWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_MinWindowSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_MinWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_AdditionalSettings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHServer_get_AdditionalSettings(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHServerAdditionalSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_ClientSoftwareName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHServer_get_ClientSoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1938576961, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_AllowedSubsystems)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHServer_get_AllowedSubsystems(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_KexKeyStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHServer_get_KexKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHCustomKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_KexKeyStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHCustomKeyStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_KexKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_ThreadSafe)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHServer_get_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_ThreadSafe)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_BannerSendStage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHBannerSendStageRaw fOutResultRaw = 0;
		SBCheckError(TElSSHServer_get_BannerSendStage(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_BannerSendStage)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_BannerSendStage(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHBannerSendStageRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_SSHAuthOrder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHAuthOrderRaw fOutResultRaw = 0;
		SBCheckError(TElSSHServer_get_SSHAuthOrder(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_SSHAuthOrder)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHServer_set_SSHAuthOrder(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHAuthOrderRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthAttempt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthAttemptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthAttempt)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthAttemptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthAttemptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthFailed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationFailedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthFailed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthFailed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthFailed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationFailedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationFailedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthBanner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthBannerEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthBanner(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthBanner)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthBanner(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthBannerEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthBannerEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthPassword)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthPasswordEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthPassword(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthPassword)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthPassword(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthPasswordEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthPasswordEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthPasswordChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthPasswordChangeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthPasswordChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthPasswordChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthPasswordChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthPasswordChangeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthPasswordChangeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthPublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthPublicKeyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthPublicKey)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthPublicKeyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthPublicKeyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthHostbased)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthHostbasedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthHostbased(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthHostbased)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthHostbased(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthHostbasedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthHostbasedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthKeyboard)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthKeyboardEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthKeyboard(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthKeyboard)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthKeyboard(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthKeyboardEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthKeyboardEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnAuthKeyboardResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthKeyboardResponseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnAuthKeyboardResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnAuthKeyboardResponse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnAuthKeyboardResponse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthKeyboardResponseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthKeyboardResponseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnFurtherAuthNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHFurtherAuthNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnFurtherAuthNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnFurtherAuthNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnFurtherAuthNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHFurtherAuthNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHFurtherAuthNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnBeforeOpenSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBeforeOpenSessionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnBeforeOpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnBeforeOpenSession)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnBeforeOpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBeforeOpenSessionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBeforeOpenSessionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnBeforeOpenShell)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBeforeOpenShellEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnBeforeOpenShell(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnBeforeOpenShell)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnBeforeOpenShell(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBeforeOpenShellEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBeforeOpenShellEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnBeforeOpenCommand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBeforeOpenCommandEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnBeforeOpenCommand(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnBeforeOpenCommand)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnBeforeOpenCommand(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBeforeOpenCommandEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBeforeOpenCommandEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnBeforeOpenSubsystem)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBeforeOpenSubsystemEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnBeforeOpenSubsystem(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnBeforeOpenSubsystem)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnBeforeOpenSubsystem(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBeforeOpenSubsystemEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBeforeOpenSubsystemEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnBeforeOpenClientForwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBeforeOpenClientForwardingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnBeforeOpenClientForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnBeforeOpenClientForwarding)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnBeforeOpenClientForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBeforeOpenClientForwardingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBeforeOpenClientForwardingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnBeforeOpenX11Forwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBeforeOpenX11ForwardingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnBeforeOpenX11Forwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnBeforeOpenX11Forwarding)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnBeforeOpenX11Forwarding(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBeforeOpenX11ForwardingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBeforeOpenX11ForwardingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenSessionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenSession)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenSession(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenSessionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenSessionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenShell)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenShellEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenShell(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenShell)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenShell(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenShellEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenShellEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenCommand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenCommandEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenCommand(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenCommand)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenCommand(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenCommandEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenCommandEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenSubsystem)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenSubsystemEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenSubsystem(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenSubsystem)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenSubsystem(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenSubsystemEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenSubsystemEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenClientForwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenClientForwardingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenClientForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenClientForwarding)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenClientForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenClientForwardingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenClientForwardingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenServerForwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenServerForwardingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenServerForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenServerForwarding)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenServerForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenServerForwardingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenServerForwardingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnOpenX11Forwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHOpenX11ForwardingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnOpenX11Forwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnOpenX11Forwarding)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnOpenX11Forwarding(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHOpenX11ForwardingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHOpenX11ForwardingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnServerForwardingFailed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHServerForwardingFailedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnServerForwardingFailed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnServerForwardingFailed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnServerForwardingFailed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHServerForwardingFailedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHServerForwardingFailedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnServerForwardingRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHServerForwardingRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnServerForwardingRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnServerForwardingRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnServerForwardingRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHServerForwardingRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHServerForwardingRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnServerForwardingCancel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHServerForwardingCancelEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnServerForwardingCancel(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnServerForwardingCancel)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnServerForwardingCancel(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHServerForwardingCancelEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHServerForwardingCancelEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnX11ForwardingRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHX11ForwardingRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnX11ForwardingRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnX11ForwardingRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnX11ForwardingRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHX11ForwardingRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHX11ForwardingRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnTerminalRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHTerminalRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnTerminalRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnTerminalRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnTerminalRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHTerminalRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHTerminalRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, get_OnSpecialMessageReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHSpecialMessageEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHServer_get_OnSpecialMessageReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, set_OnSpecialMessageReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHServer_set_OnSpecialMessageReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHSpecialMessageEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHSpecialMessageEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHServer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHServer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Forced_or_ErrorCode)
	ZEND_ARG_INFO(0, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_OpenServerForwarding, 0, 0, 5)
	ZEND_ARG_INFO(0, Address)
	ZEND_ARG_INFO(0, Port)
	ZEND_ARG_INFO(0, SrcHost)
	ZEND_ARG_INFO(0, SrcPort)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_RenegotiateCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_ClientCloseReason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_ChangePwdPrompt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_ChangePwdPrompt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_AuthTypePriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_AuthTypePriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_DefaultWindowSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_DefaultWindowSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_MinWindowSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_MinWindowSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_AdditionalSettings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_ClientSoftwareName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_AllowedSubsystems, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_KexKeyStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_KexKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHCustomKeyStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_ThreadSafe, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_ThreadSafe, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_BannerSendStage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_BannerSendStage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_SSHAuthOrder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_SSHAuthOrder, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthAttempt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthAttempt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthFailed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthFailed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthBanner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthBanner, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthPassword, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthPasswordChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthPasswordChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthPublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthPublicKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthHostbased, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthHostbased, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthKeyboard, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthKeyboard, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnAuthKeyboardResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnAuthKeyboardResponse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnFurtherAuthNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnFurtherAuthNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnBeforeOpenSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnBeforeOpenSession, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnBeforeOpenShell, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnBeforeOpenShell, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnBeforeOpenCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnBeforeOpenCommand, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnBeforeOpenSubsystem, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnBeforeOpenSubsystem, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnBeforeOpenClientForwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnBeforeOpenClientForwarding, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnBeforeOpenX11Forwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnBeforeOpenX11Forwarding, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenSession, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenShell, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenShell, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenCommand, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenSubsystem, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenSubsystem, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenClientForwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenClientForwarding, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenServerForwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenServerForwarding, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnOpenX11Forwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnOpenX11Forwarding, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnServerForwardingFailed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnServerForwardingFailed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnServerForwardingRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnServerForwardingRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnServerForwardingCancel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnServerForwardingCancel, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnX11ForwardingRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnX11ForwardingRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnTerminalRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnTerminalRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_get_OnSpecialMessageReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer_set_OnSpecialMessageReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHServer_methods[] = {
	PHP_ME(TElSSHServer, Close, arginfo_TElSSHServer_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, DataAvailable, arginfo_TElSSHServer_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, Open, arginfo_TElSSHServer_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, OpenServerForwarding, arginfo_TElSSHServer_OpenServerForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, RenegotiateCiphers, arginfo_TElSSHServer_RenegotiateCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_ClientCloseReason, arginfo_TElSSHServer_get_ClientCloseReason, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_Username, arginfo_TElSSHServer_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_ChangePwdPrompt, arginfo_TElSSHServer_get_ChangePwdPrompt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_ChangePwdPrompt, arginfo_TElSSHServer_set_ChangePwdPrompt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_AuthTypePriorities, arginfo_TElSSHServer_get_AuthTypePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_AuthTypePriorities, arginfo_TElSSHServer_set_AuthTypePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_DefaultWindowSize, arginfo_TElSSHServer_get_DefaultWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_DefaultWindowSize, arginfo_TElSSHServer_set_DefaultWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_MinWindowSize, arginfo_TElSSHServer_get_MinWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_MinWindowSize, arginfo_TElSSHServer_set_MinWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_AdditionalSettings, arginfo_TElSSHServer_get_AdditionalSettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_ClientSoftwareName, arginfo_TElSSHServer_get_ClientSoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_AllowedSubsystems, arginfo_TElSSHServer_get_AllowedSubsystems, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_KexKeyStorage, arginfo_TElSSHServer_get_KexKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_KexKeyStorage, arginfo_TElSSHServer_set_KexKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_ThreadSafe, arginfo_TElSSHServer_get_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_ThreadSafe, arginfo_TElSSHServer_set_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_BannerSendStage, arginfo_TElSSHServer_get_BannerSendStage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_BannerSendStage, arginfo_TElSSHServer_set_BannerSendStage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_SSHAuthOrder, arginfo_TElSSHServer_get_SSHAuthOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_SSHAuthOrder, arginfo_TElSSHServer_set_SSHAuthOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthAttempt, arginfo_TElSSHServer_get_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthAttempt, arginfo_TElSSHServer_set_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthFailed, arginfo_TElSSHServer_get_OnAuthFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthFailed, arginfo_TElSSHServer_set_OnAuthFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthBanner, arginfo_TElSSHServer_get_OnAuthBanner, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthBanner, arginfo_TElSSHServer_set_OnAuthBanner, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthPassword, arginfo_TElSSHServer_get_OnAuthPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthPassword, arginfo_TElSSHServer_set_OnAuthPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthPasswordChange, arginfo_TElSSHServer_get_OnAuthPasswordChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthPasswordChange, arginfo_TElSSHServer_set_OnAuthPasswordChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthPublicKey, arginfo_TElSSHServer_get_OnAuthPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthPublicKey, arginfo_TElSSHServer_set_OnAuthPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthHostbased, arginfo_TElSSHServer_get_OnAuthHostbased, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthHostbased, arginfo_TElSSHServer_set_OnAuthHostbased, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthKeyboard, arginfo_TElSSHServer_get_OnAuthKeyboard, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthKeyboard, arginfo_TElSSHServer_set_OnAuthKeyboard, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnAuthKeyboardResponse, arginfo_TElSSHServer_get_OnAuthKeyboardResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnAuthKeyboardResponse, arginfo_TElSSHServer_set_OnAuthKeyboardResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnFurtherAuthNeeded, arginfo_TElSSHServer_get_OnFurtherAuthNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnFurtherAuthNeeded, arginfo_TElSSHServer_set_OnFurtherAuthNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnBeforeOpenSession, arginfo_TElSSHServer_get_OnBeforeOpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnBeforeOpenSession, arginfo_TElSSHServer_set_OnBeforeOpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnBeforeOpenShell, arginfo_TElSSHServer_get_OnBeforeOpenShell, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnBeforeOpenShell, arginfo_TElSSHServer_set_OnBeforeOpenShell, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnBeforeOpenCommand, arginfo_TElSSHServer_get_OnBeforeOpenCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnBeforeOpenCommand, arginfo_TElSSHServer_set_OnBeforeOpenCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnBeforeOpenSubsystem, arginfo_TElSSHServer_get_OnBeforeOpenSubsystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnBeforeOpenSubsystem, arginfo_TElSSHServer_set_OnBeforeOpenSubsystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnBeforeOpenClientForwarding, arginfo_TElSSHServer_get_OnBeforeOpenClientForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnBeforeOpenClientForwarding, arginfo_TElSSHServer_set_OnBeforeOpenClientForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnBeforeOpenX11Forwarding, arginfo_TElSSHServer_get_OnBeforeOpenX11Forwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnBeforeOpenX11Forwarding, arginfo_TElSSHServer_set_OnBeforeOpenX11Forwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenSession, arginfo_TElSSHServer_get_OnOpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenSession, arginfo_TElSSHServer_set_OnOpenSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenShell, arginfo_TElSSHServer_get_OnOpenShell, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenShell, arginfo_TElSSHServer_set_OnOpenShell, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenCommand, arginfo_TElSSHServer_get_OnOpenCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenCommand, arginfo_TElSSHServer_set_OnOpenCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenSubsystem, arginfo_TElSSHServer_get_OnOpenSubsystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenSubsystem, arginfo_TElSSHServer_set_OnOpenSubsystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenClientForwarding, arginfo_TElSSHServer_get_OnOpenClientForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenClientForwarding, arginfo_TElSSHServer_set_OnOpenClientForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenServerForwarding, arginfo_TElSSHServer_get_OnOpenServerForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenServerForwarding, arginfo_TElSSHServer_set_OnOpenServerForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnOpenX11Forwarding, arginfo_TElSSHServer_get_OnOpenX11Forwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnOpenX11Forwarding, arginfo_TElSSHServer_set_OnOpenX11Forwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnServerForwardingFailed, arginfo_TElSSHServer_get_OnServerForwardingFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnServerForwardingFailed, arginfo_TElSSHServer_set_OnServerForwardingFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnServerForwardingRequest, arginfo_TElSSHServer_get_OnServerForwardingRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnServerForwardingRequest, arginfo_TElSSHServer_set_OnServerForwardingRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnServerForwardingCancel, arginfo_TElSSHServer_get_OnServerForwardingCancel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnServerForwardingCancel, arginfo_TElSSHServer_set_OnServerForwardingCancel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnX11ForwardingRequest, arginfo_TElSSHServer_get_OnX11ForwardingRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnX11ForwardingRequest, arginfo_TElSSHServer_set_OnX11ForwardingRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnTerminalRequest, arginfo_TElSSHServer_get_OnTerminalRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnTerminalRequest, arginfo_TElSSHServer_set_OnTerminalRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, get_OnSpecialMessageReceived, arginfo_TElSSHServer_get_OnSpecialMessageReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, set_OnSpecialMessageReceived, arginfo_TElSSHServer_set_OnSpecialMessageReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHServer, __construct, arginfo_TElSSHServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHServer", TElSSHServer_methods);
	if (NULL == TElSSHClass_ce_ptr)
		Register_TElSSHClass(TSRMLS_C);
	TElSSHServer_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHClass_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSHServer_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSSHServerState", NULL);
	TSSHServerState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSSHServerState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSSHServerState_ce_ptr, "ssBefore", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSSHServerState_ce_ptr, "ssIdentificationLineSent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSSHServerState_ce_ptr, "ssIdentificationLineReceived", 2)
	
	INIT_CLASS_ENTRY(ce, "TSSHServerProtService", NULL);
	TSSHServerProtService_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSSHServerProtService_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSSHServerProtService_ce_ptr, "spsNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSSHServerProtService_ce_ptr, "spsAuth", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSSHServerProtService_ce_ptr, "spsConn", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBSSHBannerSendStage", NULL);
	TSBSSHBannerSendStage_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSSHBannerSendStage_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHBannerSendStage_ce_ptr, "bssBeforeAuth", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHBannerSendStage_ce_ptr, "bssAfterSuccess", 1)
}

void Register_SBSSHServer_Aliases(TSRMLS_D)
{
	if (NULL == TElSSHServerTunnelConnection_ce_ptr)
		Register_TElSSHServerTunnelConnection(TSRMLS_C);
	zend_register_class_alias("ElSSHServerTunnelConnection", TElSSHServerTunnelConnection_ce_ptr);
	if (NULL == TElSSHServer_ce_ptr)
		Register_TElSSHServer(TSRMLS_C);
	zend_register_class_alias("ElSSHServer", TElSSHServer_ce_ptr);
}

