#include "sbtspserver.h"

zend_class_entry *TElServerTSPInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElServerTSPInfo, get_Nonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElServerTSPInfo_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1902527279, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElServerTSPInfo_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, get_Time)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElServerTSPInfo_get_Time(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, set_Time)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElServerTSPInfo_set_Time(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, get_AccuracySec)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElServerTSPInfo_get_AccuracySec(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, set_AccuracySec)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElServerTSPInfo_set_AccuracySec(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, get_AccuracyMilli)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElServerTSPInfo_get_AccuracyMilli(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, set_AccuracyMilli)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElServerTSPInfo_set_AccuracyMilli(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, get_AccuracyMicro)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElServerTSPInfo_get_AccuracyMicro(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, set_AccuracyMicro)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElServerTSPInfo_set_AccuracyMicro(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, get_TSAName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerTSPInfo_get_TSAName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElServerTSPInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElServerTSPInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_Time, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_set_Time, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_AccuracySec, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_set_AccuracySec, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_AccuracyMilli, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_set_AccuracyMilli, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_AccuracyMicro, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_set_AccuracyMicro, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo_get_TSAName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElServerTSPInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElServerTSPInfo_methods[] = {
	PHP_ME(TElServerTSPInfo, get_Nonce, arginfo_TElServerTSPInfo_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, get_HashAlgorithm, arginfo_TElServerTSPInfo_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, get_Time, arginfo_TElServerTSPInfo_get_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, set_Time, arginfo_TElServerTSPInfo_set_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, get_AccuracySec, arginfo_TElServerTSPInfo_get_AccuracySec, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, set_AccuracySec, arginfo_TElServerTSPInfo_set_AccuracySec, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, get_AccuracyMilli, arginfo_TElServerTSPInfo_get_AccuracyMilli, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, set_AccuracyMilli, arginfo_TElServerTSPInfo_set_AccuracyMilli, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, get_AccuracyMicro, arginfo_TElServerTSPInfo_get_AccuracyMicro, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, set_AccuracyMicro, arginfo_TElServerTSPInfo_set_AccuracyMicro, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, get_TSAName, arginfo_TElServerTSPInfo_get_TSAName, ZEND_ACC_PUBLIC)
	PHP_ME(TElServerTSPInfo, __construct, arginfo_TElServerTSPInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElServerTSPInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElServerTSPInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElServerTSPInfo", TElServerTSPInfo_methods);
	if (NULL == TElTSPInfo_ce_ptr)
		Register_TElTSPInfo(TSRMLS_C);
	TElServerTSPInfo_ce_ptr = zend_register_internal_class_ex(&ce, TElTSPInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomTSPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomTSPServer, get_TSPInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPServer_get_TSPInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElServerTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPServer, get_DefaultPolicy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCustomTSPServer_get_DefaultPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1225166978, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPServer, set_DefaultPolicy)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomTSPServer_set_DefaultPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPServer, get_IsAuthenticode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomTSPServer_get_IsAuthenticode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPServer, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPServer_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPServer, set_Certificates)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomTSPServer_set_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPServer, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPServer_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer_get_TSPInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer_get_DefaultPolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer_set_DefaultPolicy, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer_get_IsAuthenticode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer_set_Certificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomTSPServer_methods[] = {
	PHP_ME(TElCustomTSPServer, get_TSPInfo, arginfo_TElCustomTSPServer_get_TSPInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPServer, get_DefaultPolicy, arginfo_TElCustomTSPServer_get_DefaultPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPServer, set_DefaultPolicy, arginfo_TElCustomTSPServer_set_DefaultPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPServer, get_IsAuthenticode, arginfo_TElCustomTSPServer_get_IsAuthenticode, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPServer, get_Certificates, arginfo_TElCustomTSPServer_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPServer, set_Certificates, arginfo_TElCustomTSPServer_set_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPServer, __construct, arginfo_TElCustomTSPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomTSPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomTSPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomTSPServer", TElCustomTSPServer_methods);
	if (NULL == TElTSPClass_ce_ptr)
		Register_TElTSPClass(TSRMLS_C);
	TElCustomTSPServer_ce_ptr = zend_register_internal_class_ex(&ce, TElTSPClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFileTSPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElFileTSPServer, SaveReplyToStream)
{
	long fServerResult;
	long l4FailureInfo;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &fServerResult, &l4FailureInfo, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFileTSPServer_SaveReplyToStream(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPKIStatusRaw)fServerResult, (int32_t)l4FailureInfo, SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPServer, LoadRequestFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElFileTSPServer_LoadRequestFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFileTSPServer, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFileTSPServer_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPServer_SaveReplyToStream, 0, 0, 3)
	ZEND_ARG_INFO(0, ServerResult)
	ZEND_ARG_INFO(0, FailureInfo)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPServer_LoadRequestFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFileTSPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFileTSPServer_methods[] = {
	PHP_ME(TElFileTSPServer, SaveReplyToStream, arginfo_TElFileTSPServer_SaveReplyToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPServer, LoadRequestFromStream, arginfo_TElFileTSPServer_LoadRequestFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElFileTSPServer, __construct, arginfo_TElFileTSPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFileTSPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFileTSPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFileTSPServer", TElFileTSPServer_methods);
	if (NULL == TElCustomTSPServer_ce_ptr)
		Register_TElCustomTSPServer(TSRMLS_C);
	TElFileTSPServer_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomTSPServer_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBTSPServer_Aliases(TSRMLS_D)
{
	if (NULL == TElServerTSPInfo_ce_ptr)
		Register_TElServerTSPInfo(TSRMLS_C);
	zend_register_class_alias("ElServerTSPInfo", TElServerTSPInfo_ce_ptr);
	if (NULL == TElCustomTSPServer_ce_ptr)
		Register_TElCustomTSPServer(TSRMLS_C);
	zend_register_class_alias("ElCustomTSPServer", TElCustomTSPServer_ce_ptr);
	if (NULL == TElFileTSPServer_ce_ptr)
		Register_TElFileTSPServer(TSRMLS_C);
	zend_register_class_alias("ElFileTSPServer", TElFileTSPServer_ce_ptr);
}

