#include "sbunicode.h"

zend_class_entry *TElUnicodeConverter_ce_ptr = NULL;

SB_PHP_METHOD(TElUnicodeConverter, StrToUtf8)
{
	char *sSource;
	int sSource_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSource, &sSource_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElUnicodeConverter_StrToUtf8(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-762213990, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnicodeConverter, Utf8ToStr)
{
	SBArrayZValInfo aiSource;
	uint32_t _err;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSource) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		_err = TElUnicodeConverter_Utf8ToStr(SBGetObjectHandle(getThis() TSRMLS_CC), aiSource.data, aiSource.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1966738762, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSource);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnicodeConverter, StrToWideStr)
{
	char *sSource;
	int sSource_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSource, &sSource_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElUnicodeConverter_StrToWideStr(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1558532535, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnicodeConverter, WideStrToStr)
{
	SBArrayZValInfo aiSource;
	uint32_t _err;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSource) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		_err = TElUnicodeConverter_WideStrToStr(SBGetObjectHandle(getThis() TSRMLS_CC), aiSource.data, aiSource.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(825643561, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSource);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUnicodeConverter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUnicodeConverter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnicodeConverter_StrToUtf8, 0, 0, 1)
	ZEND_ARG_INFO(0, Source)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnicodeConverter_Utf8ToStr, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnicodeConverter_StrToWideStr, 0, 0, 1)
	ZEND_ARG_INFO(0, Source)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnicodeConverter_WideStrToStr, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUnicodeConverter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElUnicodeConverter_methods[] = {
	PHP_ME(TElUnicodeConverter, StrToUtf8, arginfo_TElUnicodeConverter_StrToUtf8, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnicodeConverter, Utf8ToStr, arginfo_TElUnicodeConverter_Utf8ToStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnicodeConverter, StrToWideStr, arginfo_TElUnicodeConverter_StrToWideStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnicodeConverter, WideStrToStr, arginfo_TElUnicodeConverter_WideStrToStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElUnicodeConverter, __construct, arginfo_TElUnicodeConverter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElUnicodeConverter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElUnicodeConverter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElUnicodeConverter", TElUnicodeConverter_methods);
	if (NULL == TElStringConverter_ce_ptr)
		Register_TElStringConverter(TSRMLS_C);
	TElUnicodeConverter_ce_ptr = zend_register_internal_class_ex(&ce, TElStringConverter_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBUnicode, CreateUnicodeStringConverter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBUnicode_CreateUnicodeStringConverter(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElStringConverter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

