#include "sbwebsocketcommon.h"

zend_class_entry *TSBMsgType_ce_ptr = NULL;

void SB_CALLBACK TSBWSBeforeMsgSendEventRaw(void * _ObjectData, TObjectHandle Sender, TElWebSocketMessageHandle Msg)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMsg;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMsg);
	SBInitObject(zMsg, TElWebSocketMessage_ce_ptr, Msg TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zMsg;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMsg);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWSMsgReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, TElWebSocketMessageHandle Msg)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMsg;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMsg);
	SBInitObject(zMsg, TElWebSocketMessage_ce_ptr, Msg TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zMsg;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMsg);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWSPongEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWSTextDataEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcText, int32_t szText, int8_t Last)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zText;
	zval * zLast;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zText);
	ZVAL_STRINGL(zText, pcText, szText, 1);
	MAKE_STD_ZVAL(zLast);
	ZVAL_BOOL(zLast, (zend_bool)Last);

	params[0] = &zSender;
	params[1] = &zText;
	params[2] = &zLast;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zText);
	zval_ptr_dtor(&zLast);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWSCloseConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t Remote, int32_t CloseDescription)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zRemote;
	zval * zCloseDescription;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRemote);
	ZVAL_BOOL(zRemote, (zend_bool)Remote);
	MAKE_STD_ZVAL(zCloseDescription);
	ZVAL_LONG(zCloseDescription, (long)CloseDescription);

	params[0] = &zSender;
	params[1] = &zRemote;
	params[2] = &zCloseDescription;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRemote);
	zval_ptr_dtor(&zCloseDescription);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBWSBinaryDataEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t Size, int8_t Last)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	zval * zLast;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);
	MAKE_STD_ZVAL(zLast);
	ZVAL_BOOL(zLast, (zend_bool)Last);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	params[3] = &zLast;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	zval_ptr_dtor(&zLast);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElWebSocketMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketMessage, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketMessage_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElWebSocketMessage_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, &l4SizeRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1196885365, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, LoadFromBuffer)
{
	long l4Offset;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Offset, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebSocketMessage_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Offset, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_IsFinal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_IsFinal(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_IsFinal)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_set_IsFinal(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_RSV1)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_RSV1(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_RSV1)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_set_RSV1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_RSV2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_RSV2(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_RSV2)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_set_RSV2(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_RSV3)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_RSV3(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_RSV3)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_set_RSV3(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_OpCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_OpCode(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_OpCode)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_set_OpCode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_Mask)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_Mask(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_Mask)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketMessage_set_Mask(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_PayloadLen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_PayloadLen(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_Fragmented)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_Fragmented(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_MaskKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElWebSocketMessage_get_MaskKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-354037792, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_MaskKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebSocketMessage_set_MaskKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_PayloadData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElWebSocketMessage_get_PayloadData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1052436182, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, set_PayloadData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebSocketMessage_set_PayloadData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, get_FullSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketMessage_get_FullSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketMessage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_LoadFromBuffer, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_IsFinal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_IsFinal, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_RSV1, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_RSV1, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_RSV2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_RSV2, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_RSV3, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_RSV3, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_OpCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_OpCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_Mask, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_Mask, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_PayloadLen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_Fragmented, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_MaskKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_MaskKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_PayloadData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_set_PayloadData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage_get_FullSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketMessage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketMessage_methods[] = {
	PHP_ME(TElWebSocketMessage, Clone, arginfo_TElWebSocketMessage_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, Clear, arginfo_TElWebSocketMessage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, SaveToBuffer, arginfo_TElWebSocketMessage_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, LoadFromBuffer, arginfo_TElWebSocketMessage_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_IsFinal, arginfo_TElWebSocketMessage_get_IsFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_IsFinal, arginfo_TElWebSocketMessage_set_IsFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_RSV1, arginfo_TElWebSocketMessage_get_RSV1, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_RSV1, arginfo_TElWebSocketMessage_set_RSV1, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_RSV2, arginfo_TElWebSocketMessage_get_RSV2, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_RSV2, arginfo_TElWebSocketMessage_set_RSV2, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_RSV3, arginfo_TElWebSocketMessage_get_RSV3, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_RSV3, arginfo_TElWebSocketMessage_set_RSV3, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_OpCode, arginfo_TElWebSocketMessage_get_OpCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_OpCode, arginfo_TElWebSocketMessage_set_OpCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_Mask, arginfo_TElWebSocketMessage_get_Mask, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_Mask, arginfo_TElWebSocketMessage_set_Mask, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_PayloadLen, arginfo_TElWebSocketMessage_get_PayloadLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_Fragmented, arginfo_TElWebSocketMessage_get_Fragmented, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_MaskKey, arginfo_TElWebSocketMessage_get_MaskKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_MaskKey, arginfo_TElWebSocketMessage_set_MaskKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_PayloadData, arginfo_TElWebSocketMessage_get_PayloadData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, set_PayloadData, arginfo_TElWebSocketMessage_set_PayloadData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, get_FullSize, arginfo_TElWebSocketMessage_get_FullSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketMessage, __construct, arginfo_TElWebSocketMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketMessage", TElWebSocketMessage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebSocketMessage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebSocketOption_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketOption, Assign)
{
	zval *oOption;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOption, TElWebSocketOption_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebSocketOption_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOption TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketOption)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketOption_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketOption_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketOption_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(678188887, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketOption_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, set_Active)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketOption_set_Active(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, get_Priority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketOption_get_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, set_Priority)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebSocketOption_set_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, get_ParamStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketOption_get_ParamStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-16014019, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, set_ParamStr)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebSocketOption_set_ParamStr(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketOption, __construct)
{
	long l4APriority;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketOption_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4APriority) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketOption_Create_1((int32_t)l4APriority, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Option, TElWebSocketOption, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_set_Active, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_get_Priority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_set_Priority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_get_ParamStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption_set_ParamStr, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketOption___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, APriority)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketOption_methods[] = {
	PHP_ME(TElWebSocketOption, Assign, arginfo_TElWebSocketOption_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, Clone, arginfo_TElWebSocketOption_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, get_Name, arginfo_TElWebSocketOption_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, get_Active, arginfo_TElWebSocketOption_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, set_Active, arginfo_TElWebSocketOption_set_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, get_Priority, arginfo_TElWebSocketOption_get_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, set_Priority, arginfo_TElWebSocketOption_set_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, get_ParamStr, arginfo_TElWebSocketOption_get_ParamStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, set_ParamStr, arginfo_TElWebSocketOption_set_ParamStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketOption, __construct, arginfo_TElWebSocketOption___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketOption(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketOption_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketOption", TElWebSocketOption_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebSocketOption_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebSocketExtension_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketExtension, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtension_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtension, Encode)
{
	zval *oMsg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMsg, TElWebSocketMessage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtension_Encode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtension, Decode)
{
	zval *oMsg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMsg, TElWebSocketMessage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtension_Decode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtension, __construct)
{
	long l4APriority;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtension_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4APriority) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtension_Create_1((int32_t)l4APriority, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtension_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtension_Encode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElWebSocketMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtension_Decode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElWebSocketMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtension___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, APriority)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketExtension_methods[] = {
	PHP_ME(TElWebSocketExtension, Clone, arginfo_TElWebSocketExtension_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtension, Encode, arginfo_TElWebSocketExtension_Encode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtension, Decode, arginfo_TElWebSocketExtension_Decode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtension, __construct, arginfo_TElWebSocketExtension___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketExtension(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketExtension_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketExtension", TElWebSocketExtension_methods);
	if (NULL == TElWebSocketOption_ce_ptr)
		Register_TElWebSocketOption(TSRMLS_C);
	TElWebSocketExtension_ce_ptr = zend_register_internal_class_ex(&ce, TElWebSocketOption_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebSocketBase_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketBase, SetControl)
{
	zval *oControl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oControl, TElSSLClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_SetControl(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oControl TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, CreateWebSocketAccept_Inst)
{
	char *sKey;
	int sKey_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketBase_CreateWebSocketAccept_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1877254269, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, CreateWebSocketAccept)
{
	char *sKey;
	int sKey_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketBase_CreateWebSocketAccept(sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1877254269, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, Close)
{
	long l4CloseDescription;
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bl", &bSilent, &l4CloseDescription) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_Close_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent, (int32_t)l4CloseDescription) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, SendData)
{
	long l4Count;
	long l4OpCode;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	zval *oStrm;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebSocketBase_SendData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4StartIndex, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWebSocketBase_SendData_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_SendData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStrm, TStream_ce_ptr, &l4OpCode) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_SendData_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int32_t)l4OpCode) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, integer, integer) or (TStream) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, SendText)
{
	char *sText;
	int sText_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sText, &sText_len) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_SendText(SBGetObjectHandle(getThis() TSRMLS_CC), sText, (int32_t)sText_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, Ping)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_Ping(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_SubProtocols)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_SubProtocols(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketSubProtocols_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_SubProtocol)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_SubProtocol(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketSubProtocol_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketExtensions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OwnTag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketBase_get_OwnTag(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OwnTag)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_set_OwnTag(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWebSocketBase_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_ProtocolStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketBase_get_ProtocolStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1414099983, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_PeerSubProtocolStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketBase_get_PeerSubProtocolStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-181925215, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_PeerSubProtocolStr)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_set_PeerSubProtocolStr(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_ExtensionsStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketBase_get_ExtensionsStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1348538133, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_PeerExtensionsStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWebSocketBase_get_PeerExtensionsStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-63096740, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_PeerExtensionsStr)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_set_PeerExtensionsStr(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_FrameLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketBase_get_FrameLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_FrameLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWebSocketBase_set_FrameLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OnBeforeMessageSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSBeforeMsgSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_OnBeforeMessageSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OnBeforeMessageSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketBase_set_OnBeforeMessageSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSBeforeMsgSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSBeforeMsgSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OnMessageReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSMsgReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_OnMessageReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OnMessageReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketBase_set_OnMessageReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSMsgReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSMsgReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OnBinaryData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSBinaryDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_OnBinaryData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OnBinaryData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketBase_set_OnBinaryData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSBinaryDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSBinaryDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OnTextData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSTextDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_OnTextData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OnTextData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketBase_set_OnTextData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSTextDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSTextDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OnPong)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSPongEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_OnPong(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OnPong)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketBase_set_OnPong(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSPongEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSPongEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketBase_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketBase_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketBase, __construct)
{
	zval *oControl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketBase_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oControl, TElSSLClass_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketBase_Create_1(SBGetObjectHandle(oControl TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElSSLClass)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_SetControl, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Control, TElSSLClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_CreateWebSocketAccept_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_CreateWebSocketAccept, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
	ZEND_ARG_INFO(0, CloseDescription)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_SendData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, StartIndex_or_OpCode)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_SendText, 0, 0, 1)
	ZEND_ARG_INFO(0, Text)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_Ping, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_SubProtocols, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_SubProtocol, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OwnTag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OwnTag, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_ProtocolStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_PeerSubProtocolStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_PeerSubProtocolStr, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_ExtensionsStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_PeerExtensionsStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_PeerExtensionsStr, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_FrameLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_FrameLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OnBeforeMessageSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OnBeforeMessageSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OnMessageReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OnMessageReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OnBinaryData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OnBinaryData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OnTextData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OnTextData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OnPong, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OnPong, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketBase___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Control, TElSSLClass, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketBase_methods[] = {
	PHP_ME(TElWebSocketBase, SetControl, arginfo_TElWebSocketBase_SetControl, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, CreateWebSocketAccept_Inst, arginfo_TElWebSocketBase_CreateWebSocketAccept_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, CreateWebSocketAccept, arginfo_TElWebSocketBase_CreateWebSocketAccept, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElWebSocketBase, Close, arginfo_TElWebSocketBase_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, SendData, arginfo_TElWebSocketBase_SendData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, SendText, arginfo_TElWebSocketBase_SendText, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, Ping, arginfo_TElWebSocketBase_Ping, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_SubProtocols, arginfo_TElWebSocketBase_get_SubProtocols, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_SubProtocol, arginfo_TElWebSocketBase_get_SubProtocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_Extensions, arginfo_TElWebSocketBase_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_Tag, arginfo_TElWebSocketBase_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_Tag, arginfo_TElWebSocketBase_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OwnTag, arginfo_TElWebSocketBase_get_OwnTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OwnTag, arginfo_TElWebSocketBase_set_OwnTag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_Active, arginfo_TElWebSocketBase_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_ProtocolStr, arginfo_TElWebSocketBase_get_ProtocolStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_PeerSubProtocolStr, arginfo_TElWebSocketBase_get_PeerSubProtocolStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_PeerSubProtocolStr, arginfo_TElWebSocketBase_set_PeerSubProtocolStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_ExtensionsStr, arginfo_TElWebSocketBase_get_ExtensionsStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_PeerExtensionsStr, arginfo_TElWebSocketBase_get_PeerExtensionsStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_PeerExtensionsStr, arginfo_TElWebSocketBase_set_PeerExtensionsStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_FrameLength, arginfo_TElWebSocketBase_get_FrameLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_FrameLength, arginfo_TElWebSocketBase_set_FrameLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OnBeforeMessageSend, arginfo_TElWebSocketBase_get_OnBeforeMessageSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OnBeforeMessageSend, arginfo_TElWebSocketBase_set_OnBeforeMessageSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OnMessageReceived, arginfo_TElWebSocketBase_get_OnMessageReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OnMessageReceived, arginfo_TElWebSocketBase_set_OnMessageReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OnBinaryData, arginfo_TElWebSocketBase_get_OnBinaryData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OnBinaryData, arginfo_TElWebSocketBase_set_OnBinaryData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OnTextData, arginfo_TElWebSocketBase_get_OnTextData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OnTextData, arginfo_TElWebSocketBase_set_OnTextData, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OnPong, arginfo_TElWebSocketBase_get_OnPong, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OnPong, arginfo_TElWebSocketBase_set_OnPong, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, get_OnCloseConnection, arginfo_TElWebSocketBase_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, set_OnCloseConnection, arginfo_TElWebSocketBase_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketBase, __construct, arginfo_TElWebSocketBase___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketBase(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketBase_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketBase", TElWebSocketBase_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebSocketBase_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebSocketSubProtocol_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketSubProtocol, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocol_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketSubProtocol_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocol, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocol_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketBase_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocol, get_OnMessageReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWSMsgReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocol_get_OnMessageReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocol, set_OnMessageReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWebSocketSubProtocol_set_OnMessageReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWSMsgReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWSMsgReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocol, __construct)
{
	long l4APriority;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocol_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4APriority) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocol_Create_1((int32_t)l4APriority, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocol_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocol_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocol_get_OnMessageReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocol_set_OnMessageReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocol___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, APriority)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketSubProtocol_methods[] = {
	PHP_ME(TElWebSocketSubProtocol, Clone, arginfo_TElWebSocketSubProtocol_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocol, get_Owner, arginfo_TElWebSocketSubProtocol_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocol, get_OnMessageReceived, arginfo_TElWebSocketSubProtocol_get_OnMessageReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocol, set_OnMessageReceived, arginfo_TElWebSocketSubProtocol_set_OnMessageReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocol, __construct, arginfo_TElWebSocketSubProtocol___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketSubProtocol(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketSubProtocol_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketSubProtocol", TElWebSocketSubProtocol_methods);
	if (NULL == TElWebSocketOption_ce_ptr)
		Register_TElWebSocketOption(TSRMLS_C);
	TElWebSocketSubProtocol_ce_ptr = zend_register_internal_class_ex(&ce, TElWebSocketOption_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebSocketExtensions_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketExtensions, CopyTo)
{
	zval *oExts;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oExts, TElWebSocketExtensions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebSocketExtensions_CopyTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oExts TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketExtensions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, Encode)
{
	zval *oMsg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMsg, TElWebSocketMessage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtensions_Encode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, Decode)
{
	zval *oMsg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMsg, TElWebSocketMessage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtensions_Decode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, Add)
{
	zval *oExt;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oExt, TElWebSocketExtension_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketExtensions_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oExt TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElWebSocketExtensions_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, Sort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebSocketExtensions_Sort(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtensions_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketExtension_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketExtensions_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketExtensions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketExtensions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_CopyTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Exts, TElWebSocketExtensions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_Encode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElWebSocketMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_Decode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElWebSocketMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Ext, TElWebSocketExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_Sort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketExtensions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketExtensions_methods[] = {
	PHP_ME(TElWebSocketExtensions, CopyTo, arginfo_TElWebSocketExtensions_CopyTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, Encode, arginfo_TElWebSocketExtensions_Encode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, Decode, arginfo_TElWebSocketExtensions_Decode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, Add, arginfo_TElWebSocketExtensions_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, Remove, arginfo_TElWebSocketExtensions_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, Sort, arginfo_TElWebSocketExtensions_Sort, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, get_Items, arginfo_TElWebSocketExtensions_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, get_Count, arginfo_TElWebSocketExtensions_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketExtensions, __construct, arginfo_TElWebSocketExtensions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketExtensions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketExtensions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketExtensions", TElWebSocketExtensions_methods);
	if (NULL == TElWebSocketExtension_ce_ptr)
		Register_TElWebSocketExtension(TSRMLS_C);
	TElWebSocketExtensions_ce_ptr = zend_register_internal_class_ex(&ce, TElWebSocketExtension_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWebSocketSubProtocols_ce_ptr = NULL;

SB_PHP_METHOD(TElWebSocketSubProtocols, CopyTo)
{
	zval *oProtos;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProtos, TElWebSocketSubProtocols_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWebSocketSubProtocols_CopyTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProtos TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketSubProtocols)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, Add)
{
	zval *oProto;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProto, TElWebSocketSubProtocol_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketSubProtocols_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProto TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElWebSocketSubProtocol)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElWebSocketSubProtocols_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, Sort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWebSocketSubProtocols_Sort(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocols_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketSubProtocol_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWebSocketSubProtocols_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocols_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWebSocketBase_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWebSocketSubProtocols, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWebSocketSubProtocols_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_CopyTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Protos, TElWebSocketSubProtocols, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Proto, TElWebSocketSubProtocol, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_Sort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWebSocketSubProtocols___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWebSocketSubProtocols_methods[] = {
	PHP_ME(TElWebSocketSubProtocols, CopyTo, arginfo_TElWebSocketSubProtocols_CopyTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, Add, arginfo_TElWebSocketSubProtocols_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, Remove, arginfo_TElWebSocketSubProtocols_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, Sort, arginfo_TElWebSocketSubProtocols_Sort, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, get_Items, arginfo_TElWebSocketSubProtocols_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, get_Count, arginfo_TElWebSocketSubProtocols_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, get_Owner, arginfo_TElWebSocketSubProtocols_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElWebSocketSubProtocols, __construct, arginfo_TElWebSocketSubProtocols___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWebSocketSubProtocols(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWebSocketSubProtocols_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWebSocketSubProtocols", TElWebSocketSubProtocols_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWebSocketSubProtocols_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBWebSocketCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_VERSION, SB_WS_VERSION, SB_WS_VERSION);
	SB_REGISTER_STRING_CONSTANT(SBWebSocketCommon, WS_VERSION_STR, SB_WS_VERSION_STR, SB_WS_VERSION_STR);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, DEFAULT_FRAME_LEN, SB_DEFAULT_FRAME_LEN, SB_DEFAULT_FRAME_LEN);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_MODE_CLIENT, SB_WS_MODE_CLIENT, SB_WS_MODE_CLIENT);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_MODE_SERVER, SB_WS_MODE_SERVER, SB_WS_MODE_SERVER);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_NO_CLOSE_DESC, SB_WS_NO_CLOSE_DESC, SB_WS_NO_CLOSE_DESC);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_OK, SB_WS_STATUS_OK, SB_WS_STATUS_OK);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_GOING_AWAY, SB_WS_STATUS_GOING_AWAY, SB_WS_STATUS_GOING_AWAY);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_PROTOCOL_ERROR, SB_WS_STATUS_PROTOCOL_ERROR, SB_WS_STATUS_PROTOCOL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_CANT_ACCEPT_DATA, SB_WS_STATUS_CANT_ACCEPT_DATA, SB_WS_STATUS_CANT_ACCEPT_DATA);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_RESERVED, SB_WS_STATUS_RESERVED, SB_WS_STATUS_RESERVED);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_NO_STATUS_CODE, SB_WS_STATUS_NO_STATUS_CODE, SB_WS_STATUS_NO_STATUS_CODE);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_CONN_CLOSED_ABNORMALLY, SB_WS_STATUS_CONN_CLOSED_ABNORMALLY, SB_WS_STATUS_CONN_CLOSED_ABNORMALLY);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_NOT_CONSISTENT_DATA, SB_WS_STATUS_NOT_CONSISTENT_DATA, SB_WS_STATUS_NOT_CONSISTENT_DATA);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_POLICY_VIOLATION, SB_WS_STATUS_POLICY_VIOLATION, SB_WS_STATUS_POLICY_VIOLATION);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_TOO_BIG_MESSAGE, SB_WS_STATUS_TOO_BIG_MESSAGE, SB_WS_STATUS_TOO_BIG_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_CLIENT_EXTENSIONS_EXPECTED, SB_WS_STATUS_CLIENT_EXTENSIONS_EXPECTED, SB_WS_STATUS_CLIENT_EXTENSIONS_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_UNEXPECTED, SB_WS_STATUS_UNEXPECTED, SB_WS_STATUS_UNEXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_STATUS_TLS_HANDSHAKE_FAILURE, SB_WS_STATUS_TLS_HANDSHAKE_FAILURE, SB_WS_STATUS_TLS_HANDSHAKE_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_OP_CONTINUATION, SB_WS_OP_CONTINUATION, SB_WS_OP_CONTINUATION);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_OP_TEXT, SB_WS_OP_TEXT, SB_WS_OP_TEXT);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_OP_BINARY, SB_WS_OP_BINARY, SB_WS_OP_BINARY);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_OP_CLOSE, SB_WS_OP_CLOSE, SB_WS_OP_CLOSE);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_OP_PING, SB_WS_OP_PING, SB_WS_OP_PING);
	SB_REGISTER_LONG_CONSTANT(SBWebSocketCommon, WS_OP_PONG, SB_WS_OP_PONG, SB_WS_OP_PONG);
}

void Register_SBWebSocketCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBMsgType", NULL);
	TSBMsgType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBMsgType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBMsgType_ce_ptr, "wmtNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBMsgType_ce_ptr, "wmtBinary", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBMsgType_ce_ptr, "wmtText", 2)
}

