#include "sbx509ex.h"

zend_class_entry *TElX509CertificateEx_ce_ptr = NULL;

SB_PHP_METHOD(TElX509CertificateEx, WriteIssuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElX509CertificateEx_WriteIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1055420259, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, WriteSubject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElX509CertificateEx_WriteSubject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-119655019, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, SetIssuer)
{
	zval *oIssuer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oIssuer, TName_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_SetIssuer(SBGetObjectHandle(getThis() TSRMLS_CC), (TName *)SBGetStructPointer(oIssuer TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, SetSubject)
{
	zval *oSubject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oSubject, TName_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_SetSubject(SBGetObjectHandle(getThis() TSRMLS_CC), (TName *)SBGetStructPointer(oSubject TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, SetLongSerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElX509CertificateEx_SetLongSerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, Generate)
{
	long l4Algorithm;
	long l4Bits;
	long l4DWordsInEncryptKey;
	zval *oCertificate;
	zval *oKeyAlgorithm;
	zval *oParent;
	zval *oRequest;
	zval *oSignatureAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4DWordsInEncryptKey) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4DWordsInEncryptKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oRequest, TElCertificateRequest_ce_ptr, &oCertificate, TElX509CertificateEx_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_Generate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRequest TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oRequest, TElCertificateRequest_ce_ptr, &oCertificate, TElX509CertificateEx_ce_ptr, &oSignatureAlgorithm, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_Generate_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRequest TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), SBGetObjectHandle(oSignatureAlgorithm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oParent, TElX509Certificate_ce_ptr, &l4Algorithm, &l4DWordsInEncryptKey) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_Generate_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4DWordsInEncryptKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oKeyAlgorithm, TElAlgorithmIdentifier_ce_ptr, &oSignatureAlgorithm, TElAlgorithmIdentifier_ce_ptr, &l4Bits) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_Generate_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyAlgorithm TSRMLS_CC), SBGetObjectHandle(oSignatureAlgorithm TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!l", &oParent, TElX509Certificate_ce_ptr, &oKeyAlgorithm, TElAlgorithmIdentifier_ce_ptr, &oSignatureAlgorithm, TElAlgorithmIdentifier_ce_ptr, &l4Bits) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_Generate_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oKeyAlgorithm TSRMLS_CC), SBGetObjectHandle(oSignatureAlgorithm TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (TElCertificateRequest, TElX509CertificateEx) or (TElCertificateRequest, TElX509CertificateEx, TElAlgorithmIdentifier) or (TElX509Certificate, integer, integer) or (TElAlgorithmIdentifier, TElAlgorithmIdentifier, integer) or (TElX509Certificate, TElAlgorithmIdentifier, TElAlgorithmIdentifier, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, CAGenerate)
{
	long l4Algorithm;
	long l4DWordsInEncryptKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4DWordsInEncryptKey) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_CAGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4DWordsInEncryptKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, BeginGenerate)
{
	long l4Algorithm;
	long l4DWordsInEncryptKey;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4DWordsInEncryptKey) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_BeginGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4DWordsInEncryptKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oParent, TElX509Certificate_ce_ptr, &l4Algorithm, &l4DWordsInEncryptKey) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_BeginGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4DWordsInEncryptKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (TElX509Certificate, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, EndGenerate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_EndGenerate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, CancelGeneration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_CancelGeneration(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateEx_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, SetCACertificate)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oCert;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElX509CertificateEx_SetCACertificate(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_SetCACertificate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, SetCAPrivateKey)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElX509CertificateEx_SetCAPrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, Sign)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zend_bool bDetached;
	zend_bool bIncludeCertificates;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzbb", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &bDetached, &bIncludeCertificates) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElX509CertificateEx_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bDetached, (int8_t)bIncludeCertificates, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, Verify)
{
	long l4InSize;
	long l4SignatureSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piSignature;
	zval *zpInBuffer;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpInBuffer, &l4InSize, &zpSignature, &l4SignatureSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElX509CertificateEx_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piSignature.data, (int32_t)l4SignatureSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piSignature);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateEx_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, get_PreserveKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateEx_get_PreserveKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, set_PreserveKeyMaterial)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_set_PreserveKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, get_AltKeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElX509CertificateEx_get_AltKeyID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2138353442, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, set_AltKeyID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElX509CertificateEx_set_AltKeyID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, get_PreferredHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElX509CertificateEx_get_PreferredHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, set_PreferredHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_set_PreferredHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, get_SaveDefaultASN1Tags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateEx_get_SaveDefaultASN1Tags(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, set_SaveDefaultASN1Tags)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateEx_set_SaveDefaultASN1Tags(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateEx, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateEx_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_WriteIssuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_WriteSubject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_SetIssuer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Issuer, TName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_SetSubject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Subject, TName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_SetLongSerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_Generate, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_Request_or_Parent_or_KeyAlgorithm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DWordsInEncryptKey_or_Certificate_or_Algorithm_or_SignatureAlgorithm_or_KeyAlgorithm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SignatureAlgorithm_or_DWordsInEncryptKey_or_Bits, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_CAGenerate, 0, 0, 2)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, DWordsInEncryptKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_BeginGenerate, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_Parent, 0, 1)
	ZEND_ARG_INFO(0, DWordsInEncryptKey_or_Algorithm)
	ZEND_ARG_INFO(0, DWordsInEncryptKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_EndGenerate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_CancelGeneration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_SetCACertificate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Cert, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_SetCAPrivateKey, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_Sign, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_INFO(0, Detached)
	ZEND_ARG_INFO(0, IncludeCertificates)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_Verify, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, Signature, 0, 1)
	ZEND_ARG_INFO(0, SignatureSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_get_PreserveKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_set_PreserveKeyMaterial, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_get_AltKeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_set_AltKeyID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_get_PreferredHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_set_PreferredHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_get_SaveDefaultASN1Tags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx_set_SaveDefaultASN1Tags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateEx___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElX509CertificateEx_methods[] = {
	PHP_ME(TElX509CertificateEx, WriteIssuer, arginfo_TElX509CertificateEx_WriteIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, WriteSubject, arginfo_TElX509CertificateEx_WriteSubject, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, SetIssuer, arginfo_TElX509CertificateEx_SetIssuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, SetSubject, arginfo_TElX509CertificateEx_SetSubject, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, SetLongSerialNumber, arginfo_TElX509CertificateEx_SetLongSerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, Generate, arginfo_TElX509CertificateEx_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, CAGenerate, arginfo_TElX509CertificateEx_CAGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, BeginGenerate, arginfo_TElX509CertificateEx_BeginGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, EndGenerate, arginfo_TElX509CertificateEx_EndGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, CancelGeneration, arginfo_TElX509CertificateEx_CancelGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, AsyncOperationFinished, arginfo_TElX509CertificateEx_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, SetCACertificate, arginfo_TElX509CertificateEx_SetCACertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, SetCAPrivateKey, arginfo_TElX509CertificateEx_SetCAPrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, Sign, arginfo_TElX509CertificateEx_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, Verify, arginfo_TElX509CertificateEx_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, ClassType, arginfo_TElX509CertificateEx_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElX509CertificateEx, get_PreserveKeyMaterial, arginfo_TElX509CertificateEx_get_PreserveKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, set_PreserveKeyMaterial, arginfo_TElX509CertificateEx_set_PreserveKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, get_AltKeyID, arginfo_TElX509CertificateEx_get_AltKeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, set_AltKeyID, arginfo_TElX509CertificateEx_set_AltKeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, get_PreferredHashAlgorithm, arginfo_TElX509CertificateEx_get_PreferredHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, set_PreferredHashAlgorithm, arginfo_TElX509CertificateEx_set_PreferredHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, get_SaveDefaultASN1Tags, arginfo_TElX509CertificateEx_get_SaveDefaultASN1Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, set_SaveDefaultASN1Tags, arginfo_TElX509CertificateEx_set_SaveDefaultASN1Tags, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateEx, __construct, arginfo_TElX509CertificateEx___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElX509CertificateEx(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElX509CertificateEx_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElX509CertificateEx", TElX509CertificateEx_methods);
	if (NULL == TElX509Certificate_ce_ptr)
		Register_TElX509Certificate(TSRMLS_C);
	TElX509CertificateEx_ce_ptr = zend_register_internal_class_ex(&ce, TElX509Certificate_ce_ptr, NULL TSRMLS_CC);
}

