#include "sbxmlsoapcore.h"

zend_class_entry *TSBXMLSOAPVersion_ce_ptr = NULL;

zend_class_entry *TElXMLSOAPElement_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPElement, get_SOAPVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPVersionRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPElement_get_SOAPVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPElement, get_NamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPElement_get_NamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1050227845, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPElement, __construct)
{
	char *sAName;
	char *sANamespaceURI;
	int sAName_len;
	int sANamespaceURI_len;
	long fAVersion;
	zval *oBeforeChild;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPElement_Create((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPElement_Create_1((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oParentElement, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPElement_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lss", &oParentElement, TElXMLDOMElement_ce_ptr, &oBeforeChild, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPElement_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oBeforeChild TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string) or (TElXMLDOMElement, integer, string) or (TElXMLDOMElement, TElXMLDOMElement, integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPElement_get_SOAPVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPElement_get_NamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPElement___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AVersion_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ANamespaceURI_or_AVersion_or_BeforeChild, 0, 1)
	ZEND_ARG_INFO(0, AName_or_ANamespaceURI_or_AVersion)
	ZEND_ARG_INFO(0, ANamespaceURI)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPElement_methods[] = {
	PHP_ME(TElXMLSOAPElement, LoadFromXML, arginfo_TElXMLSOAPElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPElement, SaveToXML, arginfo_TElXMLSOAPElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPElement, get_SOAPVersion, arginfo_TElXMLSOAPElement_get_SOAPVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPElement, get_NamespaceURI, arginfo_TElXMLSOAPElement_get_NamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPElement, __construct, arginfo_TElXMLSOAPElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPElement", TElXMLSOAPElement_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLSOAPElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPHeaderBlock_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeaderBlock_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeaderBlock_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeaderBlock_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, get_Actor)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPHeaderBlock_get_Actor(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1855824044, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, set_Actor)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeaderBlock_set_Actor(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, get_EncodingStyle)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPHeaderBlock_get_EncodingStyle(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1641507103, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, set_EncodingStyle)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeaderBlock_set_EncodingStyle(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, get_Role)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPHeaderBlock_get_Role(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(793490286, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, set_Role)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeaderBlock_set_Role(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, get_MustUnderstand)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPHeaderBlock_get_MustUnderstand(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-24254483, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, set_MustUnderstand)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeaderBlock_set_MustUnderstand(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, get_Relay)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPHeaderBlock_get_Relay(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2010256620, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, set_Relay)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeaderBlock_set_Relay(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, get_SOAPNamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPHeaderBlock_get_SOAPNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(840381326, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeaderBlock, __construct)
{
	char *sASOAPNamespaceURI;
	int sASOAPNamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sASOAPNamespaceURI, &sASOAPNamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeaderBlock_Create(sASOAPNamespaceURI, (int32_t)sASOAPNamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_get_Actor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_set_Actor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_get_EncodingStyle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_set_EncodingStyle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_get_Role, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_set_Role, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_get_MustUnderstand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_set_MustUnderstand, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_get_Relay, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_set_Relay, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock_get_SOAPNamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeaderBlock___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, ASOAPNamespaceURI)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPHeaderBlock_methods[] = {
	PHP_ME(TElXMLSOAPHeaderBlock, LoadFromXML, arginfo_TElXMLSOAPHeaderBlock_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, SaveToXML, arginfo_TElXMLSOAPHeaderBlock_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, get_Actor, arginfo_TElXMLSOAPHeaderBlock_get_Actor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, set_Actor, arginfo_TElXMLSOAPHeaderBlock_set_Actor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, get_EncodingStyle, arginfo_TElXMLSOAPHeaderBlock_get_EncodingStyle, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, set_EncodingStyle, arginfo_TElXMLSOAPHeaderBlock_set_EncodingStyle, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, get_Role, arginfo_TElXMLSOAPHeaderBlock_get_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, set_Role, arginfo_TElXMLSOAPHeaderBlock_set_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, get_MustUnderstand, arginfo_TElXMLSOAPHeaderBlock_get_MustUnderstand, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, set_MustUnderstand, arginfo_TElXMLSOAPHeaderBlock_set_MustUnderstand, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, get_Relay, arginfo_TElXMLSOAPHeaderBlock_get_Relay, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, set_Relay, arginfo_TElXMLSOAPHeaderBlock_set_Relay, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, get_SOAPNamespaceURI, arginfo_TElXMLSOAPHeaderBlock_get_SOAPNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeaderBlock, __construct, arginfo_TElXMLSOAPHeaderBlock___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPHeaderBlock(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPHeaderBlock_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPHeaderBlock", TElXMLSOAPHeaderBlock_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLSOAPHeaderBlock_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPHeader_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPHeader, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeader_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeader, ReloadBlocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeader_ReloadBlocks(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeader, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPHeader_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeader, LoadBlockFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeader_LoadBlockFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPHeaderBlock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeader, get_BlockCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPHeader_get_BlockCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeader, get_Blocks)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeader_get_Blocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPHeaderBlock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPHeader, __construct)
{
	char *sAName;
	char *sANamespaceURI;
	int sAName_len;
	int sANamespaceURI_len;
	long fAVersion;
	zval *oBeforeChild;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeader_Create((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeader_Create_1((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oParentElement, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeader_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lss", &oParentElement, TElXMLDOMElement_ce_ptr, &oBeforeChild, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPHeader_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oBeforeChild TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string) or (TElXMLDOMElement, integer, string) or (TElXMLDOMElement, TElXMLDOMElement, integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader_ReloadBlocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader_LoadBlockFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader_get_BlockCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader_get_Blocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPHeader___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AVersion_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ANamespaceURI_or_AVersion_or_BeforeChild, 0, 1)
	ZEND_ARG_INFO(0, AName_or_ANamespaceURI_or_AVersion)
	ZEND_ARG_INFO(0, ANamespaceURI)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPHeader_methods[] = {
	PHP_ME(TElXMLSOAPHeader, Clear, arginfo_TElXMLSOAPHeader_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeader, ReloadBlocks, arginfo_TElXMLSOAPHeader_ReloadBlocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeader, LoadFromXML, arginfo_TElXMLSOAPHeader_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeader, LoadBlockFromXML, arginfo_TElXMLSOAPHeader_LoadBlockFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeader, get_BlockCount, arginfo_TElXMLSOAPHeader_get_BlockCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeader, get_Blocks, arginfo_TElXMLSOAPHeader_get_Blocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPHeader, __construct, arginfo_TElXMLSOAPHeader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPHeader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPHeader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPHeader", TElXMLSOAPHeader_methods);
	if (NULL == TElXMLSOAPElement_ce_ptr)
		Register_TElXMLSOAPElement(TSRMLS_C);
	TElXMLSOAPHeader_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPBodyEntry_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPBodyEntry, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBodyEntry_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBodyEntry, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBodyEntry_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBodyEntry_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBodyEntry, get_EncodingStyle)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPBodyEntry_get_EncodingStyle(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-371388143, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBodyEntry, set_EncodingStyle)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBodyEntry_set_EncodingStyle(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBodyEntry, get_NamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPBodyEntry_get_NamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2039703240, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBodyEntry, __construct)
{
	char *sANamespaceURI;
	int sANamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBodyEntry_Create(sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBodyEntry_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBodyEntry_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBodyEntry_get_EncodingStyle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBodyEntry_set_EncodingStyle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBodyEntry_get_NamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBodyEntry___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, ANamespaceURI)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPBodyEntry_methods[] = {
	PHP_ME(TElXMLSOAPBodyEntry, LoadFromXML, arginfo_TElXMLSOAPBodyEntry_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBodyEntry, SaveToXML, arginfo_TElXMLSOAPBodyEntry_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBodyEntry, get_EncodingStyle, arginfo_TElXMLSOAPBodyEntry_get_EncodingStyle, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBodyEntry, set_EncodingStyle, arginfo_TElXMLSOAPBodyEntry_set_EncodingStyle, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBodyEntry, get_NamespaceURI, arginfo_TElXMLSOAPBodyEntry_get_NamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBodyEntry, __construct, arginfo_TElXMLSOAPBodyEntry___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPBodyEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPBodyEntry_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPBodyEntry", TElXMLSOAPBodyEntry_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLSOAPBodyEntry_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPBody_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPBody, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBody_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBody, ReloadEntries)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBody_ReloadEntries(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBody, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBody_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBody, get_EntryCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPBody_get_EntryCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBody, get_Entries)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBody_get_Entries(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPBodyEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBody, __construct)
{
	char *sAName;
	char *sANamespaceURI;
	int sAName_len;
	int sANamespaceURI_len;
	long fAVersion;
	zval *oBeforeChild;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBody_Create((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBody_Create_1((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oParentElement, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBody_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lss", &oParentElement, TElXMLDOMElement_ce_ptr, &oBeforeChild, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBody_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oBeforeChild TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string) or (TElXMLDOMElement, integer, string) or (TElXMLDOMElement, TElXMLDOMElement, integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBody_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBody_ReloadEntries, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBody_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBody_get_EntryCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBody_get_Entries, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBody___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AVersion_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ANamespaceURI_or_AVersion_or_BeforeChild, 0, 1)
	ZEND_ARG_INFO(0, AName_or_ANamespaceURI_or_AVersion)
	ZEND_ARG_INFO(0, ANamespaceURI)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPBody_methods[] = {
	PHP_ME(TElXMLSOAPBody, Clear, arginfo_TElXMLSOAPBody_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBody, ReloadEntries, arginfo_TElXMLSOAPBody_ReloadEntries, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBody, LoadFromXML, arginfo_TElXMLSOAPBody_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBody, get_EntryCount, arginfo_TElXMLSOAPBody_get_EntryCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBody, get_Entries, arginfo_TElXMLSOAPBody_get_Entries, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBody, __construct, arginfo_TElXMLSOAPBody___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPBody(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPBody_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPBody", TElXMLSOAPBody_methods);
	if (NULL == TElXMLSOAPElement_ce_ptr)
		Register_TElXMLSOAPElement(TSRMLS_C);
	TElXMLSOAPBody_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPEnvelope_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPEnvelope, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPEnvelope_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPEnvelope, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPEnvelope_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPEnvelope, CreateHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPEnvelope_CreateHeader(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPEnvelope, CreateBody)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPEnvelope_CreateBody(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPEnvelope, get_Header)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_get_Header(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPHeader_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPEnvelope, get_Body)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_get_Body(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPBody_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPEnvelope, __construct)
{
	char *sAName;
	char *sANamespaceURI;
	int sAName_len;
	int sANamespaceURI_len;
	long fAVersion;
	zval *oBeforeChild;
	zval *oDocument;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_Create((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_Create_1((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oParentElement, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lss", &oParentElement, TElXMLDOMElement_ce_ptr, &oBeforeChild, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oBeforeChild TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oDocument, TElXMLDOMDocument_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_Create_4(SBGetObjectHandle(oDocument TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lss", &oDocument, TElXMLDOMDocument_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPEnvelope_Create_5(SBGetObjectHandle(oDocument TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string) or (TElXMLDOMElement, integer, string) or (TElXMLDOMElement, TElXMLDOMElement, integer, string, string) or (TElXMLDOMDocument, integer, string) or (TElXMLDOMDocument, integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope_CreateHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope_CreateBody, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope_get_Header, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope_get_Body, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPEnvelope___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AVersion_or_ParentElement_or_Document, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ANamespaceURI_or_AVersion_or_BeforeChild, 0, 1)
	ZEND_ARG_INFO(0, AName_or_ANamespaceURI_or_AVersion)
	ZEND_ARG_INFO(0, ANamespaceURI_or_AName)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPEnvelope_methods[] = {
	PHP_ME(TElXMLSOAPEnvelope, Clear, arginfo_TElXMLSOAPEnvelope_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPEnvelope, LoadFromXML, arginfo_TElXMLSOAPEnvelope_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPEnvelope, CreateHeader, arginfo_TElXMLSOAPEnvelope_CreateHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPEnvelope, CreateBody, arginfo_TElXMLSOAPEnvelope_CreateBody, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPEnvelope, get_Header, arginfo_TElXMLSOAPEnvelope_get_Header, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPEnvelope, get_Body, arginfo_TElXMLSOAPEnvelope_get_Body, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPEnvelope, __construct, arginfo_TElXMLSOAPEnvelope___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPEnvelope(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPEnvelope_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPEnvelope", TElXMLSOAPEnvelope_methods);
	if (NULL == TElXMLSOAPElement_ce_ptr)
		Register_TElXMLSOAPElement(TSRMLS_C);
	TElXMLSOAPEnvelope_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPElement_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSOAPCore, GetSOAPNamespaceURI)
{
	long fVersion;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fVersion) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSOAPCore_GetSOAPNamespaceURI((TSBXMLSOAPVersionRaw)fVersion, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(478004102, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSOAPCore, SOAPSecGetElementId)
{
	uint32_t _err;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSOAPCore_SOAPSecGetElementId(SBGetObjectHandle(oElement TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1524986120, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSOAPCore, SOAPSecSetElementId)
{
	char *sValue;
	int sValue_len;
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oElement, TElXMLDOMElement_ce_ptr, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBXMLSOAPCore_SOAPSecSetElementId(SBGetObjectHandle(oElement TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string)" TSRMLS_CC);
	}
}

void Register_SBXMLSOAPCore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPUnsupportedOperation, SB_SSOAPUnsupportedOperation, SB_SSOAPUnsupportedOperation);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPDocumentElementExists, SB_SSOAPDocumentElementExists, SB_SSOAPDocumentElementExists);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPEnvelopeBodyElementExists, SB_SSOAPEnvelopeBodyElementExists, SB_SSOAPEnvelopeBodyElementExists);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPEnvelopeHeaderElementExists, SB_SSOAPEnvelopeHeaderElementExists, SB_SSOAPEnvelopeHeaderElementExists);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPHeaderElementNotLoaded, SB_SSOAPHeaderElementNotLoaded, SB_SSOAPHeaderElementNotLoaded);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPHeaderBlockNotLoaded, SB_SSOAPHeaderBlockNotLoaded, SB_SSOAPHeaderBlockNotLoaded);
	SB_REGISTER_STRING_CONSTANT(SBXMLSOAPCore, SSOAPBodyElementNotLoaded, SB_SSOAPBodyElementNotLoaded, SB_SSOAPBodyElementNotLoaded);
}

void Register_SBXMLSOAPCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBXMLSOAPVersion", NULL);
	TSBXMLSOAPVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLSOAPVersion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPVersion_ce_ptr, "SOAP_v1_1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPVersion_ce_ptr, "SOAP_v1_2", 1)
}

