#include "sbxmlsoapsecurity.h"

zend_class_entry *TSBXMLWSSEmbedCertificate_ce_ptr = NULL;

zend_class_entry *TElXMLSOAPSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-59246065, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-59246065, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, LoadFromXML)
{
	zval *oMsg;
	zval *oSignatureElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSignatureElement, TElXMLDOMElement_ce_ptr, &oMsg, TElXMLSOAPMessage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignatureElement TSRMLS_CC), SBGetObjectHandle(oMsg TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLSOAPMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, InitiateAsyncSign)
{
	long fIncludeDataParams;
	long fSignatureMethod;
	zend_bool bIncludeKey;
	zend_bool bIncludeKeyValue;
	zval *oCertificate;
	zval *oCertStorage;
	zval *oKeyData;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbl", &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbl", &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_8(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lb", &oParentElement, TElXMLDOMElement_ce_ptr, &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_10(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_11(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_12(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_13(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_14(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_InitiateAsyncSign_15(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElX509Certificate) or (TElX509Certificate, bool) or (TElX509Certificate, bool, bool, integer) or (TElCustomCertStorage) or (TElCustomCertStorage, bool) or (TElCustomCertStorage, bool, bool, integer) or (TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement, TElX509Certificate, bool, bool, integer) or (TElXMLDOMElement, TElCustomCertStorage, bool, bool, integer) or (TElXMLDOMElement, TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement) or (TElXMLDOMElement, TElX509Certificate) or (TElXMLDOMElement, TElX509Certificate, bool) or (TElXMLDOMElement, TElCustomCertStorage) or (TElXMLDOMElement, TElCustomCertStorage, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, Sign)
{
	long fIncludeDataParams;
	long fSignatureMethod;
	zend_bool bIncludeKey;
	zend_bool bIncludeKeyValue;
	zval *oCertificate;
	zval *oCertStorage;
	zval *oKeyData;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbl", &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbl", &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_8(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lb", &oParentElement, TElXMLDOMElement_ce_ptr, &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_10(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_11(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_12(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_Sign_13(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate) or (TElX509Certificate, bool) or (TElX509Certificate, bool, bool, integer) or (TElCustomCertStorage) or (TElCustomCertStorage, bool) or (TElCustomCertStorage, bool, bool, integer) or (TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement, TElX509Certificate, bool, bool, integer) or (TElXMLDOMElement, TElCustomCertStorage, bool, bool, integer) or (TElXMLDOMElement, TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement, TElX509Certificate) or (TElXMLDOMElement, TElX509Certificate, bool) or (TElXMLDOMElement, TElCustomCertStorage) or (TElXMLDOMElement, TElCustomCertStorage, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPSignatureHandler_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(911135219, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, get_Actor)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPSignatureHandler_get_Actor(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1127862588, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, set_Actor)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_set_Actor(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, get_MustUnderstand)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPSignatureHandler_get_MustUnderstand(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1546966344, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, set_MustUnderstand)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPSignatureHandler_set_MustUnderstand(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_LoadFromXML, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, SignatureElement, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, Msg, TElXMLSOAPMessage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_InitiateAsyncSign, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_CertStorage_or_KeyData_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IncludeKey_or_SignatureMethod_or_Certificate_or_CertStorage_or_KeyData, 0, 1)
	ZEND_ARG_INFO(0, IncludeKeyValue_or_IncludeKey_or_SignatureMethod)
	ZEND_ARG_INFO(0, IncludeDataParams_or_IncludeKeyValue_or_IncludeKey)
	ZEND_ARG_INFO(0, IncludeDataParams)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_Sign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_CertStorage_or_KeyData_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IncludeKey_or_SignatureMethod_or_Certificate_or_CertStorage_or_KeyData, 0, 1)
	ZEND_ARG_INFO(0, IncludeKeyValue_or_IncludeKey_or_SignatureMethod)
	ZEND_ARG_INFO(0, IncludeDataParams_or_IncludeKeyValue_or_IncludeKey)
	ZEND_ARG_INFO(0, IncludeDataParams)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_get_Actor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_set_Actor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_get_MustUnderstand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler_set_MustUnderstand, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPSignatureHandler_methods[] = {
	PHP_ME(TElXMLSOAPSignatureHandler, GetName_Inst, arginfo_TElXMLSOAPSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, GetName, arginfo_TElXMLSOAPSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPSignatureHandler, LoadFromXML, arginfo_TElXMLSOAPSignatureHandler_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, Reset, arginfo_TElXMLSOAPSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, InitiateAsyncSign, arginfo_TElXMLSOAPSignatureHandler_InitiateAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, Sign, arginfo_TElXMLSOAPSignatureHandler_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, ClassType, arginfo_TElXMLSOAPSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPSignatureHandler, get_ID, arginfo_TElXMLSOAPSignatureHandler_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, set_ID, arginfo_TElXMLSOAPSignatureHandler_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, get_Actor, arginfo_TElXMLSOAPSignatureHandler_get_Actor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, set_Actor, arginfo_TElXMLSOAPSignatureHandler_set_Actor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, get_MustUnderstand, arginfo_TElXMLSOAPSignatureHandler_get_MustUnderstand, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, set_MustUnderstand, arginfo_TElXMLSOAPSignatureHandler_set_MustUnderstand, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPSignatureHandler, __construct, arginfo_TElXMLSOAPSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPSignatureHandler", TElXMLSOAPSignatureHandler_methods);
	if (NULL == TElXMLSOAPBaseSignatureHandler_ce_ptr)
		Register_TElXMLSOAPBaseSignatureHandler(TSRMLS_C);
	TElXMLSOAPSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLWSSSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLWSSSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2138498265, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLWSSSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2138498265, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, InitiateAsyncSign)
{
	char *sTokenID;
	int sTokenID_len;
	long fEmbedCertificate;
	long fIncludeDataParams;
	long fSignatureMethod;
	long fTokenType;
	zend_bool bEmbedKeyInSignature;
	zend_bool bIncludeKey;
	zend_bool bIncludeKeyValue;
	zval *oCertificate;
	zval *oCertStorage;
	zval *oKeyData;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCertificate, TElX509Certificate_ce_ptr, &fEmbedCertificate) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertificate, TElX509Certificate_ce_ptr, &fEmbedCertificate, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, sTokenID, (int32_t)sTokenID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lls", &oCertificate, TElX509Certificate_ce_ptr, &fEmbedCertificate, &fTokenType, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, (TSBXMLWSSETokenTypeRaw)fTokenType, sTokenID, (int32_t)sTokenID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCertStorage, TElCustomCertStorage_ce_ptr, &fEmbedCertificate) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertStorage, TElCustomCertStorage_ce_ptr, &fEmbedCertificate, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, sTokenID, (int32_t)sTokenID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lls", &oCertStorage, TElCustomCertStorage_ce_ptr, &fEmbedCertificate, &fTokenType, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_8(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, (TSBXMLWSSETokenTypeRaw)fTokenType, sTokenID, (int32_t)sTokenID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bEmbedKeyInSignature) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bEmbedKeyInSignature, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_10(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_11(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lb", &oParentElement, TElXMLDOMElement_ce_ptr, &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_12(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParentElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_13(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_14(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_15(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_16(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_InitiateAsyncSign_17(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElX509Certificate) or (TElX509Certificate, integer) or (TElX509Certificate, integer, string) or (TElX509Certificate, integer, integer, string) or (TElCustomCertStorage) or (TElCustomCertStorage, integer) or (TElCustomCertStorage, integer, string) or (TElCustomCertStorage, integer, integer, string) or (TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement, TElX509Certificate, bool, bool, integer) or (TElXMLDOMElement, TElCustomCertStorage, bool, bool, integer) or (TElXMLDOMElement, TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement) or (TElXMLDOMElement, TElX509Certificate) or (TElXMLDOMElement, TElX509Certificate, bool) or (TElXMLDOMElement, TElCustomCertStorage) or (TElXMLDOMElement, TElCustomCertStorage, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, Sign)
{
	char *sTokenID;
	int sTokenID_len;
	long fEmbedCertificate;
	long fIncludeDataParams;
	long fSignatureMethod;
	long fTokenType;
	zend_bool bEmbedKeyInSignature;
	zend_bool bIncludeKey;
	zend_bool bIncludeKeyValue;
	zval *oCertificate;
	zval *oCertStorage;
	zval *oKeyData;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCertificate, TElX509Certificate_ce_ptr, &fEmbedCertificate) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertificate, TElX509Certificate_ce_ptr, &fEmbedCertificate, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, sTokenID, (int32_t)sTokenID_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lls", &oCertificate, TElX509Certificate_ce_ptr, &fEmbedCertificate, &fTokenType, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, (TSBXMLWSSETokenTypeRaw)fTokenType, sTokenID, (int32_t)sTokenID_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oCertStorage, TElCustomCertStorage_ce_ptr, &fEmbedCertificate) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oCertStorage, TElCustomCertStorage_ce_ptr, &fEmbedCertificate, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, sTokenID, (int32_t)sTokenID_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lls", &oCertStorage, TElCustomCertStorage_ce_ptr, &fEmbedCertificate, &fTokenType, &sTokenID, &sTokenID_len) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (TSBXMLWSSEmbedCertificateRaw)fEmbedCertificate, (TSBXMLWSSETokenTypeRaw)fTokenType, sTokenID, (int32_t)sTokenID_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bEmbedKeyInSignature) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_8(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bEmbedKeyInSignature) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbl", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey, &bIncludeKeyValue, &fIncludeDataParams) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_10(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey, (int8_t)bIncludeKeyValue, (TElXMLKeyInfoX509DataParamsRaw)fIncludeDataParams) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lb", &oParentElement, TElXMLDOMElement_ce_ptr, &oKeyData, TElXMLKeyInfoData_ce_ptr, &fSignatureMethod, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_11(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oKeyData TSRMLS_CC), (TElXMLSignatureMethodRaw)fSignatureMethod, (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_12(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertificate, TElX509Certificate_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_13(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_14(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oParentElement, TElXMLDOMElement_ce_ptr, &oCertStorage, TElCustomCertStorage_ce_ptr, &bIncludeKey) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_Sign_15(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oCertStorage TSRMLS_CC), (int8_t)bIncludeKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate) or (TElX509Certificate, integer) or (TElX509Certificate, integer, string) or (TElX509Certificate, integer, integer, string) or (TElCustomCertStorage) or (TElCustomCertStorage, integer) or (TElCustomCertStorage, integer, string) or (TElCustomCertStorage, integer, integer, string) or (TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement, TElX509Certificate, bool, bool, integer) or (TElXMLDOMElement, TElCustomCertStorage, bool, bool, integer) or (TElXMLDOMElement, TElXMLKeyInfoData, integer, bool) or (TElXMLDOMElement, TElX509Certificate) or (TElXMLDOMElement, TElX509Certificate, bool) or (TElXMLDOMElement, TElCustomCertStorage) or (TElXMLDOMElement, TElCustomCertStorage, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, get_SecurityHeader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_get_SecurityHeader(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLWSSESecurity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, set_SecurityHeader)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLWSSESecurity_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLWSSSignatureHandler_set_SecurityHeader(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLWSSESecurity)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLWSSSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLWSSSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_InitiateAsyncSign, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_CertStorage_or_KeyData_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EmbedCertificate_or_SignatureMethod_or_Certificate_or_CertStorage_or_KeyData, 0, 1)
	ZEND_ARG_INFO(0, TokenID_or_TokenType_or_EmbedKeyInSignature_or_IncludeKey_or_SignatureMethod)
	ZEND_ARG_INFO(0, TokenID_or_IncludeKeyValue_or_IncludeKey)
	ZEND_ARG_INFO(0, IncludeDataParams)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_Sign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Certificate_or_CertStorage_or_KeyData_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EmbedCertificate_or_SignatureMethod_or_Certificate_or_CertStorage_or_KeyData, 0, 1)
	ZEND_ARG_INFO(0, TokenID_or_TokenType_or_EmbedKeyInSignature_or_IncludeKey_or_SignatureMethod)
	ZEND_ARG_INFO(0, TokenID_or_IncludeKeyValue_or_IncludeKey)
	ZEND_ARG_INFO(0, IncludeDataParams)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_get_SecurityHeader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler_set_SecurityHeader, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLWSSESecurity, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLWSSSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLWSSSignatureHandler_methods[] = {
	PHP_ME(TElXMLWSSSignatureHandler, GetName_Inst, arginfo_TElXMLWSSSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSSignatureHandler, GetName, arginfo_TElXMLWSSSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLWSSSignatureHandler, Reset, arginfo_TElXMLWSSSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSSignatureHandler, InitiateAsyncSign, arginfo_TElXMLWSSSignatureHandler_InitiateAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSSignatureHandler, Sign, arginfo_TElXMLWSSSignatureHandler_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSSignatureHandler, ClassType, arginfo_TElXMLWSSSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLWSSSignatureHandler, get_SecurityHeader, arginfo_TElXMLWSSSignatureHandler_get_SecurityHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSSignatureHandler, set_SecurityHeader, arginfo_TElXMLWSSSignatureHandler_set_SecurityHeader, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLWSSSignatureHandler, __construct, arginfo_TElXMLWSSSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLWSSSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLWSSSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLWSSSignatureHandler", TElXMLWSSSignatureHandler_methods);
	if (NULL == TElXMLSOAPBaseSignatureHandler_ce_ptr)
		Register_TElXMLSOAPBaseSignatureHandler(TSRMLS_C);
	TElXMLWSSSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBXMLSOAPSecurity_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBXMLWSSEmbedCertificate", NULL);
	TSBXMLWSSEmbedCertificate_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLWSSEmbedCertificate_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSEmbedCertificate_ce_ptr, "wecInSignature", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSEmbedCertificate_ce_ptr, "wecInBinarySecurityToken", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSEmbedCertificate_ce_ptr, "wecInSignedBinarySecurityToken", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSEmbedCertificate_ce_ptr, "wecInBinarySecurityTokenAndSignature", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLWSSEmbedCertificate_ce_ptr, "wecNone", 4)
}

