#ifndef __INC_SBMIME
#define __INC_SBMIME

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"
#include "sbstrutils.h"
#include "sbstreams.h"
#include "sbchsconv.h"
#include "sbchsconvcharsets.h"
#include "sbchscjk.h"
#include "sbmimestream.h"
#include "sbmimeenc.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_cXMailerPrefix 	"EldoS MIMEBlackbox"
#define SB_cXMailerDefaultFieldValue 	"EldoS MIMEBlackbox, version: 14.0.290.0"
#define SB_EL_OK 	0
#define SB_EL_WARNING 	1
#define SB_EL_BUFFER_TOO_SMALL 	2
#define SB_EL_NULL_POINTER_ERROR 	3
#define SB_EL_FILE_ERROR 	4
#define SB_EL_ALLOC_MEM_ERROR 	5
#define SB_EL_NEXT 	5
#define SB_EL_END 	6
#define SB_EL_BREAK 	7
#define SB_EL_ERROR 	8
#define SB_EL_HANDLERR_ERROR 	9

typedef TElClassHandle TElMessageHandle;

typedef TElMessageHandle ElMessageHandle;

typedef TElClassHandle TElMessageHeaderHandle;

typedef TElMessageHeaderHandle ElMessageHeaderHandle;

typedef TElClassHandle TElMessageHeaderFieldHandle;

typedef TElMessageHeaderFieldHandle ElMessageHeaderFieldHandle;

typedef TElClassHandle TElMailAddressGroupHandle;

typedef TElMailAddressGroupHandle ElMailAddressGroupHandle;

typedef TElClassHandle TElMailAddressListHandle;

typedef TElMailAddressListHandle ElMailAddressListHandle;

typedef TElClassHandle TElMailAddressHandle;

typedef TElMailAddressHandle ElMailAddressHandle;

typedef TElClassHandle TElMessagePartHandle;

typedef TElMessagePartHandle ElMessagePartHandle;

typedef TElClassHandle TElMultiPartListHandle;

typedef TElMultiPartListHandle ElMultiParTElListHandle;

typedef TElClassHandle TElPlainTextPartHandle;

typedef TElPlainTextPartHandle ElPlainTextPartHandle;

typedef TElClassHandle TElMessagePartHandlerHandle;

typedef TElMessagePartHandlerHandle ElMessagePartHandlerHandle;

typedef TElClassHandle TElConverterHandle;

typedef TElConverterHandle ElConverterHandle;

typedef TElClassHandle TElRegisteredMessagePartHandlersHandle;

typedef TElClassHandle TElXmlPartHandle;

typedef uint8_t TElMIMEMessagePriorityRaw;

typedef enum
{
	mpLowest = 0,
	mpLow = 1,
	mpNormal = 2,
	mpHigh = 3,
	mpHighest = 4
} TElMIMEMessagePriority;

typedef TElMIMEMessagePriority ElMIMEMessagePriority;

typedef uint8_t TElHeaderEncodingRaw;

typedef enum
{
	heAutoDetect = 0,
	he8bit = 1,
	heBase64 = 2,
	heQuotedPrintable = 3
} TElHeaderEncoding;

typedef TElHeaderEncoding ElHeaderEncoding;

typedef uint8_t TElMessageParsingOptionRaw;

typedef enum
{
	mpoStoreStream = 0,
	mpoLoadData = 1,
	mpoCalcDataSize = 2,
	mpoRaiseError = 3,
	mpoDelayDataDecode = 4
} TElMessageParsingOption;

typedef uint32_t TElMessageParsingOptionsRaw;

typedef enum 
{
	f_mpoStoreStream = 1,
	f_mpoLoadData = 2,
	f_mpoCalcDataSize = 4,
	f_mpoRaiseError = 8,
	f_mpoDelayDataDecode = 16
} TElMessageParsingOptions;

typedef uint8_t TElMessageExtendedOptionRaw;

typedef enum
{
	meoIgnore7bit = 0,
	meoAllowLongHeaderLines = 1,
	meoCombineHeaderParameters = 2
} TElMessageExtendedOption;

typedef uint32_t TElMessageExtendedOptionsRaw;

typedef enum 
{
	f_meoIgnore7bit = 1,
	f_meoAllowLongHeaderLines = 2,
	f_meoCombineHeaderParameters = 4
} TElMessageExtendedOptions;

typedef TElMessageParsingOption ElMessageParsingOption;

typedef TElMessageParsingOptions ElMessageParsingOptions;

typedef TElMessageExtendedOption ElMessageExtendedOption;

typedef TElMessageExtendedOptions ElMessageExtendedOptions;

typedef uint8_t TElBodyPosRaw;

typedef enum
{
	bpBegin = 0,
	bpEnd = 1
} TElBodyPos;

typedef TElBodyPos ElBodyPos;

typedef uint8_t TElLexTokenRaw;

typedef enum
{
	ltChar = 0,
	ltCRLF = 1,
	ltTabOrSpace = 2,
	ltSpecials = 3,
	ltEos = 4
} TElLexToken;

typedef TElLexToken ElLexToken;

typedef uint8_t TElParseStateRaw;

typedef enum
{
	psMain = 0,
	psFieldValue = 1,
	psComment = 2,
	psQuotedString = 3,
	psParamName = 4,
	psParamValue = 5,
	psGroup = 6,
	psNameAddr = 7,
	psEnd = 8
} TElParseState;

typedef TElParseState ElParseState;

#pragma pack(4)
typedef struct 
{
	TElParseStateRaw State;
	int8_t _dummy0;
	int16_t _dummy1;
	void * Source;
	int32_t SouceOffset;
	int32_t Offset;
	int32_t Length;
	void * tmpStr;
	int32_t FirstBodyIndex;
} TElParseContext;

typedef TElParseContext ElParseContext;

#pragma pack(4)
typedef struct 
{
	void * Name;
	void * Value;
} TElFieldParam, * PElFieldParam;

typedef TElFieldParam ElFieldParam;

typedef TElClassHandle TElMessagePartClassHandle;

typedef TElClassHandle TElMessagePartHandlerClassHandle;

typedef uint8_t TElOnAssembleStateRaw;

typedef enum
{
	astBefore = 0,
	astAfter = 1,
	astHeaderBefore = 2,
	astHeaderAfter = 3,
	astAddressFieldBefore = 4,
	astAddressFieldItem = 5,
	astAddressFieldAfter = 6,
	astHeaderFieldsBefore = 7,
	astHeaderFieldItem = 8,
	astHeaderFieldsAfter = 9,
	astBodyBefore = 10,
	astBodyAfter = 11,
	astBodyAfterFirstBoundary = 12,
	astBodyPartBefore = 13,
	astBodyPartAfter = 14
} TElOnAssembleState;

typedef TElOnAssembleState ElOnAssembleState;

typedef uint8_t TElOnParseStateRaw;

typedef enum
{
	pstBefore = 0,
	pstAfter = 1,
	pstHeaderBefore = 2,
	pstHeaderAfter = 3,
	pstAddressFieldBefore = 4,
	pstAddressFieldItem = 5,
	pstAddressFieldAfter = 6,
	pstHeaderFieldsBefore = 7,
	pstHeaderFieldItem = 8,
	pstHeaderFieldsAfter = 9,
	pstBodyBefore = 10,
	pstBodyAfter = 11,
	pstBodyAfterFirstBoundary = 12,
	pstBodyPartBefore = 13,
	pstBodyPartAfter = 14,
	pstDecode = 15
} TElOnParseState;

typedef TElOnParseState ElOnParseState;

#ifdef SB_USE_CLASS_TELMESSAGE
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GenerateMessageID(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GenerateMessageID_1(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_Clear(TElMessageHandle _Handle, int8_t bClearMainPart);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_Assign(TElMessageHandle _Handle, TElMessageHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_ParseMessage(TElMessageHandle _Handle, TStreamHandle Source, const char * pcHeaderCharset, int32_t szHeaderCharset, const char * pcBodyCharset, int32_t szBodyCharset, TElMessageParsingOptionsRaw AOptions, int8_t IgnoreHeaderNativeCharset, int8_t IgnoreBodyNativeCharset, int8_t bActivatePartHandlers, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_AssembleMessage(TElMessageHandle _Handle, TStreamHandle Destination, int8_t bAssembleSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_AssembleMessage_1(TElMessageHandle _Handle, TStreamHandle Destination, const char * pcACharset, int32_t szACharset, TElHeaderEncodingRaw HeaderEncoding, const char * pcBodyEncoding, int32_t szBodyEncoding, const char * pcAttachEncoding, int32_t szAttachEncoding, int8_t bAssembleSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GetMessageSentTime(TElMessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GetMessageReceivedTime(TElMessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GetReplyToMailAddress(TElMessageHandle _Handle, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetCustomHeader(TElMessageHandle _Handle, const char * pcHeaderName, int32_t szHeaderName, const char * pcHeaderValue, int32_t szHeaderValue, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetMessageID(TElMessageHandle _Handle, const char * pcAMessageID, int32_t szAMessageID, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetResentMessageID(TElMessageHandle _Handle, const char * pcAMessageID, int32_t szAMessageID, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetInReplyTo(TElMessageHandle _Handle, const char * pcAInReplyTo, int32_t szAInReplyTo, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetReferences(TElMessageHandle _Handle, const char * pcAReferences, int32_t szAReferences, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetKeywords(TElMessageHandle _Handle, const char * pcAKeywords, int32_t szAKeywords, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetSubject(TElMessageHandle _Handle, const char * pcASubject, int32_t szASubject, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetComments(TElMessageHandle _Handle, const char * pcAComments, int32_t szAComments, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GetDate(TElMessageHandle _Handle, int64_t * DateTime, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetDate(TElMessageHandle _Handle, int64_t ADateTime, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_GetResentDate(TElMessageHandle _Handle, int64_t * DateTime, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetResentDate(TElMessageHandle _Handle, int64_t DateTime, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetReturnPath(TElMessageHandle _Handle, const char * pcAReturnPath, int32_t szAReturnPath, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_SetMainPart(TElMessageHandle _Handle, const TElMessagePartHandle AMainPart, int8_t bMakeCopy, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_AttachData(TElMessageHandle _Handle, const char * pcContentType, int32_t szContentType, const char * pcFileName, int32_t szFileName, TStreamHandle Stream, int32_t DataSize, int8_t bMakeCopy, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_AttachData_1(TElMessageHandle _Handle, const char * pcContentType, int32_t szContentType, const char * pcFileName, int32_t szFileName, const char * pcwsData, int32_t szwsData, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_AttachData_2(TElMessageHandle _Handle, const char * pcContentType, int32_t szContentType, const char * pcFileName, int32_t szFileName, const uint8_t pBuffer[], int32_t szBuffer, int32_t Offset, int32_t Count, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_AttachFile(TElMessageHandle _Handle, const char * pcContentType, int32_t szContentType, const char * pcFileName, int32_t szFileName, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_CustomHeaders(TElMessageHandle _Handle, const char * pcHeaderName, int32_t szHeaderName, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_CustomHeaders(TElMessageHandle _Handle, const char * pcHeaderName, int32_t szHeaderName, const char * pcHeaderValue, int32_t szHeaderValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_MessageID(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_MessageID(TElMessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentMessageID(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_InReplyTo(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_References(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Keywords(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Subject(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Comments(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ReturnPath(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ReplyTo(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ReplyTo(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentReplyTo(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ResentReplyTo(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_From(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_From(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentFrom(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ResentFrom(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Sender(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_Sender(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentSender(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ResentSender(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_To_(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_To_(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentTo(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ResentTo(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_CC(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_CC(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentCC(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ResentCC(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_BCC(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_BCC(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ResentBCC(TElMessageHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ResentBCC(TElMessageHandle _Handle, TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_MainPart(TElMessageHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_AttachmentsCount(TElMessageHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Attachments(TElMessageHandle _Handle, int32_t Index, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_RequestReadReceipt(TElMessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_RequestReadReceipt(TElMessageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_RequestDeliveryReceipt(TElMessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_RequestDeliveryReceipt(TElMessageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Priority(TElMessageHandle _Handle, TElMIMEMessagePriorityRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_Priority(TElMessageHandle _Handle, TElMIMEMessagePriorityRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_HeaderFieldValues(TElMessageHandle _Handle, const char * pcName, int32_t szName, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_HeaderFields(TElMessageHandle _Handle, const char * pcAName, int32_t szAName, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_AttachEncoding(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_AttachEncoding(TElMessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_BodyEncoding(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_BodyEncoding(TElMessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_Charset(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_Charset(TElMessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_HeaderEncoding(TElMessageHandle _Handle, TElHeaderEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_HeaderEncoding(TElMessageHandle _Handle, TElHeaderEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_ExtendedOptions(TElMessageHandle _Handle, TElMessageExtendedOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_ExtendedOptions(TElMessageHandle _Handle, TElMessageExtendedOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_MIMEPrefix(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_MIMEPrefix(TElMessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_get_DefaultContentType(TElMessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_set_DefaultContentType(TElMessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_Create(int8_t bCreateMainPart, const char * pcXMailer, int32_t szXMailer, TElMessageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_Create_1(TElMessagePartClassHandle AMainPartClass, int32_t Fake, const char * pcXMailer, int32_t szXMailer, TElMessageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_Create_2(TElMessagePartHandle AMainPart, const char * pcXMailer, int32_t szXMailer, TElMessageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessage_Create_3(const char * pcXMailer, int32_t szXMailer, TElMessageHandle * OutResult);
#endif /* SB_USE_CLASS_TELMESSAGE */

#ifdef SB_USE_CLASS_TELMESSAGEHEADER
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_SetField(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue, int32_t Index, int8_t ClearParams, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_Assign(TElMessageHeaderHandle _Handle, const TElMessageHeaderHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_Clear(TElMessageHeaderHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_Clone(TElMessageHeaderHandle _Handle, TElMessageHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_AddField(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue, int8_t bOverride, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_DeleteField(TElMessageHeaderHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_DeleteField_1(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_GetField(TElMessageHeaderHandle _Handle, int32_t Index, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_GetField_1(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, int32_t Index, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_FieldExists(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_AddMailAddressList(TElMessageHeaderHandle _Handle, const TElMailAddressListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_DeleteMailAddressList(TElMessageHeaderHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_DeleteMailAddressList_1(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_GetMailAddressList(TElMessageHeaderHandle _Handle, int32_t Index, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_GetMailAddressList_1(TElMessageHeaderHandle _Handle, const char * pcName, int32_t szName, int32_t Index, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_Assemble(TElMessageHeaderHandle _Handle, char * pcsResult, int32_t * szsResult, const char * pcCharset, int32_t szCharset, TElHeaderEncodingRaw Encoding, TElMessagePartHandlerHandle MessagePartHandler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_Parse(TElMessageHeaderHandle _Handle, const char * pcASource, int32_t szASource, char * pcCharset, int32_t * szCharset, int8_t IgnoreNativeCharset, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_AddressList(TElMessageHeaderHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_AllowLongLines(TElMessageHeaderHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_set_AllowLongLines(TElMessageHeaderHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_BodyLen(TElMessageHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_set_BodyLen(TElMessageHeaderHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_FieldsCount(TElMessageHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_HeaderFields(TElMessageHeaderHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_MailAddressListCount(TElMessageHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_StreamPosBegin(TElMessageHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_set_StreamPosBegin(TElMessageHeaderHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_ParseAddresses(TElMessageHeaderHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_set_ParseAddresses(TElMessageHeaderHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_get_CombineParameters(TElMessageHeaderHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_set_CombineParameters(TElMessageHeaderHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeader_Create(TElMessageHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELMESSAGEHEADER */

#ifdef SB_USE_CLASS_TELMESSAGEHEADERFIELD
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_Clear(TElMessageHeaderFieldHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_Clone(TElMessageHeaderFieldHandle _Handle, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_AddParam(TElMessageHeaderFieldHandle _Handle, const char * pcParamName, int32_t szParamName, const char * pcParamValue, int32_t szParamValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_ClearParams(TElMessageHeaderFieldHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_DeleteParam(TElMessageHeaderFieldHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_DeleteParam_1(TElMessageHeaderFieldHandle _Handle, const char * pcParamName, int32_t szParamName);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_GetParamIndexByName(TElMessageHeaderFieldHandle _Handle, const char * pcParamName, int32_t szParamName, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_GetParamName(TElMessageHeaderFieldHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_GetParamValue(TElMessageHeaderFieldHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_GetParamValue_1(TElMessageHeaderFieldHandle _Handle, const char * pcParamName, int32_t szParamName, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_ParamExists(TElMessageHeaderFieldHandle _Handle, const char * pcParamName, int32_t szParamName, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_SetParamValue(TElMessageHeaderFieldHandle _Handle, int32_t Index, const char * pcwsValue, int32_t szwsValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_SetParamValue_1(TElMessageHeaderFieldHandle _Handle, const char * pcParamName, int32_t szParamName, const char * pcwsValue, int32_t szwsValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_Body(TElMessageHeaderFieldHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_set_Body(TElMessageHeaderFieldHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_Comments(TElMessageHeaderFieldHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_set_Comments(TElMessageHeaderFieldHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_EncodedWords(TElMessageHeaderFieldHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_set_EncodedWords(TElMessageHeaderFieldHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_QuotedParams(TElMessageHeaderFieldHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_set_QuotedParams(TElMessageHeaderFieldHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_Name(TElMessageHeaderFieldHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_set_Name(TElMessageHeaderFieldHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_ParamsCount(TElMessageHeaderFieldHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_get_Value(TElMessageHeaderFieldHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_set_Value(TElMessageHeaderFieldHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_Create(TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_Create_1(const char * pcAName, int32_t szAName, const char * pcAValue, int32_t szAValue, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessageHeaderField_Create_2(const char * pcSource, int32_t szSource, int32_t * Offset, const char * pcCharset, int32_t szCharset, int8_t IgnoreNativeCharset, TElMessageHeaderFieldHandle * OutResult);
#endif /* SB_USE_CLASS_TELMESSAGEHEADERFIELD */

#ifdef SB_USE_CLASS_TELMAILADDRESSGROUP
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_AddAddress(TElMailAddressGroupHandle _Handle, const char * pcAAlias, int32_t szAAlias, const char * pcAAddress, int32_t szAAddress, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_Clear(TElMailAddressGroupHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_Clone(TElMailAddressGroupHandle _Handle, TElMailAddressGroupHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_DeleteAddress(TElMailAddressGroupHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_IndexOfAddress(TElMailAddressGroupHandle _Handle, TElMailAddressHandle AAddress, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_get_Name(TElMailAddressGroupHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_set_Name(TElMailAddressGroupHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_get_AddressesCount(TElMailAddressGroupHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_get_Address(TElMailAddressGroupHandle _Handle, int32_t Index, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressGroup_Create(TElMailAddressGroupHandle * OutResult);
#endif /* SB_USE_CLASS_TELMAILADDRESSGROUP */

#ifdef SB_USE_CLASS_TELMAILADDRESSLIST
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Clear(TElMailAddressListHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Clone(TElMailAddressListHandle _Handle, TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Assemble(TElMailAddressListHandle _Handle, const char * pcFieldName, int32_t szFieldName, char * pcsResult, int32_t * szsResult, const char * pcCharset, int32_t szCharset, TElHeaderEncodingRaw Encoding, int8_t AllowLongHeaderLines, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Parse(TElMailAddressListHandle _Handle, const char * pcwsSource, int32_t szwsSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Parse_1(TElMailAddressListHandle _Handle, const char * pcwsSource, int32_t szwsSource, const char * pcCharset, int32_t szCharset, int8_t IgnoreNativeCharset, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_AddAddress(TElMailAddressListHandle _Handle, const char * pcAlias, int32_t szAlias, const char * pcAddress, int32_t szAddress, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_DeleteAddress(TElMailAddressListHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_GetAddress(TElMailAddressListHandle _Handle, int32_t Index, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_IndexOfAddress(TElMailAddressListHandle _Handle, TElMailAddressHandle Address, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_AddGroup(TElMailAddressListHandle _Handle, TElMailAddressGroupHandle Group, int8_t bMakeCopy, TElMailAddressGroupHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_DeleteGroup(TElMailAddressListHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_DeleteGroup_1(TElMailAddressListHandle _Handle, const char * pcGroupName, int32_t szGroupName);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_GetGroup(TElMailAddressListHandle _Handle, int32_t Index, TElMailAddressGroupHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_GetGroupName(TElMailAddressListHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_GetAddressFromAll(TElMailAddressListHandle _Handle, int32_t Index, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_get_Count(TElMailAddressListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_get_FieldName(TElMailAddressListHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_set_FieldName(TElMailAddressListHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_get_GroupsCount(TElMailAddressListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_get_TotalCount(TElMailAddressListHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Create(TElMailAddressListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddressList_Create_1(const char * pcSource, int32_t szSource, TElMailAddressListHandle * OutResult);
#endif /* SB_USE_CLASS_TELMAILADDRESSLIST */

#ifdef SB_USE_CLASS_TELMAILADDRESS
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_Clear(TElMailAddressHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_Clone(TElMailAddressHandle _Handle, TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_IsAddress(TElMailAddressHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_IsAlias(TElMailAddressHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_get_Alias(TElMailAddressHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_set_Alias(TElMailAddressHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_get_Address(TElMailAddressHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_set_Address(TElMailAddressHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_get_Comments(TElMailAddressHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_set_Comments(TElMailAddressHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_Create(TElMailAddressHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMailAddress_Create_1(const char * pcAAlias, int32_t szAAlias, const char * pcAAddress, int32_t szAAddress, TElMailAddressHandle * OutResult);
#endif /* SB_USE_CLASS_TELMAILADDRESS */

#ifdef SB_USE_CLASS_TELMESSAGEPART
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_CreatePartForHeader(TElMessageHeaderHandle Header, TElMessageHandle AMessage, TElMessagePartHandle AParent, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_CreatePartForHeader_1(TElMessagePartHandle _Handle, TElMessageHeaderHandle Header, TElMessageHandle AMessage, TElMessagePartHandle AParent, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Assign(TElMessagePartHandle _Handle, TElMessagePartHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Clear(TElMessagePartHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Clone(TElMessagePartHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Parse(TElMessagePartHandle _Handle, TElMessageHeaderHandle Header, TStreamHandle Source, const char * pcBoundary, int32_t szBoundary, const char * pcHeaderCharset, int32_t szHeaderCharset, const char * pcBodyCharset, int32_t szBodyCharset, TElMessageParsingOptionsRaw AOptions, int8_t IgnoreHeaderNativeCharset, int8_t IgnoreBodyNativeCharset, int8_t bActivatePartHandlers, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Assemble(TElMessagePartHandle _Handle, TStreamHandle Destination, const char * pcCharset, int32_t szCharset, TElHeaderEncodingRaw HeaderEncoding, const char * pcBodyEncoding, int32_t szBodyEncoding, const char * pcAttachEncoding, int32_t szAttachEncoding, int8_t bAssembleSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsText(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsTextPlain(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsTextHtml(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsMessage(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsImage(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsAudio(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsVideo(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsMultipart(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsAttachment(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsInline(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_IsApplication(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetFieldValue(TElMessagePartHandle _Handle, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetContentType(TElMessagePartHandle _Handle, const char * pcAValue, int32_t szAValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetContentSubtype(TElMessagePartHandle _Handle, const char * pcAValue, int32_t szAValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetContentTransferEncoding(TElMessagePartHandle _Handle, const char * pcAValue, int32_t szAValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetContentID(TElMessagePartHandle _Handle, const char * pcAValue, int32_t szAValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetContentDisposition(TElMessagePartHandle _Handle, const char * pcAValue, int32_t szAValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetContentDescription(TElMessagePartHandle _Handle, const char * pcAValue, int32_t szAValue, int8_t ClearParams);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_GetDataSize(TElMessagePartHandle _Handle, int32_t * Size, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_GetData(TElMessagePartHandle _Handle, char * pcwsData, int32_t * szwsData, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_GetData_1(TElMessagePartHandle _Handle, uint8_t pBuffer[], int32_t * szBuffer, int32_t * BufferSize, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SaveDataToStream(TElMessagePartHandle _Handle, TStreamHandle Stream, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SaveDataToFile(TElMessagePartHandle _Handle, const char * pcwsFileName, int32_t szwsFileName, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetData(TElMessagePartHandle _Handle, TStreamHandle Stream, int32_t DataSize, int8_t bMakeCopy);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetData_1(TElMessagePartHandle _Handle, const char * pcwsData, int32_t szwsData);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetData_2(TElMessagePartHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Offset, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_GetText(TElMessagePartHandle _Handle, char * pcAText, int32_t * szAText, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_SetText(TElMessagePartHandle _Handle, const char * pcAText, int32_t szAText);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_GetPart(TElMessagePartHandle _Handle, int32_t Index, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_AddPart(TElMessagePartHandle _Handle, TElMessagePartHandle Part, int8_t bMakeCopy, int32_t PartIndex, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_AddPart_1(TElMessagePartHandle _Handle, TElMessagePartHandle Part);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_DeletePart(TElMessagePartHandle _Handle, int32_t Index, int8_t bDestroy);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_DeletePart_1(TElMessagePartHandle _Handle, TElMessagePartHandle Part, int8_t bDestroy);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_BodyLen(TElMessagePartHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_Stream(TElMessagePartHandle _Handle, TStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_StreamPosBegin(TElMessagePartHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_Data(TElMessagePartHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_Data(TElMessagePartHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_DataStream(TElMessagePartHandle _Handle, TStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_DataStream(TElMessagePartHandle _Handle, TStreamHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_DataSize(TElMessagePartHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_DataSize(TElMessagePartHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_Options(TElMessagePartHandle _Handle, TElMessageParsingOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_Options(TElMessagePartHandle _Handle, TElMessageParsingOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_DisposeStream(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_DisposeStream(TElMessagePartHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_DisposeDataStream(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_DisposeDataStream(TElMessagePartHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_Header(TElMessagePartHandle _Handle, TElMessageHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_Parent(TElMessagePartHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ParentMessage(TElMessagePartHandle _Handle, TElMessageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_HeaderFields(TElMessagePartHandle _Handle, const char * pcwsFieldName, int32_t szwsFieldName, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_HeaderContentTypeField(TElMessagePartHandle _Handle, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_HeaderContentDispositionField(TElMessagePartHandle _Handle, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_HeaderContentTransferEncodingField(TElMessagePartHandle _Handle, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_HeaderContentLocationField(TElMessagePartHandle _Handle, TElMessageHeaderFieldHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ContentType(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ContentSubtype(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ContentTransferEncoding(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ContentID(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ContentDisposition(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_ContentDescription(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_FileName(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_FileName(TElMessagePartHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_CharSet(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_CharSet(TElMessagePartHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_HeaderCharSet(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_BodyCharSet(TElMessagePartHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_PartsCount(TElMessagePartHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_AttachmentsCount(TElMessagePartHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_Attachments(TElMessagePartHandle _Handle, int32_t Index, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_MessagePartHandler(TElMessagePartHandle _Handle, TElMessagePartHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_MessagePartHandler(TElMessagePartHandle _Handle, TElMessagePartHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_MessageBodyPartHandler(TElMessagePartHandle _Handle, TElMessagePartHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_set_MessageBodyPartHandler(TElMessagePartHandle _Handle, TElMessagePartHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_get_IsActivatedMessagePartHandler(TElMessagePartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Create(TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePart_Create_1(TElMessageHandle AMessage, TElMessagePartHandle AParent, TElMessagePartHandle * OutResult);
#endif /* SB_USE_CLASS_TELMESSAGEPART */

#ifdef SB_USE_CLASS_TELMULTIPARTLIST
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Assign(TElMultiPartListHandle _Handle, TElMessagePartHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Clear(TElMultiPartListHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Clone(TElMultiPartListHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Parse(TElMultiPartListHandle _Handle, TElMessageHeaderHandle AHeader, TStreamHandle Source, const char * pcBoundary, int32_t szBoundary, const char * pcHeaderCharset, int32_t szHeaderCharset, const char * pcBodyCharset, int32_t szBodyCharset, TElMessageParsingOptionsRaw AOptions, int8_t IgnoreHeaderNativeCharset, int8_t IgnoreBodyNativeCharset, int8_t bActivatePartHandlers, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Assemble(TElMultiPartListHandle _Handle, TStreamHandle Destination, const char * pcCharset, int32_t szCharset, TElHeaderEncodingRaw HeaderEncoding, const char * pcBodyEncoding, int32_t szBodyEncoding, const char * pcAttachEncoding, int32_t szAttachEncoding, int8_t bAssembleSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_GetPart(TElMultiPartListHandle _Handle, int32_t Index, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_AddPart(TElMultiPartListHandle _Handle, TElMessagePartHandle Part, int8_t bMakeCopy, int32_t PartIndex, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_AddPart_1(TElMessagePartHandle _Handle, TElMessagePartHandle Part);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_DeletePart(TElMultiPartListHandle _Handle, int32_t Index, int8_t bDestroy);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_DeletePart_1(TElMultiPartListHandle _Handle, TElMessagePartHandle Part, int8_t bDestroy);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsText(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsTextPlain(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsMessage(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsImage(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsAudio(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsVideo(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_IsMultipart(TElMultiPartListHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_GetDataSize(TElMultiPartListHandle _Handle, int32_t * Size, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_GetData(TElMultiPartListHandle _Handle, char * pcwsData, int32_t * szwsData, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_GetData_1(TElMultiPartListHandle _Handle, uint8_t pBuffer[], int32_t * szBuffer, int32_t * BufferSize, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_SetData(TElMultiPartListHandle _Handle, TStreamHandle Stream, int32_t DataSize, int8_t bMakeCopy);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_SetData_1(TElMultiPartListHandle _Handle, const char * pcwsData, int32_t szwsData);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_SetData_2(TElMultiPartListHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Offset, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_GenerateBoundary(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_GenerateBoundary_1(TElMultiPartListHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_get_Boundary(TElMultiPartListHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_set_Boundary(TElMultiPartListHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Create(TElMultiPartListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMultiPartList_Create_1(TElMessageHandle AMessage, TElMessagePartHandle AParent, TElMultiPartListHandle * OutResult);
#endif /* SB_USE_CLASS_TELMULTIPARTLIST */

#ifdef SB_USE_CLASS_TELPLAINTEXTPART
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_Clone(TElPlainTextPartHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_Assign(TElPlainTextPartHandle _Handle, TElMessagePartHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_Parse(TElPlainTextPartHandle _Handle, TElMessageHeaderHandle Header, TStreamHandle Source, const char * pcBoundary, int32_t szBoundary, const char * pcHeaderCharset, int32_t szHeaderCharset, const char * pcBodyCharset, int32_t szBodyCharset, TElMessageParsingOptionsRaw AOptions, int8_t IgnoreHeaderNativeCharset, int8_t IgnoreBodyNativeCharset, int8_t bActivatePartHandlers, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_Assemble(TElPlainTextPartHandle _Handle, TStreamHandle Destination, const char * pcCharset, int32_t szCharset, TElHeaderEncodingRaw HeaderEncoding, const char * pcBodyEncoding, int32_t szBodyEncoding, const char * pcAttachEncoding, int32_t szAttachEncoding, int8_t bAssembleSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_GetText(TElPlainTextPartHandle _Handle, char * pcAText, int32_t * szAText, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_SetText(TElPlainTextPartHandle _Handle, const char * pcAText, int32_t szAText);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsText(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsTextPlain(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsMessage(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsImage(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsAudio(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsVideo(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsMultipart(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_IsAttachment(TElPlainTextPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_GetDataSize(TElPlainTextPartHandle _Handle, int32_t * Size, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_GetData(TElPlainTextPartHandle _Handle, char * pcwsData, int32_t * szwsData, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_GetData_1(TElPlainTextPartHandle _Handle, uint8_t pBuffer[], int32_t * szBuffer, int32_t * BufferSize, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_SetData(TElPlainTextPartHandle _Handle, TStreamHandle Stream, int32_t DataSize, int8_t bMakeCopy);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_SetData_1(TElPlainTextPartHandle _Handle, const char * pcwsData, int32_t szwsData);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_SetData_2(TElPlainTextPartHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Offset, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_Create(TElPlainTextPartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPlainTextPart_Create_1(TElMessageHandle AMessage, TElMessagePartHandle AParent, TElPlainTextPartHandle * OutResult);
#endif /* SB_USE_CLASS_TELPLAINTEXTPART */

#ifdef SB_USE_CLASS_TELMESSAGEPARTHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_Decode(TElMessagePartHandlerHandle _Handle, int8_t bActivatePartHandlers, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_GetDescription(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_GetDescription_1(TElMessagePartHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_get_DecodedPart(TElMessagePartHandlerHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_set_DecodedPart(TElMessagePartHandlerHandle _Handle, TElMessagePartHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_get_IsDecoderActivated(TElMessagePartHandlerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_get_IsError(TElMessagePartHandlerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_get_ErrorText(TElMessagePartHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_get_ResultCode(TElMessagePartHandlerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMessagePartHandler_Create(TObjectHandle aParams, TElMessagePartHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELMESSAGEPARTHANDLER */

#ifdef SB_USE_CLASS_TELCONVERTER
SB_IMPORT uint32_t SB_APIENTRY TElConverter_Convert(TElConverterHandle _Handle, TStreamHandle Source, TStreamHandle Dest, TPlConvertOptionsRaw Options, int32_t MaxChars, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElConverter_Convert_1(TElConverterHandle _Handle, const char * pcSource, int32_t szSource, char * pcDest, int32_t * szDest, TPlConvertOptionsRaw Options, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElConverter_Create(TPlConverterHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElConverter_Create_1(const char * pcSrcCharset, int32_t szSrcCharset, const char * pcDstCharset, int32_t szDstCharset, TPlConverterHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElConverter_Create_2(IPlCharsetHandle SrcCharset, IPlCharsetHandle DstCharset, TPlConverterHandle * OutResult);
#endif /* SB_USE_CLASS_TELCONVERTER */

#ifdef SB_USE_CLASS_TELREGISTEREDMESSAGEPARTHANDLERS
SB_IMPORT uint32_t SB_APIENTRY TElRegisteredMessagePartHandlers_AddHandler(TElRegisteredMessagePartHandlersHandle _Handle, TElMessagePartHandlerClassHandle hc);
SB_IMPORT uint32_t SB_APIENTRY TElRegisteredMessagePartHandlers_GetHandlersCount(TElRegisteredMessagePartHandlersHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRegisteredMessagePartHandlers_GetHandlerClass(TElRegisteredMessagePartHandlersHandle _Handle, int32_t Index, TElMessagePartHandlerClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRegisteredMessagePartHandlers_RemoveHandler(TElRegisteredMessagePartHandlersHandle _Handle, TElMessagePartHandlerClassHandle hc);
SB_IMPORT uint32_t SB_APIENTRY TElRegisteredMessagePartHandlers_Create(TElRegisteredMessagePartHandlersHandle * OutResult);
#endif /* SB_USE_CLASS_TELREGISTEREDMESSAGEPARTHANDLERS */

#ifdef SB_USE_CLASS_TELXMLPART
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_Assemble(TElXmlPartHandle _Handle, TStreamHandle Destination, const char * pcCharset, int32_t szCharset, TElHeaderEncodingRaw HeaderEncoding, const char * pcBodyEncoding, int32_t szBodyEncoding, const char * pcAttachEncoding, int32_t szAttachEncoding, int8_t bAssembleSource, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_Clone(TElXmlPartHandle _Handle, TElMessagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsText(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsTextPlain(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsTextHtml(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsMessage(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsImage(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsAudio(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsVideo(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_IsMultipart(TElXmlPartHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_Parse(TElXmlPartHandle _Handle, TElMessageHeaderHandle Header, TStreamHandle Source, const char * pcBoundary, int32_t szBoundary, const char * pcHeaderCharset, int32_t szHeaderCharset, const char * pcBodyCharset, int32_t szBodyCharset, TElMessageParsingOptionsRaw AOptions, int8_t IgnoreHeaderNativeCharset, int8_t IgnoreBodyNativeCharset, int8_t bActivatePartHandlers, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_Create(TElXmlPartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXmlPart_Create_1(TElMessageHandle AMessage, TElMessagePartHandle AParent, TElXmlPartHandle * OutResult);
#endif /* SB_USE_CLASS_TELXMLPART */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElParseContext_ce_ptr;
extern zend_class_entry *TElFieldParam_ce_ptr;
extern zend_class_entry *TElMessagePartClass_ce_ptr;
extern zend_class_entry *TElMessagePartHandlerClass_ce_ptr;
extern zend_class_entry *TElMessage_ce_ptr;
extern zend_class_entry *TElMessageHeader_ce_ptr;
extern zend_class_entry *TElMessageHeaderField_ce_ptr;
extern zend_class_entry *TElMailAddressGroup_ce_ptr;
extern zend_class_entry *TElMailAddressList_ce_ptr;
extern zend_class_entry *TElMailAddress_ce_ptr;
extern zend_class_entry *TElMessagePart_ce_ptr;
extern zend_class_entry *TElMultiPartList_ce_ptr;
extern zend_class_entry *TElPlainTextPart_ce_ptr;
extern zend_class_entry *TElMessagePartHandler_ce_ptr;
extern zend_class_entry *TElConverter_ce_ptr;
extern zend_class_entry *TElRegisteredMessagePartHandlers_ce_ptr;
extern zend_class_entry *TElXmlPart_ce_ptr;

void Register_TElParseContext(TSRMLS_D);
void Register_TElFieldParam(TSRMLS_D);
void Register_TElMessage(TSRMLS_D);
void Register_TElMessageHeader(TSRMLS_D);
void Register_TElMessageHeaderField(TSRMLS_D);
void Register_TElMailAddressGroup(TSRMLS_D);
void Register_TElMailAddressList(TSRMLS_D);
void Register_TElMailAddress(TSRMLS_D);
void Register_TElMessagePart(TSRMLS_D);
void Register_TElMultiPartList(TSRMLS_D);
void Register_TElPlainTextPart(TSRMLS_D);
void Register_TElMessagePartHandler(TSRMLS_D);
void Register_TElConverter(TSRMLS_D);
void Register_TElRegisteredMessagePartHandlers(TSRMLS_D);
void Register_TElXmlPart(TSRMLS_D);
SB_PHP_FUNCTION(SBMIME, WideSameText);
SB_PHP_FUNCTION(SBMIME, GetHeaderFromStream);
SB_PHP_FUNCTION(SBMIME, DeleteQuotationMarks);
SB_PHP_FUNCTION(SBMIME, SetInQuotationMarks);
SB_PHP_FUNCTION(SBMIME, IsAddressListField);
SB_PHP_FUNCTION(SBMIME, IsMessageScopeField);
SB_PHP_FUNCTION(SBMIME, IsUnstructuredField);
SB_PHP_FUNCTION(SBMIME, RegisterUnstructuredField);
SB_PHP_FUNCTION(SBMIME, AddRegisteredMIMEMessagePartHandler);
SB_PHP_FUNCTION(SBMIME, RemoveRegisteredMIMEMessagePartHandler);
void Register_SBMIME_Constants(int module_number TSRMLS_DC);
void Register_SBMIME_Enum_Flags(TSRMLS_D);
void Register_SBMIME_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_MIME
SB_IMPORT uint32_t SB_APIENTRY SBMIME_WideSameText(const char * pcS1, int32_t szS1, const char * pcS2, int32_t szS2, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_GetHeaderFromStream(const TStreamHandle Source, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_DeleteQuotationMarks(char * pcStr, int32_t * szStr);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_SetInQuotationMarks(char * pcStr, int32_t * szStr);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_IsAddressListField(const char * pcFieldName, int32_t szFieldName, int8_t CheckPartial, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_IsMessageScopeField(const char * pcFieldName, int32_t szFieldName, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_IsUnstructuredField(const char * pcFieldName, int32_t szFieldName, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_RegisterUnstructuredField(const char * pcFieldName, int32_t szFieldName);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_AddRegisteredMIMEMessagePartHandler(TElMessagePartHandlerClassHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY SBMIME_RemoveRegisteredMIMEMessagePartHandler(TElMessagePartHandlerClassHandle Handler);
#endif /* SB_USE_GLOBAL_PROCS_MIME */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBMIME */

