#ifndef __INC_SBMIMESTREAM
#define __INC_SBMIMESTREAM

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstreams.h"
#include "sbconstants.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_rsStreamReadError 	"Stream read error"
#define SB_rsCannotOpenFile 	"Cannot open file \"%s\""

typedef TElClassHandle TElCustomMIMEStreamHandle;

typedef TElClassHandle TNullMIMEStreamHandle;

typedef TElClassHandle TElCustomMemoryMIMEStreamHandle;

typedef TElClassHandle TElMemoryMIMEStreamHandle;

typedef TElClassHandle TAnsiStringMIMEStreamHandle;

typedef TElClassHandle TWideStringMIMEStreamHandle;

typedef TElCustomMIMEStreamHandle ElCustomStreamHandle;

typedef TElMemoryMIMEStreamHandle ElMemoryStreamHandle;

typedef TElCustomMemoryMIMEStreamHandle ElCustomMemoryStreamHandle;

#ifdef SB_USE_CLASS_TELCUSTOMMIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_Flush(TElCustomMIMEStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_CopyFrom(TElCustomMIMEStreamHandle _Handle, TStreamHandle SrcStream, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream__CopyTo(TElCustomMIMEStreamHandle _Handle, TStreamHandle DestStream, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_Squeeze(TElCustomMIMEStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_Reserve(TElCustomMIMEStreamHandle _Handle, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_get_Capacity(TElCustomMIMEStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_set_Capacity(TElCustomMIMEStreamHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMIMEStream_Create(TElCustomMIMEStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELCUSTOMMIMESTREAM */

#ifdef SB_USE_CLASS_TNULLMIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY TNullMIMEStream_Read(TNullMIMEStreamHandle _Handle, void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TNullMIMEStream_Write(TNullMIMEStreamHandle _Handle, const void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TNullMIMEStream_Seek(TNullMIMEStreamHandle _Handle, int32_t Offset, uint16_t Origin, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TNullMIMEStream_Seek_1(TNullMIMEStreamHandle _Handle, int64_t Offset, TSeekOriginRaw Origin, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TNullMIMEStream_Create(TNullMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TNullMIMEStream_Create_1(int64_t ASize, TNullMIMEStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TNULLMIMESTREAM */

#ifdef SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_SetMemory(TElCustomMemoryMIMEStreamHandle _Handle, const uint8_t pValue[], int32_t szValue, int64_t ASize);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_SaveToStream(TElCustomMemoryMIMEStreamHandle _Handle, TStreamHandle Stream, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_SaveToFileEx(TElCustomMemoryMIMEStreamHandle _Handle, const char * pcFileName, int32_t szFileName, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_SaveToFile(TElCustomMemoryMIMEStreamHandle _Handle, const char * pcFileName, int32_t szFileName);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_LoadFromStream(TElCustomMemoryMIMEStreamHandle _Handle, TStreamHandle Stream, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_LoadFromFileEx(TElCustomMemoryMIMEStreamHandle _Handle, const char * pcFileName, int32_t szFileName, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_LoadFromFile(TElCustomMemoryMIMEStreamHandle _Handle, const char * pcFileName, int32_t szFileName);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Read(TElCustomMemoryMIMEStreamHandle _Handle, void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Write(TElCustomMemoryMIMEStreamHandle _Handle, const void * Buffer, int32_t Count, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Seek(TElCustomMemoryMIMEStreamHandle _Handle, int32_t Offset, uint16_t Origin, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Seek_1(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Offset, TSeekOriginRaw Origin, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Clear(TElCustomMemoryMIMEStreamHandle _Handle, int64_t NewCapacity);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Squeeze(TElCustomMemoryMIMEStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Reserve(TElCustomMemoryMIMEStreamHandle _Handle, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_SizePos(TElCustomMemoryMIMEStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_get_Memory(TElCustomMemoryMIMEStreamHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_set_Memory(TElCustomMemoryMIMEStreamHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_get_MemoryDelta(TElCustomMemoryMIMEStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_set_MemoryDelta(TElCustomMemoryMIMEStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Create(TElCustomMemoryMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElCustomMemoryMIMEStream_Create_1(int64_t ACapacity, TElCustomMemoryMIMEStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELCUSTOMMEMORYMIMESTREAM */

#ifdef SB_USE_CLASS_TELMEMORYMIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_get_Memory(TElMemoryMIMEStreamHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_set_Memory(TElMemoryMIMEStreamHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_get_Bytes(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_set_Bytes(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_get_Words(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_set_Words(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_Create(TElCustomMemoryMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElMemoryMIMEStream_Create_1(int64_t ACapacity, TElCustomMemoryMIMEStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELMEMORYMIMESTREAM */

#ifdef SB_USE_CLASS_TANSISTRINGMIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_GetAnsiStringMIMEStream(TAnsiStringMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_GetAnsiStringMIMEStream_1(TAnsiStringMIMEStreamHandle _Handle, TAnsiStringMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_WriteChar(TAnsiStringMIMEStreamHandle _Handle, char ch);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_WriteString(TAnsiStringMIMEStreamHandle _Handle, const char * pcS, int32_t szS, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_get_AnsiLength(TAnsiStringMIMEStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_set_AnsiLength(TAnsiStringMIMEStreamHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_get_AnsiData(TAnsiStringMIMEStreamHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_set_AnsiData(TAnsiStringMIMEStreamHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_get_Bytes(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_set_Bytes(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_get_Chars(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, char * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_set_Chars(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, char Value);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_Create(TAnsiStringMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_Create_1(const char * pcsValue, int32_t szsValue, TAnsiStringMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TAnsiStringMIMEStream_Create_2(int64_t ACapacity, TAnsiStringMIMEStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TANSISTRINGMIMESTREAM */

#ifdef SB_USE_CLASS_TWIDESTRINGMIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_WriteWChar(TWideStringMIMEStreamHandle _Handle, const char * pcch, int32_t szch);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_WriteWString(TWideStringMIMEStreamHandle _Handle, const char * pcS, int32_t szS, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_get_CurrentWord(TWideStringMIMEStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_get_WideData(TWideStringMIMEStreamHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_set_WideData(TWideStringMIMEStreamHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_get_WideLength(TWideStringMIMEStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_set_WideLength(TWideStringMIMEStreamHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_get_Words(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_set_Words(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_get_WChars(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_set_WChars(TElCustomMemoryMIMEStreamHandle _Handle, int64_t Index, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_Create(TWideStringMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_Create_1(const char * pcwsValue, int32_t szwsValue, TWideStringMIMEStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TWideStringMIMEStream_Create_2(int64_t ACapacity, TWideStringMIMEStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TWIDESTRINGMIMESTREAM */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElCustomMIMEStream_ce_ptr;
extern zend_class_entry *TNullMIMEStream_ce_ptr;
extern zend_class_entry *TElCustomMemoryMIMEStream_ce_ptr;
extern zend_class_entry *TElMemoryMIMEStream_ce_ptr;
extern zend_class_entry *TAnsiStringMIMEStream_ce_ptr;
extern zend_class_entry *TWideStringMIMEStream_ce_ptr;

void Register_TElCustomMIMEStream(TSRMLS_D);
void Register_TNullMIMEStream(TSRMLS_D);
void Register_TElCustomMemoryMIMEStream(TSRMLS_D);
void Register_TElMemoryMIMEStream(TSRMLS_D);
void Register_TAnsiStringMIMEStream(TSRMLS_D);
void Register_TWideStringMIMEStream(TSRMLS_D);
SB_PHP_FUNCTION(SBMIMEStream, WriteStringToStream);
SB_PHP_FUNCTION(SBMIMEStream, WriteWideStringToStream);
SB_PHP_FUNCTION(SBMIMEStream, WriteStreamToStream);
SB_PHP_FUNCTION(SBMIMEStream, ReadLineFromStream);
SB_PHP_FUNCTION(SBMIMEStream, SeekStreamToEnd);
void Register_SBMIMEStream_Constants(int module_number TSRMLS_DC);
void Register_SBMIMEStream_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_MIMESTREAM
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_WriteStringToStream(const uint8_t pS[], int32_t szS, TStreamHandle Stream, int64_t LPos, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_WriteStringToStream_1(const char * pcS, int32_t szS, TStreamHandle Stream, int64_t LPos, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_WriteWideStringToStream(const char * pcS, int32_t szS, TStreamHandle Stream, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_WriteStreamToStream(TStreamHandle Source, TStreamHandle Dest, int64_t Count, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_ReadLineFromStream(TStreamHandle Source, TStreamHandle smDest, int32_t * iLineLength, int32_t MaxLineLength, int8_t bReadLongLine, int8_t bSeekLongToEOL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_ReadLineFromStream_1(TStreamHandle Source, char * pcsDest, int32_t * szsDest, int32_t MaxLineLength, int8_t bReadLongLine, int8_t bSeekLongToEOL, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBMIMEStream_SeekStreamToEnd(TStreamHandle Stream, int64_t * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_MIMESTREAM */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBMIMESTREAM */

