#ifndef __INC_SBOFFICE
#define __INC_SBOFFICE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbcompoundfile.h"
#include "sbofficebinarycore.h"
#include "sbofficeconstants.h"
#include "sbofficecommon.h"
#include "sbofficepackage.h"
#include "sbofficeresources.h"
#include "sbofficexmlcore.h"
#include "sbxmlcore.h"
#include "sbxmldefs.h"
#include "sbxmlutils.h"
#include "sbarczip.h"
#include "sbcryptoprov.h"
#include "sbcustomcertstorage.h"
#include "sbdc.h"
#include "sbstreams.h"
#include "sbx509.h"
#include "sbtypes.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElOfficeOpenXMLSignatureViewHandle;

typedef TElClassHandle TElOfficeCustomSecurityHandlerHandle;

typedef TElClassHandle TElOfficeCustomEncryptionHandlerHandle;

typedef TElClassHandle TElOfficeBinaryCustomEncryptionHandlerHandle;

typedef TElClassHandle TElOfficeOpenXMLCustomEncryptionHandlerHandle;

typedef TElClassHandle TElOpenOfficeCustomEncryptionHandlerHandle;

typedef TElClassHandle TElOfficeCustomSignatureHandlerHandle;

typedef TElClassHandle TElOfficeBinaryCustomSignatureHandlerHandle;

typedef TElClassHandle TElOfficeBinaryUnsupportedSignatureHandlerHandle;

typedef TElClassHandle TElOfficeBinaryInvalidSignatureHandlerHandle;

typedef TElClassHandle TElOfficeOpenXMLCustomSignatureHandlerHandle;

typedef TElClassHandle TElOfficeOpenXMLUnsupportedSignatureHandlerHandle;

typedef TElClassHandle TElOfficeOpenXMLInvalidSignatureHandlerHandle;

typedef TElClassHandle TElOpenOfficeCustomSignatureHandlerHandle;

typedef TElClassHandle TElOpenOfficeUnsupportedSignatureHandlerHandle;

typedef TElClassHandle TElOpenOfficeInvalidSignatureHandlerHandle;

typedef TElClassHandle TElOfficeBinaryDocumentHandle;

typedef TElClassHandle TElOfficeOpenXMLPackageHandle;

typedef TElClassHandle TElOfficeOpenXMLSignatureLineHandle;

typedef TElClassHandle TElOfficeOpenXMLDocumentHandle;

typedef TElClassHandle TElOfficeOpenXPSSignatureDefinitionHandle;

typedef TElClassHandle TElOfficeOpenXPSPageContentHandle;

typedef TElClassHandle TElOfficeOpenXPSFixedDocumentHandle;

typedef TElClassHandle TElOfficeOpenXPSDocumentHandle;

typedef TElClassHandle TElOpenOfficeDocumentHandle;

typedef TElClassHandle TElOfficeDocumentHandle;

typedef TElClassHandle TElOfficeSecurityHandlerClassHandle;

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureView_get_SignatureHandler(TElOfficeOpenXMLSignatureViewHandle _Handle, TElOfficeOpenXMLCustomSignatureHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureView_set_SignatureHandler(TElOfficeOpenXMLSignatureViewHandle _Handle, TElOfficeOpenXMLCustomSignatureHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureView_get_Package(TElOfficeOpenXMLSignatureViewHandle _Handle, TElOfficeOpenXMLPackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureView_Create(TElOfficeOpenXMLPackageHandle APackage, TElOfficeOpenXMLSignatureViewHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNATUREVIEW */

#ifdef SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_GetName_1(TElOfficeCustomSecurityHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_Reset(TElOfficeCustomSecurityHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_get_CryptoProviderManager(TElOfficeCustomSecurityHandlerHandle _Handle, TElCustomCryptoProviderManagerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_set_CryptoProviderManager(TElOfficeCustomSecurityHandlerHandle _Handle, TElCustomCryptoProviderManagerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSecurityHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICECUSTOMSECURITYHANDLER */

#ifdef SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomEncryptionHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomEncryptionHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICECUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomEncryptionHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomEncryptionHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEBINARYCUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomEncryptionHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomEncryptionHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICECUSTOMENCRYPTIONHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomEncryptionHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomEncryptionHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOPENOFFICECUSTOMENCRYPTIONHANDLER */

#ifdef SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSignatureHandler_Reset(TElOfficeCustomSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSignatureHandler_CompleteAsyncSign(TElOfficeCustomSignatureHandlerHandle _Handle, TElDCAsyncStateHandle State);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSignatureHandler_get_IsCalculated(TElOfficeCustomSignatureHandlerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCustomSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICECUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomSignatureHandler_Reset(TElOfficeBinaryCustomSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomSignatureHandler_get_Storage(TElOfficeBinaryCustomSignatureHandlerHandle _Handle, TElCompoundFileStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomSignatureHandler_get_SignatureStreamEntry(TElOfficeBinaryCustomSignatureHandlerHandle _Handle, TElCompoundFileStreamEntryHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryCustomSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEBINARYCUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYUNSUPPORTEDSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryUnsupportedSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryUnsupportedSignatureHandler_GetName_1(TElOfficeBinaryUnsupportedSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryUnsupportedSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryUnsupportedSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEBINARYUNSUPPORTEDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYINVALIDSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryInvalidSignatureHandler_Reset(TElOfficeBinaryInvalidSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryInvalidSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryInvalidSignatureHandler_GetName_1(TElOfficeBinaryInvalidSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryInvalidSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryInvalidSignatureHandler_get_ErrorMessage(TElOfficeBinaryInvalidSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryInvalidSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEBINARYINVALIDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomSignatureHandler_Reset(TElOfficeOpenXMLCustomSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomSignatureHandler_get_Package(TElOfficeOpenXMLCustomSignatureHandlerHandle _Handle, TElOfficePackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomSignatureHandler_get_SignaturePart(TElOfficeOpenXMLCustomSignatureHandlerHandle _Handle, TElOfficePackagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLCustomSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLCUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLUNSUPPORTEDSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLUnsupportedSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLUnsupportedSignatureHandler_GetName_1(TElOfficeOpenXMLUnsupportedSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLUnsupportedSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLUnsupportedSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLUNSUPPORTEDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLINVALIDSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLInvalidSignatureHandler_Reset(TElOfficeOpenXMLInvalidSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLInvalidSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLInvalidSignatureHandler_GetName_1(TElOfficeOpenXMLInvalidSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLInvalidSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLInvalidSignatureHandler_get_ErrorMessage(TElOfficeOpenXMLInvalidSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLInvalidSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLINVALIDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomSignatureHandler_Reset(TElOpenOfficeCustomSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomSignatureHandler_get_Package(TElOpenOfficeCustomSignatureHandlerHandle _Handle, TElOpenOfficePackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomSignatureHandler_get_XMLElement(TElOpenOfficeCustomSignatureHandlerHandle _Handle, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomSignatureHandler_get_SignaturePath(TElOpenOfficeCustomSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeCustomSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOPENOFFICECUSTOMSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICEUNSUPPORTEDSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeUnsupportedSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeUnsupportedSignatureHandler_GetName_1(TElOpenOfficeUnsupportedSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeUnsupportedSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeUnsupportedSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOPENOFFICEUNSUPPORTEDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOPENOFFICEINVALIDSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeInvalidSignatureHandler_Reset(TElOpenOfficeInvalidSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeInvalidSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeInvalidSignatureHandler_GetName_1(TElOpenOfficeInvalidSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeInvalidSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeInvalidSignatureHandler_get_ErrorMessage(TElOpenOfficeInvalidSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeInvalidSignatureHandler_Create(TComponentHandle Owner, TElOfficeCustomSecurityHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELOPENOFFICEINVALIDSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELOFFICEBINARYDOCUMENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_Open(TElOfficeBinaryDocumentHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_Open_1(TElOfficeBinaryDocumentHandle _Handle, TStreamHandle Stream, int8_t OwnStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_Open_2(TElOfficeBinaryDocumentHandle _Handle, TStreamHandle Stream, int8_t OwnStream, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_Close(TElOfficeBinaryDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_Flush(TElOfficeBinaryDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_DecryptTo(TElOfficeBinaryDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_EncryptTo(TElOfficeBinaryDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_AddSignature(TElOfficeBinaryDocumentHandle _Handle, TElOfficeBinaryCustomSignatureHandlerHandle Handler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_AddSignature_1(TElOfficeBinaryDocumentHandle _Handle, TElOfficeBinaryCustomSignatureHandlerHandle Handler, int8_t OwnHandler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_RemoveSignature(TElOfficeBinaryDocumentHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_CompleteAsyncSign(TElOfficeBinaryDocumentHandle _Handle, TElOfficeBinaryCustomSignatureHandlerHandle Handler, TElDCAsyncStateHandle State);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_Encryptable(TElOfficeBinaryDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_Signable(TElOfficeBinaryDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_IsEncrypted(TElOfficeBinaryDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_IsSigned(TElOfficeBinaryDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_DocumentFormat(TElOfficeBinaryDocumentHandle _Handle, TSBOfficeDocumentFormatRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_DocumentType(TElOfficeBinaryDocumentHandle _Handle, TSBOfficeBinaryDocumentTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_EncryptionHandler(TElOfficeBinaryDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_set_EncryptionHandler(TElOfficeBinaryDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_OwnEncryptionHandler(TElOfficeBinaryDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_set_OwnEncryptionHandler(TElOfficeBinaryDocumentHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_SignatureHandlerCount(TElOfficeBinaryDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_SignatureHandlers(TElOfficeBinaryDocumentHandle _Handle, int32_t Index, TElOfficeBinaryCustomSignatureHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_get_Storage(TElOfficeBinaryDocumentHandle _Handle, TElCompoundFileStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryDocument_Create(TElOfficeBinaryDocumentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEBINARYDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Open(TElOfficeOpenXMLPackageHandle _Handle, TElOfficePackageHandle APackage);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Open_1(TElOfficeOpenXMLPackageHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Open_2(TElOfficeOpenXMLPackageHandle _Handle, TStreamHandle Stream, int8_t OwnStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Open_3(TElOfficeOpenXMLPackageHandle _Handle, TStreamHandle Stream, int8_t OwnStream, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Close(TElOfficeOpenXMLPackageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Flush(TElOfficeOpenXMLPackageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_AddSignature(TElOfficeOpenXMLPackageHandle _Handle, TElOfficeOpenXMLCustomSignatureHandlerHandle Handler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_AddSignature_1(TElOfficeOpenXMLPackageHandle _Handle, TElOfficeOpenXMLCustomSignatureHandlerHandle Handler, int8_t OwnHandler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_RemoveSignature(TElOfficeOpenXMLPackageHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_CompleteAsyncSign(TElOfficeOpenXMLPackageHandle _Handle, TElOfficeOpenXMLCustomSignatureHandlerHandle Handler, TElDCAsyncStateHandle State);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_SignatureHandlerCount(TElOfficeOpenXMLPackageHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_SignatureHandlers(TElOfficeOpenXMLPackageHandle _Handle, int32_t Index, TElOfficeOpenXMLCustomSignatureHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_Encryptable(TElOfficeOpenXMLPackageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_Signable(TElOfficeOpenXMLPackageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_IsSigned(TElOfficeOpenXMLPackageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_Package(TElOfficeOpenXMLPackageHandle _Handle, TElOfficePackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_CoreProperties(TElOfficeOpenXMLPackageHandle _Handle, TElOfficeOpenXMLCorePropertiesHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_ThumbnailPart(TElOfficeOpenXMLPackageHandle _Handle, TElOfficePackagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_OnCreateTemporaryStream(TElOfficeOpenXMLPackageHandle _Handle, TSBOfficeCreateTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_set_OnCreateTemporaryStream(TElOfficeOpenXMLPackageHandle _Handle, TSBOfficeCreateTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_get_OnCloseTemporaryStream(TElOfficeOpenXMLPackageHandle _Handle, TSBOfficeCloseTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_set_OnCloseTemporaryStream(TElOfficeOpenXMLPackageHandle _Handle, TSBOfficeCloseTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLPackage_Create(TElOfficeOpenXMLPackageHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLPACKAGE */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLSIGNATURELINE
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_AdditionalSignatureInfo(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_AllowComments(TElOfficeOpenXMLSignatureLineHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_ID(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_ImageData(TElOfficeOpenXMLSignatureLineHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_SignatureProviderId(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_SignatureProviderUrl(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_ShowSignDate(TElOfficeOpenXMLSignatureLineHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_SigningInstructions(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_SuggestedSigner(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_SuggestedSigner2(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_get_SuggestedSignerEmail(TElOfficeOpenXMLSignatureLineHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLSignatureLine_Create(TElOfficeOpenXMLPackageHandle APackage, TElOfficeOpenXMLSignatureLineHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLSIGNATURELINE */

#ifdef SB_USE_CLASS_TELOFFICEOPENXMLDOCUMENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_Close(TElOfficeOpenXMLDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_EncryptTo(TElOfficeOpenXMLDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_get_DocumentType(TElOfficeOpenXMLDocumentHandle _Handle, TSBOfficeOpenXMLDocumentTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_get_OfficeDocumentPart(TElOfficeOpenXMLDocumentHandle _Handle, TElOfficePackagePartHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_get_EncryptionHandler(TElOfficeOpenXMLDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_set_EncryptionHandler(TElOfficeOpenXMLDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_get_OwnEncryptionHandler(TElOfficeOpenXMLDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_set_OwnEncryptionHandler(TElOfficeOpenXMLDocumentHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_get_SignatureLineCount(TElOfficeOpenXMLDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_get_SignatureLines(TElOfficeOpenXMLDocumentHandle _Handle, int32_t Index, TElOfficeOpenXMLSignatureLineHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXMLDocument_Create(TElOfficeOpenXMLDocumentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXMLDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREDEFINITION
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_Intent(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_Intent(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_PageURI(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_PageURI(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_SignBy(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_SignByUTC(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_SignByUTC(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_SigningLocation(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_SigningLocation(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_SignerName(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_SignerName(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_SpotID(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_SpotID(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_SpotIDGUID(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, TGuid * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_SpotIDGUID(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, TGuid * Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_StartX(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_StartX(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, double Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_get_StartY(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_set_StartY(TElOfficeOpenXPSSignatureDefinitionHandle _Handle, double Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSSignatureDefinition_Create(TElOfficeOpenXMLPackageHandle APackage, TElOfficeOpenXPSSignatureDefinitionHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSSIGNATUREDEFINITION */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSPAGECONTENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSPageContent_get_Package(TElOfficeOpenXPSPageContentHandle _Handle, TElOfficeOpenXMLPackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSPageContent_get_Source(TElOfficeOpenXPSPageContentHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSPageContent_get_Width(TElOfficeOpenXPSPageContentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSPageContent_get_Height(TElOfficeOpenXPSPageContentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSPageContent_Create(TElOfficeOpenXMLPackageHandle APackage, TElOfficeOpenXPSPageContentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSPAGECONTENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSFIXEDDOCUMENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSFixedDocument_get_Package(TElOfficeOpenXPSFixedDocumentHandle _Handle, TElOfficeOpenXMLPackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSFixedDocument_get_URI(TElOfficeOpenXPSFixedDocumentHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSFixedDocument_get_Count(TElOfficeOpenXPSFixedDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSFixedDocument_get_PageContents(TElOfficeOpenXPSFixedDocumentHandle _Handle, int32_t Index, TElOfficeOpenXPSPageContentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSFixedDocument_Create(TElOfficeOpenXMLPackageHandle APackage, TElOfficeOpenXPSFixedDocumentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSFIXEDDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEOPENXPSDOCUMENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_AddSignatureDefinition(TElOfficeOpenXPSDocumentHandle _Handle, const char * pcIntent, int32_t szIntent, const char * pcSignerName, int32_t szSignerName, const char * pcSignerLocation, int32_t szSignerLocation, int64_t SignBy, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_AddSignatureDefinition_1(TElOfficeOpenXPSDocumentHandle _Handle, const char * pcIntent, int32_t szIntent, const char * pcSignerName, int32_t szSignerName, const char * pcSignerLocation, int32_t szSignerLocation, int64_t SignBy, const char * pcPageURI, int32_t szPageURI, double StartX, double StartY, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_AddSignatureDefinition_2(TElOfficeOpenXPSDocumentHandle _Handle, TElOfficeOpenXPSSignatureDefinitionHandle SigDef, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_Close(TElOfficeOpenXPSDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_get_FixedDocumentCount(TElOfficeOpenXPSDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_get_SignatureDefinitionCount(TElOfficeOpenXPSDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_get_FixedDocuments(TElOfficeOpenXPSDocumentHandle _Handle, int32_t Index, TElOfficeOpenXPSFixedDocumentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_get_SignatureDefinitions(TElOfficeOpenXPSDocumentHandle _Handle, int32_t Index, TElOfficeOpenXPSSignatureDefinitionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeOpenXPSDocument_Create(TElOfficeOpenXPSDocumentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEOPENXPSDOCUMENT */

#ifdef SB_USE_CLASS_TELOPENOFFICEDOCUMENT
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Open(TElOpenOfficeDocumentHandle _Handle, TElOpenOfficePackageHandle APackage);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Open_1(TElOpenOfficeDocumentHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Open_2(TElOpenOfficeDocumentHandle _Handle, TStreamHandle Stream, int8_t OwnStream);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Open_3(TElOpenOfficeDocumentHandle _Handle, TStreamHandle Stream, int8_t OwnStream, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Open_4(TElOpenOfficeDocumentHandle _Handle, TStreamHandle Stream, int64_t StreamOffset, int8_t OwnStream, int8_t ReadOnly, TElZipReaderHandle ZipReader);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Close(TElOpenOfficeDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Flush(TElOpenOfficeDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_DecryptTo(TElOpenOfficeDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_EncryptTo(TElOpenOfficeDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_AddSignature(TElOpenOfficeDocumentHandle _Handle, TElOpenOfficeCustomSignatureHandlerHandle Handler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_AddSignature_1(TElOpenOfficeDocumentHandle _Handle, TElOpenOfficeCustomSignatureHandlerHandle Handler, int8_t OwnHandler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_RemoveSignature(TElOpenOfficeDocumentHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_CompleteAsyncSign(TElOpenOfficeDocumentHandle _Handle, TElOpenOfficeCustomSignatureHandlerHandle Handler, TElDCAsyncStateHandle State);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_DocumentType(TElOpenOfficeDocumentHandle _Handle, TSBOpenOfficeDocumentTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_Encryptable(TElOpenOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_Signable(TElOpenOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_IsEncrypted(TElOpenOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_IsSigned(TElOpenOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_EncryptionHandler(TElOpenOfficeDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_set_EncryptionHandler(TElOpenOfficeDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_OwnEncryptionHandler(TElOpenOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_set_OwnEncryptionHandler(TElOpenOfficeDocumentHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_SignatureHandlerCount(TElOpenOfficeDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_SignatureHandlers(TElOpenOfficeDocumentHandle _Handle, int32_t Index, TElOpenOfficeCustomSignatureHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_Package(TElOpenOfficeDocumentHandle _Handle, TElOpenOfficePackageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_OnCreateTemporaryStream(TElOpenOfficeDocumentHandle _Handle, TSBOfficeCreateTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_set_OnCreateTemporaryStream(TElOpenOfficeDocumentHandle _Handle, TSBOfficeCreateTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_get_OnCloseTemporaryStream(TElOpenOfficeDocumentHandle _Handle, TSBOfficeCloseTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_set_OnCloseTemporaryStream(TElOpenOfficeDocumentHandle _Handle, TSBOfficeCloseTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElOpenOfficeDocument_Create(TElOpenOfficeDocumentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOPENOFFICEDOCUMENT */

#ifdef SB_USE_CLASS_TELOFFICEDOCUMENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Open(TElOfficeDocumentHandle _Handle, const char * pcFileName, int32_t szFileName);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Open_1(TElOfficeDocumentHandle _Handle, const char * pcFileName, int32_t szFileName, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Open_2(TElOfficeDocumentHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Open_3(TElOfficeDocumentHandle _Handle, TStreamHandle Stream, int8_t OwnStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Open_4(TElOfficeDocumentHandle _Handle, TStreamHandle Stream, int8_t OwnStream, int8_t ReadOnly);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Close(TElOfficeDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Flush(TElOfficeDocumentHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_DecryptTo(TElOfficeDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_EncryptTo(TElOfficeDocumentHandle _Handle, TStreamHandle NewStream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_AddSignature(TElOfficeDocumentHandle _Handle, TElOfficeCustomSignatureHandlerHandle Handler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_AddSignature_1(TElOfficeDocumentHandle _Handle, TElOfficeCustomSignatureHandlerHandle Handler, int8_t OwnHandler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_RemoveSignature(TElOfficeDocumentHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_CompleteAsyncSign(TElOfficeDocumentHandle _Handle, TElOfficeCustomSignatureHandlerHandle Handler, TElDCAsyncStateHandle State);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_DocumentFormat(TElOfficeDocumentHandle _Handle, TSBOfficeDocumentFormatRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_IsEncrypted(TElOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_IsSigned(TElOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_Encryptable(TElOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_Signable(TElOfficeDocumentHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_SignatureHandlerCount(TElOfficeDocumentHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_SignatureHandlers(TElOfficeDocumentHandle _Handle, int32_t Index, TElOfficeCustomSignatureHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_BinaryDocument(TElOfficeDocumentHandle _Handle, TElOfficeBinaryDocumentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_OpenXMLDocument(TElOfficeDocumentHandle _Handle, TElOfficeOpenXMLDocumentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_OpenXPSDocument(TElOfficeDocumentHandle _Handle, TElOfficeOpenXPSDocumentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_OpenDocument(TElOfficeDocumentHandle _Handle, TElOpenOfficeDocumentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_EncryptionHandler(TElOfficeDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_set_EncryptionHandler(TElOfficeDocumentHandle _Handle, TElOfficeCustomEncryptionHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_OnCreateTemporaryStream(TElOfficeDocumentHandle _Handle, TSBOfficeCreateTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_set_OnCreateTemporaryStream(TElOfficeDocumentHandle _Handle, TSBOfficeCreateTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_get_OnCloseTemporaryStream(TElOfficeDocumentHandle _Handle, TSBOfficeCloseTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_set_OnCloseTemporaryStream(TElOfficeDocumentHandle _Handle, TSBOfficeCloseTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocument_Create(TComponentHandle AOwner, TElOfficeDocumentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDOCUMENT */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElOfficeSecurityHandlerClass_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLSignatureView_ce_ptr;
extern zend_class_entry *TElOfficeCustomSecurityHandler_ce_ptr;
extern zend_class_entry *TElOfficeCustomEncryptionHandler_ce_ptr;
extern zend_class_entry *TElOfficeBinaryCustomEncryptionHandler_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLCustomEncryptionHandler_ce_ptr;
extern zend_class_entry *TElOpenOfficeCustomEncryptionHandler_ce_ptr;
extern zend_class_entry *TElOfficeCustomSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeBinaryCustomSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeBinaryUnsupportedSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeBinaryInvalidSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLCustomSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLUnsupportedSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLInvalidSignatureHandler_ce_ptr;
extern zend_class_entry *TElOpenOfficeCustomSignatureHandler_ce_ptr;
extern zend_class_entry *TElOpenOfficeUnsupportedSignatureHandler_ce_ptr;
extern zend_class_entry *TElOpenOfficeInvalidSignatureHandler_ce_ptr;
extern zend_class_entry *TElOfficeBinaryDocument_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLPackage_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLSignatureLine_ce_ptr;
extern zend_class_entry *TElOfficeOpenXMLDocument_ce_ptr;
extern zend_class_entry *TElOfficeOpenXPSSignatureDefinition_ce_ptr;
extern zend_class_entry *TElOfficeOpenXPSPageContent_ce_ptr;
extern zend_class_entry *TElOfficeOpenXPSFixedDocument_ce_ptr;
extern zend_class_entry *TElOfficeOpenXPSDocument_ce_ptr;
extern zend_class_entry *TElOpenOfficeDocument_ce_ptr;
extern zend_class_entry *TElOfficeDocument_ce_ptr;

void Register_TElOfficeOpenXMLSignatureView(TSRMLS_D);
void Register_TElOfficeCustomSecurityHandler(TSRMLS_D);
void Register_TElOfficeCustomEncryptionHandler(TSRMLS_D);
void Register_TElOfficeBinaryCustomEncryptionHandler(TSRMLS_D);
void Register_TElOfficeOpenXMLCustomEncryptionHandler(TSRMLS_D);
void Register_TElOpenOfficeCustomEncryptionHandler(TSRMLS_D);
void Register_TElOfficeCustomSignatureHandler(TSRMLS_D);
void Register_TElOfficeBinaryCustomSignatureHandler(TSRMLS_D);
void Register_TElOfficeBinaryUnsupportedSignatureHandler(TSRMLS_D);
void Register_TElOfficeBinaryInvalidSignatureHandler(TSRMLS_D);
void Register_TElOfficeOpenXMLCustomSignatureHandler(TSRMLS_D);
void Register_TElOfficeOpenXMLUnsupportedSignatureHandler(TSRMLS_D);
void Register_TElOfficeOpenXMLInvalidSignatureHandler(TSRMLS_D);
void Register_TElOpenOfficeCustomSignatureHandler(TSRMLS_D);
void Register_TElOpenOfficeUnsupportedSignatureHandler(TSRMLS_D);
void Register_TElOpenOfficeInvalidSignatureHandler(TSRMLS_D);
void Register_TElOfficeBinaryDocument(TSRMLS_D);
void Register_TElOfficeOpenXMLPackage(TSRMLS_D);
void Register_TElOfficeOpenXMLSignatureLine(TSRMLS_D);
void Register_TElOfficeOpenXMLDocument(TSRMLS_D);
void Register_TElOfficeOpenXPSSignatureDefinition(TSRMLS_D);
void Register_TElOfficeOpenXPSPageContent(TSRMLS_D);
void Register_TElOfficeOpenXPSFixedDocument(TSRMLS_D);
void Register_TElOfficeOpenXPSDocument(TSRMLS_D);
void Register_TElOpenOfficeDocument(TSRMLS_D);
void Register_TElOfficeDocument(TSRMLS_D);
SB_PHP_FUNCTION(SBOffice, RegisterSecurityHandler);
SB_PHP_FUNCTION(SBOffice, UnregisterSecurityHandler);
SB_PHP_FUNCTION(SBOffice, DocumentFormatToString);
SB_PHP_FUNCTION(SBOffice, BinaryDocumentTypeToString);
SB_PHP_FUNCTION(SBOffice, OpenXMLDocumentTypeToString);
SB_PHP_FUNCTION(SBOffice, OpenDocumentTypeToString);
SB_PHP_FUNCTION(SBOffice, IsSharedWorkbook);
SB_PHP_FUNCTION(SBOffice, Initialize);
void Register_SBOffice_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_OFFICE
SB_IMPORT uint32_t SB_APIENTRY SBOffice_RegisterSecurityHandler(TElOfficeSecurityHandlerClassHandle HandlerClass);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_UnregisterSecurityHandler(TElOfficeSecurityHandlerClassHandle HandlerClass);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_DocumentFormatToString(TSBOfficeDocumentFormatRaw DocumentFormat, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_BinaryDocumentTypeToString(TSBOfficeBinaryDocumentTypeRaw DocumentType, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_OpenXMLDocumentTypeToString(TSBOfficeOpenXMLDocumentTypeRaw DocumentType, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_OpenDocumentTypeToString(TSBOpenOfficeDocumentTypeRaw DocumentType, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_IsSharedWorkbook(TElCompoundFileStorageHandle Storage, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOffice_Initialize(void);
#endif /* SB_USE_GLOBAL_PROCS_OFFICE */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBOFFICE */

