#ifndef __INC_SBOFFICECONSTANTS
#define __INC_SBOFFICECONSTANTS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_OFFICE_ERROR_BASE 	733184
#define SB_OFFICE_ERROR_SECURITY_BASE 	733440
#define SB_OFFICE_ERROR_PACKAGE_BASE 	733696
#define SB_OFFICE_ERROR_BINARY_CORE_BASE 	733952
#define SB_OFFICE_ERROR_XML_CORE_BASE 	734208
#define SB_OFFICE_ERROR_INTERNAL_ERROR 	733185
#define SB_OFFICE_ERROR_NOT_IMPLEMENTED 	733186
#define SB_OFFICE_ERROR_INDEX_OUT_OF_BOUNDS 	733187
#define SB_OFFICE_ERROR_DOCUMENT_NOT_OPENED 	733195
#define SB_OFFICE_ERROR_DOCUMENT_NOT_ENCRYPTED 	733196
#define SB_OFFICE_ERROR_DOCUMENT_FORMAT_UNSUPPORTED_OPERATION 	733197
#define SB_OFFICE_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED 	733198
#define SB_OFFICE_ERROR_INVALID_DOCUMENT_FORMAT 	733199
#define SB_OFFICE_ERROR_INVALID_DOCUMENT_TYPE 	733200
#define SB_OFFICE_ERROR_INVALID_SIGNATURE_HANDLER 	733201
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_HANDLER 	733202
#define SB_OFFICE_ERROR_ENCRYPTION_HANDLER_CHANGE_FAILED 	733203
#define SB_OFFICE_ERROR_SIGNATURE_CALCULATED_CANT_ATTACH 	733204
#define SB_OFFICE_ERROR_SIGNATURE_HANDLER_NOT_ATTACHED 	733205
#define SB_OFFICE_ERROR_CANT_ATTACH_SIGNATURE 	733206
#define SB_OFFICE_ERROR_SIGNATURE_CALCULATED_CANT_DETACH 	733207
#define SB_OFFICE_ERROR_SHARED_WORKBOOK_CANT_SIGN 	733208
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_STREAM 	733209
#define SB_OFFICE_ERROR_INVALID_USER_EDIT_ATOM 	733210
#define SB_OFFICE_ERROR_INVALID_PERSIST_DIRECTORY_ATOM 	733211
#define SB_OFFICE_ERROR_ENCRYPTED_PACKAGE_ENTRY_NOT_FOUND 	733212
#define SB_OFFICE_ERROR_ENCRYPTION_HANDLER_CANT_ENCRYPT_DOCUMENT 	733213
#define SB_OFFICE_ERROR_WORKBOOK_BOF_RECORD_NOT_FOUND 	733214
#define SB_OFFICE_ERROR_ENCRYPTION_FAILED_DOCUMENT_ENCRYPTED 	733215
#define SB_OFFICE_ERROR_ENCRYPTION_FAILED_DOCUMENT_SIGNED 	733216
#define SB_OFFICE_ERROR_INVALID_ART_BSTORE_CONTAINER_FILE_BLOCK 	733217
#define SB_OFFICE_ERROR_UNSUPPORTED_ART_BSTORE_CONTAINER_FILE_BLOCK 	733218
#define SB_OFFICE_ERROR_DATA_SPACES_VERSION_ENTRY_NOT_FOUND 	733219
#define SB_OFFICE_ERROR_DATA_SPACE_MAP_ENTRY_NOT_FOUND 	733220
#define SB_OFFICE_ERROR_DATA_SPACE_INFO_ENTRY_NOT_FOUND 	733221
#define SB_OFFICE_ERROR_DATA_SPACES_TRANSFORM_INFO_ENTRY_NOT_FOUND 	733222
#define SB_OFFICE_ERROR_STRONG_ENCRYPTION_DATA_SPACE_ENTRY_NOT_FOUND 	733223
#define SB_OFFICE_ERROR_DATA_SPACES_STRONG_ENCRYPTION_TRANSFORM_NOT_FOUND 	733224
#define SB_OFFICE_ERROR_DATA_SPACES_STRONG_ENCRYPTION_TRANSFORM_PRIMARY_NOT_FOUND 	733225
#define SB_OFFICE_ERROR_INVALID_DATA_SPACE_DEFINITION_TRANSFORM_REFERENCE_ENTRY 	733226
#define SB_OFFICE_ERROR_INVALID_TRANSFORM_INFO_HEADER 	733227
#define SB_OFFICE_ERROR_ENCRYPTION_INFO_ENTRY_NOT_FOUND 	733228
#define SB_OFFICE_ERROR_INVALID_CURRENT_USER_STREAM_SIZE 	733229
#define SB_OFFICE_ERROR_CORRUPTED_PACKAGE_SIGNATURE 	733230
#define SB_OFFICE_ERROR_ORIGIN_PART_NOT_FOUND 	733231
#define SB_OFFICE_ERROR_DATA_READ_FAILED 	733232
#define SB_OFFICE_ERROR_FIXED_DOCUMENT_PART_NOT_FOUND 	733233
#define SB_OFFICE_ERROR_FIXED_DOCUMENT_SEQUENCE_PART_NOT_FOUND 	733234
#define SB_OFFICE_ERROR_INVALID_SIGNATURE_DEFINITION_PART 	733235
#define SB_OFFICE_ERROR_NO_SIGNATURE_DEFINITION 	733236
#define SB_OFFICE_ERROR_UNSUPPORTED_ALGORITHM 	733441
#define SB_OFFICE_ERROR_UNSUPPORTED_DIGEST_ALGORITHM 	733442
#define SB_OFFICE_ERROR_INVALID_CIPHER_MODE 	733443
#define SB_OFFICE_ERROR_INVALID_PASSWORD 	733444
#define SB_OFFICE_ERROR_INVALID_ENCRYPTED_PACKAGE_STREAM_SIZE_VALUE 	733445
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_HEADER_FLAGS 	733446
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_ALGORITHM 	733447
#define SB_OFFICE_ERROR_INVALID_DIGEST_ALGORITHM 	733448
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_ALGORITHM_KEY_SIZE 	733449
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_VERIFIER_SALT_SIZE 	733450
#define SB_OFFICE_ERROR_INVALID_SALT_SIZE 	733451
#define SB_OFFICE_ERROR_INVALID_BLOCK_SIZE 	733452
#define SB_OFFICE_ERROR_INVALID_HASH_SIZE 	733453
#define SB_OFFICE_ERROR_INVALID_SPIN_COUNT 	733454
#define SB_OFFICE_ERROR_INVALID_HMAC_KEY_SIZE 	733455
#define SB_OFFICE_ERROR_INVALID_CHECKSUM 	733456
#define SB_OFFICE_ERROR_INVALID_FILE_ENTRY_SIZE_VALUE 	733457
#define SB_OFFICE_ERROR_INVALID_VERIFIER_HASH_SIZE 	733458
#define SB_OFFICE_ERROR_INVALID_KEY_LENGTH 	733459
#define SB_OFFICE_ERROR_INSUFFICIENT_DATA 	733460
#define SB_OFFICE_ERROR_ENCRYPTED_PACKAGE_DATA_SIZE_READ_FAILED 	733461
#define SB_OFFICE_ERROR_ENCRYPTED_PACKAGE_DATA_SIZE_WRITE_FAILED 	733462
#define SB_OFFICE_ERROR_CANT_MODIFY_ENCRYPTION_HANDLER_PROPERTIES 	733463
#define SB_OFFICE_ERROR_CANT_MODIFY_SIGNATURE_PROPERTIES 	733464
#define SB_OFFICE_ERROR_CANT_MODIFY_KEY_ENCRYPTORS 	733465
#define SB_OFFICE_ERROR_PASSWORD_TOO_SHORT 	733466
#define SB_OFFICE_ERROR_PASSWORD_TOO_LONG 	733467
#define SB_OFFICE_ERROR_DATA_INTEGRITY_ERROR 	733468
#define SB_OFFICE_ERROR_FILE_ENTRY_NOT_ENCRYPTED 	733469
#define SB_OFFICE_ERROR_UNSUPPORTED_AUTO_INCREMENT_PARAMETER_VALUE 	733470
#define SB_OFFICE_ERROR_NO_CERTIFICATE 	733471
#define SB_OFFICE_ERROR_NO_KEY_DATA 	733472
#define SB_OFFICE_ERROR_SIGNATURE_CALCULATED_CANT_SIGN 	733473
#define SB_OFFICE_ERROR_PROTECTED_DOCUMENT_SIGN_UNSUPPORTED 	733474
#define SB_OFFICE_ERROR_SIGNATURE_NOT_CALCULATED_CANT_VALIDATE 	733475
#define SB_OFFICE_ERROR_NOTHING_TO_SIGN 	733476
#define SB_OFFICE_ERROR_PACKAGE_OBJECT_ELEMENT_NOT_FOUND 	733477
#define SB_OFFICE_ERROR_INVALID_PACKAGE_OBJECT_ELEMENT 	733478
#define SB_OFFICE_ERROR_INVALID_PACKAGE_PART_CONTENT_TYPE 	733479
#define SB_OFFICE_ERROR_INVALID_TRANSFORM_IN_PACKAGE_MANIFEST_ELEMENT 	733480
#define SB_OFFICE_ERROR_UNSUPPORTED_CERTIFICATE_PUBLIC_KEY_ALGORITHM 	733481
#define SB_OFFICE_ERROR_UNSUPPORTED_CANONICALIZATION_METHOD 	733482
#define SB_OFFICE_ERROR_NO_PACKAGE_PART 	733483
#define SB_OFFICE_ERROR_NO_RELATIONSHIPS 	733484
#define SB_OFFICE_ERROR_NO_SIGNED_PART 	733485
#define SB_OFFICE_ERROR_NO_SIGNED_ENTRY 	733486
#define SB_OFFICE_ERROR_SIGNED_PART_NOT_ATTACHED 	733487
#define SB_OFFICE_ERROR_PACKAGE_PART_NOT_FOUND 	733488
#define SB_OFFICE_ERROR_PACKAGE_ENTRY_NOT_FOUND 	733489
#define SB_OFFICE_ERROR_CANT_MODIFY_SIGNED_PARTS 	733490
#define SB_OFFICE_ERROR_CANT_MODIFY_SIGNED_ENTRIES 	733491
#define SB_OFFICE_ERROR_SIGNED_RELATIONSHIP_PART_EXISTS 	733492
#define SB_OFFICE_ERROR_SIGNED_PART_EXISTS 	733493
#define SB_OFFICE_ERROR_SIGNED_ENTRY_EXISTS 	733494
#define SB_OFFICE_ERROR_SIGNATURE_CALCULATED_CANT_EMBED_CERTIFICATE 	733495
#define SB_OFFICE_ERROR_CANT_COMPLETE_ASYNC_SIGN_NO_SIGNATURE 	733510
#define SB_OFFICE_ERROR_ASYNC_STATE_CERTIFICATE_LOAD_FAILED 	733511
#define SB_OFFICE_ERROR_BAD_ASYNC_STATE 	733512
#define SB_OFFICE_ERROR_PART_CREATE_FAILED_EXISTS 	733697
#define SB_OFFICE_ERROR_PART_CREATE_FAILED_READONLY 	733698
#define SB_OFFICE_ERROR_PART_DELETE_FAILED_READONLY 	733699
#define SB_OFFICE_ERROR_PART_STREAM_CREATE_FAILED_READONLY 	733700
#define SB_OFFICE_ERROR_PART_STREAM_DELETE_FAILED_READONLY 	733701
#define SB_OFFICE_ERROR_PACKAGE_DIRECTORY_NOT_EXISTS 	733702
#define SB_OFFICE_ERROR_CONTENT_TYPES_STREAM_NOT_FOUND 	733703
#define SB_OFFICE_ERROR_MANIFEST_STREAM_NOT_FOUND 	733704
#define SB_OFFICE_ERROR_MIMETYPE_STREAM_NOT_FOUND 	733705
#define SB_OFFICE_ERROR_STREAM_OPEN_FOR_WRITING_FAILED 	733706
#define SB_OFFICE_ERROR_STREAM_EXISTS 	733707
#define SB_OFFICE_ERROR_DUPLICATE_PART 	733708
#define SB_OFFICE_ERROR_INTERLEAVED_PART_STREAM_GET_FAILED 	733709
#define SB_OFFICE_ERROR_OUTPUT_BUFFER_TOO_SMALL 	733953
#define SB_OFFICE_ERROR_VALUE_READ_FAILED 	733954
#define SB_OFFICE_ERROR_VALUE_WRITE_FAILED 	733955
#define SB_OFFICE_ERROR_NO_STREAM_PARAMETER 	733956
#define SB_OFFICE_ERROR_INVALID_RESERVED_VALUE 	733957
#define SB_OFFICE_ERROR_INVALID_DATA_SPACES_FEATURE_IDENTIFIER 	733958
#define SB_OFFICE_ERROR_INVALID_DATA_SPACES_READER_VERSION 	733959
#define SB_OFFICE_ERROR_INVALID_DATA_SPACE_MAP_HEADER_LENGTH 	733960
#define SB_OFFICE_ERROR_INVALID_DATA_SPACE_MAP_ENTRY_LENGTH 	733961
#define SB_OFFICE_ERROR_INVALID_DATA_SPACE_DEFINITION_HEADER_LENGTH 	733962
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_HEADER_SIZE_EXTRA 	733963
#define SB_OFFICE_ERROR_INVALID_ENCRYPTION_HEADER_LENGTH 	733964
#define SB_OFFICE_ERROR_INVALID_BIN_ENCRYPTION_VERIFIER_SALT_SIZE 	733965
#define SB_OFFICE_ERROR_INVALID_ENCRYPTED_STREAM_NAME_LENGTH 	733966
#define SB_OFFICE_ERROR_INVALID_CERTIFICATE_INFO_SIZE 	733967
#define SB_OFFICE_ERROR_INVALID_CERTIFICATE_INFO_VERSION 	733968
#define SB_OFFICE_ERROR_INVALID_CERTIFICATE_INFO_SIGNER_NAME_LENGTH 	733969
#define SB_OFFICE_ERROR_INVALID_CERTIFICATE_INFO_ISSUER_NAME_LENGTH 	733970
#define SB_OFFICE_ERROR_INVALID_DOC_SIG_SERIALIZED_CERT_STORE_VERSION 	733971
#define SB_OFFICE_ERROR_INVALID_DOC_SIG_SERIALIZED_CERT_STORE_FILE_TYPE 	733972
#define SB_OFFICE_ERROR_INVALID_INTERMEDIATE_CERTIFICATES_STORE_SIZE 	733973
#define SB_OFFICE_ERROR_INVALID_END_ELEMENT_MARKER_ENTRY 	733974
#define SB_OFFICE_ERROR_INVALID_PERSIST_DIRECTORY_ENTRY 	733975
#define SB_OFFICE_ERROR_INVALID_RECORD_SIZE 	733976
#define SB_OFFICE_ERROR_INVALID_LOGICAL_ITEM_SUFFIX_NAME 	734209
#define SB_OFFICE_ERROR_INVALID_XML_ELEMENT 	734210
#define SB_OFFICE_ERROR_NO_XML_ELEMENT_PARAMETER 	734211
#define SB_OFFICE_ERROR_NO_XML_DOCUMENT_PARAMETER 	734212
#define SB_OFFICE_ERROR_INVALID_KEY_ENCRYPTOR_XML_ELEMENT 	734213
#define SB_OFFICE_ERROR_SIGNATURE_INFO_V1_NO_REQUIRED_ELEMENT 	734214
#define SB_OFFICE_ERROR_NEGATIVE_INTEGER 	734215
#define SB_OFFICE_ERROR_VERSION_STRING_TOO_LONG 	734216
#define SB_OFFICE_ERROR_SIGNATURE_COMMENTS_STRING_TOO_LONG 	734217
#define SB_OFFICE_ERROR_SIGNATURE_PROVIDER_URL_STRING_TOO_LONG 	734218
#define SB_OFFICE_ERROR_SIGNATURE_TEXT_STRING_TOO_LONG 	734219
#define SB_OFFICE_SIGNATURE_PROVIDER_DETAILS_NO_RESTRICTION 	0
#define SB_OFFICE_SIGNATURE_PROVIDER_DETAILS_UI 	1
#define SB_OFFICE_SIGNATURE_PROVIDER_DETAILS_INVISIBLE 	2
#define SB_OFFICE_SIGNATURE_PROVIDER_DETAILS_VISIBLE 	4
#define SB_OFFICE_SIGNATURE_PROVIDER_DETAILS_APPLICATION_UI 	8
#define SB_OFFICE_SIGNATURE_PROVIDER_DETAILS_APPLICATION_STAMP_UI 	16
#define SB_OFFICE_SIGNATURE_PROVIDER_ID_DEFAULT 	"{00000000-0000-0000-0000-000000000000}"
#define SB_OFFICE_SIGNATURE_PROVIDER_ID_EAST_ASIAN 	"{000CD6A4-0000-0000-C000-000000000046}"
#define SB_OFFICE_SIGNATURE_TYPE_NO_PRINT 	1
#define SB_OFFICE_SIGNATURE_TYPE_PRINT 	2
#define SB_OFFICE_BINARY_SIGNATURE_HANDLER_TYPE_CRYPTOAPI 	"urn:schemas-eldos-com:signatures"
#define SB_OFFICE_BINARY_SIGNATURE_HANDLER_TYPE_XML 	"urn:schemas-eldos-com:xmlsignatures"

#ifdef __cplusplus
};	/* extern "C" */
#endif

void Register_SBOfficeConstants_Constants(int module_number TSRMLS_DC);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBOFFICECONSTANTS */

