#ifndef __INC_SBPGPENTITIES
#define __INC_SBPGPENTITIES

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbpgpexceptions.h"
#include "sbpgpconstants.h"
#include "sbpgputils.h"
#include "sbmath.h"
#include "sbx509.h"
#include "sbstreams.h"
#include "sbstrutils.h"
#include "sbconstants.h"
#include "sbtypes.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_PGP_BLOCK_SIZE 	65536
#define SB_PGP_PACKET_BLOCK_BASE_SIZE 	13
#define SB_PGP_PACKET_BLOCK_SIZE 	8192

typedef TElClassHandle TElPGPEntityHandle;

typedef TElPGPEntityHandle ElPGPEntityHandle;

typedef TElClassHandle TElPGPSecretKeyEntityHandle;

typedef TElPGPSecretKeyEntityHandle ElPGPSecretKeyEntityHandle;

typedef TElClassHandle TElPGPS2KHandle;

typedef TElPGPS2KHandle ElPGPS2KHandle;

typedef TElClassHandle TElPGPUserIDEntityHandle;

typedef TElPGPUserIDEntityHandle ElPGPUserIDEntityHandle;

typedef TElClassHandle TElPGPUserAttrSubpacketHandle;

typedef TElPGPUserAttrSubpacketHandle ElPGPUserAttrSubpacketHandle;

typedef TElClassHandle TElPGPUserAttrImageSubpacketHandle;

typedef TElPGPUserAttrImageSubpacketHandle ElPGPUserAttrImageSubpacketHandle;

typedef TElClassHandle TElPGPUserAttrEntityHandle;

typedef TElPGPUserAttrEntityHandle ElPGPUserAttrEntityHandle;

typedef TElClassHandle TElPGPSignatureEntityHandle;

typedef TElPGPSignatureEntityHandle ElPGPSignatureEntityHandle;

typedef TElClassHandle TElPGPSignatureSubpacketHandle;

typedef TElPGPSignatureSubpacketHandle ElPGPSignatureSubpacketHandle;

typedef TElClassHandle TElPGPCreationTimeSignatureSubpacketHandle;

typedef TElPGPCreationTimeSignatureSubpacketHandle ElPGPCreationTimeSignatureSubpacketHandle;

typedef TElClassHandle TElPGPExpirationTimeSignatureSubpacketHandle;

typedef TElPGPExpirationTimeSignatureSubpacketHandle ElPGPExpirationTimeSignatureSubpacketHandle;

typedef TElClassHandle TElPGPEmbeddedSignatureSignatureSubpacketHandle;

typedef TElPGPEmbeddedSignatureSignatureSubpacketHandle ElPGPEmbeddedSignatureSignatureSubpacketHandle;

typedef TElClassHandle TElPGPExportableCertificationSignatureSubpacketHandle;

typedef TElPGPExportableCertificationSignatureSubpacketHandle ElPGPExportableCertificationSignatureSubpacketHandle;

typedef TElClassHandle TElPGPTrustSignatureSubpacketHandle;

typedef TElPGPTrustSignatureSubpacketHandle ElPGPTrustSignatureSubpacketHandle;

typedef TElClassHandle TElPGPRegularExpressionSignatureSubpacketHandle;

typedef TElPGPRegularExpressionSignatureSubpacketHandle ElPGPRegularExpressionSignatureSubpacketHandle;

typedef TElClassHandle TElPGPRevocableSignatureSubpacketHandle;

typedef TElPGPRevocableSignatureSubpacketHandle ElPGPRevocableSignatureSubpacketHandle;

typedef TElClassHandle TElPGPKeyExpirationTimeSignatureSubpacketHandle;

typedef TElPGPKeyExpirationTimeSignatureSubpacketHandle ElPGPKeyExpirationTimeSignatureSubpacketHandle;

typedef TElClassHandle TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle;

typedef TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle ElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle;

typedef TElClassHandle TElPGPRevocationKeySignatureSubpacketHandle;

typedef TElPGPRevocationKeySignatureSubpacketHandle ElPGPRevocationKeySignatureSubpacketHandle;

typedef TElClassHandle TElPGPIssuerKeyIDSignatureSubpacketHandle;

typedef TElPGPIssuerKeyIDSignatureSubpacketHandle ElPGPIssuerKeyIDSignatureSubpacketHandle;

typedef TElClassHandle TElPGPNotationDataSignatureSubpacketHandle;

typedef TElPGPNotationDataSignatureSubpacketHandle ElPGPNotationDataSignatureSubpacketHandle;

typedef TElClassHandle TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle;

typedef TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle ElPGPPreferredHashAlgorithmsSignatureSubpacketHandle;

typedef TElClassHandle TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle;

typedef TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle ElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle;

typedef TElClassHandle TElPGPKeyServerPreferencesSignatureSubpacketHandle;

typedef TElPGPKeyServerPreferencesSignatureSubpacketHandle ElPGPKeyServerPreferencesSignatureSubpacketHandle;

typedef TElClassHandle TElPGPPreferredKeyServerSignatureSubpacketHandle;

typedef TElPGPPreferredKeyServerSignatureSubpacketHandle ElPGPPreferredKeyServerSignatureSubpacketHandle;

typedef TElClassHandle TElPGPPrimaryUserIDSignatureSubpacketHandle;

typedef TElPGPPrimaryUserIDSignatureSubpacketHandle ElPGPPrimaryUserIDSignatureSubpacketHandle;

typedef TElClassHandle TElPGPPolicyURLSignatureSubpacketHandle;

typedef TElPGPPolicyURLSignatureSubpacketHandle ElPGPPolicyURLSignatureSubpacketHandle;

typedef TElClassHandle TElPGPKeyFlagsSignatureSubpacketHandle;

typedef TElPGPKeyFlagsSignatureSubpacketHandle ElPGPKeyFlagsSignatureSubpacketHandle;

typedef TElClassHandle TElPGPSignersUserIDSignatureSubpacketHandle;

typedef TElPGPSignersUserIDSignatureSubpacketHandle ElPGPSignersUserIDSignatureSubpacketHandle;

typedef TElClassHandle TElPGPReasonForRevocationSignatureSubpacketHandle;

typedef TElPGPReasonForRevocationSignatureSubpacketHandle ElPGPReasonForRevocationSignatureSubpacketHandle;

typedef TElClassHandle TElPGPFeaturesSignatureSubpacketHandle;

typedef TElPGPFeaturesSignatureSubpacketHandle ElPGPFeaturesSignatureSubpacketHandle;

typedef TElClassHandle TElPGPTargetSignatureSubpacketHandle;

typedef TElPGPTargetSignatureSubpacketHandle ElPGPTargetSignatureSubpacketHandle;

typedef TElClassHandle TElPGPX509SignatureSubpacketHandle;

typedef TElPGPX509SignatureSubpacketHandle ElPGPX509SignatureSubpacketHandle;

typedef TElClassHandle TElPGPSignatureSubpacketsHandle;

typedef TElPGPSignatureSubpacketsHandle ElPGPSignatureSubpacketsHandle;

typedef TElClassHandle TElPGPTrustEntityHandle;

typedef TElPGPTrustEntityHandle ElPGPTrustEntityHandle;

typedef TElClassHandle TElPGPPublicKeyEncryptedSessionKeyEntityHandle;

typedef TElPGPPublicKeyEncryptedSessionKeyEntityHandle ElPGPPublicKeyEncryptedSessionKeyEntityHandle;

typedef TElClassHandle TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle;

typedef TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle ElPGPSymmetricKeyEncryptedSessionKeyEntityHandle;

typedef TElClassHandle TElPGPOnePassSignatureEntityHandle;

typedef TElPGPOnePassSignatureEntityHandle ElPGPOnePassSignatureEntityHandle;

typedef TElClassHandle TElPGPPublicKeyEntityHandle;

typedef TElPGPPublicKeyEntityHandle ElPGPPublicKeyEntityHandle;

typedef TElClassHandle TElPGPStreamingEntityHandle;

typedef TElPGPStreamingEntityHandle ElPGPStreamingEntityHandle;

typedef TElClassHandle TElPGPLiteralHandle;

typedef TElPGPLiteralHandle ElPGPLiteralHandle;

typedef TElClassHandle TElPGPSymmetricallyEncryptedHandle;

typedef TElPGPSymmetricallyEncryptedHandle ElPGPSymmetricallyEncryptedHandle;

typedef TElClassHandle TElPGPCompressedHandle;

typedef TElPGPCompressedHandle ElPGPCompressedHandle;

typedef TElClassHandle TElPGPStreamProcessorHandle;

typedef TElPGPStreamProcessorHandle ElPGPStreamProcessorHandle;

typedef TElClassHandle TElPGPStubEntityHandle;

typedef TElPGPStubEntityHandle ElPGPStubEntityHandle;

typedef TElClassHandle TElPGPStreamIOHandle;

typedef uint8_t TSBPGPLoadStateRaw;

typedef enum
{
	lsHeader = 0,
	lsOldPacketLen = 1,
	lsNewPacketLen = 2,
	lsChunk = 3,
	lsUndefSizeChunk = 4,
	lsLastChunk = 5,
	_lsFinished = 6
} TSBPGPLoadState;

typedef uint8_t TSBPGPReasonForRevocationRaw;

typedef enum
{
	rrNoReason = 0,
	rrKeySuperseded = 1,
	rrKeyCompromised = 2,
	rrKeyRetired = 3,
	rrUserIDNotValid = 4
} TSBPGPReasonForRevocation;

typedef void (SB_CALLBACK *TSBPGPReadEvent)(void * _ObjectData, TObjectHandle Sender, void * UserData, void * Buffer, int32_t MaxSize, int32_t * Written, int8_t * Last);

typedef void (SB_CALLBACK *TSBPGPWriteEvent)(void * _ObjectData, TObjectHandle Sender, void * UserData, void * Buffer, int32_t Size);

typedef void (SB_CALLBACK *TSBPGPPacketEvent)(void * _ObjectData, TObjectHandle Sender, uint8_t PacketType, TElPGPEntityHandle * Entity, int8_t * Stop);

typedef void (SB_CALLBACK *TSBPGPPacketProcessedEvent)(void * _ObjectData, TObjectHandle Sender, TElPGPEntityHandle Packet, int8_t * Continue);

typedef void (SB_CALLBACK *TSBPGPTemporaryStreamEvent)(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream, int8_t * FreeOnFinish);

#ifdef SB_USE_CLASS_TELPGPENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_Assign(TElPGPEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_AssignTo(TElPGPEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_Load(TElPGPEntityHandle _Handle, void * AReadUserData, void * AWriteUserData);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_Save(TElPGPEntityHandle _Handle, void * AReadUserData, void * AWriteUserData);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_DataAvailable(TElPGPEntityHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_LoadFromStream(TElPGPEntityHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_SaveToStream(TElPGPEntityHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_WriteFlags(TElPGPEntityHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_WriteFlags(TElPGPEntityHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_AsyncMode(TElPGPEntityHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_AsyncMode(TElPGPEntityHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_PacketType(TElPGPEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_BytesLeft(TElPGPEntityHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_OldPacket(TElPGPEntityHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_OldPacket(TElPGPEntityHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_ForceUndefLenProcessing(TElPGPEntityHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_ForceUndefLenProcessing(TElPGPEntityHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_OnRead(TElPGPEntityHandle _Handle, TSBPGPReadEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_OnRead(TElPGPEntityHandle _Handle, TSBPGPReadEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_OnWrite(TElPGPEntityHandle _Handle, TSBPGPWriteEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_OnWrite(TElPGPEntityHandle _Handle, TSBPGPWriteEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_get_OnFinish(TElPGPEntityHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_set_OnFinish(TElPGPEntityHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntity_Create(TElPGPEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPENTITY */

#ifdef SB_USE_CLASS_TELPGPPUBLICKEYENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_Assign(TElPGPPublicKeyEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_AssignTo(TElPGPPublicKeyEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_AssignFromSecret(TElPGPPublicKeyEntityHandle _Handle, TElPGPSecretKeyEntityHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_Timestamp(TElPGPPublicKeyEntityHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_Timestamp(TElPGPPublicKeyEntityHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_Expires(TElPGPPublicKeyEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_Expires(TElPGPPublicKeyEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_PublicKeyAlgorithm(TElPGPPublicKeyEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_PublicKeyAlgorithm(TElPGPPublicKeyEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_KeyMaterial(TElPGPPublicKeyEntityHandle _Handle, int32_t Index, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_KeyMaterial(TElPGPPublicKeyEntityHandle _Handle, int32_t Index, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_Version(TElPGPPublicKeyEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_Version(TElPGPPublicKeyEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_CurveOID(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_CurveOID(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_KDFHashAlgorithm(TElPGPPublicKeyEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_KDFHashAlgorithm(TElPGPPublicKeyEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_KEKSymmetricAlgorithm(TElPGPPublicKeyEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_KEKSymmetricAlgorithm(TElPGPPublicKeyEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_RSAPublicModulus(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_RSAPublicModulus(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_RSAPublicExponent(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_RSAPublicExponent(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_DSAPublicPrime(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_DSAPublicPrime(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_DSAPublicGroupOrder(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_DSAPublicGroupOrder(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_DSAPublicGroupGenerator(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_DSAPublicGroupGenerator(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_DSAPublicKeyValue(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_DSAPublicKeyValue(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_ElGamalPrime(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_ElGamalPrime(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_ElGamalGroupGenerator(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_ElGamalGroupGenerator(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_ElGamalPublicKeyValue(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_ElGamalPublicKeyValue(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_get_ECPublicKey(TElPGPPublicKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_set_ECPublicKey(TElPGPPublicKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_Create(TElPGPPublicKeyEntityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEntity_Create_1(int8_t Subkey, TElPGPPublicKeyEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPUBLICKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPS2K
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_Assign(TElPGPS2KHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_AssignTo(TElPGPS2KHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_Load(TElPGPS2KHandle _Handle, const uint8_t pBuffer[], int32_t szBuffer, int32_t Offset, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_Save(TElPGPS2KHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_GetSymmetricKey(TElPGPS2KHandle _Handle, const char * pcPassphrase, int32_t szPassphrase, int32_t Needed, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_get_S2KType(TElPGPS2KHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_set_S2KType(TElPGPS2KHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_get_Salt(TElPGPS2KHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_set_Salt(TElPGPS2KHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_get_Count(TElPGPS2KHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_set_Count(TElPGPS2KHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_get_HashAlgorithm(TElPGPS2KHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_set_HashAlgorithm(TElPGPS2KHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPS2K_Create(TElPGPS2KHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPS2K */

#ifdef SB_USE_CLASS_TELPGPUSERIDENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserIDEntity_Assign(TElPGPUserIDEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserIDEntity_AssignTo(TElPGPUserIDEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserIDEntity_get_Name(TElPGPUserIDEntityHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserIDEntity_set_Name(TElPGPUserIDEntityHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserIDEntity_Create(TElPGPUserIDEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPUSERIDENTITY */

#ifdef SB_USE_CLASS_TELPGPUSERATTRSUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrSubpacket_Assign(TElPGPUserAttrSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrSubpacket_AssignTo(TElPGPUserAttrSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrSubpacket_Compare(TElPGPUserAttrSubpacketHandle _Handle, TElPGPUserAttrSubpacketHandle Source, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrSubpacket_get_SubpacketType(TElPGPUserAttrSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrSubpacket_set_SubpacketType(TElPGPUserAttrSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrSubpacket_Create(TElPGPUserAttrSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPUSERATTRSUBPACKET */

#ifdef SB_USE_CLASS_TELPGPUSERATTRIMAGESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_Assign(TElPGPUserAttrImageSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_AssignTo(TElPGPUserAttrImageSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_Compare(TElPGPUserAttrImageSubpacketHandle _Handle, TElPGPUserAttrSubpacketHandle Source, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_get_HeaderVersion(TElPGPUserAttrImageSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_set_HeaderVersion(TElPGPUserAttrImageSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_get_ImageFormat(TElPGPUserAttrImageSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_set_ImageFormat(TElPGPUserAttrImageSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_get_ImageData(TElPGPUserAttrImageSubpacketHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_set_ImageData(TElPGPUserAttrImageSubpacketHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrImageSubpacket_Create(TElPGPUserAttrImageSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPUSERATTRIMAGESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPUSERATTRENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrEntity_Assign(TElPGPUserAttrEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrEntity_AssignTo(TElPGPUserAttrEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrEntity_get_Subpackets(TElPGPUserAttrEntityHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUserAttrEntity_Create(TElPGPUserAttrEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPUSERATTRENTITY */

#ifdef SB_USE_CLASS_TELPGPSIGNATUREENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_Assign(TElPGPSignatureEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_AssignTo(TElPGPSignatureEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_Version(TElPGPSignatureEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_Version(TElPGPSignatureEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_SignatureClass(TElPGPSignatureEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_SignatureClass(TElPGPSignatureEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_CreationTime(TElPGPSignatureEntityHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_CreationTime(TElPGPSignatureEntityHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_KeyID(TElPGPSignatureEntityHandle _Handle, TSBKeyID * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_KeyID(TElPGPSignatureEntityHandle _Handle, TSBKeyID * Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_PublicKeyAlgorithm(TElPGPSignatureEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_PublicKeyAlgorithm(TElPGPSignatureEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_HashAlgorithm(TElPGPSignatureEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_HashAlgorithm(TElPGPSignatureEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_Subpackets(TElPGPSignatureEntityHandle _Handle, TElPGPSignatureSubpacketsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_SignatureMaterial(TElPGPSignatureEntityHandle _Handle, TSBPGPSignatureMaterial * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_SignatureMaterial(TElPGPSignatureEntityHandle _Handle, TSBPGPSignatureMaterial * Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_get_LeftBits(TElPGPSignatureEntityHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_set_LeftBits(TElPGPSignatureEntityHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureEntity_Create(TElPGPSignatureEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSIGNATUREENTITY */

#ifdef SB_USE_CLASS_TELPGPSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_Assign(TElPGPSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_AssignTo(TElPGPSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_get_Hashed(TElPGPSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_set_Hashed(TElPGPSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_get_Critical(TElPGPSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_set_Critical(TElPGPSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_get_SubpacketType(TElPGPSignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPCREATIONTIMESIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPCreationTimeSignatureSubpacket_Assign(TElPGPCreationTimeSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCreationTimeSignatureSubpacket_AssignTo(TElPGPCreationTimeSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCreationTimeSignatureSubpacket_get_CreationTime(TElPGPCreationTimeSignatureSubpacketHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCreationTimeSignatureSubpacket_set_CreationTime(TElPGPCreationTimeSignatureSubpacketHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCreationTimeSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPCREATIONTIMESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPEXPIRATIONTIMESIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPExpirationTimeSignatureSubpacket_Assign(TElPGPExpirationTimeSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExpirationTimeSignatureSubpacket_AssignTo(TElPGPExpirationTimeSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExpirationTimeSignatureSubpacket_get_ExpirationTime(TElPGPExpirationTimeSignatureSubpacketHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExpirationTimeSignatureSubpacket_set_ExpirationTime(TElPGPExpirationTimeSignatureSubpacketHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExpirationTimeSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPEXPIRATIONTIMESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPEMBEDDEDSIGNATURESIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPEmbeddedSignatureSignatureSubpacket_Assign(TElPGPEmbeddedSignatureSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEmbeddedSignatureSignatureSubpacket_AssignTo(TElPGPEmbeddedSignatureSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEmbeddedSignatureSignatureSubpacket_get_Signature(TElPGPEmbeddedSignatureSignatureSubpacketHandle _Handle, TElPGPSignatureEntityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEmbeddedSignatureSignatureSubpacket_set_Signature(TElPGPEmbeddedSignatureSignatureSubpacketHandle _Handle, TElPGPSignatureEntityHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEmbeddedSignatureSignatureSubpacket_Create(TElPGPEmbeddedSignatureSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPEMBEDDEDSIGNATURESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPEXPORTABLECERTIFICATIONSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPExportableCertificationSignatureSubpacket_Assign(TElPGPExportableCertificationSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExportableCertificationSignatureSubpacket_AssignTo(TElPGPExportableCertificationSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExportableCertificationSignatureSubpacket_get_Exportable(TElPGPExportableCertificationSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExportableCertificationSignatureSubpacket_set_Exportable(TElPGPExportableCertificationSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPExportableCertificationSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPEXPORTABLECERTIFICATIONSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPTRUSTSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_Assign(TElPGPTrustSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_AssignTo(TElPGPTrustSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_get_Level(TElPGPTrustSignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_set_Level(TElPGPTrustSignatureSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_get_Amount(TElPGPTrustSignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_set_Amount(TElPGPTrustSignatureSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPTRUSTSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREGULAREXPRESSIONSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPRegularExpressionSignatureSubpacket_Assign(TElPGPRegularExpressionSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRegularExpressionSignatureSubpacket_AssignTo(TElPGPRegularExpressionSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRegularExpressionSignatureSubpacket_get_Expression(TElPGPRegularExpressionSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRegularExpressionSignatureSubpacket_set_Expression(TElPGPRegularExpressionSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRegularExpressionSignatureSubpacket_Create(TElPGPRegularExpressionSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPREGULAREXPRESSIONSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREVOCABLESIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocableSignatureSubpacket_Assign(TElPGPRevocableSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocableSignatureSubpacket_AssignTo(TElPGPRevocableSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocableSignatureSubpacket_get_Revocable(TElPGPRevocableSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocableSignatureSubpacket_set_Revocable(TElPGPRevocableSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocableSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPREVOCABLESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPKEYEXPIRATIONTIMESIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyExpirationTimeSignatureSubpacket_Assign(TElPGPKeyExpirationTimeSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyExpirationTimeSignatureSubpacket_AssignTo(TElPGPKeyExpirationTimeSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyExpirationTimeSignatureSubpacket_get_Expires(TElPGPKeyExpirationTimeSignatureSubpacketHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyExpirationTimeSignatureSubpacket_set_Expires(TElPGPKeyExpirationTimeSignatureSubpacketHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyExpirationTimeSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPKEYEXPIRATIONTIMESIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDSYMMETRICALGORITHMSSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_Assign(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_AssignTo(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_Preferred(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_Preferred(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle _Handle, int32_t Index, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_get_PreferredCount(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_set_PreferredCount(TElPGPPreferredSymmetricAlgorithmsSignatureSubpacketHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPREFERREDSYMMETRICALGORITHMSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREVOCATIONKEYSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_Assign(TElPGPRevocationKeySignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_AssignTo(TElPGPRevocationKeySignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_get_RevClass(TElPGPRevocationKeySignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_set_RevClass(TElPGPRevocationKeySignatureSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_get_AlgID(TElPGPRevocationKeySignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_set_AlgID(TElPGPRevocationKeySignatureSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_get_Fingerprint(TElPGPRevocationKeySignatureSubpacketHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_set_Fingerprint(TElPGPRevocationKeySignatureSubpacketHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPRevocationKeySignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPREVOCATIONKEYSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPISSUERKEYIDSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPIssuerKeyIDSignatureSubpacket_Assign(TElPGPIssuerKeyIDSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPIssuerKeyIDSignatureSubpacket_AssignTo(TElPGPIssuerKeyIDSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPIssuerKeyIDSignatureSubpacket_get_KeyID(TElPGPIssuerKeyIDSignatureSubpacketHandle _Handle, TSBKeyID * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPIssuerKeyIDSignatureSubpacket_set_KeyID(TElPGPIssuerKeyIDSignatureSubpacketHandle _Handle, TSBKeyID * Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPIssuerKeyIDSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPISSUERKEYIDSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPNOTATIONDATASIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_Assign(TElPGPNotationDataSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_AssignTo(TElPGPNotationDataSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_get_HumanReadable(TElPGPNotationDataSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_set_HumanReadable(TElPGPNotationDataSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_get_Name(TElPGPNotationDataSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_set_Name(TElPGPNotationDataSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_get_Value(TElPGPNotationDataSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_set_Value(TElPGPNotationDataSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPNotationDataSignatureSubpacket_Create(TElPGPNotationDataSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPNOTATIONDATASIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDHASHALGORITHMSSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_Assign(TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_AssignTo(TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_Preferred(TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_Preferred(TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle _Handle, int32_t Index, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_get_PreferredCount(TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_set_PreferredCount(TElPGPPreferredHashAlgorithmsSignatureSubpacketHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredHashAlgorithmsSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPREFERREDHASHALGORITHMSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDCOMPRESSIONALGORITHMSSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_Assign(TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_AssignTo(TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_Preferred(TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle _Handle, int32_t Index, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_Preferred(TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle _Handle, int32_t Index, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_get_PreferredCount(TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_set_PreferredCount(TElPGPPreferredCompressionAlgorithmsSignatureSubpacketHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPREFERREDCOMPRESSIONALGORITHMSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPKEYSERVERPREFERENCESSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyServerPreferencesSignatureSubpacket_Assign(TElPGPKeyServerPreferencesSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyServerPreferencesSignatureSubpacket_AssignTo(TElPGPKeyServerPreferencesSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyServerPreferencesSignatureSubpacket_get_NoModify(TElPGPKeyServerPreferencesSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyServerPreferencesSignatureSubpacket_set_NoModify(TElPGPKeyServerPreferencesSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyServerPreferencesSignatureSubpacket_Create(TElPGPKeyServerPreferencesSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPKEYSERVERPREFERENCESSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPREFERREDKEYSERVERSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredKeyServerSignatureSubpacket_Assign(TElPGPPreferredKeyServerSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredKeyServerSignatureSubpacket_AssignTo(TElPGPPreferredKeyServerSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredKeyServerSignatureSubpacket_get_URL(TElPGPPreferredKeyServerSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredKeyServerSignatureSubpacket_set_URL(TElPGPPreferredKeyServerSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPreferredKeyServerSignatureSubpacket_Create(TElPGPPreferredKeyServerSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPREFERREDKEYSERVERSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPRIMARYUSERIDSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPPrimaryUserIDSignatureSubpacket_Assign(TElPGPPrimaryUserIDSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPrimaryUserIDSignatureSubpacket_AssignTo(TElPGPPrimaryUserIDSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPrimaryUserIDSignatureSubpacket_get_Primary(TElPGPPrimaryUserIDSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPrimaryUserIDSignatureSubpacket_set_Primary(TElPGPPrimaryUserIDSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPrimaryUserIDSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPRIMARYUSERIDSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPPOLICYURLSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPPolicyURLSignatureSubpacket_Assign(TElPGPPolicyURLSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPolicyURLSignatureSubpacket_AssignTo(TElPGPPolicyURLSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPolicyURLSignatureSubpacket_get_URL(TElPGPPolicyURLSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPolicyURLSignatureSubpacket_set_URL(TElPGPPolicyURLSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPolicyURLSignatureSubpacket_Create(TElPGPPolicyURLSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPOLICYURLSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPKEYFLAGSSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_Assign(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_AssignTo(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_get_CertifyOtherKeys(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_set_CertifyOtherKeys(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_get_SignData(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_set_SignData(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_get_EncryptData(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_set_EncryptData(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_get_EncryptStorage(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_set_EncryptStorage(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_get_SplitKey(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_set_SplitKey(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_get_GroupKey(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_set_GroupKey(TElPGPKeyFlagsSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPKeyFlagsSignatureSubpacket_Create(TElPGPKeyFlagsSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPKEYFLAGSSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPSIGNERSUSERIDSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignersUserIDSignatureSubpacket_Assign(TElPGPSignersUserIDSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignersUserIDSignatureSubpacket_AssignTo(TElPGPSignersUserIDSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignersUserIDSignatureSubpacket_get_UserID(TElPGPSignersUserIDSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignersUserIDSignatureSubpacket_set_UserID(TElPGPSignersUserIDSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignersUserIDSignatureSubpacket_Create(TElPGPSignersUserIDSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSIGNERSUSERIDSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPREASONFORREVOCATIONSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_Assign(TElPGPReasonForRevocationSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_AssignTo(TElPGPReasonForRevocationSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_get_Reason(TElPGPReasonForRevocationSignatureSubpacketHandle _Handle, TSBPGPReasonForRevocationRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_set_Reason(TElPGPReasonForRevocationSignatureSubpacketHandle _Handle, TSBPGPReasonForRevocationRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_get_Comment(TElPGPReasonForRevocationSignatureSubpacketHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_set_Comment(TElPGPReasonForRevocationSignatureSubpacketHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPReasonForRevocationSignatureSubpacket_Create(TElPGPReasonForRevocationSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPREASONFORREVOCATIONSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPFEATURESSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPFeaturesSignatureSubpacket_Assign(TElPGPFeaturesSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPFeaturesSignatureSubpacket_AssignTo(TElPGPFeaturesSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPFeaturesSignatureSubpacket_get_ModificationDetection(TElPGPFeaturesSignatureSubpacketHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPFeaturesSignatureSubpacket_set_ModificationDetection(TElPGPFeaturesSignatureSubpacketHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPFeaturesSignatureSubpacket_Create(TElPGPFeaturesSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPFEATURESSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPTARGETSIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_Assign(TElPGPTargetSignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_AssignTo(TElPGPTargetSignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_get_Hash(TElPGPTargetSignatureSubpacketHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_set_Hash(TElPGPTargetSignatureSubpacketHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_get_PublicKeyAlgorithm(TElPGPTargetSignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_set_PublicKeyAlgorithm(TElPGPTargetSignatureSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_get_HashAlgorithm(TElPGPTargetSignatureSubpacketHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_set_HashAlgorithm(TElPGPTargetSignatureSubpacketHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTargetSignatureSubpacket_Create(TElPGPSignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPTARGETSIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPX509SIGNATURESUBPACKET
SB_IMPORT uint32_t SB_APIENTRY TElPGPX509SignatureSubpacket_Assign(TElPGPX509SignatureSubpacketHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPX509SignatureSubpacket_AssignTo(TElPGPX509SignatureSubpacketHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPX509SignatureSubpacket_get_Certificate(TElPGPX509SignatureSubpacketHandle _Handle, TElX509CertificateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPX509SignatureSubpacket_Create(TElPGPX509SignatureSubpacketHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPX509SIGNATURESUBPACKET */

#ifdef SB_USE_CLASS_TELPGPSIGNATURESUBPACKETS
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_GetSubpacket(TElPGPSignatureSubpacketsHandle _Handle, uint8_t SubpacketType, int32_t StartFrom, TElPGPSignatureSubpacketHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_GetSubpacketCount(TElPGPSignatureSubpacketsHandle _Handle, uint8_t SubpacketType, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_Add(TElPGPSignatureSubpacketsHandle _Handle, TElPGPSignatureSubpacketHandle Item, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_Add_1(TListHandle _Handle, void * Item, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_RemoveSubpacket(TElPGPSignatureSubpacketsHandle _Handle, uint8_t SubpacketType, int32_t StartIndex, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_RemoveSubpacketByIndex(TElPGPSignatureSubpacketsHandle _Handle, int32_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_Clear(TElPGPSignatureSubpacketsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSignatureSubpackets_Create(TElPGPSignatureSubpacketsHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSIGNATURESUBPACKETS */

#ifdef SB_USE_CLASS_TELPGPTRUSTENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustEntity_Assign(TElPGPTrustEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustEntity_AssignTo(TElPGPTrustEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustEntity_get_Flags(TElPGPTrustEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustEntity_set_Flags(TElPGPTrustEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPTrustEntity_Create(TElPGPTrustEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPTRUSTENTITY */

#ifdef SB_USE_CLASS_TELPGPPUBLICKEYENCRYPTEDSESSIONKEYENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_Assign(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_AssignTo(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_get_KeyID(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, TSBKeyID * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_set_KeyID(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, TSBKeyID * Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_get_PublicKeyAlgorithm(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_set_PublicKeyAlgorithm(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_get_EncryptedKey(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, TSBPGPEncryptedSymmetricKey * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_set_EncryptedKey(TElPGPPublicKeyEncryptedSessionKeyEntityHandle _Handle, TSBPGPEncryptedSymmetricKey * Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPPublicKeyEncryptedSessionKeyEntity_Create(TElPGPPublicKeyEncryptedSessionKeyEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPPUBLICKEYENCRYPTEDSESSIONKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPSYMMETRICKEYENCRYPTEDSESSIONKEYENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_Assign(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_AssignTo(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_SymmetricAlgorithm(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_SymmetricAlgorithm(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_EncryptedKey(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_set_EncryptedKey(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_get_S2K(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle _Handle, TElPGPS2KHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricKeyEncryptedSessionKeyEntity_Create(TElPGPSymmetricKeyEncryptedSessionKeyEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSYMMETRICKEYENCRYPTEDSESSIONKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPONEPASSSIGNATUREENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_Assign(TElPGPOnePassSignatureEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_AssignTo(TElPGPOnePassSignatureEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_get_SignatureClass(TElPGPOnePassSignatureEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_set_SignatureClass(TElPGPOnePassSignatureEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_get_HashAlgorithm(TElPGPOnePassSignatureEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_set_HashAlgorithm(TElPGPOnePassSignatureEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_get_PublicKeyAlgorithm(TElPGPOnePassSignatureEntityHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_set_PublicKeyAlgorithm(TElPGPOnePassSignatureEntityHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_get_KeyID(TElPGPOnePassSignatureEntityHandle _Handle, TSBKeyID * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_set_KeyID(TElPGPOnePassSignatureEntityHandle _Handle, TSBKeyID * Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_get_Version(TElPGPOnePassSignatureEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_set_Version(TElPGPOnePassSignatureEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_get_Nested(TElPGPOnePassSignatureEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_set_Nested(TElPGPOnePassSignatureEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPOnePassSignatureEntity_Create(TElPGPOnePassSignatureEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPONEPASSSIGNATUREENTITY */

#ifdef SB_USE_CLASS_TELPGPSECRETKEYENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_Assign(TElPGPSecretKeyEntityHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_AssignTo(TElPGPSecretKeyEntityHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_get_SymmetricAlgorithm(TElPGPSecretKeyEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_set_SymmetricAlgorithm(TElPGPSecretKeyEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_get_S2K(TElPGPSecretKeyEntityHandle _Handle, TElPGPS2KHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_set_S2K(TElPGPSecretKeyEntityHandle _Handle, TElPGPS2KHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_get_S2KUsage(TElPGPSecretKeyEntityHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_set_S2KUsage(TElPGPSecretKeyEntityHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_get_IV(TElPGPSecretKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_set_IV(TElPGPSecretKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_get_EncryptedKey(TElPGPSecretKeyEntityHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_set_EncryptedKey(TElPGPSecretKeyEntityHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_Create(TElPGPSecretKeyEntityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSecretKeyEntity_Create_1(int8_t Subkey, TElPGPSecretKeyEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSECRETKEYENTITY */

#ifdef SB_USE_CLASS_TELPGPSTREAMINGENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_DataAvailable(TElPGPStreamingEntityHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_LoadFromStream(TElPGPStreamingEntityHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_SaveToStream(TElPGPStreamingEntityHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_Save(TElPGPStreamingEntityHandle _Handle, void * AReadUserData, void * AWriteUserData);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_get_WriteFixedLength(TElPGPStreamingEntityHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_set_WriteFixedLength(TElPGPStreamingEntityHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_get_OnHeaderProcessed(TElPGPStreamingEntityHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_set_OnHeaderProcessed(TElPGPStreamingEntityHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_get_OnTemporaryStream(TElPGPStreamingEntityHandle _Handle, TSBPGPTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_set_OnTemporaryStream(TElPGPStreamingEntityHandle _Handle, TSBPGPTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamingEntity_Create(TElPGPStreamingEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSTREAMINGENTITY */

#ifdef SB_USE_CLASS_TELPGPLITERAL
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_Assign(TElPGPLiteralHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_AssignTo(TElPGPLiteralHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_get_Filename(TElPGPLiteralHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_set_Filename(TElPGPLiteralHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_get_Timestamp(TElPGPLiteralHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_set_Timestamp(TElPGPLiteralHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_get_TextMode(TElPGPLiteralHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_set_TextMode(TElPGPLiteralHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPLiteral_Create(TElPGPLiteralHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPLITERAL */

#ifdef SB_USE_CLASS_TELPGPSYMMETRICALLYENCRYPTED
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_Assign(TElPGPSymmetricallyEncryptedHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_AssignTo(TElPGPSymmetricallyEncryptedHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_get_IntegrityProtected(TElPGPSymmetricallyEncryptedHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_set_IntegrityProtected(TElPGPSymmetricallyEncryptedHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_get_Version(TElPGPSymmetricallyEncryptedHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_set_Version(TElPGPSymmetricallyEncryptedHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSymmetricallyEncrypted_Create(TElPGPSymmetricallyEncryptedHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSYMMETRICALLYENCRYPTED */

#ifdef SB_USE_CLASS_TELPGPCOMPRESSED
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressed_Assign(TElPGPCompressedHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressed_AssignTo(TElPGPCompressedHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressed_get_Algorithm(TElPGPCompressedHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressed_set_Algorithm(TElPGPCompressedHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressed_Create(TElPGPCompressedHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPCOMPRESSED */

#ifdef SB_USE_CLASS_TELPGPSTREAMPROCESSOR
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_Assign(TElPGPStreamProcessorHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_AssignTo(TElPGPStreamProcessorHandle _Handle, TPersistentHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_Process(TElPGPStreamProcessorHandle _Handle, void * AReadUserData, void * AWriteUserData);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_ProcessStream(TElPGPStreamProcessorHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_DataAvailable(TElPGPStreamProcessorHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_CurrentEntity(TElPGPStreamProcessorHandle _Handle, TElPGPEntityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_Empty(TElPGPStreamProcessorHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_Empty(TElPGPStreamProcessorHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_AsyncMode(TElPGPStreamProcessorHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_AsyncMode(TElPGPStreamProcessorHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_ReadUserData(TElPGPStreamProcessorHandle _Handle, void * * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_WriteUserData(TElPGPStreamProcessorHandle _Handle, void * * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_OnRead(TElPGPStreamProcessorHandle _Handle, TSBPGPReadEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_OnRead(TElPGPStreamProcessorHandle _Handle, TSBPGPReadEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_OnWrite(TElPGPStreamProcessorHandle _Handle, TSBPGPWriteEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_OnWrite(TElPGPStreamProcessorHandle _Handle, TSBPGPWriteEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_OnPacket(TElPGPStreamProcessorHandle _Handle, TSBPGPPacketEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_OnPacket(TElPGPStreamProcessorHandle _Handle, TSBPGPPacketEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_OnPacketProcessed(TElPGPStreamProcessorHandle _Handle, TSBPGPPacketProcessedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_OnPacketProcessed(TElPGPStreamProcessorHandle _Handle, TSBPGPPacketProcessedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_get_OnFinish(TElPGPStreamProcessorHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_set_OnFinish(TElPGPStreamProcessorHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamProcessor_Create(TElPGPStreamProcessorHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSTREAMPROCESSOR */

#ifdef SB_USE_CLASS_TELPGPSTUBENTITY
SB_IMPORT uint32_t SB_APIENTRY TElPGPStubEntity_Create(TElPGPEntityHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSTUBENTITY */

#ifdef SB_USE_CLASS_TELPGPSTREAMIO
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamIO_Read(TElPGPStreamIOHandle _Handle, TObjectHandle Sender, void * UserData, void * Buffer, int32_t MaxSize, int32_t * Written, int8_t * Last);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamIO_Write(TElPGPStreamIOHandle _Handle, TObjectHandle Sender, void * UserData, void * Buffer, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamIO_get_Stream(TElPGPStreamIOHandle _Handle, TStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamIO_set_Stream(TElPGPStreamIOHandle _Handle, TStreamHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStreamIO_Create(TStreamHandle Strm, TElPGPStreamIOHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSTREAMIO */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElPGPEntity_ce_ptr;
extern zend_class_entry *TElPGPPublicKeyEntity_ce_ptr;
extern zend_class_entry *TElPGPS2K_ce_ptr;
extern zend_class_entry *TElPGPUserIDEntity_ce_ptr;
extern zend_class_entry *TElPGPUserAttrSubpacket_ce_ptr;
extern zend_class_entry *TElPGPUserAttrImageSubpacket_ce_ptr;
extern zend_class_entry *TElPGPUserAttrEntity_ce_ptr;
extern zend_class_entry *TElPGPSignatureEntity_ce_ptr;
extern zend_class_entry *TElPGPSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPCreationTimeSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPExpirationTimeSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPEmbeddedSignatureSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPExportableCertificationSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPTrustSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPRegularExpressionSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPRevocableSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPKeyExpirationTimeSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPRevocationKeySignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPIssuerKeyIDSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPNotationDataSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPPreferredHashAlgorithmsSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPPreferredCompressionAlgorithmsSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPKeyServerPreferencesSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPPreferredKeyServerSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPPrimaryUserIDSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPPolicyURLSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPKeyFlagsSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPSignersUserIDSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPReasonForRevocationSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPFeaturesSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPTargetSignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPX509SignatureSubpacket_ce_ptr;
extern zend_class_entry *TElPGPSignatureSubpackets_ce_ptr;
extern zend_class_entry *TElPGPTrustEntity_ce_ptr;
extern zend_class_entry *TElPGPPublicKeyEncryptedSessionKeyEntity_ce_ptr;
extern zend_class_entry *TElPGPSymmetricKeyEncryptedSessionKeyEntity_ce_ptr;
extern zend_class_entry *TElPGPOnePassSignatureEntity_ce_ptr;
extern zend_class_entry *TElPGPSecretKeyEntity_ce_ptr;
extern zend_class_entry *TElPGPStreamingEntity_ce_ptr;
extern zend_class_entry *TElPGPLiteral_ce_ptr;
extern zend_class_entry *TElPGPSymmetricallyEncrypted_ce_ptr;
extern zend_class_entry *TElPGPCompressed_ce_ptr;
extern zend_class_entry *TElPGPStreamProcessor_ce_ptr;
extern zend_class_entry *TElPGPStubEntity_ce_ptr;
extern zend_class_entry *TElPGPStreamIO_ce_ptr;

void SB_CALLBACK TSBPGPReadEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, void * Buffer, int32_t MaxSize, int32_t * Written, int8_t * Last);
void SB_CALLBACK TSBPGPWriteEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, void * Buffer, int32_t Size);
void SB_CALLBACK TSBPGPPacketEventRaw(void * _ObjectData, TObjectHandle Sender, uint8_t PacketType, TElPGPEntityHandle * Entity, int8_t * Stop);
void SB_CALLBACK TSBPGPPacketProcessedEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPEntityHandle Packet, int8_t * Continue);
void SB_CALLBACK TSBPGPTemporaryStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream, int8_t * FreeOnFinish);
void Register_TElPGPEntity(TSRMLS_D);
void Register_TElPGPPublicKeyEntity(TSRMLS_D);
void Register_TElPGPS2K(TSRMLS_D);
void Register_TElPGPUserIDEntity(TSRMLS_D);
void Register_TElPGPUserAttrSubpacket(TSRMLS_D);
void Register_TElPGPUserAttrImageSubpacket(TSRMLS_D);
void Register_TElPGPUserAttrEntity(TSRMLS_D);
void Register_TElPGPSignatureEntity(TSRMLS_D);
void Register_TElPGPSignatureSubpacket(TSRMLS_D);
void Register_TElPGPCreationTimeSignatureSubpacket(TSRMLS_D);
void Register_TElPGPExpirationTimeSignatureSubpacket(TSRMLS_D);
void Register_TElPGPEmbeddedSignatureSignatureSubpacket(TSRMLS_D);
void Register_TElPGPExportableCertificationSignatureSubpacket(TSRMLS_D);
void Register_TElPGPTrustSignatureSubpacket(TSRMLS_D);
void Register_TElPGPRegularExpressionSignatureSubpacket(TSRMLS_D);
void Register_TElPGPRevocableSignatureSubpacket(TSRMLS_D);
void Register_TElPGPKeyExpirationTimeSignatureSubpacket(TSRMLS_D);
void Register_TElPGPPreferredSymmetricAlgorithmsSignatureSubpacket(TSRMLS_D);
void Register_TElPGPRevocationKeySignatureSubpacket(TSRMLS_D);
void Register_TElPGPIssuerKeyIDSignatureSubpacket(TSRMLS_D);
void Register_TElPGPNotationDataSignatureSubpacket(TSRMLS_D);
void Register_TElPGPPreferredHashAlgorithmsSignatureSubpacket(TSRMLS_D);
void Register_TElPGPPreferredCompressionAlgorithmsSignatureSubpacket(TSRMLS_D);
void Register_TElPGPKeyServerPreferencesSignatureSubpacket(TSRMLS_D);
void Register_TElPGPPreferredKeyServerSignatureSubpacket(TSRMLS_D);
void Register_TElPGPPrimaryUserIDSignatureSubpacket(TSRMLS_D);
void Register_TElPGPPolicyURLSignatureSubpacket(TSRMLS_D);
void Register_TElPGPKeyFlagsSignatureSubpacket(TSRMLS_D);
void Register_TElPGPSignersUserIDSignatureSubpacket(TSRMLS_D);
void Register_TElPGPReasonForRevocationSignatureSubpacket(TSRMLS_D);
void Register_TElPGPFeaturesSignatureSubpacket(TSRMLS_D);
void Register_TElPGPTargetSignatureSubpacket(TSRMLS_D);
void Register_TElPGPX509SignatureSubpacket(TSRMLS_D);
void Register_TElPGPSignatureSubpackets(TSRMLS_D);
void Register_TElPGPTrustEntity(TSRMLS_D);
void Register_TElPGPPublicKeyEncryptedSessionKeyEntity(TSRMLS_D);
void Register_TElPGPSymmetricKeyEncryptedSessionKeyEntity(TSRMLS_D);
void Register_TElPGPOnePassSignatureEntity(TSRMLS_D);
void Register_TElPGPSecretKeyEntity(TSRMLS_D);
void Register_TElPGPStreamingEntity(TSRMLS_D);
void Register_TElPGPLiteral(TSRMLS_D);
void Register_TElPGPSymmetricallyEncrypted(TSRMLS_D);
void Register_TElPGPCompressed(TSRMLS_D);
void Register_TElPGPStreamProcessor(TSRMLS_D);
void Register_TElPGPStubEntity(TSRMLS_D);
void Register_TElPGPStreamIO(TSRMLS_D);
SB_PHP_FUNCTION(SBPGPEntities, CreateEntity);
SB_PHP_FUNCTION(SBPGPEntities, CloneEntity);
void Register_SBPGPEntities_Constants(int module_number TSRMLS_DC);
void Register_SBPGPEntities_Enum_Flags(TSRMLS_D);
void Register_SBPGPEntities_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_PGPENTITIES
SB_IMPORT uint32_t SB_APIENTRY SBPGPEntities_CreateEntity(uint8_t PktType, TElPGPEntityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBPGPEntities_CloneEntity(TElPGPEntityHandle Entity, TElPGPEntityHandle * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_PGPENTITIES */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBPGPENTITIES */

