#ifndef __INC_SBPKCS11MANAGER
#define __INC_SBPKCS11MANAGER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbstrutils.h"
#include "sbrsa.h"
#include "sbdsa.h"
#include "sbasn1.h"
#include "sbpkcs11common.h"
#include "sbpkcs11base.h"
#include "sbx509.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"
#include "sbsharedresource.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElPKCS11ManagerHandle;

typedef TElPKCS11ManagerHandle ElPKCS11ManagerHandle;

typedef TElClassHandle TElPKCS11ManagerObjectHandle;

typedef TElPKCS11ManagerObjectHandle ElPKCS11ManagerObjectHandle;

typedef TElClassHandle TElPKCS11ManagerDataObjectHandle;

typedef TElPKCS11ManagerDataObjectHandle ElPKCS11ManagerDataObjectHandle;

typedef TElClassHandle TElPKCS11ManagerCertificateObjectHandle;

typedef TElPKCS11ManagerCertificateObjectHandle ElPKCS11ManagerCertificateObjectHandle;

typedef TElClassHandle TElPKCS11ManagerKeyObjectHandle;

typedef TElPKCS11ManagerKeyObjectHandle ElPKCS11ManagerKeyObjectHandle;

typedef TElClassHandle TElPKCS11ManagerPublicKeyObjectHandle;

typedef TElPKCS11ManagerPublicKeyObjectHandle ElPKCS11ManagerPublicKeyObjectHandle;

typedef TElClassHandle TElPKCS11ManagerPrivateKeyObjectHandle;

typedef TElPKCS11ManagerPrivateKeyObjectHandle ElPKCS11ManagerPrivateKeyObjectHandle;

typedef TElClassHandle TElPKCS11ManagerSecretKeyObjectHandle;

typedef TElPKCS11ManagerSecretKeyObjectHandle ElPKCS11ManagerSecretKeyObjectHandle;

typedef TElClassHandle TElPKCS11ConsumerManagerHandle;

typedef TElPKCS11ConsumerManagerHandle ElPKCS11ConsumerManagerHandle;

#ifdef SB_USE_CLASS_TELPKCS11MANAGER
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_Close(TElPKCS11ManagerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_Open(TElPKCS11ManagerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_OpenSession(TElPKCS11ManagerHandle _Handle, int32_t SlotIndex, int8_t ReadOnly, TElPKCS11SessionInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_CloseSession(TElPKCS11ManagerHandle _Handle);
#ifdef SB_NOT_CPU64_OR_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_IndexOfObject(TElPKCS11ManagerHandle _Handle, uint32_t Handle, int32_t * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_IndexOfObject(TElPKCS11ManagerHandle _Handle, int64_t Handle, int32_t * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_IndexOfObject_1(TElPKCS11ManagerHandle _Handle, TElPKCS11ManagerObjectHandle AnObject, int32_t * OutResult);
#ifdef SB_NOT_CPU64_OR_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_RemoveObject(TElPKCS11ManagerHandle _Handle, uint32_t Handle);
#else
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_RemoveObject(TElPKCS11ManagerHandle _Handle, int64_t Handle);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_RemoveObject_1(TElPKCS11ManagerHandle _Handle, TElPKCS11ManagerObjectHandle AnObject);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_RemoveObject_2(TElPKCS11ManagerHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_RefreshObjects(TElPKCS11ManagerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_AddObject(TElPKCS11ManagerHandle _Handle, TElPKCS11ManagerObjectHandle AnObject, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_get_Objects(TElPKCS11ManagerHandle _Handle, int32_t Index, TElPKCS11ManagerObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_get_Count(TElPKCS11ManagerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_get_Module(TElPKCS11ManagerHandle _Handle, TElPKCS11ModuleHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_get_DLLName(TElPKCS11ManagerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_set_DLLName(TElPKCS11ManagerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_get_PKCS11Options(TElPKCS11ManagerHandle _Handle, TSBPKCS11StorageOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_set_PKCS11Options(TElPKCS11ManagerHandle _Handle, TSBPKCS11StorageOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_get_OnNotification(TElPKCS11ManagerHandle _Handle, TElPKCSNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_set_OnNotification(TElPKCS11ManagerHandle _Handle, TElPKCSNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11Manager_Create(TComponentHandle Owner, TElPKCS11ManagerHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGER */

#ifdef SB_USE_CLASS_TELPKCS11MANAGEROBJECT
#ifdef SB_NOT_CPU64_OR_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_Handle(TElPKCS11ManagerObjectHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_HWSize(TElPKCS11ManagerObjectHandle _Handle, uint32_t * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_Handle(TElPKCS11ManagerObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_HWSize(TElPKCS11ManagerObjectHandle _Handle, int64_t * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_ID(TElPKCS11ManagerObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_Label_(TElPKCS11ManagerObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_set_Label_(TElPKCS11ManagerObjectHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_Modifiable(TElPKCS11ManagerObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_set_Modifiable(TElPKCS11ManagerObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_Private_(TElPKCS11ManagerObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_set_Private_(TElPKCS11ManagerObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_get_Token(TElPKCS11ManagerObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_set_Token(TElPKCS11ManagerObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGEROBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERDATAOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_get_Application(TElPKCS11ManagerDataObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_set_Application(TElPKCS11ManagerDataObjectHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_get_OID(TElPKCS11ManagerDataObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_set_OID(TElPKCS11ManagerDataObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_get_Value(TElPKCS11ManagerDataObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_set_Value(TElPKCS11ManagerDataObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerDataObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGERDATAOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERCERTIFICATEOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_ACAttrTypes(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_ACAttrTypes(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_ACIssuer(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_ACIssuer(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_ACOwner(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_ACOwner(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_Category(TElPKCS11ManagerCertificateObjectHandle _Handle, TElPKCS11CertificateCategoryRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_Category(TElPKCS11ManagerCertificateObjectHandle _Handle, TElPKCS11CertificateCategoryRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_CertificateType(TElPKCS11ManagerCertificateObjectHandle _Handle, TElPKCS11CertificateTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_CertificateType(TElPKCS11ManagerCertificateObjectHandle _Handle, TElPKCS11CertificateTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_Issuer(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_Issuer(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_SerialNumber(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_SerialNumber(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_Subject(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_Subject(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_Trusted(TElPKCS11ManagerCertificateObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_Trusted(TElPKCS11ManagerCertificateObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_ValidFrom(TElPKCS11ManagerCertificateObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_ValidFrom(TElPKCS11ManagerCertificateObjectHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_ValidTo(TElPKCS11ManagerCertificateObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_ValidTo(TElPKCS11ManagerCertificateObjectHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_URL(TElPKCS11ManagerCertificateObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_URL(TElPKCS11ManagerCertificateObjectHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_get_Value(TElPKCS11ManagerCertificateObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_set_Value(TElPKCS11ManagerCertificateObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerCertificateObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGERCERTIFICATEOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerKeyObject_get_ValidFrom(TElPKCS11ManagerKeyObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerKeyObject_set_ValidFrom(TElPKCS11ManagerKeyObjectHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerKeyObject_get_ValidTo(TElPKCS11ManagerKeyObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerKeyObject_set_ValidTo(TElPKCS11ManagerKeyObjectHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerKeyObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGERKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERPUBLICKEYOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_get_Encrypt(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_set_Encrypt(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_get_Subject(TElPKCS11ManagerPublicKeyObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_set_Subject(TElPKCS11ManagerPublicKeyObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_get_Trusted(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_set_Trusted(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_get_Verify(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_set_Verify(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_get_VerifyRecover(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_set_VerifyRecover(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_get_Wrap(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_set_Wrap(TElPKCS11ManagerPublicKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPublicKeyObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGERPUBLICKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERPRIVATEKEYOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_AlwaysAuthenticate(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_AlwaysAuthenticate(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_Decrypt(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_Decrypt(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_Extractable(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_Extractable(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_Sensitive(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_Sensitive(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_Sign(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_Sign(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_SignRecover(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_SignRecover(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_Subject(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_Subject(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_get_Unwrap(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_set_Unwrap(TElPKCS11ManagerPrivateKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerPrivateKeyObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGERPRIVATEKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11MANAGERSECRETKEYOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Decrypt(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Decrypt(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Encrypt(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Encrypt(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Extractable(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Extractable(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Sensitive(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Sensitive(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Sign(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Sign(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Unwrap(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Unwrap(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Verify(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Verify(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_get_Wrap(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_set_Wrap(TElPKCS11ManagerSecretKeyObjectHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ManagerSecretKeyObject_Create(TElPKCS11ManagerHandle Owner, TElPKCS11ManagerObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11MANAGERSECRETKEYOBJECT */

#ifdef SB_USE_CLASS_TELPKCS11CONSUMERMANAGER
SB_IMPORT uint32_t SB_APIENTRY TElPKCS11ConsumerManager_Create(TElPKCS11ConsumerHandle * OutResult);
#endif /* SB_USE_CLASS_TELPKCS11CONSUMERMANAGER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElPKCS11Manager_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerObject_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerDataObject_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerCertificateObject_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerKeyObject_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerPublicKeyObject_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerPrivateKeyObject_ce_ptr;
extern zend_class_entry *TElPKCS11ManagerSecretKeyObject_ce_ptr;
extern zend_class_entry *TElPKCS11ConsumerManager_ce_ptr;

void Register_TElPKCS11Manager(TSRMLS_D);
void Register_TElPKCS11ManagerObject(TSRMLS_D);
void Register_TElPKCS11ManagerDataObject(TSRMLS_D);
void Register_TElPKCS11ManagerCertificateObject(TSRMLS_D);
void Register_TElPKCS11ManagerKeyObject(TSRMLS_D);
void Register_TElPKCS11ManagerPublicKeyObject(TSRMLS_D);
void Register_TElPKCS11ManagerPrivateKeyObject(TSRMLS_D);
void Register_TElPKCS11ManagerSecretKeyObject(TSRMLS_D);
void Register_TElPKCS11ConsumerManager(TSRMLS_D);
void Register_SBPKCS11Manager_Aliases(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBPKCS11MANAGER */
