#ifndef __INC_SBSFTPSERVER
#define __INC_SBSFTPSERVER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbchsconv.h"
#include "sbchsconvcharsets.h"
#include "sbchscjk.h"
#include "sbsshutils.h"
#include "sbsshhandlers.h"
#include "sbsshcommon.h"
#include "sbsftpcommon.h"
#include "sbsharedresource.h"
#include "sbconstants.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TSBSftpHandleHandle;

typedef TElClassHandle TElSFTPServerHandle;

typedef TElSFTPServerHandle ElSFTPServerHandle;

#ifdef SB_USE_CLASS_TSBSFTPHANDLE
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_Allocated(TSBSftpHandleHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_Allocated(TSBSftpHandleHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_Name(TSBSftpHandleHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_Name(TSBSftpHandleHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_Info(TSBSftpHandleHandle _Handle, TElSftpFileInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_Info(TSBSftpHandleHandle _Handle, TElSftpFileInfoHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_InfoUsed(TSBSftpHandleHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_InfoUsed(TSBSftpHandleHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_Eof(TSBSftpHandleHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_Eof(TSBSftpHandleHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_Data(TSBSftpHandleHandle _Handle, void * * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_Data(TSBSftpHandleHandle _Handle, void * Value);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_get_Directory(TSBSftpHandleHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_set_Directory(TSBSftpHandleHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TSBSftpHandle_Create(TSBSftpHandleHandle * OutResult);
#endif /* SB_USE_CLASS_TSBSFTPHANDLE */

#ifdef SB_USE_CLASS_TELSFTPSERVER
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_Close(TElSFTPServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_DataAvailable(TElSFTPServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_Open(TElSFTPServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_Active(TElSFTPServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_ServerVersion(TElSFTPServerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_ServerVersion(TElSFTPServerHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_NewLineConvention(TElSFTPServerHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_NewLineConvention(TElSFTPServerHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_NegotiatedCharset(TElSFTPServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_Version(TElSFTPServerHandle _Handle, TSBSftpVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_UseUTF8(TElSFTPServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_UseUTF8(TElSFTPServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_UseUTF8OnSFTP3(TElSFTPServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_UseUTF8OnSFTP3(TElSFTPServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_RemoteCharset(TElSFTPServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_RemoteCharset(TElSFTPServerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_LocalCharset(TElSFTPServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_LocalCharset(TElSFTPServerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_NoCharacterEncoding(TElSFTPServerHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_NoCharacterEncoding(TElSFTPServerHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_Supported(TElSFTPServerHandle _Handle, TElSftpSupportedExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_ClientVendorID(TElSFTPServerHandle _Handle, TElSftpVendorIDExtensionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_FilenameCharset(TElSFTPServerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_FilenameCharset(TElSFTPServerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_Versions(TElSFTPServerHandle _Handle, TSBSftpVersionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_Versions(TElSFTPServerHandle _Handle, TSBSftpVersionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnBlock(TElSFTPServerHandle _Handle, TElSFTPServerBlockEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnBlock(TElSFTPServerHandle _Handle, TElSFTPServerBlockEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnUnblock(TElSFTPServerHandle _Handle, TElSFTPServerUnblockEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnUnblock(TElSFTPServerHandle _Handle, TElSFTPServerUnblockEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnClose(TElSFTPServerHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnClose(TElSFTPServerHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnCloseHandle(TElSFTPServerHandle _Handle, TElSFTPServerCloseHandleEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnCloseHandle(TElSFTPServerHandle _Handle, TElSFTPServerCloseHandleEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnCreateDirectory(TElSFTPServerHandle _Handle, TElSFTPServerCreateDirectoryEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnCreateDirectory(TElSFTPServerHandle _Handle, TElSFTPServerCreateDirectoryEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnCreateSymLink(TElSFTPServerHandle _Handle, TElSFTPServerCreateSymLinkEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnCreateSymLink(TElSFTPServerHandle _Handle, TElSFTPServerCreateSymLinkEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnCreateHardLink(TElSFTPServerHandle _Handle, TElSFTPServerCreateHardLinkEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnCreateHardLink(TElSFTPServerHandle _Handle, TElSFTPServerCreateHardLinkEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnError(TElSFTPServerHandle _Handle, TSBSftpErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnError(TElSFTPServerHandle _Handle, TSBSftpErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnFindClose(TElSFTPServerHandle _Handle, TElSFTPServerFindCloseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnFindClose(TElSFTPServerHandle _Handle, TElSFTPServerFindCloseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnFindFirst(TElSFTPServerHandle _Handle, TElSFTPServerFindFirstEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnFindFirst(TElSFTPServerHandle _Handle, TElSFTPServerFindFirstEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnFindNext(TElSFTPServerHandle _Handle, TElSFTPServerFindNextEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnFindNext(TElSFTPServerHandle _Handle, TElSFTPServerFindNextEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnOpen(TElSFTPServerHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnOpen(TElSFTPServerHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnOpenFile(TElSFTPServerHandle _Handle, TElSFTPServerOpenFileEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnOpenFile(TElSFTPServerHandle _Handle, TElSFTPServerOpenFileEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnReadFile(TElSFTPServerHandle _Handle, TElSFTPServerReadEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnReadFile(TElSFTPServerHandle _Handle, TElSFTPServerReadEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnReadSymLink(TElSFTPServerHandle _Handle, TElSFTPServerReadSymLinkEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnReadSymLink(TElSFTPServerHandle _Handle, TElSFTPServerReadSymLinkEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnReceive(TElSFTPServerHandle _Handle, TElSFTPServerReceiveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnReceive(TElSFTPServerHandle _Handle, TElSFTPServerReceiveEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRemove(TElSFTPServerHandle _Handle, TElSFTPServerRemoveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRemove(TElSFTPServerHandle _Handle, TElSFTPServerRemoveEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRenameFile(TElSFTPServerHandle _Handle, TElSFTPServerRenameFileEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRenameFile(TElSFTPServerHandle _Handle, TElSFTPServerRenameFileEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestAbsolutePath(TElSFTPServerHandle _Handle, TElSFTPServerRequestAbsolutePathEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestAbsolutePath(TElSFTPServerHandle _Handle, TElSFTPServerRequestAbsolutePathEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestAttributes(TElSFTPServerHandle _Handle, TElSFTPServerRequestAttributesEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestAttributes(TElSFTPServerHandle _Handle, TElSFTPServerRequestAttributesEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestAttributes2(TElSFTPServerHandle _Handle, TElSFTPServerRequestAttributes2Event * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestAttributes2(TElSFTPServerHandle _Handle, TElSFTPServerRequestAttributes2Event pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnSend(TElSFTPServerHandle _Handle, TElSFTPServerSendEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnSend(TElSFTPServerHandle _Handle, TElSFTPServerSendEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnSetAttributes(TElSFTPServerHandle _Handle, TElSFTPServerSetAttributesEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnSetAttributes(TElSFTPServerHandle _Handle, TElSFTPServerSetAttributesEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnSetAttributes2(TElSFTPServerHandle _Handle, TElSFTPServerSetAttributes2Event * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnSetAttributes2(TElSFTPServerHandle _Handle, TElSFTPServerSetAttributes2Event pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnTextSeek(TElSFTPServerHandle _Handle, TElSFTPServerTextSeekEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnTextSeek(TElSFTPServerHandle _Handle, TElSFTPServerTextSeekEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnWriteFile(TElSFTPServerHandle _Handle, TElSFTPServerWriteEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnWriteFile(TElSFTPServerHandle _Handle, TElSFTPServerWriteEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnExtendedRequest(TElSFTPServerHandle _Handle, TElSFTPServerExtendedRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnExtendedRequest(TElSFTPServerHandle _Handle, TElSFTPServerExtendedRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnVersionChange(TElSFTPServerHandle _Handle, TElSftpServerVersionChangeEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnVersionChange(TElSFTPServerHandle _Handle, TElSftpServerVersionChangeEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnSendVendorID(TElSFTPServerHandle _Handle, TElSFTPServerSendVendorIDEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnSendVendorID(TElSFTPServerHandle _Handle, TElSFTPServerSendVendorIDEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestFileHash(TElSFTPServerHandle _Handle, TElSFTPServerRequestFileHashEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestFileHash(TElSFTPServerHandle _Handle, TElSFTPServerRequestFileHashEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestFileHashByHandle(TElSFTPServerHandle _Handle, TElSFTPServerRequestFileHashByHandleEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestFileHashByHandle(TElSFTPServerHandle _Handle, TElSFTPServerRequestFileHashByHandleEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestAvailableSpace(TElSFTPServerHandle _Handle, TElSFTPServerRequestAvailableSpaceEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestAvailableSpace(TElSFTPServerHandle _Handle, TElSFTPServerRequestAvailableSpaceEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestStatVFS(TElSFTPServerHandle _Handle, TElSFTPServerRequestStatVFSEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestStatVFS(TElSFTPServerHandle _Handle, TElSFTPServerRequestStatVFSEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestHomeDirectory(TElSFTPServerHandle _Handle, TElSFTPServerRequestHomeDirectoryEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestHomeDirectory(TElSFTPServerHandle _Handle, TElSFTPServerRequestHomeDirectoryEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnCopyRemoteFile(TElSFTPServerHandle _Handle, TElSFTPServerCopyRemoteFileEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnCopyRemoteFile(TElSFTPServerHandle _Handle, TElSFTPServerCopyRemoteFileEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnCopyRemoteData(TElSFTPServerHandle _Handle, TElSFTPServerCopyRemoteDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnCopyRemoteData(TElSFTPServerHandle _Handle, TElSFTPServerCopyRemoteDataEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnMakeTempFolder(TElSFTPServerHandle _Handle, TElSFTPServerReturnPathEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnMakeTempFolder(TElSFTPServerHandle _Handle, TElSFTPServerReturnPathEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_get_OnRequestTempFolder(TElSFTPServerHandle _Handle, TElSFTPServerReturnPathEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_set_OnRequestTempFolder(TElSFTPServerHandle _Handle, TElSFTPServerReturnPathEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElSFTPServer_Create(TComponentHandle AOwner, TElSFTPServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELSFTPSERVER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TSBSftpHandle_ce_ptr;
extern zend_class_entry *TElSFTPServer_ce_ptr;

void Register_TSBSftpHandle(TSRMLS_D);
void Register_TElSFTPServer(TSRMLS_D);
void Register_SBSftpServer_Aliases(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBSFTPSERVER */

