#ifndef __INC_SBXMLSOAPSECURITY
#define __INC_SBXMLSOAPSECURITY

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbcustomcertstorage.h"
#include "sbconstants.h"
#include "sbdc.h"
#include "sbdcdef.h"
#include "sbrandom.h"
#include "sbtypes.h"
#include "sbstrutils.h"
#include "sbutils.h"
#include "sbx509.h"
#include "sbxmldefs.h"
#include "sbxmlcore.h"
#include "sbxmlsec.h"
#include "sbxmlsig.h"
#include "sbxmltransform.h"
#include "sbxmlutils.h"
#include "sbxmlsoapcore.h"
#include "sbxmlwsscore.h"
#include "sbxmlsoap.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElXMLSOAPSignatureHandlerHandle;

typedef TElClassHandle TElXMLWSSSignatureHandlerHandle;

typedef uint8_t TSBXMLWSSEmbedCertificateRaw;

typedef enum
{
	wecInSignature = 0,
	wecInBinarySecurityToken = 1,
	wecInSignedBinarySecurityToken = 2,
	wecInBinarySecurityTokenAndSignature = 3,
	wecNone = 4
} TSBXMLWSSEmbedCertificate;

#ifdef SB_USE_CLASS_TELXMLSOAPSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_GetName_1(TElXMLSOAPSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_LoadFromXML(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle SignatureElement, TElXMLSOAPMessageHandle Msg);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Reset(TElXMLSOAPSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign(TElXMLSOAPSignatureHandlerHandle _Handle, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_1(TElXMLSOAPSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_2(TElXMLSOAPSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_3(TElXMLSOAPSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_4(TElXMLSOAPSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_5(TElXMLSOAPSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_6(TElXMLSOAPSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_7(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_8(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_9(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_10(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_11(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_12(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_13(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_14(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_InitiateAsyncSign_15(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign(TElXMLSOAPSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_1(TElXMLSOAPSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_2(TElXMLSOAPSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_3(TElXMLSOAPSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_4(TElXMLSOAPSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_5(TElXMLSOAPSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_6(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_7(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_8(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_9(TElXMLSOAPSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_10(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_11(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_12(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Sign_13(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_get_ID(TElXMLSOAPSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_set_ID(TElXMLSOAPSignatureHandlerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_get_Actor(TElXMLSOAPSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_set_Actor(TElXMLSOAPSignatureHandlerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_get_MustUnderstand(TElXMLSOAPSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_set_MustUnderstand(TElXMLSOAPSignatureHandlerHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElXMLSOAPSignatureHandler_Create(TComponentHandle Owner, TElXMLSOAPSignatureHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELXMLSOAPSIGNATUREHANDLER */

#ifdef SB_USE_CLASS_TELXMLWSSSIGNATUREHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_GetName(char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_GetName_1(TElXMLWSSSignatureHandlerHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Reset(TElXMLWSSSignatureHandlerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign(TElXMLWSSSignatureHandlerHandle _Handle, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_1(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_2(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_3(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, const char * pcTokenID, int32_t szTokenID, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_4(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, TSBXMLWSSETokenTypeRaw TokenType, const char * pcTokenID, int32_t szTokenID, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_5(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_6(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_7(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, const char * pcTokenID, int32_t szTokenID, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_8(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, TSBXMLWSSETokenTypeRaw TokenType, const char * pcTokenID, int32_t szTokenID, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_9(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t EmbedKeyInSignature, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_10(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_11(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_12(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_13(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_14(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_15(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_16(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_InitiateAsyncSign_17(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, TElDCAsyncStateHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_1(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TSBXMLWSSEmbedCertificateRaw EmbedCertificate);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_2(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, const char * pcTokenID, int32_t szTokenID);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_3(TElXMLWSSSignatureHandlerHandle _Handle, TElX509CertificateHandle Certificate, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, TSBXMLWSSETokenTypeRaw TokenType, const char * pcTokenID, int32_t szTokenID);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_4(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_5(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TSBXMLWSSEmbedCertificateRaw EmbedCertificate);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_6(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, const char * pcTokenID, int32_t szTokenID);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_7(TElXMLWSSSignatureHandlerHandle _Handle, TElCustomCertStorageHandle CertStorage, TSBXMLWSSEmbedCertificateRaw EmbedCertificate, TSBXMLWSSETokenTypeRaw TokenType, const char * pcTokenID, int32_t szTokenID);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_8(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t EmbedKeyInSignature);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_9(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_10(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey, int8_t IncludeKeyValue, TElXMLKeyInfoX509DataParamsRaw IncludeDataParams);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_11(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElXMLKeyInfoDataHandle KeyData, TElXMLSignatureMethodRaw SignatureMethod, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_12(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_13(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElX509CertificateHandle Certificate, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_14(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Sign_15(TElXMLSOAPBaseSignatureHandlerHandle _Handle, TElXMLDOMElementHandle ParentElement, TElCustomCertStorageHandle CertStorage, int8_t IncludeKey);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_get_SecurityHeader(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLWSSESecurityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_set_SecurityHeader(TElXMLWSSSignatureHandlerHandle _Handle, TElXMLWSSESecurityHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElXMLWSSSignatureHandler_Create(TComponentHandle Owner, TElXMLSOAPBaseSignatureHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELXMLWSSSIGNATUREHANDLER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElXMLSOAPSignatureHandler_ce_ptr;
extern zend_class_entry *TElXMLWSSSignatureHandler_ce_ptr;

void Register_TElXMLSOAPSignatureHandler(TSRMLS_D);
void Register_TElXMLWSSSignatureHandler(TSRMLS_D);
void Register_SBXMLSOAPSecurity_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBXMLSOAPSECURITY */

