<?php 
    date_default_timezone_set("UTC");

    function DoCertificateValidate($Sender, $X509Certificate, &$Validate)
    {
        $Validate = true;
    }

    if (isset($_POST["upload"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $ID = $_POST["ID"];
        $skey = $_POST["skey"];
        $cont = $_POST["container"];
        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if ((strlen($ID) > 0) and (strlen($skey) > 0) and (strlen($cont) > 0) and (strlen($inputfile) > 0))
        {
            $storage = new TElAWSS3DataStorage(NULL);
            $https = new TElHTTPSClient(NULL);
            $https->OnCertificateValidate = "DoCertificateValidate";
            $storage->HTTPClient = $https;
            $storage->KeyID = $ID;
            $storage->AccessKey = $skey;

            try
            {
                if ($storage->BucketExists($cont))
                {
                    $yourfile = basename($filename);
                    $in = new TMemoryStream;

                    $in->LoadFromFile($inputfile);

                    $storage->WriteObject($cont, $yourfile, $in, NULL);

                    print "Upload done!";
                }
                else
                {
                    print "Entered container is not in storage";
                }
            }
            catch(SBException $e) 
            {
                print "Failed to connect AWS S3 storage: " . $e->getMessage() ." <br/>";
                return;
            }
        }
        else
        {
            $error_details = "";

            if (strlen($ID) == 0)
            {
                $error_details = $error_details . "Key ID is not provided<br/>";
            }
            if (strlen($skey) == 0)
            {
                $error_details = $error_details . "Secret key is not provided<br/>";
            }
            if (strlen($cont) == 0)
            {
                $error_details = $error_details . "Container is not provided<br/>";
            }
            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "File to upload is not provided<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS AWS S3 Data Storage demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox AWS S3 Data Storage demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox AWS S3 Data Storage components for uploading file to storage. <br/>
              Please provide your AWS S3 Data Storage key ID and secret key, file to upload and click the 'Upload' button to upload file to storage. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="20%" align="right"> Key ID: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="ID" value="" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Secret key: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="skey" value="" size="60" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Container: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="container" value="" size="40" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> File: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="inputfile" value="" size="40" /> </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="upload" value="Upload File"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>