<?php 
    date_default_timezone_set("UTC");

    function DoCertificateValidate($Sender, $X509Certificate, &$Validate)
    {
        $Validate = true;
    }

    function GetDomain($mail)
    {
        $p = strpos($mail, "@");
        return substr($mail, $p + 1, strlen($mail) - $p);
    }

    if (isset($_POST["sendmes"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $tomail = $_POST["tomail"];
        $frommail = $_POST["frommail"];
        $subject = $_POST["subject"];
        $body = $_POST["body"];
        $attachfile = $_FILES["attach"]["tmp_name"];
        $filename = $_FILES["attach"]["name"];
        $serv = $_POST["serv"];
        $port = $_POST["port"];
        $nossl = (isset($_POST['sslmode']) && $_POST['sslmode'] == 'mode1');
        $implicit = (isset($_POST['sslmode']) && $_POST['sslmode'] == 'mode2');
        $explicit = (isset($_POST['sslmode']) && $_POST['sslmode'] == 'mode3');
        $user = $_POST["user"];
        $password = $_POST["pass"];

        if ((strlen($tomail) > 0) and (strlen($frommail) > 0) and (strlen($serv) > 0) and (strlen($port) > 0) and 
            ($nossl or $implicit or $explicit) and (strlen($user) > 0) and (strlen($password) > 0))
        {
            $smtp = new TElSMTPClient(NULL);
            $msg = new TElMessage(false);
            $mesbody = new TElPlainTextPart();

            if (strlen($attachfile) > 0)
            {
                $mmp = new TElMultiPartList();

                $mesbody->SetText($body);
                $mmp->AddPart($mesbody, true, 0);

                $attachstream = new TMemoryStream;
                $attachstream->LoadFromFile($attachfile);

                $attach = new TElMessagePart();
                $attach->Header->AddField("Content-Type", "application/octet-stream", true)->AddParam("name", $filename);
                $attach->Header->AddField("Content-Disposition", "attachment", true)->AddParam("filename", $filename);
                $attach->Header->AddField("Content-Transfer-Encoding", "base64", true);
                $attach->SetData($attachstream, $attachstream->size, true);

                $mmp->AddPart($attach, true, 0);

                $msg->SetMainPart($mmp, true);
            }
            else
            {
                $mesbody->SetText($body);
                $msg->SetMainPart($mesbody, true);
            }

            $msg->To_->AddAddress("", $tomail);
            $msg->From->AddAddress("", $frommail);
            $msg->SetSubject($subject);
            $msg->MessageID = $msg->GenerateMessageID();
            $date = new DateTime('now');
            $msg->SetDate($date);

            $smtp->OnCertificateValidate = "DoCertificateValidate";
            $smtp->Address = $serv;
            $smtp->Port = $port;
            $smtp->UseSSL = !$nossl;

            if ($smtp->UseSSL)
            {
                if ($implicit)
                {
                    $smtp->SSLMode = 0;
                }
                else
                {
                    $smtp->SSLMode = 1;
                }
            }

            $smtp->Username = $user;
            $smtp->Password = $password;

            try
            {
                $smtp->Open();
                $smtp->Login(GetDomain($frommail));
                $smtp->Send($msg);
                $smtp->Close(false);

                print "Done <br/>";
                return;
            }
            catch(SBException $e) 
            {
                print "Failed to send message : " . $e->getMessage() ." <br/>";
                return;
            }
        }
        else
        {
            $error_details = "";

            if (strlen($tomail) == 0)
            {
                $error_details = $error_details . "Field \"To\" is not provided<br/>";
            }
            if (strlen($frommail) == 0)
            {
                $error_details = $error_details . " Field \"From\" is not provided <br/>";
            }
            if (strlen($serv) == 0)
            {
                $error_details = $error_details . "SMTP server is not provided<br/>";
            }
            if (strlen($port) == 0)
            {
                $error_details = $error_details . "SMTP port is not provided<br/>";
            }
            if (!($nossl or $implicit or $explicit))
            {
                $error_details = $error_details . "SSL mode is not selected<br/>";
            }
            if (strlen($user) == 0)
            {
                $error_details = $error_details . "User is not provided<br/>";
            }
            if (strlen($password) == 0)
            {
                $error_details = $error_details . "Password is not provided<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS OpenPGP protect demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="800" height="100%">
    <tr height="*"></tr>
    <tr height="500">
      <td width="800" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox SMTP demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox SMTP components for send letters. <br/>
              Please provide your smtp server, the message info and click the 'SendMessage' button to send the letter. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="*">
                  <td width="50%" height="*">
                    <fieldset>
                    <legend>Message</legend>
                      <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                        <tr height="30">
                          <td width="20%" align="right"> To: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="text" name="tomail" value="" size="30" /> <td>
                        </tr>
                        <tr height="30">
                          <td width="20%" align="right"> From: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="text" name="frommail" value="" size="30" /> </td>
                        </tr>
                        <tr height="30">
                          <td width="20%" align="right"> Subject: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="text" name="subject" value="" size="30" /> </td>
                        </tr>
                        <tr height="95">
                          <td width="20%" align="right"> Body: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <textarea name="body" COLS=30 ROWS=4></textarea> </td>
                        </tr>
                        <tr height="30">
                          <td width="20%" align="right"> Attachment: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="file" name="attach" value="" size="30" /> <td>
                        </tr>
                      </table>
                    </fieldset>
                  </td>
                  <td width="50%" height="*">
                    <fieldset>
                    <legend>SMTP Server</legend>
                      <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                        <tr height="30">
                          <td width="20%" align="right"> Server: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="text" name="serv" value="" size="30" /> <td>
                        </tr>
                        <tr height="30">
                          <td width="20%" align="right"> Port: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="text" name="port" value="" size="30" /> </td>
                        </tr>
                        <tr height="40">
                          <td width="20%" align="right"> SSL Mode: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> 
                            <input type="radio" name="sslmode" CHECKED value="mode1" size="30" /> <span class="mtx4">No SSL</span>
                            <input type="radio" name="sslmode" value="mode2" size="30" /> <span class="mtx4">Implicit</span>
                            <input type="radio" name="sslmode" value="mode3" size="30" /> <span class="mtx4">Explicit</span>
                          </td>
                        </tr>
                        <tr height="30">
                          <td width="20%" align="right"> User name: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="text" name="user" value="" size="30" /> </td>
                        </tr>
                        <tr height="50">
                          <td width="20%" align="right"> Password: </td>
                          <td width="10"></td>
                          <td width="*" align="left"> <input type="password" name="pass" value="" size="30"> </td>
                        </tr>
                        <tr height="35" valign="center">
                          <td colspan="3" align="right"> <input type="submit" name="sendmes" value="Send message"/> </td>
                        </tr>
                      </table>
                      </fieldset>
                  </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>