<?php 
    date_default_timezone_set("UTC");

    $doc = new TElOfficeDocument(NULL);
    $filename = "";
    $tempname = "";

    function ShowForm()
    {
        global $doc;
        global $tempname;
        global $filename;

        echo '<html>';
        echo '<head>';
        echo '  <title>EldoS Secure Office demo</title>';
        echo '  <style type="text/css">';
        echo '  .textheader {';
        echo '    font-family: Arial;';
        echo '    font-size: 16;';
        echo '    font-weight: bold;';
        echo '  }';
        echo '  .textnormal {';
        echo '    font-family: Arial;';
        echo '    font-size: 12;';
        echo '  }';
        echo '  </style>';
        echo '</head>';
        echo '<body>';
        echo '  <div align="center">';
        echo '  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">';
        echo '    <tr height="*"></tr>';
        echo '    <tr height="400">';
        echo '      <td width="600" valign="top">';
        echo '        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">';
        echo '          <tr height="50">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textheader">EldoS SecureBlackbox Secure Office demo (Sign/Verify))</div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="50">';
        echo '            <td width="100%" height="*" align="center" valign="center" class="textnormal">';
        echo '              <div align="center"> This sample illustrates the use of SecureBlackbox Secure Office components to sign/verify files. </div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="*">';
        echo '            <td width="100%" height="*">';
        echo '              <form action="SecureOffice_SV.php" method="post" enctype="multipart/form-data">';
        echo '                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td width="30%" align="left"> <span class="mtx4">File info:</span> </td>';
        echo '                    <td width="10"></td>';
        echo '                    <td width="*" align="right"></td>';
        echo '                  </tr>';
        echo '                  <tr height="50">';
        echo '                    <td colspan="3" align="left">';

        $S = "Document format: " . SBOffice\DocumentFormatToString($doc->get_DocumentFormat()) . "\r\n";
        $rows = 1;
        if (!(empty($doc->get_BinaryDocument())))
        {
            $S = $S . "Document type: " . SBOffice\BinaryDocumentTypeToString($doc->get_BinaryDocument()->get_DocumentType()) . "\r\n";
            $rows++;
        }
        else
        if (!(empty($doc->get_OpenXMLDocument())))
        {
            $S = $S . "Document type: " . SBOffice\OpenXMLDocumentTypeToString($doc->get_OpenXMLDocument()->get_DocumentType()) . "\r\n";
            $rows++;
        }
        $S = $S . "\r\n";
        $rows++;

        if ($doc->get_IsEncrypted())
        {
            if (!(empty($doc->get_EncryptionHandler())))
            {
                $S = $S . "The document is ENCRYPTED using " . $doc->get_EncryptionHandler()->CastTo()->GetName() . " handler \r\n";
            }
            else
            {
                $S = $S . "The document is ENCRYPTED using UNKNOWN handler \r\n";
            }
            $rows++;

            if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLStandardEncryptionHandler')
            {
                $S = $S . " - Encryption algorithm: " .
                     SBConstants\GetAlgorithmNameByAlgorithm($doc->get_EncryptionHandler()->CastTo()->get_EncryptionAlgorithm()) . " \r\n";
                $rows++;
            }
            else
            if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeOpenXMLAgileEncryptionHandler')
            {
                $S = $S . " - Key Encryptors: " . $doc->get_EncryptionHandler()->CastTo()->get_KeyEncryptorCount() . " \r\n";
                $S = $S . " - Cipher algorithm: " .
                     SBConstants\GetAlgorithmNameByAlgorithm($doc->get_EncryptionHandler()->CastTo()->get_CipherAlgorithm()) . " \r\n";
                $S = $S . " - Hash algorithm: " .
                     SBConstants\GetAlgorithmNameByAlgorithm($doc->get_EncryptionHandler()->CastTo()->get_HashAlgorithm()) . " \r\n";
                $rows = $rows + 3;
            }
            else
            if ($doc->get_EncryptionHandler()->ClassName_Inst() == 'TElOfficeBinaryRC4CryptoAPIEncryptionHandler')
            {
                $S = $S . " - Key length: " . $doc->get_EncryptionHandler()->CastTo()->get_KeyLength() . " \r\n";
                if ($doc->get_EncryptionHandler()->CastTo()->get_EncryptDocumentProperties())
                {
                    $S = $S . " - Document properties are encrypted \r\n";
                }
                else
                {
                    $S = $S . " - Document properties are NOT encrypted \r\n";
                }
                $rows = $rows + 2;
            }
        }

        if ($doc->get_IsSigned())
        {
            $S = $S . "Document is SIGNED \r\n";
            $rows++;
        }

        if ((!$doc->get_IsEncrypted()) and (!$doc->get_IsSigned()))
        {
            $S = $S . "Document is neither encrypted nor signed \r\n";
            $rows++;
        }

        if (!empty($doc->get_OpenXMLDocument()))
        {
            if ($doc->get_OpenXMLDocument()->CastTo()->get_SignatureLineCount() > 0)
            {
                $S = $S . "Document contains " . $doc->get_OpenXMLDocument()->CastTo()->get_SignatureLineCount() . " signature line(s) \r\n";
                $rows++;
            }
        }
        else if (!empty($doc->get_OpenXPSDocument()))
        {
            if ($doc->get_OpenXPSDocument()->CastTo()->get_SignatureDefinitionCount() > 0)
            {
                $S = $S . "Document contains " . $doc->get_OpenXPSDocument()->CastTo()->get_SignatureDefinitionCount() . " signature definiotion(s) \r\n";
                $rows++;
            }
        }

        echo '                      <textarea readonly name="info" cols=60 rows=' . $rows . '>';
        echo $S;
        echo '                      </textarea>';
        echo '                    </td>';
        echo '                  </tr>';

        echo '                  <tr height="0" valign="bottom">';
        echo '                    <td colspan="3" align="left"> <input type="hidden" name="inputfile" value="' . $tempname . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="0" valign="bottom">';
        echo '                    <td colspan="3" align="left"> <input type="hidden" name="filename" value="' . $filename . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="60" valign="bottom">';
        echo '                    <td colspan="3" align="left">';

        if ($doc->get_Signable())
        {
            echo '                      <fieldset class="textnormal">';
        }
        else
        {
           echo '                      <fieldset class="textnormal" disabled="disabled">';
        }
        echo '                      <legend class="lgd">Signature options </legend>';
        echo '                        <table class="textnormal" width="100%">';
        echo '                          <tr height="30">';
        echo '                            <td width="30%" align="left"> Certificate file </td>';
        echo '                            <td width="*" align="left"> <input type="file" name="certfile" value="" size="20" /> </td>';
        echo '                            <td width="30%" align="left"> Password </td>';
        echo '                            <td width="*" align="left"> <input type="password" name="certpass" value="" size="20" /> </td>';
        echo '                          </tr>';
        echo '                          <tr height="30">';
        echo '                            <td width="30%" align="left"> Signature type </td>';
        echo '                            <td colspan="3" align="left">';

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary)
        {
            echo '                              <select name="signtype" size="1" onchange="this.form.include.disabled=!(this.form.signtype.value == 1);this.form.sigtext.disabled=!(this.form.signtype.value == 1);this.form.sigcom.disabled=!(this.form.signtype.value == 1)">';
            $handler = new TElOfficeBinaryCryptoAPISignatureHandler(NULL);
            echo '                                <option value=0 selected>' . $handler->GetName() . '</option>';
            $handler = new TElOfficeBinaryXMLSignatureHandler(NULL);
            echo '                                <option value=1>' . $handler->GetName() . '</option>';
        }
        else
        {
            echo '                              <select name="signtype" size="1">';

            if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
            {
                $handler = new TElOfficeOpenXMLSignatureHandler(NULL);
                echo '                                <option value=0 selected>' . $handler->GetName() . '</option>';
            }
            if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXPS)
            {
                $handler = new TElOfficeOpenXPSSignatureHandler(NULL);
                echo '                                <option value=0 selected>' . $handler->GetName() . '</option>';
            }
            if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenDocument)
            {
                $handler = new TElOpenOfficeSignatureHandler(NULL);
                echo '                                <option value=0 selected>' . $handler->GetName() . '</option>';
            }
        }

        echo '                              </select>';
        echo '                            <td>';
        echo '                          </tr>';

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary)
        {
            echo '                          <tr height="30">';
            echo '                            <td colspan="4" align="left" width="100%">';
            echo '                              <fieldset class="textnormal">';
            echo '                              <legend class="lgd"> Signature Info </legend>';
            echo '                                <table class="textnormal" width="100%">';
            echo '                                  <tr height="30">';
            echo '                                    <td colspan="4" align="left"> <label><input type="checkbox" name="include" value="yes" disabled/> Include </label> </td>';
            echo '                                  </tr>';
            echo '                                  <tr height="30">';
            echo '                                    <td width="21%" align="left"> Signature text </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="sigtext" value="" size="20" disabled/> </td>';
            echo '                                    <td width="35%" align="left"> Signature comments </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="sigcom" value="Type Comments Here" size="20" disabled/> </td>';
            echo '                                  </tr>';
            echo '                                </table>';
            echo '                              </fieldset>';
            echo '                            </td>';
            echo '                          </tr>';
        }

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
        {
            echo '                          <tr height="30">';
            echo '                            <td colspan="4" align="left" width="100%">';
            echo '                              <fieldset class="textnormal">';
            echo '                              <legend class="lgd"> Signature Info </legend>';
            echo '                                <table class="textnormal" width="100%">';
            echo '                                  <tr height="30">';
            echo '                                    <td colspan="4" align="left"> <label><input type="checkbox" name="include" value="yes"/> Include </label> </td>';
            echo '                                  </tr>';
            echo '                                  <tr height="30">';
            echo '                                    <td width="21%" align="left"> Signature text </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="sigtext" value="" size="20" /> </td>';
            echo '                                    <td width="35%" align="left"> Signature comments </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="sigcom" value="Type Comments Here" size="20" /> </td>';
            echo '                                  </tr>';
            echo '                                </table>';
            echo '                              </fieldset>';
            echo '                            </td>';
            echo '                          </tr>';
        }

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
        {
            echo '                          <tr height="30">';
            echo '                            <td colspan="2" align="left"> <label><input type="checkbox" name="signdoc" value="yes"/> Sign document </label> </td>';
            echo '                            <td colspan="2" align="left"> <label><input type="checkbox" name="signprop" value="yes"/> Sign document properties </label> </td>';
            echo '                          </tr>';
        }

        if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXPS)
        {
            echo '                          <tr height="30">';
            echo '                            <td colspan="4" align="left" width="100%">';
            echo '                              <fieldset class="textnormal">';
            echo '                                <legend> <label> <input type="checkbox" name="adddef" onchange="this.form.intent.disabled=!this.form.adddef.checked;this.form.signame.disabled=!this.form.adddef.checked;this.form.sigloc.disabled=!this.form.adddef.checked;this.form.sigvis.disabled=!this.form.adddef.checked"/> Add signature definition </label> </legend>';
            echo '                                <table class="textnormal" width="100%">';
            echo '                                  <tr height="30">';
            echo '                                    <td width="30%" align="left"> Intent </td>';
            echo '                                    <td colspan="3" align="left">';
            echo '                                      <select name="intent" size="1" disabled>';
            echo '                                        <option value="I am the author of this document" selected> I am the author of this document </option>';
            echo '                                        <option value="I agree to the terms defined by placement of my signature on this document"> I agree to the terms defined by placement of my signature on this document </option>';
            echo '                                        <option value="I have reviewed this document"> I have reviewed this document </option>';
            echo '                                        <option value="I attest to the accuracy and integrity of this document"> I attest to the accuracy and integrity of this document </option>';
            echo '                                        <option value="I am approving this document"> I am approving this document </option>';
            echo '                                      </select>';
            echo '                                    </td>';
            echo '                                  </tr>';
            echo '                                  <tr height="30">';
            echo '                                    <td width="30%" align="left"> Signer name </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="signame" value="" size="25" disabled/> </td>';
            echo '                                    <td width="30%" align="left"> Signer location </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="sigloc" value="" size="25" disabled/> </td>';
            echo '                                  </tr>';
            echo '                                  <tr height="30">';
            echo '                                    <td colspan="4" align="left"> <label><input type="checkbox" name="sigvis" value="yes" disabled/> Visible (IE dosn\'t support) </label> </td>';
            echo '                                  </tr>';
            echo '                                </table>';
            echo '                              </fieldset>';
            echo '                            </td>';
            echo '                          </tr>';
            echo '                          <tr height="30">';
            echo '                            <td colspan="2" align="left"> <label><input type="checkbox" name="signorig" value="yes"/> Sign signature origin </label> </td>';
            echo '                            <td colspan="2" align="left"> <label><input type="checkbox" name="signprop" value="yes"/> Sign document properties </label> </td>';
            echo '                          </tr>';
        }

        echo '                          <tr height="30" valign="bottom">';
        echo '                            <td colspan="4" align="center"> <input type="submit" name="sign" value="Sign"/> </td>';
        echo '                          </tr>';

        echo '                        </table>';
        echo '                      </fieldset>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="60" valign="bottom">';
        echo '                    <td colspan="3" align="left">';

        if ($doc->get_IsSigned())
        {
            echo '                      <fieldset class="textnormal">';
        }
        else
        {
            echo '                      <fieldset class="textnormal" disabled="disabled">';
        }
        echo '                      <legend class="lgd"> Signatures info </legend>';
        echo '                        <table class="textnormal" width="100%">';
        echo '                          <tr height="50">';
        echo '                            <td align="left">';

        $S = "";
        $rows = 0;
        for ($i = 0; $i <= $doc->get_SignatureHandlerCount() - 1; $i++)
        {
            if ($i > 0)
            {
                $S = $S . "\r\n";
                $rows++;
            }
            $S = $S . "Signature" . ($i + 1) . ": \r\n";
            $rows++;
            $handler = $doc->get_SignatureHandlers($i);
            $S = $S . "    The document is signed using \"" . $handler->CastTo()->GetName() . "\" handler \r\n";
            $rows++;
            if ($handler->ClassName_Inst() == 'TElOfficeOpenXMLInvalidSignatureHandler')
            {
                $S = $S . "    Error message: " . $handler->CastTo()->get_ErrorMessage() . "\r\n";
                $rows++;
            }
            else
            if ($handler->ClassName_Inst() == 'TElOfficeBinaryInvalidSignatureHandler')
            {
                $S = $S . "    Error message: " . $handler->CastTo()->get_ErrorMessage() . "\r\n";
                $rows++;
            }
            else 
            if (($handler->ClassName_Inst() == 'TElOfficeOpenXMLBaseSignatureHandler') or
                ($handler->ClassName_Inst() == 'TElOfficeOpenXMLSignatureHandler') or
                ($handler->ClassName_Inst() == 'TElOfficeOpenXPSSignatureHandler'))
            {
                $S = $S . "    Signature time: " . $handler->CastTo()->get_SignatureTime()->get_ValueUTC()->format('d-m-Y H:i:s') . "\r\n";
                $rows++;

                if ($handler->ClassName_Inst() == 'TElOfficeOpenXMLSignatureHandler')
                {
                    if (!empty($handler->CastTo()->get_SignatureLine()))
                    {
                        $S = $S . "    Signature is attached to the signature line: \r\n";
                        $S = $S . "     - ID: " . $handler->CastTo()->get_SignatureLine()->get_ID() . "\r\n";
                        $rows = $rows + 2;
                        if (strlen($handler->CastTo()->get_SignatureLine()->get_SuggestedSigner()) > 0) {
                            $S = $S . "     - Suggested Signer: " . $handler->CastTo()->get_SignatureLine()->get_SuggestedSigner() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureLine()->get_SuggestedSigner2()) > 0) {
                            $S = $S . "     - Suggested Signer2: " . $handler->CastTo()->get_SignatureLine()->get_SuggestedSigner2() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureLine()->get_SuggestedSignerEmail()) > 0) {
                            $S = $S . "     - Suggested Signer Email: " . $handler->CastTo()->get_SignatureLine()->get_SuggestedSignerEmail() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureLine()->get_SigningInstructions()) > 0) {
                            $S = $S . "     - Signing Instructions: " . $handler->CastTo()->get_SignatureLine()->get_SigningInstructions() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureLine()->get_AdditionalSignatureInfo()) > 0) {
                            $S = $S . "     - Additional Signature Info: " . $handler->CastTo()->get_SignatureLine()->get_AdditionalSignatureInfo() . "\r\n"; $rows++;}
                    }

                    if ($handler->CastTo()->IsDocumentSigned())
                    {
                        $S = $S . "    Document content is signed \r\n";
                        $rows++;
                    }
                    else
                    {
                        $S = $S . "    Document content is partially signed \r\n";
                        $rows++;
                    }
                }
                else
                if ($handler->ClassName_Inst() == 'TElOfficeOpenXPSSignatureHandler')
                {
                    if (!empty($handler->CastTo()->get_SignatureDefinition()))
                    {
                        $S = $S . "    Signature is attached to the signature definition: \r\n";
                        $S = $S . "     - Spot ID: " . $handler->CastTo()->get_SignatureDefinition()->get_SpotID() . "\r\n";
                        $rows = $rows + 2;
                        if (strlen($handler->CastTo()->get_SignatureDefinition()->get_Intent()) > 0) {
                            $S = $S . "     - Intent: " . $handler->CastTo()->get_SignatureDefinition()->get_Intent() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureDefinition()->get_SignerName()) > 0) {
                            $S = $S . "     - Signer Name: " . $handler->CastTo()->get_SignatureDefinition()->get_SignerName() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureDefinition()->get_SigningLocation()) > 0) {
                            $S = $S . "     - Signing Location: " . $handler->CastTo()->get_SignatureDefinition()->get_SigningLocation() . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureDefinition()->get_SignBy()) > 0) {
                            $S = $S . "     - Sign By: " . $handler->CastTo()->get_SignatureDefinition()->get_SignByUTC()->format('d-m-Y H:i:s') . "\r\n"; $rows++;}

                        if (strlen($handler->CastTo()->get_SignatureDefinition()->get_PageURI()) > 0) {
                            $S = $S . "     - Page URI: " . $handler->CastTo()->get_SignatureDefinition()->get_PageURI() . "\r\n"; $rows++;}
                    }

                    if (!$handler->CastTo()->IsDocumentSigned())
                    {
                        $S = $S . "    This is NOT an OpenXPS signature \r\n";
                        $rows++;
                    }

                    if ($handler->CastTo()->IsSignatureOriginSigned())
                    {
                        $S = $S . "    Signature origin is signed \r\n";
                        $rows++;
                    }
                }

                if ($handler->CastTo()->IsCorePropertiesSigned())
                {
                    $S = $S . "    Document properties are signed \r\n";
                    $rows++;
                }
            }
            else
            if ($handler->ClassName_Inst() == 'TElOfficeBinaryCryptoAPISignatureHandler')
            {
                $S = $S .  "    Sign time: " . $handler->CastTo()->get_SignTime()->format('d-m-Y H:i:s') . "\r\n";
                $rows++;
                if ($handler->CastTo()->get_ExpireTime()->format('d-m-Y H:i:s') != '30-12-1899 00:00:00')
                {
                    $S = $S . "    Expire time: " . $handler->CastTo()->get_ExpireTime()->format('d-m-Y H:i:s') . "\r\n";
                    $rows++;
                }
            }
            else
            if ($handler->ClassName_Inst() == 'TElOfficeBinaryXMLSignatureHandler')
            {
                $S = $S . "    Signature time: " . $handler->CastTo()->get_SignatureTime()->get_ValueUTC()->format('d-m-Y H:i:s') . "\r\n";
                $rows++;
            }
            else
            if ($handler->ClassName_Inst() == 'TElOpenOfficeSignatureHandler')
            {
                $S = $S . "    Signature time: " . $handler->CastTo()->get_SignatureTime()->get_ValueUTC()->format('d-m-Y H:i:s') . "\r\n";
                if ($handler->CastTo()->IsDocumentSigned())
                {
                    $S = $S . "    Document content is signed \r\n";
                    $rows++;
                }
                else
                {
                    $S = $S . "    Document content is partially signed \r\n";
                    $rows++;
                }
            }
        }

        echo '                              <textarea readonly name="info" cols=70 rows=' . $rows . '>';
        echo $S;
        echo '                              </textarea>';
        echo '                            </td>';
        echo '                          </tr>';
        echo '                          <tr height="30" valign="bottom">';
        echo '                            <td align="center"> <input type="submit" name="validate" value="Validate"/> </td>';
        echo '                          </tr>';
        echo '                        </table>';
        echo '                      </fieldset>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>';
        echo '                  </tr>';
        echo '                </table>';
        echo '              </form>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="20">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>';
        echo '            </td>';
        echo '          </tr>';
        echo '        </table>';
        echo '      </td>';
        echo '    </tr>';
        echo '    <tr height="*"></tr>';
        echo '  </table>';
        echo '  </div>';
        echo '</body>';
        echo '</html>';
    }

    if (isset($_POST["validate"])) 
    {
        $inputfile = $_POST["inputfile"];
        $filename = $_POST["filename"];

        try
        {
            $doc->Open($inputfile, false);

            $S = "Result of validation: <br/><br/>";
            for ($i = 0; $i <= $doc->get_SignatureHandlerCount() - 1; $i++)
            {
                $handler = $doc->get_SignatureHandlers($i);
                $ValidationStatus = $handler->CastTo()->Validate();

                if (($handler->ClassName_Inst() == 'TElOfficeOpenXMLBaseSignatureHandler') or
                    ($handler->ClassName_Inst() == 'TElOfficeOpenXMLSignatureHandler') or
                    ($handler->ClassName_Inst() == 'TElOfficeOpenXPSSignatureHandler'))
                {
                    if ($ValidationStatus == TSBOfficeOpenXMLSignatureValidationStatus::svsValid)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is VALID <br/>';
                    }
                    else if ($ValidationStatus = TSBOfficeOpenXMLSignatureValidationStatus::svsValidButNotParts)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' integrity is ok, but some of parts are INVALID <br/>';
                    }
                    else
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is INVALID <br/>';
                    }
                }
                else
                if ($handler->ClassName_Inst() == 'TElOfficeBinaryCryptoAPISignatureHandler')
                {
                    if ($ValidationStatus == TSBOfficeBinarySignatureValidationStatus::bsvsValid)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is VALID <br/>';
                    }
                    else
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is INVALID <br/>';
                    }
                }
                else
                if ($handler->ClassName_Inst() == 'TElOfficeBinaryXMLSignatureHandler')
                {
                    if ($ValidationStatus == TSBOfficeBinarySignatureValidationStatus::bsvsValid)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is VALID <br/>';
                    }
                    else if ($ValidationStatus = TSBOfficeBinarySignatureValidationStatus::bsvsValidButNotEntries)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' integrity is ok, but some of entries are INVALID <br/>';
                    }
                    else
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is INVALID <br/>';
                    }
                }
                else
                if ($handler->ClassName_Inst() == 'TElOpenOfficeSignatureHandler')
                {
                    if ($ValidationStatus == TSBOpenOfficeSignatureValidationStatus::osvsValid)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is VALID <br/>';
                    }
                    else if ($ValidationStatus = TSBOpenOfficeSignatureValidationStatus::osvsValidButNotEntries)
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' integrity is ok, but some of entries are INVALID <br/>';
                    }
                    else
                    {
                        $S = $S . 'Signature' . ($i + 1) . ' is INVALID <br/>';
                    }
                }
            }

            print $S;
            return;
        }
        catch(SBException $e)
        {
            print $e->getMessage();
        }
    }

    if (isset($_POST["sign"])) 
    {
        $inputfile = $_POST["inputfile"];
        $filename = $_POST["filename"];
        $certfile = $_FILES["certfile"]["tmp_name"];
        $certpass = $_POST["certpass"];
        $signtype = $_POST["signtype"];
        $include = (isset($_POST['include']) && $_POST['include'] == 'yes');
        if (isset($_POST['signdoc'])) {$sigtext = $_POST["sigtext"];}
        if (isset($_POST['sigcom'])) {$sigcom = $_POST["sigcom"];}

        $signdoc = (isset($_POST['signdoc']) && $_POST['signdoc'] == 'yes');
        $signprop = (isset($_POST['signprop']) && $_POST['signprop'] == 'yes');

        $adddef = (isset($_POST['adddef']) && $_POST['adddef'] == 'yes');
        if (isset($_POST['intent'])) {$intent = $_POST["intent"];}
        if (isset($_POST['signame'])) {$signame = $_POST["signame"];}
        if (isset($_POST['sigloc'])) {$sigloc = $_POST["sigloc"];}
        $sigvis = (isset($_POST['sigvis']) && $_POST['sigvis'] == 'yes');
        $signorig = (isset($_POST['signorig']) && $_POST['signorig'] == 'yes');
        $signprop = (isset($_POST['signprop']) && $_POST['signprop'] == 'yes');

        if (strlen($certfile) > 0)
        {
            try
            {
                $doc->Open($inputfile, false);

                $cert = new TElX509Certificate(NULL);
                $r = $cert->LoadFromFileAuto($certfile, $certpass);
                if ($r != 0)
                {
                    print 'Failed to load certificate, error ' . $r;
                    return;
                }

                $handler;
                if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfBinary)
                {
                    if ($signtype == 0)
                    {
                        $handler = new TElOfficeBinaryCryptoAPISignatureHandler(NULL);
                        $doc->AddSignature($handler, false);

                        $date = new DateTime();
                        $date->add(new DateInterval('P100Y'));
                        $handler->set_ExpireTime($date);
                        $handler->Sign($cert);
                    }
                    else
                    {
                        $handler = new TElOfficeBinaryXMLSignatureHandler(NULL);
                        $doc->AddSignature($handler, false);

                        $handler->get_SignatureInfoV1()->set_Included($include);
                        $handler->get_SignatureInfoV1()->set_SignatureText($sigtext);
                        $handler->get_SignatureInfoV1()->set_SignatureComments($sigcom);
                        $handler->Sign($cert);
                    }
                }

                if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXML)
                {
                    $handler = new TElOfficeOpenXMLSignatureHandler(NULL);
                    $doc->AddSignature($handler, false);

                    if ($signdoc)
                    {
                        $handler->AddDocument();
                    }
                    else
                    {
                        $handler->AddPart($doc->get_OpenXMLDocument()->get_OfficeDocumentPart());
                    }

                    if ($signprop)
                    {
                        $handler->AddCoreProperties();
                    }

                    $handler->get_SignatureInfoV1()->set_Included($include);
                    $handler->get_SignatureInfoV1()->set_SignatureText($sigtext);
                    $handler->get_SignatureInfoV1()->set_SignatureComments($sigcom);

                    $handler->Sign($cert);
                }

                if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenXPS)
                {
                    $handler = new TElOfficeOpenXPSSignatureHandler(NULL);
                    $doc->AddSignature($handler, false);

                    $handler->AddDocument();

                    if ($signprop)
                    {
                        $handler->AddCoreProperties();
                    }

                    if ($signorig)
                    {
                        $handler->AddSignatureOrigin();
                    }

                    if ($adddef)
                    {
                        $date = new DateTime();
                        $date->add(new DateInterval('P1Y'));

                        if ($sigvis)
                        {
                            $doc->get_OpenXPSDocument()->AddSignatureDefinition($intent, $signame, $sigloc, $date,
                                  $doc->get_OpenXPSDocument()->get_FixedDocuments(0)->get_PageContents(0)->get_Source(), 100, 100);
                        }
                        else
                        {
                            $doc->get_OpenXPSDocument()->AddSignatureDefinition($intent, $signame, $sigloc, $date);
                        }
            
                        $num = $doc->get_OpenXPSDocument()->get_SignatureDefinitionCount() - 1;
                        $doc->get_OpenXPSDocument()->get_SignatureDefinitions($num)->set_SignatureHandler($handler);
                    }

                    $handler->Sign($cert);
                }

                if ($doc->get_DocumentFormat() == TSBOfficeDocumentFormat::dfOpenDocument)
                {
                    $handler = new TElOpenOfficeSignatureHandler(NULL);
                    $doc->AddSignature($handler, false);

                    $handler->AddDocument();

                    $handler->Sign($cert);
                }

                $doc->Close();

                if (ob_get_level()) 
                {
                        ob_end_clean();
                }

                header('Content-Description: File Transfer');
                header('Content-Type: application/octet-stream');
                header("Content-Disposition: attachment; filename=$filename");
                header('Content-Transfer-Encoding: binary');
                header('Expires: 0');
                header('Cache-Control: must-revalidate');
                header('Pragma: public');
                header('Content-Length: ' . filesize($inputfile));
                readfile($inputfile);

                unlink($inputfile);

                return;
                //print "Sign succeeded";
            }
            catch(SBException $e)
            {
                print $e->getMessage();
            }
        }
        else
        {
            print "Certificate file is not provided";
        }
    }

    if (isset($_POST["open"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if (strlen($inputfile) > 0)
        {
            $tempname = tempnam(sys_get_temp_dir(), $filename);

            if (!copy($inputfile, $tempname)) 
            {
                print "Can not copy $inputfile...\n";
                die;
            }

            try
            {
                $doc->Open($tempname, true);

                ShowForm();

                $doc->Close();
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
            }
        }
        else
        {
            print "Office file is not provided";
        }
    }
?>