<?php 
    date_default_timezone_set("UTC");

    $tempname = "";

    function DoKeyPassword($Sender, $Key, &$Password)
    {
        $Password = $_POST["pass"];
    }

    function DoOutputFile($Sender, $Filename, $TimeStamp, &$Path)
    {
        $Path = $GLOBALS["tempname"];
    }

    if (isset($_POST["unprotect"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            return;
        }

        $pkey = $_FILES["pkey"]["tmp_name"];
        $skey = $_FILES["skey"]["tmp_name"];
        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if ((strlen($pkey) > 0) and (strlen($skey) > 0) and (strlen($inputfile) > 0))
        {
            $pgpKeyring = new TElPGPKeyring(NULL);

            try
            {
                $pgpKeyring->Load($pkey, $skey, true);
            }
            catch(SBException $e) 
            {
                print "Failed to load keyring : " . $e->getMessage() ." <br/>";
                return;
            }

            $reader = new TElPGPReader(NULL);
            $reader->DecryptingKeys = $pgpKeyring;
            $reader->VerifyingKeys = $pgpKeyring;
            $reader->OnKeyPassphrase = "DoKeyPassword";
            $reader->OnRequestOutputFile = "DoOutputFile";

            try
            {
                $yourfile = basename($filename);
                $p = strrpos($yourfile, ".pgp");
                if ($p > 0) 
                    $yourfile = substr($yourfile, 0, $p);

                $GLOBALS["tempname"]= tempnam(sys_get_temp_dir(), $yourfile);

                $reader->DecryptAndVerifyFile($inputfile);

                header("Content-Disposition: attachment; filename=$yourfile");

                readfile($GLOBALS["tempname"]);

                unlink($GLOBALS["tempname"]);

                return;
            }
            catch(SBException $e) 
            {
                unlink($GLOBALS["tempname"]);

                print "Unprotection operation failed: " . $e->getMessage() ." <br/>";
            }
        }
        else
        {
            $error_details = "";

            if (strlen($pkey) == 0)
            {
                $error_details = $error_details . "Public keyring file is not provided<br/>";
            }
            if (strlen($skey) == 0)
            {
                $error_details = $error_details . " Secret keyring file is not provided <br/>";
            }
            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "OpenPGP-protected file is not provided <br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS OpenPGP unprotect demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox OpenPGP unprotect demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox OpenPGP components for unprotecting OpenPGP-protected files<br/>
              Please provide your keyring files and the file to unprotect and click the 'Unprotect' button to unprotect the file.</div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="40%" align="right"> Public keyring file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="pkey" value="" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Secret keyring file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="skey" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Key password: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="password" name="pass" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> OpenPGP file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="inputfile" value="" size="30" /> </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="unprotect" value="Unprotect"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>