<?php

    // This script displays the signing log and allows the user to download the signed file.
    // The user's browser is redirected here by the applet.

    error_reporting(E_ALL);
    date_default_timezone_set("UTC");
    
    if (!isset($_GET["sessionid"])) {
        print "No session information found. Please start again from <a href='../'>the main page</a>.";
	return; 
    }

    $session_id = $_GET["sessionid"];

    // creating per-session temporary directory for the signing operation
    $path = "../work/" . $session_id;

    if (is_dir($path) === false) {
        print "No session information found. Please start again from <a href='../'>the main page</a>.";
        return;
    }

    // reading the status
    $f = fopen($path . "/status.txt", "r");
    $flag = fread($f, 1);
    fclose($f);

    // reading the log
    $f = fopen($path . "/log.txt", "r");
    $log = fread($f, 8192);
    fclose($f);
    
    $resstr = "";
    if ($flag == "1") {
        // the signing was successful
        $url = "../work/" . $session_id . "/completed.pdf";
        $resstr = "The signing was successful. Download the resulting document <a href=\"$url\">here</a>.";
    } else {
        // the signing was unsuccessful
        $resstr = "Error happened during signing. Please check the log.";
    }

?>

<html>
<head>
  <title>EldoS PDF Distributed Signer demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox Distributed PDF Signer demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> 
                This is the final step of the distributed signing protocol. Below you will see the result
                of the whole signing operation and the log.
                <br /><br />
              </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*" class="textnormal">
              <div align="center">
                <?php print $resstr; ?>
              </div><br /><br /><br />
              Signing log:<br /><br />
              <textarea cols="40" rows="8"><?php print $log; ?></textarea><br /><br />
              <div align="center">
                <a href="../">Start again</a>
              </div><br />
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>
</body>
</html>