<?php 
    date_default_timezone_set("UTC");

    $decryptor = new TElXMLDecryptor(NULL);
    $inputfile = "";
    $filename = "";
    $tempname = "";

    function ShowForm()
    {
        global $decryptor;
        global $filename;
        global $tempname;

        echo '<html>';
        echo '<head>';
        echo '  <title>EldoS XML demo</title>';
        echo '  <style type="text/css">';
        echo '  .textheader {';
        echo '    font-family: Arial;';
        echo '    font-size: 16;';
        echo '    font-weight: bold;';
        echo '  }';
        echo '  .textnormal {';
        echo '    font-family: Arial;';
        echo '    font-size: 12;';
        echo '  }';
        echo '  </style>';
        echo '</head>';
        echo '<body>';
        echo '  <div align="center">';
        echo '  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">';
        echo '    <tr height="*"></tr>';
        echo '    <tr height="400">';
        echo '      <td width="600" valign="top">';
        echo '        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">';
        echo '          <tr height="50">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textheader">EldoS SecureBlackbox XML demo</div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="70">';
        echo '            <td width="100%" height="*" align="center" valign="center" class="textnormal">';
        echo '              <div align="center"> This sample illustrates the use of SecureBlackbox XML components for decrypting xml files. <br/>';
        echo '              Please provide key file and click the "Decrypt" button to decrypt xml file. </div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="*">';
        echo '            <td width="100%" height="*">';
        echo '              <form action="XML_Decrypt.php" method="post" enctype="multipart/form-data">';
        echo '                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="inputfile" value="' . $tempname . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="0">';
        echo '                    <td colspan="3"> <input type="hidden" name="filename" value="' . $filename . '" size="30" /> </td>';
        echo '                  </tr>';
        echo '                  <tr height="30">';
        echo '                    <td colspan="3" align="left">';
        echo '                      <fieldset>';
        echo '                        <legend> Decryption options </legend>';
        echo '                        <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                          <tr height="30">';
        echo '                            <td width="*">';
        echo '                              <fieldset>';
        echo '                                <legend> General  </legend>';
        echo '                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                                  <tr height="30">';
        echo '                                    <td width="40%" align="right"> Encrypted data type </td>';
        echo '                                    <td width="10" > &nbsp;&nbsp; </td>';

        $s = "";
        switch ($decryptor->get_EncryptedDataType())
        {
            case TElXMLEncryptedDataType::xedtContent : $s = "Content"; break;
            case TElXMLEncryptedDataType::xedtExternal : $s = "External file"; break;
            default : $s = "Element";
        }

        echo '                                    <td width="*" align="left"> <input type="text" name="datatype" value="' . $s . '" size="25" disabled/> </td>';
        echo '                                  </tr>';
        echo '                                  <tr height="30">';
        echo '                                    <td width="40%" align="right"> Encryption method </td>';
        echo '                                    <td width="10" > </td>';

        $s = "";
        switch ($decryptor->get_EncryptionMethod())
        {
            case TElXMLEncryptionMethod::xemAES : $s = "AES"; break;
            case TElXMLEncryptionMethod::xemCamellia : $s = "Camellia"; break;
            case TElXMLEncryptionMethod::xemDES : $s = "DES"; break;
            case TElXMLEncryptionMethod::xemRC4 : $s = "RC4"; break;
            case TElXMLEncryptionMethod::xemSEED : $s = "SEED"; break;
            case TElXMLEncryptionMethod::xemAES_GCM : $s = "AES-GCM"; break;
            default : $s = "3DES";
        }

        echo '                                    <td width="*" align="left"> <input type="text" name="encmethod" value="' . $s . '" size="25" disabled/> </td>';
        echo '                                  </tr>';

        if ($decryptor->get_EncryptedDataType() == TElXMLEncryptedDataType::xedtExternal)
        {
            echo '                                  <tr height="30">';
            echo '                                    <td width="40%" align="right"> Mime type </td>';
            echo '                                    <td width="10"> </td>';
            echo '                                    <td width="*" align="left"> <input type="text" name="mime" value="' . $decryptor->get_MimeType() . '" size="25" disabled/> </td>';
            echo '                                  </tr>';
        }

        echo '                                </table>';
        echo '                              </fieldset>';
        echo '                            </td>';
        echo '                          </tr>';
        echo '                          <tr height="40">';
        echo '                            <td width="*">';

        if ($decryptor->get_EncryptKey())
        {
            echo '                              <fieldset>';
            echo '                                <legend> <label> <input type="checkbox" name="enckey" value="yes" checked disabled/> Encrypt key </label> </legend>';
            echo '                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
            echo '                                  <tr height="30">';

            if ($decryptor->get_KeyEncryptionType() == TElXMLKeyEncryptionType::xetKeyTransport)
            {
                echo '                                    <td width="40%" align="right"> <label> Key Transport </label> </td>';
                echo '                                    <td width="10"></td>';

                $s = "";
                switch ($decryptor->get_KeyTransportMethod())
                {
                    case TElXMLKeyTransportMethod::xktRSA15 : $s = "RSA v1.5"; break;
                    default : $s = "RSA-OAEP";
                }
                echo '                                    <td width="*" align="left"> <input type="text" name="keytransport" value="' . $s . '" size="25" disabled/> </td>';
            }
            else
            {
                echo '                                    <td width="40%" align="right"> <label> Key Transport </label> </td>';
                echo '                                    <td width="10"></td>';

                $s = "";
                switch ($decryptor->get_KeyWrapMethod())
                {
                    case TElXMLKeyWrapMethod::xwmAES128 : $s = "AES 128 bit"; break;
                    case TElXMLKeyWrapMethod::xwmAES192 : $s = "AES 192 bit"; break;
                    case TElXMLKeyWrapMethod::xwmAES256 : $s = "AES 256 bit"; break;
                    case TElXMLKeyWrapMethod::xwmCamellia128 : $s = "Camellia 128 bit"; break;
                    case TElXMLKeyWrapMethod::xwmCamellia192 : $s = "Camellia 192 bit"; break;
                    case TElXMLKeyWrapMethod::xwmCamellia256 : $s = "Camellia 256 bit"; break;
                    case TElXMLKeyWrapMethod::xwmSEED : $s = "SEED 128 bit"; break;
                    default : $s = "3DES";
                }
                echo '                                    <td width="*" align="left"> <input type="text" name="keywrap" value="' . $s . '" size="25" disabled/> </td>';
            }
            echo '                                  </tr>';
            echo '                                </table>';
            echo '                              </fieldset>';
        }
        else
        {
            echo '                                <label> <input type="checkbox" name="enckey" value="yes" disabled/> Encrypt key </label>';
        }

        echo '                            </td>';
        echo '                          </tr>';
        echo '                          <tr height="30">';
        echo '                            <td width="*">';
        echo '                              <fieldset>';
        echo '                                <legend> Key Info </label> </legend>';
        echo '                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                                  <tr height="30">';
        echo '                                    <td width="20%" align="left"> Key name </td>';
        echo '                                    <td width="*" align="left"> <input type="text" name="keyname" value="' . $decryptor->get_KeyName() . '" size="25" disabled/> </td>';
        echo '                                    <td width="10" > &nbsp;&nbsp; </td>';
        echo '                                    <td width="20%" align="left"> Key file </td>';
        echo '                                    <td width="*" align="left"> <input type="file" name="keyfile" value="" size="25"/> </td>';
        echo '                                  </tr>';

        if ($decryptor->get_EncryptKey())
        {
            if ($decryptor->get_KeyEncryptionType() == TElXMLKeyEncryptionType::xetKeyTransport)
            {
                echo '                                  <tr height="30">';
                echo '                                    <td width="20%" align="left"> Passphrase </td>';
                echo '                                    <td colspan=4 align="left"> <input type="password" name="password" value="" size="25"/> </td>';
                echo '                                  </tr>';
            }
        }

        echo '                                </table>';
        echo '                              </fieldset>';
        echo '                            </td>';
        echo '                          </tr>';
        echo '                        </table>';
        echo '                      </fieldset>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="45" valign="center">';
        echo '                    <td colspan="3" align="center"> <input type="submit" name="decrypt" value="Decrypt"/> </td>';
        echo '                  </tr>';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>';
        echo '                  </tr>';
        echo '                </table>';
        echo '              </form>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="20">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>';
        echo '            </td>';
        echo '          </tr>';
        echo '        </table>';
        echo '      </td>';
        echo '    </tr>';
        echo '    <tr height="*"></tr>';
        echo '  </table>';
        echo '  </div>  ';
        echo '</body>';
        echo '</html>';
    }

    if (isset($_POST["decrypt"])) 
    {
        $inputfile = $_POST["inputfile"];
        $filename = $_POST["filename"];
        $keyfile = $_FILES["keyfile"]["tmp_name"];
        if (isset($_POST['password'])) {$password = $_POST['password'];}

        if ((strlen($inputfile) > 0) and (strlen($keyfile) > 0))
        {
            $in = new TMemoryStream;
            $in->LoadFromFile($inputfile);

            $xmldoc = new TElXMLDOMDocument();
            try
            {
                $xmldoc->LoadFromStream($in);
                $node = $xmldoc->get_DocumentElement();
                if (!($node->ClassName_Inst() == 'TElXMLDOMElement') or
                ($node->CastTo()->get_LocalName() != 'EncryptedData'))
                {
                    $find = false;

                    $node = $node->get_FirstChild();
                    while (!empty($node))
                    {
                        if ($node->CastTo()->get_LocalName() == 'EncryptedData') {$find = true; break;}

                        $node = $node->get_NextSibling();
                    }

                    if (!$find)
                    {
                        print 'Selected XML file is not encrypted';
                        return;
                    }
                }
                $decryptor->Load($node->CastTo());
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
                return;
            }

            try
            {
                if ($decryptor->get_EncryptKey())
                {
                    if ($decryptor->get_KeyEncryptionType() == TElXMLKeyEncryptionType::xetKeyWrap)
                    {
                        $syskekdata = new TElXMLKeyInfoSymmetricData(true);

                        $keystream = new TMemoryStream;
                        $keystream->LoadFromFile($keyfile);

                        $syskekdata->get_Key()->Load($keystream, $keystream->Size);

                        $decryptor->set_KeyEncryptionKeyData($syskekdata);
                    }
                    else
                    {
                        $rsakeydata = new TElXMLKeyInfoRSAData(true);
                        $rsakeydata->get_RSAKeyMaterial()->set_Passphrase($password);
                        $x509keydata = new TElXMLKeyInfoX509Data(true);

                        $keystream = new TMemoryStream;
                        $keystream->LoadFromFile($keyfile);

                        try
                        {
                            $rsakeydata->get_RSAKeyMaterial()->LoadSecret($keystream, $keystream->Size);
                        }
                        catch(SBException $e) {}

                        if (!($rsakeydata->get_RSAKeyMaterial()->get_SecretKey()))
                        {
                            $cert = new TElX509Certificate(NULL);
                            $r = $cert->LoadFromFileAuto($keyfile, $password);
                            if ($r == 0)
                            {
                                $x509keydata->set_Certificate($cert);
                            }
                        }

                        if ($rsakeydata->get_RSAKeyMaterial()->get_SecretKey())
                        {
                            $decryptor->set_KeyEncryptionKeyData($rsakeydata);
                        }
                        else
                        if (!empty($x509keydata->get_Certificate()))
                        {
                            $decryptor->set_KeyEncryptionKeyData($x509keydata);
                        }
                        else
                        {
                            print "Key not loaded";
                            return;
                        }
                    }
                }
                else
                {
                    $symkeydata = new TElXMLKeyInfoSymmetricData(true);

                    $keystream = new TMemoryStream;
                    $keystream->LoadFromFile($keyfile);
                    $keystream->set_Position(0);

                    $symkeydata->get_Key()->Load($keystream, $keystream->get_Size());

                    $decryptor->set_KeyData($symkeydata);
                }

                $Res = $decryptor->Decrypt($xmldoc);
                if ($Res != SBXMLEnc\SB_XML_ENC_ERROR_OK)
                {
                    if ((!$decryptor->get_EncryptKey() and ($Res == SBXMLEnc\SB_XML_ENC_ERROR_INVALID_KEY)) or
                        ($decryptor->get_EncryptKey() and ($Res == SB_XML_ENC_ERROR_INVALID_KEK)))
                    {
                        print "Decryption failed. Bad key or data is corrupted.";
                        return;
                    }
                    else
                    {
                        print "Decryption failed. Error code: " . $Res;
                        return;
                    }
                }

                if ($decryptor->get_EncryptedDataType() == TElXMLEncryptedDataType::xedtExternal) 
                {
                    $yourfile = basename($filename) . ".tmp";
                    $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                    file_put_contents($tempname, $decryptor->get_DecryptedData());

                    if (ob_get_level()) 
                    {
                        ob_end_clean();
                    }

                    header('Content-Description: File Transfer');
                    header('Content-Type: application/octet-stream');
                    header("Content-Disposition: attachment; filename=$filename");
                    header('Content-Transfer-Encoding: binary');
                    header('Expires: 0');
                    header('Cache-Control: must-revalidate');
                    header('Pragma: public');
                    header('Content-Length: ' . filesize($tempname));
                    readfile($tempname);

                    unlink($tempname);
                }
                else
                {
                    if (!empty($decryptor->get_DecryptedNode()))
                    {
                        if ($node->ClassName_Inst() == 'TElXMLDOMDocument')
                        {
                            $xmldoc->ReplaceChild($decryptor->get_DecryptedNode(), $xmldoc->get_DocumentElement());
                        }
                            else
                        {
                            $node->get_ParentNode()->ReplaceChild($decryptor->get_DecryptedNode(), $node);
                        }
                    }
                    else
                    if (($decryptor->get_EncryptedDataType() == TElXMLEncryptedDataType::xedtContent) and
                        !empty($decryptor->get_DecryptedNodeList()))
                    {
                        $T = $node->get_ParentNode();
                        for ($i = 0; $i <= $decryptor->get_DecryptedNodeList()->Length - 1; $i++)
                        {
                            $T->InsertBefore($decryptor->get_DecryptedNodeList()->get_Item($i)->CloneNode(True), $node);
                        }

                        $T->RemoveChild($node);
                    }

                    $out = new TMemoryStream;
                    $xmldoc->SaveToStream($out);

                    $yourfile = basename($filename) . ".tmp";
                    $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                    $out->SaveToFile($tempname);

                    if (ob_get_level()) 
                    {
                        ob_end_clean();
                    }

                    header('Content-Description: File Transfer');
                    header('Content-Type: application/octet-stream');
                    header("Content-Disposition: attachment; filename=$filename");
                    header('Content-Transfer-Encoding: binary');
                    header('Expires: 0');
                    header('Cache-Control: must-revalidate');
                    header('Pragma: public');
                    header('Content-Length: ' . filesize($tempname));
                    readfile($tempname);

                    unlink($tempname);
                }

                unlink($inputfile);
                //print "Ok";
                return;
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
            }
        }
        else
        {
            $error_details = "";

            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "XML file is not provided<br/>";
            }
            if (strlen($keyfile) == 0)
            {
                $error_details = $error_details . "Key file is not provided <br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }

    if (isset($_POST["open"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if (strlen($inputfile) > 0)
        {
            $in = new TMemoryStream;
            $in->LoadFromFile($inputfile);

            $xmldoc = new TElXMLDOMDocument();
            try
            {
                $xmldoc->LoadFromStream($in);
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
                return;
            }

            $node = $xmldoc->get_DocumentElement();

            if (!($node->ClassName_Inst() == 'TElXMLDOMElement') or
                ($node->CastTo()->get_LocalName() != 'EncryptedData'))
            {
                $find = false;

                $node = $node->get_FirstChild();
                while (!empty($node))
                {
                    if ($node->CastTo()->get_LocalName() == 'EncryptedData') {$find = true; break;}

                    $node = $node->get_NextSibling();
                }

                if (!$find)
                {
                    print 'Selected XML file is not encrypted';
                    return;
                }
            }

            try
            {
                $decryptor->Load($node->CastTo());
            }
            catch(SBException $e) 
            {
                print 'Encrypted data loading failed. (' . $e->getMessage() . ')';
                return;
            }

            $tempname = tempnam(sys_get_temp_dir(), $filename);

            if (!copy($inputfile, $tempname)) 
            {
                print "Can not copy $inputfile...\n";
                die;
            }

            ShowForm();
        }
        else
        {
            print "XML file is not provided";
        }
    }
?>