<?php
    error_reporting(E_ALL);
    date_default_timezone_set("UTC");
    
    $pass = "";
    $eprocess = "";
    
    function OnUserActionNeeded($Sender, $ForEvent, $Description, $Param, &$UserAction)
    {
        global $eprocess;
        $eprocess .= "Extraction. " .$Description ." <br/>";
        $UserAction = SBArcZip\ZIP_ACTION_ABORT;
        // see information about OnUserActionNeeded callback at https://www.eldos.com/documentation/sbb/documentation/ref_cl_zipreader_evt_onuseractionneeded.html
    }
    
    function OnPasswordNeeded($Sender, $Param, &$Password, &$Cancel)
    {
        global $pass;
        $Password = $pass;
    }
    
    function OnProgress($Sender, $Processed, $Total, $OverallProcessed, $OverallTotal, &$Cancel)
    {
        global $eprocess;
        $eprocess .= "Extraction. Progress: current " .$Processed ." / " .$Total .", total " .$OverallProcessed ." / " .$OverallTotal ." <br/>";
    }
    
    function OnExtractionStart($Sender, $Entry, &$Extract)
    {
        $path = $Entry->Path;
        global $eprocess;
        $eprocess .= "Extraction. Current file: " .$path ." <br/>";
    }
    
    function OnExtractionFinished($Sender, $Entry)
    {
        if (!$Entry->IsDirectory) {
            $name = $Entry->FileName;
            global $eprocess;
            $eprocess .= "Extraction. File extracted: " .$name ." <br/>";
        }
    }
    
    if (isset($_POST["unpack"])) {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) {
            print "SecureBlackbox extension NOT available";
            die;
        }
        
        try {
            if (!SBUtils\GetLicense()) {
                #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it in "sbb.license_key" php.ini directive or here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
                SBUtils\SetLicenseKey("<enter license key here>");
            }
        } catch (SBException $e) {
            print "<p style='color:red'>Setting SBB License Key failed with message: <br/>" . $e->getErrorMessage() . "</p>";
            die;
        }
        
        $pass = $_POST["pass"];
        $filename = "";
        if ($_FILES["filename"]["error"] == 0) {
            $filename = $_FILES["filename"]["tmp_name"];
        }
        
        if (strlen($filename) > 0) {
            $error_happened = false;
            $error_details = "";
            
            $zipReader = new TElZipReader(null);
            $zipReader->OnUserActionNeeded = "OnUserActionNeeded";
            $zipReader->OnExtractionStart = "OnExtractionStart";
            $zipReader->OnExtractionFinished = "OnExtractionFinished";
            $zipReader->OnPasswordNeeded = "OnPasswordNeeded";
            $zipReader->OnProgress = "OnProgress";
            
            try {
                $zipReader->Open($filename, false);
                $outputPath = SBStrUtils\SBExtractFilePath($filename);
                $zipReader->Extract("*.*", $outputPath);
                $zipReader->Close();
            } catch(SBException $e) {
                $error_happened = true;
                $error_details = "Unpacking zip archive failed with message: " . $e->getErrorMessage();
            }
            
            if (!$error_happened) {
                if (strlen($eprocess) == 0) {
                    print "Zero files were extracted";
                } else {
                    print "Extraction process: <br/><br/>" .$eprocess;
                }
            } else {
                print "Error happened: <br/>" . $error_details;
            }
            
            return;
        } else {
            $error_details = "";
            if (strlen($filename) == 0) {
                $error_details = $error_details . "Archive file for unpacking is not specified <br/>";
            }
            print "Error happened: <br/><br/>" . $error_details;
        }
    }     
?>

<html>
<head>
  <title>EldoS ZIP Reader demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox ZIP Reader demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox components for unpacking zip archive. <br/>
              Please select zip-archive file and provide archive password if needed, next click the 'Unpack' button to unpack archive. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="40%" align="right"> Archive file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="filename" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Archive password: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input width="20" type="password" name="pass" value="" size="20" /> <td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="unpack" value="Unpack"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>
</body>
</html>