#include "sbarctar.h"

void SB_CALLBACK TSBTarExtractionFinishedEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zEntry;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEntry;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarExtractionMakeDirectoryEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zEntry;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEntry;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Processed, int64_t Total, int64_t OverallProcessed, int64_t OverallTotal, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zProcessed;
	zval * zTotal;
	zval * zOverallProcessed;
	zval * zOverallTotal;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProcessed);
	ZVAL_LONG(zProcessed, (long)Processed);
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zOverallProcessed);
	ZVAL_LONG(zOverallProcessed, (long)OverallProcessed);
	MAKE_STD_ZVAL(zOverallTotal);
	ZVAL_LONG(zOverallTotal, (long)OverallTotal);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zProcessed;
	params[2] = &zTotal;
	params[3] = &zOverallProcessed;
	params[4] = &zOverallTotal;
	params[5] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProcessed);
	zval_ptr_dtor(&zTotal);
	zval_ptr_dtor(&zOverallProcessed);
	zval_ptr_dtor(&zOverallTotal);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarExtractionStartEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry, int8_t * Extract)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zEntry;
	zval * zExtract;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);
	MAKE_STD_ZVAL(zExtract);
	ZVAL_BOOL(zExtract, (zend_bool)*Extract);

	params[0] = &zSender;
	params[1] = &zEntry;
	params[2] = &zExtract;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	*Extract = (int8_t)Z_BVAL_P(zExtract);
	zval_ptr_dtor(&zExtract);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarUserActionNeededEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ForEvent, const char * pcDescription, int32_t szDescription, void * Param, int32_t * UserAction)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zForEvent;
	zval * zDescription;
	zval * zParam;
	zval * zUserAction;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zForEvent);
	ZVAL_LONG(zForEvent, (long)ForEvent);
	MAKE_STD_ZVAL(zDescription);
	ZVAL_STRINGL(zDescription, pcDescription, szDescription, 1);
	MAKE_STD_ZVAL(zParam);
	SBInitPointerObject(zParam, Param TSRMLS_CC);
	MAKE_STD_ZVAL(zUserAction);
	ZVAL_LONG(zUserAction, (long)*UserAction);

	params[0] = &zSender;
	params[1] = &zForEvent;
	params[2] = &zDescription;
	params[3] = &zParam;
	params[4] = &zUserAction;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zForEvent);
	zval_ptr_dtor(&zDescription);
	zval_ptr_dtor(&zParam);
	*UserAction = (int32_t)Z_LVAL_P(zUserAction);
	zval_ptr_dtor(&zUserAction);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarExtractionStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zEntry;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEntry;
	params[2] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionStartEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry, int8_t * Compress)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zEntry;
	zval * zCompress;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);
	MAKE_STD_ZVAL(zCompress);
	ZVAL_BOOL(zCompress, (zend_bool)*Compress);

	params[0] = &zSender;
	params[1] = &zEntry;
	params[2] = &zCompress;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	*Compress = (int8_t)Z_BVAL_P(zCompress);
	zval_ptr_dtor(&zCompress);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionTarToGZipStartEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Compress)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCompress;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCompress);
	ZVAL_BOOL(zCompress, (zend_bool)*Compress);

	params[0] = &zSender;
	params[1] = &zCompress;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Compress = (int8_t)Z_BVAL_P(zCompress);
	zval_ptr_dtor(&zCompress);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionTarToBZip2StartEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Compress)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCompress;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCompress);
	ZVAL_BOOL(zCompress, (zend_bool)*Compress);

	params[0] = &zSender;
	params[1] = &zCompress;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Compress = (int8_t)Z_BVAL_P(zCompress);
	zval_ptr_dtor(&zCompress);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarUnCompressionTarFromGZipStartEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Compress)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCompress;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCompress);
	ZVAL_BOOL(zCompress, (zend_bool)*Compress);

	params[0] = &zSender;
	params[1] = &zCompress;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Compress = (int8_t)Z_BVAL_P(zCompress);
	zval_ptr_dtor(&zCompress);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarUnCompressionTarFromBZip2StartEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t * Compress)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCompress;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCompress);
	ZVAL_BOOL(zCompress, (zend_bool)*Compress);

	params[0] = &zSender;
	params[1] = &zCompress;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Compress = (int8_t)Z_BVAL_P(zCompress);
	zval_ptr_dtor(&zCompress);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zEntry;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEntry;
	params[2] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionFinishedEventRaw(void * _ObjectData, TObjectHandle Sender, TElTarArchiveDirectoryEntryHandle Entry)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zEntry;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEntry);
	SBInitObject(zEntry, TElTarArchiveDirectoryEntry_ce_ptr, Entry TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEntry;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEntry);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionTarToGZipFinishedEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarCompressionTarToBZip2FinishedEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarUnCompressionTarFromGZipFinishedEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBTarUnCompressionTarFromBZip2FinishedEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBTarFileType_ce_ptr = NULL;

zend_class_entry *TSBTarCompressMethod_ce_ptr = NULL;

zend_class_entry *TElTarArchiveDirectoryEntry_ce_ptr = NULL;

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, AddEntry)
{
	char *sAPath;
	int sAPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAPath, &sAPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_AddEntry(SBGetObjectHandle(getThis() TSRMLS_CC), sAPath, (int32_t)sAPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, AddNewEntry)
{
	char *sAPath;
	int sAPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAPath, &sAPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_AddNewEntry(SBGetObjectHandle(getThis() TSRMLS_CC), sAPath, (int32_t)sAPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, RemoveEntry)
{
	char *sAPath;
	int sAPath_len;
	zend_bool bCaseSensitive;
	zval *oEntry;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEntry, TElTarArchiveDirectoryEntry_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarArchiveDirectoryEntry_RemoveEntry(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEntry TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAPath, &sAPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarArchiveDirectoryEntry_RemoveEntry_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAPath, (int32_t)sAPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sAPath, &sAPath_len, &bCaseSensitive) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarArchiveDirectoryEntry_RemoveEntry_2(SBGetObjectHandle(getThis() TSRMLS_CC), sAPath, (int32_t)sAPath_len, (int8_t)bCaseSensitive, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarArchiveDirectoryEntry) or (string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, ClearEntries)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_ClearEntries(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, EntryWithName)
{
	char *sAName;
	int sAName_len;
	zend_bool bCaseSensitive;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_EntryWithName(SBGetObjectHandle(getThis() TSRMLS_CC), sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sAName, &sAName_len, &bCaseSensitive) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_EntryWithName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAName, (int32_t)sAName_len, (int8_t)bCaseSensitive, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, EntryWithPath)
{
	char *sAPath;
	int sAPath_len;
	zend_bool bCaseSensitive;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAPath, &sAPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_EntryWithPath(SBGetObjectHandle(getThis() TSRMLS_CC), sAPath, (int32_t)sAPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sAPath, &sAPath_len, &bCaseSensitive) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_EntryWithPath_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAPath, (int32_t)sAPath_len, (int8_t)bCaseSensitive, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_Parent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_get_Parent(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_Entries)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_get_Entries(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_Path)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarArchiveDirectoryEntry_get_Path(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-178603070, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_LocalHeaderOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElTarArchiveDirectoryEntry_get_LocalHeaderOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, set_LocalHeaderOffset)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_set_LocalHeaderOffset(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarFileAttributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_CheckSum)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElTarArchiveDirectoryEntry_get_CheckSum(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_Process)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarArchiveDirectoryEntry_get_Process(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, set_Process)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_set_Process(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_ExtractionPath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarArchiveDirectoryEntry_get_ExtractionPath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-511913171, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, set_ExtractionPath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_set_ExtractionPath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_ExtractionStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_get_ExtractionStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, set_ExtractionStream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_set_ExtractionStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, get_InputStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_get_InputStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, set_InputStream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarArchiveDirectoryEntry_set_InputStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarArchiveDirectoryEntry, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElBaseArchive_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarArchiveDirectoryEntry_Create_1(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElBaseArchive)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_AddEntry, 0, 0, 1)
	ZEND_ARG_INFO(0, APath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_AddNewEntry, 0, 0, 1)
	ZEND_ARG_INFO(0, APath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_RemoveEntry, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Entry_or_APath, 0, 1)
	ZEND_ARG_INFO(0, CaseSensitive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_ClearEntries, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_EntryWithName, 0, 0, 1)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, CaseSensitive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_EntryWithPath, 0, 0, 1)
	ZEND_ARG_INFO(0, APath)
	ZEND_ARG_INFO(0, CaseSensitive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_Parent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_Entries, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_Path, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_LocalHeaderOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_set_LocalHeaderOffset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_CheckSum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_Process, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_set_Process, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_ExtractionPath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_set_ExtractionPath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_ExtractionStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_set_ExtractionStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_get_InputStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry_set_InputStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarArchiveDirectoryEntry___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Owner, TElBaseArchive, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarArchiveDirectoryEntry_methods[] = {
	PHP_ME(TElTarArchiveDirectoryEntry, Clear, arginfo_TElTarArchiveDirectoryEntry_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, AddEntry, arginfo_TElTarArchiveDirectoryEntry_AddEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, AddNewEntry, arginfo_TElTarArchiveDirectoryEntry_AddNewEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, RemoveEntry, arginfo_TElTarArchiveDirectoryEntry_RemoveEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, ClearEntries, arginfo_TElTarArchiveDirectoryEntry_ClearEntries, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, EntryWithName, arginfo_TElTarArchiveDirectoryEntry_EntryWithName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, EntryWithPath, arginfo_TElTarArchiveDirectoryEntry_EntryWithPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_Parent, arginfo_TElTarArchiveDirectoryEntry_get_Parent, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_Entries, arginfo_TElTarArchiveDirectoryEntry_get_Entries, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_Path, arginfo_TElTarArchiveDirectoryEntry_get_Path, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_LocalHeaderOffset, arginfo_TElTarArchiveDirectoryEntry_get_LocalHeaderOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, set_LocalHeaderOffset, arginfo_TElTarArchiveDirectoryEntry_set_LocalHeaderOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_Attributes, arginfo_TElTarArchiveDirectoryEntry_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_CheckSum, arginfo_TElTarArchiveDirectoryEntry_get_CheckSum, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_Process, arginfo_TElTarArchiveDirectoryEntry_get_Process, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, set_Process, arginfo_TElTarArchiveDirectoryEntry_set_Process, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_ExtractionPath, arginfo_TElTarArchiveDirectoryEntry_get_ExtractionPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, set_ExtractionPath, arginfo_TElTarArchiveDirectoryEntry_set_ExtractionPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_ExtractionStream, arginfo_TElTarArchiveDirectoryEntry_get_ExtractionStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, set_ExtractionStream, arginfo_TElTarArchiveDirectoryEntry_set_ExtractionStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, get_InputStream, arginfo_TElTarArchiveDirectoryEntry_get_InputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, set_InputStream, arginfo_TElTarArchiveDirectoryEntry_set_InputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarArchiveDirectoryEntry, __construct, arginfo_TElTarArchiveDirectoryEntry___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarArchiveDirectoryEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarArchiveDirectoryEntry_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarArchiveDirectoryEntry", TElTarArchiveDirectoryEntry_methods);
	if (NULL == TElArchiveDirectoryEntry_ce_ptr)
		Register_TElArchiveDirectoryEntry(TSRMLS_C);
	TElTarArchiveDirectoryEntry_ce_ptr = zend_register_internal_class_ex(&ce, TElArchiveDirectoryEntry_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTarFileAttributes_ce_ptr = NULL;

SB_PHP_METHOD(TElTarFileAttributes, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElTarFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElTarFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_Mode)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_FileSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_FileSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_FileType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarFileTypeRaw fOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_FileType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_FileType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_FileType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBTarFileTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_FileTypeCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElTarFileAttributes_get_FileTypeCode(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_FileTypeCode)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElTarFileAttributes_set_FileTypeCode(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_ModifyTimeAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_ModifyTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_ModifyTimeAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_ModifyTimeAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_ModifyTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_ModifyTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_ModifyTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_LinkName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarFileAttributes_get_LinkName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-526494548, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_LinkName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_LinkName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_SUID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_SUID(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_SUID)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_SUID(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_SGID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_SGID(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_SGID)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_SGID(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_OwnerRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_OwnerRead(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_OwnerRead)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_OwnerRead(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_OwnerWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_OwnerWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_OwnerWrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_OwnerWrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_OwnerExecute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_OwnerExecute(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_OwnerExecute)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_OwnerExecute(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_GroupRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_GroupRead(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_GroupRead)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_GroupRead(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_GroupWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_GroupWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_GroupWrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_GroupWrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_GroupExecute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_GroupExecute(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_GroupExecute)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_GroupExecute(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_OtherRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_OtherRead(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_OtherRead)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_OtherRead(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_OtherWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_OtherWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_OtherWrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_OtherWrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_OtherExecute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_OtherExecute(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_OtherExecute)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_OtherExecute(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_UIDAndGIDAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_UIDAndGIDAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_UIDAndGIDAvailable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_UIDAndGIDAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_UID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_UID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_GID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_GID(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_GID)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_GID(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_HasUStar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarFileAttributes_get_HasUStar(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_HasUStar)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_HasUStar(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_UName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarFileAttributes_get_UName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1588381032, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_UName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_UName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_GName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarFileAttributes_get_GName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1150026118, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_GName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_GName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_DevMajor)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarFileAttributes_get_DevMajor(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(272550131, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_DevMajor)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_DevMajor(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_DevMinor)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarFileAttributes_get_DevMinor(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-763148096, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_DevMinor)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_DevMinor(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, get_Prefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarFileAttributes_get_Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1154137396, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, set_Prefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarFileAttributes_set_Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarFileAttributes, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarFileAttributes_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElTarFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElTarFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_FileSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_FileSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_FileType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_FileType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_FileTypeCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_FileTypeCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_ModifyTimeAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_ModifyTimeAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_ModifyTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_ModifyTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_LinkName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_LinkName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_SUID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_SUID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_SGID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_SGID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_OwnerRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_OwnerRead, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_OwnerWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_OwnerWrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_OwnerExecute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_OwnerExecute, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_GroupRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_GroupRead, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_GroupWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_GroupWrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_GroupExecute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_GroupExecute, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_OtherRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_OtherRead, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_OtherWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_OtherWrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_OtherExecute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_OtherExecute, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_UIDAndGIDAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_UIDAndGIDAvailable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_UID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_GID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_GID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_HasUStar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_HasUStar, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_UName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_UName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_GName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_GName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_DevMajor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_DevMajor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_DevMinor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_DevMinor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_get_Prefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes_set_Prefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarFileAttributes___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarFileAttributes_methods[] = {
	PHP_ME(TElTarFileAttributes, Assign, arginfo_TElTarFileAttributes_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, AssignTo, arginfo_TElTarFileAttributes_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_Mode, arginfo_TElTarFileAttributes_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_Mode, arginfo_TElTarFileAttributes_set_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_FileSize, arginfo_TElTarFileAttributes_get_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_FileSize, arginfo_TElTarFileAttributes_set_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_FileType, arginfo_TElTarFileAttributes_get_FileType, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_FileType, arginfo_TElTarFileAttributes_set_FileType, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_FileTypeCode, arginfo_TElTarFileAttributes_get_FileTypeCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_FileTypeCode, arginfo_TElTarFileAttributes_set_FileTypeCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_ModifyTimeAvailable, arginfo_TElTarFileAttributes_get_ModifyTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_ModifyTimeAvailable, arginfo_TElTarFileAttributes_set_ModifyTimeAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_ModifyTime, arginfo_TElTarFileAttributes_get_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_ModifyTime, arginfo_TElTarFileAttributes_set_ModifyTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_LinkName, arginfo_TElTarFileAttributes_get_LinkName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_LinkName, arginfo_TElTarFileAttributes_set_LinkName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_SUID, arginfo_TElTarFileAttributes_get_SUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_SUID, arginfo_TElTarFileAttributes_set_SUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_SGID, arginfo_TElTarFileAttributes_get_SGID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_SGID, arginfo_TElTarFileAttributes_set_SGID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_OwnerRead, arginfo_TElTarFileAttributes_get_OwnerRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_OwnerRead, arginfo_TElTarFileAttributes_set_OwnerRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_OwnerWrite, arginfo_TElTarFileAttributes_get_OwnerWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_OwnerWrite, arginfo_TElTarFileAttributes_set_OwnerWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_OwnerExecute, arginfo_TElTarFileAttributes_get_OwnerExecute, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_OwnerExecute, arginfo_TElTarFileAttributes_set_OwnerExecute, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_GroupRead, arginfo_TElTarFileAttributes_get_GroupRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_GroupRead, arginfo_TElTarFileAttributes_set_GroupRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_GroupWrite, arginfo_TElTarFileAttributes_get_GroupWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_GroupWrite, arginfo_TElTarFileAttributes_set_GroupWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_GroupExecute, arginfo_TElTarFileAttributes_get_GroupExecute, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_GroupExecute, arginfo_TElTarFileAttributes_set_GroupExecute, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_OtherRead, arginfo_TElTarFileAttributes_get_OtherRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_OtherRead, arginfo_TElTarFileAttributes_set_OtherRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_OtherWrite, arginfo_TElTarFileAttributes_get_OtherWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_OtherWrite, arginfo_TElTarFileAttributes_set_OtherWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_OtherExecute, arginfo_TElTarFileAttributes_get_OtherExecute, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_OtherExecute, arginfo_TElTarFileAttributes_set_OtherExecute, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_UIDAndGIDAvailable, arginfo_TElTarFileAttributes_get_UIDAndGIDAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_UIDAndGIDAvailable, arginfo_TElTarFileAttributes_set_UIDAndGIDAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_UID, arginfo_TElTarFileAttributes_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_UID, arginfo_TElTarFileAttributes_set_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_GID, arginfo_TElTarFileAttributes_get_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_GID, arginfo_TElTarFileAttributes_set_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_HasUStar, arginfo_TElTarFileAttributes_get_HasUStar, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_HasUStar, arginfo_TElTarFileAttributes_set_HasUStar, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_UName, arginfo_TElTarFileAttributes_get_UName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_UName, arginfo_TElTarFileAttributes_set_UName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_GName, arginfo_TElTarFileAttributes_get_GName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_GName, arginfo_TElTarFileAttributes_set_GName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_DevMajor, arginfo_TElTarFileAttributes_get_DevMajor, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_DevMajor, arginfo_TElTarFileAttributes_set_DevMajor, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_DevMinor, arginfo_TElTarFileAttributes_get_DevMinor, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_DevMinor, arginfo_TElTarFileAttributes_set_DevMinor, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, get_Prefix, arginfo_TElTarFileAttributes_get_Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, set_Prefix, arginfo_TElTarFileAttributes_set_Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarFileAttributes, __construct, arginfo_TElTarFileAttributes___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarFileAttributes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarFileAttributes_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarFileAttributes", TElTarFileAttributes_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElTarFileAttributes_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTarProcessingUnit_ce_ptr = NULL;

SB_PHP_METHOD(TElTarProcessingUnit, InitializeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarProcessingUnit_InitializeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarProcessingUnit, ProcessBlock)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTarProcessingUnit_ProcessBlock(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarProcessingUnit, FinalizeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarProcessingUnit_FinalizeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarProcessingUnit, get_ProcessingEntry)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarProcessingUnit_get_ProcessingEntry(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarProcessingUnit, set_ProcessingEntry)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElTarArchiveDirectoryEntry_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarProcessingUnit_set_ProcessingEntry(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarArchiveDirectoryEntry)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarProcessingUnit, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarProcessingUnit_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarProcessingUnit_InitializeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarProcessingUnit_ProcessBlock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarProcessingUnit_FinalizeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarProcessingUnit_get_ProcessingEntry, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarProcessingUnit_set_ProcessingEntry, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElTarArchiveDirectoryEntry, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarProcessingUnit___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarProcessingUnit_methods[] = {
	PHP_ME(TElTarProcessingUnit, InitializeProcessing, arginfo_TElTarProcessingUnit_InitializeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarProcessingUnit, ProcessBlock, arginfo_TElTarProcessingUnit_ProcessBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarProcessingUnit, FinalizeProcessing, arginfo_TElTarProcessingUnit_FinalizeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarProcessingUnit, get_ProcessingEntry, arginfo_TElTarProcessingUnit_get_ProcessingEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarProcessingUnit, set_ProcessingEntry, arginfo_TElTarProcessingUnit_set_ProcessingEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarProcessingUnit, __construct, arginfo_TElTarProcessingUnit___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarProcessingUnit(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarProcessingUnit_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarProcessingUnit", TElTarProcessingUnit_methods);
	if (NULL == TElArcProcessingUnit_ce_ptr)
		Register_TElArcProcessingUnit(TSRMLS_C);
	TElTarProcessingUnit_ce_ptr = zend_register_internal_class_ex(&ce, TElArcProcessingUnit_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTarReader_ce_ptr = NULL;

SB_PHP_METHOD(TElTarReader, Open)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElTarReader_Open(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarReader_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarReader_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, Extract)
{
	char *sMask;
	char *sOutputPath;
	int sMask_len;
	int sOutputPath_len;
	zval *oEntries;
	zval *oEntry;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oEntry, TElTarArchiveDirectoryEntry_ce_ptr, &sOutputPath, &sOutputPath_len) == SUCCESS)
	{
		SBCheckError(TElTarReader_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEntry TSRMLS_CC), sOutputPath, (int32_t)sOutputPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oEntries, TList_ce_ptr, &sOutputPath, &sOutputPath_len) == SUCCESS)
	{
		SBCheckError(TElTarReader_Extract_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEntries TSRMLS_CC), sOutputPath, (int32_t)sOutputPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sMask, &sMask_len, &sOutputPath, &sOutputPath_len) == SUCCESS)
	{
		SBCheckError(TElTarReader_Extract_2(SBGetObjectHandle(getThis() TSRMLS_CC), sMask, (int32_t)sMask_len, sOutputPath, (int32_t)sOutputPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarArchiveDirectoryEntry, string) or (TList, string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, ExtractContents)
{
	uint32_t _err;
	zval *oEntry;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEntry, TElTarArchiveDirectoryEntry_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElTarReader_ExtractContents(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEntry TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-594904169, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarArchiveDirectoryEntry)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_Directory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarReader_get_Directory(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_IgnoreArchiveErrors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarReader_get_IgnoreArchiveErrors(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_IgnoreArchiveErrors)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarReader_set_IgnoreArchiveErrors(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_CaseSensitiveFilenames)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarReader_get_CaseSensitiveFilenames(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_CaseSensitiveFilenames)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTarReader_set_CaseSensitiveFilenames(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_FilenamesCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTarReader_get_FilenamesCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-224115316, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_FilenamesCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElTarReader_set_FilenamesCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarReader_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarReader_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_CompressionMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressMethodRaw fOutResultRaw = 0;
		SBCheckError(TElTarReader_get_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_CompressionMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElTarReader_set_CompressionMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBTarCompressMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnExtractionStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarExtractionStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnExtractionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnExtractionStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnExtractionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarExtractionStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarExtractionStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnExtractionMakeDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarExtractionMakeDirectoryEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnExtractionMakeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnExtractionMakeDirectory)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnExtractionMakeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarExtractionMakeDirectoryEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarExtractionMakeDirectoryEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnExtractionStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarExtractionStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnExtractionStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnExtractionStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnExtractionStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarExtractionStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarExtractionStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnExtractionFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarExtractionFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnExtractionFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnExtractionFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnExtractionFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarExtractionFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarExtractionFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnUserActionNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarUserActionNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnUserActionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnUserActionNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnUserActionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarUserActionNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarUserActionNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnArchiveError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarArchiveErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnArchiveError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarArchiveErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarArchiveErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnUnCompressionTarFromGZipStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarUnCompressionTarFromGZipStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnUnCompressionTarFromGZipStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnUnCompressionTarFromGZipStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnUnCompressionTarFromGZipStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarUnCompressionTarFromGZipStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarUnCompressionTarFromGZipStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnUnCompressionTarFromGZipFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarUnCompressionTarFromGZipFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnUnCompressionTarFromGZipFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnUnCompressionTarFromGZipFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnUnCompressionTarFromGZipFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarUnCompressionTarFromGZipFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarUnCompressionTarFromGZipFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnUnCompressionTarFromBZip2Start)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarUnCompressionTarFromBZip2StartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnUnCompressionTarFromBZip2Start(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnUnCompressionTarFromBZip2Start)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnUnCompressionTarFromBZip2Start(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarUnCompressionTarFromBZip2StartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarUnCompressionTarFromBZip2StartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, get_OnUnCompressionTarFromBZip2Finished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarUnCompressionTarFromBZip2FinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarReader_get_OnUnCompressionTarFromBZip2Finished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, set_OnUnCompressionTarFromBZip2Finished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarReader_set_OnUnCompressionTarFromBZip2Finished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarUnCompressionTarFromBZip2FinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarUnCompressionTarFromBZip2FinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarReader, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarReader_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_Extract, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Entry_or_Entries_or_Mask, 0, 1)
	ZEND_ARG_INFO(0, OutputPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_ExtractContents, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Entry, TElTarArchiveDirectoryEntry, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_Directory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_IgnoreArchiveErrors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_IgnoreArchiveErrors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_CaseSensitiveFilenames, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_CaseSensitiveFilenames, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_FilenamesCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_FilenamesCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_CompressionMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_CompressionMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnExtractionStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnExtractionStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnExtractionMakeDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnExtractionMakeDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnExtractionStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnExtractionStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnExtractionFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnExtractionFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnUserActionNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnUserActionNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnArchiveError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnArchiveError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnUnCompressionTarFromGZipStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnUnCompressionTarFromGZipStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnUnCompressionTarFromGZipFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnUnCompressionTarFromGZipFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnUnCompressionTarFromBZip2Start, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnUnCompressionTarFromBZip2Start, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_get_OnUnCompressionTarFromBZip2Finished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader_set_OnUnCompressionTarFromBZip2Finished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarReader___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarReader_methods[] = {
	PHP_ME(TElTarReader, Open, arginfo_TElTarReader_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, Close, arginfo_TElTarReader_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, Extract, arginfo_TElTarReader_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, ExtractContents, arginfo_TElTarReader_ExtractContents, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_Directory, arginfo_TElTarReader_get_Directory, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_IgnoreArchiveErrors, arginfo_TElTarReader_get_IgnoreArchiveErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_IgnoreArchiveErrors, arginfo_TElTarReader_set_IgnoreArchiveErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_CaseSensitiveFilenames, arginfo_TElTarReader_get_CaseSensitiveFilenames, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_CaseSensitiveFilenames, arginfo_TElTarReader_set_CaseSensitiveFilenames, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_FilenamesCharset, arginfo_TElTarReader_get_FilenamesCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_FilenamesCharset, arginfo_TElTarReader_set_FilenamesCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_FileSystemAdapter, arginfo_TElTarReader_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_FileSystemAdapter, arginfo_TElTarReader_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_CompressionMethod, arginfo_TElTarReader_get_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_CompressionMethod, arginfo_TElTarReader_set_CompressionMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnExtractionStreamNeeded, arginfo_TElTarReader_get_OnExtractionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnExtractionStreamNeeded, arginfo_TElTarReader_set_OnExtractionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnExtractionMakeDirectory, arginfo_TElTarReader_get_OnExtractionMakeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnExtractionMakeDirectory, arginfo_TElTarReader_set_OnExtractionMakeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnProgress, arginfo_TElTarReader_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnProgress, arginfo_TElTarReader_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnExtractionStart, arginfo_TElTarReader_get_OnExtractionStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnExtractionStart, arginfo_TElTarReader_set_OnExtractionStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnExtractionFinished, arginfo_TElTarReader_get_OnExtractionFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnExtractionFinished, arginfo_TElTarReader_set_OnExtractionFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnUserActionNeeded, arginfo_TElTarReader_get_OnUserActionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnUserActionNeeded, arginfo_TElTarReader_set_OnUserActionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnArchiveError, arginfo_TElTarReader_get_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnArchiveError, arginfo_TElTarReader_set_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnUnCompressionTarFromGZipStart, arginfo_TElTarReader_get_OnUnCompressionTarFromGZipStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnUnCompressionTarFromGZipStart, arginfo_TElTarReader_set_OnUnCompressionTarFromGZipStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnUnCompressionTarFromGZipFinished, arginfo_TElTarReader_get_OnUnCompressionTarFromGZipFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnUnCompressionTarFromGZipFinished, arginfo_TElTarReader_set_OnUnCompressionTarFromGZipFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnUnCompressionTarFromBZip2Start, arginfo_TElTarReader_get_OnUnCompressionTarFromBZip2Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnUnCompressionTarFromBZip2Start, arginfo_TElTarReader_set_OnUnCompressionTarFromBZip2Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, get_OnUnCompressionTarFromBZip2Finished, arginfo_TElTarReader_get_OnUnCompressionTarFromBZip2Finished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, set_OnUnCompressionTarFromBZip2Finished, arginfo_TElTarReader_set_OnUnCompressionTarFromBZip2Finished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarReader, __construct, arginfo_TElTarReader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarReader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarReader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarReader", TElTarReader_methods);
	if (NULL == TElBaseArchive_ce_ptr)
		Register_TElBaseArchive(TSRMLS_C);
	TElTarReader_ce_ptr = zend_register_internal_class_ex(&ce, TElBaseArchive_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTarWriter_ce_ptr = NULL;

SB_PHP_METHOD(TElTarWriter, CreateArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarWriter_CreateArchive(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, Add)
{
	char *sFileName;
	char *sPath;
	int sFileName_len;
	int sPath_len;
	long l4Count;
	long l4Mode;
	long l4StartIndex;
	SBArrayZValInfo aiBuf;
	zval *oParent;
	zval *oStream;
	zval *oUSTAR;
	zval *zaBuf;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &sPath, &sPath_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sPath, (int32_t)sPath_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sPath, &sPath_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!slO!", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &oStream, TStream_ce_ptr, &sFileName, &sFileName_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lO!", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &oStream, TStream_ce_ptr, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Add_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oStream, TStream_ce_ptr, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Add_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!", &oStream, TStream_ce_ptr, &sFileName, &sFileName_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Add_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zllslO!", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &zaBuf, &l4StartIndex, &l4Count, &sFileName, &sFileName_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTarWriter_Add_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), aiBuf.data, aiBuf.len, (int32_t)l4StartIndex, (int32_t)l4Count, sFileName, (int32_t)sFileName_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuf);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllslO!", &zaBuf, &l4StartIndex, &l4Count, &sFileName, &sFileName_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTarWriter_Add_7(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuf.data, aiBuf.len, (int32_t)l4StartIndex, (int32_t)l4Count, sFileName, (int32_t)sFileName_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuf);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarArchiveDirectoryEntry, string, integer, TElUStarTarHeader) or (string, integer, TElUStarTarHeader) or (TElTarArchiveDirectoryEntry, TStream, string, integer, TElUStarTarHeader) or (TElTarArchiveDirectoryEntry, TStream, integer, TElUStarTarHeader) or (TStream, integer, TElUStarTarHeader) or (TStream, string, integer, TElUStarTarHeader) or (TElTarArchiveDirectoryEntry, array of byte|string|NULL, integer, integer, string, integer, TElUStarTarHeader) or (array of byte|string|NULL, integer, integer, string, integer, TElUStarTarHeader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, AddDirContents)
{
	char *sMask;
	char *sPath;
	int sMask_len;
	int sPath_len;
	long l4Mode;
	zval *oParent;
	zval *oUSTAR;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &sPath, &sPath_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarWriter_AddDirContents(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sPath, (int32_t)sPath_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sPath, &sPath_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarWriter_AddDirContents_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &sPath, &sPath_len, &sMask, &sMask_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarWriter_AddDirContents_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sPath, (int32_t)sPath_len, sMask, (int32_t)sMask_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!", &sPath, &sPath_len, &sMask, &sMask_len, &l4Mode, &oUSTAR, TElUStarTarHeader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarWriter_AddDirContents_3(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sMask, (int32_t)sMask_len, (int32_t)l4Mode, SBGetObjectHandle(oUSTAR TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElTarArchiveDirectoryEntry, string, integer, TElUStarTarHeader) or (string, integer, TElUStarTarHeader) or (TElTarArchiveDirectoryEntry, string, string, integer, TElUStarTarHeader) or (string, string, integer, TElUStarTarHeader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, MakeDir)
{
	char *sPath;
	int sPath_len;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_MakeDir(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oParent, TElTarArchiveDirectoryEntry_ce_ptr, &sPath, &sPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_MakeDir_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sPath, (int32_t)sPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElTarArchiveDirectoryEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElTarArchiveDirectoryEntry, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, Remove)
{
	char *sMask;
	int sMask_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMask, &sMask_len) == SUCCESS)
	{
		SBCheckError(TElTarWriter_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), sMask, (int32_t)sMask_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, BeginCompression)
{
	char *sDestination;
	int sDestination_len;
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarWriter_BeginCompression(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDestination, &sDestination_len) == SUCCESS)
	{
		SBCheckError(TElTarWriter_BeginCompression_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDestination, (int32_t)sDestination_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, UpdateCompression)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarWriter_UpdateCompression(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, EndCompression)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarWriter_EndCompression(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, Compress)
{
	char *sDestination;
	int sDestination_len;
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTarWriter_Compress(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDestination, &sDestination_len) == SUCCESS)
	{
		SBCheckError(TElTarWriter_Compress_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDestination, (int32_t)sDestination_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarWriter_Compress_2(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTarWriter_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTarWriter_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_UID)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTarWriter_set_UID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_GID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTarWriter_get_GID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_GID)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTarWriter_set_GID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_ReplaceMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBArcReplaceModeRaw fOutResultRaw = 0;
		SBCheckError(TElTarWriter_get_ReplaceMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_ReplaceMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElTarWriter_set_ReplaceMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBArcReplaceModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_NewArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTarWriter_get_NewArchive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElTarWriter_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_CompressionLevel)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElTarWriter_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionTarToGZipStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionTarToGZipStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionTarToGZipStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionTarToGZipStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionTarToGZipStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionTarToGZipStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionTarToGZipStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionTarToGZipFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionTarToGZipFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionTarToGZipFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionTarToGZipFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionTarToGZipFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionTarToGZipFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionTarToGZipFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionTarToBZip2Start)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionTarToBZip2StartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionTarToBZip2Start(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionTarToBZip2Start)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionTarToBZip2Start(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionTarToBZip2StartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionTarToBZip2StartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, get_OnCompressionTarToBZip2Finished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBTarCompressionTarToBZip2FinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElTarWriter_get_OnCompressionTarToBZip2Finished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, set_OnCompressionTarToBZip2Finished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElTarWriter_set_OnCompressionTarToBZip2Finished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBTarCompressionTarToBZip2FinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBTarCompressionTarToBZip2FinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTarWriter, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTarWriter_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_CreateArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_Add, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Parent_or_Path_or_Stream_or_Buf, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Mode_or_Stream_or_FileName_or_Buf_or_StartIndex, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_USTAR_or_FileName_or_StartIndex_or_Count, 0, 1)
	ZEND_ARG_TYPE_INFO(0, USTAR_or_Mode_or_Count_or_FileName, 0, 1)
	ZEND_ARG_TYPE_INFO(0, USTAR_or_FileName_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_USTAR, 0, 1)
	ZEND_ARG_OBJ_INFO(0, USTAR, TElUStarTarHeader, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_AddDirContents, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Parent_or_Path, 0, 1)
	ZEND_ARG_INFO(0, Path_or_Mode_or_Mask)
	ZEND_ARG_TYPE_INFO(0, Mode_or_USTAR_or_Mask, 0, 1)
	ZEND_ARG_TYPE_INFO(0, USTAR_or_Mode, 0, 1)
	ZEND_ARG_OBJ_INFO(0, USTAR, TElUStarTarHeader, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_MakeDir, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_Parent, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Mask)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_BeginCompression, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Destination, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_UpdateCompression, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_EndCompression, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_Compress, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Destination, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_UID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_GID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_GID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_ReplaceMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_ReplaceMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_NewArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionTarToGZipStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionTarToGZipStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionTarToGZipFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionTarToGZipFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionTarToBZip2Start, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionTarToBZip2Start, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_get_OnCompressionTarToBZip2Finished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter_set_OnCompressionTarToBZip2Finished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTarWriter___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTarWriter_methods[] = {
	PHP_ME(TElTarWriter, CreateArchive, arginfo_TElTarWriter_CreateArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, Add, arginfo_TElTarWriter_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, AddDirContents, arginfo_TElTarWriter_AddDirContents, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, MakeDir, arginfo_TElTarWriter_MakeDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, Remove, arginfo_TElTarWriter_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, BeginCompression, arginfo_TElTarWriter_BeginCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, UpdateCompression, arginfo_TElTarWriter_UpdateCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, EndCompression, arginfo_TElTarWriter_EndCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, Compress, arginfo_TElTarWriter_Compress, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, Close, arginfo_TElTarWriter_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_UID, arginfo_TElTarWriter_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_UID, arginfo_TElTarWriter_set_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_GID, arginfo_TElTarWriter_get_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_GID, arginfo_TElTarWriter_set_GID, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_ReplaceMode, arginfo_TElTarWriter_get_ReplaceMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_ReplaceMode, arginfo_TElTarWriter_set_ReplaceMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_NewArchive, arginfo_TElTarWriter_get_NewArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_CompressionLevel, arginfo_TElTarWriter_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_CompressionLevel, arginfo_TElTarWriter_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionStreamNeeded, arginfo_TElTarWriter_get_OnCompressionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionStreamNeeded, arginfo_TElTarWriter_set_OnCompressionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionStart, arginfo_TElTarWriter_get_OnCompressionStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionStart, arginfo_TElTarWriter_set_OnCompressionStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionFinished, arginfo_TElTarWriter_get_OnCompressionFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionFinished, arginfo_TElTarWriter_set_OnCompressionFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionTarToGZipStart, arginfo_TElTarWriter_get_OnCompressionTarToGZipStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionTarToGZipStart, arginfo_TElTarWriter_set_OnCompressionTarToGZipStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionTarToGZipFinished, arginfo_TElTarWriter_get_OnCompressionTarToGZipFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionTarToGZipFinished, arginfo_TElTarWriter_set_OnCompressionTarToGZipFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionTarToBZip2Start, arginfo_TElTarWriter_get_OnCompressionTarToBZip2Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionTarToBZip2Start, arginfo_TElTarWriter_set_OnCompressionTarToBZip2Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, get_OnCompressionTarToBZip2Finished, arginfo_TElTarWriter_get_OnCompressionTarToBZip2Finished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, set_OnCompressionTarToBZip2Finished, arginfo_TElTarWriter_set_OnCompressionTarToBZip2Finished, ZEND_ACC_PUBLIC)
	PHP_ME(TElTarWriter, __construct, arginfo_TElTarWriter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTarWriter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTarWriter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTarWriter", TElTarWriter_methods);
	if (NULL == TElTarReader_ce_ptr)
		Register_TElTarReader(TSRMLS_C);
	TElTarWriter_ce_ptr = zend_register_internal_class_ex(&ce, TElTarReader_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBArcTar_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_EVENT_EXTRACTION_FAILED, SB_TAR_EVENT_EXTRACTION_FAILED, SB_TAR_EVENT_EXTRACTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_EVENT_FILE_ALREADY_EXISTS, SB_TAR_EVENT_FILE_ALREADY_EXISTS, SB_TAR_EVENT_FILE_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_EVENT_CANNOT_CREATE_FILE, SB_TAR_EVENT_CANNOT_CREATE_FILE, SB_TAR_EVENT_CANNOT_CREATE_FILE);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_EVENT_DIR_ALREADY_EXISTS, SB_TAR_EVENT_DIR_ALREADY_EXISTS, SB_TAR_EVENT_DIR_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_EVENT_FILE_ALREADY_ADDED, SB_TAR_EVENT_FILE_ALREADY_ADDED, SB_TAR_EVENT_FILE_ALREADY_ADDED);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_EVENT_CRC_MISMATCH, SB_TAR_EVENT_CRC_MISMATCH, SB_TAR_EVENT_CRC_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_ACTION_IGNORE, SB_TAR_ACTION_IGNORE, SB_TAR_ACTION_IGNORE);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_ACTION_ABORT, SB_TAR_ACTION_ABORT, SB_TAR_ACTION_ABORT);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_ACTION_RETRY, SB_TAR_ACTION_RETRY, SB_TAR_ACTION_RETRY);
	SB_REGISTER_LONG_CONSTANT(SBArcTar, TAR_ACTION_SKIP, SB_TAR_ACTION_SKIP, SB_TAR_ACTION_SKIP);
}

void Register_SBArcTar_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBTarFileType", NULL);
	TSBTarFileType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBTarFileType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBTarFileType_ce_ptr, "uftFIFOSpecial", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarFileType_ce_ptr, "uftCharacterSpecial", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarFileType_ce_ptr, "uftDirectory", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarFileType_ce_ptr, "uftBlockSpecial", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarFileType_ce_ptr, "uftRegularFile", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarFileType_ce_ptr, "uftSymbolicLink", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBTarCompressMethod", NULL);
	TSBTarCompressMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBTarCompressMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBTarCompressMethod_ce_ptr, "cmNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarCompressMethod_ce_ptr, "cmGZip", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBTarCompressMethod_ce_ptr, "cmBZip2", 2)
}

void Register_SBArcTar_Aliases(TSRMLS_D)
{
	if (NULL == TElTarArchiveDirectoryEntry_ce_ptr)
		Register_TElTarArchiveDirectoryEntry(TSRMLS_C);
	zend_register_class_alias("ElTarArchiveDirectoryEntry", TElTarArchiveDirectoryEntry_ce_ptr);
	if (NULL == TElTarProcessingUnit_ce_ptr)
		Register_TElTarProcessingUnit(TSRMLS_C);
	zend_register_class_alias("ElTarProcessingUnit", TElTarProcessingUnit_ce_ptr);
	if (NULL == TElTarReader_ce_ptr)
		Register_TElTarReader(TSRMLS_C);
	zend_register_class_alias("ElTarReader", TElTarReader_ce_ptr);
	if (NULL == TElTarWriter_ce_ptr)
		Register_TElTarWriter(TSRMLS_C);
	zend_register_class_alias("ElTarWriter", TElTarWriter_ce_ptr);
}

