#include "sbcertvalidator.h"

void SB_CALLBACK TSBCRLNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TElCustomCRLStorageHandle * CRLs)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zCRLs;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCRLs);
	SBInitObject(zCRLs, TElCustomCRLStorage_ce_ptr, *CRLs TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zCRLs;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	*CRLs = SBGetObjectHandleCE(zCRLs, TElCustomCRLStorage_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCRLs TSRMLS_CC);
	zval_ptr_dtor(&zCRLs);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCACertificateRetrievedEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TSBGeneralNameRaw NameType, const char * pcLocation, int32_t szLocation, TElX509CertificateHandle CACertificate)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertificate;
	zval * zNameType;
	zval * zLocation;
	zval * zCACertificate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zNameType);
	ZVAL_LONG(zNameType, (long)NameType);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zNameType;
	params[3] = &zLocation;
	params[4] = &zCACertificate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zNameType);
	zval_ptr_dtor(&zLocation);
	zval_ptr_dtor(&zCACertificate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCRLRetrievedEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TSBGeneralNameRaw NameType, const char * pcLocation, int32_t szLocation, TElCertificateRevocationListHandle CRL)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zNameType;
	zval * zLocation;
	zval * zCRL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zNameType);
	ZVAL_LONG(zNameType, (long)NameType);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zCRL);
	SBInitObject(zCRL, TElCertificateRevocationList_ce_ptr, CRL TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zNameType;
	params[4] = &zLocation;
	params[5] = &zCRL;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	zval_ptr_dtor(&zNameType);
	zval_ptr_dtor(&zLocation);
	zval_ptr_dtor(&zCRL);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBAfterCRLUseEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TElCertificateRevocationListHandle CRL)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zCRL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCRL);
	SBInitObject(zCRL, TElCertificateRevocationList_ce_ptr, CRL TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zCRL;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	zval_ptr_dtor(&zCRL);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBAfterOCSPResponseUseEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TElOCSPResponseHandle Response)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zResponse;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zResponse);
	SBInitObject(zResponse, TElOCSPResponse_ce_ptr, Response TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zResponse;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	zval_ptr_dtor(&zResponse);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBOCSPResponseSignerValidEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TElOCSPResponseHandle Response, TElX509CertificateHandle SignerCertificate, int8_t * SignerValid)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zResponse;
	zval * zSignerCertificate;
	zval * zSignerValid;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zResponse);
	SBInitObject(zResponse, TElOCSPResponse_ce_ptr, Response TSRMLS_CC);
	MAKE_STD_ZVAL(zSignerCertificate);
	SBInitObject(zSignerCertificate, TElX509Certificate_ce_ptr, SignerCertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zSignerValid);
	ZVAL_BOOL(zSignerValid, (zend_bool)*SignerValid);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zResponse;
	params[4] = &zSignerCertificate;
	params[5] = &zSignerValid;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	zval_ptr_dtor(&zResponse);
	zval_ptr_dtor(&zSignerCertificate);
	*SignerValid = (int8_t)Z_BVAL_P(zSignerValid);
	zval_ptr_dtor(&zSignerValid);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBeforeCertificateRetrieverUseEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TSBGeneralNameRaw NameType, const char * pcLocation, int32_t szLocation, TElCustomCertificateRetrieverHandle * Retriever)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertificate;
	zval * zNameType;
	zval * zLocation;
	zval * zRetriever;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zNameType);
	ZVAL_LONG(zNameType, (long)NameType);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zRetriever);
	SBInitObject(zRetriever, TElCustomCertificateRetriever_ce_ptr, *Retriever TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zNameType;
	params[3] = &zLocation;
	params[4] = &zRetriever;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zNameType);
	zval_ptr_dtor(&zLocation);
	*Retriever = SBGetObjectHandleCE(zRetriever, TElCustomCertificateRetriever_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zRetriever TSRMLS_CC);
	zval_ptr_dtor(&zRetriever);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBeforeCRLRetrieverUseEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TSBGeneralNameRaw NameType, const char * pcLocation, int32_t szLocation, TElCustomCRLRetrieverHandle * Retriever)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zNameType;
	zval * zLocation;
	zval * zRetriever;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zNameType);
	ZVAL_LONG(zNameType, (long)NameType);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zRetriever);
	SBInitObject(zRetriever, TElCustomCRLRetriever_ce_ptr, *Retriever TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zNameType;
	params[4] = &zLocation;
	params[5] = &zRetriever;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	zval_ptr_dtor(&zNameType);
	zval_ptr_dtor(&zLocation);
	*Retriever = SBGetObjectHandleCE(zRetriever, TElCustomCRLRetriever_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zRetriever TSRMLS_CC);
	zval_ptr_dtor(&zRetriever);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBeforeOCSPClientUseEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, const char * pcOCSPLocation, int32_t szOCSPLocation, TElOCSPClientHandle * OCSPClient)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zOCSPLocation;
	zval * zOCSPClient;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zOCSPLocation);
	ZVAL_STRINGL(zOCSPLocation, pcOCSPLocation, szOCSPLocation, 1);
	MAKE_STD_ZVAL(zOCSPClient);
	SBInitObject(zOCSPClient, TElOCSPClient_ce_ptr, *OCSPClient TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zOCSPLocation;
	params[4] = &zOCSPClient;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	zval_ptr_dtor(&zOCSPLocation);
	*OCSPClient = SBGetObjectHandleCE(zOCSPClient, TElOCSPClient_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zOCSPClient TSRMLS_CC);
	zval_ptr_dtor(&zOCSPClient);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCertificateValidatorCRLErrorEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, const char * pcLocation, int32_t szLocation, TElCustomCRLRetrieverHandle Retriever, int32_t ErrorCode)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertificate;
	zval * zLocation;
	zval * zRetriever;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zRetriever);
	SBInitObject(zRetriever, TElCustomCRLRetriever_ce_ptr, Retriever TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zLocation;
	params[3] = &zRetriever;
	params[4] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zLocation);
	zval_ptr_dtor(&zRetriever);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCertificateValidatorOCSPErrorEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, const char * pcLocation, int32_t szLocation, TElOCSPClientHandle Client, int32_t ErrorCode)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCertificate;
	zval * zLocation;
	zval * zClient;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zLocation);
	ZVAL_STRINGL(zLocation, pcLocation, szLocation, 1);
	MAKE_STD_ZVAL(zClient);
	SBInitObject(zClient, TElOCSPClient_ce_ptr, Client TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zLocation;
	params[3] = &zClient;
	params[4] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zLocation);
	zval_ptr_dtor(&zClient);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBCACertificateNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle * CACertificate)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, *CACertificate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	*CACertificate = SBGetObjectHandleCE(zCACertificate, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCACertificate TSRMLS_CC);
	zval_ptr_dtor(&zCACertificate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBeforeCertificateValidationEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCertificate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCertificate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBAfterCertificateValidationEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Certificate, TElX509CertificateHandle CACertificate, TSBCertificateValidityRaw * Validity, TSBCertificateValidityReasonRaw * Reason, int8_t * DoContinue)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zCertificate;
	zval * zCACertificate;
	zval * zValidity;
	zval * zReason;
	zval * zDoContinue;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCertificate);
	SBInitObject(zCertificate, TElX509Certificate_ce_ptr, Certificate TSRMLS_CC);
	MAKE_STD_ZVAL(zCACertificate);
	SBInitObject(zCACertificate, TElX509Certificate_ce_ptr, CACertificate TSRMLS_CC);
	MAKE_STD_ZVAL(zValidity);
	ZVAL_LONG(zValidity, (long)*Validity);
	MAKE_STD_ZVAL(zReason);
	ZVAL_LONG(zReason, (long)*Reason);
	MAKE_STD_ZVAL(zDoContinue);
	ZVAL_BOOL(zDoContinue, (zend_bool)*DoContinue);

	params[0] = &zSender;
	params[1] = &zCertificate;
	params[2] = &zCACertificate;
	params[3] = &zValidity;
	params[4] = &zReason;
	params[5] = &zDoContinue;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCertificate);
	zval_ptr_dtor(&zCACertificate);
	*Validity = (TSBCertificateValidityRaw)Z_LVAL_P(zValidity);
	zval_ptr_dtor(&zValidity);
	*Reason = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zReason);
	zval_ptr_dtor(&zReason);
	*DoContinue = (int8_t)Z_BVAL_P(zDoContinue);
	zval_ptr_dtor(&zDoContinue);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBX509RevocationCheckPreference_ce_ptr = NULL;

zend_class_entry *TElX509CertificateValidator_ce_ptr = NULL;

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElX509CertificateValidator, InitializeWinStorages)
#endif
#ifdef MACOS
SB_PHP_METHOD(TElX509CertificateValidator, InitializeAppleStorages)
#endif
#ifndef LINUX
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifndef MACOS
		SBCheckError(TElX509CertificateValidator_InitializeWinStorages(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
#else
		SBCheckError(TElX509CertificateValidator_InitializeAppleStorages(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElX509CertificateValidator, Validate)
{
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zend_bool bCompleteChainValidation;
	zval *dtValidityMoment;
	zval *oAdditionalCertificates;
	zval *oCertificate;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bOzz", &oCertificate, TElX509Certificate_ce_ptr, &oAdditionalCertificates, TElCustomCertStorage_ce_ptr, &bCompleteChainValidation, &dtValidityMoment, php_date_get_date_ce(), &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElX509CertificateValidator_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), SBGetObjectHandle(oAdditionalCertificates TSRMLS_CC), (int8_t)bCompleteChainValidation, SBGetDateTime(dtValidityMoment TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCertificate, TElX509Certificate_ce_ptr, &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElX509CertificateValidator_Validate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElCustomCertStorage, bool, DateTime, &integer, &integer) or (TElX509Certificate, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ValidateForSMIME)
{
	char *sEMailAddress;
	int sEMailAddress_len;
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zend_bool bCompleteChainValidation;
	zval *dtValidityMoment;
	zval *oAdditionalCertificates;
	zval *oCertificate;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!bOzz", &oCertificate, TElX509Certificate_ce_ptr, &sEMailAddress, &sEMailAddress_len, &oAdditionalCertificates, TElCustomCertStorage_ce_ptr, &bCompleteChainValidation, &dtValidityMoment, php_date_get_date_ce(), &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElX509CertificateValidator_ValidateForSMIME(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), sEMailAddress, (int32_t)sEMailAddress_len, SBGetObjectHandle(oAdditionalCertificates TSRMLS_CC), (int8_t)bCompleteChainValidation, SBGetDateTime(dtValidityMoment TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, string, TElCustomCertStorage, bool, DateTime, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ValidateForSSL)
{
	char *sDomainName;
	char *sIPAddress;
	int sDomainName_len;
	int sIPAddress_len;
	long fHostRole;
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zend_bool bCompleteChainValidation;
	zend_bool bInternalValidation;
	zval *dtValidityMoment;
	zval *oAdditionalCertificates;
	zval *oCertificate;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!bOzz", &oCertificate, TElX509Certificate_ce_ptr, &sDomainName, &sDomainName_len, &sIPAddress, &sIPAddress_len, &fHostRole, &oAdditionalCertificates, TElCustomCertStorage_ce_ptr, &bCompleteChainValidation, &dtValidityMoment, php_date_get_date_ce(), &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElX509CertificateValidator_ValidateForSSL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), sDomainName, (int32_t)sDomainName_len, sIPAddress, (int32_t)sIPAddress_len, (TSBHostRoleRaw)fHostRole, SBGetObjectHandle(oAdditionalCertificates TSRMLS_CC), (int8_t)bCompleteChainValidation, SBGetDateTime(dtValidityMoment TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!bObzz", &oCertificate, TElX509Certificate_ce_ptr, &sDomainName, &sDomainName_len, &sIPAddress, &sIPAddress_len, &fHostRole, &oAdditionalCertificates, TElCustomCertStorage_ce_ptr, &bCompleteChainValidation, &dtValidityMoment, php_date_get_date_ce(), &bInternalValidation, &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElX509CertificateValidator_ValidateForSSL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), sDomainName, (int32_t)sDomainName_len, sIPAddress, (int32_t)sIPAddress_len, (TSBHostRoleRaw)fHostRole, SBGetObjectHandle(oAdditionalCertificates TSRMLS_CC), (int8_t)bCompleteChainValidation, SBGetDateTime(dtValidityMoment TSRMLS_CC), (int8_t)bInternalValidation, &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, string, string, integer, TElCustomCertStorage, bool, DateTime, &integer, &integer) or (TElX509Certificate, string, string, integer, TElCustomCertStorage, bool, DateTime, bool, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ValidateForTimestamping)
{
	TSBCertificateValidityRaw fValidityRaw;
	TSBCertificateValidityReasonRaw fReasonRaw;
	zend_bool bCompleteChainValidation;
	zval *dtValidityMoment;
	zval *oAdditionalCertificates;
	zval *oCertificate;
	zval *zfReason;
	zval *zfValidity;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bOzz", &oCertificate, TElX509Certificate_ce_ptr, &oAdditionalCertificates, TElCustomCertStorage_ce_ptr, &bCompleteChainValidation, &dtValidityMoment, php_date_get_date_ce(), &zfValidity, &zfReason) == SUCCESS) && PZVAL_IS_REF(zfValidity) && (IS_LONG == Z_TYPE_P(zfValidity)) && PZVAL_IS_REF(zfReason) && (IS_LONG == Z_TYPE_P(zfReason)))
	{
		fValidityRaw = (TSBCertificateValidityRaw)Z_LVAL_P(zfValidity);
		fReasonRaw = (TSBCertificateValidityReasonRaw)Z_LVAL_P(zfReason);
		SBCheckError(TElX509CertificateValidator_ValidateForTimestamping(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), SBGetObjectHandle(oAdditionalCertificates TSRMLS_CC), (int8_t)bCompleteChainValidation, SBGetDateTime(dtValidityMoment TSRMLS_CC), &fValidityRaw, &fReasonRaw) TSRMLS_CC);
		ZVAL_LONG(zfValidity, (long)fValidityRaw);
		ZVAL_LONG(zfReason, (long)fReasonRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, TElCustomCertStorage, bool, DateTime, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, AddTrustedCertificates)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_AddTrustedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearTrustedCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearTrustedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, AddBlockedCertificates)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_AddBlockedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearBlockedCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearBlockedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, AddKnownCertificates)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_AddKnownCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearKnownCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearKnownCertificates(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, AddKnownCRLs)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCustomCRLStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_AddKnownCRLs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearKnownCRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearKnownCRLs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, AddKnownOCSPResponses)
{
	zval *oResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResponse, TElOCSPResponse_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_AddKnownOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResponse TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearKnownOCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearKnownOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ResetCertificateCache_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ResetCertificateCache_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ResetCertificateCache)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ResetCertificateCache() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearOutdatedCacheRecords_Inst)
{
	long l4CacheValidityTime;
	zval *dtClearMoment;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtClearMoment, php_date_get_date_ce(), &l4CacheValidityTime) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearOutdatedCacheRecords_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtClearMoment TSRMLS_CC), (int32_t)l4CacheValidityTime) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, ClearOutdatedCacheRecords)
{
	long l4CacheValidityTime;
	zval *dtClearMoment;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtClearMoment, php_date_get_date_ce(), &l4CacheValidityTime) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_ClearOutdatedCacheRecords(SBGetDateTime(dtClearMoment TSRMLS_CC), (int32_t)l4CacheValidityTime) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_UsedCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_UsedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_UsedCRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_UsedCRLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCRLStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_UsedOCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_UsedOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElX509CertificateValidator, get_WinStorageTrust)
#else
SB_PHP_METHOD(TElX509CertificateValidator, get_Logger)
#endif
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_WINDOWS
		SBCheckError(TElX509CertificateValidator_get_WinStorageTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBCheckError(TElX509CertificateValidator_get_Logger(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidatorLogger_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElX509CertificateValidator, get_WinStorageCA)
#else
SB_PHP_METHOD(TElX509CertificateValidator, set_Logger)
#endif
{
#ifndef SB_WINDOWS
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509CertificateValidatorLogger_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_Logger(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509CertificateValidatorLogger)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_InternalLogger)
{
#endif
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_WINDOWS
		SBCheckError(TElX509CertificateValidator_get_WinStorageCA(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBCheckError(TElX509CertificateValidator_get_InternalLogger(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidatorLogger_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElX509CertificateValidator, get_WinStorageBlocked)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_WinStorageBlocked(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_Logger)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_Logger(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidatorLogger_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_Logger)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509CertificateValidatorLogger_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_Logger(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509CertificateValidatorLogger)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_InternalLogger)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_InternalLogger(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidatorLogger_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#endif
#ifdef MACOS
SB_PHP_METHOD(TElX509CertificateValidator, get_AppleStorageCA)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_AppleStorageCA(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAppleCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_AppleStorageTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_AppleStorageTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAppleCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#endif
#ifndef LINUX
SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreSystemTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreSystemTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreSystemTrust)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreSystemTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_UseSystemStorages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_UseSystemStorages(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_UseSystemStorages)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_UseSystemStorages(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElX509CertificateValidator, get_CheckCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_CheckCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_CheckCRL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_CheckCRL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_CheckOCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_CheckOCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_CheckOCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_CheckOCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_CheckValidityPeriodForTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_CheckValidityPeriodForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_CheckValidityPeriodForTrusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_CheckValidityPeriodForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreCAKeyUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreCAKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreCAKeyUsage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreCAKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreRevocationKeyUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreRevocationKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreRevocationKeyUsage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreRevocationKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreSSLKeyUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreSSLKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreSSLKeyUsage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreSSLKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreBadOCSPChains)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreBadOCSPChains(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreBadOCSPChains)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreBadOCSPChains(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreCABasicConstraints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreCABasicConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreCABasicConstraints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreCABasicConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_IgnoreCANameConstraints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_IgnoreCANameConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_IgnoreCANameConstraints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_IgnoreCANameConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_MandatoryCRLCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_MandatoryCRLCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_MandatoryCRLCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_MandatoryCRLCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_MandatoryOCSPCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_MandatoryOCSPCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_MandatoryOCSPCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_MandatoryOCSPCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_MandatoryRevocationCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_MandatoryRevocationCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_MandatoryRevocationCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_MandatoryRevocationCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_ValidateInvalidCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_ValidateInvalidCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_ValidateInvalidCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_ValidateInvalidCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_ForceCompleteChainValidationForTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_ForceCompleteChainValidationForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_ForceCompleteChainValidationForTrusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_ForceCompleteChainValidationForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_ForceRevocationCheckForRoot)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_ForceRevocationCheckForRoot(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_ForceRevocationCheckForRoot)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_ForceRevocationCheckForRoot(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OfflineMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_OfflineMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OfflineMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_OfflineMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_RevocationMomentGracePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_RevocationMomentGracePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_RevocationMomentGracePeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_RevocationMomentGracePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_ImplicitlyTrustSelfSignedCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_ImplicitlyTrustSelfSignedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_ImplicitlyTrustSelfSignedCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_ImplicitlyTrustSelfSignedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_PromoteLongOCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_PromoteLongOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_PromoteLongOCSPResponses)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_PromoteLongOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_RevocationCheckPreference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBX509RevocationCheckPreferenceRaw fOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_RevocationCheckPreference(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_RevocationCheckPreference)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_RevocationCheckPreference(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBX509RevocationCheckPreferenceRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_LookupCRLByNameIfDPNotPresent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_LookupCRLByNameIfDPNotPresent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_LookupCRLByNameIfDPNotPresent)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_LookupCRLByNameIfDPNotPresent(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_SkipSubjectNameIfAltNameExists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_SkipSubjectNameIfAltNameExists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_SkipSubjectNameIfAltNameExists)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_SkipSubjectNameIfAltNameExists(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_CacheValidityTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_CacheValidityTime(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_CacheValidityTime)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_CacheValidityTime(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_CacheValidationResults)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidator_get_CacheValidationResults(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_CacheValidationResults)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidator_set_CacheValidationResults(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnCRLNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnCRLNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnCRLNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnCRLNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCRLNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCRLNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnCRLRetrieved)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCRLRetrievedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnCRLRetrieved(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnCRLRetrieved)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnCRLRetrieved(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCRLRetrievedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCRLRetrievedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnBeforeCRLRetrieverUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBeforeCRLRetrieverUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnBeforeCRLRetrieverUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnBeforeCRLRetrieverUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnBeforeCRLRetrieverUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBeforeCRLRetrieverUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBeforeCRLRetrieverUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnBeforeCertificateRetrieverUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBeforeCertificateRetrieverUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnBeforeCertificateRetrieverUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnBeforeCertificateRetrieverUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnBeforeCertificateRetrieverUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBeforeCertificateRetrieverUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBeforeCertificateRetrieverUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnCACertificateRetrieved)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCACertificateRetrievedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnCACertificateRetrieved(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnCACertificateRetrieved)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnCACertificateRetrieved(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCACertificateRetrievedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCACertificateRetrievedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnBeforeOCSPClientUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBeforeOCSPClientUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnBeforeOCSPClientUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnBeforeOCSPClientUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnBeforeOCSPClientUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBeforeOCSPClientUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBeforeOCSPClientUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnBeforeCertificateValidation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBeforeCertificateValidationEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnBeforeCertificateValidation(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnBeforeCertificateValidation)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnBeforeCertificateValidation(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBeforeCertificateValidationEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBeforeCertificateValidationEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnAfterCertificateValidation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAfterCertificateValidationEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnAfterCertificateValidation(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnAfterCertificateValidation)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnAfterCertificateValidation(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAfterCertificateValidationEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAfterCertificateValidationEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnCACertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCACertificateNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnCACertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnCACertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnCACertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCACertificateNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCACertificateNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnAfterCRLUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAfterCRLUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnAfterCRLUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnAfterCRLUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnAfterCRLUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAfterCRLUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAfterCRLUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnAfterOCSPResponseUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAfterOCSPResponseUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnAfterOCSPResponseUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnAfterOCSPResponseUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnAfterOCSPResponseUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAfterOCSPResponseUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAfterOCSPResponseUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnOCSPResponseSignerValid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOCSPResponseSignerValidEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnOCSPResponseSignerValid(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnOCSPResponseSignerValid)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnOCSPResponseSignerValid(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOCSPResponseSignerValidEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOCSPResponseSignerValidEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnCRLError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidatorCRLErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnCRLError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnCRLError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnCRLError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidatorCRLErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidatorCRLErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, get_OnOCSPError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidatorOCSPErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_get_OnOCSPError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, set_OnOCSPError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElX509CertificateValidator_set_OnOCSPError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidatorOCSPErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidatorOCSPErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidator, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidator_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_InitializeWinStorages, 0, 0, 0)
#endif
#ifdef MACOS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_InitializeAppleStorages, 0, 0, 0)
#endif
#ifndef LINUX
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_Validate, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_TYPE_INFO(1, AdditionalCertificates_or_Validity, 0, 1)
	ZEND_ARG_INFO(1, CompleteChainValidation_or_Reason)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
	ZEND_ARG_INFO(1, Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ValidateForSMIME, 0, 0, 7)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, EMailAddress)
	ZEND_ARG_OBJ_INFO(0, AdditionalCertificates, TElCustomCertStorage, 1)
	ZEND_ARG_INFO(0, CompleteChainValidation)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
	ZEND_ARG_INFO(1, Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ValidateForSSL, 0, 0, 9)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, DomainName)
	ZEND_ARG_INFO(0, IPAddress)
	ZEND_ARG_INFO(0, HostRole)
	ZEND_ARG_OBJ_INFO(0, AdditionalCertificates, TElCustomCertStorage, 1)
	ZEND_ARG_INFO(0, CompleteChainValidation)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
	ZEND_ARG_INFO(1, Validity_or_InternalValidation)
	ZEND_ARG_INFO(1, Reason_or_Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ValidateForTimestamping, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
	ZEND_ARG_OBJ_INFO(0, AdditionalCertificates, TElCustomCertStorage, 1)
	ZEND_ARG_INFO(0, CompleteChainValidation)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
	ZEND_ARG_INFO(1, Validity)
	ZEND_ARG_INFO(1, Reason)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_AddTrustedCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearTrustedCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_AddBlockedCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearBlockedCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_AddKnownCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearKnownCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_AddKnownCRLs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElCustomCRLStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearKnownCRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_AddKnownOCSPResponses, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Response, TElOCSPResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearKnownOCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ResetCertificateCache_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ResetCertificateCache, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearOutdatedCacheRecords_Inst, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ClearMoment, DateTime, 0)
	ZEND_ARG_INFO(0, CacheValidityTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_ClearOutdatedCacheRecords, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ClearMoment, DateTime, 0)
	ZEND_ARG_INFO(0, CacheValidityTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_UsedCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_UsedCRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_UsedOCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_WinStorageTrust, 0, 0, 0)
#else
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_Logger, 0, 0, 0)
#endif
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_WinStorageCA, 0, 0, 0)
#else
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_Logger, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509CertificateValidatorLogger, 1)
#endif
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_WinStorageBlocked, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_Logger, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_Logger, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509CertificateValidatorLogger, 1)
ZEND_END_ARG_INFO()

#endif
#ifndef MACOS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_InternalLogger, 0, 0, 0)
ZEND_END_ARG_INFO()

#else
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_InternalLogger, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_AppleStorageCA, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_AppleStorageTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

#endif
#ifndef LINUX
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreSystemTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreSystemTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_UseSystemStorages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_UseSystemStorages, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_CheckCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_CheckCRL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_CheckOCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_CheckOCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_CheckValidityPeriodForTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_CheckValidityPeriodForTrusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreCAKeyUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreCAKeyUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreRevocationKeyUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreRevocationKeyUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreSSLKeyUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreSSLKeyUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreBadOCSPChains, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreBadOCSPChains, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreCABasicConstraints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreCABasicConstraints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_IgnoreCANameConstraints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_IgnoreCANameConstraints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_MandatoryCRLCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_MandatoryCRLCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_MandatoryOCSPCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_MandatoryOCSPCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_MandatoryRevocationCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_MandatoryRevocationCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_ValidateInvalidCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_ValidateInvalidCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_ForceCompleteChainValidationForTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_ForceCompleteChainValidationForTrusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_ForceRevocationCheckForRoot, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_ForceRevocationCheckForRoot, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OfflineMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OfflineMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_RevocationMomentGracePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_RevocationMomentGracePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_ImplicitlyTrustSelfSignedCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_ImplicitlyTrustSelfSignedCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_PromoteLongOCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_PromoteLongOCSPResponses, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_RevocationCheckPreference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_RevocationCheckPreference, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_LookupCRLByNameIfDPNotPresent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_LookupCRLByNameIfDPNotPresent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_SkipSubjectNameIfAltNameExists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_SkipSubjectNameIfAltNameExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_CacheValidityTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_CacheValidityTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_CacheValidationResults, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_CacheValidationResults, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnCRLNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnCRLNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnCRLRetrieved, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnCRLRetrieved, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnBeforeCRLRetrieverUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnBeforeCRLRetrieverUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnBeforeCertificateRetrieverUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnBeforeCertificateRetrieverUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnCACertificateRetrieved, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnCACertificateRetrieved, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnBeforeOCSPClientUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnBeforeOCSPClientUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnBeforeCertificateValidation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnBeforeCertificateValidation, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnAfterCertificateValidation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnAfterCertificateValidation, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnCACertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnCACertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnAfterCRLUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnAfterCRLUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnAfterOCSPResponseUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnAfterOCSPResponseUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnOCSPResponseSignerValid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnOCSPResponseSignerValid, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnCRLError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnCRLError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_get_OnOCSPError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator_set_OnOCSPError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidator___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElX509CertificateValidator_methods[] = {
#ifdef SB_WINDOWS
	PHP_ME(TElX509CertificateValidator, InitializeWinStorages, arginfo_TElX509CertificateValidator_InitializeWinStorages, ZEND_ACC_PUBLIC)
#endif
#ifdef MACOS
	PHP_ME(TElX509CertificateValidator, InitializeAppleStorages, arginfo_TElX509CertificateValidator_InitializeAppleStorages, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElX509CertificateValidator, Validate, arginfo_TElX509CertificateValidator_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ValidateForSMIME, arginfo_TElX509CertificateValidator_ValidateForSMIME, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ValidateForSSL, arginfo_TElX509CertificateValidator_ValidateForSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ValidateForTimestamping, arginfo_TElX509CertificateValidator_ValidateForTimestamping, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, AddTrustedCertificates, arginfo_TElX509CertificateValidator_AddTrustedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ClearTrustedCertificates, arginfo_TElX509CertificateValidator_ClearTrustedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, AddBlockedCertificates, arginfo_TElX509CertificateValidator_AddBlockedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ClearBlockedCertificates, arginfo_TElX509CertificateValidator_ClearBlockedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, AddKnownCertificates, arginfo_TElX509CertificateValidator_AddKnownCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ClearKnownCertificates, arginfo_TElX509CertificateValidator_ClearKnownCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, AddKnownCRLs, arginfo_TElX509CertificateValidator_AddKnownCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ClearKnownCRLs, arginfo_TElX509CertificateValidator_ClearKnownCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, AddKnownOCSPResponses, arginfo_TElX509CertificateValidator_AddKnownOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ClearKnownOCSPResponses, arginfo_TElX509CertificateValidator_ClearKnownOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ResetCertificateCache_Inst, arginfo_TElX509CertificateValidator_ResetCertificateCache_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ResetCertificateCache, arginfo_TElX509CertificateValidator_ResetCertificateCache, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElX509CertificateValidator, ClearOutdatedCacheRecords_Inst, arginfo_TElX509CertificateValidator_ClearOutdatedCacheRecords_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, ClearOutdatedCacheRecords, arginfo_TElX509CertificateValidator_ClearOutdatedCacheRecords, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElX509CertificateValidator, get_UsedCertificates, arginfo_TElX509CertificateValidator_get_UsedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_UsedCRLs, arginfo_TElX509CertificateValidator_get_UsedCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_UsedOCSPResponses, arginfo_TElX509CertificateValidator_get_UsedOCSPResponses, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElX509CertificateValidator, get_WinStorageTrust, arginfo_TElX509CertificateValidator_get_WinStorageTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_WinStorageCA, arginfo_TElX509CertificateValidator_get_WinStorageCA, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_WinStorageBlocked, arginfo_TElX509CertificateValidator_get_WinStorageBlocked, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElX509CertificateValidator, get_Logger, arginfo_TElX509CertificateValidator_get_Logger, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_Logger, arginfo_TElX509CertificateValidator_set_Logger, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_InternalLogger, arginfo_TElX509CertificateValidator_get_InternalLogger, ZEND_ACC_PUBLIC)
#ifdef MACOS
	PHP_ME(TElX509CertificateValidator, get_AppleStorageCA, arginfo_TElX509CertificateValidator_get_AppleStorageCA, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_AppleStorageTrust, arginfo_TElX509CertificateValidator_get_AppleStorageTrust, ZEND_ACC_PUBLIC)
#endif
#ifndef LINUX
	PHP_ME(TElX509CertificateValidator, get_IgnoreSystemTrust, arginfo_TElX509CertificateValidator_get_IgnoreSystemTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreSystemTrust, arginfo_TElX509CertificateValidator_set_IgnoreSystemTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_UseSystemStorages, arginfo_TElX509CertificateValidator_get_UseSystemStorages, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_UseSystemStorages, arginfo_TElX509CertificateValidator_set_UseSystemStorages, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElX509CertificateValidator, get_CheckCRL, arginfo_TElX509CertificateValidator_get_CheckCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_CheckCRL, arginfo_TElX509CertificateValidator_set_CheckCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_CheckOCSP, arginfo_TElX509CertificateValidator_get_CheckOCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_CheckOCSP, arginfo_TElX509CertificateValidator_set_CheckOCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_CheckValidityPeriodForTrusted, arginfo_TElX509CertificateValidator_get_CheckValidityPeriodForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_CheckValidityPeriodForTrusted, arginfo_TElX509CertificateValidator_set_CheckValidityPeriodForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_IgnoreCAKeyUsage, arginfo_TElX509CertificateValidator_get_IgnoreCAKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreCAKeyUsage, arginfo_TElX509CertificateValidator_set_IgnoreCAKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_IgnoreRevocationKeyUsage, arginfo_TElX509CertificateValidator_get_IgnoreRevocationKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreRevocationKeyUsage, arginfo_TElX509CertificateValidator_set_IgnoreRevocationKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_IgnoreSSLKeyUsage, arginfo_TElX509CertificateValidator_get_IgnoreSSLKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreSSLKeyUsage, arginfo_TElX509CertificateValidator_set_IgnoreSSLKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_IgnoreBadOCSPChains, arginfo_TElX509CertificateValidator_get_IgnoreBadOCSPChains, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreBadOCSPChains, arginfo_TElX509CertificateValidator_set_IgnoreBadOCSPChains, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_IgnoreCABasicConstraints, arginfo_TElX509CertificateValidator_get_IgnoreCABasicConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreCABasicConstraints, arginfo_TElX509CertificateValidator_set_IgnoreCABasicConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_IgnoreCANameConstraints, arginfo_TElX509CertificateValidator_get_IgnoreCANameConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_IgnoreCANameConstraints, arginfo_TElX509CertificateValidator_set_IgnoreCANameConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_MandatoryCRLCheck, arginfo_TElX509CertificateValidator_get_MandatoryCRLCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_MandatoryCRLCheck, arginfo_TElX509CertificateValidator_set_MandatoryCRLCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_MandatoryOCSPCheck, arginfo_TElX509CertificateValidator_get_MandatoryOCSPCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_MandatoryOCSPCheck, arginfo_TElX509CertificateValidator_set_MandatoryOCSPCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_MandatoryRevocationCheck, arginfo_TElX509CertificateValidator_get_MandatoryRevocationCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_MandatoryRevocationCheck, arginfo_TElX509CertificateValidator_set_MandatoryRevocationCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_ValidateInvalidCertificates, arginfo_TElX509CertificateValidator_get_ValidateInvalidCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_ValidateInvalidCertificates, arginfo_TElX509CertificateValidator_set_ValidateInvalidCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_ForceCompleteChainValidationForTrusted, arginfo_TElX509CertificateValidator_get_ForceCompleteChainValidationForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_ForceCompleteChainValidationForTrusted, arginfo_TElX509CertificateValidator_set_ForceCompleteChainValidationForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_ForceRevocationCheckForRoot, arginfo_TElX509CertificateValidator_get_ForceRevocationCheckForRoot, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_ForceRevocationCheckForRoot, arginfo_TElX509CertificateValidator_set_ForceRevocationCheckForRoot, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OfflineMode, arginfo_TElX509CertificateValidator_get_OfflineMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OfflineMode, arginfo_TElX509CertificateValidator_set_OfflineMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_RevocationMomentGracePeriod, arginfo_TElX509CertificateValidator_get_RevocationMomentGracePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_RevocationMomentGracePeriod, arginfo_TElX509CertificateValidator_set_RevocationMomentGracePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_ImplicitlyTrustSelfSignedCertificates, arginfo_TElX509CertificateValidator_get_ImplicitlyTrustSelfSignedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_ImplicitlyTrustSelfSignedCertificates, arginfo_TElX509CertificateValidator_set_ImplicitlyTrustSelfSignedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_PromoteLongOCSPResponses, arginfo_TElX509CertificateValidator_get_PromoteLongOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_PromoteLongOCSPResponses, arginfo_TElX509CertificateValidator_set_PromoteLongOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_RevocationCheckPreference, arginfo_TElX509CertificateValidator_get_RevocationCheckPreference, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_RevocationCheckPreference, arginfo_TElX509CertificateValidator_set_RevocationCheckPreference, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_LookupCRLByNameIfDPNotPresent, arginfo_TElX509CertificateValidator_get_LookupCRLByNameIfDPNotPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_LookupCRLByNameIfDPNotPresent, arginfo_TElX509CertificateValidator_set_LookupCRLByNameIfDPNotPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_SkipSubjectNameIfAltNameExists, arginfo_TElX509CertificateValidator_get_SkipSubjectNameIfAltNameExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_SkipSubjectNameIfAltNameExists, arginfo_TElX509CertificateValidator_set_SkipSubjectNameIfAltNameExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_CacheValidityTime, arginfo_TElX509CertificateValidator_get_CacheValidityTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_CacheValidityTime, arginfo_TElX509CertificateValidator_set_CacheValidityTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_CacheValidationResults, arginfo_TElX509CertificateValidator_get_CacheValidationResults, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_CacheValidationResults, arginfo_TElX509CertificateValidator_set_CacheValidationResults, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnCRLNeeded, arginfo_TElX509CertificateValidator_get_OnCRLNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnCRLNeeded, arginfo_TElX509CertificateValidator_set_OnCRLNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnCRLRetrieved, arginfo_TElX509CertificateValidator_get_OnCRLRetrieved, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnCRLRetrieved, arginfo_TElX509CertificateValidator_set_OnCRLRetrieved, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnBeforeCRLRetrieverUse, arginfo_TElX509CertificateValidator_get_OnBeforeCRLRetrieverUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnBeforeCRLRetrieverUse, arginfo_TElX509CertificateValidator_set_OnBeforeCRLRetrieverUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnBeforeCertificateRetrieverUse, arginfo_TElX509CertificateValidator_get_OnBeforeCertificateRetrieverUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnBeforeCertificateRetrieverUse, arginfo_TElX509CertificateValidator_set_OnBeforeCertificateRetrieverUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnCACertificateRetrieved, arginfo_TElX509CertificateValidator_get_OnCACertificateRetrieved, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnCACertificateRetrieved, arginfo_TElX509CertificateValidator_set_OnCACertificateRetrieved, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnBeforeOCSPClientUse, arginfo_TElX509CertificateValidator_get_OnBeforeOCSPClientUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnBeforeOCSPClientUse, arginfo_TElX509CertificateValidator_set_OnBeforeOCSPClientUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnBeforeCertificateValidation, arginfo_TElX509CertificateValidator_get_OnBeforeCertificateValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnBeforeCertificateValidation, arginfo_TElX509CertificateValidator_set_OnBeforeCertificateValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnAfterCertificateValidation, arginfo_TElX509CertificateValidator_get_OnAfterCertificateValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnAfterCertificateValidation, arginfo_TElX509CertificateValidator_set_OnAfterCertificateValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnCACertificateNeeded, arginfo_TElX509CertificateValidator_get_OnCACertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnCACertificateNeeded, arginfo_TElX509CertificateValidator_set_OnCACertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnAfterCRLUse, arginfo_TElX509CertificateValidator_get_OnAfterCRLUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnAfterCRLUse, arginfo_TElX509CertificateValidator_set_OnAfterCRLUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnAfterOCSPResponseUse, arginfo_TElX509CertificateValidator_get_OnAfterOCSPResponseUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnAfterOCSPResponseUse, arginfo_TElX509CertificateValidator_set_OnAfterOCSPResponseUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnOCSPResponseSignerValid, arginfo_TElX509CertificateValidator_get_OnOCSPResponseSignerValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnOCSPResponseSignerValid, arginfo_TElX509CertificateValidator_set_OnOCSPResponseSignerValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnCRLError, arginfo_TElX509CertificateValidator_get_OnCRLError, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnCRLError, arginfo_TElX509CertificateValidator_set_OnCRLError, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, get_OnOCSPError, arginfo_TElX509CertificateValidator_get_OnOCSPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, set_OnOCSPError, arginfo_TElX509CertificateValidator_set_OnOCSPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidator, __construct, arginfo_TElX509CertificateValidator___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElX509CertificateValidator(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElX509CertificateValidator_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElX509CertificateValidator", TElX509CertificateValidator_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElX509CertificateValidator_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElX509CertificateValidatorLogger_ce_ptr = NULL;

SB_PHP_METHOD(TElX509CertificateValidatorLogger, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidatorLogger_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidatorLogger, get_Log)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidatorLogger_get_Log(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidatorLogger, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidatorLogger_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidatorLogger_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidatorLogger_get_Log, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidatorLogger___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElX509CertificateValidatorLogger_methods[] = {
	PHP_ME(TElX509CertificateValidatorLogger, Reset, arginfo_TElX509CertificateValidatorLogger_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidatorLogger, get_Log, arginfo_TElX509CertificateValidatorLogger_get_Log, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidatorLogger, __construct, arginfo_TElX509CertificateValidatorLogger___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElX509CertificateValidatorLogger(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElX509CertificateValidatorLogger_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElX509CertificateValidatorLogger", TElX509CertificateValidatorLogger_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElX509CertificateValidatorLogger_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElX509CertificateValidationResult_ce_ptr = NULL;

SB_PHP_METHOD(TElX509CertificateValidationResult, EqualParams)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509CertificateValidationResult_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_EqualParams(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509CertificateValidationResult)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_LastValidatedTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_LastValidatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_LastValidatedTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_LastValidatedTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_Validity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidityRaw fOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_Validity(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_Validity)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_Validity(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCertificateValidityRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_Reason)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidityReasonRaw fOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_Reason(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_Reason)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_Reason(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBCertificateValidityReasonRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifndef LINUX
SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreSystemTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreSystemTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreSystemTrust)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreSystemTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_UseSystemStorages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_UseSystemStorages(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_UseSystemStorages)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_UseSystemStorages(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElX509CertificateValidationResult, get_CheckCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_CheckCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_CheckCRL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_CheckCRL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_CheckOCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_CheckOCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_CheckOCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_CheckOCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_CheckValidityPeriodForTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_CheckValidityPeriodForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_CheckValidityPeriodForTrusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_CheckValidityPeriodForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreCAKeyUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreCAKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreCAKeyUsage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreCAKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreRevocationKeyUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreRevocationKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreRevocationKeyUsage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreRevocationKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreSSLKeyUsage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreSSLKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreSSLKeyUsage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreSSLKeyUsage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreBadOCSPChains)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreBadOCSPChains(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreBadOCSPChains)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreBadOCSPChains(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreCABasicConstraints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreCABasicConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreCABasicConstraints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreCABasicConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_IgnoreCANameConstraints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_IgnoreCANameConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_IgnoreCANameConstraints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_IgnoreCANameConstraints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_MandatoryCRLCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_MandatoryCRLCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_MandatoryCRLCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_MandatoryCRLCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_MandatoryOCSPCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_MandatoryOCSPCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_MandatoryOCSPCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_MandatoryOCSPCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_MandatoryRevocationCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_MandatoryRevocationCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_MandatoryRevocationCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_MandatoryRevocationCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_ValidateInvalidCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_ValidateInvalidCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_ValidateInvalidCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_ValidateInvalidCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_ForceCompleteChainValidationForTrusted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_ForceCompleteChainValidationForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_ForceCompleteChainValidationForTrusted)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_ForceCompleteChainValidationForTrusted(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_ForceRevocationCheckForRoot)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_ForceRevocationCheckForRoot(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_ForceRevocationCheckForRoot)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_ForceRevocationCheckForRoot(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_OfflineMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_OfflineMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_OfflineMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_OfflineMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_RevocationMomentGracePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_RevocationMomentGracePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_RevocationMomentGracePeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_RevocationMomentGracePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_ImplicitlyTrustSelfSignedCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_ImplicitlyTrustSelfSignedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_ImplicitlyTrustSelfSignedCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_ImplicitlyTrustSelfSignedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_PromoteLongOCSPResponses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_PromoteLongOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_PromoteLongOCSPResponses)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_PromoteLongOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_RevocationCheckPreference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBX509RevocationCheckPreferenceRaw fOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_RevocationCheckPreference(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_RevocationCheckPreference)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_RevocationCheckPreference(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBX509RevocationCheckPreferenceRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_LookupCRLByNameIfDPNotPresent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_LookupCRLByNameIfDPNotPresent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_LookupCRLByNameIfDPNotPresent)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_LookupCRLByNameIfDPNotPresent(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, get_SkipSubjectNameIfAltNameExists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CertificateValidationResult_get_SkipSubjectNameIfAltNameExists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, set_SkipSubjectNameIfAltNameExists)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElX509CertificateValidationResult_set_SkipSubjectNameIfAltNameExists(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CertificateValidationResult, __construct)
{
	zval *oValidator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValidator, TElX509CertificateValidator_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CertificateValidationResult_Create(SBGetObjectHandle(oValidator TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509CertificateValidator)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_EqualParams, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509CertificateValidationResult, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_LastValidatedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_LastValidatedTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_Validity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_Validity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_Reason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_Reason, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifndef LINUX
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreSystemTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreSystemTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_UseSystemStorages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_UseSystemStorages, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_CheckCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_CheckCRL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_CheckOCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_CheckOCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_CheckValidityPeriodForTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_CheckValidityPeriodForTrusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreCAKeyUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreCAKeyUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreRevocationKeyUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreRevocationKeyUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreSSLKeyUsage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreSSLKeyUsage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreBadOCSPChains, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreBadOCSPChains, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreCABasicConstraints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreCABasicConstraints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_IgnoreCANameConstraints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_IgnoreCANameConstraints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_MandatoryCRLCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_MandatoryCRLCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_MandatoryOCSPCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_MandatoryOCSPCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_MandatoryRevocationCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_MandatoryRevocationCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_ValidateInvalidCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_ValidateInvalidCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_ForceCompleteChainValidationForTrusted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_ForceCompleteChainValidationForTrusted, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_ForceRevocationCheckForRoot, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_ForceRevocationCheckForRoot, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_OfflineMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_OfflineMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_RevocationMomentGracePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_RevocationMomentGracePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_ImplicitlyTrustSelfSignedCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_ImplicitlyTrustSelfSignedCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_PromoteLongOCSPResponses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_PromoteLongOCSPResponses, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_RevocationCheckPreference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_RevocationCheckPreference, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_LookupCRLByNameIfDPNotPresent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_LookupCRLByNameIfDPNotPresent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_get_SkipSubjectNameIfAltNameExists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult_set_SkipSubjectNameIfAltNameExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CertificateValidationResult___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Validator, TElX509CertificateValidator, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElX509CertificateValidationResult_methods[] = {
	PHP_ME(TElX509CertificateValidationResult, EqualParams, arginfo_TElX509CertificateValidationResult_EqualParams, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_LastValidatedTime, arginfo_TElX509CertificateValidationResult_get_LastValidatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_LastValidatedTime, arginfo_TElX509CertificateValidationResult_set_LastValidatedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_Validity, arginfo_TElX509CertificateValidationResult_get_Validity, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_Validity, arginfo_TElX509CertificateValidationResult_set_Validity, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_Reason, arginfo_TElX509CertificateValidationResult_get_Reason, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_Reason, arginfo_TElX509CertificateValidationResult_set_Reason, ZEND_ACC_PUBLIC)
#ifndef LINUX
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreSystemTrust, arginfo_TElX509CertificateValidationResult_get_IgnoreSystemTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreSystemTrust, arginfo_TElX509CertificateValidationResult_set_IgnoreSystemTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_UseSystemStorages, arginfo_TElX509CertificateValidationResult_get_UseSystemStorages, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_UseSystemStorages, arginfo_TElX509CertificateValidationResult_set_UseSystemStorages, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElX509CertificateValidationResult, get_CheckCRL, arginfo_TElX509CertificateValidationResult_get_CheckCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_CheckCRL, arginfo_TElX509CertificateValidationResult_set_CheckCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_CheckOCSP, arginfo_TElX509CertificateValidationResult_get_CheckOCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_CheckOCSP, arginfo_TElX509CertificateValidationResult_set_CheckOCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_CheckValidityPeriodForTrusted, arginfo_TElX509CertificateValidationResult_get_CheckValidityPeriodForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_CheckValidityPeriodForTrusted, arginfo_TElX509CertificateValidationResult_set_CheckValidityPeriodForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreCAKeyUsage, arginfo_TElX509CertificateValidationResult_get_IgnoreCAKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreCAKeyUsage, arginfo_TElX509CertificateValidationResult_set_IgnoreCAKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreRevocationKeyUsage, arginfo_TElX509CertificateValidationResult_get_IgnoreRevocationKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreRevocationKeyUsage, arginfo_TElX509CertificateValidationResult_set_IgnoreRevocationKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreSSLKeyUsage, arginfo_TElX509CertificateValidationResult_get_IgnoreSSLKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreSSLKeyUsage, arginfo_TElX509CertificateValidationResult_set_IgnoreSSLKeyUsage, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreBadOCSPChains, arginfo_TElX509CertificateValidationResult_get_IgnoreBadOCSPChains, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreBadOCSPChains, arginfo_TElX509CertificateValidationResult_set_IgnoreBadOCSPChains, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreCABasicConstraints, arginfo_TElX509CertificateValidationResult_get_IgnoreCABasicConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreCABasicConstraints, arginfo_TElX509CertificateValidationResult_set_IgnoreCABasicConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_IgnoreCANameConstraints, arginfo_TElX509CertificateValidationResult_get_IgnoreCANameConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_IgnoreCANameConstraints, arginfo_TElX509CertificateValidationResult_set_IgnoreCANameConstraints, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_MandatoryCRLCheck, arginfo_TElX509CertificateValidationResult_get_MandatoryCRLCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_MandatoryCRLCheck, arginfo_TElX509CertificateValidationResult_set_MandatoryCRLCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_MandatoryOCSPCheck, arginfo_TElX509CertificateValidationResult_get_MandatoryOCSPCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_MandatoryOCSPCheck, arginfo_TElX509CertificateValidationResult_set_MandatoryOCSPCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_MandatoryRevocationCheck, arginfo_TElX509CertificateValidationResult_get_MandatoryRevocationCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_MandatoryRevocationCheck, arginfo_TElX509CertificateValidationResult_set_MandatoryRevocationCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_ValidateInvalidCertificates, arginfo_TElX509CertificateValidationResult_get_ValidateInvalidCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_ValidateInvalidCertificates, arginfo_TElX509CertificateValidationResult_set_ValidateInvalidCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_ForceCompleteChainValidationForTrusted, arginfo_TElX509CertificateValidationResult_get_ForceCompleteChainValidationForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_ForceCompleteChainValidationForTrusted, arginfo_TElX509CertificateValidationResult_set_ForceCompleteChainValidationForTrusted, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_ForceRevocationCheckForRoot, arginfo_TElX509CertificateValidationResult_get_ForceRevocationCheckForRoot, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_ForceRevocationCheckForRoot, arginfo_TElX509CertificateValidationResult_set_ForceRevocationCheckForRoot, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_OfflineMode, arginfo_TElX509CertificateValidationResult_get_OfflineMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_OfflineMode, arginfo_TElX509CertificateValidationResult_set_OfflineMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_RevocationMomentGracePeriod, arginfo_TElX509CertificateValidationResult_get_RevocationMomentGracePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_RevocationMomentGracePeriod, arginfo_TElX509CertificateValidationResult_set_RevocationMomentGracePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_ImplicitlyTrustSelfSignedCertificates, arginfo_TElX509CertificateValidationResult_get_ImplicitlyTrustSelfSignedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_ImplicitlyTrustSelfSignedCertificates, arginfo_TElX509CertificateValidationResult_set_ImplicitlyTrustSelfSignedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_PromoteLongOCSPResponses, arginfo_TElX509CertificateValidationResult_get_PromoteLongOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_PromoteLongOCSPResponses, arginfo_TElX509CertificateValidationResult_set_PromoteLongOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_RevocationCheckPreference, arginfo_TElX509CertificateValidationResult_get_RevocationCheckPreference, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_RevocationCheckPreference, arginfo_TElX509CertificateValidationResult_set_RevocationCheckPreference, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_LookupCRLByNameIfDPNotPresent, arginfo_TElX509CertificateValidationResult_get_LookupCRLByNameIfDPNotPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_LookupCRLByNameIfDPNotPresent, arginfo_TElX509CertificateValidationResult_set_LookupCRLByNameIfDPNotPresent, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, get_SkipSubjectNameIfAltNameExists, arginfo_TElX509CertificateValidationResult_get_SkipSubjectNameIfAltNameExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, set_SkipSubjectNameIfAltNameExists, arginfo_TElX509CertificateValidationResult_set_SkipSubjectNameIfAltNameExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CertificateValidationResult, __construct, arginfo_TElX509CertificateValidationResult___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElX509CertificateValidationResult(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElX509CertificateValidationResult_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElX509CertificateValidationResult", TElX509CertificateValidationResult_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElX509CertificateValidationResult_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElX509CachedCertificate_ce_ptr = NULL;

SB_PHP_METHOD(TElX509CachedCertificate, AddValidationResult)
{
	zval *oRes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRes, TElX509CertificateValidationResult_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElX509CachedCertificate_AddValidationResult(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRes TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509CertificateValidationResult)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, RemoveValidationResult)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElX509CachedCertificate_RemoveValidationResult(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, FindResultByValidityMoment)
{
	long l4CacheValidityTime;
	zval *dtValidityMoment;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtValidityMoment, php_date_get_date_ce(), &l4CacheValidityTime) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CachedCertificate_FindResultByValidityMoment(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValidityMoment TSRMLS_CC), (int32_t)l4CacheValidityTime, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidationResult_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, IsRevoked)
{
	zval *dtValidityMoment;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValidityMoment, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CachedCertificate_IsRevoked(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValidityMoment TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, IsPermanentlyInvalid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElX509CachedCertificate_IsPermanentlyInvalid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CachedCertificate_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, get_ValidationResults)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CachedCertificate_get_ValidationResults(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidationResult_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, get_ValidationResultCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElX509CachedCertificate_get_ValidationResultCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElX509CachedCertificate, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElX509CachedCertificate_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_AddValidationResult, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Res, TElX509CertificateValidationResult, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_RemoveValidationResult, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_FindResultByValidityMoment, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
	ZEND_ARG_INFO(0, CacheValidityTime)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_IsRevoked, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ValidityMoment, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_IsPermanentlyInvalid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_get_ValidationResults, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate_get_ValidationResultCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElX509CachedCertificate___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElX509CachedCertificate_methods[] = {
	PHP_ME(TElX509CachedCertificate, AddValidationResult, arginfo_TElX509CachedCertificate_AddValidationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, RemoveValidationResult, arginfo_TElX509CachedCertificate_RemoveValidationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, FindResultByValidityMoment, arginfo_TElX509CachedCertificate_FindResultByValidityMoment, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, IsRevoked, arginfo_TElX509CachedCertificate_IsRevoked, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, IsPermanentlyInvalid, arginfo_TElX509CachedCertificate_IsPermanentlyInvalid, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, ClassType, arginfo_TElX509CachedCertificate_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElX509CachedCertificate, get_ValidationResults, arginfo_TElX509CachedCertificate_get_ValidationResults, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, get_ValidationResultCount, arginfo_TElX509CachedCertificate_get_ValidationResultCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElX509CachedCertificate, __construct, arginfo_TElX509CachedCertificate___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElX509CachedCertificate(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElX509CachedCertificate_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElX509CachedCertificate", TElX509CachedCertificate_methods);
	if (NULL == TElX509Certificate_ce_ptr)
		Register_TElX509Certificate(TSRMLS_C);
	TElX509CachedCertificate_ce_ptr = zend_register_internal_class_ex(&ce, TElX509Certificate_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCacheCertStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElCacheCertStorage, BeginWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCacheCertStorage_BeginWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCacheCertStorage, EndWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCacheCertStorage_EndWrite(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCacheCertStorage, Add)
{
	long fReason;
	long fValidity;
	zend_bool bCopyPrivateKey;
	zval *dtValidityMoment;
	zval *oValidator;
	zval *oX509Certificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!OllO!", &oX509Certificate, TElX509Certificate_ce_ptr, &dtValidityMoment, php_date_get_date_ce(), &fValidity, &fReason, &oValidator, TElX509CertificateValidator_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCacheCertStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oX509Certificate TSRMLS_CC), SBGetDateTime(dtValidityMoment TSRMLS_CC), (TSBCertificateValidityRaw)fValidity, (TSBCertificateValidityReasonRaw)fReason, SBGetObjectHandle(oValidator TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oX509Certificate, TElX509Certificate_ce_ptr, &bCopyPrivateKey) == SUCCESS)
	{
		SBCheckError(TElCacheCertStorage_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oX509Certificate TSRMLS_CC), (int8_t)bCopyPrivateKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, DateTime, integer, integer, TElX509CertificateValidator) or (TElX509Certificate, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCacheCertStorage, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCacheCertStorage_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCacheCertStorage_BeginWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCacheCertStorage_EndWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCacheCertStorage_Add, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, X509Certificate, 0, 1)
	ZEND_ARG_INFO(0, ValidityMoment_or_CopyPrivateKey)
	ZEND_ARG_INFO(0, Validity)
	ZEND_ARG_INFO(0, Reason)
	ZEND_ARG_OBJ_INFO(0, Validator, TElX509CertificateValidator, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCacheCertStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCacheCertStorage_methods[] = {
	PHP_ME(TElCacheCertStorage, BeginWrite, arginfo_TElCacheCertStorage_BeginWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElCacheCertStorage, EndWrite, arginfo_TElCacheCertStorage_EndWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElCacheCertStorage, Add, arginfo_TElCacheCertStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCacheCertStorage, __construct, arginfo_TElCacheCertStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCacheCertStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCacheCertStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCacheCertStorage", TElCacheCertStorage_methods);
	if (NULL == TElMemoryCertStorage_ce_ptr)
		Register_TElMemoryCertStorage(TSRMLS_C);
	TElCacheCertStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElMemoryCertStorage_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCertValidator, GetCertificateCache)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCertValidator_GetCertificateCache(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCacheCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBCertValidator_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_CRL_ERROR_BASE, SB_VALIDATOR_CRL_ERROR_BASE, SB_VALIDATOR_CRL_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_OCSP_ERROR_BASE, SB_VALIDATOR_OCSP_ERROR_BASE, SB_VALIDATOR_OCSP_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_CRL_ERROR_VALIDATION_FAILED, SB_VALIDATOR_CRL_ERROR_VALIDATION_FAILED, SB_VALIDATOR_CRL_ERROR_VALIDATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_CRL_ERROR_NO_RETRIEVER, SB_VALIDATOR_CRL_ERROR_NO_RETRIEVER, SB_VALIDATOR_CRL_ERROR_NO_RETRIEVER);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_CRL_ERROR_RETRIEVER_FAILED, SB_VALIDATOR_CRL_ERROR_RETRIEVER_FAILED, SB_VALIDATOR_CRL_ERROR_RETRIEVER_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_CRL_ERROR_NO_CRLS_RETRIEVED, SB_VALIDATOR_CRL_ERROR_NO_CRLS_RETRIEVED, SB_VALIDATOR_CRL_ERROR_NO_CRLS_RETRIEVED);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_CRL_ERROR_CERT_REVOKED, SB_VALIDATOR_CRL_ERROR_CERT_REVOKED, SB_VALIDATOR_CRL_ERROR_CERT_REVOKED);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_OCSP_ERROR_VALIDATION_FAILED, SB_VALIDATOR_OCSP_ERROR_VALIDATION_FAILED, SB_VALIDATOR_OCSP_ERROR_VALIDATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_OCSP_ERROR_NO_CLIENT, SB_VALIDATOR_OCSP_ERROR_NO_CLIENT, SB_VALIDATOR_OCSP_ERROR_NO_CLIENT);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_OCSP_ERROR_CLIENT_FAILED, SB_VALIDATOR_OCSP_ERROR_CLIENT_FAILED, SB_VALIDATOR_OCSP_ERROR_CLIENT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_OCSP_ERROR_INVALID_RESPONSE, SB_VALIDATOR_OCSP_ERROR_INVALID_RESPONSE, SB_VALIDATOR_OCSP_ERROR_INVALID_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBCertValidator, SB_VALIDATOR_OCSP_ERROR_CERT_REVOKED, SB_VALIDATOR_OCSP_ERROR_CERT_REVOKED, SB_VALIDATOR_OCSP_ERROR_CERT_REVOKED);
}

void Register_SBCertValidator_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBX509RevocationCheckPreference", NULL);
	TSBX509RevocationCheckPreference_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBX509RevocationCheckPreference_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBX509RevocationCheckPreference_ce_ptr, "rcpPreferCRL", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBX509RevocationCheckPreference_ce_ptr, "rcpPreferOCSP", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBX509RevocationCheckPreference_ce_ptr, "rcpCheckBoth", 2)
}
