#include "sbcryptoprovpkcs11.h"

zend_class_entry *TSBPKCS11CryptoObjectOperation_ce_ptr = NULL;

void SB_CALLBACK TSBPKCS11CryptoProviderAttributesPreparedEventRaw(void * _ObjectData, TObjectHandle Sender, TElCustomCryptoKeyHandle CryptoKey, TSBPKCS11CryptoObjectOperationRaw Operation, TElPKCS11AttributeListHandle PubSet, TElPKCS11AttributeListHandle PrivSet)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCryptoKey;
	zval * zOperation;
	zval * zPubSet;
	zval * zPrivSet;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCryptoKey);
	SBInitObject(zCryptoKey, TElCustomCryptoKey_ce_ptr, CryptoKey TSRMLS_CC);
	MAKE_STD_ZVAL(zOperation);
	ZVAL_LONG(zOperation, (long)Operation);
	MAKE_STD_ZVAL(zPubSet);
	SBInitObject(zPubSet, TElPKCS11AttributeList_ce_ptr, PubSet TSRMLS_CC);
	MAKE_STD_ZVAL(zPrivSet);
	SBInitObject(zPrivSet, TElPKCS11AttributeList_ce_ptr, PrivSet TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCryptoKey;
	params[2] = &zOperation;
	params[3] = &zPubSet;
	params[4] = &zPrivSet;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCryptoKey);
	zval_ptr_dtor(&zOperation);
	zval_ptr_dtor(&zPubSet);
	zval_ptr_dtor(&zPrivSet);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBPKCS11CryptoContextType_ce_ptr = NULL;

zend_class_entry *TSBPKCS11CryptoContextOperation_ce_ptr = NULL;

zend_class_entry *TElPKCS11CryptoProviderOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, Assign)
{
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOptions TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderOptions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_UseForPublicKeyOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_UseForPublicKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_UseForPublicKeyOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_UseForPublicKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_UseForSymmetricKeyOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_UseForSymmetricKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_UseForSymmetricKeyOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_UseForSymmetricKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_UseForHashingOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_UseForHashingOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_UseForHashingOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_UseForHashingOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_UseForNonPrivateOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_UseForNonPrivateOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_UseForNonPrivateOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_UseForNonPrivateOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_ForceUseForIndirectHashingOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_ForceUseForIndirectHashingOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_ForceUseForIndirectHashingOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_ForceUseForIndirectHashingOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_DelayedPublicKeyImport)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_DelayedPublicKeyImport(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_DelayedPublicKeyImport)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_DelayedPublicKeyImport(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_ThreadSafe)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_ThreadSafe)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_IgnoreReportedSupportedAlgorithms)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_IgnoreReportedSupportedAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_IgnoreReportedSupportedAlgorithms)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_IgnoreReportedSupportedAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_NormalizeSourceLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProviderOptions_get_NormalizeSourceLength(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_NormalizeSourceLength)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_NormalizeSourceLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_OperationPIN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS11CryptoProviderOptions_get_OperationPIN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1369636021, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_OperationPIN)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProviderOptions_set_OperationPIN(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, get_DefaultRSAPublicExponent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPKCS11CryptoProviderOptions_get_DefaultRSAPublicExponent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1875001440, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, set_DefaultRSAPublicExponent)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProviderOptions_set_DefaultRSAPublicExponent(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProviderOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProviderOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Options, TElCustomCryptoProviderOptions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_UseForPublicKeyOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_UseForPublicKeyOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_UseForSymmetricKeyOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_UseForSymmetricKeyOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_UseForHashingOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_UseForHashingOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_UseForNonPrivateOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_UseForNonPrivateOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_ForceUseForIndirectHashingOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_ForceUseForIndirectHashingOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_DelayedPublicKeyImport, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_DelayedPublicKeyImport, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_ThreadSafe, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_ThreadSafe, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_IgnoreReportedSupportedAlgorithms, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_IgnoreReportedSupportedAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_NormalizeSourceLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_NormalizeSourceLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_OperationPIN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_OperationPIN, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_get_DefaultRSAPublicExponent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions_set_DefaultRSAPublicExponent, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProviderOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11CryptoProviderOptions_methods[] = {
	PHP_ME(TElPKCS11CryptoProviderOptions, Assign, arginfo_TElPKCS11CryptoProviderOptions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_UseForPublicKeyOperations, arginfo_TElPKCS11CryptoProviderOptions_get_UseForPublicKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_UseForPublicKeyOperations, arginfo_TElPKCS11CryptoProviderOptions_set_UseForPublicKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_UseForSymmetricKeyOperations, arginfo_TElPKCS11CryptoProviderOptions_get_UseForSymmetricKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_UseForSymmetricKeyOperations, arginfo_TElPKCS11CryptoProviderOptions_set_UseForSymmetricKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_UseForHashingOperations, arginfo_TElPKCS11CryptoProviderOptions_get_UseForHashingOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_UseForHashingOperations, arginfo_TElPKCS11CryptoProviderOptions_set_UseForHashingOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_UseForNonPrivateOperations, arginfo_TElPKCS11CryptoProviderOptions_get_UseForNonPrivateOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_UseForNonPrivateOperations, arginfo_TElPKCS11CryptoProviderOptions_set_UseForNonPrivateOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_ForceUseForIndirectHashingOperations, arginfo_TElPKCS11CryptoProviderOptions_get_ForceUseForIndirectHashingOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_ForceUseForIndirectHashingOperations, arginfo_TElPKCS11CryptoProviderOptions_set_ForceUseForIndirectHashingOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_DelayedPublicKeyImport, arginfo_TElPKCS11CryptoProviderOptions_get_DelayedPublicKeyImport, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_DelayedPublicKeyImport, arginfo_TElPKCS11CryptoProviderOptions_set_DelayedPublicKeyImport, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_ThreadSafe, arginfo_TElPKCS11CryptoProviderOptions_get_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_ThreadSafe, arginfo_TElPKCS11CryptoProviderOptions_set_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_IgnoreReportedSupportedAlgorithms, arginfo_TElPKCS11CryptoProviderOptions_get_IgnoreReportedSupportedAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_IgnoreReportedSupportedAlgorithms, arginfo_TElPKCS11CryptoProviderOptions_set_IgnoreReportedSupportedAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_NormalizeSourceLength, arginfo_TElPKCS11CryptoProviderOptions_get_NormalizeSourceLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_NormalizeSourceLength, arginfo_TElPKCS11CryptoProviderOptions_set_NormalizeSourceLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_OperationPIN, arginfo_TElPKCS11CryptoProviderOptions_get_OperationPIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_OperationPIN, arginfo_TElPKCS11CryptoProviderOptions_set_OperationPIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, get_DefaultRSAPublicExponent, arginfo_TElPKCS11CryptoProviderOptions_get_DefaultRSAPublicExponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, set_DefaultRSAPublicExponent, arginfo_TElPKCS11CryptoProviderOptions_set_DefaultRSAPublicExponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProviderOptions, __construct, arginfo_TElPKCS11CryptoProviderOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11CryptoProviderOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11CryptoProviderOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11CryptoProviderOptions", TElPKCS11CryptoProviderOptions_methods);
	if (NULL == TElCustomCryptoProviderOptions_ce_ptr)
		Register_TElCustomCryptoProviderOptions(TSRMLS_C);
	TElPKCS11CryptoProviderOptions_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoProviderOptions_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11CryptoProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11CryptoProvider, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProvider_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProvider_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, SetAsDefault_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProvider_SetAsDefault_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, SetAsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoProvider_SetAsDefault() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, IsAlgorithmSupported)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4Mode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProvider_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaAlgOID, &zaAlgParams, &l4Mode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, IsOperationSupported)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4Operation, &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProvider_IsOperationSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlO!O!", &l4Operation, &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_IsOperationSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, GetAlgorithmProperty)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Algorithm, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElPKCS11CryptoProvider_GetAlgorithmProperty(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1508929938, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlz", &zaAlgOID, &zaAlgParams, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElPKCS11CryptoProvider_GetAlgorithmProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-145555180, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, GetAlgorithmClass)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProvider_GetAlgorithmClass(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaAlgOID, &zaAlgParams) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_GetAlgorithmClass_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, GetProviderProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElPKCS11CryptoProvider_GetProviderProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1941861931, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, SetProviderProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_SetProviderProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, GetDefaultInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_GetDefaultInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, CreateKey)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4Algorithm, &l4Mode, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_CreateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zaAlgOID, &zaAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_CreateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElRelativeDistinguishedName) or (array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, CloneKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_CloneKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, ReleaseKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElPKCS11CryptoProvider_ReleaseKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, DeleteKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElPKCS11CryptoProvider_DeleteKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, DecryptKey)
{
	long l4EncKeySize;
	SBArrayZValInfo aiEncKeyAlgOID;
	SBArrayZValInfo aiEncKeyAlgParams;
	SBArrayZValInfo aiKeyAlgOID;
	SBArrayZValInfo aiKeyAlgParams;
	SBArrayZValInfo piEncKey;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaEncKeyAlgOID;
	zval *zaEncKeyAlgParams;
	zval *zaKeyAlgOID;
	zval *zaKeyAlgParams;
	zval *zpEncKey;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO!zzO!zz", &zpEncKey, &l4EncKeySize, &zaEncKeyAlgOID, &zaEncKeyAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zaKeyAlgOID, &zaKeyAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpEncKey) == IS_STRING) || (Z_TYPE_P(zpEncKey) == IS_ARRAY) || (Z_TYPE_P(zpEncKey) == IS_NULL) || ((Z_TYPE_P(zpEncKey) == IS_OBJECT) && (Z_OBJCE_P(zpEncKey) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpEncKey, &piEncKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgOID, &aiEncKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgParams, &aiEncKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgOID, &aiKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgParams, &aiKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_DecryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), piEncKey.data, (int32_t)l4EncKeySize, aiEncKeyAlgOID.data, aiEncKeyAlgOID.len, aiEncKeyAlgParams.data, aiEncKeyAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), aiKeyAlgOID.data, aiKeyAlgOID.len, aiKeyAlgParams.data, aiKeyAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piEncKey);
		SBFreeArrayZValInfo(&aiEncKeyAlgOID);
		SBFreeArrayZValInfo(&aiEncKeyAlgParams);
		SBFreeArrayZValInfo(&aiKeyAlgOID);
		SBFreeArrayZValInfo(&aiKeyAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, EncryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_EncryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_EncryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, DecryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_DecryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_DecryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, SignInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zend_bool bDetached;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_SignInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!bO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_SignInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, VerifyInit)
{
	long l4Algorithm;
	long l4SigSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	SBArrayZValInfo piSigBuffer;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_VerifyInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_VerifyInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, EncryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_EncryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, DecryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_DecryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, SignUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_SignUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, VerifyUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_VerifyUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, EncryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_EncryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, DecryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_DecryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, SignFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_SignFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, VerifyFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_VerifyFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, HashInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_HashInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!O!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_HashInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, HashUpdate)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_HashUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, HashFinal)
{
	SBArrayZValInfo piProgressData;
	uint32_t _err;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oContext, TElCustomCryptoContext_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		_err = TElPKCS11CryptoProvider_HashFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1583357807, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piProgressData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, ReleaseCryptoContext)
{
	TElClassHandle hoContext;
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TElCustomCryptoContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext) && (IS_OBJECT == Z_TYPE_P(oContext)))
	{
		hoContext = SBGetObjectHandle(oContext TSRMLS_CC);
		SBCheckError(TElPKCS11CryptoProvider_ReleaseCryptoContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContext) TSRMLS_CC);
		SBUpdateObjectHandle(oContext, hoContext TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, CreateKeyStorage)
{
	zend_bool bPersistent;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bPersistent, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_CreateKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPersistent, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, ReleaseKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElPKCS11CryptoProvider_ReleaseKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, DeleteKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElPKCS11CryptoProvider_DeleteKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, RandomInit)
{
	long l4BaseDataSize;
	SBArrayZValInfo piBaseData;
	zval *oParams;
	zval *zpBaseData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBaseData, &l4BaseDataSize, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBaseData) == IS_STRING) || (Z_TYPE_P(zpBaseData) == IS_ARRAY) || (Z_TYPE_P(zpBaseData) == IS_NULL) || ((Z_TYPE_P(zpBaseData) == IS_OBJECT) && (Z_OBJCE_P(zpBaseData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBaseData, &piBaseData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_RandomInit(SBGetObjectHandle(getThis() TSRMLS_CC), piBaseData.data, (int32_t)l4BaseDataSize, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBaseData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, RandomSeed)
{
	long l4DataSize;
	SBArrayZValInfo piData;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpData, &l4DataSize) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_RandomSeed(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, RandomGenerate)
{
	long l4MaxValue;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoProvider_RandomGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4MaxValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoProvider_RandomGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4MaxValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, get_OnAttributesPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPKCS11CryptoProviderAttributesPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_get_OnAttributesPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, set_OnAttributesPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPKCS11CryptoProvider_set_OnAttributesPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPKCS11CryptoProviderAttributesPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPKCS11CryptoProviderAttributesPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoProvider, __construct)
{
	zval *oAOwner;
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr, &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoProvider_Create_1(SBGetObjectHandle(oOptions TSRMLS_CC), SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or (TElCustomCryptoProviderOptions, TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_SetAsDefault_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_SetAsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_IsAlgorithmSupported, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_IsOperationSupported, 0, 0, 5)
	ZEND_ARG_INFO(0, Operation)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_GetAlgorithmProperty, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_GetAlgorithmClass, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_GetProviderProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_SetProviderProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_GetDefaultInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_CreateKey, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_CloneKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_ReleaseKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_DeleteKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_DecryptKey, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, EncKey, 0, 1)
	ZEND_ARG_INFO(0, EncKeySize)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_EncryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_DecryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_SignInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Detached_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Detached, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_VerifyInit, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigSize_or_SigBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_SigSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_EncryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_DecryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_SignUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_VerifyUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_EncryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_DecryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_SignFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_VerifyFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_HashInit, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_HashUpdate, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_HashFinal, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_ReleaseCryptoContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Context, TElCustomCryptoContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_CreateKeyStorage, 0, 0, 2)
	ZEND_ARG_INFO(0, Persistent)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_ReleaseKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_DeleteKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_RandomInit, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BaseData, 0, 1)
	ZEND_ARG_INFO(0, BaseDataSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_RandomSeed, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_RandomGenerate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_MaxValue, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_get_OnAttributesPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider_set_OnAttributesPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoProvider___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwner_or_Options, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11CryptoProvider_methods[] = {
	PHP_ME(TElPKCS11CryptoProvider, Init, arginfo_TElPKCS11CryptoProvider_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, Deinit, arginfo_TElPKCS11CryptoProvider_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, SetAsDefault_Inst, arginfo_TElPKCS11CryptoProvider_SetAsDefault_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, SetAsDefault, arginfo_TElPKCS11CryptoProvider_SetAsDefault, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11CryptoProvider, Clone, arginfo_TElPKCS11CryptoProvider_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, IsAlgorithmSupported, arginfo_TElPKCS11CryptoProvider_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, IsOperationSupported, arginfo_TElPKCS11CryptoProvider_IsOperationSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, GetAlgorithmProperty, arginfo_TElPKCS11CryptoProvider_GetAlgorithmProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, GetAlgorithmClass, arginfo_TElPKCS11CryptoProvider_GetAlgorithmClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, GetProviderProp, arginfo_TElPKCS11CryptoProvider_GetProviderProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, SetProviderProp, arginfo_TElPKCS11CryptoProvider_SetProviderProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, GetDefaultInstance, arginfo_TElPKCS11CryptoProvider_GetDefaultInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, CreateKey, arginfo_TElPKCS11CryptoProvider_CreateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, CloneKey, arginfo_TElPKCS11CryptoProvider_CloneKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, ReleaseKey, arginfo_TElPKCS11CryptoProvider_ReleaseKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, DeleteKey, arginfo_TElPKCS11CryptoProvider_DeleteKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, DecryptKey, arginfo_TElPKCS11CryptoProvider_DecryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, EncryptInit, arginfo_TElPKCS11CryptoProvider_EncryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, DecryptInit, arginfo_TElPKCS11CryptoProvider_DecryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, SignInit, arginfo_TElPKCS11CryptoProvider_SignInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, VerifyInit, arginfo_TElPKCS11CryptoProvider_VerifyInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, EncryptUpdate, arginfo_TElPKCS11CryptoProvider_EncryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, DecryptUpdate, arginfo_TElPKCS11CryptoProvider_DecryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, SignUpdate, arginfo_TElPKCS11CryptoProvider_SignUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, VerifyUpdate, arginfo_TElPKCS11CryptoProvider_VerifyUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, EncryptFinal, arginfo_TElPKCS11CryptoProvider_EncryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, DecryptFinal, arginfo_TElPKCS11CryptoProvider_DecryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, SignFinal, arginfo_TElPKCS11CryptoProvider_SignFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, VerifyFinal, arginfo_TElPKCS11CryptoProvider_VerifyFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, HashInit, arginfo_TElPKCS11CryptoProvider_HashInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, HashUpdate, arginfo_TElPKCS11CryptoProvider_HashUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, HashFinal, arginfo_TElPKCS11CryptoProvider_HashFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, ReleaseCryptoContext, arginfo_TElPKCS11CryptoProvider_ReleaseCryptoContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, CreateKeyStorage, arginfo_TElPKCS11CryptoProvider_CreateKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, ReleaseKeyStorage, arginfo_TElPKCS11CryptoProvider_ReleaseKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, DeleteKeyStorage, arginfo_TElPKCS11CryptoProvider_DeleteKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, RandomInit, arginfo_TElPKCS11CryptoProvider_RandomInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, RandomSeed, arginfo_TElPKCS11CryptoProvider_RandomSeed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, RandomGenerate, arginfo_TElPKCS11CryptoProvider_RandomGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, ClassType, arginfo_TElPKCS11CryptoProvider_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPKCS11CryptoProvider, get_OnAttributesPrepared, arginfo_TElPKCS11CryptoProvider_get_OnAttributesPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, set_OnAttributesPrepared, arginfo_TElPKCS11CryptoProvider_set_OnAttributesPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoProvider, __construct, arginfo_TElPKCS11CryptoProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11CryptoProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11CryptoProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11CryptoProvider", TElPKCS11CryptoProvider_methods);
	if (NULL == TElExternalCryptoProvider_ce_ptr)
		Register_TElExternalCryptoProvider(TSRMLS_C);
	TElPKCS11CryptoProvider_ce_ptr = zend_register_internal_class_ex(&ce, TElExternalCryptoProvider_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11CryptoKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11CryptoKey, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, Generate)
{
	long l4Bits;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zz", &l4Bits, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ChangeAlgorithm)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_ChangeAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ImportPublic)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoKey_ImportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ImportSecret)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoKey_ImportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ExportPublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS11CryptoKey_ExportPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ExportSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS11CryptoKey_ExportSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoKey_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ClonePublic)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoKey_ClonePublic(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, GetKeyProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElPKCS11CryptoKey_GetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1917289127, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, SetKeyProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoKey_SetKeyProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, Equals)
{
	zend_bool bPublicOnly;
	zval *oParams;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bO!", &oSource, TElCustomCryptoKey_ce_ptr, &bPublicOnly, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoKey_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey, bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, Persistentiate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPKCS11CryptoKey_Persistentiate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoKey, __construct)
{
	zval *oCryptoProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoKey_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_Generate, 0, 0, 4)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ChangeAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ImportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ImportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ExportPublic, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ExportSecret, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ClonePublic, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_GetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_SetKeyProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_Equals, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomCryptoKey, 1)
	ZEND_ARG_INFO(0, PublicOnly)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey_Persistentiate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoKey___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11CryptoKey_methods[] = {
	PHP_ME(TElPKCS11CryptoKey, Reset, arginfo_TElPKCS11CryptoKey_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, Generate, arginfo_TElPKCS11CryptoKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ChangeAlgorithm, arginfo_TElPKCS11CryptoKey_ChangeAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ImportPublic, arginfo_TElPKCS11CryptoKey_ImportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ImportSecret, arginfo_TElPKCS11CryptoKey_ImportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ExportPublic, arginfo_TElPKCS11CryptoKey_ExportPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ExportSecret, arginfo_TElPKCS11CryptoKey_ExportSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, Clone, arginfo_TElPKCS11CryptoKey_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ClonePublic, arginfo_TElPKCS11CryptoKey_ClonePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ClearPublic, arginfo_TElPKCS11CryptoKey_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, ClearSecret, arginfo_TElPKCS11CryptoKey_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, GetKeyProp, arginfo_TElPKCS11CryptoKey_GetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, SetKeyProp, arginfo_TElPKCS11CryptoKey_SetKeyProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, PrepareForEncryption, arginfo_TElPKCS11CryptoKey_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, PrepareForSigning, arginfo_TElPKCS11CryptoKey_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, CancelPreparation, arginfo_TElPKCS11CryptoKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, AsyncOperationFinished, arginfo_TElPKCS11CryptoKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, Equals, arginfo_TElPKCS11CryptoKey_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, Persistentiate, arginfo_TElPKCS11CryptoKey_Persistentiate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoKey, __construct, arginfo_TElPKCS11CryptoKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11CryptoKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11CryptoKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11CryptoKey", TElPKCS11CryptoKey_methods);
	if (NULL == TElCustomCryptoKey_ce_ptr)
		Register_TElCustomCryptoKey(TSRMLS_C);
	TElPKCS11CryptoKey_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11CryptoContext_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11CryptoContext, EstimateOutputSize)
{
	long l8InSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8InSize) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPKCS11CryptoContext_EstimateOutputSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8InSize, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoContext, Clone)
{
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoContext_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoContext, GetContextProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElPKCS11CryptoContext_GetContextProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(123350853, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoContext, SetContextProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoContext_SetContextProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11CryptoContext, __construct)
{
	long fOperation;
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *oProv;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!lO!O!", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &fOperation, &oProv, TElCustomCryptoProvider_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11CryptoContext_Create((int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), (TSBPKCS11CryptoContextOperationRaw)fOperation, SBGetObjectHandle(oProv TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!lO!O!", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &fOperation, &oProv, TElCustomCryptoProvider_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11CryptoContext_Create_1(aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), (TSBPKCS11CryptoContextOperationRaw)fOperation, SBGetObjectHandle(oProv TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, integer, TElCustomCryptoProvider, TElRelativeDistinguishedName) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, integer, TElCustomCryptoProvider, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoContext_EstimateOutputSize, 0, 0, 1)
	ZEND_ARG_INFO(0, InSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoContext_Clone, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoContext_GetContextProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoContext_SetContextProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11CryptoContext___construct, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Operation_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Operation, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Prov, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11CryptoContext_methods[] = {
	PHP_ME(TElPKCS11CryptoContext, EstimateOutputSize, arginfo_TElPKCS11CryptoContext_EstimateOutputSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoContext, Clone, arginfo_TElPKCS11CryptoContext_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoContext, GetContextProp, arginfo_TElPKCS11CryptoContext_GetContextProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoContext, SetContextProp, arginfo_TElPKCS11CryptoContext_SetContextProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11CryptoContext, __construct, arginfo_TElPKCS11CryptoContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11CryptoContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11CryptoContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11CryptoContext", TElPKCS11CryptoContext_methods);
	if (NULL == TElCustomCryptoContext_ce_ptr)
		Register_TElCustomCryptoContext(TSRMLS_C);
	TElPKCS11CryptoContext_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoContext_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPKCS11ECParamsDirectory_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS11ECParamsDirectory, AddKnownCurve)
{
	char *sName;
	int sName_len;
	long l4KeyBits;
	SBArrayZValInfo aiCurveOID;
	zval *zaCurveOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sName, &sName_len, &zaCurveOID, &l4KeyBits) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaCurveOID)) || (IS_ARRAY == Z_TYPE_P(zaCurveOID)) || (IS_NULL == Z_TYPE_P(zaCurveOID))))
	{
		if (!SBGetByteArrayFromZVal(zaCurveOID, &aiCurveOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ECParamsDirectory_AddKnownCurve(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, aiCurveOID.data, aiCurveOID.len, (int32_t)l4KeyBits) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiCurveOID);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ECParamsDirectory, GetKeyBits)
{
	SBArrayZValInfo aiCurveOID;
	zval *zaCurveOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaCurveOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaCurveOID)) || (IS_ARRAY == Z_TYPE_P(zaCurveOID)) || (IS_NULL == Z_TYPE_P(zaCurveOID))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaCurveOID, &aiCurveOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ECParamsDirectory_GetKeyBits(SBGetObjectHandle(getThis() TSRMLS_CC), aiCurveOID.data, aiCurveOID.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiCurveOID);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ECParamsDirectory, IsKnownCurve)
{
	SBArrayZValInfo aiCurveOID;
	zval *zaCurveOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaCurveOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaCurveOID)) || (IS_ARRAY == Z_TYPE_P(zaCurveOID)) || (IS_NULL == Z_TYPE_P(zaCurveOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaCurveOID, &aiCurveOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS11ECParamsDirectory_IsKnownCurve(SBGetObjectHandle(getThis() TSRMLS_CC), aiCurveOID.data, aiCurveOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiCurveOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS11ECParamsDirectory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS11ECParamsDirectory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ECParamsDirectory_AddKnownCurve, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_TYPE_INFO(0, CurveOID, 0, 1)
	ZEND_ARG_INFO(0, KeyBits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ECParamsDirectory_GetKeyBits, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CurveOID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ECParamsDirectory_IsKnownCurve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CurveOID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS11ECParamsDirectory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS11ECParamsDirectory_methods[] = {
	PHP_ME(TElPKCS11ECParamsDirectory, AddKnownCurve, arginfo_TElPKCS11ECParamsDirectory_AddKnownCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ECParamsDirectory, GetKeyBits, arginfo_TElPKCS11ECParamsDirectory_GetKeyBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ECParamsDirectory, IsKnownCurve, arginfo_TElPKCS11ECParamsDirectory_IsKnownCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS11ECParamsDirectory, __construct, arginfo_TElPKCS11ECParamsDirectory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS11ECParamsDirectory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS11ECParamsDirectory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS11ECParamsDirectory", TElPKCS11ECParamsDirectory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS11ECParamsDirectory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCryptoProvPKCS11, PKCS11CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCryptoProvPKCS11_PKCS11CryptoProvider(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBCryptoProvPKCS11_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPKCS11CryptoObjectOperation", NULL);
	TSBPKCS11CryptoObjectOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11CryptoObjectOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoObjectOperation_ce_ptr, "pcooGenerateKeyPair", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoObjectOperation_ce_ptr, "pcooGenerateKey", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoObjectOperation_ce_ptr, "pcooCreatePublicKey", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoObjectOperation_ce_ptr, "pcooCreatePrivateKey", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoObjectOperation_ce_ptr, "pcooCreateDomainParams", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoObjectOperation_ce_ptr, "pcooCreateSecretKey", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11CryptoContextType", NULL);
	TSBPKCS11CryptoContextType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11CryptoContextType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextType_ce_ptr, "cctUndefined", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextType_ce_ptr, "cctSymCrypto", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextType_ce_ptr, "cctPKICrypto", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextType_ce_ptr, "cctHash", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextType_ce_ptr, "cctHMAC", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBPKCS11CryptoContextOperation", NULL);
	TSBPKCS11CryptoContextOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPKCS11CryptoContextOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoUndefined", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoEncrypt", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoDecrypt", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoSign", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoVerify", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoSignDetached", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoVerifyDetached", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBPKCS11CryptoContextOperation_ce_ptr, "ccoHash", 7)
}

