#include "sbftpsserver.h"

zend_class_entry *TSBFTPSConnectionStatus_ce_ptr = NULL;

zend_class_entry *TSBFTPSInternalConnectionStatus_ce_ptr = NULL;

zend_class_entry *TSBFTPSSecurityOption_ce_ptr = NULL;

zend_class_entry *TSBFTPSSecurityOptions_ce_ptr = NULL;

void SB_CALLBACK TSBFTPSServerCommandProcessedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcCommand, int32_t szCommand, int32_t ReplyCode)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCommand;
	zval * zReplyCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCommand);
	ZVAL_STRINGL(zCommand, pcCommand, szCommand, 1);
	MAKE_STD_ZVAL(zReplyCode);
	ZVAL_LONG(zReplyCode, (long)ReplyCode);

	params[0] = &zSender;
	params[1] = &zCommand;
	params[2] = &zReplyCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCommand);
	zval_ptr_dtor(&zReplyCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerDataConnectionCloseEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerEstablishSecureConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSLServerHandle Server)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zServer;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zServer);
	SBInitObject(zServer, TElSSLServer_ce_ptr, Server TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zServer;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zServer);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerUsernameReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcLogin, int32_t szLogin, int8_t * Allow, int8_t * NeedsPassword)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zLogin;
	zval * zAllow;
	zval * zNeedsPassword;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zLogin);
	ZVAL_STRINGL(zLogin, pcLogin, szLogin, 1);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);
	MAKE_STD_ZVAL(zNeedsPassword);
	ZVAL_BOOL(zNeedsPassword, (zend_bool)*NeedsPassword);

	params[0] = &zSender;
	params[1] = &zLogin;
	params[2] = &zAllow;
	params[3] = &zNeedsPassword;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zLogin);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	*NeedsPassword = (int8_t)Z_BVAL_P(zNeedsPassword);
	zval_ptr_dtor(&zNeedsPassword);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerCommandReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcCommand, int32_t szCommand, const char * pcParameters, int32_t szParameters, int8_t * Ignore)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCommand;
	zval * zParameters;
	zval * zIgnore;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCommand);
	ZVAL_STRINGL(zCommand, pcCommand, szCommand, 1);
	MAKE_STD_ZVAL(zParameters);
	ZVAL_STRINGL(zParameters, pcParameters, szParameters, 1);
	MAKE_STD_ZVAL(zIgnore);
	ZVAL_BOOL(zIgnore, (zend_bool)*Ignore);

	params[0] = &zSender;
	params[1] = &zCommand;
	params[2] = &zParameters;
	params[3] = &zIgnore;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCommand);
	zval_ptr_dtor(&zParameters);
	*Ignore = (int8_t)Z_BVAL_P(zIgnore);
	zval_ptr_dtor(&zIgnore);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerCommandUnhandledEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcCommand, int32_t szCommand, const char * pcParameters, int32_t szParameters, int8_t * Ignore)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCommand;
	zval * zParameters;
	zval * zIgnore;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCommand);
	ZVAL_STRINGL(zCommand, pcCommand, szCommand, 1);
	MAKE_STD_ZVAL(zParameters);
	ZVAL_STRINGL(zParameters, pcParameters, szParameters, 1);
	MAKE_STD_ZVAL(zIgnore);
	ZVAL_BOOL(zIgnore, (zend_bool)*Ignore);

	params[0] = &zSender;
	params[1] = &zCommand;
	params[2] = &zParameters;
	params[3] = &zIgnore;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCommand);
	zval_ptr_dtor(&zParameters);
	*Ignore = (int8_t)Z_BVAL_P(zIgnore);
	zval_ptr_dtor(&zIgnore);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerPasswordAuthEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcLogin, int32_t szLogin, const char * pcPassword, int32_t szPassword, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zLogin;
	zval * zPassword;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zLogin);
	ZVAL_STRINGL(zLogin, pcLogin, szLogin, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, szPassword, 1);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zLogin;
	params[2] = &zPassword;
	params[3] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zLogin);
	zval_ptr_dtor(&zPassword);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerBeforeSendReplyEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t * Code, char * pcReply, int32_t * szReply, const char * pcCommand, int32_t szCommand)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCode;
	zval * zReply;
	zval * zCommand;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCode);
	ZVAL_LONG(zCode, (long)*Code);
	MAKE_STD_ZVAL(zReply);
	ZVAL_STRINGL(zReply, pcReply, *szReply, 1);
	MAKE_STD_ZVAL(zCommand);
	ZVAL_STRINGL(zCommand, pcCommand, szCommand, 1);

	params[0] = &zSender;
	params[1] = &zCode;
	params[2] = &zReply;
	params[3] = &zCommand;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Code = (int32_t)Z_LVAL_P(zCode);
	zval_ptr_dtor(&zCode);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zReply), (int32_t)Z_STRLEN_P(zReply)) TSRMLS_CC);
	zval_ptr_dtor(&zReply);
	zval_ptr_dtor(&zCommand);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerDirectoryRequestEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcDirectory, int32_t * szDirectory, int32_t * ErrorCode)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zDirectory;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDirectory);
	ZVAL_STRINGL(zDirectory, pcDirectory, *szDirectory, 1);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);

	params[0] = &zSender;
	params[1] = &zDirectory;
	params[2] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zDirectory), (int32_t)Z_STRLEN_P(zDirectory)) TSRMLS_CC);
	zval_ptr_dtor(&zDirectory);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerRestartTransferRequestEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Offset, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zOffset;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOffset);
	ZVAL_LONG(zOffset, (long)Offset);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zOffset;
	params[2] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOffset);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerDataPortChangeEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcAddress, int32_t szAddress, int32_t Port, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zAddress;
	zval * zPort;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAddress);
	ZVAL_STRINGL(zAddress, pcAddress, szAddress, 1);
	MAKE_STD_ZVAL(zPort);
	ZVAL_LONG(zPort, (long)Port);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zAddress;
	params[2] = &zPort;
	params[3] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAddress);
	zval_ptr_dtor(&zPort);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerPassiveModeRequestEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcAddress, int32_t * szAddress, int32_t * Port, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zAddress;
	zval * zPort;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAddress);
	ZVAL_STRINGL(zAddress, pcAddress, *szAddress, 1);
	MAKE_STD_ZVAL(zPort);
	ZVAL_LONG(zPort, (long)*Port);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zAddress;
	params[2] = &zPort;
	params[3] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zAddress), (int32_t)Z_STRLEN_P(zAddress)) TSRMLS_CC);
	zval_ptr_dtor(&zAddress);
	*Port = (int32_t)Z_LVAL_P(zPort);
	zval_ptr_dtor(&zPort);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerDataConnectionNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TSBFTPSConnectionStatusRaw * Status)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStatus;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStatus);
	ZVAL_LONG(zStatus, (long)*Status);

	params[0] = &zSender;
	params[1] = &zStatus;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Status = (TSBFTPSConnectionStatusRaw)Z_LVAL_P(zStatus);
	zval_ptr_dtor(&zStatus);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerFileListItemRequestEventRaw(void * _ObjectData, TObjectHandle Sender, TElFTPSServerFileInfoHandle Item, int32_t * ErrorCode)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zItem;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zItem);
	SBInitObject(zItem, TElFTPSServerFileInfo_ce_ptr, Item TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);

	params[0] = &zSender;
	params[1] = &zItem;
	params[2] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zItem);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerTransferProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Progress, int64_t Total, int8_t * Abort)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zProgress;
	zval * zTotal;
	zval * zAbort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProgress);
	ZVAL_LONG(zProgress, (long)Progress);
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zAbort);
	ZVAL_BOOL(zAbort, (zend_bool)*Abort);

	params[0] = &zSender;
	params[1] = &zProgress;
	params[2] = &zTotal;
	params[3] = &zAbort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProgress);
	zval_ptr_dtor(&zTotal);
	*Abort = (int8_t)Z_BVAL_P(zAbort);
	zval_ptr_dtor(&zAbort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerFileRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcPath, int32_t szPath, int32_t * ErrorCode)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zPath;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPath);
	ZVAL_STRINGL(zPath, pcPath, szPath, 1);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);

	params[0] = &zSender;
	params[1] = &zPath;
	params[2] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPath);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerFileAllocateEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Size, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSize;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zSize;
	params[2] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSize);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerFileInfoNeededEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcPath, int32_t szPath, TElFTPSServerFileInfoHandle Info, int32_t * ErrorCode)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zPath;
	zval * zInfo;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPath);
	ZVAL_STRINGL(zPath, pcPath, szPath, 1);
	MAKE_STD_ZVAL(zInfo);
	SBInitObject(zInfo, TElFTPSServerFileInfo_ce_ptr, Info TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);

	params[0] = &zSender;
	params[1] = &zPath;
	params[2] = &zInfo;
	params[3] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPath);
	zval_ptr_dtor(&zInfo);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerFileRenameRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOldName, int32_t szOldName, const char * pcNewName, int32_t szNewName, int32_t * ErrorCode)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zOldName;
	zval * zNewName;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOldName);
	ZVAL_STRINGL(zOldName, pcOldName, szOldName, 1);
	MAKE_STD_ZVAL(zNewName);
	ZVAL_STRINGL(zNewName, pcNewName, szNewName, 1);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);

	params[0] = &zSender;
	params[1] = &zOldName;
	params[2] = &zNewName;
	params[3] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOldName);
	zval_ptr_dtor(&zNewName);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerInformationRequestEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcInformation, int32_t * szInformation)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zInformation;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zInformation);
	ZVAL_STRINGL(zInformation, pcInformation, *szInformation, 1);

	params[0] = &zSender;
	params[1] = &zInformation;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zInformation), (int32_t)Z_STRLEN_P(zInformation)) TSRMLS_CC);
	zval_ptr_dtor(&zInformation);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerHostRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcHost, int32_t szHost, int32_t * ErrorCode)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zHost;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHost);
	ZVAL_STRINGL(zHost, pcHost, szHost, 1);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);

	params[0] = &zSender;
	params[1] = &zHost;
	params[2] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHost);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerExtPassiveModeRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcProtocol, int32_t szProtocol, int32_t * Port, int8_t * Success)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zProtocol;
	zval * zPort;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProtocol);
	ZVAL_STRINGL(zProtocol, pcProtocol, szProtocol, 1);
	MAKE_STD_ZVAL(zPort);
	ZVAL_LONG(zPort, (long)*Port);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)*Success);

	params[0] = &zSender;
	params[1] = &zProtocol;
	params[2] = &zPort;
	params[3] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProtocol);
	*Port = (int32_t)Z_LVAL_P(zPort);
	zval_ptr_dtor(&zPort);
	*Success = (int8_t)Z_BVAL_P(zSuccess);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerSiteCommandEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcParameters, int32_t szParameters, int32_t * ErrorCode, char * pcResponse, int32_t * szResponse)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zParameters;
	zval * zErrorCode;
	zval * zResponse;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zParameters);
	ZVAL_STRINGL(zParameters, pcParameters, szParameters, 1);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)*ErrorCode);
	MAKE_STD_ZVAL(zResponse);
	ZVAL_STRINGL(zResponse, pcResponse, *szResponse, 1);

	params[0] = &zSender;
	params[1] = &zParameters;
	params[2] = &zErrorCode;
	params[3] = &zResponse;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zParameters);
	*ErrorCode = (int32_t)Z_LVAL_P(zErrorCode);
	zval_ptr_dtor(&zErrorCode);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zResponse), (int32_t)Z_STRLEN_P(zResponse)) TSRMLS_CC);
	zval_ptr_dtor(&zResponse);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBFTPSServerFileAttribute_ce_ptr = NULL;

zend_class_entry *TSBFTPSServerFileAttributes_ce_ptr = NULL;

zend_class_entry *TSBFTPSServerFileType_ce_ptr = NULL;

zend_class_entry *TElFTPSServerFileInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElFTPSServerFileInfo, AttributeIncluded)
{
	long fAttribute;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAttribute) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_AttributeIncluded(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFTPSServerFileAttributeRaw)fAttribute, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, IncludeAttribute)
{
	long fAttribute;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAttribute) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_IncludeAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFTPSServerFileAttributeRaw)fAttribute) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, ExcludeAttribute)
{
	long fAttribute;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAttribute) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_ExcludeAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFTPSServerFileAttributeRaw)fAttribute) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_Size)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_Size(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServerFileInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1853098116, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_UnixPermissions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_get_UnixPermissions(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_UnixPermissions)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_UnixPermissions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_FileType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileTypeRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_get_FileType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_FileType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_FileType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFTPSServerFileTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_CreationDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_get_CreationDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_CreationDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_CreationDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_ModificationDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_get_ModificationDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_ModificationDate)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_ModificationDate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_Owner)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServerFileInfo_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(518306955, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_Owner)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_Group)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServerFileInfo_get_Group(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1136386510, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_Group)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_Group(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, get_IncludedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileAttributesRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServerFileInfo_get_IncludedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, set_IncludedAttributes)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServerFileInfo_set_IncludedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFTPSServerFileAttributesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerFileInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServerFileInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_AttributeIncluded, 0, 0, 1)
	ZEND_ARG_INFO(0, Attribute)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_IncludeAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Attribute)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_ExcludeAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Attribute)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_Size, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_UnixPermissions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_UnixPermissions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_FileType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_FileType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_CreationDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_CreationDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_ModificationDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_ModificationDate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_Owner, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_Group, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_Group, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_get_IncludedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo_set_IncludedAttributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerFileInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElFTPSServerFileInfo_methods[] = {
	PHP_ME(TElFTPSServerFileInfo, AttributeIncluded, arginfo_TElFTPSServerFileInfo_AttributeIncluded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, IncludeAttribute, arginfo_TElFTPSServerFileInfo_IncludeAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, ExcludeAttribute, arginfo_TElFTPSServerFileInfo_ExcludeAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_Size, arginfo_TElFTPSServerFileInfo_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_Size, arginfo_TElFTPSServerFileInfo_set_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_Name, arginfo_TElFTPSServerFileInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_Name, arginfo_TElFTPSServerFileInfo_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_UnixPermissions, arginfo_TElFTPSServerFileInfo_get_UnixPermissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_UnixPermissions, arginfo_TElFTPSServerFileInfo_set_UnixPermissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_FileType, arginfo_TElFTPSServerFileInfo_get_FileType, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_FileType, arginfo_TElFTPSServerFileInfo_set_FileType, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_CreationDate, arginfo_TElFTPSServerFileInfo_get_CreationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_CreationDate, arginfo_TElFTPSServerFileInfo_set_CreationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_ModificationDate, arginfo_TElFTPSServerFileInfo_get_ModificationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_ModificationDate, arginfo_TElFTPSServerFileInfo_set_ModificationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_Owner, arginfo_TElFTPSServerFileInfo_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_Owner, arginfo_TElFTPSServerFileInfo_set_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_Group, arginfo_TElFTPSServerFileInfo_get_Group, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_Group, arginfo_TElFTPSServerFileInfo_set_Group, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, get_IncludedAttributes, arginfo_TElFTPSServerFileInfo_get_IncludedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, set_IncludedAttributes, arginfo_TElFTPSServerFileInfo_set_IncludedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerFileInfo, __construct, arginfo_TElFTPSServerFileInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFTPSServerFileInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFTPSServerFileInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFTPSServerFileInfo", TElFTPSServerFileInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElFTPSServerFileInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFTPSServerMessageTable_ce_ptr = NULL;

SB_PHP_METHOD(TElFTPSServerMessageTable, SetDefaults)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServerMessageTable_SetDefaults(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerMessageTable, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServerMessageTable_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerMessageTable, GetMessage)
{
	char *sCommand;
	int sCommand_len;
	long l4Code;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Code, &sCommand, &sCommand_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServerMessageTable_GetMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Code, sCommand, (int32_t)sCommand_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1724084479, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerMessageTable, SetMessage)
{
	char *sCommand;
	char *sMsg;
	int sCommand_len;
	int sMsg_len;
	long l4Code;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Code, &sMsg, &sMsg_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServerMessageTable_SetMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Code, sMsg, (int32_t)sMsg_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &l4Code, &sMsg, &sMsg_len, &sCommand, &sCommand_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServerMessageTable_SetMessage_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Code, sMsg, (int32_t)sMsg_len, sCommand, (int32_t)sCommand_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerMessageTable, get_Greeting)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServerMessageTable_get_Greeting(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1086925221, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerMessageTable, set_Greeting)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServerMessageTable_set_Greeting(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServerMessageTable, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServerMessageTable_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable_SetDefaults, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable_GetMessage, 0, 0, 2)
	ZEND_ARG_INFO(0, Code)
	ZEND_ARG_INFO(0, Command)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable_SetMessage, 0, 0, 2)
	ZEND_ARG_INFO(0, Code)
	ZEND_ARG_INFO(0, Msg)
	ZEND_ARG_INFO(0, Command)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable_get_Greeting, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable_set_Greeting, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServerMessageTable___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElFTPSServerMessageTable_methods[] = {
	PHP_ME(TElFTPSServerMessageTable, SetDefaults, arginfo_TElFTPSServerMessageTable_SetDefaults, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerMessageTable, Clear, arginfo_TElFTPSServerMessageTable_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerMessageTable, GetMessage, arginfo_TElFTPSServerMessageTable_GetMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerMessageTable, SetMessage, arginfo_TElFTPSServerMessageTable_SetMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerMessageTable, get_Greeting, arginfo_TElFTPSServerMessageTable_get_Greeting, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerMessageTable, set_Greeting, arginfo_TElFTPSServerMessageTable_set_Greeting, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServerMessageTable, __construct, arginfo_TElFTPSServerMessageTable___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFTPSServerMessageTable(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFTPSServerMessageTable_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFTPSServerMessageTable", TElFTPSServerMessageTable_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElFTPSServerMessageTable_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFTPSUser_ce_ptr = NULL;

SB_PHP_METHOD(TElFTPSUser, GetData)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElFTPSUser_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, &l4SizeRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-956505007, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, SetData)
{
	long l4Size;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaValue, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElFTPSUser_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, SetBasePath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_SetBasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, SetOutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_SetOutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, SetIncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_SetIncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, AddUser_Inst)
{
	char *sBasePath;
	char *sPassword;
	char *sUserName;
	int sBasePath_len;
	int sPassword_len;
	int sUserName_len;
	long l4IncomingSpeedLimit;
	long l4OutgoingSpeedLimit;
	zval *oUsers;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_AddUser_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sss", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &sBasePath, &sBasePath_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_AddUser_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, sBasePath, (int32_t)sBasePath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssll", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &sBasePath, &sBasePath_len, &l4OutgoingSpeedLimit, &l4IncomingSpeedLimit) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_AddUser_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, sBasePath, (int32_t)sBasePath_len, (int32_t)l4OutgoingSpeedLimit, (int32_t)l4IncomingSpeedLimit) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElUsers, string, string) or (TElUsers, string, string, string) or (TElUsers, string, string, string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, AddUser)
{
	char *sBasePath;
	char *sPassword;
	char *sUserName;
	int sBasePath_len;
	int sPassword_len;
	int sUserName_len;
	long l4IncomingSpeedLimit;
	long l4OutgoingSpeedLimit;
	zval *oUsers;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_AddUser(SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sss", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &sBasePath, &sBasePath_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_AddUser_2(SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, sBasePath, (int32_t)sBasePath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssll", &oUsers, TElUsers_ce_ptr, &sUserName, &sUserName_len, &sPassword, &sPassword_len, &sBasePath, &sBasePath_len, &l4OutgoingSpeedLimit, &l4IncomingSpeedLimit) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_AddUser_4(SBGetObjectHandle(oUsers TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, sBasePath, (int32_t)sBasePath_len, (int32_t)l4OutgoingSpeedLimit, (int32_t)l4IncomingSpeedLimit) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElUsers, string, string) or (TElUsers, string, string, string) or (TElUsers, string, string, string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSUser_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, get_BasePath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSUser_get_BasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1941310874, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, set_BasePath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_set_BasePath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElFTPSUser_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElFTPSUser_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSUser_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUser, __construct)
{
	char *sUserName;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserName, &sUserName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSUser_Create(sUserName, (int32_t)sUserName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_GetData, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_SetData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_SetBasePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_SetOutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_SetIncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_AddUser_Inst, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Users, TElUsers, 1)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, BasePath)
	ZEND_ARG_INFO(0, OutgoingSpeedLimit)
	ZEND_ARG_INFO(0, IncomingSpeedLimit)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_AddUser, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Users, TElUsers, 1)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, BasePath)
	ZEND_ARG_INFO(0, OutgoingSpeedLimit)
	ZEND_ARG_INFO(0, IncomingSpeedLimit)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_get_BasePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_set_BasePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUser___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, UserName)
ZEND_END_ARG_INFO()

static zend_function_entry TElFTPSUser_methods[] = {
	PHP_ME(TElFTPSUser, GetData, arginfo_TElFTPSUser_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, SetData, arginfo_TElFTPSUser_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, SetBasePath, arginfo_TElFTPSUser_SetBasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, SetOutgoingSpeedLimit, arginfo_TElFTPSUser_SetOutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, SetIncomingSpeedLimit, arginfo_TElFTPSUser_SetIncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, AddUser_Inst, arginfo_TElFTPSUser_AddUser_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, AddUser, arginfo_TElFTPSUser_AddUser, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElFTPSUser, ClassType, arginfo_TElFTPSUser_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElFTPSUser, get_BasePath, arginfo_TElFTPSUser_get_BasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, set_BasePath, arginfo_TElFTPSUser_set_BasePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, get_OutgoingSpeedLimit, arginfo_TElFTPSUser_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, set_OutgoingSpeedLimit, arginfo_TElFTPSUser_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, get_IncomingSpeedLimit, arginfo_TElFTPSUser_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, set_IncomingSpeedLimit, arginfo_TElFTPSUser_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUser, __construct, arginfo_TElFTPSUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFTPSUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFTPSUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFTPSUser", TElFTPSUser_methods);
	if (NULL == TElCustomUser_ce_ptr)
		Register_TElCustomUser(TSRMLS_C);
	TElFTPSUser_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomUser_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFTPSServer_ce_ptr = NULL;

SB_PHP_METHOD(TElFTPSServer, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServer_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServer_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, CloseDataConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServer_CloseDataConnection(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, TransferDataFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServer_TransferDataFinished(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElFTPSServer_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, SendCustomReply)
{
	char *sReply;
	int sReply_len;
	long l4Code;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Code, &sReply, &sReply_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_SendCustomReply(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Code, sReply, (int32_t)sReply_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, AssignTLSParamsFromTemplate)
{
	zval *oTpl;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTpl, TElSSLServer_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_AssignTLSParamsFromTemplate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTpl TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSLServer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ASCIIMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ASCIIMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_Authenticated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_Authenticated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_Authenticated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_Authenticated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_PassiveMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_PassiveMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ExtPassiveOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ExtPassiveOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_MessageTable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_get_MessageTable(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFTPSServerMessageTable_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_MessageTable)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElFTPSServerMessageTable_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_MessageTable(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElFTPSServerMessageTable)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_LastCommand)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServer_get_LastCommand(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1310559438, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_LastTransferCommand)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServer_get_LastTransferCommand(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1531324129, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_TransferInProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_TransferInProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ControlChannelEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ControlChannelEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_DataChannelEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_DataChannelEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_CipherSuites)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_CipherSuites(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_CipherSuites)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_CipherSuites(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_CipherSuitePriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_CipherSuitePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_CipherSuitePriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_CipherSuitePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_CompressionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_CompressionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ClientAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_ClientAuthentication)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_ClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_AuthenticationLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticationLevelRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_AuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_AuthenticationLevel)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_AuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAuthenticationLevelRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ForceCertificateChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_ForceCertificateChain)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_ForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ControlChannelCipherSuite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ControlChannelCipherSuite(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ControlChannelSSLVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ControlChannelSSLVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ControlChannelSSLCompressionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ControlChannelSSLCompressionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ControlChannelSSLConnectionInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_get_ControlChannelSSLConnectionInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSLConnectionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_DataChannelCipherSuite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_DataChannelCipherSuite(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_DataChannelSSLVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_DataChannelSSLVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_DataChannelSSLCompressionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_DataChannelSSLCompressionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_DataChannelSSLConnectionInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_get_DataChannelSSLConnectionInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSLConnectionInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_SessionPool)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_get_SessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSessionPool_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_SessionPool)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSessionPool_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_SessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSessionPool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ClientCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_get_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_ClientCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_SystemType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElFTPSServer_get_SystemType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(562058206, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_SystemType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_SystemType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_ImplicitSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_ImplicitSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_ImplicitSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_ImplicitSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_SecurityOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSSecurityOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_SecurityOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_SecurityOptions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_SecurityOptions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBFTPSSecurityOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_TransferBlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElFTPSServer_get_TransferBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_TransferBlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElFTPSServer_set_TransferBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnCmdReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnCmdReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnCmdReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnCmdReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnCmdSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnCmdSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnCmdSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnCmdSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnDataReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnDataReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnDataReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnDataReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnDataSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnDataSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnDataSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnDataSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnTransferDataNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnTransferDataNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnTransferDataNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnTransferDataNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnTransferDataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnTransferDataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnTransferDataAvailable)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnTransferDataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnTransferProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerTransferProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnTransferProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnTransferProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnTransferProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerTransferProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerTransferProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnTransferCompleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnTransferCompleted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnAbortTransfer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnAbortTransfer(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnAbortTransfer)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnAbortTransfer(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnCommandReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnCommandReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnCommandReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnCommandReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnCommandUnhandled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandUnhandledEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnCommandUnhandled(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnCommandUnhandled)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnCommandUnhandled(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandUnhandledEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandUnhandledEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnCommandProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandProcessedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnCommandProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnCommandProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnCommandProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandProcessedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandProcessedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnBeforeSendReply)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerBeforeSendReplyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnBeforeSendReply(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnBeforeSendReply)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnBeforeSendReply(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerBeforeSendReplyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerBeforeSendReplyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnUsernameReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerUsernameReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnUsernameReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnUsernameReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnUsernameReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerUsernameReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerUsernameReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnPasswordAuth)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerPasswordAuthEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnPasswordAuth(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnPasswordAuth)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnPasswordAuth(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerPasswordAuthEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerPasswordAuthEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnWorkingDirectoryRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDirectoryRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnWorkingDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnWorkingDirectoryRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnWorkingDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDirectoryRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDirectoryRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnMakeDirectoryRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDirectoryRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnMakeDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnMakeDirectoryRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnMakeDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDirectoryRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDirectoryRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnRemoveDirectoryRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDirectoryRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnRemoveDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnRemoveDirectoryRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnRemoveDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDirectoryRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDirectoryRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnRestartTransferRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerRestartTransferRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnRestartTransferRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnRestartTransferRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnRestartTransferRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerRestartTransferRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerRestartTransferRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnChangeDirectoryRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDirectoryRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnChangeDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnChangeDirectoryRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnChangeDirectoryRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDirectoryRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDirectoryRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnDataPortChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDataPortChangeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnDataPortChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnDataPortChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnDataPortChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDataPortChangeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDataPortChangeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnPassiveModeRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerPassiveModeRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnPassiveModeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnPassiveModeRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnPassiveModeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerPassiveModeRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerPassiveModeRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnDataConnectionNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDataConnectionNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnDataConnectionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnDataConnectionNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnDataConnectionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDataConnectionNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDataConnectionNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnDataConnectionClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDataConnectionCloseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnDataConnectionClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnDataConnectionClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnDataConnectionClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDataConnectionCloseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDataConnectionCloseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileListRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerDirectoryRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileListRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileListRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileListRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerDirectoryRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerDirectoryRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileListItemRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileListItemRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileListItemRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileListItemRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileListItemRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileListItemRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileListItemRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileListCompleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileListCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileListCompleted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileListCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileRetrieveRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileRetrieveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileRetrieveRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileRetrieveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileAllocate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileAllocateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileAllocate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileAllocate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileAllocate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileAllocateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileAllocateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileStoreRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileStoreRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileStoreRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileStoreRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileAppendRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileAppendRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileAppendRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileAppendRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileInfoNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileInfoNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileInfoNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileInfoNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileInfoNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileInfoNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileInfoNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileRemoveRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileRemoveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileRemoveRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileRemoveRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnFileRenameRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileRenameRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnFileRenameRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnFileRenameRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnFileRenameRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileRenameRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileRenameRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnStatusRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerInformationRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnStatusRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnStatusRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnStatusRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerInformationRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerInformationRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnVirtualHostRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerHostRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnVirtualHostRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnVirtualHostRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnVirtualHostRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerHostRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerHostRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnEstablishSecureConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerEstablishSecureConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnEstablishSecureConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnEstablishSecureConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnEstablishSecureConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerEstablishSecureConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerEstablishSecureConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnExtPassiveModeRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerExtPassiveModeRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnExtPassiveModeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnExtPassiveModeRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnExtPassiveModeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerExtPassiveModeRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerExtPassiveModeRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, get_OnSiteCommand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerSiteCommandEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElFTPSServer_get_OnSiteCommand(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, set_OnSiteCommand)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElFTPSServer_set_OnSiteCommand(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerSiteCommandEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerSiteCommandEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSServer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSServer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_CloseDataConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_TransferDataFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_SendCustomReply, 0, 0, 2)
	ZEND_ARG_INFO(0, Code)
	ZEND_ARG_INFO(0, Reply)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_AssignTLSParamsFromTemplate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tpl, TElSSLServer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ASCIIMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_Authenticated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_Authenticated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_PassiveMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ExtPassiveOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_MessageTable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_MessageTable, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElFTPSServerMessageTable, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_LastCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_LastTransferCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_TransferInProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ControlChannelEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_DataChannelEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_CipherSuites, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_CipherSuites, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_CipherSuitePriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_CipherSuitePriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_CompressionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_CompressionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ClientAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_ClientAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_AuthenticationLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_AuthenticationLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ForceCertificateChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_ForceCertificateChain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ControlChannelCipherSuite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ControlChannelSSLVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ControlChannelSSLCompressionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ControlChannelSSLConnectionInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_DataChannelCipherSuite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_DataChannelSSLVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_DataChannelSSLCompressionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_DataChannelSSLConnectionInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_SessionPool, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_SessionPool, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSessionPool, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ClientCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_ClientCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_SystemType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_SystemType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_ImplicitSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_ImplicitSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_SecurityOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_SecurityOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_TransferBlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_TransferBlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnCmdReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnCmdReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnCmdSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnCmdSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnDataReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnDataReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnDataSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnDataSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnTransferDataNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnTransferDataNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnTransferDataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnTransferDataAvailable, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnTransferProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnTransferProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnTransferCompleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnTransferCompleted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnAbortTransfer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnAbortTransfer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnCommandReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnCommandReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnCommandUnhandled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnCommandUnhandled, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnCommandProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnCommandProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnBeforeSendReply, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnBeforeSendReply, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnUsernameReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnUsernameReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnPasswordAuth, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnPasswordAuth, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnWorkingDirectoryRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnWorkingDirectoryRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnMakeDirectoryRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnMakeDirectoryRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnRemoveDirectoryRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnRemoveDirectoryRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnRestartTransferRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnRestartTransferRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnChangeDirectoryRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnChangeDirectoryRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnDataPortChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnDataPortChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnPassiveModeRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnPassiveModeRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnDataConnectionNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnDataConnectionNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnDataConnectionClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnDataConnectionClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileListRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileListRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileListItemRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileListItemRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileListCompleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileListCompleted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileRetrieveRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileRetrieveRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileAllocate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileAllocate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileStoreRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileStoreRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileAppendRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileAppendRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileInfoNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileInfoNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileRemoveRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileRemoveRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnFileRenameRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnFileRenameRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnStatusRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnStatusRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnVirtualHostRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnVirtualHostRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnEstablishSecureConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnEstablishSecureConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnExtPassiveModeRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnExtPassiveModeRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_get_OnSiteCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer_set_OnSiteCommand, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFTPSServer_methods[] = {
	PHP_ME(TElFTPSServer, Open, arginfo_TElFTPSServer_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, Close, arginfo_TElFTPSServer_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, CloseDataConnection, arginfo_TElFTPSServer_CloseDataConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, TransferDataFinished, arginfo_TElFTPSServer_TransferDataFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, DataAvailable, arginfo_TElFTPSServer_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, SendCustomReply, arginfo_TElFTPSServer_SendCustomReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, AssignTLSParamsFromTemplate, arginfo_TElFTPSServer_AssignTLSParamsFromTemplate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_Active, arginfo_TElFTPSServer_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ASCIIMode, arginfo_TElFTPSServer_get_ASCIIMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_Authenticated, arginfo_TElFTPSServer_get_Authenticated, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_Authenticated, arginfo_TElFTPSServer_set_Authenticated, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_PassiveMode, arginfo_TElFTPSServer_get_PassiveMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ExtPassiveOnly, arginfo_TElFTPSServer_get_ExtPassiveOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_MessageTable, arginfo_TElFTPSServer_get_MessageTable, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_MessageTable, arginfo_TElFTPSServer_set_MessageTable, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_LastCommand, arginfo_TElFTPSServer_get_LastCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_LastTransferCommand, arginfo_TElFTPSServer_get_LastTransferCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_TransferInProgress, arginfo_TElFTPSServer_get_TransferInProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ControlChannelEncrypted, arginfo_TElFTPSServer_get_ControlChannelEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_DataChannelEncrypted, arginfo_TElFTPSServer_get_DataChannelEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_CipherSuites, arginfo_TElFTPSServer_get_CipherSuites, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_CipherSuites, arginfo_TElFTPSServer_set_CipherSuites, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_CipherSuitePriorities, arginfo_TElFTPSServer_get_CipherSuitePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_CipherSuitePriorities, arginfo_TElFTPSServer_set_CipherSuitePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_CompressionAlgorithms, arginfo_TElFTPSServer_get_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_CompressionAlgorithms, arginfo_TElFTPSServer_set_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_Versions, arginfo_TElFTPSServer_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_Versions, arginfo_TElFTPSServer_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ClientAuthentication, arginfo_TElFTPSServer_get_ClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_ClientAuthentication, arginfo_TElFTPSServer_set_ClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_AuthenticationLevel, arginfo_TElFTPSServer_get_AuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_AuthenticationLevel, arginfo_TElFTPSServer_set_AuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ForceCertificateChain, arginfo_TElFTPSServer_get_ForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_ForceCertificateChain, arginfo_TElFTPSServer_set_ForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ControlChannelCipherSuite, arginfo_TElFTPSServer_get_ControlChannelCipherSuite, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ControlChannelSSLVersion, arginfo_TElFTPSServer_get_ControlChannelSSLVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ControlChannelSSLCompressionAlgorithm, arginfo_TElFTPSServer_get_ControlChannelSSLCompressionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ControlChannelSSLConnectionInfo, arginfo_TElFTPSServer_get_ControlChannelSSLConnectionInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_DataChannelCipherSuite, arginfo_TElFTPSServer_get_DataChannelCipherSuite, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_DataChannelSSLVersion, arginfo_TElFTPSServer_get_DataChannelSSLVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_DataChannelSSLCompressionAlgorithm, arginfo_TElFTPSServer_get_DataChannelSSLCompressionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_DataChannelSSLConnectionInfo, arginfo_TElFTPSServer_get_DataChannelSSLConnectionInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_CertStorage, arginfo_TElFTPSServer_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_CertStorage, arginfo_TElFTPSServer_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_SessionPool, arginfo_TElFTPSServer_get_SessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_SessionPool, arginfo_TElFTPSServer_set_SessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ClientCertStorage, arginfo_TElFTPSServer_get_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_ClientCertStorage, arginfo_TElFTPSServer_set_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_SystemType, arginfo_TElFTPSServer_get_SystemType, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_SystemType, arginfo_TElFTPSServer_set_SystemType, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_ImplicitSSL, arginfo_TElFTPSServer_get_ImplicitSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_ImplicitSSL, arginfo_TElFTPSServer_set_ImplicitSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_SecurityOptions, arginfo_TElFTPSServer_get_SecurityOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_SecurityOptions, arginfo_TElFTPSServer_set_SecurityOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_UseUTF8, arginfo_TElFTPSServer_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_UseUTF8, arginfo_TElFTPSServer_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_TransferBlockSize, arginfo_TElFTPSServer_get_TransferBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_TransferBlockSize, arginfo_TElFTPSServer_set_TransferBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnOpen, arginfo_TElFTPSServer_get_OnOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnOpen, arginfo_TElFTPSServer_set_OnOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnCmdReceive, arginfo_TElFTPSServer_get_OnCmdReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnCmdReceive, arginfo_TElFTPSServer_set_OnCmdReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnCmdSend, arginfo_TElFTPSServer_get_OnCmdSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnCmdSend, arginfo_TElFTPSServer_set_OnCmdSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnDataReceive, arginfo_TElFTPSServer_get_OnDataReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnDataReceive, arginfo_TElFTPSServer_set_OnDataReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnDataSend, arginfo_TElFTPSServer_get_OnDataSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnDataSend, arginfo_TElFTPSServer_set_OnDataSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnTransferDataNeeded, arginfo_TElFTPSServer_get_OnTransferDataNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnTransferDataNeeded, arginfo_TElFTPSServer_set_OnTransferDataNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnTransferDataAvailable, arginfo_TElFTPSServer_get_OnTransferDataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnTransferDataAvailable, arginfo_TElFTPSServer_set_OnTransferDataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnTransferProgress, arginfo_TElFTPSServer_get_OnTransferProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnTransferProgress, arginfo_TElFTPSServer_set_OnTransferProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnTransferCompleted, arginfo_TElFTPSServer_get_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnTransferCompleted, arginfo_TElFTPSServer_set_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnAbortTransfer, arginfo_TElFTPSServer_get_OnAbortTransfer, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnAbortTransfer, arginfo_TElFTPSServer_set_OnAbortTransfer, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnClose, arginfo_TElFTPSServer_get_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnClose, arginfo_TElFTPSServer_set_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnCommandReceived, arginfo_TElFTPSServer_get_OnCommandReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnCommandReceived, arginfo_TElFTPSServer_set_OnCommandReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnCommandUnhandled, arginfo_TElFTPSServer_get_OnCommandUnhandled, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnCommandUnhandled, arginfo_TElFTPSServer_set_OnCommandUnhandled, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnCommandProcessed, arginfo_TElFTPSServer_get_OnCommandProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnCommandProcessed, arginfo_TElFTPSServer_set_OnCommandProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnBeforeSendReply, arginfo_TElFTPSServer_get_OnBeforeSendReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnBeforeSendReply, arginfo_TElFTPSServer_set_OnBeforeSendReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnUsernameReceived, arginfo_TElFTPSServer_get_OnUsernameReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnUsernameReceived, arginfo_TElFTPSServer_set_OnUsernameReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnPasswordAuth, arginfo_TElFTPSServer_get_OnPasswordAuth, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnPasswordAuth, arginfo_TElFTPSServer_set_OnPasswordAuth, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnWorkingDirectoryRequest, arginfo_TElFTPSServer_get_OnWorkingDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnWorkingDirectoryRequest, arginfo_TElFTPSServer_set_OnWorkingDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnMakeDirectoryRequest, arginfo_TElFTPSServer_get_OnMakeDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnMakeDirectoryRequest, arginfo_TElFTPSServer_set_OnMakeDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnRemoveDirectoryRequest, arginfo_TElFTPSServer_get_OnRemoveDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnRemoveDirectoryRequest, arginfo_TElFTPSServer_set_OnRemoveDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnRestartTransferRequest, arginfo_TElFTPSServer_get_OnRestartTransferRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnRestartTransferRequest, arginfo_TElFTPSServer_set_OnRestartTransferRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnChangeDirectoryRequest, arginfo_TElFTPSServer_get_OnChangeDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnChangeDirectoryRequest, arginfo_TElFTPSServer_set_OnChangeDirectoryRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnDataPortChange, arginfo_TElFTPSServer_get_OnDataPortChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnDataPortChange, arginfo_TElFTPSServer_set_OnDataPortChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnPassiveModeRequest, arginfo_TElFTPSServer_get_OnPassiveModeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnPassiveModeRequest, arginfo_TElFTPSServer_set_OnPassiveModeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnDataConnectionNeeded, arginfo_TElFTPSServer_get_OnDataConnectionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnDataConnectionNeeded, arginfo_TElFTPSServer_set_OnDataConnectionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnDataConnectionClose, arginfo_TElFTPSServer_get_OnDataConnectionClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnDataConnectionClose, arginfo_TElFTPSServer_set_OnDataConnectionClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileListRequest, arginfo_TElFTPSServer_get_OnFileListRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileListRequest, arginfo_TElFTPSServer_set_OnFileListRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileListItemRequest, arginfo_TElFTPSServer_get_OnFileListItemRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileListItemRequest, arginfo_TElFTPSServer_set_OnFileListItemRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileListCompleted, arginfo_TElFTPSServer_get_OnFileListCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileListCompleted, arginfo_TElFTPSServer_set_OnFileListCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileRetrieveRequest, arginfo_TElFTPSServer_get_OnFileRetrieveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileRetrieveRequest, arginfo_TElFTPSServer_set_OnFileRetrieveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileAllocate, arginfo_TElFTPSServer_get_OnFileAllocate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileAllocate, arginfo_TElFTPSServer_set_OnFileAllocate, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileStoreRequest, arginfo_TElFTPSServer_get_OnFileStoreRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileStoreRequest, arginfo_TElFTPSServer_set_OnFileStoreRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileAppendRequest, arginfo_TElFTPSServer_get_OnFileAppendRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileAppendRequest, arginfo_TElFTPSServer_set_OnFileAppendRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileInfoNeeded, arginfo_TElFTPSServer_get_OnFileInfoNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileInfoNeeded, arginfo_TElFTPSServer_set_OnFileInfoNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileRemoveRequest, arginfo_TElFTPSServer_get_OnFileRemoveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileRemoveRequest, arginfo_TElFTPSServer_set_OnFileRemoveRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnFileRenameRequest, arginfo_TElFTPSServer_get_OnFileRenameRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnFileRenameRequest, arginfo_TElFTPSServer_set_OnFileRenameRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnStatusRequest, arginfo_TElFTPSServer_get_OnStatusRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnStatusRequest, arginfo_TElFTPSServer_set_OnStatusRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnVirtualHostRequest, arginfo_TElFTPSServer_get_OnVirtualHostRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnVirtualHostRequest, arginfo_TElFTPSServer_set_OnVirtualHostRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnEstablishSecureConnection, arginfo_TElFTPSServer_get_OnEstablishSecureConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnEstablishSecureConnection, arginfo_TElFTPSServer_set_OnEstablishSecureConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnExtPassiveModeRequest, arginfo_TElFTPSServer_get_OnExtPassiveModeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnExtPassiveModeRequest, arginfo_TElFTPSServer_set_OnExtPassiveModeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, get_OnSiteCommand, arginfo_TElFTPSServer_get_OnSiteCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, set_OnSiteCommand, arginfo_TElFTPSServer_set_OnSiteCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSServer, __construct, arginfo_TElFTPSServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFTPSServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFTPSServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFTPSServer", TElFTPSServer_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElFTPSServer_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBFTPSServer_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_NOOP, SB_FTP_CMD_NOOP, SB_FTP_CMD_NOOP);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_USER, SB_FTP_CMD_USER, SB_FTP_CMD_USER);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_PASS, SB_FTP_CMD_PASS, SB_FTP_CMD_PASS);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_QUIT, SB_FTP_CMD_QUIT, SB_FTP_CMD_QUIT);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_SYST, SB_FTP_CMD_SYST, SB_FTP_CMD_SYST);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_PWD, SB_FTP_CMD_PWD, SB_FTP_CMD_PWD);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_REST, SB_FTP_CMD_REST, SB_FTP_CMD_REST);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_TYPE, SB_FTP_CMD_TYPE, SB_FTP_CMD_TYPE);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_CWD, SB_FTP_CMD_CWD, SB_FTP_CMD_CWD);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_PORT, SB_FTP_CMD_PORT, SB_FTP_CMD_PORT);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_PASV, SB_FTP_CMD_PASV, SB_FTP_CMD_PASV);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_LIST, SB_FTP_CMD_LIST, SB_FTP_CMD_LIST);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_NLST, SB_FTP_CMD_NLST, SB_FTP_CMD_NLST);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_MLST, SB_FTP_CMD_MLST, SB_FTP_CMD_MLST);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_MLSD, SB_FTP_CMD_MLSD, SB_FTP_CMD_MLSD);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_RETR, SB_FTP_CMD_RETR, SB_FTP_CMD_RETR);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_ABOR, SB_FTP_CMD_ABOR, SB_FTP_CMD_ABOR);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_ALLO, SB_FTP_CMD_ALLO, SB_FTP_CMD_ALLO);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_STOR, SB_FTP_CMD_STOR, SB_FTP_CMD_STOR);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_APPE, SB_FTP_CMD_APPE, SB_FTP_CMD_APPE);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_CDUP, SB_FTP_CMD_CDUP, SB_FTP_CMD_CDUP);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_SIZE, SB_FTP_CMD_SIZE, SB_FTP_CMD_SIZE);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_MDTM, SB_FTP_CMD_MDTM, SB_FTP_CMD_MDTM);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_RMD, SB_FTP_CMD_RMD, SB_FTP_CMD_RMD);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_MKD, SB_FTP_CMD_MKD, SB_FTP_CMD_MKD);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_DELE, SB_FTP_CMD_DELE, SB_FTP_CMD_DELE);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_RNFR, SB_FTP_CMD_RNFR, SB_FTP_CMD_RNFR);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_RNTO, SB_FTP_CMD_RNTO, SB_FTP_CMD_RNTO);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_FEAT, SB_FTP_CMD_FEAT, SB_FTP_CMD_FEAT);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_HOST, SB_FTP_CMD_HOST, SB_FTP_CMD_HOST);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_OPTS, SB_FTP_CMD_OPTS, SB_FTP_CMD_OPTS);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_STAT, SB_FTP_CMD_STAT, SB_FTP_CMD_STAT);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_HELP, SB_FTP_CMD_HELP, SB_FTP_CMD_HELP);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_AUTH, SB_FTP_CMD_AUTH, SB_FTP_CMD_AUTH);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_PBSZ, SB_FTP_CMD_PBSZ, SB_FTP_CMD_PBSZ);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_PROT, SB_FTP_CMD_PROT, SB_FTP_CMD_PROT);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_CCC, SB_FTP_CMD_CCC, SB_FTP_CMD_CCC);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_REIN, SB_FTP_CMD_REIN, SB_FTP_CMD_REIN);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_MODE, SB_FTP_CMD_MODE, SB_FTP_CMD_MODE);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_EPRT, SB_FTP_CMD_EPRT, SB_FTP_CMD_EPRT);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_EPSV, SB_FTP_CMD_EPSV, SB_FTP_CMD_EPSV);
	SB_REGISTER_STRING_CONSTANT(SBFTPSServer, FTP_CMD_SITE, SB_FTP_CMD_SITE, SB_FTP_CMD_SITE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_DC_ALREADY_OPEN, SB_FTP_CODE_DC_ALREADY_OPEN, SB_FTP_CODE_DC_ALREADY_OPEN);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_OPENING_DC, SB_FTP_CODE_OPENING_DC, SB_FTP_CODE_OPENING_DC);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_COMMAND_OK, SB_FTP_CODE_COMMAND_OK, SB_FTP_CODE_COMMAND_OK);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_FEATURES, SB_FTP_CODE_FEATURES, SB_FTP_CODE_FEATURES);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_DIR_STATUS, SB_FTP_CODE_DIR_STATUS, SB_FTP_CODE_DIR_STATUS);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_FILE_STATUS, SB_FTP_CODE_FILE_STATUS, SB_FTP_CODE_FILE_STATUS);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_HELP_MESSAGE, SB_FTP_CODE_HELP_MESSAGE, SB_FTP_CODE_HELP_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_SYSTEM_TYPE, SB_FTP_CODE_SYSTEM_TYPE, SB_FTP_CODE_SYSTEM_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_SERVICE_READY, SB_FTP_CODE_SERVICE_READY, SB_FTP_CODE_SERVICE_READY);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_CLOSING_CONNECTION, SB_FTP_CODE_CLOSING_CONNECTION, SB_FTP_CODE_CLOSING_CONNECTION);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ABORT_OK, SB_FTP_CODE_ABORT_OK, SB_FTP_CODE_ABORT_OK);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_CLOSING_DC, SB_FTP_CODE_CLOSING_DC, SB_FTP_CODE_CLOSING_DC);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ENTER_PASSIVE_MODE, SB_FTP_CODE_ENTER_PASSIVE_MODE, SB_FTP_CODE_ENTER_PASSIVE_MODE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ENTER_EXT_PASV_MODE, SB_FTP_CODE_ENTER_EXT_PASV_MODE, SB_FTP_CODE_ENTER_EXT_PASV_MODE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_LOGGED_IN, SB_FTP_CODE_LOGGED_IN, SB_FTP_CODE_LOGGED_IN);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_AUTH_COMPLETE, SB_FTP_CODE_AUTH_COMPLETE, SB_FTP_CODE_AUTH_COMPLETE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ACTION_OK, SB_FTP_CODE_ACTION_OK, SB_FTP_CODE_ACTION_OK);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_DIRECTORY_OK, SB_FTP_CODE_DIRECTORY_OK, SB_FTP_CODE_DIRECTORY_OK);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_PASSWORD_NEEDED, SB_FTP_CODE_PASSWORD_NEEDED, SB_FTP_CODE_PASSWORD_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ACCOUNT_NEEDED, SB_FTP_CODE_ACCOUNT_NEEDED, SB_FTP_CODE_ACCOUNT_NEEDED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_FILE_ACTION_PENDING, SB_FTP_CODE_FILE_ACTION_PENDING, SB_FTP_CODE_FILE_ACTION_PENDING);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_SERVICE_UNAVAILABLE, SB_FTP_CODE_SERVICE_UNAVAILABLE, SB_FTP_CODE_SERVICE_UNAVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_CANNOT_OPEN_DC, SB_FTP_CODE_CANNOT_OPEN_DC, SB_FTP_CODE_CANNOT_OPEN_DC);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_TRANSFER_ABORTED, SB_FTP_CODE_TRANSFER_ABORTED, SB_FTP_CODE_TRANSFER_ABORTED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ACTION_NOT_TAKEN, SB_FTP_CODE_ACTION_NOT_TAKEN, SB_FTP_CODE_ACTION_NOT_TAKEN);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_PROCESSING_ERROR, SB_FTP_CODE_PROCESSING_ERROR, SB_FTP_CODE_PROCESSING_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_DISK_QUOTA_EXCEEDED, SB_FTP_CODE_DISK_QUOTA_EXCEEDED, SB_FTP_CODE_DISK_QUOTA_EXCEEDED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_CMD_NOT_UNDERSTOOD, SB_FTP_CODE_CMD_NOT_UNDERSTOOD, SB_FTP_CODE_CMD_NOT_UNDERSTOOD);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_PARAMETERS_ERROR, SB_FTP_CODE_PARAMETERS_ERROR, SB_FTP_CODE_PARAMETERS_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_CMD_NOT_IMPLEMENTED, SB_FTP_CODE_CMD_NOT_IMPLEMENTED, SB_FTP_CODE_CMD_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_BAD_CMD_SEQUENCE, SB_FTP_CODE_BAD_CMD_SEQUENCE, SB_FTP_CODE_BAD_CMD_SEQUENCE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_PARAM_NOT_IMPLEMENTED, SB_FTP_CODE_PARAM_NOT_IMPLEMENTED, SB_FTP_CODE_PARAM_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_UNKNOWN_PROTOCOL, SB_FTP_CODE_UNKNOWN_PROTOCOL, SB_FTP_CODE_UNKNOWN_PROTOCOL);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_NOT_LOGGED_IN, SB_FTP_CODE_NOT_LOGGED_IN, SB_FTP_CODE_NOT_LOGGED_IN);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_CMD_NOT_SECURED, SB_FTP_CODE_CMD_NOT_SECURED, SB_FTP_CODE_CMD_NOT_SECURED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_REQUEST_DENIED, SB_FTP_CODE_REQUEST_DENIED, SB_FTP_CODE_REQUEST_DENIED);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_CODE_ACTION_UNAVAILABLE, SB_FTP_CODE_ACTION_UNAVAILABLE, SB_FTP_CODE_ACTION_UNAVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBFTPSServer, FTP_TRANSFER_BLOCK_SIZE, SB_FTP_TRANSFER_BLOCK_SIZE, SB_FTP_TRANSFER_BLOCK_SIZE);
}

void Register_SBFTPSServer_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBFTPSConnectionStatus", NULL);
	TSBFTPSConnectionStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSConnectionStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSConnectionStatus_ce_ptr, "fcsDisconnected", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSConnectionStatus_ce_ptr, "fcsPending", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSConnectionStatus_ce_ptr, "fcsConnected", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBFTPSInternalConnectionStatus", NULL);
	TSBFTPSInternalConnectionStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSInternalConnectionStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSInternalConnectionStatus_ce_ptr, "fcisNotConnected", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSInternalConnectionStatus_ce_ptr, "fcisPending", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSInternalConnectionStatus_ce_ptr, "fcisEstablishingSSL", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSInternalConnectionStatus_ce_ptr, "fcisConnected", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSInternalConnectionStatus_ce_ptr, "fcisShuttingDownSSL", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSInternalConnectionStatus_ce_ptr, "fcisDisconnected", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBFTPSSecurityOption", NULL);
	TSBFTPSSecurityOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSSecurityOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOption_ce_ptr, "fsoPlainLogin", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOption_ce_ptr, "fsoEncryption", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOption_ce_ptr, "fsoAuth", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOption_ce_ptr, "fsoClearControlChannel", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOption_ce_ptr, "fsoClearDataChannel", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOption_ce_ptr, "fsoEncryptedDataChannel", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBFTPSSecurityOptions", NULL);
	TSBFTPSSecurityOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSSecurityOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOptions_ce_ptr, "fsoPlainLogin", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOptions_ce_ptr, "fsoEncryption", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOptions_ce_ptr, "fsoAuth", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOptions_ce_ptr, "fsoClearControlChannel", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOptions_ce_ptr, "fsoClearDataChannel", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSSecurityOptions_ce_ptr, "fsoEncryptedDataChannel", 32)
	
	INIT_CLASS_ENTRY(ce, "TSBFTPSServerFileAttribute", NULL);
	TSBFTPSServerFileAttribute_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSServerFileAttribute_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaSize", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaName", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaFileType", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaModificationDate", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaCreationDate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaUnixPermissions", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaOwner", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttribute_ce_ptr, "fsaGroup", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBFTPSServerFileAttributes", NULL);
	TSBFTPSServerFileAttributes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSServerFileAttributes_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaSize", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaName", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaFileType", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaModificationDate", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaCreationDate", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaUnixPermissions", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaOwner", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileAttributes_ce_ptr, "fsaGroup", 128)
	
	INIT_CLASS_ENTRY(ce, "TSBFTPSServerFileType", NULL);
	TSBFTPSServerFileType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBFTPSServerFileType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileType_ce_ptr, "fstFile", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileType_ce_ptr, "fstDirectory", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBFTPSServerFileType_ce_ptr, "fstCurrentDirectory", 2)
}

void Register_SBFTPSServer_Aliases(TSRMLS_D)
{
	if (NULL == TElFTPSServerFileInfo_ce_ptr)
		Register_TElFTPSServerFileInfo(TSRMLS_C);
	zend_register_class_alias("ElFTPSServerFileInfo", TElFTPSServerFileInfo_ce_ptr);
	if (NULL == TElFTPSServer_ce_ptr)
		Register_TElFTPSServer(TSRMLS_C);
	zend_register_class_alias("ElFTPSServer", TElFTPSServer_ce_ptr);
	if (NULL == TElFTPSServerMessageTable_ce_ptr)
		Register_TElFTPSServerMessageTable(TSRMLS_C);
	zend_register_class_alias("ElFTPSServerMessageTable", TElFTPSServerMessageTable_ce_ptr);
}

