#include "sbhttpscommon.h"

zend_class_entry *TGZHeaderSkipped_ce_ptr = NULL;

zend_class_entry *SBHTTPSCommon_TSBHTTPChunkState_ce_ptr = NULL;

zend_class_entry *TSBHTTPMethod_ce_ptr = NULL;

zend_class_entry *TSBHTTPMultipartMode_ce_ptr = NULL;

#ifdef SB_WINDOWS
void SB_CALLBACK TSBHTTPHeadersEventRaw(void * _ObjectData, TObjectHandle Sender, TStringListHandle Headers)
#else
void SB_CALLBACK TSBHTTPHeadersEventRaw(void * _ObjectData, TObjectHandle Sender, TElStringListHandle Headers)
#endif
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHeaders;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHeaders);
#ifdef SB_WINDOWS
	SBInitObject(zHeaders, TStringList_ce_ptr, Headers TSRMLS_CC);
#else
	SBInitObject(zHeaders, TElStringList_ce_ptr, Headers TSRMLS_CC);
#endif

	params[0] = &zSender;
	params[1] = &zHeaders;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHeaders);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElHTTPSClientParams_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPSClientParams, get_DoReconnect)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPSClientParams_get_DoReconnect(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_DoReconnect)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_DoReconnect(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_IntoDataRedirection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPSClientParams_get_IntoDataRedirection(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_IntoDataRedirection)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_IntoDataRedirection(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_RelocationURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPSClientParams_get_RelocationURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(910926359, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_RelocationURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_RelocationURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_RequestMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPSClientParams_get_RequestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_RequestMethod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_RequestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_ContentLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPSClientParams_get_ContentLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_ContentLength)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_ContentLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPSClientParams_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1465799918, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_ContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_SentStreams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPSClientParams_get_SentStreams(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TSBObjectList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_SentStreams)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TSBObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_SentStreams(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_DataStreams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPSClientParams_get_DataStreams(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TSBObjectList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_DataStreams)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TSBObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_DataStreams(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_AllowRedirection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPSClientParams_get_AllowRedirection(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_AllowRedirection)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_AllowRedirection(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_NewURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPSClientParams_get_NewURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1104098786, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_NewURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_NewURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_ServerStatusCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPSClientParams_get_ServerStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_ServerStatusCode)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_ServerStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPSClientParams_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(339165224, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPSClientParams_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPSClientParams, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPSClientParams_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_DoReconnect, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_DoReconnect, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_IntoDataRedirection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_IntoDataRedirection, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_RelocationURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_RelocationURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_RequestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_RequestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_ContentLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_ContentLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_ContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_SentStreams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_SentStreams, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_DataStreams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_DataStreams, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_AllowRedirection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_AllowRedirection, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_NewURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_NewURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_ServerStatusCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_ServerStatusCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPSClientParams___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPSClientParams_methods[] = {
	PHP_ME(TElHTTPSClientParams, get_DoReconnect, arginfo_TElHTTPSClientParams_get_DoReconnect, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_DoReconnect, arginfo_TElHTTPSClientParams_set_DoReconnect, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_IntoDataRedirection, arginfo_TElHTTPSClientParams_get_IntoDataRedirection, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_IntoDataRedirection, arginfo_TElHTTPSClientParams_set_IntoDataRedirection, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_RelocationURL, arginfo_TElHTTPSClientParams_get_RelocationURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_RelocationURL, arginfo_TElHTTPSClientParams_set_RelocationURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_RequestMethod, arginfo_TElHTTPSClientParams_get_RequestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_RequestMethod, arginfo_TElHTTPSClientParams_set_RequestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_ContentLength, arginfo_TElHTTPSClientParams_get_ContentLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_ContentLength, arginfo_TElHTTPSClientParams_set_ContentLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_ContentType, arginfo_TElHTTPSClientParams_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_ContentType, arginfo_TElHTTPSClientParams_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_SentStreams, arginfo_TElHTTPSClientParams_get_SentStreams, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_SentStreams, arginfo_TElHTTPSClientParams_set_SentStreams, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_DataStreams, arginfo_TElHTTPSClientParams_get_DataStreams, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_DataStreams, arginfo_TElHTTPSClientParams_set_DataStreams, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_AllowRedirection, arginfo_TElHTTPSClientParams_get_AllowRedirection, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_AllowRedirection, arginfo_TElHTTPSClientParams_set_AllowRedirection, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_NewURL, arginfo_TElHTTPSClientParams_get_NewURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_NewURL, arginfo_TElHTTPSClientParams_set_NewURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_ServerStatusCode, arginfo_TElHTTPSClientParams_get_ServerStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_ServerStatusCode, arginfo_TElHTTPSClientParams_set_ServerStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, get_URL, arginfo_TElHTTPSClientParams_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, set_URL, arginfo_TElHTTPSClientParams_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPSClientParams, __construct, arginfo_TElHTTPSClientParams___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPSClientParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPSClientParams_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPSClientParams", TElHTTPSClientParams_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElHTTPSClientParams_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomSAMLAdapter_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomSAMLAdapter, HandleDocumentEnd)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElHTTPSClientParams_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSAMLAdapter_HandleDocumentEnd(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClientParams)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSAMLAdapter, HandlePerformExchange)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElHTTPSClientParams_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSAMLAdapter_HandlePerformExchange(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClientParams)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSAMLAdapter, HandleRedirection)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElHTTPSClientParams_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomSAMLAdapter_HandleRedirection(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClientParams)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSAMLAdapter, HandleReadyData)
{
	SBArrayZValInfo aiBuf;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomSAMLAdapter_HandleReadyData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuf.data, aiBuf.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuf);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSAMLAdapter, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomSAMLAdapter_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomSAMLAdapter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomSAMLAdapter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSAMLAdapter_HandleDocumentEnd, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElHTTPSClientParams, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSAMLAdapter_HandlePerformExchange, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElHTTPSClientParams, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSAMLAdapter_HandleRedirection, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElHTTPSClientParams, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSAMLAdapter_HandleReadyData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSAMLAdapter_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomSAMLAdapter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomSAMLAdapter_methods[] = {
	PHP_ME(TElCustomSAMLAdapter, HandleDocumentEnd, arginfo_TElCustomSAMLAdapter_HandleDocumentEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSAMLAdapter, HandlePerformExchange, arginfo_TElCustomSAMLAdapter_HandlePerformExchange, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSAMLAdapter, HandleRedirection, arginfo_TElCustomSAMLAdapter_HandleRedirection, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSAMLAdapter, HandleReadyData, arginfo_TElCustomSAMLAdapter_HandleReadyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSAMLAdapter, Reset, arginfo_TElCustomSAMLAdapter_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomSAMLAdapter, __construct, arginfo_TElCustomSAMLAdapter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomSAMLAdapter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomSAMLAdapter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomSAMLAdapter", TElCustomSAMLAdapter_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomSAMLAdapter_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPRanges_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPRanges, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPRanges_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPRanges_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, get_RangeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPRanges_get_RangeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, set_RangeCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElHTTPRanges_set_RangeCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, get_RangeEnd)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPRanges_get_RangeEnd(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, set_RangeEnd)
{
	long l4Index;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPRanges_set_RangeEnd(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, get_RangeStart)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPRanges_get_RangeStart(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, set_RangeStart)
{
	long l4Index;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPRanges_set_RangeStart(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPRanges, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPRanges_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_get_RangeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_set_RangeCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_get_RangeEnd, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_set_RangeEnd, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_get_RangeStart, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges_set_RangeStart, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPRanges___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPRanges_methods[] = {
	PHP_ME(TElHTTPRanges, Assign, arginfo_TElHTTPRanges_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, Clone, arginfo_TElHTTPRanges_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, get_RangeCount, arginfo_TElHTTPRanges_get_RangeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, set_RangeCount, arginfo_TElHTTPRanges_set_RangeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, get_RangeEnd, arginfo_TElHTTPRanges_get_RangeEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, set_RangeEnd, arginfo_TElHTTPRanges_set_RangeEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, get_RangeStart, arginfo_TElHTTPRanges_get_RangeStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, set_RangeStart, arginfo_TElHTTPRanges_set_RangeStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPRanges, __construct, arginfo_TElHTTPRanges___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPRanges(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPRanges_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPRanges", TElHTTPRanges_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElHTTPRanges_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPParams_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPParams, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPParams_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_ContentLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPParams_get_ContentLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, set_ContentLength)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_set_ContentLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_ContentRangeStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPParams_get_ContentRangeStart(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, set_ContentRangeStart)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_set_ContentRangeStart(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_ContentRangeEnd)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPParams_get_ContentRangeEnd(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, set_ContentRangeEnd)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_set_ContentRangeEnd(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_ContentRangeFullSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPParams_get_ContentRangeFullSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, set_ContentRangeFullSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_set_ContentRangeFullSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPParams_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1578828936, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, set_ContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_Cookies)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPParams_get_Cookies(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_CustomHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPParams_get_CustomHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, get_Date)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElHTTPParams_get_Date(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, set_Date)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElHTTPParams_set_Date(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPParams, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPParams_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_ContentLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_set_ContentLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_ContentRangeStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_set_ContentRangeStart, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_ContentRangeEnd, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_set_ContentRangeEnd, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_ContentRangeFullSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_set_ContentRangeFullSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_set_ContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_Cookies, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_CustomHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_get_Date, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams_set_Date, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPParams___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPParams_methods[] = {
	PHP_ME(TElHTTPParams, Assign, arginfo_TElHTTPParams_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, Clone, arginfo_TElHTTPParams_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_ContentLength, arginfo_TElHTTPParams_get_ContentLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, set_ContentLength, arginfo_TElHTTPParams_set_ContentLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_ContentRangeStart, arginfo_TElHTTPParams_get_ContentRangeStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, set_ContentRangeStart, arginfo_TElHTTPParams_set_ContentRangeStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_ContentRangeEnd, arginfo_TElHTTPParams_get_ContentRangeEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, set_ContentRangeEnd, arginfo_TElHTTPParams_set_ContentRangeEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_ContentRangeFullSize, arginfo_TElHTTPParams_get_ContentRangeFullSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, set_ContentRangeFullSize, arginfo_TElHTTPParams_set_ContentRangeFullSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_ContentType, arginfo_TElHTTPParams_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, set_ContentType, arginfo_TElHTTPParams_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_Cookies, arginfo_TElHTTPParams_get_Cookies, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_CustomHeaders, arginfo_TElHTTPParams_get_CustomHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, get_Date, arginfo_TElHTTPParams_get_Date, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, set_Date, arginfo_TElHTTPParams_set_Date, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPParams, __construct, arginfo_TElHTTPParams___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPParams_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPParams", TElHTTPParams_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElHTTPParams_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPCustomRequestParams_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPCustomRequestParams, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCustomRequestParams_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Accept)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Accept(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-394053977, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Accept)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Accept(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_AcceptCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_AcceptCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1490518578, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_AcceptCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_AcceptCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_AcceptLanguage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_AcceptLanguage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1556850657, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_AcceptLanguage)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_AcceptLanguage(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_AcceptRanges)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCustomRequestParams_get_AcceptRanges(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPRanges_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Authorization)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Authorization(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1783871801, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Authorization)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Authorization(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Connection)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Connection(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1594449847, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Connection)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Connection(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_IfMatch)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_IfMatch(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1693931077, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_IfMatch)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_IfMatch(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_IfModifiedSince)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElHTTPCustomRequestParams_get_IfModifiedSince(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_IfModifiedSince)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_IfModifiedSince(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_IfNoneMatch)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_IfNoneMatch(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1590968394, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_IfNoneMatch)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_IfNoneMatch(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_IfUnmodifiedSince)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElHTTPCustomRequestParams_get_IfUnmodifiedSince(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_IfUnmodifiedSince)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_IfUnmodifiedSince(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_From)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_From(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1360409200, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_From)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_From(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-219505234, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1064754444, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Referer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Referer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-293357523, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Referer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Referer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_UserAgent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_UserAgent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-303448531, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_UserAgent)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_UserAgent(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, get_Host)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPCustomRequestParams_get_Host(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-657162467, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, set_Host)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPCustomRequestParams_set_Host(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCustomRequestParams, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCustomRequestParams_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Accept, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Accept, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_AcceptCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_AcceptCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_AcceptLanguage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_AcceptLanguage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_AcceptRanges, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Authorization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Authorization, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Connection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Connection, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_IfMatch, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_IfMatch, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_IfModifiedSince, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_IfModifiedSince, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_IfNoneMatch, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_IfNoneMatch, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_IfUnmodifiedSince, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_IfUnmodifiedSince, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_From, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_From, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Referer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Referer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_UserAgent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_UserAgent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_get_Host, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams_set_Host, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCustomRequestParams___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPCustomRequestParams_methods[] = {
	PHP_ME(TElHTTPCustomRequestParams, Assign, arginfo_TElHTTPCustomRequestParams_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, Clone, arginfo_TElHTTPCustomRequestParams_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Accept, arginfo_TElHTTPCustomRequestParams_get_Accept, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Accept, arginfo_TElHTTPCustomRequestParams_set_Accept, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_AcceptCharset, arginfo_TElHTTPCustomRequestParams_get_AcceptCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_AcceptCharset, arginfo_TElHTTPCustomRequestParams_set_AcceptCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_AcceptLanguage, arginfo_TElHTTPCustomRequestParams_get_AcceptLanguage, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_AcceptLanguage, arginfo_TElHTTPCustomRequestParams_set_AcceptLanguage, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_AcceptRanges, arginfo_TElHTTPCustomRequestParams_get_AcceptRanges, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Authorization, arginfo_TElHTTPCustomRequestParams_get_Authorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Authorization, arginfo_TElHTTPCustomRequestParams_set_Authorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Connection, arginfo_TElHTTPCustomRequestParams_get_Connection, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Connection, arginfo_TElHTTPCustomRequestParams_set_Connection, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_IfMatch, arginfo_TElHTTPCustomRequestParams_get_IfMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_IfMatch, arginfo_TElHTTPCustomRequestParams_set_IfMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_IfModifiedSince, arginfo_TElHTTPCustomRequestParams_get_IfModifiedSince, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_IfModifiedSince, arginfo_TElHTTPCustomRequestParams_set_IfModifiedSince, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_IfNoneMatch, arginfo_TElHTTPCustomRequestParams_get_IfNoneMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_IfNoneMatch, arginfo_TElHTTPCustomRequestParams_set_IfNoneMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_IfUnmodifiedSince, arginfo_TElHTTPCustomRequestParams_get_IfUnmodifiedSince, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_IfUnmodifiedSince, arginfo_TElHTTPCustomRequestParams_set_IfUnmodifiedSince, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_From, arginfo_TElHTTPCustomRequestParams_get_From, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_From, arginfo_TElHTTPCustomRequestParams_set_From, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Username, arginfo_TElHTTPCustomRequestParams_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Username, arginfo_TElHTTPCustomRequestParams_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Password, arginfo_TElHTTPCustomRequestParams_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Password, arginfo_TElHTTPCustomRequestParams_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Referer, arginfo_TElHTTPCustomRequestParams_get_Referer, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Referer, arginfo_TElHTTPCustomRequestParams_set_Referer, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_UserAgent, arginfo_TElHTTPCustomRequestParams_get_UserAgent, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_UserAgent, arginfo_TElHTTPCustomRequestParams_set_UserAgent, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, get_Host, arginfo_TElHTTPCustomRequestParams_get_Host, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, set_Host, arginfo_TElHTTPCustomRequestParams_set_Host, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCustomRequestParams, __construct, arginfo_TElHTTPCustomRequestParams___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPCustomRequestParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPCustomRequestParams_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPCustomRequestParams", TElHTTPCustomRequestParams_methods);
	if (NULL == TElHTTPParams_ce_ptr)
		Register_TElHTTPParams(TSRMLS_C);
	TElHTTPCustomRequestParams_ce_ptr = zend_register_internal_class_ex(&ce, TElHTTPParams_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPMultipartPart_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPMultipartPart, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-331243583, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_ContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_ContentTransferEncoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_ContentTransferEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(405152931, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_ContentTransferEncoding)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_ContentTransferEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_CustomHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPMultipartPart_get_CustomHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPMultipartPart_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_Stream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_CloseStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPMultipartPart_get_CloseStream(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_CloseStream)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_CloseStream(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_FieldName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_FieldName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1817070622, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_FieldName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_FieldName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_FieldValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_FieldValue(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1759445781, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_FieldValue)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_FieldValue(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_Filename)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_Filename(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1821469398, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_Filename)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_Filename(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_ContentID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_ContentID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-923451957, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_ContentID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_ContentID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_ContentDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_ContentDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1426893875, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_ContentDescription)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_ContentDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, get_ContentDisposition)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPMultipartPart_get_ContentDisposition(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1957712757, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, set_ContentDisposition)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartPart_set_ContentDisposition(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartPart, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPMultipartPart_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_ContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_ContentTransferEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_ContentTransferEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_CustomHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_Stream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_CloseStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_CloseStream, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_FieldName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_FieldName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_FieldValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_FieldValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_Filename, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_Filename, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_ContentID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_ContentID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_ContentDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_ContentDescription, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_get_ContentDisposition, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart_set_ContentDisposition, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartPart___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPMultipartPart_methods[] = {
	PHP_ME(TElHTTPMultipartPart, get_ContentType, arginfo_TElHTTPMultipartPart_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_ContentType, arginfo_TElHTTPMultipartPart_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_ContentTransferEncoding, arginfo_TElHTTPMultipartPart_get_ContentTransferEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_ContentTransferEncoding, arginfo_TElHTTPMultipartPart_set_ContentTransferEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_CustomHeaders, arginfo_TElHTTPMultipartPart_get_CustomHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_Stream, arginfo_TElHTTPMultipartPart_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_Stream, arginfo_TElHTTPMultipartPart_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_CloseStream, arginfo_TElHTTPMultipartPart_get_CloseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_CloseStream, arginfo_TElHTTPMultipartPart_set_CloseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_FieldName, arginfo_TElHTTPMultipartPart_get_FieldName, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_FieldName, arginfo_TElHTTPMultipartPart_set_FieldName, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_FieldValue, arginfo_TElHTTPMultipartPart_get_FieldValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_FieldValue, arginfo_TElHTTPMultipartPart_set_FieldValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_Filename, arginfo_TElHTTPMultipartPart_get_Filename, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_Filename, arginfo_TElHTTPMultipartPart_set_Filename, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_ContentID, arginfo_TElHTTPMultipartPart_get_ContentID, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_ContentID, arginfo_TElHTTPMultipartPart_set_ContentID, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_ContentDescription, arginfo_TElHTTPMultipartPart_get_ContentDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_ContentDescription, arginfo_TElHTTPMultipartPart_set_ContentDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, get_ContentDisposition, arginfo_TElHTTPMultipartPart_get_ContentDisposition, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, set_ContentDisposition, arginfo_TElHTTPMultipartPart_set_ContentDisposition, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartPart, __construct, arginfo_TElHTTPMultipartPart___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPMultipartPart(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPMultipartPart_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPMultipartPart", TElHTTPMultipartPart_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElHTTPMultipartPart_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPMultipartList_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPMultipartList, AddFormField)
{
	char *sFieldName;
	char *sFieldValue;
	int sFieldName_len;
	int sFieldValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFieldName, &sFieldName_len, &sFieldValue, &sFieldValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPMultipartList_AddFormField(SBGetObjectHandle(getThis() TSRMLS_CC), sFieldName, (int32_t)sFieldName_len, sFieldValue, (int32_t)sFieldValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, AddFormFile)
{
	char *sContentType;
	char *sFieldName;
	char *sFilename;
	int sContentType_len;
	int sFieldName_len;
	int sFilename_len;
	zend_bool bCloseStream;
	zval *oFileStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!b", &sFieldName, &sFieldName_len, &sFilename, &sFilename_len, &sContentType, &sContentType_len, &oFileStream, TStream_ce_ptr, &bCloseStream) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPMultipartList_AddFormFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFieldName, (int32_t)sFieldName_len, sFilename, (int32_t)sFilename_len, sContentType, (int32_t)sContentType_len, SBGetObjectHandle(oFileStream TSRMLS_CC), (int8_t)bCloseStream, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, AddContentStream)
{
	char *sContentID;
	char *sContentType;
	int sContentID_len;
	int sContentType_len;
	zend_bool bCloseStream;
	zval *oAStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!b", &sContentID, &sContentID_len, &sContentType, &sContentType_len, &oAStream, TStream_ce_ptr, &bCloseStream) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPMultipartList_AddContentStream(SBGetObjectHandle(getThis() TSRMLS_CC), sContentID, (int32_t)sContentID_len, sContentType, (int32_t)sContentType_len, SBGetObjectHandle(oAStream TSRMLS_CC), (int8_t)bCloseStream, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, Add)
{
	zval *oAPart;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPMultipartList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPart, TElHTTPMultipartPart_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPMultipartList_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAPart TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElHTTPMultipartPart)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, Insert)
{
	long l4Index;
	zval *oAPart;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAPart, TElHTTPMultipartPart_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAPart TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElHTTPMultipartPart)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElHTTPMultipartList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPMultipartList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, get_Parts)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPMultipartList_get_Parts(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPMultipartPart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPMultipartList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPMultipartList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_AddFormField, 0, 0, 2)
	ZEND_ARG_INFO(0, FieldName)
	ZEND_ARG_INFO(0, FieldValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_AddFormFile, 0, 0, 5)
	ZEND_ARG_INFO(0, FieldName)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, ContentType)
	ZEND_ARG_OBJ_INFO(0, FileStream, TStream, 1)
	ZEND_ARG_INFO(0, CloseStream)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_AddContentStream, 0, 0, 4)
	ZEND_ARG_INFO(0, ContentID)
	ZEND_ARG_INFO(0, ContentType)
	ZEND_ARG_OBJ_INFO(0, AStream, TStream, 1)
	ZEND_ARG_INFO(0, CloseStream)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_Add, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, APart, TElHTTPMultipartPart, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, APart, TElHTTPMultipartPart, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList_get_Parts, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPMultipartList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPMultipartList_methods[] = {
	PHP_ME(TElHTTPMultipartList, AddFormField, arginfo_TElHTTPMultipartList_AddFormField, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, AddFormFile, arginfo_TElHTTPMultipartList_AddFormFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, AddContentStream, arginfo_TElHTTPMultipartList_AddContentStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, Add, arginfo_TElHTTPMultipartList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, Insert, arginfo_TElHTTPMultipartList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, Delete, arginfo_TElHTTPMultipartList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, Clear, arginfo_TElHTTPMultipartList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, get_Count, arginfo_TElHTTPMultipartList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, get_Parts, arginfo_TElHTTPMultipartList_get_Parts, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPMultipartList, __construct, arginfo_TElHTTPMultipartList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPMultipartList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPMultipartList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPMultipartList", TElHTTPMultipartList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElHTTPMultipartList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPEncodingProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPEncodingProcessor, Initialize)
{
	zend_bool bAsEncoder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAsEncoder) == SUCCESS)
	{
		SBCheckError(TElHTTPEncodingProcessor_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bAsEncoder) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPEncodingProcessor, DecodeData)
{
	int32_t l4ProcessedRaw;
	int8_t bEndReachedRaw;
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zbEndReached;
	zval *zl4Processed;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzz", &zaBuffer, &l4Position, &l4Size, &zl4Processed, &zbEndReached) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Processed) && (IS_LONG == Z_TYPE_P(zl4Processed)) && PZVAL_IS_REF(zbEndReached) && (IS_BOOL == Z_TYPE_P(zbEndReached)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4ProcessedRaw = (int32_t)Z_LVAL_P(zl4Processed);
		bEndReachedRaw = (int8_t)Z_BVAL_P(zbEndReached);
		_err = TElHTTPEncodingProcessor_DecodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, &l4ProcessedRaw, &bEndReachedRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-633398217, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zl4Processed, (long)l4ProcessedRaw);
		ZVAL_BOOL(zbEndReached, (zend_bool)bEndReachedRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &integer, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPEncodingProcessor, EncodeData)
{
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Position, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElHTTPEncodingProcessor_EncodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(489817321, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPEncodingProcessor, get_BytesEncoded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElHTTPEncodingProcessor_get_BytesEncoded(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPEncodingProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPEncodingProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPEncodingProcessor_Initialize, 0, 0, 1)
	ZEND_ARG_INFO(0, AsEncoder)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPEncodingProcessor_DecodeData, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Processed)
	ZEND_ARG_INFO(1, EndReached)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPEncodingProcessor_EncodeData, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPEncodingProcessor_get_BytesEncoded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPEncodingProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPEncodingProcessor_methods[] = {
	PHP_ME(TElHTTPEncodingProcessor, Initialize, arginfo_TElHTTPEncodingProcessor_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPEncodingProcessor, DecodeData, arginfo_TElHTTPEncodingProcessor_DecodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPEncodingProcessor, EncodeData, arginfo_TElHTTPEncodingProcessor_EncodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPEncodingProcessor, get_BytesEncoded, arginfo_TElHTTPEncodingProcessor_get_BytesEncoded, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPEncodingProcessor, __construct, arginfo_TElHTTPEncodingProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPEncodingProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPEncodingProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPEncodingProcessor", TElHTTPEncodingProcessor_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElHTTPEncodingProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPChunkedProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPChunkedProcessor, Initialize)
{
	zend_bool bAsEncoder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAsEncoder) == SUCCESS)
	{
		SBCheckError(TElHTTPChunkedProcessor_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bAsEncoder) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPChunkedProcessor, DecodeData)
{
	int32_t l4ProcessedRaw;
	int8_t bEndReachedRaw;
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zbEndReached;
	zval *zl4Processed;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzz", &zaBuffer, &l4Position, &l4Size, &zl4Processed, &zbEndReached) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Processed) && (IS_LONG == Z_TYPE_P(zl4Processed)) && PZVAL_IS_REF(zbEndReached) && (IS_BOOL == Z_TYPE_P(zbEndReached)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4ProcessedRaw = (int32_t)Z_LVAL_P(zl4Processed);
		bEndReachedRaw = (int8_t)Z_BVAL_P(zbEndReached);
		_err = TElHTTPChunkedProcessor_DecodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, &l4ProcessedRaw, &bEndReachedRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-123412968, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zl4Processed, (long)l4ProcessedRaw);
		ZVAL_BOOL(zbEndReached, (zend_bool)bEndReachedRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &integer, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPChunkedProcessor, EncodeData)
{
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Position, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElHTTPChunkedProcessor_EncodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(355460841, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPChunkedProcessor, EncodeLastData)
{
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Position, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElHTTPChunkedProcessor_EncodeLastData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-516511120, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPChunkedProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPChunkedProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPChunkedProcessor_Initialize, 0, 0, 1)
	ZEND_ARG_INFO(0, AsEncoder)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPChunkedProcessor_DecodeData, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Processed)
	ZEND_ARG_INFO(1, EndReached)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPChunkedProcessor_EncodeData, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPChunkedProcessor_EncodeLastData, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPChunkedProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPChunkedProcessor_methods[] = {
	PHP_ME(TElHTTPChunkedProcessor, Initialize, arginfo_TElHTTPChunkedProcessor_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPChunkedProcessor, DecodeData, arginfo_TElHTTPChunkedProcessor_DecodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPChunkedProcessor, EncodeData, arginfo_TElHTTPChunkedProcessor_EncodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPChunkedProcessor, EncodeLastData, arginfo_TElHTTPChunkedProcessor_EncodeLastData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPChunkedProcessor, __construct, arginfo_TElHTTPChunkedProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPChunkedProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPChunkedProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPChunkedProcessor", TElHTTPChunkedProcessor_methods);
	if (NULL == TElHTTPEncodingProcessor_ce_ptr)
		Register_TElHTTPEncodingProcessor(TSRMLS_C);
	TElHTTPChunkedProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TElHTTPEncodingProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPCompressedProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPCompressedProcessor, Initialize)
{
	zend_bool bAsEncoder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAsEncoder) == SUCCESS)
	{
		SBCheckError(TElHTTPCompressedProcessor_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bAsEncoder) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElHTTPCompressedProcessor_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, DecodeData)
{
	int32_t l4ProcessedRaw;
	int8_t bEndReachedRaw;
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zbEndReached;
	zval *zl4Processed;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzz", &zaBuffer, &l4Position, &l4Size, &zl4Processed, &zbEndReached) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Processed) && (IS_LONG == Z_TYPE_P(zl4Processed)) && PZVAL_IS_REF(zbEndReached) && (IS_BOOL == Z_TYPE_P(zbEndReached)))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4ProcessedRaw = (int32_t)Z_LVAL_P(zl4Processed);
		bEndReachedRaw = (int8_t)Z_BVAL_P(zbEndReached);
		_err = TElHTTPCompressedProcessor_DecodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, &l4ProcessedRaw, &bEndReachedRaw, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(267199522, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		ZVAL_LONG(zl4Processed, (long)l4ProcessedRaw);
		ZVAL_BOOL(zbEndReached, (zend_bool)bEndReachedRaw);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &integer, &bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, EncodeData)
{
	long l4Position;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Position, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElHTTPCompressedProcessor_EncodeData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Position, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1515715728, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, get_Deflated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPCompressedProcessor_get_Deflated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, set_Deflated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElHTTPCompressedProcessor_set_Deflated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, get_Gzipped)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElHTTPCompressedProcessor_get_Gzipped(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, set_Gzipped)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElHTTPCompressedProcessor_set_Gzipped(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHTTPCompressedProcessor_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElHTTPCompressedProcessor_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPCompressedProcessor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPCompressedProcessor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_Initialize, 0, 0, 1)
	ZEND_ARG_INFO(0, AsEncoder)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_DecodeData, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Processed)
	ZEND_ARG_INFO(1, EndReached)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_EncodeData, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Position)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_get_Deflated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_set_Deflated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_get_Gzipped, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_set_Gzipped, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPCompressedProcessor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPCompressedProcessor_methods[] = {
	PHP_ME(TElHTTPCompressedProcessor, Initialize, arginfo_TElHTTPCompressedProcessor_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, Reset, arginfo_TElHTTPCompressedProcessor_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, DecodeData, arginfo_TElHTTPCompressedProcessor_DecodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, EncodeData, arginfo_TElHTTPCompressedProcessor_EncodeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, get_Deflated, arginfo_TElHTTPCompressedProcessor_get_Deflated, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, set_Deflated, arginfo_TElHTTPCompressedProcessor_set_Deflated, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, get_Gzipped, arginfo_TElHTTPCompressedProcessor_get_Gzipped, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, set_Gzipped, arginfo_TElHTTPCompressedProcessor_set_Gzipped, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, get_CompressionLevel, arginfo_TElHTTPCompressedProcessor_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, set_CompressionLevel, arginfo_TElHTTPCompressedProcessor_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPCompressedProcessor, __construct, arginfo_TElHTTPCompressedProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPCompressedProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPCompressedProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPCompressedProcessor", TElHTTPCompressedProcessor_methods);
	if (NULL == TElHTTPEncodingProcessor_ce_ptr)
		Register_TElHTTPEncodingProcessor(TSRMLS_C);
	TElHTTPCompressedProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TElHTTPEncodingProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHTTPUtils_ce_ptr = NULL;

SB_PHP_METHOD(TElHTTPUtils, DateTimeToHTTPTime_Inst)
{
	uint32_t _err;
	zval *dtD;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtD, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPUtils_DateTimeToHTTPTime_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtD TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-501271202, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPUtils, DateTimeToHTTPTime)
{
	uint32_t _err;
	zval *dtD;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtD, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPUtils_DateTimeToHTTPTime(SBGetDateTime(dtD TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-501271202, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPUtils, HTTPTimeToDateTime_Inst)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElHTTPUtils_HTTPTimeToDateTime_1(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPUtils, HTTPTimeToDateTime)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElHTTPUtils_HTTPTimeToDateTime(sS, (int32_t)sS_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHTTPUtils, SetHeaderByName_Inst)
{
	char *sHeader;
	char *sValue;
	int sHeader_len;
	int sValue_len;
	zval *oHeaders;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oHeaders, TStringList_ce_ptr, &sHeader, &sHeader_len, &sValue, &sValue_len) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oHeaders, TElStringList_ce_ptr, &sHeader, &sHeader_len, &sValue, &sValue_len) == SUCCESS)
#endif
	{
		SBCheckError(TElHTTPUtils_SetHeaderByName_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sHeader, (int32_t)sHeader_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, string, string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, string, string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElHTTPUtils, SetHeaderByName)
{
	char *sHeader;
	char *sValue;
	int sHeader_len;
	int sValue_len;
	zval *oHeaders;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oHeaders, TStringList_ce_ptr, &sHeader, &sHeader_len, &sValue, &sValue_len) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oHeaders, TElStringList_ce_ptr, &sHeader, &sHeader_len, &sValue, &sValue_len) == SUCCESS)
#endif
	{
		SBCheckError(TElHTTPUtils_SetHeaderByName(SBGetObjectHandle(oHeaders TSRMLS_CC), sHeader, (int32_t)sHeader_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, string, string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, string, string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElHTTPUtils, GetHeaderByName_Inst)
{
	char *sHeader;
	int sHeader_len;
	uint32_t _err;
	zval *oHeaders;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oHeaders, TStringList_ce_ptr, &sHeader, &sHeader_len) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oHeaders, TElStringList_ce_ptr, &sHeader, &sHeader_len) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPUtils_GetHeaderByName_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sHeader, (int32_t)sHeader_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(273106011, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1832581725, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElHTTPUtils, GetHeaderByName)
{
	char *sHeader;
	int sHeader_len;
	uint32_t _err;
	zval *oHeaders;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oHeaders, TStringList_ce_ptr, &sHeader, &sHeader_len) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oHeaders, TElStringList_ce_ptr, &sHeader, &sHeader_len) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHTTPUtils_GetHeaderByName(SBGetObjectHandle(oHeaders TSRMLS_CC), sHeader, (int32_t)sHeader_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(273106011, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1832581725, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElHTTPUtils, MergeHeaders_Inst)
{
	zval *oSource;
	zval *oTarget;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSource, TStringList_ce_ptr, &oTarget, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSource, TElStringList_ce_ptr, &oTarget, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElHTTPUtils_MergeHeaders_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oTarget TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElHTTPUtils, MergeHeaders)
{
	zval *oSource;
	zval *oTarget;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSource, TStringList_ce_ptr, &oTarget, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSource, TElStringList_ce_ptr, &oTarget, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElHTTPUtils_MergeHeaders(SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oTarget TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElHTTPUtils, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElHTTPUtils_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_DateTimeToHTTPTime_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, D, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_DateTimeToHTTPTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, D, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_HTTPTimeToDateTime_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_HTTPTimeToDateTime, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_SetHeaderByName_Inst, 0, 0, 3)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, Header)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_SetHeaderByName, 0, 0, 3)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, Header)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_GetHeaderByName_Inst, 0, 0, 2)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, Header)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_GetHeaderByName, 0, 0, 2)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, Header)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_MergeHeaders_Inst, 0, 0, 2)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Source, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Target, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Source, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Target, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils_MergeHeaders, 0, 0, 2)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Source, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Target, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Source, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Target, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHTTPUtils___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElHTTPUtils_methods[] = {
	PHP_ME(TElHTTPUtils, DateTimeToHTTPTime_Inst, arginfo_TElHTTPUtils_DateTimeToHTTPTime_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPUtils, DateTimeToHTTPTime, arginfo_TElHTTPUtils_DateTimeToHTTPTime, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElHTTPUtils, HTTPTimeToDateTime_Inst, arginfo_TElHTTPUtils_HTTPTimeToDateTime_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPUtils, HTTPTimeToDateTime, arginfo_TElHTTPUtils_HTTPTimeToDateTime, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElHTTPUtils, SetHeaderByName_Inst, arginfo_TElHTTPUtils_SetHeaderByName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPUtils, SetHeaderByName, arginfo_TElHTTPUtils_SetHeaderByName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElHTTPUtils, GetHeaderByName_Inst, arginfo_TElHTTPUtils_GetHeaderByName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPUtils, GetHeaderByName, arginfo_TElHTTPUtils_GetHeaderByName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElHTTPUtils, MergeHeaders_Inst, arginfo_TElHTTPUtils_MergeHeaders_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElHTTPUtils, MergeHeaders, arginfo_TElHTTPUtils_MergeHeaders, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElHTTPUtils, __construct, arginfo_TElHTTPUtils___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHTTPUtils(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHTTPUtils_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHTTPUtils", TElHTTPUtils_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElHTTPUtils_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBHTTPSCommon, HTTPHeaderGetDelimiter)
{
	int32_t l4EndHeaderIndexRaw;
	long l4Index;
	long l4Length;
	SBArrayZValInfo aiDelimiter;
	SBArrayZValInfo aiHeader;
	uint32_t _err;
	zval *zaDelimiter;
	zval *zaHeader;
	zval *zl4EndHeaderIndex;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzz", &zaHeader, &l4Index, &l4Length, &zaDelimiter, &zl4EndHeaderIndex) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHeader)) || (IS_ARRAY == Z_TYPE_P(zaHeader)) || (IS_NULL == Z_TYPE_P(zaHeader))) && PZVAL_IS_REF(zaDelimiter) && ((IS_STRING == Z_TYPE_P(zaDelimiter)) || (IS_ARRAY == Z_TYPE_P(zaDelimiter))) && PZVAL_IS_REF(zl4EndHeaderIndex) && (IS_LONG == Z_TYPE_P(zl4EndHeaderIndex)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHeader, &aiHeader TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDelimiter, &aiDelimiter TSRMLS_CC)) RETURN_FALSE;
		l4EndHeaderIndexRaw = (int32_t)Z_LVAL_P(zl4EndHeaderIndex);
		_err = SBHTTPSCommon_HTTPHeaderGetDelimiter(aiHeader.data, aiHeader.len, (int32_t)l4Index, (int32_t)l4Length, aiDelimiter.data, &aiDelimiter.len, &l4EndHeaderIndexRaw, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDelimiter, &aiDelimiter TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(569562451, 3, aiDelimiter.data, &aiDelimiter.len) TSRMLS_CC);
			((char *)aiDelimiter.data)[aiDelimiter.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDelimiter);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHeader);
		SBSetByteArrayToZVal(&aiDelimiter, zaDelimiter);
		ZVAL_LONG(zl4EndHeaderIndex, (long)l4EndHeaderIndexRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, &array of byte|string, &integer)" TSRMLS_CC);
	}
}

void Register_SBHTTPSCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBHTTPSCommon, SCannotParseGZHeader, SB_SCannotParseGZHeader, SB_SCannotParseGZHeader);
	SB_REGISTER_STRING_CONSTANT(SBHTTPSCommon, SCannotInflateCompressedData, SB_SCannotInflateCompressedData, SB_SCannotInflateCompressedData);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, ERROR_FACILITY_HTTP, SB_ERROR_FACILITY_HTTP, SB_ERROR_FACILITY_HTTP);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, ERROR_HTTP_PROTOCOL_ERROR_FLAG, SB_ERROR_HTTP_PROTOCOL_ERROR_FLAG, SB_ERROR_HTTP_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_CONNECT_FAILED, SB_HTTP_ERROR_CONNECT_FAILED, SB_HTTP_ERROR_CONNECT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_REQUEST_NOT_COMPLETED, SB_HTTP_ERROR_REQUEST_NOT_COMPLETED, SB_HTTP_ERROR_REQUEST_NOT_COMPLETED);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_INVALID_PROTOCOL_IN_URI, SB_HTTP_ERROR_INVALID_PROTOCOL_IN_URI, SB_HTTP_ERROR_INVALID_PROTOCOL_IN_URI);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_DATETIME_PARSING_ERROR, SB_HTTP_ERROR_DATETIME_PARSING_ERROR, SB_HTTP_ERROR_DATETIME_PARSING_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_COMPRESSION_ERROR, SB_HTTP_ERROR_COMPRESSION_ERROR, SB_HTTP_ERROR_COMPRESSION_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_AUTH_FAILURE, SB_HTTP_ERROR_AUTH_FAILURE, SB_HTTP_ERROR_AUTH_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_CANT_PARSE_RESPONSE, SB_HTTP_ERROR_CANT_PARSE_RESPONSE, SB_HTTP_ERROR_CANT_PARSE_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_CANT_PARSE_REQUEST, SB_HTTP_ERROR_CANT_PARSE_REQUEST, SB_HTTP_ERROR_CANT_PARSE_REQUEST);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_UNKNOWN_TRANSFER_ENCODING, SB_HTTP_ERROR_UNKNOWN_TRANSFER_ENCODING, SB_HTTP_ERROR_UNKNOWN_TRANSFER_ENCODING);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, SB_HTTP_ERROR_TRANSFER_DECODING, SB_HTTP_ERROR_TRANSFER_DECODING, SB_HTTP_ERROR_TRANSFER_DECODING);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, HEAD_CRC, SB_HEAD_CRC, SB_HEAD_CRC);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, EXTRA_FIELD, SB_EXTRA_FIELD, SB_EXTRA_FIELD);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, ORIG_NAME, SB_ORIG_NAME, SB_ORIG_NAME);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, COMMENT, SB_COMMENT, SB_COMMENT);
	SB_REGISTER_LONG_CONSTANT(SBHTTPSCommon, RESERVED, SB_RESERVED, SB_RESERVED);
}

void Register_SBHTTPSCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TGZHeaderSkipped", NULL);
	TGZHeaderSkipped_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TGZHeaderSkipped_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzMagic", 1)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzMethod", 2)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzFlags", 3)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzTimeXFlagsOSCode", 4)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzExtra", 5)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzFileName", 6)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzFileComment", 7)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzCRC", 8)
	SB_DECLARE_CLASS_LONG_CONST(TGZHeaderSkipped_ce_ptr, "gzAll", 9)
	
	INIT_CLASS_ENTRY(ce, "SBHTTPSCommon_TSBHTTPChunkState", NULL);
	SBHTTPSCommon_TSBHTTPChunkState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SBHTTPSCommon_TSBHTTPChunkState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SBHTTPSCommon_TSBHTTPChunkState_ce_ptr, "chSize", 0)
	SB_DECLARE_CLASS_LONG_CONST(SBHTTPSCommon_TSBHTTPChunkState_ce_ptr, "chLineFeed", 1)
	SB_DECLARE_CLASS_LONG_CONST(SBHTTPSCommon_TSBHTTPChunkState_ce_ptr, "chData", 2)
	SB_DECLARE_CLASS_LONG_CONST(SBHTTPSCommon_TSBHTTPChunkState_ce_ptr, "chHeader", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBHTTPMethod", NULL);
	TSBHTTPMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBHTTPMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmGet", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmPost", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmHead", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmOptions", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmDelete", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmTrace", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmPut", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmConnect", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMethod_ce_ptr, "hmCustom", 8)
	
	INIT_CLASS_ENTRY(ce, "TSBHTTPMultipartMode", NULL);
	TSBHTTPMultipartMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBHTTPMultipartMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMultipartMode_ce_ptr, "hmpFormData", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMultipartMode_ce_ptr, "hmpRelated", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBHTTPMultipartMode_ce_ptr, "hmpCustom", 2)
}

void Register_SBHTTPSCommon_Aliases(TSRMLS_D)
{
	if (NULL == TElHTTPParams_ce_ptr)
		Register_TElHTTPParams(TSRMLS_C);
	zend_register_class_alias("ElHTTPParams", TElHTTPParams_ce_ptr);
	if (NULL == TElHTTPCustomRequestParams_ce_ptr)
		Register_TElHTTPCustomRequestParams(TSRMLS_C);
	zend_register_class_alias("ElHTTPCustomRequestParams", TElHTTPCustomRequestParams_ce_ptr);
}
