#include "sbpdfcore.h"

zend_class_entry *TPDFAssembleType_ce_ptr = NULL;

void SB_CALLBACK TSBPDFCreateTemporaryStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream, int8_t * FreeOnClose)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zStream;
	zval * zFreeOnClose;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);
	MAKE_STD_ZVAL(zFreeOnClose);
	ZVAL_BOOL(zFreeOnClose, (zend_bool)*FreeOnClose);

	params[0] = &zSender;
	params[1] = &zStream;
	params[2] = &zFreeOnClose;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	*FreeOnClose = (int8_t)Z_BVAL_P(zFreeOnClose);
	zval_ptr_dtor(&zFreeOnClose);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPDFProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Percent, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zPercent;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPercent);
	ZVAL_LONG(zPercent, (long)Percent);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zPercent;
	params[2] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPercent);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPDFCallbackFuncRaw(void * _ObjectData, TElPDFObjectHandle Obj, int8_t * OutResult)
{
	zval **params[1];
	zval * zObj;
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zObj);
	SBInitObject(zObj, TElPDFObject_ce_ptr, Obj TSRMLS_CC);

	params[0] = &zObj;
	SBCallEvent((zval *)_ObjectData, &pzOutResult, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zObj);
	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

zend_class_entry *TPDFStringEncoding_ce_ptr = NULL;

zend_class_entry *TPDFXrefEntryType_ce_ptr = NULL;

zend_class_entry *TElPDFObject_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFObject, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFObject_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, Write)
{
	zend_bool bAssemble;
	zval *os;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &os, TStream_ce_ptr, &bAssemble) == SUCCESS)
	{
		SBCheckError(TElPDFObject_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(os TSRMLS_CC), (int8_t)bAssemble) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFObject_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1737708713, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, set_Data)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFObject_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_After)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFObject_get_After(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2059913761, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, set_After)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFObject_set_After(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_Between)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFObject_get_Between(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(296474085, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, set_Between)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFObject_set_Between(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_TypeErr)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFObject_get_TypeErr(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_Parent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFObject_get_Parent(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_Offset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPDFObject_get_Offset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPDFObject_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_OrigOffset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPDFObject_get_OrigOffset(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFObject_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFObject_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_Write, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, s, TStream, 1)
	ZEND_ARG_INFO(0, Assemble)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_After, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_set_After, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_Between, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_set_Between, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_TypeErr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_Parent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_Offset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_OrigOffset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFObject_methods[] = {
	PHP_ME(TElPDFObject, CreateCopy, arginfo_TElPDFObject_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, Write, arginfo_TElPDFObject_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_Data, arginfo_TElPDFObject_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, set_Data, arginfo_TElPDFObject_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_After, arginfo_TElPDFObject_get_After, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, set_After, arginfo_TElPDFObject_set_After, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_Between, arginfo_TElPDFObject_get_Between, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, set_Between, arginfo_TElPDFObject_set_Between, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_TypeErr, arginfo_TElPDFObject_get_TypeErr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_Parent, arginfo_TElPDFObject_get_Parent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_Offset, arginfo_TElPDFObject_get_Offset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_Size, arginfo_TElPDFObject_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_OrigOffset, arginfo_TElPDFObject_get_OrigOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, get_Tag, arginfo_TElPDFObject_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, set_Tag, arginfo_TElPDFObject_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFObject, __construct, arginfo_TElPDFObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFObject", TElPDFObject_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFObject_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFFile_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFFile, Add)
{
	zval *ov;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ov, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFFile_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, Clear)
{
	zend_bool bADestroyOwnedObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bADestroyOwnedObjects) == SUCCESS)
	{
		SBCheckError(TElPDFFile_Clear(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bADestroyOwnedObjects) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, Load)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFFile_Load(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, Save)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFFile_Save(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, GetRootObjectIndex)
{
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElPDFObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFFile_GetRootObjectIndex(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, GetLastObjectNum)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFFile_GetLastObjectNum(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, SearchForEOFOffset)
{
	long l8LastPosition;
	zval *of;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &of, TStream_ce_ptr, &l8LastPosition) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPDFFile_SearchForEOFOffset(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(of TSRMLS_CC), (int64_t)l8LastPosition, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, FindObj)
{
	long l4GenNumber;
	long l4ObjNumber;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4ObjNumber, &l4GenNumber) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFFile_FindObj(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ObjNumber, (int32_t)l4GenNumber, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFRef_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, GetXRefEntry)
{
	long l4GenNumber;
	long l4ObjNumber;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4ObjNumber, &l4GenNumber) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFFile_GetXRefEntry(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ObjNumber, (int32_t)l4GenNumber, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFXrefEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_Stream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFFile_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_Stream)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_Root)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFFile_get_Root(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_Trailer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFFile_get_Trailer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFDictionary_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_Trailer)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPDFDictionary_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_Trailer(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFFile_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_Version)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_AssembleType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TPDFAssembleTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPDFFile_get_AssembleType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_AssembleType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_AssembleType(SBGetObjectHandle(getThis() TSRMLS_CC), (TPDFAssembleTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_PromptReassemble)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFFile_get_PromptReassemble(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_PromptReassemble)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_PromptReassemble(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_XRefStreamsUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFFile_get_XRefStreamsUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_ContainsObjectStreams)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFFile_get_ContainsObjectStreams(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_SkipObjLoadingFromObjStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFFile_get_SkipObjLoadingFromObjStream(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_SkipObjLoadingFromObjStream)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_SkipObjLoadingFromObjStream(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_Encrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFFile_get_Encrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_NewLine)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFFile_get_NewLine(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1014153039, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_NewLine)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPDFFile_set_NewLine(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_OnCreateTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFCreateTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFFile_get_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_OnCreateTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFFile_set_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFCreateTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFCreateTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFFile_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFFile_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, get_OnDecryptStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPDFCallbackFunc pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPDFFile_get_OnDecryptStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, set_OnDecryptStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPDFFile_set_OnDecryptStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPDFCallbackFuncRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPDFCallbackFunc|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFFile, __construct)
{
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFFile_Create(SBGetObjectHandle(oaStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, v, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_Clear, 0, 0, 1)
	ZEND_ARG_INFO(0, ADestroyOwnedObjects)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_Load, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_Save, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_GetRootObjectIndex, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_GetLastObjectNum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_SearchForEOFOffset, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, f, TStream, 1)
	ZEND_ARG_INFO(0, LastPosition)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_FindObj, 0, 0, 2)
	ZEND_ARG_INFO(0, ObjNumber)
	ZEND_ARG_INFO(0, GenNumber)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_GetXRefEntry, 0, 0, 2)
	ZEND_ARG_INFO(0, ObjNumber)
	ZEND_ARG_INFO(0, GenNumber)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_Stream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_Root, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_Trailer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_Trailer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPDFDictionary, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_AssembleType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_AssembleType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_PromptReassemble, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_PromptReassemble, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_XRefStreamsUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_ContainsObjectStreams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_SkipObjLoadingFromObjStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_SkipObjLoadingFromObjStream, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_Encrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_NewLine, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_NewLine, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_OnCreateTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_OnCreateTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_get_OnDecryptStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile_set_OnDecryptStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFFile___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFFile_methods[] = {
	PHP_ME(TElPDFFile, Add, arginfo_TElPDFFile_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, Clear, arginfo_TElPDFFile_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, Load, arginfo_TElPDFFile_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, Save, arginfo_TElPDFFile_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, GetRootObjectIndex, arginfo_TElPDFFile_GetRootObjectIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, GetLastObjectNum, arginfo_TElPDFFile_GetLastObjectNum, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, SearchForEOFOffset, arginfo_TElPDFFile_SearchForEOFOffset, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, FindObj, arginfo_TElPDFFile_FindObj, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, GetXRefEntry, arginfo_TElPDFFile_GetXRefEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_Stream, arginfo_TElPDFFile_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_Stream, arginfo_TElPDFFile_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_Root, arginfo_TElPDFFile_get_Root, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_Trailer, arginfo_TElPDFFile_get_Trailer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_Trailer, arginfo_TElPDFFile_set_Trailer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_Version, arginfo_TElPDFFile_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_Version, arginfo_TElPDFFile_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_AssembleType, arginfo_TElPDFFile_get_AssembleType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_AssembleType, arginfo_TElPDFFile_set_AssembleType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_PromptReassemble, arginfo_TElPDFFile_get_PromptReassemble, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_PromptReassemble, arginfo_TElPDFFile_set_PromptReassemble, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_XRefStreamsUsed, arginfo_TElPDFFile_get_XRefStreamsUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_ContainsObjectStreams, arginfo_TElPDFFile_get_ContainsObjectStreams, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_SkipObjLoadingFromObjStream, arginfo_TElPDFFile_get_SkipObjLoadingFromObjStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_SkipObjLoadingFromObjStream, arginfo_TElPDFFile_set_SkipObjLoadingFromObjStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_Encrypted, arginfo_TElPDFFile_get_Encrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_NewLine, arginfo_TElPDFFile_get_NewLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_NewLine, arginfo_TElPDFFile_set_NewLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_OnCreateTemporaryStream, arginfo_TElPDFFile_get_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_OnCreateTemporaryStream, arginfo_TElPDFFile_set_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_OnProgress, arginfo_TElPDFFile_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_OnProgress, arginfo_TElPDFFile_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, get_OnDecryptStream, arginfo_TElPDFFile_get_OnDecryptStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, set_OnDecryptStream, arginfo_TElPDFFile_set_OnDecryptStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFFile, __construct, arginfo_TElPDFFile___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFFile(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFFile_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFFile", TElPDFFile_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFFile_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFNull_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFNull, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFNull_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFNull, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFNull_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFNull_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFNull___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFNull_methods[] = {
	PHP_ME(TElPDFNull, CreateCopy, arginfo_TElPDFNull_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFNull, __construct, arginfo_TElPDFNull___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFNull(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFNull_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFNull", TElPDFNull_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFNull_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFBoolean_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFBoolean, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFBoolean_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFBoolean, get_Bool)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFBoolean_get_Bool(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFBoolean, set_Bool)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFBoolean_set_Bool(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFBoolean, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFBoolean_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFBoolean_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFBoolean_get_Bool, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFBoolean_set_Bool, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFBoolean___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFBoolean_methods[] = {
	PHP_ME(TElPDFBoolean, CreateCopy, arginfo_TElPDFBoolean_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFBoolean, get_Bool, arginfo_TElPDFBoolean_get_Bool, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFBoolean, set_Bool, arginfo_TElPDFBoolean_set_Bool, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFBoolean, __construct, arginfo_TElPDFBoolean___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFBoolean(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFBoolean_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFBoolean", TElPDFBoolean_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFBoolean_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFReal_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFReal, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFReal_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFReal, get_RealValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElPDFReal_get_RealValue(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFReal, set_RealValue)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElPDFReal_set_RealValue(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFReal, get_IntValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFReal_get_IntValue(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFReal, set_IntValue)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFReal_set_IntValue(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFReal, get_IsInt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFReal_get_IsInt(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFReal, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFReal_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal_get_RealValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal_set_RealValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal_get_IntValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal_set_IntValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal_get_IsInt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFReal___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFReal_methods[] = {
	PHP_ME(TElPDFReal, CreateCopy, arginfo_TElPDFReal_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFReal, get_RealValue, arginfo_TElPDFReal_get_RealValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFReal, set_RealValue, arginfo_TElPDFReal_set_RealValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFReal, get_IntValue, arginfo_TElPDFReal_get_IntValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFReal, set_IntValue, arginfo_TElPDFReal_set_IntValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFReal, get_IsInt, arginfo_TElPDFReal_get_IsInt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFReal, __construct, arginfo_TElPDFReal___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFReal(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFReal_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFReal", TElPDFReal_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFReal_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFString_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFString, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFString_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, get_Str)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFString_get_Str(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1093416304, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, set_Str)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPDFString_set_Str(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, get_OrigStr)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFString_get_OrigStr(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(758242762, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, set_OrigStr)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPDFString_set_OrigStr(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, get_Encoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TPDFStringEncodingRaw fOutResultRaw = 0;
		SBCheckError(TElPDFString_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, set_Encoding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPDFString_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), (TPDFStringEncodingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFString, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFString_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_get_Str, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_set_Str, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_get_OrigStr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_set_OrigStr, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFString___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFString_methods[] = {
	PHP_ME(TElPDFString, CreateCopy, arginfo_TElPDFString_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, get_Str, arginfo_TElPDFString_get_Str, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, set_Str, arginfo_TElPDFString_set_Str, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, get_OrigStr, arginfo_TElPDFString_get_OrigStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, set_OrigStr, arginfo_TElPDFString_set_OrigStr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, get_Encoding, arginfo_TElPDFString_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, set_Encoding, arginfo_TElPDFString_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFString, __construct, arginfo_TElPDFString___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFString(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFString_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFString", TElPDFString_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFString_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFComment_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFComment, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFComment_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFComment, get_Comment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFComment_get_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1843861475, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFComment, set_Comment)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFComment_set_Comment(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFComment, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFComment_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFComment_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFComment_get_Comment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFComment_set_Comment, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFComment___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFComment_methods[] = {
	PHP_ME(TElPDFComment, CreateCopy, arginfo_TElPDFComment_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFComment, get_Comment, arginfo_TElPDFComment_get_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFComment, set_Comment, arginfo_TElPDFComment_set_Comment, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFComment, __construct, arginfo_TElPDFComment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFComment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFComment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFComment", TElPDFComment_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFComment_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFName_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFName, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFName_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFName, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFName_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(79070548, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFName, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPDFName_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFName, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFName_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFName_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFName_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFName_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFName___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFName_methods[] = {
	PHP_ME(TElPDFName, CreateCopy, arginfo_TElPDFName_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFName, get_Name, arginfo_TElPDFName_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFName, set_Name, arginfo_TElPDFName_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFName, __construct, arginfo_TElPDFName___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFName(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFName_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFName", TElPDFName_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFName_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFCpxObj_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFCpxObj, get_Before)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFCpxObj_get_Before(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2028947625, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFCpxObj, set_Before)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFCpxObj_set_Before(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFCpxObj, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFCpxObj_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFCpxObj_get_Before, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFCpxObj_set_Before, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFCpxObj___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFCpxObj_methods[] = {
	PHP_ME(TElPDFCpxObj, get_Before, arginfo_TElPDFCpxObj_get_Before, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFCpxObj, set_Before, arginfo_TElPDFCpxObj_set_Before, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFCpxObj, __construct, arginfo_TElPDFCpxObj___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFCpxObj(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFCpxObj_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFCpxObj", TElPDFCpxObj_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFCpxObj_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFArray_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFArray, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFArray_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, Add)
{
	zval *ov;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ov, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFArray_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, Insert)
{
	long l4Position;
	zval *ov;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &ov, TElPDFObject_ce_ptr, &l4Position) == SUCCESS)
	{
		SBCheckError(TElPDFArray_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(ov TSRMLS_CC), (int32_t)l4Position) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFObject, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, Remove)
{
	zval *ov;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ov, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFArray_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFArray_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, get_Items)
{
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFArray_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, set_Items)
{
	long l8Index;
	zval *ov;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l8Index, &ov, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFArray_set_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPDFArray_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, get_Render)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFArray_get_Render(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, set_Render)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPDFArray_set_Render(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFArray, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFArray_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, v, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_Insert, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, v, TElPDFObject, 1)
	ZEND_ARG_INFO(0, Position)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, v, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_set_Items, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, v, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_get_Render, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray_set_Render, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFArray___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFArray_methods[] = {
	PHP_ME(TElPDFArray, CreateCopy, arginfo_TElPDFArray_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, Add, arginfo_TElPDFArray_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, Insert, arginfo_TElPDFArray_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, Remove, arginfo_TElPDFArray_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, Clear, arginfo_TElPDFArray_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, get_Items, arginfo_TElPDFArray_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, set_Items, arginfo_TElPDFArray_set_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, get_Count, arginfo_TElPDFArray_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, get_Render, arginfo_TElPDFArray_get_Render, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, set_Render, arginfo_TElPDFArray_set_Render, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFArray, __construct, arginfo_TElPDFArray___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFArray_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFArray", TElPDFArray_methods);
	if (NULL == TElPDFCpxObj_ce_ptr)
		Register_TElPDFCpxObj(TSRMLS_C);
	TElPDFArray_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFCpxObj_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFDictionary_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFDictionary, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFDictionary_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, Add)
{
	char *sName;
	int sName_len;
	SBArrayZValInfo aiName;
	zval *ov;
	zval *zaName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaName, &ov, TElPDFObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaName)) || (IS_ARRAY == Z_TYPE_P(zaName)) || (IS_NULL == Z_TYPE_P(zaName))))
	{
		if (!SBGetByteArrayFromZVal(zaName, &aiName TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFDictionary_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiName.data, aiName.len, SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiName);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sName, &sName_len, &ov, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &ov, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(ov TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElPDFObject) or (string, TElPDFObject) or (TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, GetItemByName)
{
	char *sS;
	int sS_len;
	SBArrayZValInfo aiName;
	zval *zaName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaName) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaName)) || (IS_ARRAY == Z_TYPE_P(zaName)) || (IS_NULL == Z_TYPE_P(zaName))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaName, &aiName TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFDictionary_GetItemByName(SBGetObjectHandle(getThis() TSRMLS_CC), aiName.data, aiName.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiName);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFDictionary_GetItemByName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, SetItemByName)
{
	char *sS;
	int sS_len;
	SBArrayZValInfo aiName;
	zval *oItem;
	zval *zaName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaName, &oItem, TElPDFObject_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaName)) || (IS_ARRAY == Z_TYPE_P(zaName)) || (IS_NULL == Z_TYPE_P(zaName))))
	{
		if (!SBGetByteArrayFromZVal(zaName, &aiName TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFDictionary_SetItemByName(SBGetObjectHandle(getThis() TSRMLS_CC), aiName.data, aiName.len, SBGetObjectHandle(oItem TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiName);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sS, &sS_len, &oItem, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_SetItemByName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, SBGetObjectHandle(oItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElPDFObject) or (string, TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, AddString)
{
	char *sData;
	char *sName;
	int sData_len;
	int sName_len;
	long fEnc;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslb", &sName, &sName_len, &sData, &sData_len, &fEnc, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_AddString(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sData, (int32_t)sData_len, (TPDFStringEncodingRaw)fEnc, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, AddName)
{
	char *sData;
	char *sName;
	int sData_len;
	int sName_len;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sName, &sName_len, &sData, &sData_len, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_AddName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sData, (int32_t)sData_len, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, AddInt)
{
	char *sName;
	int sName_len;
	long l8Value;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slb", &sName, &sName_len, &l8Value, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_AddInt(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int64_t)l8Value, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, AddBoolean)
{
	char *sName;
	int sName_len;
	zend_bool bOverwrite;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbb", &sName, &sName_len, &bValue, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_AddBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, AddReal)
{
	char *sName;
	double dValue;
	int sName_len;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sdb", &sName, &sName_len, &dValue, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_AddReal(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (double)dValue, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, double, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, AddRect)
{
	char *sName;
	int sName_len;
	long l4X1;
	long l4X2;
	long l4Y1;
	long l4Y2;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllllb", &sName, &sName_len, &l4X1, &l4Y1, &l4X2, &l4Y2, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_AddRect(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4X1, (int32_t)l4Y1, (int32_t)l4X2, (int32_t)l4Y2, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, RemoveItemByName)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		SBCheckError(TElPDFDictionary_RemoveItemByName(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, get_Names)
{
	long l8Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPDFDictionary_get_Names(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(780665126, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFDictionary, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFDictionary_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Name_or_v, 0, 1)
	ZEND_ARG_OBJ_INFO(0, v, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_GetItemByName, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Name_or_S, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_SetItemByName, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Name_or_S, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Item, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_AddString, 0, 0, 4)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Enc)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_AddName, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_AddInt, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_AddBoolean, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_AddReal, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_AddRect, 0, 0, 6)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, X1)
	ZEND_ARG_INFO(0, Y1)
	ZEND_ARG_INFO(0, X2)
	ZEND_ARG_INFO(0, Y2)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_RemoveItemByName, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary_get_Names, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFDictionary___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFDictionary_methods[] = {
	PHP_ME(TElPDFDictionary, CreateCopy, arginfo_TElPDFDictionary_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, Add, arginfo_TElPDFDictionary_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, GetItemByName, arginfo_TElPDFDictionary_GetItemByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, SetItemByName, arginfo_TElPDFDictionary_SetItemByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, AddString, arginfo_TElPDFDictionary_AddString, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, AddName, arginfo_TElPDFDictionary_AddName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, AddInt, arginfo_TElPDFDictionary_AddInt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, AddBoolean, arginfo_TElPDFDictionary_AddBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, AddReal, arginfo_TElPDFDictionary_AddReal, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, AddRect, arginfo_TElPDFDictionary_AddRect, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, RemoveItemByName, arginfo_TElPDFDictionary_RemoveItemByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, get_Names, arginfo_TElPDFDictionary_get_Names, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFDictionary, __construct, arginfo_TElPDFDictionary___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFDictionary(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFDictionary_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFDictionary", TElPDFDictionary_methods);
	if (NULL == TElPDFArray_ce_ptr)
		Register_TElPDFArray(TSRMLS_C);
	TElPDFDictionary_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFArray_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFStream_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFStream, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFStream_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, Write)
{
	zend_bool bAssemble;
	zval *os;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &os, TStream_ce_ptr, &bAssemble) == SUCCESS)
	{
		SBCheckError(TElPDFStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(os TSRMLS_CC), (int8_t)bAssemble) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFStream_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1784188018, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, set_Data)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFStream_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, set_CR2)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFStream_set_CR2(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, get_Stream)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFStream_get_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(575874293, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, set_Stream)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFStream_set_Stream(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, get_DecompressedStream)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFStream_get_DecompressedStream(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(561794007, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, get_Dict)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFStream_get_Dict(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFDictionary_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, set_Dict)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPDFDictionary_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFStream_set_Dict(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, get_OrigStream)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPDFStream_get_OrigStream(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-700377368, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, set_OrigStream)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPDFStream_set_OrigStream(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFStream, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFStream_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_Write, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, s, TStream, 1)
	ZEND_ARG_INFO(0, Assemble)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_set_CR2, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_get_Stream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_set_Stream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_get_DecompressedStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_get_Dict, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_set_Dict, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPDFDictionary, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_get_OrigStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream_set_OrigStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFStream___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFStream_methods[] = {
	PHP_ME(TElPDFStream, CreateCopy, arginfo_TElPDFStream_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, Write, arginfo_TElPDFStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, get_Data, arginfo_TElPDFStream_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, set_Data, arginfo_TElPDFStream_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, set_CR2, arginfo_TElPDFStream_set_CR2, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, get_Stream, arginfo_TElPDFStream_get_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, set_Stream, arginfo_TElPDFStream_set_Stream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, get_DecompressedStream, arginfo_TElPDFStream_get_DecompressedStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, get_Dict, arginfo_TElPDFStream_get_Dict, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, set_Dict, arginfo_TElPDFStream_set_Dict, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, get_OrigStream, arginfo_TElPDFStream_get_OrigStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, set_OrigStream, arginfo_TElPDFStream_set_OrigStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFStream, __construct, arginfo_TElPDFStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFStream", TElPDFStream_methods);
	if (NULL == TElPDFCpxObj_ce_ptr)
		Register_TElPDFCpxObj(TSRMLS_C);
	TElPDFStream_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFCpxObj_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFIndirect_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFIndirect, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFIndirect_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, XrefAdd)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFIndirect_XrefAdd(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, XrefAddOnce)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFIndirect_XrefAddOnce(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, XrefFree)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFIndirect_XrefFree(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, get_ObjNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFIndirect_get_ObjNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, set_ObjNumber)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFIndirect_set_ObjNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, get_GenNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFIndirect_get_GenNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, set_GenNumber)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFIndirect_set_GenNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, get_Obj)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFIndirect_get_Obj(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, set_Obj)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPDFObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFIndirect_set_Obj(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, get_XrefAdded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFIndirect_get_XrefAdded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFIndirect, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFIndirect_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_XrefAdd, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_XrefAddOnce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_XrefFree, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_get_ObjNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_set_ObjNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_get_GenNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_set_GenNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_get_Obj, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_set_Obj, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPDFObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect_get_XrefAdded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFIndirect___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFIndirect_methods[] = {
	PHP_ME(TElPDFIndirect, CreateCopy, arginfo_TElPDFIndirect_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, XrefAdd, arginfo_TElPDFIndirect_XrefAdd, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, XrefAddOnce, arginfo_TElPDFIndirect_XrefAddOnce, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, XrefFree, arginfo_TElPDFIndirect_XrefFree, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, get_ObjNumber, arginfo_TElPDFIndirect_get_ObjNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, set_ObjNumber, arginfo_TElPDFIndirect_set_ObjNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, get_GenNumber, arginfo_TElPDFIndirect_get_GenNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, set_GenNumber, arginfo_TElPDFIndirect_set_GenNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, get_Obj, arginfo_TElPDFIndirect_get_Obj, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, set_Obj, arginfo_TElPDFIndirect_set_Obj, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, get_XrefAdded, arginfo_TElPDFIndirect_get_XrefAdded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFIndirect, __construct, arginfo_TElPDFIndirect___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFIndirect(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFIndirect_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFIndirect", TElPDFIndirect_methods);
	if (NULL == TElPDFCpxObj_ce_ptr)
		Register_TElPDFCpxObj(TSRMLS_C);
	TElPDFIndirect_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFCpxObj_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFRef_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFRef, CreateCopy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFRef_CreateCopy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, SetNumbers)
{
	long l4GenNum;
	long l4ObjNum;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4ObjNum, &l4GenNum) == SUCCESS)
	{
		SBCheckError(TElPDFRef_SetNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ObjNum, (int32_t)l4GenNum) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, get_ObjNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFRef_get_ObjNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, set_ObjNumber)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFRef_set_ObjNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, get_GenNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFRef_get_GenNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, set_GenNumber)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPDFRef_set_GenNumber(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, get_Obj)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFRef_get_Obj(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFIndirect_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, get_Loaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPDFRef_get_Loaded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFRef, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFRef_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_CreateCopy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_SetNumbers, 0, 0, 2)
	ZEND_ARG_INFO(0, ObjNum)
	ZEND_ARG_INFO(0, GenNum)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_get_ObjNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_set_ObjNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_get_GenNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_set_GenNumber, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_get_Obj, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef_get_Loaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFRef___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFRef_methods[] = {
	PHP_ME(TElPDFRef, CreateCopy, arginfo_TElPDFRef_CreateCopy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, SetNumbers, arginfo_TElPDFRef_SetNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, get_ObjNumber, arginfo_TElPDFRef_get_ObjNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, set_ObjNumber, arginfo_TElPDFRef_set_ObjNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, get_GenNumber, arginfo_TElPDFRef_get_GenNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, set_GenNumber, arginfo_TElPDFRef_set_GenNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, get_Obj, arginfo_TElPDFRef_get_Obj, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, get_Loaded, arginfo_TElPDFRef_get_Loaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFRef, __construct, arginfo_TElPDFRef___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFRef_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFRef", TElPDFRef_methods);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	TElPDFRef_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFXRef_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFXRef, get_Trailer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFXRef_get_Trailer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFDictionary_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRef, set_Trailer)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPDFDictionary_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPDFXRef_set_Trailer(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRef, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFXRef_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRef_get_Trailer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRef_set_Trailer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPDFDictionary, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRef___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFXRef_methods[] = {
	PHP_ME(TElPDFXRef, get_Trailer, arginfo_TElPDFXRef_get_Trailer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRef, set_Trailer, arginfo_TElPDFXRef_set_Trailer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRef, __construct, arginfo_TElPDFXRef___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFXRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFXRef_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFXRef", TElPDFXRef_methods);
	if (NULL == TElPDFCpxObj_ce_ptr)
		Register_TElPDFCpxObj(TSRMLS_C);
	TElPDFXRef_ce_ptr = zend_register_internal_class_ex(&ce, TElPDFCpxObj_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFXrefEntry_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFXrefEntry, get_EntryType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TPDFXrefEntryTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPDFXrefEntry_get_EntryType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXrefEntry, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFXrefEntry_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXrefEntry_get_EntryType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXrefEntry___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFXrefEntry_methods[] = {
	PHP_ME(TElPDFXrefEntry, get_EntryType, arginfo_TElPDFXrefEntry_get_EntryType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXrefEntry, __construct, arginfo_TElPDFXrefEntry___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFXrefEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFXrefEntry_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFXrefEntry", TElPDFXrefEntry_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFXrefEntry_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPDFXRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElPDFXRefs, AddXRef)
{
	long l4GenNumber;
	long l4ObjNumber;
	long l4StreamObjIndex;
	long l4StreamObjNumber;
	long l8Offset;
	zend_bool bOverwriteIfExists;
	zend_bool bRaiseExceptionIfExists;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllbb", &l4ObjNumber, &l4GenNumber, &l8Offset, &bRaiseExceptionIfExists, &bOverwriteIfExists) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFXRefs_AddXRef(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ObjNumber, (int32_t)l4GenNumber, (int64_t)l8Offset, (int8_t)bRaiseExceptionIfExists, (int8_t)bOverwriteIfExists, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llllbb", &l4ObjNumber, &l4GenNumber, &l4StreamObjNumber, &l4StreamObjIndex, &bRaiseExceptionIfExists, &bOverwriteIfExists) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFXRefs_AddXRef_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ObjNumber, (int32_t)l4GenNumber, (int32_t)l4StreamObjNumber, (int32_t)l4StreamObjIndex, (int8_t)bRaiseExceptionIfExists, (int8_t)bOverwriteIfExists, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, bool, bool) or (integer, integer, integer, integer, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRefs, RemoveXRef)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElPDFXRefs_RemoveXRef(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPDFXRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRefs, Find)
{
	long l4GenNumber;
	long l4ObjNumber;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4ObjNumber, &l4GenNumber) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFXRefs_Find(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ObjNumber, (int32_t)l4GenNumber, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRefs, get_XRefs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFXRefs_get_XRefs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFXrefEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRefs, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPDFXRefs_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPDFXRefs, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPDFXRefs_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs_AddXRef, 0, 0, 5)
	ZEND_ARG_INFO(0, ObjNumber)
	ZEND_ARG_INFO(0, GenNumber)
	ZEND_ARG_INFO(0, Offset_or_StreamObjNumber)
	ZEND_ARG_INFO(0, RaiseExceptionIfExists_or_StreamObjIndex)
	ZEND_ARG_INFO(0, OverwriteIfExists_or_RaiseExceptionIfExists)
	ZEND_ARG_INFO(0, OverwriteIfExists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs_RemoveXRef, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs_Find, 0, 0, 2)
	ZEND_ARG_INFO(0, ObjNumber)
	ZEND_ARG_INFO(0, GenNumber)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs_get_XRefs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPDFXRefs___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElPDFFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPDFXRefs_methods[] = {
	PHP_ME(TElPDFXRefs, AddXRef, arginfo_TElPDFXRefs_AddXRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRefs, RemoveXRef, arginfo_TElPDFXRefs_RemoveXRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRefs, Clear, arginfo_TElPDFXRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRefs, Find, arginfo_TElPDFXRefs_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRefs, get_XRefs, arginfo_TElPDFXRefs_get_XRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRefs, get_Count, arginfo_TElPDFXRefs_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElPDFXRefs, __construct, arginfo_TElPDFXRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPDFXRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPDFXRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPDFXRefs", TElPDFXRefs_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPDFXRefs_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPDFCore, GetNameObjectFromDictionary)
{
	char *sDefault;
	char *sName;
	int sDefault_len;
	int sName_len;
	uint32_t _err;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &sDefault, &sDefault_len, &bRaiseException) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPDFCore_GetNameObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, sDefault, (int32_t)sDefault_len, (int8_t)bRaiseException, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-565889885, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetIntObjectFromDictionary)
{
	char *sName;
	int sName_len;
	long l4Default;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &l4Default, &bRaiseException) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBPDFCore_GetIntObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Default, (int8_t)bRaiseException, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetRealObjectFromDictionary)
{
	char *sName;
	double dDefault;
	int sName_len;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sdb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &dDefault, &bRaiseException) == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(SBPDFCore_GetRealObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (double)dDefault, (int8_t)bRaiseException, &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, double, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetStringObjectFromDictionary)
{
	char *sName;
	int sName_len;
	uint32_t _err;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &bRaiseException) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPDFCore_GetStringObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bRaiseException, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1690467249, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetArrayObjectFromDictionary)
{
	char *sName;
	int sName_len;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &bRaiseException) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPDFCore_GetArrayObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bRaiseException, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetDictionaryObjectFromDictionary)
{
	char *sName;
	int sName_len;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &bRaiseException) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPDFCore_GetDictionaryObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bRaiseException, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFDictionary_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetBooleanObjectFromDictionary)
{
	char *sName;
	int sName_len;
	zend_bool bDefault;
	zend_bool bRaiseException;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sbb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &bDefault, &bRaiseException) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBPDFCore_GetBooleanObjectFromDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bDefault, (int8_t)bRaiseException, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddRealObjectToDictionary)
{
	char *sName;
	double dValue;
	int sName_len;
	zend_bool bOverwrite;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sd", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &dValue) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddRealObjectToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (double)dValue) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sdb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &dValue, &bOverwrite) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddRealObjectToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (double)dValue, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, double) or (TElPDFDictionary, string, double, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddIntObjectToDictionary)
{
	char *sName;
	int sName_len;
	long l4Value;
	zend_bool bOverwrite;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &l4Value) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddIntObjectToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Value) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &l4Value, &bOverwrite) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddIntObjectToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Value, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, integer) or (TElPDFDictionary, string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddBooleanObjectToDictionary)
{
	char *sName;
	int sName_len;
	zend_bool bOverwrite;
	zend_bool bValue;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &bValue) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddBooleanObjectToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sbb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &bValue, &bOverwrite) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddBooleanObjectToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, bool) or (TElPDFDictionary, string, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddStringObjectToDictionary)
{
	char *sName;
	int sName_len;
	long fEnc;
	SBArrayZValInfo aiValue;
	zend_bool bOverwrite;
	zval *oDict;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!szl", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &zaValue, &fEnc) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPDFCore_AddStringObjectToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, aiValue.data, aiValue.len, (TPDFStringEncodingRaw)fEnc, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		SBInitObject(return_value, TElPDFString_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!szlb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &zaValue, &fEnc, &bOverwrite) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPDFCore_AddStringObjectToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, aiValue.data, aiValue.len, (TPDFStringEncodingRaw)fEnc, (int8_t)bOverwrite) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, array of byte|string|NULL, integer) or (TElPDFDictionary, string, array of byte|string|NULL, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddNameObjectToDictionary)
{
	char *sName;
	char *sValue;
	int sName_len;
	int sValue_len;
	zend_bool bOverwrite;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddNameObjectToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &sValue, &sValue_len, &bOverwrite) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddNameObjectToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, string) or (TElPDFDictionary, string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddRectangleObjectToDictionary)
{
	char *sName;
	int sName_len;
	long l4X1;
	long l4X2;
	long l4Y1;
	long l4Y2;
	zend_bool bOverwrite;
	zval *oDict;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sllll", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &l4X1, &l4Y1, &l4X2, &l4Y2) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPDFCore_AddRectangleObjectToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4X1, (int32_t)l4Y1, (int32_t)l4X2, (int32_t)l4Y2, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFArray_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sllllb", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &l4X1, &l4Y1, &l4X2, &l4Y2, &bOverwrite) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddRectangleObjectToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4X1, (int32_t)l4Y1, (int32_t)l4X2, (int32_t)l4Y2, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, integer, integer, integer, integer) or (TElPDFDictionary, string, integer, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddReferenceToDictionary)
{
	char *sName;
	int sName_len;
	zend_bool bOverwrite;
	zval *oDict;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &oObj, TElPDFRef_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddReferenceToDictionary(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!b", &oDict, TElPDFDictionary_ce_ptr, &sName, &sName_len, &oObj, TElPDFRef_ce_ptr, &bOverwrite) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddReferenceToDictionary_1(SBGetObjectHandle(oDict TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oObj TSRMLS_CC), (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, string, TElPDFRef) or (TElPDFDictionary, string, TElPDFRef, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddRealObjectToArray)
{
	double dValue;
	zval *oArr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!d", &oArr, TElPDFArray_ce_ptr, &dValue) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddRealObjectToArray(SBGetObjectHandle(oArr TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFArray, double)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddIntObjectToArray)
{
	long l4Value;
	zval *oArr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oArr, TElPDFArray_ce_ptr, &l4Value) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddIntObjectToArray(SBGetObjectHandle(oArr TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFArray, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddNameObjectToArray)
{
	char *sValue;
	int sValue_len;
	zval *oArr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oArr, TElPDFArray_ce_ptr, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(SBPDFCore_AddNameObjectToArray(SBGetObjectHandle(oArr TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFArray, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, AddStringObjectToArray)
{
	long fEnc;
	SBArrayZValInfo aiValue;
	zval *oArr;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zl", &oArr, TElPDFArray_ce_ptr, &zaValue, &fEnc) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPDFCore_AddStringObjectToArray(SBGetObjectHandle(oArr TSRMLS_CC), aiValue.data, aiValue.len, (TPDFStringEncodingRaw)fEnc) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFArray, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, CreateStream)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElPDFFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBPDFCore_CreateStream(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPDFStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFFile)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, CompressStream)
{
	zend_bool bAddCRLF;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStrm, TElPDFStream_ce_ptr, &bAddCRLF) == SUCCESS)
	{
		SBCheckError(SBPDFCore_CompressStream(SBGetObjectHandle(oStrm TSRMLS_CC), (int8_t)bAddCRLF) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, EncodePDFDate)
{
	uint32_t _err;
	zend_bool bAddUTCPostfix;
	zval *dtD;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtD, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPDFCore_EncodePDFDate(SBGetDateTime(dtD TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-807044135, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &dtD, php_date_get_date_ce(), &bAddUTCPostfix) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBPDFCore_EncodePDFDate_1(SBGetDateTime(dtD TSRMLS_CC), (int8_t)bAddUTCPostfix, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1321059517, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime) or (DateTime, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, DecodePDFDate)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBPDFCore_DecodePDFDate(sS, (int32_t)sS_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, EncodeTextString)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPDFCore_EncodeTextString(sStr, (int32_t)sStr_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1131210513, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, EncodeTextStringUnicode)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPDFCore_EncodeTextStringUnicode(sStr, (int32_t)sStr_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(67706360, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, DecodeTextString)
{
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuf) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf)) || (IS_NULL == Z_TYPE_P(zaBuf))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBPDFCore_DecodeTextString(aiBuf.data, aiBuf.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-17947006, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPDFCore, GetSortedKeyList)
{
	zval *oDictionary;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDictionary, TElPDFDictionary_ce_ptr, &oList, TStringList_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBPDFCore_GetSortedKeyList(SBGetObjectHandle(oDictionary TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPDFDictionary, TStringList)" TSRMLS_CC);
	}
}

void Register_SBPDFCore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, SFPDFDecompressionError, SB_SFPDFDecompressionError, SB_SFPDFDecompressionError);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, SFPDFUnsupportedPredictorAlgorithm, SB_SFPDFUnsupportedPredictorAlgorithm, SB_SFPDFUnsupportedPredictorAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, SPDFInterruptedByUser, SB_SPDFInterruptedByUser, SB_SPDFInterruptedByUser);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, SPDFUnsupportedEncodingFilter, SB_SPDFUnsupportedEncodingFilter, SB_SPDFUnsupportedEncodingFilter);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, SPDFFailedToCloneObject, SB_SPDFFailedToCloneObject, SB_SPDFFailedToCloneObject);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, SPDFInvalidStreamDictionary, SB_SPDFInvalidStreamDictionary, SB_SPDFInvalidStreamDictionary);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BASE, SB_PDF_ERROR_BASE, SB_PDF_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SECURITY_BASE, SB_PDF_ERROR_SECURITY_BASE, SB_PDF_ERROR_SECURITY_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_PADES_BASE, SB_PDF_ERROR_PADES_BASE, SB_PDF_ERROR_PADES_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INTERNAL_ERROR, SB_PDF_ERROR_INTERNAL_ERROR, SB_PDF_ERROR_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NOT_IMPLEMENTED, SB_PDF_ERROR_NOT_IMPLEMENTED, SB_PDF_ERROR_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INDEX_OUT_OF_BOUNDS, SB_PDF_ERROR_INDEX_OUT_OF_BOUNDS, SB_PDF_ERROR_INDEX_OUT_OF_BOUNDS);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_PARAMATER, SB_PDF_ERROR_INVALID_PARAMATER, SB_PDF_ERROR_INVALID_PARAMATER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INTERRUPTED_BY_USER, SB_PDF_ERROR_INTERRUPTED_BY_USER, SB_PDF_ERROR_INTERRUPTED_BY_USER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SILENT_ERROR, SB_PDF_ERROR_SILENT_ERROR, SB_PDF_ERROR_SILENT_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CLONE_OBJECT_FAILED, SB_PDF_ERROR_CLONE_OBJECT_FAILED, SB_PDF_ERROR_CLONE_OBJECT_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_STREAM_DATA, SB_PDF_ERROR_INVALID_STREAM_DATA, SB_PDF_ERROR_INVALID_STREAM_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_STREAM_DICTIONARY, SB_PDF_ERROR_INVALID_STREAM_DICTIONARY, SB_PDF_ERROR_INVALID_STREAM_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_REFERENCE, SB_PDF_ERROR_INVALID_REFERENCE, SB_PDF_ERROR_INVALID_REFERENCE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_REFERENCE_TABLE, SB_PDF_ERROR_INVALID_REFERENCE_TABLE, SB_PDF_ERROR_INVALID_REFERENCE_TABLE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_INDIRECT_OBJECT, SB_PDF_ERROR_INVALID_INDIRECT_OBJECT, SB_PDF_ERROR_INVALID_INDIRECT_OBJECT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_OBJECT_STREAM, SB_PDF_ERROR_INVALID_OBJECT_STREAM, SB_PDF_ERROR_INVALID_OBJECT_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_OBJECT_OR_GENERATION_NUMBER, SB_PDF_ERROR_INVALID_OBJECT_OR_GENERATION_NUMBER, SB_PDF_ERROR_INVALID_OBJECT_OR_GENERATION_NUMBER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_ROOT_OBJECT_LIST_ITEM_TYPE, SB_PDF_ERROR_INVALID_ROOT_OBJECT_LIST_ITEM_TYPE, SB_PDF_ERROR_INVALID_ROOT_OBJECT_LIST_ITEM_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_CROSS_REFERENCE_STREAM, SB_PDF_ERROR_INVALID_CROSS_REFERENCE_STREAM, SB_PDF_ERROR_INVALID_CROSS_REFERENCE_STREAM);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_CROSS_REFERENCE_STREAM_DATA, SB_PDF_ERROR_INVALID_CROSS_REFERENCE_STREAM_DATA, SB_PDF_ERROR_INVALID_CROSS_REFERENCE_STREAM_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INDIRECT_OBJECT_EXPECTED, SB_PDF_ERROR_INDIRECT_OBJECT_EXPECTED, SB_PDF_ERROR_INDIRECT_OBJECT_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_OBJECT, SB_PDF_ERROR_BAD_OBJECT, SB_PDF_ERROR_BAD_OBJECT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_TRAILER, SB_PDF_ERROR_BAD_TRAILER, SB_PDF_ERROR_BAD_TRAILER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNEXPECTED_EOF, SB_PDF_ERROR_UNEXPECTED_EOF, SB_PDF_ERROR_UNEXPECTED_EOF);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNEXPECTED_CHARACTER, SB_PDF_ERROR_UNEXPECTED_CHARACTER, SB_PDF_ERROR_UNEXPECTED_CHARACTER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_ILLEGAL_STRING, SB_PDF_ERROR_ILLEGAL_STRING, SB_PDF_ERROR_ILLEGAL_STRING);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_ILLEGAL_STREAM_DICTIONARY, SB_PDF_ERROR_ILLEGAL_STREAM_DICTIONARY, SB_PDF_ERROR_ILLEGAL_STREAM_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_VERSION, SB_PDF_ERROR_UNSUPPORTED_VERSION, SB_PDF_ERROR_UNSUPPORTED_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_CROSS_REFERENCE_ENTRY, SB_PDF_ERROR_BAD_CROSS_REFERENCE_ENTRY, SB_PDF_ERROR_BAD_CROSS_REFERENCE_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CYCLE_CROSS_REFERENCE, SB_PDF_ERROR_CYCLE_CROSS_REFERENCE, SB_PDF_ERROR_CYCLE_CROSS_REFERENCE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_XREF_TABLE_ERROR_INDIRECT_EXPECTED, SB_PDF_ERROR_XREF_TABLE_ERROR_INDIRECT_EXPECTED, SB_PDF_ERROR_XREF_TABLE_ERROR_INDIRECT_EXPECTED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_CROSS_REFERENCE_FIELD_SIZE, SB_PDF_ERROR_UNSUPPORTED_CROSS_REFERENCE_FIELD_SIZE, SB_PDF_ERROR_UNSUPPORTED_CROSS_REFERENCE_FIELD_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_ENCODING_FILTER, SB_PDF_ERROR_UNSUPPORTED_ENCODING_FILTER, SB_PDF_ERROR_UNSUPPORTED_ENCODING_FILTER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CROSS_REFERENCE_STREAM_INVALID_INDEX, SB_PDF_ERROR_CROSS_REFERENCE_STREAM_INVALID_INDEX, SB_PDF_ERROR_CROSS_REFERENCE_STREAM_INVALID_INDEX);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CROSS_REFERENCE_STREAM_INVALID_W_ENTRY, SB_PDF_ERROR_CROSS_REFERENCE_STREAM_INVALID_W_ENTRY, SB_PDF_ERROR_CROSS_REFERENCE_STREAM_INVALID_W_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_OBJECT_ALREADY_EXISTS, SB_PDF_ERROR_OBJECT_ALREADY_EXISTS, SB_PDF_ERROR_OBJECT_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DECOMPRESSION_FAILED, SB_PDF_ERROR_DECOMPRESSION_FAILED, SB_PDF_ERROR_DECOMPRESSION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_PNG_DATA, SB_PDF_ERROR_INVALID_PNG_DATA, SB_PDF_ERROR_INVALID_PNG_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_PNG_PREDICTOR, SB_PDF_ERROR_UNSUPPORTED_PNG_PREDICTOR, SB_PDF_ERROR_UNSUPPORTED_PNG_PREDICTOR);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_PREDICTOR_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_PREDICTOR_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_PREDICTOR_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_DOCUMENT, SB_PDF_ERROR_NO_DOCUMENT, SB_PDF_ERROR_NO_DOCUMENT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_NOT_OPENED, SB_PDF_ERROR_DOCUMENT_NOT_OPENED, SB_PDF_ERROR_DOCUMENT_NOT_OPENED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_DOCUMENT_FORMAT, SB_PDF_ERROR_UNSUPPORTED_DOCUMENT_FORMAT, SB_PDF_ERROR_UNSUPPORTED_DOCUMENT_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_ACRO_FORM_ENTRY, SB_PDF_ERROR_INVALID_ACRO_FORM_ENTRY, SB_PDF_ERROR_INVALID_ACRO_FORM_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_ROOT_ENTRY, SB_PDF_ERROR_INVALID_ROOT_ENTRY, SB_PDF_ERROR_INVALID_ROOT_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_LINEARIZATION_DICTIONARY, SB_PDF_ERROR_INVALID_LINEARIZATION_DICTIONARY, SB_PDF_ERROR_INVALID_LINEARIZATION_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_ID, SB_PDF_ERROR_INVALID_DOCUMENT_ID, SB_PDF_ERROR_INVALID_DOCUMENT_ID);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_CATALOG, SB_PDF_ERROR_INVALID_DOCUMENT_CATALOG, SB_PDF_ERROR_INVALID_DOCUMENT_CATALOG);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_INFO_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_INFO_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_INFO_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_PAGES_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_PAGES_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_PAGES_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_REQUIREMENTS_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_REQUIREMENTS_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_REQUIREMENTS_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_NAMES_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_NAMES_DICTIONARY, SB_PDF_ERROR_INVALID_DOCUMENT_NAMES_DICTIONARY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DOCUMENT_ANNOTATION, SB_PDF_ERROR_INVALID_DOCUMENT_ANNOTATION, SB_PDF_ERROR_INVALID_DOCUMENT_ANNOTATION);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_SIGNED_CANT_CHANGE_VERSION, SB_PDF_ERROR_DOCUMENT_SIGNED_CANT_CHANGE_VERSION, SB_PDF_ERROR_DOCUMENT_SIGNED_CANT_CHANGE_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_OPENED_CANT_CHANGE_PROPERTY, SB_PDF_ERROR_DOCUMENT_OPENED_CANT_CHANGE_PROPERTY, SB_PDF_ERROR_DOCUMENT_OPENED_CANT_CHANGE_PROPERTY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_IMAGE_TYPE, SB_PDF_ERROR_UNSUPPORTED_IMAGE_TYPE, SB_PDF_ERROR_UNSUPPORTED_IMAGE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_MASK_IMAGE_TYPE, SB_PDF_ERROR_UNSUPPORTED_MASK_IMAGE_TYPE, SB_PDF_ERROR_UNSUPPORTED_MASK_IMAGE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_COLOR_SPACE_TYPE, SB_PDF_ERROR_UNSUPPORTED_COLOR_SPACE_TYPE, SB_PDF_ERROR_UNSUPPORTED_COLOR_SPACE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_ENCODING_HANDLER_NOT_FOUND, SB_PDF_ERROR_ENCODING_HANDLER_NOT_FOUND, SB_PDF_ERROR_ENCODING_HANDLER_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED, SB_PDF_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED, SB_PDF_ERROR_SECURITY_HANDLER_ALREADY_REGISTERED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SECURITY_HANDLER_NOT_FOUND, SB_PDF_ERROR_SECURITY_HANDLER_NOT_FOUND, SB_PDF_ERROR_SECURITY_HANDLER_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SECURITY_HANDLER_NOT_ATTACHED, SB_PDF_ERROR_SECURITY_HANDLER_NOT_ATTACHED, SB_PDF_ERROR_SECURITY_HANDLER_NOT_ATTACHED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_SECURITY_HANDLER, SB_PDF_ERROR_NO_SECURITY_HANDLER, SB_PDF_ERROR_NO_SECURITY_HANDLER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_SIGNATURE_HANDLER, SB_PDF_ERROR_NO_SIGNATURE_HANDLER, SB_PDF_ERROR_NO_SIGNATURE_HANDLER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_DIGEST_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_DIGEST_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_DIGEST_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_ENCRYPTION_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_ENCRYPTION_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_ENCRYPTION_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DIGEST, SB_PDF_ERROR_INVALID_DIGEST, SB_PDF_ERROR_INVALID_DIGEST);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SIGNATURE_REFERENCE, SB_PDF_ERROR_INVALID_SIGNATURE_REFERENCE, SB_PDF_ERROR_INVALID_SIGNATURE_REFERENCE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SECURTIY_HANDLER, SB_PDF_ERROR_INVALID_SECURTIY_HANDLER, SB_PDF_ERROR_INVALID_SECURTIY_HANDLER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SIGNATURE_CONTENTS, SB_PDF_ERROR_INVALID_SIGNATURE_CONTENTS, SB_PDF_ERROR_INVALID_SIGNATURE_CONTENTS);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SIGNATURE_BYTE_RANGE, SB_PDF_ERROR_INVALID_SIGNATURE_BYTE_RANGE, SB_PDF_ERROR_INVALID_SIGNATURE_BYTE_RANGE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BYTE_RANGE_NOT_COVER_DOCUMENT, SB_PDF_ERROR_BYTE_RANGE_NOT_COVER_DOCUMENT, SB_PDF_ERROR_BYTE_RANGE_NOT_COVER_DOCUMENT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_NOT_ENCRYPTED, SB_PDF_ERROR_DOCUMENT_NOT_ENCRYPTED, SB_PDF_ERROR_DOCUMENT_NOT_ENCRYPTED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_SIGNED_CANT_ENCRYPT, SB_PDF_ERROR_DOCUMENT_SIGNED_CANT_ENCRYPT, SB_PDF_ERROR_DOCUMENT_SIGNED_CANT_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_ENCRYPT, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_ENCRYPT, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_ENCRYPT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_SIGN, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_SIGN, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_TIMESTAMP, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_TIMESTAMP, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_UPDATE_SIGNATURE, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_UPDATE_SIGNATURE, SB_PDF_ERROR_DOCUMENT_ENCRYPTED_CANT_UPDATE_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CANT_SIGN_AND_ENCRYPT_TOO_MANY_SIGNATURES, SB_PDF_ERROR_CANT_SIGN_AND_ENCRYPT_TOO_MANY_SIGNATURES, SB_PDF_ERROR_CANT_SIGN_AND_ENCRYPT_TOO_MANY_SIGNATURES);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DECRYPTION_MODE, SB_PDF_ERROR_INVALID_DECRYPTION_MODE, SB_PDF_ERROR_INVALID_DECRYPTION_MODE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_DECRYPTION_MODE_CANT_SIGN, SB_PDF_ERROR_INVALID_DECRYPTION_MODE_CANT_SIGN, SB_PDF_ERROR_INVALID_DECRYPTION_MODE_CANT_SIGN);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SIGNATURE_UPDATED_CANT_MODIFY, SB_PDF_ERROR_SIGNATURE_UPDATED_CANT_MODIFY, SB_PDF_ERROR_SIGNATURE_UPDATED_CANT_MODIFY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_SIGNATURE, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_SIGNATURE, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_SIGNATURE_UPDATE, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_SIGNATURE_UPDATE, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_SIGNATURE_UPDATE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_TIMESTAMP, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_TIMESTAMP, SB_PDF_ERROR_NO_ENOUGH_SPACE_FOR_TIMESTAMP);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_RELOAD_SIGNATURE_FAILED, SB_PDF_ERROR_RELOAD_SIGNATURE_FAILED, SB_PDF_ERROR_RELOAD_SIGNATURE_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SIGNATURE_SIZE_TOO_LARGE, SB_PDF_ERROR_SIGNATURE_SIZE_TOO_LARGE, SB_PDF_ERROR_SIGNATURE_SIZE_TOO_LARGE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_MDP_SIGNATURE_NOT_FIRST, SB_PDF_ERROR_MDP_SIGNATURE_NOT_FIRST, SB_PDF_ERROR_MDP_SIGNATURE_NOT_FIRST);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_ADOBE8_COMPATIBILITY_WARNING, SB_PDF_ERROR_ADOBE8_COMPATIBILITY_WARNING, SB_PDF_ERROR_ADOBE8_COMPATIBILITY_WARNING);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CANT_DECODE_OBJECT, SB_PDF_ERROR_CANT_DECODE_OBJECT, SB_PDF_ERROR_CANT_DECODE_OBJECT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CANT_DECRYPT_OBJECT, SB_PDF_ERROR_CANT_DECRYPT_OBJECT, SB_PDF_ERROR_CANT_DECRYPT_OBJECT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CANT_ADD_SECOND_SIGNATURE, SB_PDF_ERROR_CANT_ADD_SECOND_SIGNATURE, SB_PDF_ERROR_CANT_ADD_SECOND_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SIGNATURE_INFORMATION, SB_PDF_ERROR_INVALID_SIGNATURE_INFORMATION, SB_PDF_ERROR_INVALID_SIGNATURE_INFORMATION);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SECURITY_HANDLER_INFORMATION, SB_PDF_ERROR_INVALID_SECURITY_HANDLER_INFORMATION, SB_PDF_ERROR_INVALID_SECURITY_HANDLER_INFORMATION);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_ENCRYPTED_DATA, SB_PDF_ERROR_INVALID_ENCRYPTED_DATA, SB_PDF_ERROR_INVALID_ENCRYPTED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_BLOCK_CIPHER_PADDING, SB_PDF_ERROR_INVALID_BLOCK_CIPHER_PADDING, SB_PDF_ERROR_INVALID_BLOCK_CIPHER_PADDING);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_KEY_SIZE, SB_PDF_ERROR_INVALID_KEY_SIZE, SB_PDF_ERROR_INVALID_KEY_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_PASSWORD, SB_PDF_ERROR_INVALID_PASSWORD, SB_PDF_ERROR_INVALID_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_PASSWORD_INFO, SB_PDF_ERROR_INVALID_PASSWORD_INFO, SB_PDF_ERROR_INVALID_PASSWORD_INFO);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_OBJECT_NOT_ENCRYPTED, SB_PDF_ERROR_OBJECT_NOT_ENCRYPTED, SB_PDF_ERROR_OBJECT_NOT_ENCRYPTED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNEXPECTED_CIPHER_INFO, SB_PDF_ERROR_UNEXPECTED_CIPHER_INFO, SB_PDF_ERROR_UNEXPECTED_CIPHER_INFO);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_PERMISSIONS_VERIFICATION_FAILED, SB_PDF_ERROR_PERMISSIONS_VERIFICATION_FAILED, SB_PDF_ERROR_PERMISSIONS_VERIFICATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_PASSWORD_HANDLER_REVISION, SB_PDF_ERROR_UNSUPPORTED_PASSWORD_HANDLER_REVISION, SB_PDF_ERROR_UNSUPPORTED_PASSWORD_HANDLER_REVISION);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_SECURITY_HANDLER_SUBFILTER, SB_PDF_ERROR_UNSUPPORTED_SECURITY_HANDLER_SUBFILTER, SB_PDF_ERROR_UNSUPPORTED_SECURITY_HANDLER_SUBFILTER);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_SIGNING_CERTIFICATE_CHAIN, SB_PDF_ERROR_INVALID_SIGNING_CERTIFICATE_CHAIN, SB_PDF_ERROR_INVALID_SIGNING_CERTIFICATE_CHAIN);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_PKCS7_DATA, SB_PDF_ERROR_INVALID_PKCS7_DATA, SB_PDF_ERROR_INVALID_PKCS7_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_PKCS7_SIGNING_FAILED, SB_PDF_ERROR_PKCS7_SIGNING_FAILED, SB_PDF_ERROR_PKCS7_SIGNING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_SIGNING_CERTIFICATE, SB_PDF_ERROR_NO_SIGNING_CERTIFICATE, SB_PDF_ERROR_NO_SIGNING_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_SIGNER_CERTIFICATE, SB_PDF_ERROR_NO_SIGNER_CERTIFICATE, SB_PDF_ERROR_NO_SIGNER_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_FEATURE, SB_PDF_ERROR_UNSUPPORTED_FEATURE, SB_PDF_ERROR_UNSUPPORTED_FEATURE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_SIGNATURE_TYPE, SB_PDF_ERROR_UNSUPPORTED_SIGNATURE_TYPE, SB_PDF_ERROR_UNSUPPORTED_SIGNATURE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_TSP_CLIENT, SB_PDF_ERROR_NO_TSP_CLIENT, SB_PDF_ERROR_NO_TSP_CLIENT);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_ENCRYPTION_CERTIFICATE, SB_PDF_ERROR_NO_ENCRYPTION_CERTIFICATE, SB_PDF_ERROR_NO_ENCRYPTION_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_UNSUPPORTED_KEY_ENCRYPTION_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_KEY_ENCRYPTION_ALGORITHM, SB_PDF_ERROR_UNSUPPORTED_KEY_ENCRYPTION_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_ENCRYPTION_FAILED, SB_PDF_ERROR_ENCRYPTION_FAILED, SB_PDF_ERROR_ENCRYPTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_ENCRYPTION_KEY_GENERATION_FAILED, SB_PDF_ERROR_ENCRYPTION_KEY_GENERATION_FAILED, SB_PDF_ERROR_ENCRYPTION_KEY_GENERATION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_NO_DECRYPTION_KEY, SB_PDF_ERROR_NO_DECRYPTION_KEY, SB_PDF_ERROR_NO_DECRYPTION_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_ASYNC_STATE, SB_PDF_ERROR_BAD_ASYNC_STATE, SB_PDF_ERROR_BAD_ASYNC_STATE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_DC_MODULE_UNAVAILABLE, SB_PDF_ERROR_DC_MODULE_UNAVAILABLE, SB_PDF_ERROR_DC_MODULE_UNAVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_PRESIGNATURE, SB_PDF_ERROR_BAD_PRESIGNATURE, SB_PDF_ERROR_BAD_PRESIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_SIGNATURE_NOT_FOUND, SB_PDF_ERROR_SIGNATURE_NOT_FOUND, SB_PDF_ERROR_SIGNATURE_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_TOO_MANY_SIGNATURES, SB_PDF_ERROR_TOO_MANY_SIGNATURES, SB_PDF_ERROR_TOO_MANY_SIGNATURES);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_SIGNATURE_TYPE, SB_PDF_ERROR_BAD_SIGNATURE_TYPE, SB_PDF_ERROR_BAD_SIGNATURE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_TIMESTAMPING_FAILED, SB_PDF_ERROR_TIMESTAMPING_FAILED, SB_PDF_ERROR_TIMESTAMPING_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_TIMESTAMP_DATA, SB_PDF_ERROR_INVALID_TIMESTAMP_DATA, SB_PDF_ERROR_INVALID_TIMESTAMP_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_INVALID_CMS_DATA, SB_PDF_ERROR_INVALID_CMS_DATA, SB_PDF_ERROR_INVALID_CMS_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_BAD_SIGNING_CERTIFICATE_ATTRIBUTE, SB_PDF_ERROR_BAD_SIGNING_CERTIFICATE_ATTRIBUTE, SB_PDF_ERROR_BAD_SIGNING_CERTIFICATE_ATTRIBUTE);
	SB_REGISTER_LONG_CONSTANT(SBPDFCore, SB_PDF_ERROR_CHAIN_VALIDATION_FAILED, SB_PDF_ERROR_CHAIN_VALIDATION_FAILED, SB_PDF_ERROR_CHAIN_VALIDATION_FAILED);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, PDF_CONST_STR_STARTXREF, SB_PDF_CONST_STR_STARTXREF, SB_PDF_CONST_STR_STARTXREF);
	SB_REGISTER_STRING_CONSTANT(SBPDFCore, PDF_CONST_STR_EOF, SB_PDF_CONST_STR_EOF, SB_PDF_CONST_STR_EOF);
}

void Register_SBPDFCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TPDFAssembleType", NULL);
	TPDFAssembleType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPDFAssembleType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPDFAssembleType_ce_ptr, "atAppendChanges", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPDFAssembleType_ce_ptr, "atReassemble", 1)
	
	INIT_CLASS_ENTRY(ce, "TPDFStringEncoding", NULL);
	TPDFStringEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPDFStringEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPDFStringEncoding_ce_ptr, "seBinary", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPDFStringEncoding_ce_ptr, "seHexadecimal", 1)
	SB_DECLARE_CLASS_LONG_CONST(TPDFStringEncoding_ce_ptr, "seOctal", 2)
	
	INIT_CLASS_ENTRY(ce, "TPDFXrefEntryType", NULL);
	TPDFXrefEntryType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPDFXrefEntryType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPDFXrefEntryType_ce_ptr, "etGeneric", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPDFXrefEntryType_ce_ptr, "etObjStream", 1)
}

void Register_SBPDFCore_Aliases(TSRMLS_D)
{
	if (NULL == TElPDFFile_ce_ptr)
		Register_TElPDFFile(TSRMLS_C);
	zend_register_class_alias("TPDFFile", TElPDFFile_ce_ptr);
	if (NULL == TElPDFObject_ce_ptr)
		Register_TElPDFObject(TSRMLS_C);
	zend_register_class_alias("TPDFObject", TElPDFObject_ce_ptr);
	if (NULL == TElPDFNull_ce_ptr)
		Register_TElPDFNull(TSRMLS_C);
	zend_register_class_alias("TPDFNull", TElPDFNull_ce_ptr);
	if (NULL == TElPDFBoolean_ce_ptr)
		Register_TElPDFBoolean(TSRMLS_C);
	zend_register_class_alias("TPDFBoolean", TElPDFBoolean_ce_ptr);
	if (NULL == TElPDFReal_ce_ptr)
		Register_TElPDFReal(TSRMLS_C);
	zend_register_class_alias("TPDFReal", TElPDFReal_ce_ptr);
	if (NULL == TElPDFString_ce_ptr)
		Register_TElPDFString(TSRMLS_C);
	zend_register_class_alias("TPDFString", TElPDFString_ce_ptr);
	if (NULL == TElPDFComment_ce_ptr)
		Register_TElPDFComment(TSRMLS_C);
	zend_register_class_alias("TPDFComment", TElPDFComment_ce_ptr);
	if (NULL == TElPDFName_ce_ptr)
		Register_TElPDFName(TSRMLS_C);
	zend_register_class_alias("TPDFName", TElPDFName_ce_ptr);
	if (NULL == TElPDFCpxObj_ce_ptr)
		Register_TElPDFCpxObj(TSRMLS_C);
	zend_register_class_alias("TPDFCpxObj", TElPDFCpxObj_ce_ptr);
	if (NULL == TElPDFArray_ce_ptr)
		Register_TElPDFArray(TSRMLS_C);
	zend_register_class_alias("TPDFArray", TElPDFArray_ce_ptr);
	if (NULL == TElPDFDictionary_ce_ptr)
		Register_TElPDFDictionary(TSRMLS_C);
	zend_register_class_alias("TPDFDictionary", TElPDFDictionary_ce_ptr);
	if (NULL == TElPDFStream_ce_ptr)
		Register_TElPDFStream(TSRMLS_C);
	zend_register_class_alias("TPDFStream", TElPDFStream_ce_ptr);
	if (NULL == TElPDFIndirect_ce_ptr)
		Register_TElPDFIndirect(TSRMLS_C);
	zend_register_class_alias("TPDFIndirect", TElPDFIndirect_ce_ptr);
	if (NULL == TElPDFRef_ce_ptr)
		Register_TElPDFRef(TSRMLS_C);
	zend_register_class_alias("TPDFRef", TElPDFRef_ce_ptr);
	if (NULL == TElPDFXRef_ce_ptr)
		Register_TElPDFXRef(TSRMLS_C);
	zend_register_class_alias("TPDFXRef", TElPDFXRef_ce_ptr);
	if (NULL == TElPDFXrefEntry_ce_ptr)
		Register_TElPDFXrefEntry(TSRMLS_C);
	zend_register_class_alias("TPDFXrefEntry", TElPDFXrefEntry_ce_ptr);
	if (NULL == TElPDFXRefs_ce_ptr)
		Register_TElPDFXRefs(TSRMLS_C);
	zend_register_class_alias("TPDFXRefs", TElPDFXRefs_ce_ptr);
}

