#include "sbpublickeycrypto.h"

void SB_CALLBACK TSBAsyncOperationFinishedEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t Success)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSuccess;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSuccess);
	ZVAL_BOOL(zSuccess, (zend_bool)Success);

	params[0] = &zSender;
	params[1] = &zSuccess;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSuccess);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBKeyStoreFormat_ce_ptr = NULL;

zend_class_entry *TSBPublicKeyOperation_ce_ptr = NULL;

zend_class_entry *TSBPublicKeyVerificationResult_ce_ptr = NULL;

zend_class_entry *TSBPublicKeyCryptoEncoding_ce_ptr = NULL;

zend_class_entry *TElPublicKeyCryptoClass_ce_ptr = NULL;

zend_class_entry *TSBRSAKeyFormat_ce_ptr = NULL;

zend_class_entry *TSBRSAPublicKeyCryptoType_ce_ptr = NULL;

zend_class_entry *TSBDSAKeyFormat_ce_ptr = NULL;

zend_class_entry *TSBDHKeyFormat_ce_ptr = NULL;

zend_class_entry *TSBDHPublicKeyCryptoType_ce_ptr = NULL;

zend_class_entry *TElPublicKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElPublicKeyMaterial, GetMaxPublicKeySize_Inst)
{
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_GetMaxPublicKeySize_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, GetMaxPublicKeySize)
{
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_GetMaxPublicKeySize(SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, AssignCryptoKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_AssignCryptoKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, Generate)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, LoadPublic)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, LoadSecret)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPublicKeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPublicKeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, Save)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_Save(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, Load)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_Load(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, LoadFromXML)
{
	char *sStr;
	int sStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sStr, (int32_t)sStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, SaveToXML)
{
	uint32_t _err;
	zend_bool bIncludePrivateKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludePrivateKey) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPublicKeyMaterial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludePrivateKey, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-980248540, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, BeginGenerate)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_BeginGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, EndGenerate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_EndGenerate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, CancelAsyncOperation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_CancelAsyncOperation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_PublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_SecretKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPublicKeyMaterial, get_CertHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		CERT_CONTEXT * proOutResult;
		SBCheckError(TElPublicKeyMaterial_get_CertHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &proOutResult) TSRMLS_CC);
		object_init_ex(return_value, CERT_CONTEXT_ce_ptr);
		SBSetStructPointer(return_value, proOutResult, sizeof(CERT_CONTEXT) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_CertHandle)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, CERT_CONTEXT_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_set_CertHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (CERT_CONTEXT *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(CERT_CONTEXT)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_KeyExchangePIN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPublicKeyMaterial_get_KeyExchangePIN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-881848744, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_KeyExchangePIN)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_set_KeyExchangePIN(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_SignaturePIN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPublicKeyMaterial_get_SignaturePIN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-376680196, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_SignaturePIN)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_set_SignaturePIN(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPublicKeyMaterial, get_KeyHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_KeyHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_KeyHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_KeyHandle)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
#else
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPublicKeyMaterial_set_KeyHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPublicKeyMaterial_set_KeyHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_SessionHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_SessionHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
#else
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_SessionHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_SessionHandle)
{
#ifdef SB_NOT_CPU64_OR_WINDOWS
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
#else
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
#endif
	{
#ifdef SB_NOT_CPU64_OR_WINDOWS
		SBCheckError(TElPublicKeyMaterial_set_SessionHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
#else
		SBCheckError(TElPublicKeyMaterial_set_SessionHandle(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElPublicKeyMaterial, get_CNGKeyHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t * poOutResult = NULL;
		SBCheckError(TElPublicKeyMaterial_get_CNGKeyHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_CNGKeyHandle)
{
	SBArrayZValInfo piValue;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpValue) == SUCCESS) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyMaterial_set_CNGKeyHandle(SBGetObjectHandle(getThis() TSRMLS_CC), piValue.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piValue);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_CNGProvHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t * poOutResult = NULL;
		SBCheckError(TElPublicKeyMaterial_get_CNGProvHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_CNGProvHandle)
{
	SBArrayZValInfo piValue;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpValue) == SUCCESS) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyMaterial_set_CNGProvHandle(SBGetObjectHandle(getThis() TSRMLS_CC), piValue.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piValue);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElPublicKeyMaterial, get_Busy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_Busy(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_StoreFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyStoreFormatRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_StoreFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_StoreFormat)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPublicKeyMaterial_set_StoreFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyStoreFormatRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyMaterial_get_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, get_OnAsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAsyncOperationFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPublicKeyMaterial_get_OnAsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, set_OnAsyncOperationFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPublicKeyMaterial_set_OnAsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAsyncOperationFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAsyncOperationFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_GetMaxPublicKeySize_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_GetMaxPublicKeySize, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_AssignCryptoKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_Generate, 0, 0, 0)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Stream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Str)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_SaveToXML, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludePrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_BeginGenerate, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_EndGenerate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_CancelAsyncOperation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_SecretKey, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_CertHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_CertHandle, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, CERT_CONTEXT, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_KeyExchangePIN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_KeyExchangePIN, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_SignaturePIN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_SignaturePIN, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_KeyHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_KeyHandle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_SessionHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_SessionHandle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_CNGKeyHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_CNGKeyHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_CNGProvHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_CNGProvHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_Busy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_StoreFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_StoreFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_get_OnAsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial_set_OnAsyncOperationFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPublicKeyMaterial_methods[] = {
	PHP_ME(TElPublicKeyMaterial, GetMaxPublicKeySize_Inst, arginfo_TElPublicKeyMaterial_GetMaxPublicKeySize_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, GetMaxPublicKeySize, arginfo_TElPublicKeyMaterial_GetMaxPublicKeySize, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPublicKeyMaterial, AssignCryptoKey, arginfo_TElPublicKeyMaterial_AssignCryptoKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, Generate, arginfo_TElPublicKeyMaterial_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, LoadPublic, arginfo_TElPublicKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, LoadSecret, arginfo_TElPublicKeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, SavePublic, arginfo_TElPublicKeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, SaveSecret, arginfo_TElPublicKeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, LoadParameters, arginfo_TElPublicKeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, SaveParameters, arginfo_TElPublicKeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, Save, arginfo_TElPublicKeyMaterial_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, Load, arginfo_TElPublicKeyMaterial_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, LoadFromXML, arginfo_TElPublicKeyMaterial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, SaveToXML, arginfo_TElPublicKeyMaterial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, Clone, arginfo_TElPublicKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, Equals, arginfo_TElPublicKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, ClearSecret, arginfo_TElPublicKeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, ClearPublic, arginfo_TElPublicKeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, Clear, arginfo_TElPublicKeyMaterial_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, BeginGenerate, arginfo_TElPublicKeyMaterial_BeginGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, EndGenerate, arginfo_TElPublicKeyMaterial_EndGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, CancelAsyncOperation, arginfo_TElPublicKeyMaterial_CancelAsyncOperation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, PrepareForEncryption, arginfo_TElPublicKeyMaterial_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, PrepareForSigning, arginfo_TElPublicKeyMaterial_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_PublicKey, arginfo_TElPublicKeyMaterial_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_SecretKey, arginfo_TElPublicKeyMaterial_get_SecretKey, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPublicKeyMaterial, get_CertHandle, arginfo_TElPublicKeyMaterial_get_CertHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_CertHandle, arginfo_TElPublicKeyMaterial_set_CertHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_KeyExchangePIN, arginfo_TElPublicKeyMaterial_get_KeyExchangePIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_KeyExchangePIN, arginfo_TElPublicKeyMaterial_set_KeyExchangePIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_SignaturePIN, arginfo_TElPublicKeyMaterial_get_SignaturePIN, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_SignaturePIN, arginfo_TElPublicKeyMaterial_set_SignaturePIN, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPublicKeyMaterial, get_KeyHandle, arginfo_TElPublicKeyMaterial_get_KeyHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_KeyHandle, arginfo_TElPublicKeyMaterial_set_KeyHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_SessionHandle, arginfo_TElPublicKeyMaterial_get_SessionHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_SessionHandle, arginfo_TElPublicKeyMaterial_set_SessionHandle, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElPublicKeyMaterial, get_CNGKeyHandle, arginfo_TElPublicKeyMaterial_get_CNGKeyHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_CNGKeyHandle, arginfo_TElPublicKeyMaterial_set_CNGKeyHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_CNGProvHandle, arginfo_TElPublicKeyMaterial_get_CNGProvHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_CNGProvHandle, arginfo_TElPublicKeyMaterial_set_CNGProvHandle, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElPublicKeyMaterial, get_Busy, arginfo_TElPublicKeyMaterial_get_Busy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_StoreFormat, arginfo_TElPublicKeyMaterial_get_StoreFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_StoreFormat, arginfo_TElPublicKeyMaterial_set_StoreFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_AsyncOperationFinished, arginfo_TElPublicKeyMaterial_get_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, get_OnAsyncOperationFinished, arginfo_TElPublicKeyMaterial_get_OnAsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, set_OnAsyncOperationFinished, arginfo_TElPublicKeyMaterial_set_OnAsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyMaterial, __construct, arginfo_TElPublicKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPublicKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPublicKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPublicKeyMaterial", TElPublicKeyMaterial_methods);
	if (NULL == TElKeyMaterial_ce_ptr)
		Register_TElKeyMaterial(TSRMLS_C);
	TElPublicKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElPublicKeyCrypto, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, Encrypt)
{
	int32_t l4OutSizeRaw;
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_Encrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, Decrypt)
{
	int32_t l4OutSizeRaw;
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_Decrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, Sign)
{
	int32_t l4OutSizeRaw;
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, SignDetached)
{
	int32_t l4OutSizeRaw;
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_SignDetached(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_SignDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, Verify)
{
	int32_t l4OutSizeRaw;
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		TSBPublicKeyVerificationResultRaw fOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, &fOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		TSBPublicKeyVerificationResultRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_Verify_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, VerifyDetached)
{
	long l4InCount;
	long l4InSize;
	long l4SigCount;
	long l4SigSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piSigBuffer;
	zval *oInStream;
	zval *oSigStream;
	zval *zpInBuffer;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpInBuffer, &l4InSize, &zpSigBuffer, &l4SigSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))))
	{
		TSBPublicKeyVerificationResultRaw fOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_VerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piSigBuffer.data, (int32_t)l4SigSize, &fOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piSigBuffer);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oInStream, TStream_ce_ptr, &oSigStream, TStream_ce_ptr, &l4InCount, &l4SigCount) == SUCCESS)
	{
		TSBPublicKeyVerificationResultRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_VerifyDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oSigStream TSRMLS_CC), (int32_t)l4InCount, (int32_t)l4SigCount, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, DecryptKey)
{
	long l4EncKeySize;
	SBArrayZValInfo aiEncKeyAlgOID;
	SBArrayZValInfo aiEncKeyAlgParams;
	SBArrayZValInfo piEncKey;
	zval *zaEncKeyAlgOID;
	zval *zaEncKeyAlgParams;
	zval *zpEncKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpEncKey, &l4EncKeySize, &zaEncKeyAlgOID, &zaEncKeyAlgParams) == SUCCESS) && ((Z_TYPE_P(zpEncKey) == IS_STRING) || (Z_TYPE_P(zpEncKey) == IS_ARRAY) || (Z_TYPE_P(zpEncKey) == IS_NULL) || ((Z_TYPE_P(zpEncKey) == IS_OBJECT) && (Z_OBJCE_P(zpEncKey) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpEncKey, &piEncKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgOID, &aiEncKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgParams, &aiEncKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_DecryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), piEncKey.data, (int32_t)l4EncKeySize, aiEncKeyAlgOID.data, aiEncKeyAlgOID.len, aiEncKeyAlgParams.data, aiEncKeyAlgParams.len, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piEncKey);
		SBFreeArrayZValInfo(&aiEncKeyAlgOID);
		SBFreeArrayZValInfo(&aiEncKeyAlgParams);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, BeginEncrypt)
{
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpInBuffer, &l4InSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_BeginEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_BeginEncrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, EndEncrypt)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_EndEncrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_EndEncrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, BeginDecrypt)
{
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpInBuffer, &l4InSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_BeginDecrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_BeginDecrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, EndDecrypt)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_EndDecrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_EndDecrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, BeginSign)
{
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpInBuffer, &l4InSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_BeginSign(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_BeginSign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, EndSign)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_EndSign(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_EndSign_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, BeginSignDetached)
{
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpInBuffer, &l4InSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_BeginSignDetached(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_BeginSignDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, EndSignDetached)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElPublicKeyCrypto_EndSignDetached(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_EndSignDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, BeginVerify)
{
	long l4Count;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpInBuffer, &l4InSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_BeginVerify(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_BeginVerify_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, EndVerify)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	TSBPublicKeyVerificationResultRaw fVerificationResultRaw;
	zval *zfVerificationResult;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zpOutBuffer, &zl4OutSize, &zfVerificationResult) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && PZVAL_IS_REF(zfVerificationResult) && (IS_LONG == Z_TYPE_P(zfVerificationResult)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		fVerificationResultRaw = (TSBPublicKeyVerificationResultRaw)Z_LVAL_P(zfVerificationResult);
		SBCheckError(TElPublicKeyCrypto_EndVerify(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw, &fVerificationResultRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		ZVAL_LONG(zfVerificationResult, (long)fVerificationResultRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPublicKeyVerificationResultRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_EndVerify_1(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, &integer) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, BeginVerifyDetached)
{
	long l4InCount;
	long l4InSize;
	long l4SigCount;
	long l4SigSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piSigBuffer;
	zval *oInStream;
	zval *oSigStream;
	zval *zpInBuffer;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpInBuffer, &l4InSize, &zpSigBuffer, &l4SigSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_BeginVerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piSigBuffer.data, (int32_t)l4SigSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piSigBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oInStream, TStream_ce_ptr, &oSigStream, TStream_ce_ptr, &l4InCount, &l4SigCount) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_BeginVerifyDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oSigStream TSRMLS_CC), (int32_t)l4InCount, (int32_t)l4SigCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, EndVerifyDetached)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPublicKeyVerificationResultRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_EndVerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, CancelAsyncOperation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_CancelAsyncOperation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, set_KeyMaterial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_SupportsEncryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_SupportsEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_SupportsSigning)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_SupportsSigning(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_InputIsHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_InputIsHash(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, set_InputIsHash)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_set_InputIsHash(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_InputEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPublicKeyCryptoEncodingRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_InputEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, set_InputEncoding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_set_InputEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPublicKeyCryptoEncodingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_OutputEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPublicKeyCryptoEncodingRaw fOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_OutputEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, set_OutputEncoding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_set_OutputEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPublicKeyCryptoEncodingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_Busy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_Busy(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCrypto_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyCrypto_get_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, get_OnAsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAsyncOperationFinishedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_get_OnAsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, set_OnAsyncOperationFinished)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPublicKeyCrypto_set_OnAsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAsyncOperationFinishedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAsyncOperationFinishedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_Encrypt, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_Count, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_Decrypt, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_Count, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_Sign, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_Count, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_SignDetached, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_Count, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_Verify, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_Count, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_VerifyDetached, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_SigStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_InCount, 0, 1)
	ZEND_ARG_INFO(0, SigSize_or_SigCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_DecryptKey, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, EncKey, 0, 1)
	ZEND_ARG_INFO(0, EncKeySize)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_BeginEncrypt, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_EndEncrypt, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_BeginDecrypt, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_EndDecrypt, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_BeginSign, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_EndSign, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_BeginSignDetached, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_EndSignDetached, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_BeginVerify, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_EndVerify, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_INFO(1, VerificationResult)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_BeginVerifyDetached, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_SigStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_InCount, 0, 1)
	ZEND_ARG_INFO(0, SigSize_or_SigCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_EndVerifyDetached, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_CancelAsyncOperation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_set_KeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPublicKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_SupportsEncryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_SupportsSigning, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_InputIsHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_set_InputIsHash, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_InputEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_set_InputEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_OutputEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_set_OutputEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_Busy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_get_OnAsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto_set_OnAsyncOperationFinished, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPublicKeyCrypto_methods[] = {
	PHP_ME(TElPublicKeyCrypto, LoadParameters, arginfo_TElPublicKeyCrypto_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, SaveParameters, arginfo_TElPublicKeyCrypto_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, Encrypt, arginfo_TElPublicKeyCrypto_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, Decrypt, arginfo_TElPublicKeyCrypto_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, Sign, arginfo_TElPublicKeyCrypto_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, SignDetached, arginfo_TElPublicKeyCrypto_SignDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, Verify, arginfo_TElPublicKeyCrypto_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, VerifyDetached, arginfo_TElPublicKeyCrypto_VerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, DecryptKey, arginfo_TElPublicKeyCrypto_DecryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, BeginEncrypt, arginfo_TElPublicKeyCrypto_BeginEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, EndEncrypt, arginfo_TElPublicKeyCrypto_EndEncrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, BeginDecrypt, arginfo_TElPublicKeyCrypto_BeginDecrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, EndDecrypt, arginfo_TElPublicKeyCrypto_EndDecrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, BeginSign, arginfo_TElPublicKeyCrypto_BeginSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, EndSign, arginfo_TElPublicKeyCrypto_EndSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, BeginSignDetached, arginfo_TElPublicKeyCrypto_BeginSignDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, EndSignDetached, arginfo_TElPublicKeyCrypto_EndSignDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, BeginVerify, arginfo_TElPublicKeyCrypto_BeginVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, EndVerify, arginfo_TElPublicKeyCrypto_EndVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, BeginVerifyDetached, arginfo_TElPublicKeyCrypto_BeginVerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, EndVerifyDetached, arginfo_TElPublicKeyCrypto_EndVerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, CancelAsyncOperation, arginfo_TElPublicKeyCrypto_CancelAsyncOperation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, ClassType, arginfo_TElPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElPublicKeyCrypto, get_KeyMaterial, arginfo_TElPublicKeyCrypto_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, set_KeyMaterial, arginfo_TElPublicKeyCrypto_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_SupportsEncryption, arginfo_TElPublicKeyCrypto_get_SupportsEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_SupportsSigning, arginfo_TElPublicKeyCrypto_get_SupportsSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_InputIsHash, arginfo_TElPublicKeyCrypto_get_InputIsHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, set_InputIsHash, arginfo_TElPublicKeyCrypto_set_InputIsHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_InputEncoding, arginfo_TElPublicKeyCrypto_get_InputEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, set_InputEncoding, arginfo_TElPublicKeyCrypto_set_InputEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_OutputEncoding, arginfo_TElPublicKeyCrypto_get_OutputEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, set_OutputEncoding, arginfo_TElPublicKeyCrypto_set_OutputEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_Busy, arginfo_TElPublicKeyCrypto_get_Busy, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_HashAlgorithm, arginfo_TElPublicKeyCrypto_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, set_HashAlgorithm, arginfo_TElPublicKeyCrypto_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_AsyncOperationFinished, arginfo_TElPublicKeyCrypto_get_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, get_OnAsyncOperationFinished, arginfo_TElPublicKeyCrypto_get_OnAsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, set_OnAsyncOperationFinished, arginfo_TElPublicKeyCrypto_set_OnAsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCrypto, __construct, arginfo_TElPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPublicKeyCrypto", TElPublicKeyCrypto_methods);
	if (NULL == TElCustomCrypto_ce_ptr)
		Register_TElCustomCrypto(TSRMLS_C);
	TElPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRSAKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElRSAKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, LoadPublic)
{
	long l4Count;
	long l4ExponentSize;
	long l4ModulusSize;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piExponent;
	SBArrayZValInfo piModulus;
	zval *oStream;
	zval *zpBuffer;
	zval *zpExponent;
	zval *zpModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpModulus, &l4ModulusSize, &zpExponent, &l4ExponentSize) == SUCCESS) && ((Z_TYPE_P(zpModulus) == IS_STRING) || (Z_TYPE_P(zpModulus) == IS_ARRAY) || (Z_TYPE_P(zpModulus) == IS_NULL) || ((Z_TYPE_P(zpModulus) == IS_OBJECT) && (Z_OBJCE_P(zpModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpExponent) == IS_STRING) || (Z_TYPE_P(zpExponent) == IS_ARRAY) || (Z_TYPE_P(zpExponent) == IS_NULL) || ((Z_TYPE_P(zpExponent) == IS_OBJECT) && (Z_OBJCE_P(zpExponent) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpModulus, &piModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpExponent, &piExponent TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), piModulus.data, (int32_t)l4ModulusSize, piExponent.data, (int32_t)l4ExponentSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piModulus);
		SBFreePointerZValInfo(&piExponent);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_LoadPublic_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, LoadSecret)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAKeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElRSAKeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElRSAKeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, LoadFromXML)
{
	char *sStr;
	int sStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sStr, (int32_t)sStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, SaveToXML)
{
	uint32_t _err;
	zend_bool bIncludePrivateKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludePrivateKey) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRSAKeyMaterial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludePrivateKey, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-988686633, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, EncodePublicKey)
{
	int32_t l4OutSizeRaw;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	SBArrayZValInfo aiAlgID;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	zend_bool bInnerValuesOnly;
	zval *zaAlgID;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzzzb", &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zaAlgID, &zpOutBuffer, &zl4OutSize, &bInnerValuesOnly) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaAlgID)) || (IS_ARRAY == Z_TYPE_P(zaAlgID)) || (IS_NULL == Z_TYPE_P(zaAlgID))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgID, &aiAlgID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElRSAKeyMaterial_EncodePublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, aiAlgID.data, aiAlgID.len, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bInnerValuesOnly, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreeArrayZValInfo(&aiAlgID);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, TSBPointer|array of byte|string|NULL, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, EncodePrivateKey)
{
	int32_t l4OutSizeRaw;
	long l4DPSize;
	long l4DQSize;
	long l4DSize;
	long l4ESize;
	long l4NSize;
	long l4PrivateExponentSize;
	long l4PSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	long l4QInvSize;
	long l4QSize;
	SBArrayZValInfo piD;
	SBArrayZValInfo piDP;
	SBArrayZValInfo piDQ;
	SBArrayZValInfo piE;
	SBArrayZValInfo piN;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piQInv;
	zval *zl4OutSize;
	zval *zpD;
	zval *zpDP;
	zval *zpDQ;
	zval *zpE;
	zval *zpN;
	zval *zpOutBuffer;
	zval *zpP;
	zval *zpPrivateExponent;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpQ;
	zval *zpQInv;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzz", &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElRSAKeyMaterial_EncodePrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzlzlzlzz", &zpN, &l4NSize, &zpE, &l4ESize, &zpD, &l4DSize, &zpP, &l4PSize, &zpQ, &l4QSize, &zpDP, &l4DPSize, &zpDQ, &l4DQSize, &zpQInv, &l4QInvSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpE) == IS_STRING) || (Z_TYPE_P(zpE) == IS_ARRAY) || (Z_TYPE_P(zpE) == IS_NULL) || ((Z_TYPE_P(zpE) == IS_OBJECT) && (Z_OBJCE_P(zpE) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpDP) == IS_STRING) || (Z_TYPE_P(zpDP) == IS_ARRAY) || (Z_TYPE_P(zpDP) == IS_NULL) || ((Z_TYPE_P(zpDP) == IS_OBJECT) && (Z_OBJCE_P(zpDP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpDQ) == IS_STRING) || (Z_TYPE_P(zpDQ) == IS_ARRAY) || (Z_TYPE_P(zpDQ) == IS_NULL) || ((Z_TYPE_P(zpDQ) == IS_OBJECT) && (Z_OBJCE_P(zpDQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQInv) == IS_STRING) || (Z_TYPE_P(zpQInv) == IS_ARRAY) || (Z_TYPE_P(zpQInv) == IS_NULL) || ((Z_TYPE_P(zpQInv) == IS_OBJECT) && (Z_OBJCE_P(zpQInv) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpE, &piE TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpDP, &piDP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpDQ, &piDQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQInv, &piQInv TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElRSAKeyMaterial_EncodePrivateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), piN.data, (int32_t)l4NSize, piE.data, (int32_t)l4ESize, piD.data, (int32_t)l4DSize, piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piDP.data, (int32_t)l4DPSize, piDQ.data, (int32_t)l4DQSize, piQInv.data, (int32_t)l4QInvSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piN);
		SBFreePointerZValInfo(&piE);
		SBFreePointerZValInfo(&piD);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piDP);
		SBFreePointerZValInfo(&piDQ);
		SBFreePointerZValInfo(&piQInv);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzz", &zpN, &l4NSize, &zpE, &l4ESize, &zpD, &l4DSize, &zpP, &l4PSize, &zpQ, &l4QSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpE) == IS_STRING) || (Z_TYPE_P(zpE) == IS_ARRAY) || (Z_TYPE_P(zpE) == IS_NULL) || ((Z_TYPE_P(zpE) == IS_OBJECT) && (Z_OBJCE_P(zpE) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpE, &piE TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElRSAKeyMaterial_EncodePrivateKey_2(SBGetObjectHandle(getThis() TSRMLS_CC), piN.data, (int32_t)l4NSize, piE.data, (int32_t)l4ESize, piD.data, (int32_t)l4DSize, piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piN);
		SBFreePointerZValInfo(&piE);
		SBFreePointerZValInfo(&piD);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, DecodePrivateKey)
{
	int32_t l4DPSizeRaw;
	int32_t l4DQSizeRaw;
	int32_t l4DSizeRaw;
	int32_t l4ESizeRaw;
	int32_t l4NSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QInvSizeRaw;
	int32_t l4QSizeRaw;
	long l4BlobSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piD;
	SBArrayZValInfo piDP;
	SBArrayZValInfo piDQ;
	SBArrayZValInfo piE;
	SBArrayZValInfo piN;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piQInv;
	zval *zl4DPSize;
	zval *zl4DQSize;
	zval *zl4DSize;
	zval *zl4ESize;
	zval *zl4NSize;
	zval *zl4PSize;
	zval *zl4QInvSize;
	zval *zl4QSize;
	zval *zpBlob;
	zval *zpD;
	zval *zpDP;
	zval *zpDQ;
	zval *zpE;
	zval *zpN;
	zval *zpP;
	zval *zpQ;
	zval *zpQInv;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzz", &zpBlob, &l4BlobSize, &zpN, &zl4NSize, &zpE, &zl4ESize, &zpD, &zl4DSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4NSize) && (IS_LONG == Z_TYPE_P(zl4NSize)) && ((Z_TYPE_P(zpE) == IS_STRING) || (Z_TYPE_P(zpE) == IS_ARRAY) || (Z_TYPE_P(zpE) == IS_NULL) || ((Z_TYPE_P(zpE) == IS_OBJECT) && (Z_OBJCE_P(zpE) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4ESize) && (IS_LONG == Z_TYPE_P(zl4ESize)) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DSize) && (IS_LONG == Z_TYPE_P(zl4DSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		l4NSizeRaw = (int32_t)Z_LVAL_P(zl4NSize);
		if (!SBGetPointerFromZVal(zpE, &piE TSRMLS_CC)) RETURN_FALSE;
		l4ESizeRaw = (int32_t)Z_LVAL_P(zl4ESize);
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		l4DSizeRaw = (int32_t)Z_LVAL_P(zl4DSize);
		SBCheckError(TElRSAKeyMaterial_DecodePrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piBlob.data, (int32_t)l4BlobSize, piN.data, &l4NSizeRaw, piE.data, &l4ESizeRaw, piD.data, &l4DSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piN);
		ZVAL_LONG(zl4NSize, (long)l4NSizeRaw);
		SBFreePointerZValInfo(&piE);
		ZVAL_LONG(zl4ESize, (long)l4ESizeRaw);
		SBFreePointerZValInfo(&piD);
		ZVAL_LONG(zl4DSize, (long)l4DSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzzzzzzzzzzzz", &zpBlob, &l4BlobSize, &zpN, &zl4NSize, &zpE, &zl4ESize, &zpD, &zl4DSize, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpDP, &zl4DPSize, &zpDQ, &zl4DQSize, &zpQInv, &zl4QInvSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpN) == IS_STRING) || (Z_TYPE_P(zpN) == IS_ARRAY) || (Z_TYPE_P(zpN) == IS_NULL) || ((Z_TYPE_P(zpN) == IS_OBJECT) && (Z_OBJCE_P(zpN) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4NSize) && (IS_LONG == Z_TYPE_P(zl4NSize)) && ((Z_TYPE_P(zpE) == IS_STRING) || (Z_TYPE_P(zpE) == IS_ARRAY) || (Z_TYPE_P(zpE) == IS_NULL) || ((Z_TYPE_P(zpE) == IS_OBJECT) && (Z_OBJCE_P(zpE) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4ESize) && (IS_LONG == Z_TYPE_P(zl4ESize)) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DSize) && (IS_LONG == Z_TYPE_P(zl4DSize)) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpDP) == IS_STRING) || (Z_TYPE_P(zpDP) == IS_ARRAY) || (Z_TYPE_P(zpDP) == IS_NULL) || ((Z_TYPE_P(zpDP) == IS_OBJECT) && (Z_OBJCE_P(zpDP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DPSize) && (IS_LONG == Z_TYPE_P(zl4DPSize)) && ((Z_TYPE_P(zpDQ) == IS_STRING) || (Z_TYPE_P(zpDQ) == IS_ARRAY) || (Z_TYPE_P(zpDQ) == IS_NULL) || ((Z_TYPE_P(zpDQ) == IS_OBJECT) && (Z_OBJCE_P(zpDQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DQSize) && (IS_LONG == Z_TYPE_P(zl4DQSize)) && ((Z_TYPE_P(zpQInv) == IS_STRING) || (Z_TYPE_P(zpQInv) == IS_ARRAY) || (Z_TYPE_P(zpQInv) == IS_NULL) || ((Z_TYPE_P(zpQInv) == IS_OBJECT) && (Z_OBJCE_P(zpQInv) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QInvSize) && (IS_LONG == Z_TYPE_P(zl4QInvSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpN, &piN TSRMLS_CC)) RETURN_FALSE;
		l4NSizeRaw = (int32_t)Z_LVAL_P(zl4NSize);
		if (!SBGetPointerFromZVal(zpE, &piE TSRMLS_CC)) RETURN_FALSE;
		l4ESizeRaw = (int32_t)Z_LVAL_P(zl4ESize);
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		l4DSizeRaw = (int32_t)Z_LVAL_P(zl4DSize);
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpDP, &piDP TSRMLS_CC)) RETURN_FALSE;
		l4DPSizeRaw = (int32_t)Z_LVAL_P(zl4DPSize);
		if (!SBGetPointerFromZVal(zpDQ, &piDQ TSRMLS_CC)) RETURN_FALSE;
		l4DQSizeRaw = (int32_t)Z_LVAL_P(zl4DQSize);
		if (!SBGetPointerFromZVal(zpQInv, &piQInv TSRMLS_CC)) RETURN_FALSE;
		l4QInvSizeRaw = (int32_t)Z_LVAL_P(zl4QInvSize);
		SBCheckError(TElRSAKeyMaterial_DecodePrivateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBlob.data, (int32_t)l4BlobSize, piN.data, &l4NSizeRaw, piE.data, &l4ESizeRaw, piD.data, &l4DSizeRaw, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piDP.data, &l4DPSizeRaw, piDQ.data, &l4DQSizeRaw, piQInv.data, &l4QInvSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piN);
		ZVAL_LONG(zl4NSize, (long)l4NSizeRaw);
		SBFreePointerZValInfo(&piE);
		ZVAL_LONG(zl4ESize, (long)l4ESizeRaw);
		SBFreePointerZValInfo(&piD);
		ZVAL_LONG(zl4DSize, (long)l4DSizeRaw);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piDP);
		ZVAL_LONG(zl4DPSize, (long)l4DPSizeRaw);
		SBFreePointerZValInfo(&piDQ);
		ZVAL_LONG(zl4DQSize, (long)l4DQSizeRaw);
		SBFreePointerZValInfo(&piQInv);
		ZVAL_LONG(zl4QInvSize, (long)l4QInvSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, WritePSSParams_Inst)
{
	long l4HashAlgorithm;
	long l4MGFAlgorithm;
	long l4SaltSize;
	long l4TrailerField;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llll", &l4HashAlgorithm, &l4SaltSize, &l4MGFAlgorithm, &l4TrailerField) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_WritePSSParams_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4HashAlgorithm, (int32_t)l4SaltSize, (int32_t)l4MGFAlgorithm, (int32_t)l4TrailerField, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1545272018, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, WritePSSParams)
{
	long l4HashAlgorithm;
	long l4MGFAlgorithm;
	long l4SaltSize;
	long l4TrailerField;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llll", &l4HashAlgorithm, &l4SaltSize, &l4MGFAlgorithm, &l4TrailerField) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_WritePSSParams((int32_t)l4HashAlgorithm, (int32_t)l4SaltSize, (int32_t)l4MGFAlgorithm, (int32_t)l4TrailerField, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1545272018, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, ReadPSSParams_Inst)
{
	int32_t l4HashAlgorithmRaw;
	int32_t l4MGFHashAlgorithmRaw;
	int32_t l4MGFRaw;
	int32_t l4SaltSizeRaw;
	int32_t l4TrailerFieldRaw;
	long l4InBufferSize;
	SBArrayZValInfo piInBuffer;
	zval *zl4HashAlgorithm;
	zval *zl4MGF;
	zval *zl4MGFHashAlgorithm;
	zval *zl4SaltSize;
	zval *zl4TrailerField;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzz", &zpInBuffer, &l4InBufferSize, &zl4HashAlgorithm, &zl4SaltSize, &zl4MGF, &zl4MGFHashAlgorithm, &zl4TrailerField) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4HashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4HashAlgorithm)) && PZVAL_IS_REF(zl4SaltSize) && (IS_LONG == Z_TYPE_P(zl4SaltSize)) && PZVAL_IS_REF(zl4MGF) && (IS_LONG == Z_TYPE_P(zl4MGF)) && PZVAL_IS_REF(zl4MGFHashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4MGFHashAlgorithm)) && PZVAL_IS_REF(zl4TrailerField) && (IS_LONG == Z_TYPE_P(zl4TrailerField)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		l4HashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4HashAlgorithm);
		l4SaltSizeRaw = (int32_t)Z_LVAL_P(zl4SaltSize);
		l4MGFRaw = (int32_t)Z_LVAL_P(zl4MGF);
		l4MGFHashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4MGFHashAlgorithm);
		l4TrailerFieldRaw = (int32_t)Z_LVAL_P(zl4TrailerField);
		SBCheckError(TElRSAKeyMaterial_ReadPSSParams_1(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InBufferSize, &l4HashAlgorithmRaw, &l4SaltSizeRaw, &l4MGFRaw, &l4MGFHashAlgorithmRaw, &l4TrailerFieldRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		ZVAL_LONG(zl4HashAlgorithm, (long)l4HashAlgorithmRaw);
		ZVAL_LONG(zl4SaltSize, (long)l4SaltSizeRaw);
		ZVAL_LONG(zl4MGF, (long)l4MGFRaw);
		ZVAL_LONG(zl4MGFHashAlgorithm, (long)l4MGFHashAlgorithmRaw);
		ZVAL_LONG(zl4TrailerField, (long)l4TrailerFieldRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, &integer, &integer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, ReadPSSParams)
{
	int32_t l4HashAlgorithmRaw;
	int32_t l4MGFHashAlgorithmRaw;
	int32_t l4MGFRaw;
	int32_t l4SaltSizeRaw;
	int32_t l4TrailerFieldRaw;
	long l4InBufferSize;
	SBArrayZValInfo piInBuffer;
	zval *zl4HashAlgorithm;
	zval *zl4MGF;
	zval *zl4MGFHashAlgorithm;
	zval *zl4SaltSize;
	zval *zl4TrailerField;
	zval *zpInBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzz", &zpInBuffer, &l4InBufferSize, &zl4HashAlgorithm, &zl4SaltSize, &zl4MGF, &zl4MGFHashAlgorithm, &zl4TrailerField) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4HashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4HashAlgorithm)) && PZVAL_IS_REF(zl4SaltSize) && (IS_LONG == Z_TYPE_P(zl4SaltSize)) && PZVAL_IS_REF(zl4MGF) && (IS_LONG == Z_TYPE_P(zl4MGF)) && PZVAL_IS_REF(zl4MGFHashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4MGFHashAlgorithm)) && PZVAL_IS_REF(zl4TrailerField) && (IS_LONG == Z_TYPE_P(zl4TrailerField)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		l4HashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4HashAlgorithm);
		l4SaltSizeRaw = (int32_t)Z_LVAL_P(zl4SaltSize);
		l4MGFRaw = (int32_t)Z_LVAL_P(zl4MGF);
		l4MGFHashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4MGFHashAlgorithm);
		l4TrailerFieldRaw = (int32_t)Z_LVAL_P(zl4TrailerField);
		SBCheckError(TElRSAKeyMaterial_ReadPSSParams(piInBuffer.data, (int32_t)l4InBufferSize, &l4HashAlgorithmRaw, &l4SaltSizeRaw, &l4MGFRaw, &l4MGFHashAlgorithmRaw, &l4TrailerFieldRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		ZVAL_LONG(zl4HashAlgorithm, (long)l4HashAlgorithmRaw);
		ZVAL_LONG(zl4SaltSize, (long)l4SaltSizeRaw);
		ZVAL_LONG(zl4MGF, (long)l4MGFRaw);
		ZVAL_LONG(zl4MGFHashAlgorithm, (long)l4MGFHashAlgorithmRaw);
		ZVAL_LONG(zl4TrailerField, (long)l4TrailerFieldRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, &integer, &integer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, WriteOAEPParams_Inst)
{
	char *sStrLabel;
	int sStrLabel_len;
	long l4HashAlgorithm;
	long l4MGFHashAlgorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lls", &l4HashAlgorithm, &l4MGFHashAlgorithm, &sStrLabel, &sStrLabel_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_WriteOAEPParams_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4HashAlgorithm, (int32_t)l4MGFHashAlgorithm, sStrLabel, (int32_t)sStrLabel_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-907720355, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, WriteOAEPParams)
{
	char *sStrLabel;
	int sStrLabel_len;
	long l4HashAlgorithm;
	long l4MGFHashAlgorithm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lls", &l4HashAlgorithm, &l4MGFHashAlgorithm, &sStrLabel, &sStrLabel_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_WriteOAEPParams((int32_t)l4HashAlgorithm, (int32_t)l4MGFHashAlgorithm, sStrLabel, (int32_t)sStrLabel_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-907720355, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, ReadOAEPParams_Inst)
{
	char *sStrLabel;
	int32_t l4HashAlgorithmRaw;
	int32_t l4MGFHashAlgorithmRaw;
	int32_t sStrLabel_len;
	long l4InBufferSize;
	SBArrayZValInfo piInBuffer;
	uint32_t _err;
	zval *zl4HashAlgorithm;
	zval *zl4MGFHashAlgorithm;
	zval *zpInBuffer;
	zval *zsStrLabel;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzz", &zpInBuffer, &l4InBufferSize, &zl4HashAlgorithm, &zl4MGFHashAlgorithm, &zsStrLabel) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4HashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4HashAlgorithm)) && PZVAL_IS_REF(zl4MGFHashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4MGFHashAlgorithm)) && PZVAL_IS_REF(zsStrLabel) && (IS_STRING == Z_TYPE_P(zsStrLabel)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		l4HashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4HashAlgorithm);
		l4MGFHashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4MGFHashAlgorithm);
		sStrLabel = Z_STRVAL_P(zsStrLabel);
		sStrLabel_len = (int32_t)Z_STRLEN_P(zsStrLabel);
		_err = TElRSAKeyMaterial_ReadOAEPParams_1(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InBufferSize, &l4HashAlgorithmRaw, &l4MGFHashAlgorithmRaw, sStrLabel, &sStrLabel_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sStrLabel = emalloc(sStrLabel_len + 1);
			SBCheckError(SBGetLastReturnStringA(513475573, 5, sStrLabel, &sStrLabel_len) TSRMLS_CC);
			zval_dtor(zsStrLabel);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piInBuffer);
		ZVAL_LONG(zl4HashAlgorithm, (long)l4HashAlgorithmRaw);
		ZVAL_LONG(zl4MGFHashAlgorithm, (long)l4MGFHashAlgorithmRaw);
		sStrLabel[sStrLabel_len] = 0;
		ZVAL_STRINGL(zsStrLabel, sStrLabel, sStrLabel_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, &integer, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, ReadOAEPParams)
{
	char *sStrLabel;
	int32_t l4HashAlgorithmRaw;
	int32_t l4MGFHashAlgorithmRaw;
	int32_t sStrLabel_len;
	long l4InBufferSize;
	SBArrayZValInfo piInBuffer;
	uint32_t _err;
	zval *zl4HashAlgorithm;
	zval *zl4MGFHashAlgorithm;
	zval *zpInBuffer;
	zval *zsStrLabel;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzz", &zpInBuffer, &l4InBufferSize, &zl4HashAlgorithm, &zl4MGFHashAlgorithm, &zsStrLabel) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4HashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4HashAlgorithm)) && PZVAL_IS_REF(zl4MGFHashAlgorithm) && (IS_LONG == Z_TYPE_P(zl4MGFHashAlgorithm)) && PZVAL_IS_REF(zsStrLabel) && (IS_STRING == Z_TYPE_P(zsStrLabel)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		l4HashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4HashAlgorithm);
		l4MGFHashAlgorithmRaw = (int32_t)Z_LVAL_P(zl4MGFHashAlgorithm);
		sStrLabel = Z_STRVAL_P(zsStrLabel);
		sStrLabel_len = (int32_t)Z_STRLEN_P(zsStrLabel);
		_err = TElRSAKeyMaterial_ReadOAEPParams(piInBuffer.data, (int32_t)l4InBufferSize, &l4HashAlgorithmRaw, &l4MGFHashAlgorithmRaw, sStrLabel, &sStrLabel_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sStrLabel = emalloc(sStrLabel_len + 1);
			SBCheckError(SBGetLastReturnStringA(513475573, 4, sStrLabel, &sStrLabel_len) TSRMLS_CC);
			zval_dtor(zsStrLabel);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piInBuffer);
		ZVAL_LONG(zl4HashAlgorithm, (long)l4HashAlgorithmRaw);
		ZVAL_LONG(zl4MGFHashAlgorithm, (long)l4MGFHashAlgorithmRaw);
		sStrLabel[sStrLabel_len] = 0;
		ZVAL_STRINGL(zsStrLabel, sStrLabel, sStrLabel_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, &integer, &integer, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_KeyFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRSAKeyFormatRaw fOutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_KeyFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_KeyFormat)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_KeyFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBRSAKeyFormatRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_Passphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRSAKeyMaterial_get_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-272645688, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_Passphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_PEMEncode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_PEMEncode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_PEMEncode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_PEMEncode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_StrLabel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRSAKeyMaterial_get_StrLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1400450787, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_StrLabel)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_StrLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_SaltSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_SaltSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_MGFAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_MGFAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_MGFAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_MGFAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_TrailerField)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_TrailerField)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_RawPublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRSAKeyMaterial_get_RawPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, set_RawPublicKey)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElRSAKeyMaterial_set_RawPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_PublicModulus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_get_PublicModulus(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1053276381, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_PublicExponent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_get_PublicExponent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2131135916, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, get_PrivateExponent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAKeyMaterial_get_PrivateExponent(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1734166804, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Modulus_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_ModulusSize_or_Count)
	ZEND_ARG_TYPE_INFO(0, Exponent, 0, 1)
	ZEND_ARG_INFO(0, ExponentSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Str)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_SaveToXML, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludePrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_EncodePublicKey, 0, 0, 8)
	ZEND_ARG_TYPE_INFO(0, PublicModulus, 0, 1)
	ZEND_ARG_INFO(0, PublicModulusSize)
	ZEND_ARG_TYPE_INFO(0, PublicExponent, 0, 1)
	ZEND_ARG_INFO(0, PublicExponentSize)
	ZEND_ARG_TYPE_INFO(0, AlgID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_INFO(0, InnerValuesOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_EncodePrivateKey, 0, 0, 8)
	ZEND_ARG_TYPE_INFO(0, PublicModulus_or_N, 0, 1)
	ZEND_ARG_INFO(0, PublicModulusSize_or_NSize)
	ZEND_ARG_TYPE_INFO(0, PublicExponent_or_E, 0, 1)
	ZEND_ARG_INFO(0, PublicExponentSize_or_ESize)
	ZEND_ARG_TYPE_INFO(0, PrivateExponent_or_D, 0, 1)
	ZEND_ARG_INFO(0, PrivateExponentSize_or_DSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_P, 0, 1)
	ZEND_ARG_INFO(1, OutSize_or_PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(0, QSize)
	ZEND_ARG_TYPE_INFO(0, DP_or_OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, DPSize_or_OutSize)
	ZEND_ARG_TYPE_INFO(0, DQ, 0, 1)
	ZEND_ARG_INFO(0, DQSize)
	ZEND_ARG_TYPE_INFO(0, QInv, 0, 1)
	ZEND_ARG_INFO(0, QInvSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_DecodePrivateKey, 0, 0, 8)
	ZEND_ARG_TYPE_INFO(0, Blob, 0, 1)
	ZEND_ARG_INFO(0, BlobSize)
	ZEND_ARG_TYPE_INFO(0, N, 0, 1)
	ZEND_ARG_INFO(1, NSize)
	ZEND_ARG_TYPE_INFO(0, E, 0, 1)
	ZEND_ARG_INFO(1, ESize)
	ZEND_ARG_TYPE_INFO(0, D, 0, 1)
	ZEND_ARG_INFO(1, DSize)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_INFO(1, PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(1, QSize)
	ZEND_ARG_TYPE_INFO(0, DP, 0, 1)
	ZEND_ARG_INFO(1, DPSize)
	ZEND_ARG_TYPE_INFO(0, DQ, 0, 1)
	ZEND_ARG_INFO(1, DQSize)
	ZEND_ARG_TYPE_INFO(0, QInv, 0, 1)
	ZEND_ARG_INFO(1, QInvSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_WritePSSParams_Inst, 0, 0, 4)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_INFO(0, SaltSize)
	ZEND_ARG_INFO(0, MGFAlgorithm)
	ZEND_ARG_INFO(0, TrailerField)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_WritePSSParams, 0, 0, 4)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_INFO(0, SaltSize)
	ZEND_ARG_INFO(0, MGFAlgorithm)
	ZEND_ARG_INFO(0, TrailerField)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_ReadPSSParams_Inst, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InBufferSize)
	ZEND_ARG_INFO(1, HashAlgorithm)
	ZEND_ARG_INFO(1, SaltSize)
	ZEND_ARG_INFO(1, MGF)
	ZEND_ARG_INFO(1, MGFHashAlgorithm)
	ZEND_ARG_INFO(1, TrailerField)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_ReadPSSParams, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InBufferSize)
	ZEND_ARG_INFO(1, HashAlgorithm)
	ZEND_ARG_INFO(1, SaltSize)
	ZEND_ARG_INFO(1, MGF)
	ZEND_ARG_INFO(1, MGFHashAlgorithm)
	ZEND_ARG_INFO(1, TrailerField)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_WriteOAEPParams_Inst, 0, 0, 3)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_INFO(0, MGFHashAlgorithm)
	ZEND_ARG_INFO(0, StrLabel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_WriteOAEPParams, 0, 0, 3)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_INFO(0, MGFHashAlgorithm)
	ZEND_ARG_INFO(0, StrLabel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_ReadOAEPParams_Inst, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InBufferSize)
	ZEND_ARG_INFO(1, HashAlgorithm)
	ZEND_ARG_INFO(1, MGFHashAlgorithm)
	ZEND_ARG_INFO(1, StrLabel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_ReadOAEPParams, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InBufferSize)
	ZEND_ARG_INFO(1, HashAlgorithm)
	ZEND_ARG_INFO(1, MGFHashAlgorithm)
	ZEND_ARG_INFO(1, StrLabel)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_KeyFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_KeyFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_Passphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_Passphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_PEMEncode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_PEMEncode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_StrLabel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_StrLabel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_SaltSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_SaltSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_MGFAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_MGFAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_TrailerField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_TrailerField, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_RawPublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_set_RawPublicKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_PublicModulus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_PublicExponent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial_get_PrivateExponent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRSAKeyMaterial_methods[] = {
	PHP_ME(TElRSAKeyMaterial, Assign, arginfo_TElRSAKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, LoadParameters, arginfo_TElRSAKeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, SaveParameters, arginfo_TElRSAKeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, LoadPublic, arginfo_TElRSAKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, LoadSecret, arginfo_TElRSAKeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, SavePublic, arginfo_TElRSAKeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, SaveSecret, arginfo_TElRSAKeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, LoadFromXML, arginfo_TElRSAKeyMaterial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, SaveToXML, arginfo_TElRSAKeyMaterial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, EncodePublicKey, arginfo_TElRSAKeyMaterial_EncodePublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, EncodePrivateKey, arginfo_TElRSAKeyMaterial_EncodePrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, DecodePrivateKey, arginfo_TElRSAKeyMaterial_DecodePrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, WritePSSParams_Inst, arginfo_TElRSAKeyMaterial_WritePSSParams_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, WritePSSParams, arginfo_TElRSAKeyMaterial_WritePSSParams, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRSAKeyMaterial, ReadPSSParams_Inst, arginfo_TElRSAKeyMaterial_ReadPSSParams_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, ReadPSSParams, arginfo_TElRSAKeyMaterial_ReadPSSParams, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRSAKeyMaterial, WriteOAEPParams_Inst, arginfo_TElRSAKeyMaterial_WriteOAEPParams_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, WriteOAEPParams, arginfo_TElRSAKeyMaterial_WriteOAEPParams, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRSAKeyMaterial, ReadOAEPParams_Inst, arginfo_TElRSAKeyMaterial_ReadOAEPParams_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, ReadOAEPParams, arginfo_TElRSAKeyMaterial_ReadOAEPParams, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRSAKeyMaterial, Clone, arginfo_TElRSAKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, Equals, arginfo_TElRSAKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, ClearSecret, arginfo_TElRSAKeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, ClearPublic, arginfo_TElRSAKeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_KeyFormat, arginfo_TElRSAKeyMaterial_get_KeyFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_KeyFormat, arginfo_TElRSAKeyMaterial_set_KeyFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_Passphrase, arginfo_TElRSAKeyMaterial_get_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_Passphrase, arginfo_TElRSAKeyMaterial_set_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_PEMEncode, arginfo_TElRSAKeyMaterial_get_PEMEncode, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_PEMEncode, arginfo_TElRSAKeyMaterial_set_PEMEncode, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_StrLabel, arginfo_TElRSAKeyMaterial_get_StrLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_StrLabel, arginfo_TElRSAKeyMaterial_set_StrLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_SaltSize, arginfo_TElRSAKeyMaterial_get_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_SaltSize, arginfo_TElRSAKeyMaterial_set_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_MGFAlgorithm, arginfo_TElRSAKeyMaterial_get_MGFAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_MGFAlgorithm, arginfo_TElRSAKeyMaterial_set_MGFAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_TrailerField, arginfo_TElRSAKeyMaterial_get_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_TrailerField, arginfo_TElRSAKeyMaterial_set_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_HashAlgorithm, arginfo_TElRSAKeyMaterial_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_HashAlgorithm, arginfo_TElRSAKeyMaterial_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_RawPublicKey, arginfo_TElRSAKeyMaterial_get_RawPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, set_RawPublicKey, arginfo_TElRSAKeyMaterial_set_RawPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_PublicModulus, arginfo_TElRSAKeyMaterial_get_PublicModulus, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_PublicExponent, arginfo_TElRSAKeyMaterial_get_PublicExponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, get_PrivateExponent, arginfo_TElRSAKeyMaterial_get_PrivateExponent, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAKeyMaterial, __construct, arginfo_TElRSAKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRSAKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRSAKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRSAKeyMaterial", TElRSAKeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElRSAKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRSAPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElRSAPublicKeyCrypto, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, DecryptKey)
{
	long l4EncKeySize;
	SBArrayZValInfo aiEncKeyAlgOID;
	SBArrayZValInfo aiEncKeyAlgParams;
	SBArrayZValInfo piEncKey;
	zval *zaEncKeyAlgOID;
	zval *zaEncKeyAlgParams;
	zval *zpEncKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpEncKey, &l4EncKeySize, &zaEncKeyAlgOID, &zaEncKeyAlgParams) == SUCCESS) && ((Z_TYPE_P(zpEncKey) == IS_STRING) || (Z_TYPE_P(zpEncKey) == IS_ARRAY) || (Z_TYPE_P(zpEncKey) == IS_NULL) || ((Z_TYPE_P(zpEncKey) == IS_OBJECT) && (Z_OBJCE_P(zpEncKey) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpEncKey, &piEncKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgOID, &aiEncKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgParams, &aiEncKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAPublicKeyCrypto_DecryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), piEncKey.data, (int32_t)l4EncKeySize, aiEncKeyAlgOID.data, aiEncKeyAlgOID.len, aiEncKeyAlgParams.data, aiEncKeyAlgParams.len, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piEncKey);
		SBFreeArrayZValInfo(&aiEncKeyAlgOID);
		SBFreeArrayZValInfo(&aiEncKeyAlgParams);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_CryptoType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRSAPublicKeyCryptoTypeRaw fOutResultRaw = 0;
		SBCheckError(TElRSAPublicKeyCrypto_get_CryptoType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_CryptoType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_set_CryptoType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBRSAPublicKeyCryptoTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_UseAlgorithmPrefix)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRSAPublicKeyCrypto_get_UseAlgorithmPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_UseAlgorithmPrefix)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_set_UseAlgorithmPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_HashFuncOID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRSAPublicKeyCrypto_get_HashFuncOID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1663842686, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_HashFuncOID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAPublicKeyCrypto_set_HashFuncOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_SaltSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPublicKeyCrypto_get_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_SaltSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_set_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_StrLabel)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRSAPublicKeyCrypto_get_StrLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(627013874, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_StrLabel)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_set_StrLabel(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_TrailerField)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPublicKeyCrypto_get_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_TrailerField)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_set_TrailerField(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, get_MGFAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRSAPublicKeyCrypto_get_MGFAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, set_MGFAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRSAPublicKeyCrypto_set_MGFAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAPublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAPublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAPublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_DecryptKey, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, EncKey, 0, 1)
	ZEND_ARG_INFO(0, EncKeySize)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_CryptoType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_CryptoType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_UseAlgorithmPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_UseAlgorithmPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_HashFuncOID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_HashFuncOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_SaltSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_SaltSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_StrLabel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_StrLabel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_TrailerField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_TrailerField, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_get_MGFAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto_set_MGFAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRSAPublicKeyCrypto_methods[] = {
	PHP_ME(TElRSAPublicKeyCrypto, LoadParameters, arginfo_TElRSAPublicKeyCrypto_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, SaveParameters, arginfo_TElRSAPublicKeyCrypto_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, DecryptKey, arginfo_TElRSAPublicKeyCrypto_DecryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, ClassType, arginfo_TElRSAPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_CryptoType, arginfo_TElRSAPublicKeyCrypto_get_CryptoType, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_CryptoType, arginfo_TElRSAPublicKeyCrypto_set_CryptoType, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_UseAlgorithmPrefix, arginfo_TElRSAPublicKeyCrypto_get_UseAlgorithmPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_UseAlgorithmPrefix, arginfo_TElRSAPublicKeyCrypto_set_UseAlgorithmPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_HashFuncOID, arginfo_TElRSAPublicKeyCrypto_get_HashFuncOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_HashFuncOID, arginfo_TElRSAPublicKeyCrypto_set_HashFuncOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_SaltSize, arginfo_TElRSAPublicKeyCrypto_get_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_SaltSize, arginfo_TElRSAPublicKeyCrypto_set_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_StrLabel, arginfo_TElRSAPublicKeyCrypto_get_StrLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_StrLabel, arginfo_TElRSAPublicKeyCrypto_set_StrLabel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_TrailerField, arginfo_TElRSAPublicKeyCrypto_get_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_TrailerField, arginfo_TElRSAPublicKeyCrypto_set_TrailerField, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, get_MGFAlgorithm, arginfo_TElRSAPublicKeyCrypto_get_MGFAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, set_MGFAlgorithm, arginfo_TElRSAPublicKeyCrypto_set_MGFAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAPublicKeyCrypto, __construct, arginfo_TElRSAPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRSAPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRSAPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRSAPublicKeyCrypto", TElRSAPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElRSAPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDSAKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElDSAKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, Generate)
{
	long l4Bits;
	long l4PBits;
	long l4QBits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4PBits, &l4QBits) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_Generate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4PBits, (int32_t)l4QBits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, BeginGenerate)
{
	long l4PBits;
	long l4QBits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4PBits, &l4QBits) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_BeginGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4PBits, (int32_t)l4QBits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, LoadSecret)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElDSAKeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, LoadPublic)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElDSAKeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, ImportPublicKey)
{
	long l4GSize;
	long l4PSize;
	long l4QSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piY;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzl", &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpY, &l4YSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_ImportPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, ExportPublicKey)
{
	int32_t l4GSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4YSizeRaw;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piY;
	zval *zl4GSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4YSize;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzzzzzz", &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		SBCheckError(TElDSAKeyMaterial_ExportPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, LoadFromXML)
{
	char *sStr;
	int sStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sStr, (int32_t)sStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, SaveToXML)
{
	uint32_t _err;
	zend_bool bIncludePrivateKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludePrivateKey) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDSAKeyMaterial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludePrivateKey, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-868493960, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, EncodePrivateKey)
{
	int32_t l4OutSizeRaw;
	long l4GSize;
	long l4PSize;
	long l4QSize;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4OutSize;
	zval *zpG;
	zval *zpOutBuffer;
	zval *zpP;
	zval *zpQ;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzz", &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpX, &l4XSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElDSAKeyMaterial_EncodePrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piX.data, (int32_t)l4XSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, DecodePrivateKey)
{
	int32_t l4GSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4XSizeRaw;
	int32_t l4YSizeRaw;
	long l4BlobSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *zl4GSize;
	zval *zl4PSize;
	zval *zl4QSize;
	zval *zl4XSize;
	zval *zl4YSize;
	zval *zpBlob;
	zval *zpG;
	zval *zpP;
	zval *zpQ;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzzzzzz", &zpBlob, &l4BlobSize, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpG, &zl4GSize, &zpY, &zl4YSize, &zpX, &zl4XSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4GSize) && (IS_LONG == Z_TYPE_P(zl4GSize)) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4YSize) && (IS_LONG == Z_TYPE_P(zl4YSize)) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4XSize) && (IS_LONG == Z_TYPE_P(zl4XSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		l4GSizeRaw = (int32_t)Z_LVAL_P(zl4GSize);
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		l4YSizeRaw = (int32_t)Z_LVAL_P(zl4YSize);
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		l4XSizeRaw = (int32_t)Z_LVAL_P(zl4XSize);
		SBCheckError(TElDSAKeyMaterial_DecodePrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piBlob.data, (int32_t)l4BlobSize, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piG.data, &l4GSizeRaw, piY.data, &l4YSizeRaw, piX.data, &l4XSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piG);
		ZVAL_LONG(zl4GSize, (long)l4GSizeRaw);
		SBFreePointerZValInfo(&piY);
		ZVAL_LONG(zl4YSize, (long)l4YSizeRaw);
		SBFreePointerZValInfo(&piX);
		ZVAL_LONG(zl4XSize, (long)l4XSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDSAKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_KeyFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDSAKeyFormatRaw fOutResultRaw = 0;
		SBCheckError(TElDSAKeyMaterial_get_KeyFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_QBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDSAKeyMaterial_get_QBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDSAKeyMaterial_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_Passphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDSAKeyMaterial_get_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-132735916, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_Passphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_set_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_PEMEncode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDSAKeyMaterial_get_PEMEncode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_PEMEncode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_set_PEMEncode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_StrictKeyValidation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDSAKeyMaterial_get_StrictKeyValidation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_StrictKeyValidation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDSAKeyMaterial_set_StrictKeyValidation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAKeyMaterial_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1836464111, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_P)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAKeyMaterial_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-443615097, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_Q)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_set_Q(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAKeyMaterial_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(291130838, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_G)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_set_G(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAKeyMaterial_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-346722123, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_Y)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_set_Y(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDSAKeyMaterial_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1672331229, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, set_X)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAKeyMaterial_set_X(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_Generate, 0, 0, 0)
	ZEND_ARG_INFO(0, Bits_or_PBits)
	ZEND_ARG_INFO(0, QBits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_BeginGenerate, 0, 0, 1)
	ZEND_ARG_INFO(0, PBits)
	ZEND_ARG_INFO(0, QBits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_ImportPublicKey, 0, 0, 8)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_INFO(0, PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(0, QSize)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(0, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_ExportPublicKey, 0, 0, 8)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_INFO(1, PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(1, QSize)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(1, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(1, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Str)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_SaveToXML, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludePrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_EncodePrivateKey, 0, 0, 12)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_INFO(0, PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(0, QSize)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(0, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YSize)
	ZEND_ARG_TYPE_INFO(0, X, 0, 1)
	ZEND_ARG_INFO(0, XSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_DecodePrivateKey, 0, 0, 12)
	ZEND_ARG_TYPE_INFO(0, Blob, 0, 1)
	ZEND_ARG_INFO(0, BlobSize)
	ZEND_ARG_TYPE_INFO(0, P, 0, 1)
	ZEND_ARG_INFO(1, PSize)
	ZEND_ARG_TYPE_INFO(0, Q, 0, 1)
	ZEND_ARG_INFO(1, QSize)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(1, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(1, YSize)
	ZEND_ARG_TYPE_INFO(0, X, 0, 1)
	ZEND_ARG_INFO(1, XSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_KeyFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_QBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_Passphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_Passphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_PEMEncode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_PEMEncode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_StrictKeyValidation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_StrictKeyValidation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_P, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_Q, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_G, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_Y, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial_set_X, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDSAKeyMaterial_methods[] = {
	PHP_ME(TElDSAKeyMaterial, Assign, arginfo_TElDSAKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, LoadParameters, arginfo_TElDSAKeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, SaveParameters, arginfo_TElDSAKeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, Generate, arginfo_TElDSAKeyMaterial_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, BeginGenerate, arginfo_TElDSAKeyMaterial_BeginGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, LoadSecret, arginfo_TElDSAKeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, SaveSecret, arginfo_TElDSAKeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, LoadPublic, arginfo_TElDSAKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, SavePublic, arginfo_TElDSAKeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, ImportPublicKey, arginfo_TElDSAKeyMaterial_ImportPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, ExportPublicKey, arginfo_TElDSAKeyMaterial_ExportPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, LoadFromXML, arginfo_TElDSAKeyMaterial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, SaveToXML, arginfo_TElDSAKeyMaterial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, EncodePrivateKey, arginfo_TElDSAKeyMaterial_EncodePrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, DecodePrivateKey, arginfo_TElDSAKeyMaterial_DecodePrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, Clone, arginfo_TElDSAKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, Equals, arginfo_TElDSAKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, ClearSecret, arginfo_TElDSAKeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, ClearPublic, arginfo_TElDSAKeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_KeyFormat, arginfo_TElDSAKeyMaterial_get_KeyFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_QBits, arginfo_TElDSAKeyMaterial_get_QBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_HashAlgorithm, arginfo_TElDSAKeyMaterial_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_HashAlgorithm, arginfo_TElDSAKeyMaterial_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_Passphrase, arginfo_TElDSAKeyMaterial_get_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_Passphrase, arginfo_TElDSAKeyMaterial_set_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_PEMEncode, arginfo_TElDSAKeyMaterial_get_PEMEncode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_PEMEncode, arginfo_TElDSAKeyMaterial_set_PEMEncode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_StrictKeyValidation, arginfo_TElDSAKeyMaterial_get_StrictKeyValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_StrictKeyValidation, arginfo_TElDSAKeyMaterial_set_StrictKeyValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_P, arginfo_TElDSAKeyMaterial_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_P, arginfo_TElDSAKeyMaterial_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_Q, arginfo_TElDSAKeyMaterial_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_Q, arginfo_TElDSAKeyMaterial_set_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_G, arginfo_TElDSAKeyMaterial_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_G, arginfo_TElDSAKeyMaterial_set_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_Y, arginfo_TElDSAKeyMaterial_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_Y, arginfo_TElDSAKeyMaterial_set_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, get_X, arginfo_TElDSAKeyMaterial_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, set_X, arginfo_TElDSAKeyMaterial_set_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAKeyMaterial, __construct, arginfo_TElDSAKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDSAKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDSAKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDSAKeyMaterial", TElDSAKeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElDSAKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDSAPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElDSAPublicKeyCrypto, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAPublicKeyCrypto_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAPublicKeyCrypto, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDSAPublicKeyCrypto_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAPublicKeyCrypto, EncodeSignature)
{
	int32_t l4SigSizeRaw;
	long l4RSize;
	long l4SSize;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piSig;
	zval *zl4SigSize;
	zval *zpR;
	zval *zpS;
	zval *zpSig;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpR, &l4RSize, &zpS, &l4SSize, &zpSig, &zl4SigSize) == SUCCESS) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSig) == IS_STRING) || (Z_TYPE_P(zpSig) == IS_ARRAY) || (Z_TYPE_P(zpSig) == IS_NULL) || ((Z_TYPE_P(zpSig) == IS_OBJECT) && (Z_OBJCE_P(zpSig) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SigSize) && (IS_LONG == Z_TYPE_P(zl4SigSize)))
	{
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSig, &piSig TSRMLS_CC)) RETURN_FALSE;
		l4SigSizeRaw = (int32_t)Z_LVAL_P(zl4SigSize);
		SBCheckError(TElDSAPublicKeyCrypto_EncodeSignature(SBGetObjectHandle(getThis() TSRMLS_CC), piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, piSig.data, &l4SigSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		SBFreePointerZValInfo(&piSig);
		ZVAL_LONG(zl4SigSize, (long)l4SigSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAPublicKeyCrypto, DecodeSignature)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4SigSize;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piSig;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpR;
	zval *zpS;
	zval *zpSig;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzz", &zpSig, &l4SigSize, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpSig) == IS_STRING) || (Z_TYPE_P(zpSig) == IS_ARRAY) || (Z_TYPE_P(zpSig) == IS_NULL) || ((Z_TYPE_P(zpSig) == IS_OBJECT) && (Z_OBJCE_P(zpSig) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		if (!SBGetPointerFromZVal(zpSig, &piSig TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(TElDSAPublicKeyCrypto_DecodeSignature(SBGetObjectHandle(getThis() TSRMLS_CC), piSig.data, (int32_t)l4SigSize, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piSig);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDSAPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAPublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAPublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAPublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDSAPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDSAPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAPublicKeyCrypto_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAPublicKeyCrypto_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAPublicKeyCrypto_EncodeSignature, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, R, 0, 1)
	ZEND_ARG_INFO(0, RSize)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
	ZEND_ARG_INFO(0, SSize)
	ZEND_ARG_TYPE_INFO(0, Sig, 0, 1)
	ZEND_ARG_INFO(1, SigSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAPublicKeyCrypto_DecodeSignature, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Sig, 0, 1)
	ZEND_ARG_INFO(0, SigSize)
	ZEND_ARG_TYPE_INFO(0, R, 0, 1)
	ZEND_ARG_INFO(1, RSize)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
	ZEND_ARG_INFO(1, SSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDSAPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDSAPublicKeyCrypto_methods[] = {
	PHP_ME(TElDSAPublicKeyCrypto, LoadParameters, arginfo_TElDSAPublicKeyCrypto_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAPublicKeyCrypto, SaveParameters, arginfo_TElDSAPublicKeyCrypto_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAPublicKeyCrypto, EncodeSignature, arginfo_TElDSAPublicKeyCrypto_EncodeSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAPublicKeyCrypto, DecodeSignature, arginfo_TElDSAPublicKeyCrypto_DecodeSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElDSAPublicKeyCrypto, ClassType, arginfo_TElDSAPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDSAPublicKeyCrypto, __construct, arginfo_TElDSAPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDSAPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDSAPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDSAPublicKeyCrypto", TElDSAPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElDSAPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElECKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElECKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, Generate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_Generate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, LoadSecret)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElECKeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, LoadPublic)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElECKeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, ImportPublicKey)
{
	long l4QXSize;
	long l4QYSize;
	SBArrayZValInfo piQX;
	SBArrayZValInfo piQY;
	zval *zpQX;
	zval *zpQY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpQX, &l4QXSize, &zpQY, &l4QYSize) == SUCCESS) && ((Z_TYPE_P(zpQX) == IS_STRING) || (Z_TYPE_P(zpQX) == IS_ARRAY) || (Z_TYPE_P(zpQX) == IS_NULL) || ((Z_TYPE_P(zpQX) == IS_OBJECT) && (Z_OBJCE_P(zpQX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQY) == IS_STRING) || (Z_TYPE_P(zpQY) == IS_ARRAY) || (Z_TYPE_P(zpQY) == IS_NULL) || ((Z_TYPE_P(zpQY) == IS_OBJECT) && (Z_OBJCE_P(zpQY) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpQX, &piQX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQY, &piQY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_ImportPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), piQX.data, (int32_t)l4QXSize, piQY.data, (int32_t)l4QYSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piQX);
		SBFreePointerZValInfo(&piQY);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, ExportPublicKey)
{
	int32_t l4QXSizeRaw;
	int32_t l4QYSizeRaw;
	SBArrayZValInfo piQX;
	SBArrayZValInfo piQY;
	zval *zl4QXSize;
	zval *zl4QYSize;
	zval *zpQX;
	zval *zpQY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zpQX, &zl4QXSize, &zpQY, &zl4QYSize) == SUCCESS) && ((Z_TYPE_P(zpQX) == IS_STRING) || (Z_TYPE_P(zpQX) == IS_ARRAY) || (Z_TYPE_P(zpQX) == IS_NULL) || ((Z_TYPE_P(zpQX) == IS_OBJECT) && (Z_OBJCE_P(zpQX) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QXSize) && (IS_LONG == Z_TYPE_P(zl4QXSize)) && ((Z_TYPE_P(zpQY) == IS_STRING) || (Z_TYPE_P(zpQY) == IS_ARRAY) || (Z_TYPE_P(zpQY) == IS_NULL) || ((Z_TYPE_P(zpQY) == IS_OBJECT) && (Z_OBJCE_P(zpQY) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QYSize) && (IS_LONG == Z_TYPE_P(zl4QYSize)))
	{
		if (!SBGetPointerFromZVal(zpQX, &piQX TSRMLS_CC)) RETURN_FALSE;
		l4QXSizeRaw = (int32_t)Z_LVAL_P(zl4QXSize);
		if (!SBGetPointerFromZVal(zpQY, &piQY TSRMLS_CC)) RETURN_FALSE;
		l4QYSizeRaw = (int32_t)Z_LVAL_P(zl4QYSize);
		SBCheckError(TElECKeyMaterial_ExportPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), piQX.data, &l4QXSizeRaw, piQY.data, &l4QYSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piQX);
		ZVAL_LONG(zl4QXSize, (long)l4QXSizeRaw);
		SBFreePointerZValInfo(&piQY);
		ZVAL_LONG(zl4QYSize, (long)l4QYSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, EncodePrivateKey)
{
	int32_t l4OutSizeRaw;
	long l4Curve;
	long l4DSize;
	long l4QxSize;
	long l4QySize;
	SBArrayZValInfo piD;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piQx;
	SBArrayZValInfo piQy;
	zval *zl4OutSize;
	zval *zpD;
	zval *zpOutBuffer;
	zval *zpQx;
	zval *zpQy;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzllzz", &zpD, &l4DSize, &zpQx, &l4QxSize, &zpQy, &l4QySize, &l4Curve, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQx) == IS_STRING) || (Z_TYPE_P(zpQx) == IS_ARRAY) || (Z_TYPE_P(zpQx) == IS_NULL) || ((Z_TYPE_P(zpQx) == IS_OBJECT) && (Z_OBJCE_P(zpQx) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQy) == IS_STRING) || (Z_TYPE_P(zpQy) == IS_ARRAY) || (Z_TYPE_P(zpQy) == IS_NULL) || ((Z_TYPE_P(zpQy) == IS_OBJECT) && (Z_OBJCE_P(zpQy) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQx, &piQx TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQy, &piQy TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElECKeyMaterial_EncodePrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piD.data, (int32_t)l4DSize, piQx.data, (int32_t)l4QxSize, piQy.data, (int32_t)l4QySize, (int32_t)l4Curve, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piD);
		SBFreePointerZValInfo(&piQx);
		SBFreePointerZValInfo(&piQy);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, DecodePrivateKey)
{
	int32_t l4CurveRaw;
	int32_t l4DSizeRaw;
	int32_t l4QxSizeRaw;
	int32_t l4QySizeRaw;
	long l4BlobSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piD;
	SBArrayZValInfo piQx;
	SBArrayZValInfo piQy;
	zval *zl4Curve;
	zval *zl4DSize;
	zval *zl4QxSize;
	zval *zl4QySize;
	zval *zpBlob;
	zval *zpD;
	zval *zpQx;
	zval *zpQy;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzzz", &zpBlob, &l4BlobSize, &zpD, &zl4DSize, &zpQx, &zl4QxSize, &zpQy, &zl4QySize, &zl4Curve) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpD) == IS_STRING) || (Z_TYPE_P(zpD) == IS_ARRAY) || (Z_TYPE_P(zpD) == IS_NULL) || ((Z_TYPE_P(zpD) == IS_OBJECT) && (Z_OBJCE_P(zpD) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4DSize) && (IS_LONG == Z_TYPE_P(zl4DSize)) && ((Z_TYPE_P(zpQx) == IS_STRING) || (Z_TYPE_P(zpQx) == IS_ARRAY) || (Z_TYPE_P(zpQx) == IS_NULL) || ((Z_TYPE_P(zpQx) == IS_OBJECT) && (Z_OBJCE_P(zpQx) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QxSize) && (IS_LONG == Z_TYPE_P(zl4QxSize)) && ((Z_TYPE_P(zpQy) == IS_STRING) || (Z_TYPE_P(zpQy) == IS_ARRAY) || (Z_TYPE_P(zpQy) == IS_NULL) || ((Z_TYPE_P(zpQy) == IS_OBJECT) && (Z_OBJCE_P(zpQy) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QySize) && (IS_LONG == Z_TYPE_P(zl4QySize)) && PZVAL_IS_REF(zl4Curve) && (IS_LONG == Z_TYPE_P(zl4Curve)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpD, &piD TSRMLS_CC)) RETURN_FALSE;
		l4DSizeRaw = (int32_t)Z_LVAL_P(zl4DSize);
		if (!SBGetPointerFromZVal(zpQx, &piQx TSRMLS_CC)) RETURN_FALSE;
		l4QxSizeRaw = (int32_t)Z_LVAL_P(zl4QxSize);
		if (!SBGetPointerFromZVal(zpQy, &piQy TSRMLS_CC)) RETURN_FALSE;
		l4QySizeRaw = (int32_t)Z_LVAL_P(zl4QySize);
		l4CurveRaw = (int32_t)Z_LVAL_P(zl4Curve);
		SBCheckError(TElECKeyMaterial_DecodePrivateKey(SBGetObjectHandle(getThis() TSRMLS_CC), piBlob.data, (int32_t)l4BlobSize, piD.data, &l4DSizeRaw, piQx.data, &l4QxSizeRaw, piQy.data, &l4QySizeRaw, &l4CurveRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piD);
		ZVAL_LONG(zl4DSize, (long)l4DSizeRaw);
		SBFreePointerZValInfo(&piQx);
		ZVAL_LONG(zl4QxSize, (long)l4QxSizeRaw);
		SBFreePointerZValInfo(&piQy);
		ZVAL_LONG(zl4QySize, (long)l4QySizeRaw);
		ZVAL_LONG(zl4Curve, (long)l4CurveRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_CompressPoints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_CompressPoints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_CompressPoints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_CompressPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_HybridPoints)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_HybridPoints(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_HybridPoints)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_HybridPoints(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_FieldType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_FieldType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_FieldType)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_FieldType(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_Field)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_Field(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_FieldBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_FieldBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_M)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_M(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_M)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_M(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_K1)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_K1(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_K1)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_K1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_K2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_K2(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_K2)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_K2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_K3)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_K3(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_K3)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_K3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_RecommendedHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_RecommendedHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_D)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_D(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1021177120, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_D)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_D(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_N)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_N(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(603454462, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_N)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_N(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_H)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_H(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_H)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_H(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_A)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_A(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1287068049, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_A)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_A(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_B)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_B(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(708949973, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_B)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_B(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-685551953, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_X)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_X(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1608221127, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_Y)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_Y(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1358957045, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_Q)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_Q(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_QX)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_QX(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-221446216, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_QX)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_QX(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_QY)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_QY(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2050240722, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_QY)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_QY(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_Base)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_Base(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1371709565, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_Base)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_Base(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-638007651, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_P)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_Curve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_Curve)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_CurveOID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_CurveOID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(832490290, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_CurveOID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_CurveOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_SpecifiedCurve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_SpecifiedCurve(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_SpecifiedCurve)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_SpecifiedCurve(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_ImplicitCurve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElECKeyMaterial_get_ImplicitCurve(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_ImplicitCurve)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElECKeyMaterial_set_ImplicitCurve(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, get_Seed)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElECKeyMaterial_get_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-705577702, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, set_Seed)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECKeyMaterial_set_Seed(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_Generate, 0, 0, 0)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_ImportPublicKey, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, QX, 0, 1)
	ZEND_ARG_INFO(0, QXSize)
	ZEND_ARG_TYPE_INFO(0, QY, 0, 1)
	ZEND_ARG_INFO(0, QYSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_ExportPublicKey, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, QX, 0, 1)
	ZEND_ARG_INFO(1, QXSize)
	ZEND_ARG_TYPE_INFO(0, QY, 0, 1)
	ZEND_ARG_INFO(1, QYSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_EncodePrivateKey, 0, 0, 9)
	ZEND_ARG_TYPE_INFO(0, D, 0, 1)
	ZEND_ARG_INFO(0, DSize)
	ZEND_ARG_TYPE_INFO(0, Qx, 0, 1)
	ZEND_ARG_INFO(0, QxSize)
	ZEND_ARG_TYPE_INFO(0, Qy, 0, 1)
	ZEND_ARG_INFO(0, QySize)
	ZEND_ARG_INFO(0, Curve)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_DecodePrivateKey, 0, 0, 9)
	ZEND_ARG_TYPE_INFO(0, Blob, 0, 1)
	ZEND_ARG_INFO(0, BlobSize)
	ZEND_ARG_TYPE_INFO(0, D, 0, 1)
	ZEND_ARG_INFO(1, DSize)
	ZEND_ARG_TYPE_INFO(0, Qx, 0, 1)
	ZEND_ARG_INFO(1, QxSize)
	ZEND_ARG_TYPE_INFO(0, Qy, 0, 1)
	ZEND_ARG_INFO(1, QySize)
	ZEND_ARG_INFO(1, Curve)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_CompressPoints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_CompressPoints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_HybridPoints, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_HybridPoints, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_FieldType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_FieldType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_Field, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_FieldBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_M, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_M, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_K1, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_K1, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_K2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_K2, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_K3, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_K3, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_RecommendedHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_D, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_D, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_N, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_N, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_H, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_H, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_A, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_A, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_B, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_B, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_X, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_Y, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_Q, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_QX, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_QX, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_QY, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_QY, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_Base, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_Base, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_P, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_Curve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_Curve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_CurveOID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_CurveOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_SpecifiedCurve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_SpecifiedCurve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_ImplicitCurve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_ImplicitCurve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_get_Seed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial_set_Seed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElECKeyMaterial_methods[] = {
	PHP_ME(TElECKeyMaterial, Assign, arginfo_TElECKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, Generate, arginfo_TElECKeyMaterial_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, LoadParameters, arginfo_TElECKeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, SaveParameters, arginfo_TElECKeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, LoadSecret, arginfo_TElECKeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, SaveSecret, arginfo_TElECKeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, LoadPublic, arginfo_TElECKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, SavePublic, arginfo_TElECKeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, ImportPublicKey, arginfo_TElECKeyMaterial_ImportPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, ExportPublicKey, arginfo_TElECKeyMaterial_ExportPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, Clone, arginfo_TElECKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, Equals, arginfo_TElECKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, ClearSecret, arginfo_TElECKeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, ClearPublic, arginfo_TElECKeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, EncodePrivateKey, arginfo_TElECKeyMaterial_EncodePrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, DecodePrivateKey, arginfo_TElECKeyMaterial_DecodePrivateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_CompressPoints, arginfo_TElECKeyMaterial_get_CompressPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_CompressPoints, arginfo_TElECKeyMaterial_set_CompressPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_HybridPoints, arginfo_TElECKeyMaterial_get_HybridPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_HybridPoints, arginfo_TElECKeyMaterial_set_HybridPoints, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_FieldType, arginfo_TElECKeyMaterial_get_FieldType, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_FieldType, arginfo_TElECKeyMaterial_set_FieldType, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_Field, arginfo_TElECKeyMaterial_get_Field, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_FieldBits, arginfo_TElECKeyMaterial_get_FieldBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_M, arginfo_TElECKeyMaterial_get_M, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_M, arginfo_TElECKeyMaterial_set_M, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_K1, arginfo_TElECKeyMaterial_get_K1, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_K1, arginfo_TElECKeyMaterial_set_K1, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_K2, arginfo_TElECKeyMaterial_get_K2, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_K2, arginfo_TElECKeyMaterial_set_K2, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_K3, arginfo_TElECKeyMaterial_get_K3, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_K3, arginfo_TElECKeyMaterial_set_K3, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_HashAlgorithm, arginfo_TElECKeyMaterial_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_HashAlgorithm, arginfo_TElECKeyMaterial_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_RecommendedHashAlgorithm, arginfo_TElECKeyMaterial_get_RecommendedHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_D, arginfo_TElECKeyMaterial_get_D, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_D, arginfo_TElECKeyMaterial_set_D, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_N, arginfo_TElECKeyMaterial_get_N, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_N, arginfo_TElECKeyMaterial_set_N, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_H, arginfo_TElECKeyMaterial_get_H, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_H, arginfo_TElECKeyMaterial_set_H, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_A, arginfo_TElECKeyMaterial_get_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_A, arginfo_TElECKeyMaterial_set_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_B, arginfo_TElECKeyMaterial_get_B, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_B, arginfo_TElECKeyMaterial_set_B, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_X, arginfo_TElECKeyMaterial_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_X, arginfo_TElECKeyMaterial_set_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_Y, arginfo_TElECKeyMaterial_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_Y, arginfo_TElECKeyMaterial_set_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_Q, arginfo_TElECKeyMaterial_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_Q, arginfo_TElECKeyMaterial_set_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_QX, arginfo_TElECKeyMaterial_get_QX, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_QX, arginfo_TElECKeyMaterial_set_QX, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_QY, arginfo_TElECKeyMaterial_get_QY, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_QY, arginfo_TElECKeyMaterial_set_QY, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_Base, arginfo_TElECKeyMaterial_get_Base, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_Base, arginfo_TElECKeyMaterial_set_Base, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_P, arginfo_TElECKeyMaterial_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_P, arginfo_TElECKeyMaterial_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_Curve, arginfo_TElECKeyMaterial_get_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_Curve, arginfo_TElECKeyMaterial_set_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_CurveOID, arginfo_TElECKeyMaterial_get_CurveOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_CurveOID, arginfo_TElECKeyMaterial_set_CurveOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_SpecifiedCurve, arginfo_TElECKeyMaterial_get_SpecifiedCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_SpecifiedCurve, arginfo_TElECKeyMaterial_set_SpecifiedCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_ImplicitCurve, arginfo_TElECKeyMaterial_get_ImplicitCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_ImplicitCurve, arginfo_TElECKeyMaterial_set_ImplicitCurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, get_Seed, arginfo_TElECKeyMaterial_get_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, set_Seed, arginfo_TElECKeyMaterial_set_Seed, ZEND_ACC_PUBLIC)
	PHP_ME(TElECKeyMaterial, __construct, arginfo_TElECKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElECKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElECKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElECKeyMaterial", TElECKeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElECKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElECDSAPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElECDSAPublicKeyCrypto, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECDSAPublicKeyCrypto_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAPublicKeyCrypto, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECDSAPublicKeyCrypto_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAPublicKeyCrypto, EncodeSignature)
{
	int32_t l4SigSizeRaw;
	long l4RSize;
	long l4SSize;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piSig;
	zval *zl4SigSize;
	zval *zpR;
	zval *zpS;
	zval *zpSig;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpR, &l4RSize, &zpS, &l4SSize, &zpSig, &zl4SigSize) == SUCCESS) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSig) == IS_STRING) || (Z_TYPE_P(zpSig) == IS_ARRAY) || (Z_TYPE_P(zpSig) == IS_NULL) || ((Z_TYPE_P(zpSig) == IS_OBJECT) && (Z_OBJCE_P(zpSig) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SigSize) && (IS_LONG == Z_TYPE_P(zl4SigSize)))
	{
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSig, &piSig TSRMLS_CC)) RETURN_FALSE;
		l4SigSizeRaw = (int32_t)Z_LVAL_P(zl4SigSize);
		SBCheckError(TElECDSAPublicKeyCrypto_EncodeSignature(SBGetObjectHandle(getThis() TSRMLS_CC), piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, piSig.data, &l4SigSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		SBFreePointerZValInfo(&piSig);
		ZVAL_LONG(zl4SigSize, (long)l4SigSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAPublicKeyCrypto, DecodeSignature)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4SigSize;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	SBArrayZValInfo piSig;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpR;
	zval *zpS;
	zval *zpSig;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzz", &zpSig, &l4SigSize, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpSig) == IS_STRING) || (Z_TYPE_P(zpSig) == IS_ARRAY) || (Z_TYPE_P(zpSig) == IS_NULL) || ((Z_TYPE_P(zpSig) == IS_OBJECT) && (Z_OBJCE_P(zpSig) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		if (!SBGetPointerFromZVal(zpSig, &piSig TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(TElECDSAPublicKeyCrypto_DecodeSignature(SBGetObjectHandle(getThis() TSRMLS_CC), piSig.data, (int32_t)l4SigSize, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piSig);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDSAPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDSAPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECDSAPublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDSAPublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDSAPublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECDSAPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDSAPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDSAPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAPublicKeyCrypto_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAPublicKeyCrypto_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAPublicKeyCrypto_EncodeSignature, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, R, 0, 1)
	ZEND_ARG_INFO(0, RSize)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
	ZEND_ARG_INFO(0, SSize)
	ZEND_ARG_TYPE_INFO(0, Sig, 0, 1)
	ZEND_ARG_INFO(1, SigSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAPublicKeyCrypto_DecodeSignature, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Sig, 0, 1)
	ZEND_ARG_INFO(0, SigSize)
	ZEND_ARG_TYPE_INFO(0, R, 0, 1)
	ZEND_ARG_INFO(1, RSize)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
	ZEND_ARG_INFO(1, SSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDSAPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElECDSAPublicKeyCrypto_methods[] = {
	PHP_ME(TElECDSAPublicKeyCrypto, LoadParameters, arginfo_TElECDSAPublicKeyCrypto_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAPublicKeyCrypto, SaveParameters, arginfo_TElECDSAPublicKeyCrypto_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAPublicKeyCrypto, EncodeSignature, arginfo_TElECDSAPublicKeyCrypto_EncodeSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAPublicKeyCrypto, DecodeSignature, arginfo_TElECDSAPublicKeyCrypto_DecodeSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDSAPublicKeyCrypto, ClassType, arginfo_TElECDSAPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElECDSAPublicKeyCrypto, __construct, arginfo_TElECDSAPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElECDSAPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElECDSAPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElECDSAPublicKeyCrypto", TElECDSAPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElECDSAPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElECDHPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElECDHPublicKeyCrypto, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECDHPublicKeyCrypto_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDHPublicKeyCrypto, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElECDHPublicKeyCrypto_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDHPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDHPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElECDHPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDHPublicKeyCrypto_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECDHPublicKeyCrypto_Create_1(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDHPublicKeyCrypto_Create_2((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElECDHPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDHPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElECDHPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDHPublicKeyCrypto_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDHPublicKeyCrypto_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDHPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElECDHPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_OID_or_Alg_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElECDHPublicKeyCrypto_methods[] = {
	PHP_ME(TElECDHPublicKeyCrypto, LoadParameters, arginfo_TElECDHPublicKeyCrypto_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDHPublicKeyCrypto, SaveParameters, arginfo_TElECDHPublicKeyCrypto_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElECDHPublicKeyCrypto, ClassType, arginfo_TElECDHPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElECDHPublicKeyCrypto, __construct, arginfo_TElECDHPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElECDHPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElECDHPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElECDHPublicKeyCrypto", TElECDHPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElECDHPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDHKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElDHKeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, LoadPublic)
{
	long l4Count;
	long l4GSize;
	long l4PSize;
	long l4Size;
	long l4YSize;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piY;
	zval *oStream;
	zval *zpBuffer;
	zval *zpG;
	zval *zpP;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzl", &zpP, &l4PSize, &zpG, &l4GSize, &zpY, &l4YSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_LoadPublic_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElDHKeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElDHKeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, LoadSecret)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, LoadPeerY)
{
	long l4YSize;
	SBArrayZValInfo piY;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpY, &l4YSize) == SUCCESS) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_LoadPeerY(SBGetObjectHandle(getThis() TSRMLS_CC), piY.data, (int32_t)l4YSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piY);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, LoadFromXML)
{
	char *sStr;
	int sStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sStr, (int32_t)sStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, SaveToXML)
{
	uint32_t _err;
	zend_bool bIncludePrivateKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludePrivateKey) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDHKeyMaterial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludePrivateKey, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1774934598, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDHKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDHKeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, get_KeyFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDHKeyFormatRaw fOutResultRaw = 0;
		SBCheckError(TElDHKeyMaterial_get_KeyFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHKeyMaterial_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-204655189, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, set_P)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_set_P(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHKeyMaterial_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1881059436, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, set_G)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_set_G(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHKeyMaterial_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-48841319, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, set_X)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_set_X(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHKeyMaterial_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1978561265, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, set_Y)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_set_Y(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, get_PeerY)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDHKeyMaterial_get_PeerY(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1351594236, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, set_PeerY)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHKeyMaterial_set_PeerY(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, P_or_Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, PSize_or_Size_or_Count)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(0, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_LoadPeerY, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Str)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_SaveToXML, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludePrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_get_KeyFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_set_P, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_set_G, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_set_X, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_set_Y, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_get_PeerY, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial_set_PeerY, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDHKeyMaterial_methods[] = {
	PHP_ME(TElDHKeyMaterial, LoadParameters, arginfo_TElDHKeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, SaveParameters, arginfo_TElDHKeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, LoadPublic, arginfo_TElDHKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, SavePublic, arginfo_TElDHKeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, SaveSecret, arginfo_TElDHKeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, LoadSecret, arginfo_TElDHKeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, LoadPeerY, arginfo_TElDHKeyMaterial_LoadPeerY, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, LoadFromXML, arginfo_TElDHKeyMaterial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, SaveToXML, arginfo_TElDHKeyMaterial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, Assign, arginfo_TElDHKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, Clone, arginfo_TElDHKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, Equals, arginfo_TElDHKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, ClearSecret, arginfo_TElDHKeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, ClearPublic, arginfo_TElDHKeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, get_KeyFormat, arginfo_TElDHKeyMaterial_get_KeyFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, get_P, arginfo_TElDHKeyMaterial_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, set_P, arginfo_TElDHKeyMaterial_set_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, get_G, arginfo_TElDHKeyMaterial_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, set_G, arginfo_TElDHKeyMaterial_set_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, get_X, arginfo_TElDHKeyMaterial_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, set_X, arginfo_TElDHKeyMaterial_set_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, get_Y, arginfo_TElDHKeyMaterial_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, set_Y, arginfo_TElDHKeyMaterial_set_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, get_PeerY, arginfo_TElDHKeyMaterial_get_PeerY, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, set_PeerY, arginfo_TElDHKeyMaterial_set_PeerY, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHKeyMaterial, __construct, arginfo_TElDHKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDHKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDHKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDHKeyMaterial", TElDHKeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElDHKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDHPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElDHPublicKeyCrypto, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHPublicKeyCrypto_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHPublicKeyCrypto, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDHPublicKeyCrypto_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHPublicKeyCrypto, get_CryptoType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDHPublicKeyCryptoTypeRaw fOutResultRaw = 0;
		SBCheckError(TElDHPublicKeyCrypto_get_CryptoType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHPublicKeyCrypto, set_CryptoType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDHPublicKeyCrypto_set_CryptoType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBDHPublicKeyCryptoTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDHPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHPublicKeyCrypto_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHPublicKeyCrypto_Create_1(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHPublicKeyCrypto_Create_2((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDHPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDHPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHPublicKeyCrypto_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHPublicKeyCrypto_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHPublicKeyCrypto_get_CryptoType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHPublicKeyCrypto_set_CryptoType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDHPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_OID_or_Alg_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDHPublicKeyCrypto_methods[] = {
	PHP_ME(TElDHPublicKeyCrypto, LoadParameters, arginfo_TElDHPublicKeyCrypto_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHPublicKeyCrypto, SaveParameters, arginfo_TElDHPublicKeyCrypto_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHPublicKeyCrypto, ClassType, arginfo_TElDHPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDHPublicKeyCrypto, get_CryptoType, arginfo_TElDHPublicKeyCrypto_get_CryptoType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHPublicKeyCrypto, set_CryptoType, arginfo_TElDHPublicKeyCrypto_set_CryptoType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDHPublicKeyCrypto, __construct, arginfo_TElDHPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDHPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDHPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDHPublicKeyCrypto", TElDHPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElDHPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElElGamalKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElElGamalKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, LoadPublic)
{
	long l4Count;
	long l4GSize;
	long l4PSize;
	long l4Size;
	long l4YSize;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piY;
	zval *oStream;
	zval *zpBuffer;
	zval *zpG;
	zval *zpP;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzl", &zpP, &l4PSize, &zpG, &l4GSize, &zpY, &l4YSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElElGamalKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElElGamalKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_LoadPublic_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, LoadSecret)
{
	long l4Count;
	long l4GSize;
	long l4PSize;
	long l4Size;
	long l4XSize;
	long l4YSize;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piG;
	SBArrayZValInfo piP;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *oStream;
	zval *zpBuffer;
	zval *zpG;
	zval *zpP;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzl", &zpP, &l4PSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpX, &l4XSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElElGamalKeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piX.data, (int32_t)l4XSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piX);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElElGamalKeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_LoadSecret_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElElGamalKeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElElGamalKeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, LoadFromXML)
{
	char *sStr;
	int sStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sStr, (int32_t)sStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, SaveToXML)
{
	uint32_t _err;
	zend_bool bIncludePrivateKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludePrivateKey) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElElGamalKeyMaterial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludePrivateKey, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1839728447, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElElGamalKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElElGamalKeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElElGamalKeyMaterial_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(445539530, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElElGamalKeyMaterial_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1721900787, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElElGamalKeyMaterial_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1666374766, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElElGamalKeyMaterial_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(341175544, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, P_or_Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, PSize_or_Size_or_Count)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(0, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, P_or_Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, PSize_or_Size_or_Count)
	ZEND_ARG_TYPE_INFO(0, G, 0, 1)
	ZEND_ARG_INFO(0, GSize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YSize)
	ZEND_ARG_TYPE_INFO(0, X, 0, 1)
	ZEND_ARG_INFO(0, XSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Str)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_SaveToXML, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludePrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElElGamalKeyMaterial_methods[] = {
	PHP_ME(TElElGamalKeyMaterial, Assign, arginfo_TElElGamalKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, Clone, arginfo_TElElGamalKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, LoadPublic, arginfo_TElElGamalKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, LoadSecret, arginfo_TElElGamalKeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, SavePublic, arginfo_TElElGamalKeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, SaveSecret, arginfo_TElElGamalKeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, LoadFromXML, arginfo_TElElGamalKeyMaterial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, SaveToXML, arginfo_TElElGamalKeyMaterial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, Equals, arginfo_TElElGamalKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, ClearSecret, arginfo_TElElGamalKeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, ClearPublic, arginfo_TElElGamalKeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, get_P, arginfo_TElElGamalKeyMaterial_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, get_G, arginfo_TElElGamalKeyMaterial_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, get_Y, arginfo_TElElGamalKeyMaterial_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, get_X, arginfo_TElElGamalKeyMaterial_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalKeyMaterial, __construct, arginfo_TElElGamalKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElElGamalKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElElGamalKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElElGamalKeyMaterial", TElElGamalKeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElElGamalKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElElGamalPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElElGamalPublicKeyCrypto, EncodeResult)
{
	int32_t l4BlobSizeRaw;
	long l4ASize;
	long l4BSize;
	SBArrayZValInfo piA;
	SBArrayZValInfo piB;
	SBArrayZValInfo piBlob;
	zval *zl4BlobSize;
	zval *zpA;
	zval *zpB;
	zval *zpBlob;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpA, &l4ASize, &zpB, &l4BSize, &zpBlob, &zl4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpB) == IS_STRING) || (Z_TYPE_P(zpB) == IS_ARRAY) || (Z_TYPE_P(zpB) == IS_NULL) || ((Z_TYPE_P(zpB) == IS_OBJECT) && (Z_OBJCE_P(zpB) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BlobSize) && (IS_LONG == Z_TYPE_P(zl4BlobSize)))
	{
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpB, &piB TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		l4BlobSizeRaw = (int32_t)Z_LVAL_P(zl4BlobSize);
		SBCheckError(TElElGamalPublicKeyCrypto_EncodeResult(SBGetObjectHandle(getThis() TSRMLS_CC), piA.data, (int32_t)l4ASize, piB.data, (int32_t)l4BSize, piBlob.data, &l4BlobSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piB);
		SBFreePointerZValInfo(&piBlob);
		ZVAL_LONG(zl4BlobSize, (long)l4BlobSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalPublicKeyCrypto, DecodeResult)
{
	int32_t l4ASizeRaw;
	int32_t l4BSizeRaw;
	long l4BlobSize;
	SBArrayZValInfo piA;
	SBArrayZValInfo piB;
	SBArrayZValInfo piBlob;
	zval *zl4ASize;
	zval *zl4BSize;
	zval *zpA;
	zval *zpB;
	zval *zpBlob;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzz", &zpBlob, &l4BlobSize, &zpA, &zl4ASize, &zpB, &zl4BSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4ASize) && (IS_LONG == Z_TYPE_P(zl4ASize)) && ((Z_TYPE_P(zpB) == IS_STRING) || (Z_TYPE_P(zpB) == IS_ARRAY) || (Z_TYPE_P(zpB) == IS_NULL) || ((Z_TYPE_P(zpB) == IS_OBJECT) && (Z_OBJCE_P(zpB) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BSize) && (IS_LONG == Z_TYPE_P(zl4BSize)))
	{
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		l4ASizeRaw = (int32_t)Z_LVAL_P(zl4ASize);
		if (!SBGetPointerFromZVal(zpB, &piB TSRMLS_CC)) RETURN_FALSE;
		l4BSizeRaw = (int32_t)Z_LVAL_P(zl4BSize);
		SBCheckError(TElElGamalPublicKeyCrypto_DecodeResult(SBGetObjectHandle(getThis() TSRMLS_CC), piBlob.data, (int32_t)l4BlobSize, piA.data, &l4ASizeRaw, piB.data, &l4BSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piA);
		ZVAL_LONG(zl4ASize, (long)l4ASizeRaw);
		SBFreePointerZValInfo(&piB);
		ZVAL_LONG(zl4BSize, (long)l4BSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElElGamalPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElElGamalPublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalPublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalPublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElElGamalPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElElGamalPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalPublicKeyCrypto_EncodeResult, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, A, 0, 1)
	ZEND_ARG_INFO(0, ASize)
	ZEND_ARG_TYPE_INFO(0, B, 0, 1)
	ZEND_ARG_INFO(0, BSize)
	ZEND_ARG_TYPE_INFO(0, Blob, 0, 1)
	ZEND_ARG_INFO(1, BlobSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalPublicKeyCrypto_DecodeResult, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Blob, 0, 1)
	ZEND_ARG_INFO(0, BlobSize)
	ZEND_ARG_TYPE_INFO(0, A, 0, 1)
	ZEND_ARG_INFO(1, ASize)
	ZEND_ARG_TYPE_INFO(0, B, 0, 1)
	ZEND_ARG_INFO(1, BSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElElGamalPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElElGamalPublicKeyCrypto_methods[] = {
	PHP_ME(TElElGamalPublicKeyCrypto, EncodeResult, arginfo_TElElGamalPublicKeyCrypto_EncodeResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalPublicKeyCrypto, DecodeResult, arginfo_TElElGamalPublicKeyCrypto_DecodeResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElElGamalPublicKeyCrypto, ClassType, arginfo_TElElGamalPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElElGamalPublicKeyCrypto, __construct, arginfo_TElElGamalPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElElGamalPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElElGamalPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElElGamalPublicKeyCrypto", TElElGamalPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElElGamalPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSRPKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElSRPKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSRPKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, LoadPublic)
{
	long l4Len;
	SBArrayZValInfo aiG;
	SBArrayZValInfo aiN;
	SBArrayZValInfo aiSalt;
	SBArrayZValInfo aiV;
	SBArrayZValInfo piBuffer;
	zval *zaG;
	zval *zaN;
	zval *zaSalt;
	zval *zaV;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaN, &zaG, &zaSalt, &zaV) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaN)) || (IS_ARRAY == Z_TYPE_P(zaN)) || (IS_NULL == Z_TYPE_P(zaN))) && ((IS_STRING == Z_TYPE_P(zaG)) || (IS_ARRAY == Z_TYPE_P(zaG)) || (IS_NULL == Z_TYPE_P(zaG))) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))) && ((IS_STRING == Z_TYPE_P(zaV)) || (IS_ARRAY == Z_TYPE_P(zaV)) || (IS_NULL == Z_TYPE_P(zaV))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaN, &aiN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaG, &aiG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaV, &aiV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPKeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), aiN.data, aiN.len, aiG.data, aiG.len, aiSalt.data, aiSalt.len, aiV.data, aiV.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiN);
		SBFreeArrayZValInfo(&aiG);
		SBFreeArrayZValInfo(&aiSalt);
		SBFreeArrayZValInfo(&aiV);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPKeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Len, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, LoadPublicValues)
{
	SBArrayZValInfo aiB;
	SBArrayZValInfo aig;
	SBArrayZValInfo aiN;
	SBArrayZValInfo ais;
	zval *zaB;
	zval *zag;
	zval *zaN;
	zval *zas;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaN, &zag, &zas, &zaB) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaN)) || (IS_ARRAY == Z_TYPE_P(zaN)) || (IS_NULL == Z_TYPE_P(zaN))) && ((IS_STRING == Z_TYPE_P(zag)) || (IS_ARRAY == Z_TYPE_P(zag)) || (IS_NULL == Z_TYPE_P(zag))) && ((IS_STRING == Z_TYPE_P(zas)) || (IS_ARRAY == Z_TYPE_P(zas)) || (IS_NULL == Z_TYPE_P(zas))) && ((IS_STRING == Z_TYPE_P(zaB)) || (IS_ARRAY == Z_TYPE_P(zaB)) || (IS_NULL == Z_TYPE_P(zaB))))
	{
		if (!SBGetByteArrayFromZVal(zaN, &aiN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zag, &aig TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zas, &ais TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaB, &aiB TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPKeyMaterial_LoadPublicValues(SBGetObjectHandle(getThis() TSRMLS_CC), aiN.data, aiN.len, aig.data, aig.len, ais.data, ais.len, aiB.data, aiB.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiN);
		SBFreeArrayZValInfo(&aig);
		SBFreeArrayZValInfo(&ais);
		SBFreeArrayZValInfo(&aiB);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, LoadVerifier)
{
	SBArrayZValInfo aig;
	SBArrayZValInfo aiN;
	SBArrayZValInfo ais;
	SBArrayZValInfo aiV;
	zval *zag;
	zval *zaN;
	zval *zas;
	zval *zaV;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaN, &zag, &zas, &zaV) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaN)) || (IS_ARRAY == Z_TYPE_P(zaN)) || (IS_NULL == Z_TYPE_P(zaN))) && ((IS_STRING == Z_TYPE_P(zag)) || (IS_ARRAY == Z_TYPE_P(zag)) || (IS_NULL == Z_TYPE_P(zag))) && ((IS_STRING == Z_TYPE_P(zas)) || (IS_ARRAY == Z_TYPE_P(zas)) || (IS_NULL == Z_TYPE_P(zas))) && ((IS_STRING == Z_TYPE_P(zaV)) || (IS_ARRAY == Z_TYPE_P(zaV)) || (IS_NULL == Z_TYPE_P(zaV))))
	{
		if (!SBGetByteArrayFromZVal(zaN, &aiN TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zag, &aig TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zas, &ais TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaV, &aiV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPKeyMaterial_LoadVerifier(SBGetObjectHandle(getThis() TSRMLS_CC), aiN.data, aiN.len, aig.data, aig.len, ais.data, ais.len, aiV.data, aiV.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiN);
		SBFreeArrayZValInfo(&aig);
		SBFreeArrayZValInfo(&ais);
		SBFreeArrayZValInfo(&aiV);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, LoadClientPublicValue)
{
	SBArrayZValInfo aiA;
	zval *zaA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaA) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaA)) || (IS_ARRAY == Z_TYPE_P(zaA)) || (IS_NULL == Z_TYPE_P(zaA))))
	{
		if (!SBGetByteArrayFromZVal(zaA, &aiA TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPKeyMaterial_LoadClientPublicValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiA.data, aiA.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiA);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, PrepareServerKeyParam)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSRPKeyMaterial_PrepareServerKeyParam(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_Salt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-67183824, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_N)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_N(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2132251237, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_G)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_G(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(113978049, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1950144716, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_A)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_A(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-274165772, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_K)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_K(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(259876586, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_A_small)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_A_small(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-647267049, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_B)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_B(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1990319694, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_B_small)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_B_small(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-394041462, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_V)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_V(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1820002867, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_U)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_U(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-177054839, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, get_S)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSRPKeyMaterial_get_S(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(470941372, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPKeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPKeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, N_or_Buffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, G_or_Len, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Salt, 0, 1)
	ZEND_ARG_TYPE_INFO(0, V, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_LoadPublicValues, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, N, 0, 1)
	ZEND_ARG_TYPE_INFO(0, g, 0, 1)
	ZEND_ARG_TYPE_INFO(0, s, 0, 1)
	ZEND_ARG_TYPE_INFO(0, B, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_LoadVerifier, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, N, 0, 1)
	ZEND_ARG_TYPE_INFO(0, g, 0, 1)
	ZEND_ARG_TYPE_INFO(0, s, 0, 1)
	ZEND_ARG_TYPE_INFO(0, V, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_LoadClientPublicValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, A, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_PrepareServerKeyParam, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_Salt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_N, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_G, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_A, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_K, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_A_small, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_B, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_B_small, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_V, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_U, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial_get_S, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSRPKeyMaterial_methods[] = {
	PHP_ME(TElSRPKeyMaterial, Assign, arginfo_TElSRPKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, LoadPublic, arginfo_TElSRPKeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, LoadPublicValues, arginfo_TElSRPKeyMaterial_LoadPublicValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, LoadVerifier, arginfo_TElSRPKeyMaterial_LoadVerifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, LoadClientPublicValue, arginfo_TElSRPKeyMaterial_LoadClientPublicValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, PrepareServerKeyParam, arginfo_TElSRPKeyMaterial_PrepareServerKeyParam, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, Clone, arginfo_TElSRPKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_Salt, arginfo_TElSRPKeyMaterial_get_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_N, arginfo_TElSRPKeyMaterial_get_N, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_G, arginfo_TElSRPKeyMaterial_get_G, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_X, arginfo_TElSRPKeyMaterial_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_A, arginfo_TElSRPKeyMaterial_get_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_K, arginfo_TElSRPKeyMaterial_get_K, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_A_small, arginfo_TElSRPKeyMaterial_get_A_small, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_B, arginfo_TElSRPKeyMaterial_get_B, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_B_small, arginfo_TElSRPKeyMaterial_get_B_small, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_V, arginfo_TElSRPKeyMaterial_get_V, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_U, arginfo_TElSRPKeyMaterial_get_U, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, get_S, arginfo_TElSRPKeyMaterial_get_S, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPKeyMaterial, __construct, arginfo_TElSRPKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSRPKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSRPKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSRPKeyMaterial", TElSRPKeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElSRPKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSRPPublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElSRPPublicKeyCrypto, GetServerKey)
{
	SBArrayZValInfo aiPMS;
	uint32_t _err;
	zval *zaPMS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaPMS) == SUCCESS) && PZVAL_IS_REF(zaPMS) && ((IS_STRING == Z_TYPE_P(zaPMS)) || (IS_ARRAY == Z_TYPE_P(zaPMS))))
	{
		if (!SBGetByteArrayFromZVal(zaPMS, &aiPMS TSRMLS_CC)) RETURN_FALSE;
		_err = TElSRPPublicKeyCrypto_GetServerKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiPMS.data, &aiPMS.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaPMS, &aiPMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-219639999, 1, aiPMS.data, &aiPMS.len) TSRMLS_CC);
			((char *)aiPMS.data)[aiPMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiPMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiPMS, zaPMS);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPPublicKeyCrypto, GetClientKeyParam)
{
	char *sUserName;
	char *sUserPassword;
	int sUserName_len;
	int sUserPassword_len;
	SBArrayZValInfo aiEncPMS;
	uint32_t _err;
	zval *zaEncPMS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssz", &sUserName, &sUserName_len, &sUserPassword, &sUserPassword_len, &zaEncPMS) == SUCCESS) && PZVAL_IS_REF(zaEncPMS) && ((IS_STRING == Z_TYPE_P(zaEncPMS)) || (IS_ARRAY == Z_TYPE_P(zaEncPMS))))
	{
		if (!SBGetByteArrayFromZVal(zaEncPMS, &aiEncPMS TSRMLS_CC)) RETURN_FALSE;
		_err = TElSRPPublicKeyCrypto_GetClientKeyParam(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, sUserPassword, (int32_t)sUserPassword_len, aiEncPMS.data, &aiEncPMS.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaEncPMS, &aiEncPMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-141466582, 3, aiEncPMS.data, &aiEncPMS.len) TSRMLS_CC);
			((char *)aiEncPMS.data)[aiEncPMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiEncPMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiEncPMS, zaEncPMS);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPPublicKeyCrypto, GetServerKeyParam)
{
	SBArrayZValInfo aiEncPMS;
	uint32_t _err;
	zval *zaEncPMS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaEncPMS) == SUCCESS) && PZVAL_IS_REF(zaEncPMS) && ((IS_STRING == Z_TYPE_P(zaEncPMS)) || (IS_ARRAY == Z_TYPE_P(zaEncPMS))))
	{
		if (!SBGetByteArrayFromZVal(zaEncPMS, &aiEncPMS TSRMLS_CC)) RETURN_FALSE;
		_err = TElSRPPublicKeyCrypto_GetServerKeyParam(SBGetObjectHandle(getThis() TSRMLS_CC), aiEncPMS.data, &aiEncPMS.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaEncPMS, &aiEncPMS TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-77170774, 1, aiEncPMS.data, &aiEncPMS.len) TSRMLS_CC);
			((char *)aiEncPMS.data)[aiEncPMS.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiEncPMS);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiEncPMS, zaEncPMS);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPPublicKeyCrypto, IsTrustedPrime_Inst)
{
	SBArrayZValInfo aiN;
	zval *zaN;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaN) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaN)) || (IS_ARRAY == Z_TYPE_P(zaN)) || (IS_NULL == Z_TYPE_P(zaN))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaN, &aiN TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPPublicKeyCrypto_IsTrustedPrime_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiN.data, aiN.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiN);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPPublicKeyCrypto, IsTrustedPrime)
{
	SBArrayZValInfo aiN;
	zval *zaN;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaN) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaN)) || (IS_ARRAY == Z_TYPE_P(zaN)) || (IS_NULL == Z_TYPE_P(zaN))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaN, &aiN TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPPublicKeyCrypto_IsTrustedPrime(aiN.data, aiN.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiN);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPPublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPPublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSRPPublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPPublicKeyCrypto_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPPublicKeyCrypto_Create_1(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPPublicKeyCrypto_Create_2((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSRPPublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPPublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSRPPublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto_GetServerKey, 0, 0, 1)
	ZEND_ARG_INFO(1, PMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto_GetClientKeyParam, 0, 0, 3)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, UserPassword)
	ZEND_ARG_INFO(1, EncPMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto_GetServerKeyParam, 0, 0, 1)
	ZEND_ARG_INFO(1, EncPMS)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto_IsTrustedPrime_Inst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, N, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto_IsTrustedPrime, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, N, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSRPPublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_OID_or_Alg_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSRPPublicKeyCrypto_methods[] = {
	PHP_ME(TElSRPPublicKeyCrypto, GetServerKey, arginfo_TElSRPPublicKeyCrypto_GetServerKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPPublicKeyCrypto, GetClientKeyParam, arginfo_TElSRPPublicKeyCrypto_GetClientKeyParam, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPPublicKeyCrypto, GetServerKeyParam, arginfo_TElSRPPublicKeyCrypto_GetServerKeyParam, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPPublicKeyCrypto, IsTrustedPrime_Inst, arginfo_TElSRPPublicKeyCrypto_IsTrustedPrime_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSRPPublicKeyCrypto, IsTrustedPrime, arginfo_TElSRPPublicKeyCrypto_IsTrustedPrime, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSRPPublicKeyCrypto, ClassType, arginfo_TElSRPPublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSRPPublicKeyCrypto, __construct, arginfo_TElSRPPublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSRPPublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSRPPublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSRPPublicKeyCrypto", TElSRPPublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElSRPPublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST94KeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST94KeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94KeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, LoadSecret)
{
	long l4AIndex;
	long l4ASize;
	long l4Count;
	long l4PIndex;
	long l4PSize;
	long l4QIndex;
	long l4QSize;
	long l4Size;
	long l4XIndex;
	long l4XSize;
	long l4YIndex;
	long l4YSize;
	SBArrayZValInfo aiA;
	SBArrayZValInfo aiP;
	SBArrayZValInfo aiQ;
	SBArrayZValInfo aiX;
	SBArrayZValInfo aiY;
	SBArrayZValInfo piA;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piX;
	SBArrayZValInfo piY;
	zval *oStream;
	zval *zaA;
	zval *zaP;
	zval *zaQ;
	zval *zaX;
	zval *zaY;
	zval *zpA;
	zval *zpBuffer;
	zval *zpP;
	zval *zpQ;
	zval *zpX;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzl", &zpP, &l4PSize, &zpQ, &l4QSize, &zpA, &l4ASize, &zpY, &l4YSize, &zpX, &l4XSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piA.data, (int32_t)l4ASize, piY.data, (int32_t)l4YSize, piX.data, (int32_t)l4XSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piX);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzllzllzllzll", &zaP, &l4PIndex, &l4PSize, &zaQ, &l4QIndex, &l4QSize, &zaA, &l4AIndex, &l4ASize, &zaY, &l4YIndex, &l4YSize, &zaX, &l4XIndex, &l4XSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaP)) || (IS_ARRAY == Z_TYPE_P(zaP)) || (IS_NULL == Z_TYPE_P(zaP))) && ((IS_STRING == Z_TYPE_P(zaQ)) || (IS_ARRAY == Z_TYPE_P(zaQ)) || (IS_NULL == Z_TYPE_P(zaQ))) && ((IS_STRING == Z_TYPE_P(zaA)) || (IS_ARRAY == Z_TYPE_P(zaA)) || (IS_NULL == Z_TYPE_P(zaA))) && ((IS_STRING == Z_TYPE_P(zaY)) || (IS_ARRAY == Z_TYPE_P(zaY)) || (IS_NULL == Z_TYPE_P(zaY))) && ((IS_STRING == Z_TYPE_P(zaX)) || (IS_ARRAY == Z_TYPE_P(zaX)) || (IS_NULL == Z_TYPE_P(zaX))))
	{
		if (!SBGetByteArrayFromZVal(zaP, &aiP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaQ, &aiQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaA, &aiA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaY, &aiY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaX, &aiX TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_LoadSecret_2(SBGetObjectHandle(getThis() TSRMLS_CC), aiP.data, aiP.len, (int32_t)l4PIndex, (int32_t)l4PSize, aiQ.data, aiQ.len, (int32_t)l4QIndex, (int32_t)l4QSize, aiA.data, aiA.len, (int32_t)l4AIndex, (int32_t)l4ASize, aiY.data, aiY.len, (int32_t)l4YIndex, (int32_t)l4YSize, aiX.data, aiX.len, (int32_t)l4XIndex, (int32_t)l4XSize) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiP);
		SBFreeArrayZValInfo(&aiQ);
		SBFreeArrayZValInfo(&aiA);
		SBFreeArrayZValInfo(&aiY);
		SBFreeArrayZValInfo(&aiX);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_LoadSecret_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElGOST94KeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, LoadPublic)
{
	long l4AIndex;
	long l4ASize;
	long l4Count;
	long l4PIndex;
	long l4PSize;
	long l4QIndex;
	long l4QSize;
	long l4Size;
	long l4YIndex;
	long l4YSize;
	SBArrayZValInfo aiA;
	SBArrayZValInfo aiP;
	SBArrayZValInfo aiQ;
	SBArrayZValInfo aiY;
	SBArrayZValInfo piA;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piY;
	zval *oStream;
	zval *zaA;
	zval *zaP;
	zval *zaQ;
	zval *zaY;
	zval *zpA;
	zval *zpBuffer;
	zval *zpP;
	zval *zpQ;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzl", &zpP, &l4PSize, &zpQ, &l4QSize, &zpA, &l4ASize, &zpY, &l4YSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpA) == IS_STRING) || (Z_TYPE_P(zpA) == IS_ARRAY) || (Z_TYPE_P(zpA) == IS_NULL) || ((Z_TYPE_P(zpA) == IS_OBJECT) && (Z_OBJCE_P(zpA) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpA, &piA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piA.data, (int32_t)l4ASize, piY.data, (int32_t)l4YSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piA);
		SBFreePointerZValInfo(&piY);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzllzllzll", &zaP, &l4PIndex, &l4PSize, &zaQ, &l4QIndex, &l4QSize, &zaA, &l4AIndex, &l4ASize, &zaY, &l4YIndex, &l4YSize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaP)) || (IS_ARRAY == Z_TYPE_P(zaP)) || (IS_NULL == Z_TYPE_P(zaP))) && ((IS_STRING == Z_TYPE_P(zaQ)) || (IS_ARRAY == Z_TYPE_P(zaQ)) || (IS_NULL == Z_TYPE_P(zaQ))) && ((IS_STRING == Z_TYPE_P(zaA)) || (IS_ARRAY == Z_TYPE_P(zaA)) || (IS_NULL == Z_TYPE_P(zaA))) && ((IS_STRING == Z_TYPE_P(zaY)) || (IS_ARRAY == Z_TYPE_P(zaY)) || (IS_NULL == Z_TYPE_P(zaY))))
	{
		if (!SBGetByteArrayFromZVal(zaP, &aiP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaQ, &aiQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaA, &aiA TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaY, &aiY TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_LoadPublic_2(SBGetObjectHandle(getThis() TSRMLS_CC), aiP.data, aiP.len, (int32_t)l4PIndex, (int32_t)l4PSize, aiQ.data, aiQ.len, (int32_t)l4QIndex, (int32_t)l4QSize, aiA.data, aiA.len, (int32_t)l4AIndex, (int32_t)l4ASize, aiY.data, aiY.len, (int32_t)l4YIndex, (int32_t)l4YSize) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiP);
		SBFreeArrayZValInfo(&aiQ);
		SBFreeArrayZValInfo(&aiA);
		SBFreeArrayZValInfo(&aiY);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_LoadPublic_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElGOST94KeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, LoadFromXML)
{
	char *sStr;
	int sStr_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sStr, (int32_t)sStr_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, SaveToXML)
{
	uint32_t _err;
	zend_bool bIncludePrivateKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bIncludePrivateKey) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGOST94KeyMaterial_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bIncludePrivateKey, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1846977963, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGOST94KeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST94KeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_P)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_P(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(7925950, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2004860968, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_A)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_A(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1791545420, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_Y)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_Y(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2040809498, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, set_Y)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_set_Y(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_X)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_X(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(245594252, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, set_X)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_set_X(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_ParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1957190020, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, set_ParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_set_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_DigestParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(345127428, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, set_DigestParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_set_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, get_EncryptionParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST94KeyMaterial_get_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-92150724, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, set_EncryptionParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94KeyMaterial_set_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94KeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94KeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94KeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_P_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_PSize_or_PIndex_or_Count)
	ZEND_ARG_TYPE_INFO(0, Q_or_PSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, QSize_or_Q, 0, 1)
	ZEND_ARG_TYPE_INFO(0, A_or_QIndex, 0, 1)
	ZEND_ARG_INFO(0, ASize_or_QSize)
	ZEND_ARG_TYPE_INFO(0, Y_or_A, 0, 1)
	ZEND_ARG_INFO(0, YSize_or_AIndex)
	ZEND_ARG_TYPE_INFO(0, X_or_ASize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, XSize_or_Y, 0, 1)
	ZEND_ARG_INFO(0, YIndex)
	ZEND_ARG_INFO(0, YSize)
	ZEND_ARG_TYPE_INFO(0, X, 0, 1)
	ZEND_ARG_INFO(0, XIndex)
	ZEND_ARG_INFO(0, XSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_P_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_PSize_or_PIndex_or_Count)
	ZEND_ARG_TYPE_INFO(0, Q_or_PSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, QSize_or_Q, 0, 1)
	ZEND_ARG_TYPE_INFO(0, A_or_QIndex, 0, 1)
	ZEND_ARG_INFO(0, ASize_or_QSize)
	ZEND_ARG_TYPE_INFO(0, Y_or_A, 0, 1)
	ZEND_ARG_INFO(0, YSize_or_AIndex)
	ZEND_ARG_INFO(0, ASize)
	ZEND_ARG_TYPE_INFO(0, Y, 0, 1)
	ZEND_ARG_INFO(0, YIndex)
	ZEND_ARG_INFO(0, YSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_LoadFromXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Str)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_SaveToXML, 0, 0, 1)
	ZEND_ARG_INFO(0, IncludePrivateKey)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_P, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_A, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_Y, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_set_Y, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_X, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_set_X, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_ParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_set_ParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_DigestParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_set_DigestParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_get_EncryptionParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial_set_EncryptionParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94KeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST94KeyMaterial_methods[] = {
	PHP_ME(TElGOST94KeyMaterial, Assign, arginfo_TElGOST94KeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, Clone, arginfo_TElGOST94KeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, LoadSecret, arginfo_TElGOST94KeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, SaveSecret, arginfo_TElGOST94KeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, LoadPublic, arginfo_TElGOST94KeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, SavePublic, arginfo_TElGOST94KeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, LoadFromXML, arginfo_TElGOST94KeyMaterial_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, SaveToXML, arginfo_TElGOST94KeyMaterial_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, Equals, arginfo_TElGOST94KeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, ClearSecret, arginfo_TElGOST94KeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, ClearPublic, arginfo_TElGOST94KeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, LoadParameters, arginfo_TElGOST94KeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, SaveParameters, arginfo_TElGOST94KeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_P, arginfo_TElGOST94KeyMaterial_get_P, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_Q, arginfo_TElGOST94KeyMaterial_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_A, arginfo_TElGOST94KeyMaterial_get_A, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_Y, arginfo_TElGOST94KeyMaterial_get_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, set_Y, arginfo_TElGOST94KeyMaterial_set_Y, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_X, arginfo_TElGOST94KeyMaterial_get_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, set_X, arginfo_TElGOST94KeyMaterial_set_X, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_ParamSet, arginfo_TElGOST94KeyMaterial_get_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, set_ParamSet, arginfo_TElGOST94KeyMaterial_set_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_DigestParamSet, arginfo_TElGOST94KeyMaterial_get_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, set_DigestParamSet, arginfo_TElGOST94KeyMaterial_set_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, get_EncryptionParamSet, arginfo_TElGOST94KeyMaterial_get_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, set_EncryptionParamSet, arginfo_TElGOST94KeyMaterial_set_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST94KeyMaterial, __construct, arginfo_TElGOST94KeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST94KeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST94KeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST94KeyMaterial", TElGOST94KeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElGOST94KeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST94PublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST94PublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94PublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST94PublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94PublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94PublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94PublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST94PublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94PublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST94PublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94PublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST94PublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST94PublicKeyCrypto_methods[] = {
	PHP_ME(TElGOST94PublicKeyCrypto, ClassType, arginfo_TElGOST94PublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOST94PublicKeyCrypto, __construct, arginfo_TElGOST94PublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST94PublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST94PublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST94PublicKeyCrypto", TElGOST94PublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElGOST94PublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST2001KeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST2001KeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, Generate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_Generate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, LoadParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_LoadParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, SaveParameters)
{
	zval *oAlgorithmIdentifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlgorithmIdentifier, TElAlgorithmIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_SaveParameters(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlgorithmIdentifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, LoadSecret)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_LoadSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_LoadSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, SaveSecret)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElGOST2001KeyMaterial_SaveSecret(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_SaveSecret_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, LoadPublic)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_LoadPublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_LoadPublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, SavePublic)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElGOST2001KeyMaterial_SavePublic(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_SavePublic_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001KeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGOST2001KeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, ClearSecret)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_ClearSecret(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, ClearPublic)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST2001KeyMaterial_ClearPublic(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, get_Q)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001KeyMaterial_get_Q(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(262439143, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, set_Q)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_set_Q(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, get_D)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001KeyMaterial_get_D(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1652122636, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, set_D)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_set_D(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, get_ParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001KeyMaterial_get_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-285964983, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, set_ParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_set_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, get_DigestParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001KeyMaterial_get_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-679065874, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, set_DigestParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_set_DigestParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, get_EncryptionParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001KeyMaterial_get_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(845910027, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, set_EncryptionParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001KeyMaterial_set_EncryptionParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001KeyMaterial, __construct)
{
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001KeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001KeyMaterial_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_Generate, 0, 0, 0)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_LoadParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_SaveParameters, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AlgorithmIdentifier, TElAlgorithmIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_LoadSecret, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_SaveSecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_LoadPublic, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_SavePublic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_ClearSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_ClearPublic, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_get_Q, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_set_Q, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_get_D, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_set_D, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_get_ParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_set_ParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_get_DigestParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_set_DigestParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_get_EncryptionParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial_set_EncryptionParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001KeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST2001KeyMaterial_methods[] = {
	PHP_ME(TElGOST2001KeyMaterial, Assign, arginfo_TElGOST2001KeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, Generate, arginfo_TElGOST2001KeyMaterial_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, LoadParameters, arginfo_TElGOST2001KeyMaterial_LoadParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, SaveParameters, arginfo_TElGOST2001KeyMaterial_SaveParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, LoadSecret, arginfo_TElGOST2001KeyMaterial_LoadSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, SaveSecret, arginfo_TElGOST2001KeyMaterial_SaveSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, LoadPublic, arginfo_TElGOST2001KeyMaterial_LoadPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, SavePublic, arginfo_TElGOST2001KeyMaterial_SavePublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, Clone, arginfo_TElGOST2001KeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, Equals, arginfo_TElGOST2001KeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, ClearSecret, arginfo_TElGOST2001KeyMaterial_ClearSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, ClearPublic, arginfo_TElGOST2001KeyMaterial_ClearPublic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, get_Q, arginfo_TElGOST2001KeyMaterial_get_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, set_Q, arginfo_TElGOST2001KeyMaterial_set_Q, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, get_D, arginfo_TElGOST2001KeyMaterial_get_D, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, set_D, arginfo_TElGOST2001KeyMaterial_set_D, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, get_ParamSet, arginfo_TElGOST2001KeyMaterial_get_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, set_ParamSet, arginfo_TElGOST2001KeyMaterial_set_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, get_DigestParamSet, arginfo_TElGOST2001KeyMaterial_get_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, set_DigestParamSet, arginfo_TElGOST2001KeyMaterial_set_DigestParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, get_EncryptionParamSet, arginfo_TElGOST2001KeyMaterial_get_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, set_EncryptionParamSet, arginfo_TElGOST2001KeyMaterial_set_EncryptionParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001KeyMaterial, __construct, arginfo_TElGOST2001KeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST2001KeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST2001KeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST2001KeyMaterial", TElGOST2001KeyMaterial_methods);
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	TElGOST2001KeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST2001PublicKeyCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001PublicKeyCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, get_UKM)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001PublicKeyCrypto_get_UKM(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1732775350, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, set_UKM)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001PublicKeyCrypto_set_UKM(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, get_CEKMAC)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001PublicKeyCrypto_get_CEKMAC(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1029391852, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, set_CEKMAC)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001PublicKeyCrypto_set_CEKMAC(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, get_EphemeralKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST2001PublicKeyCrypto_get_EphemeralKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(906616094, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, set_EphemeralKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001PublicKeyCrypto_set_EphemeralKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST2001PublicKeyCrypto, __construct)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaOID, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001PublicKeyCrypto_Create(aiOID.data, aiOID.len, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Alg, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001PublicKeyCrypto_Create_1((int32_t)l4Alg, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001PublicKeyCrypto_Create_2(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!O!", &zaOID, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST2001PublicKeyCrypto_Create_3(aiOID.data, aiOID.len, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &l4Alg, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001PublicKeyCrypto_Create_4((int32_t)l4Alg, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST2001PublicKeyCrypto_Create_5(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (TElCustomCryptoProvider) or (array of byte|string|NULL, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_get_UKM, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_set_UKM, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_get_CEKMAC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_set_CEKMAC, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_get_EphemeralKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto_set_EphemeralKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST2001PublicKeyCrypto___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST2001PublicKeyCrypto_methods[] = {
	PHP_ME(TElGOST2001PublicKeyCrypto, ClassType, arginfo_TElGOST2001PublicKeyCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, get_UKM, arginfo_TElGOST2001PublicKeyCrypto_get_UKM, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, set_UKM, arginfo_TElGOST2001PublicKeyCrypto_set_UKM, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, get_CEKMAC, arginfo_TElGOST2001PublicKeyCrypto_get_CEKMAC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, set_CEKMAC, arginfo_TElGOST2001PublicKeyCrypto_set_CEKMAC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, get_EphemeralKey, arginfo_TElGOST2001PublicKeyCrypto_get_EphemeralKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, set_EphemeralKey, arginfo_TElGOST2001PublicKeyCrypto_set_EphemeralKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST2001PublicKeyCrypto, __construct, arginfo_TElGOST2001PublicKeyCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST2001PublicKeyCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST2001PublicKeyCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST2001PublicKeyCrypto", TElGOST2001PublicKeyCrypto_methods);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	TElGOST2001PublicKeyCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElPublicKeyCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPublicKeyCryptoFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElPublicKeyCryptoFactory, CreateKeyInstance)
{
	char *sPassword;
	int sPassword_len;
	long l4Alg;
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zls", &zpBuffer, &l4Size, &sPassword, &sPassword_len) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCryptoFactory_CreateKeyInstance(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, sPassword, (int32_t)sPassword_len, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oStream, TStream_ce_ptr, &sPassword, &sPassword_len, &l4Count) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCryptoFactory_CreateKeyInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int32_t)l4Count, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCryptoFactory_CreateKeyInstance_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, string) or (TStream, string, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCryptoFactory, RegisterClass)
{
	zval *oCls;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCls, TElPublicKeyCryptoClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPublicKeyCryptoFactory_RegisterClass(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCls TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyCryptoClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCryptoFactory, CreateInstance)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCryptoFactory_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBInitObject(return_value, TElPublicKeyCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCryptoFactory_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCryptoFactory, IsAlgorithmSupported)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPublicKeyCryptoFactory_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPublicKeyCryptoFactory_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCryptoFactory, get_RegisteredClasses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCryptoFactory_get_RegisteredClasses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyCryptoClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCryptoFactory, get_RegisteredClassCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPublicKeyCryptoFactory_get_RegisteredClassCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPublicKeyCryptoFactory, __construct)
{
	zval *oCryptoProvider;
	zval *oManager;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCryptoFactory_Create(SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPublicKeyCryptoFactory_Create_1(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory_CreateKeyInstance, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream_or_Alg, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Password)
	ZEND_ARG_INFO(0, Password_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory_RegisterClass, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cls, TElPublicKeyCryptoClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory_CreateInstance, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory_IsAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory_get_RegisteredClasses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory_get_RegisteredClassCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPublicKeyCryptoFactory___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPublicKeyCryptoFactory_methods[] = {
	PHP_ME(TElPublicKeyCryptoFactory, CreateKeyInstance, arginfo_TElPublicKeyCryptoFactory_CreateKeyInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCryptoFactory, RegisterClass, arginfo_TElPublicKeyCryptoFactory_RegisterClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCryptoFactory, CreateInstance, arginfo_TElPublicKeyCryptoFactory_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCryptoFactory, IsAlgorithmSupported, arginfo_TElPublicKeyCryptoFactory_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCryptoFactory, get_RegisteredClasses, arginfo_TElPublicKeyCryptoFactory_get_RegisteredClasses, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCryptoFactory, get_RegisteredClassCount, arginfo_TElPublicKeyCryptoFactory_get_RegisteredClassCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPublicKeyCryptoFactory, __construct, arginfo_TElPublicKeyCryptoFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPublicKeyCryptoFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPublicKeyCryptoFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPublicKeyCryptoFactory", TElPublicKeyCryptoFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPublicKeyCryptoFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRemoteSigningParams_ce_ptr = NULL;

SB_PHP_METHOD(TElRemoteSigningParams, get_CertificateIndex)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRemoteSigningParams_get_CertificateIndex(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, set_CertificateIndex)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRemoteSigningParams_set_CertificateIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, get_ExternalHashCalculation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRemoteSigningParams_get_ExternalHashCalculation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, set_ExternalHashCalculation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElRemoteSigningParams_set_ExternalHashCalculation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, get_ECDSACurve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRemoteSigningParams_get_ECDSACurve(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, set_ECDSACurve)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRemoteSigningParams_set_ECDSACurve(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, get_ECDSACurveOID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElRemoteSigningParams_get_ECDSACurveOID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1476270419, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, set_ECDSACurveOID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRemoteSigningParams_set_ECDSACurveOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, get_ECDSAFieldBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRemoteSigningParams_get_ECDSAFieldBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, set_ECDSAFieldBits)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRemoteSigningParams_set_ECDSAFieldBits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, get_DSAQBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRemoteSigningParams_get_DSAQBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, set_DSAQBits)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRemoteSigningParams_set_DSAQBits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRemoteSigningParams, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRemoteSigningParams_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_get_CertificateIndex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_set_CertificateIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_get_ExternalHashCalculation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_set_ExternalHashCalculation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_get_ECDSACurve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_set_ECDSACurve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_get_ECDSACurveOID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_set_ECDSACurveOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_get_ECDSAFieldBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_set_ECDSAFieldBits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_get_DSAQBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams_set_DSAQBits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRemoteSigningParams___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRemoteSigningParams_methods[] = {
	PHP_ME(TElRemoteSigningParams, get_CertificateIndex, arginfo_TElRemoteSigningParams_get_CertificateIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, set_CertificateIndex, arginfo_TElRemoteSigningParams_set_CertificateIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, get_ExternalHashCalculation, arginfo_TElRemoteSigningParams_get_ExternalHashCalculation, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, set_ExternalHashCalculation, arginfo_TElRemoteSigningParams_set_ExternalHashCalculation, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, get_ECDSACurve, arginfo_TElRemoteSigningParams_get_ECDSACurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, set_ECDSACurve, arginfo_TElRemoteSigningParams_set_ECDSACurve, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, get_ECDSACurveOID, arginfo_TElRemoteSigningParams_get_ECDSACurveOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, set_ECDSACurveOID, arginfo_TElRemoteSigningParams_set_ECDSACurveOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, get_ECDSAFieldBits, arginfo_TElRemoteSigningParams_get_ECDSAFieldBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, set_ECDSAFieldBits, arginfo_TElRemoteSigningParams_set_ECDSAFieldBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, get_DSAQBits, arginfo_TElRemoteSigningParams_get_DSAQBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, set_DSAQBits, arginfo_TElRemoteSigningParams_set_DSAQBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElRemoteSigningParams, __construct, arginfo_TElRemoteSigningParams___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRemoteSigningParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRemoteSigningParams_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRemoteSigningParams", TElRemoteSigningParams_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElRemoteSigningParams_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPublicKeyCrypto_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBKeyStoreFormat", NULL);
	TSBKeyStoreFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBKeyStoreFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBKeyStoreFormat_ce_ptr, "ksfRaw", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBKeyStoreFormat_ce_ptr, "ksfPKCS8", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBPublicKeyOperation", NULL);
	TSBPublicKeyOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPublicKeyOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoEncrypt", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoDecrypt", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoSign", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoSignDetached", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoVerify", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoVerifyDetached", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyOperation_ce_ptr, "pkoDecryptKey", 6)
	
	INIT_CLASS_ENTRY(ce, "TSBPublicKeyVerificationResult", NULL);
	TSBPublicKeyVerificationResult_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPublicKeyVerificationResult_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyVerificationResult_ce_ptr, "pkvrSuccess", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyVerificationResult_ce_ptr, "pkvrInvalidSignature", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyVerificationResult_ce_ptr, "pkvrKeyNotFound", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyVerificationResult_ce_ptr, "pkvrFailure", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPublicKeyCryptoEncoding", NULL);
	TSBPublicKeyCryptoEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPublicKeyCryptoEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyCryptoEncoding_ce_ptr, "pkeBinary", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPublicKeyCryptoEncoding_ce_ptr, "pkeBase64", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBRSAKeyFormat", NULL);
	TSBRSAKeyFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBRSAKeyFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAKeyFormat_ce_ptr, "rsaPKCS1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAKeyFormat_ce_ptr, "rsaOAEP", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAKeyFormat_ce_ptr, "rsaPSS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAKeyFormat_ce_ptr, "rsaX509", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBRSAPublicKeyCryptoType", NULL);
	TSBRSAPublicKeyCryptoType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBRSAPublicKeyCryptoType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAPublicKeyCryptoType_ce_ptr, "rsapktPKCS1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAPublicKeyCryptoType_ce_ptr, "rsapktOAEP", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAPublicKeyCryptoType_ce_ptr, "rsapktPSS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBRSAPublicKeyCryptoType_ce_ptr, "rsapktSSL3", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBDSAKeyFormat", NULL);
	TSBDSAKeyFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDSAKeyFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDSAKeyFormat_ce_ptr, "dsaFIPS", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDSAKeyFormat_ce_ptr, "dsaX509", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDHKeyFormat", NULL);
	TSBDHKeyFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDHKeyFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDHKeyFormat_ce_ptr, "dhRaw", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDHKeyFormat_ce_ptr, "dhX509", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBDHPublicKeyCryptoType", NULL);
	TSBDHPublicKeyCryptoType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBDHPublicKeyCryptoType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBDHPublicKeyCryptoType_ce_ptr, "dhpktPKCS1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBDHPublicKeyCryptoType_ce_ptr, "dhpktRaw", 1)
}

void Register_SBPublicKeyCrypto_Aliases(TSRMLS_D)
{
	if (NULL == TElPublicKeyMaterial_ce_ptr)
		Register_TElPublicKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElPublicKeyMaterial", TElPublicKeyMaterial_ce_ptr);
	if (NULL == TElPublicKeyCrypto_ce_ptr)
		Register_TElPublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElPublicKeyCrypto", TElPublicKeyCrypto_ce_ptr);
	if (NULL == TElRSAKeyMaterial_ce_ptr)
		Register_TElRSAKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElRSAKeyMaterial", TElRSAKeyMaterial_ce_ptr);
	if (NULL == TElRSAPublicKeyCrypto_ce_ptr)
		Register_TElRSAPublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElRSAPublicKeyCrypto", TElRSAPublicKeyCrypto_ce_ptr);
	if (NULL == TElDSAKeyMaterial_ce_ptr)
		Register_TElDSAKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElDSAKeyMaterial", TElDSAKeyMaterial_ce_ptr);
	if (NULL == TElDSAPublicKeyCrypto_ce_ptr)
		Register_TElDSAPublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElDSAPublicKeyCrypto", TElDSAPublicKeyCrypto_ce_ptr);
	if (NULL == TElDHKeyMaterial_ce_ptr)
		Register_TElDHKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElDHKeyMaterial", TElDHKeyMaterial_ce_ptr);
	if (NULL == TElDHPublicKeyCrypto_ce_ptr)
		Register_TElDHPublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElDHPublicKeyCrypto", TElDHPublicKeyCrypto_ce_ptr);
	if (NULL == TElElGamalKeyMaterial_ce_ptr)
		Register_TElElGamalKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElElGamalKeyMaterial", TElElGamalKeyMaterial_ce_ptr);
	if (NULL == TElElGamalPublicKeyCrypto_ce_ptr)
		Register_TElElGamalPublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElElGamalPublicKeyCrypto", TElElGamalPublicKeyCrypto_ce_ptr);
	if (NULL == TElGOST94KeyMaterial_ce_ptr)
		Register_TElGOST94KeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElGOST94KeyMaterial", TElGOST94KeyMaterial_ce_ptr);
	if (NULL == TElGOST94PublicKeyCrypto_ce_ptr)
		Register_TElGOST94PublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElGOST94PublicKeyCrypto", TElGOST94PublicKeyCrypto_ce_ptr);
	if (NULL == TElGOST2001KeyMaterial_ce_ptr)
		Register_TElGOST2001KeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElGOST2001KeyMaterial", TElGOST2001KeyMaterial_ce_ptr);
	if (NULL == TElGOST2001PublicKeyCrypto_ce_ptr)
		Register_TElGOST2001PublicKeyCrypto(TSRMLS_C);
	zend_register_class_alias("ElGOST2001PublicKeyCrypto", TElGOST2001PublicKeyCrypto_ce_ptr);
	if (NULL == TElPublicKeyCryptoFactory_ce_ptr)
		Register_TElPublicKeyCryptoFactory(TSRMLS_C);
	zend_register_class_alias("ElPublicKeyCryptoFactory", TElPublicKeyCryptoFactory_ce_ptr);
	TElPublicKeyCryptoClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElPublicKeyCryptoClass", TElPublicKeyCryptoClass_ce_ptr);
	zend_register_class_alias("ElPublicKeyCryptoClass", TObject_ce_ptr);
}
