#include "sbsymmetriccrypto.h"

zend_class_entry *TSBSymmetricCryptoMode_ce_ptr = NULL;

zend_class_entry *TSBSymmetricCipherPadding_ce_ptr = NULL;

zend_class_entry *TElSymmetricCryptoClass_ce_ptr = NULL;

zend_class_entry *TElSymmetricKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElSymmetricKeyMaterial, Generate)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, GenerateIV)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_GenerateIV(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, DeriveKey)
{
	char *sPassword;
	char *sSalt;
	int sPassword_len;
	int sSalt_len;
	long l4Bits;
	long l4Iterations;
	SBArrayZValInfo aiSalt;
	zval *zaSalt;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Bits, &sPassword, &sPassword_len) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_DeriveKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, sPassword, (int32_t)sPassword_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &l4Bits, &sPassword, &sPassword_len, &sSalt, &sSalt_len) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_DeriveKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, sPassword, (int32_t)sPassword_len, sSalt, (int32_t)sSalt_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsz", &l4Bits, &sPassword, &sPassword_len, &zaSalt) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))))
	{
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricKeyMaterial_DeriveKey_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, sPassword, (int32_t)sPassword_len, aiSalt.data, aiSalt.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSalt);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lszl", &l4Bits, &sPassword, &sPassword_len, &zaSalt, &l4Iterations) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))))
	{
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricKeyMaterial_DeriveKey_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, sPassword, (int32_t)sPassword_len, aiSalt.data, aiSalt.len, (int32_t)l4Iterations) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSalt);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string) or (integer, string, array of byte|string|NULL) or (integer, string, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, Load)
{
	long l4Count;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricKeyMaterial_Load(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_Load_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, Save)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *oStream;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElSymmetricKeyMaterial_Save(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_Save_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer) or (TStream)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSymmetricKeyMaterial, ImportEncryptedSymmetricKeyWin32)
{
	long l4PKAlgorithm;
	long l4SymAlgorithm;
#ifndef CPU64
	long u4hProv;
	long u4hUserKey;
#else
	long l8hProv;
	long l8hUserKey;
#endif
	SBArrayZValInfo aiEncryptedKey;
	SBArrayZValInfo aiSymAlgParams;
	zval *zaEncryptedKey;
	zval *zaSymAlgParams;
#ifndef CPU64
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzll", &zaEncryptedKey, &l4SymAlgorithm, &l4PKAlgorithm, &zaSymAlgParams, &u4hProv, &u4hUserKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaEncryptedKey)) || (IS_ARRAY == Z_TYPE_P(zaEncryptedKey)) || (IS_NULL == Z_TYPE_P(zaEncryptedKey))) && ((IS_STRING == Z_TYPE_P(zaSymAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaSymAlgParams)) || (IS_NULL == Z_TYPE_P(zaSymAlgParams))))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzll", &zaEncryptedKey, &l4SymAlgorithm, &l4PKAlgorithm, &zaSymAlgParams, &l8hProv, &l8hUserKey) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaEncryptedKey)) || (IS_ARRAY == Z_TYPE_P(zaEncryptedKey)) || (IS_NULL == Z_TYPE_P(zaEncryptedKey))) && ((IS_STRING == Z_TYPE_P(zaSymAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaSymAlgParams)) || (IS_NULL == Z_TYPE_P(zaSymAlgParams))))
#endif
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaEncryptedKey, &aiEncryptedKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSymAlgParams, &aiSymAlgParams TSRMLS_CC)) RETURN_FALSE;
#ifndef CPU64
		SBCheckError(TElSymmetricKeyMaterial_ImportEncryptedSymmetricKeyWin32(SBGetObjectHandle(getThis() TSRMLS_CC), aiEncryptedKey.data, aiEncryptedKey.len, (int32_t)l4SymAlgorithm, (int32_t)l4PKAlgorithm, aiSymAlgParams.data, aiSymAlgParams.len, (uint32_t)u4hProv, (uint32_t)u4hUserKey, &bOutResultRaw) TSRMLS_CC);
#else
		SBCheckError(TElSymmetricKeyMaterial_ImportEncryptedSymmetricKeyWin32(SBGetObjectHandle(getThis() TSRMLS_CC), aiEncryptedKey.data, aiEncryptedKey.len, (int32_t)l4SymAlgorithm, (int32_t)l4PKAlgorithm, aiSymAlgParams.data, aiSymAlgParams.len, (int64_t)l8hProv, (int64_t)l8hUserKey, &bOutResultRaw) TSRMLS_CC);
#endif
		SBFreeArrayZValInfo(&aiEncryptedKey);
		SBFreeArrayZValInfo(&aiSymAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSymmetricKeyMaterial, Persistentiate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_Persistentiate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, get_Key_ByteArray)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSymmetricKeyMaterial_get_Key_ByteArray(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(462094714, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, set_Key_ByteArray)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricKeyMaterial_set_Key_ByteArray(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, get_IV)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSymmetricKeyMaterial_get_IV(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-207535620, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, set_IV)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricKeyMaterial_set_IV(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricKeyMaterial_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, set_Algorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSymmetricKeyMaterial_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricKeyMaterial, __construct)
{
	zval *oKey;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricKeyMaterial_Create(SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElCustomCryptoKey_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricKeyMaterial_Create_1(SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricKeyMaterial_Create_2(SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oKey, TElCustomCryptoKey_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricKeyMaterial_Create_3(SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider) or (TElCustomCryptoKey, TElCustomCryptoProvider) or (TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomCryptoKey, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_Generate, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_GenerateIV, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_DeriveKey, 0, 0, 2)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_TYPE_INFO(0, Salt, 0, 1)
	ZEND_ARG_INFO(0, Iterations)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_Stream, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_ImportEncryptedSymmetricKeyWin32, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, EncryptedKey, 0, 1)
	ZEND_ARG_INFO(0, SymAlgorithm)
	ZEND_ARG_INFO(0, PKAlgorithm)
	ZEND_ARG_TYPE_INFO(0, SymAlgParams, 0, 1)
	ZEND_ARG_INFO(0, hProv)
	ZEND_ARG_INFO(0, hUserKey)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_Persistentiate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_get_Key_ByteArray, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_set_Key_ByteArray, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_get_IV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_set_IV, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricKeyMaterial___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Key_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prov_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSymmetricKeyMaterial_methods[] = {
	PHP_ME(TElSymmetricKeyMaterial, Generate, arginfo_TElSymmetricKeyMaterial_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, GenerateIV, arginfo_TElSymmetricKeyMaterial_GenerateIV, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, DeriveKey, arginfo_TElSymmetricKeyMaterial_DeriveKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, Load, arginfo_TElSymmetricKeyMaterial_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, Save, arginfo_TElSymmetricKeyMaterial_Save, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSymmetricKeyMaterial, ImportEncryptedSymmetricKeyWin32, arginfo_TElSymmetricKeyMaterial_ImportEncryptedSymmetricKeyWin32, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSymmetricKeyMaterial, Persistentiate, arginfo_TElSymmetricKeyMaterial_Persistentiate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, get_Key_ByteArray, arginfo_TElSymmetricKeyMaterial_get_Key_ByteArray, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, set_Key_ByteArray, arginfo_TElSymmetricKeyMaterial_set_Key_ByteArray, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, get_IV, arginfo_TElSymmetricKeyMaterial_get_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, set_IV, arginfo_TElSymmetricKeyMaterial_set_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, get_Algorithm, arginfo_TElSymmetricKeyMaterial_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, set_Algorithm, arginfo_TElSymmetricKeyMaterial_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricKeyMaterial, __construct, arginfo_TElSymmetricKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSymmetricKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSymmetricKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSymmetricKeyMaterial", TElSymmetricKeyMaterial_methods);
	if (NULL == TElKeyMaterial_ce_ptr)
		Register_TElKeyMaterial(TSRMLS_C);
	TElSymmetricKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TElKeyMaterial_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElSymmetricCrypto, InitializeEncryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_InitializeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, InitializeDecryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_InitializeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, Encrypt_Inst)
{
	int32_t l4OutSizeRaw;
	long fMode;
	long l4AlgID;
	long l4InSize;
	long l4Size;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zval *oInStream;
	zval *oOutStream;
	zval *zaIV;
	zval *zaKey;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_Encrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlzl", &l4AlgID, &zaKey, &zaIV, &fMode, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElSymmetricCrypto_Encrypt_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4AlgID, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (TSBSymmetricCryptoModeRaw)fMode, piBuffer.data, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2085357991, 7, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBFreePointerZValInfo(&piBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, Encrypt)
{
	long fMode;
	long l4AlgID;
	long l4Size;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo piBuffer;
	uint32_t _err;
	zval *zaIV;
	zval *zaKey;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlzl", &l4AlgID, &zaKey, &zaIV, &fMode, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElSymmetricCrypto_Encrypt_2((int32_t)l4AlgID, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (TSBSymmetricCryptoModeRaw)fMode, piBuffer.data, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2085357991, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBFreePointerZValInfo(&piBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, EncryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_EncryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, FinalizeEncryption)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_FinalizeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, EncryptAEAD)
{
	int32_t l4OutSizeRaw;
	long l4ADataSize;
	long l4InSize;
	SBArrayZValInfo piAssociatedData;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpAssociatedData;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpAssociatedData, &l4ADataSize, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpAssociatedData) == IS_STRING) || (Z_TYPE_P(zpAssociatedData) == IS_ARRAY) || (Z_TYPE_P(zpAssociatedData) == IS_NULL) || ((Z_TYPE_P(zpAssociatedData) == IS_OBJECT) && (Z_OBJCE_P(zpAssociatedData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpAssociatedData, &piAssociatedData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_EncryptAEAD(SBGetObjectHandle(getThis() TSRMLS_CC), piAssociatedData.data, (int32_t)l4ADataSize, piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piAssociatedData);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, Decrypt_Inst)
{
	int32_t l4OutSizeRaw;
	long fMode;
	long l4AlgID;
	long l4InCount;
	long l4InSize;
	long l4Size;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	uint32_t _err;
	zval *oInStream;
	zval *oOutStream;
	zval *zaIV;
	zval *zaKey;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l4InCount) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_Decrypt_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int32_t)l4InCount) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlzl", &l4AlgID, &zaKey, &zaIV, &fMode, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElSymmetricCrypto_Decrypt_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4AlgID, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (TSBSymmetricCryptoModeRaw)fMode, piBuffer.data, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-523334556, 7, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBFreePointerZValInfo(&piBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, Decrypt)
{
	long fMode;
	long l4AlgID;
	long l4Size;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiKey;
	SBArrayZValInfo piBuffer;
	uint32_t _err;
	zval *zaIV;
	zval *zaKey;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlzl", &l4AlgID, &zaKey, &zaIV, &fMode, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = TElSymmetricCrypto_Decrypt_2((int32_t)l4AlgID, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (TSBSymmetricCryptoModeRaw)fMode, piBuffer.data, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-523334556, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBFreePointerZValInfo(&piBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, DecryptAEAD)
{
	int32_t l4OutSizeRaw;
	long l4ADataSize;
	long l4InSize;
	SBArrayZValInfo piAssociatedData;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpAssociatedData;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpAssociatedData, &l4ADataSize, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpAssociatedData) == IS_STRING) || (Z_TYPE_P(zpAssociatedData) == IS_ARRAY) || (Z_TYPE_P(zpAssociatedData) == IS_NULL) || ((Z_TYPE_P(zpAssociatedData) == IS_OBJECT) && (Z_OBJCE_P(zpAssociatedData) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpAssociatedData, &piAssociatedData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_DecryptAEAD(SBGetObjectHandle(getThis() TSRMLS_CC), piAssociatedData.data, (int32_t)l4ADataSize, piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piAssociatedData);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, DecryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_DecryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSymmetricCrypto, DecryptUpdateWin32)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_DecryptUpdateWin32(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSymmetricCrypto, FinalizeDecryption)
{
	int32_t l4OutSizeRaw;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSymmetricCrypto_FinalizeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC), piOutBuffer.data, &l4OutSizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_AlgID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_AlgID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_MACAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_MACAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_KeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_get_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSymmetricKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_KeyMaterial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSymmetricKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_KeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSymmetricKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSymmetricCryptoModeRaw fOutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_BlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_Padding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSymmetricCipherPaddingRaw fOutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_Padding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_Padding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_Padding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSymmetricCipherPaddingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_CTRLittleEndian)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_CTRLittleEndian(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_CTRLittleEndian)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_CTRLittleEndian(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_Nonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSymmetricCrypto_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2125681251, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_Nonce)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricCrypto_set_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_TagSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_TagSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_TagSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_TagSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_AssociatedDataSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_AssociatedDataSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_AssociatedDataSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_AssociatedDataSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_PayloadSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_PayloadSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_PayloadSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_AssociatedData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_AssociatedData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_AssociatedData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_AssociatedData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_IsStreamCipher)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSymmetricCrypto_get_IsStreamCipher(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricCrypto_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSymmetricCrypto_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	long l4MacAlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!", &l4AlgID, &l4MacAlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_Create_6((int32_t)l4AlgID, (int32_t)l4MacAlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4AlgID, &l4MacAlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCrypto_Create_7((int32_t)l4AlgID, (int32_t)l4MacAlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, integer, integer, TElCustomCryptoProvider) or (integer, integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_InitializeEncryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_InitializeDecryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_Encrypt_Inst, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream_or_AlgID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_IV, 0, 1)
	ZEND_ARG_INFO(1, OutSize_or_Mode)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_Encrypt, 0, 0, 6)
	ZEND_ARG_INFO(0, AlgID)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IV, 0, 1)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_EncryptUpdate, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_FinalizeEncryption, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_EncryptAEAD, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, AssociatedData, 0, 1)
	ZEND_ARG_INFO(0, ADataSize)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_Decrypt_Inst, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream_or_AlgID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InCount_or_IV, 0, 1)
	ZEND_ARG_INFO(1, OutSize_or_Mode)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_Decrypt, 0, 0, 6)
	ZEND_ARG_INFO(0, AlgID)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IV, 0, 1)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_DecryptAEAD, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, AssociatedData, 0, 1)
	ZEND_ARG_INFO(0, ADataSize)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_DecryptUpdate, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_DecryptUpdateWin32, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_FinalizeDecryption, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_AlgID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_MACAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_KeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_KeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSymmetricKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_BlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_Padding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_Padding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_CTRLittleEndian, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_CTRLittleEndian, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_Nonce, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_TagSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_TagSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_AssociatedDataSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_AssociatedDataSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_PayloadSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_PayloadSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_AssociatedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_AssociatedData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_IsStreamCipher, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager_or_MacAlgID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSymmetricCrypto_methods[] = {
	PHP_ME(TElSymmetricCrypto, InitializeEncryption, arginfo_TElSymmetricCrypto_InitializeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, InitializeDecryption, arginfo_TElSymmetricCrypto_InitializeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, Encrypt_Inst, arginfo_TElSymmetricCrypto_Encrypt_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, Encrypt, arginfo_TElSymmetricCrypto_Encrypt, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSymmetricCrypto, EncryptUpdate, arginfo_TElSymmetricCrypto_EncryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, FinalizeEncryption, arginfo_TElSymmetricCrypto_FinalizeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, EncryptAEAD, arginfo_TElSymmetricCrypto_EncryptAEAD, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, Decrypt_Inst, arginfo_TElSymmetricCrypto_Decrypt_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, Decrypt, arginfo_TElSymmetricCrypto_Decrypt, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSymmetricCrypto, DecryptAEAD, arginfo_TElSymmetricCrypto_DecryptAEAD, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, DecryptUpdate, arginfo_TElSymmetricCrypto_DecryptUpdate, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSymmetricCrypto, DecryptUpdateWin32, arginfo_TElSymmetricCrypto_DecryptUpdateWin32, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSymmetricCrypto, FinalizeDecryption, arginfo_TElSymmetricCrypto_FinalizeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, ClassType, arginfo_TElSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSymmetricCrypto, get_AlgID, arginfo_TElSymmetricCrypto_get_AlgID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_MACAlgorithm, arginfo_TElSymmetricCrypto_get_MACAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_KeyMaterial, arginfo_TElSymmetricCrypto_get_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_KeyMaterial, arginfo_TElSymmetricCrypto_set_KeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_Mode, arginfo_TElSymmetricCrypto_get_Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_BlockSize, arginfo_TElSymmetricCrypto_get_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_KeySize, arginfo_TElSymmetricCrypto_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_Padding, arginfo_TElSymmetricCrypto_get_Padding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_Padding, arginfo_TElSymmetricCrypto_set_Padding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_CTRLittleEndian, arginfo_TElSymmetricCrypto_get_CTRLittleEndian, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_CTRLittleEndian, arginfo_TElSymmetricCrypto_set_CTRLittleEndian, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_Nonce, arginfo_TElSymmetricCrypto_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_Nonce, arginfo_TElSymmetricCrypto_set_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_TagSize, arginfo_TElSymmetricCrypto_get_TagSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_TagSize, arginfo_TElSymmetricCrypto_set_TagSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_AssociatedDataSize, arginfo_TElSymmetricCrypto_get_AssociatedDataSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_AssociatedDataSize, arginfo_TElSymmetricCrypto_set_AssociatedDataSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_PayloadSize, arginfo_TElSymmetricCrypto_get_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_PayloadSize, arginfo_TElSymmetricCrypto_set_PayloadSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_AssociatedData, arginfo_TElSymmetricCrypto_get_AssociatedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_AssociatedData, arginfo_TElSymmetricCrypto_set_AssociatedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_IsStreamCipher, arginfo_TElSymmetricCrypto_get_IsStreamCipher, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_CryptoProvider, arginfo_TElSymmetricCrypto_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_CryptoProvider, arginfo_TElSymmetricCrypto_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_CryptoProviderManager, arginfo_TElSymmetricCrypto_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_CryptoProviderManager, arginfo_TElSymmetricCrypto_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, get_OnProgress, arginfo_TElSymmetricCrypto_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, set_OnProgress, arginfo_TElSymmetricCrypto_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCrypto, __construct, arginfo_TElSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSymmetricCrypto", TElSymmetricCrypto_methods);
	if (NULL == TElCustomCrypto_ce_ptr)
		Register_TElCustomCrypto(TSRMLS_C);
	TElSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSymmetricCryptoFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElSymmetricCryptoFactory, CreateInstance)
{
	long fMode;
	long l4Alg;
	long l4Mac;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaOID, &fMode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricCryptoFactory_CreateInstance(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, (TSBSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBInitObject(return_value, TElSymmetricCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Alg, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCryptoFactory_CreateInstance_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, (TSBSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSymmetricCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lll", &l4Alg, &l4Mac, &fMode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCryptoFactory_CreateInstance_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, (int32_t)l4Mac, (TSBSymmetricCryptoModeRaw)fMode, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSymmetricCrypto_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer) or (integer, integer) or (integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, IsAlgorithmSupported)
{
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSymmetricCryptoFactory_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Alg) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSymmetricCryptoFactory_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, GetDefaultKeyAndBlockLengths)
{
	int32_t l4BlockLenRaw;
	int32_t l4KeyLenRaw;
	long l4Alg;
	SBArrayZValInfo aiOID;
	zval *zaOID;
	zval *zl4BlockLen;
	zval *zl4KeyLen;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l4Alg, &zl4KeyLen, &zl4BlockLen) == SUCCESS) && PZVAL_IS_REF(zl4KeyLen) && (IS_LONG == Z_TYPE_P(zl4KeyLen)) && PZVAL_IS_REF(zl4BlockLen) && (IS_LONG == Z_TYPE_P(zl4BlockLen)))
	{
		int8_t bOutResultRaw = 0;
		l4KeyLenRaw = (int32_t)Z_LVAL_P(zl4KeyLen);
		l4BlockLenRaw = (int32_t)Z_LVAL_P(zl4BlockLen);
		SBCheckError(TElSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Alg, &l4KeyLenRaw, &l4BlockLenRaw, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl4KeyLen, (long)l4KeyLenRaw);
		ZVAL_LONG(zl4BlockLen, (long)l4BlockLenRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zaOID, &zl4KeyLen, &zl4BlockLen) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))) && PZVAL_IS_REF(zl4KeyLen) && (IS_LONG == Z_TYPE_P(zl4KeyLen)) && PZVAL_IS_REF(zl4BlockLen) && (IS_LONG == Z_TYPE_P(zl4BlockLen)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		l4KeyLenRaw = (int32_t)Z_LVAL_P(zl4KeyLen);
		l4BlockLenRaw = (int32_t)Z_LVAL_P(zl4BlockLen);
		SBCheckError(TElSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &l4KeyLenRaw, &l4BlockLenRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		ZVAL_LONG(zl4KeyLen, (long)l4KeyLenRaw);
		ZVAL_LONG(zl4BlockLen, (long)l4BlockLenRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &integer, &integer) or (array of byte|string|NULL, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, get_CryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCryptoFactory_get_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, set_CryptoProvider)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricCryptoFactory_set_CryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCryptoFactory_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSymmetricCryptoFactory_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSymmetricCryptoFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSymmetricCryptoFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_CreateInstance, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg, 0, 1)
	ZEND_ARG_INFO(0, Mode_or_Mac)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_IsAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID_or_Alg, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Alg_or_OID, 0, 1)
	ZEND_ARG_INFO(1, KeyLen)
	ZEND_ARG_INFO(1, BlockLen)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_get_CryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_set_CryptoProvider, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSymmetricCryptoFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSymmetricCryptoFactory_methods[] = {
	PHP_ME(TElSymmetricCryptoFactory, CreateInstance, arginfo_TElSymmetricCryptoFactory_CreateInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, IsAlgorithmSupported, arginfo_TElSymmetricCryptoFactory_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, GetDefaultKeyAndBlockLengths, arginfo_TElSymmetricCryptoFactory_GetDefaultKeyAndBlockLengths, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, get_CryptoProvider, arginfo_TElSymmetricCryptoFactory_get_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, set_CryptoProvider, arginfo_TElSymmetricCryptoFactory_set_CryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, get_CryptoProviderManager, arginfo_TElSymmetricCryptoFactory_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, set_CryptoProviderManager, arginfo_TElSymmetricCryptoFactory_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSymmetricCryptoFactory, __construct, arginfo_TElSymmetricCryptoFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSymmetricCryptoFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSymmetricCryptoFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSymmetricCryptoFactory", TElSymmetricCryptoFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSymmetricCryptoFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAESSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElAESSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAESSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAESSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAESSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAESSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAESSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAESSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAESSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAESSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAESSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAESSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAESSymmetricCrypto_methods[] = {
	PHP_ME(TElAESSymmetricCrypto, ClassType, arginfo_TElAESSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAESSymmetricCrypto, __construct, arginfo_TElAESSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAESSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAESSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAESSymmetricCrypto", TElAESSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElAESSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBlowfishSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElBlowfishSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlowfishSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBlowfishSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlowfishSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBlowfishSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlowfishSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlowfishSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBlowfishSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBlowfishSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBlowfishSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBlowfishSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBlowfishSymmetricCrypto_methods[] = {
	PHP_ME(TElBlowfishSymmetricCrypto, ClassType, arginfo_TElBlowfishSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBlowfishSymmetricCrypto, __construct, arginfo_TElBlowfishSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBlowfishSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBlowfishSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBlowfishSymmetricCrypto", TElBlowfishSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElBlowfishSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTwofishSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElTwofishSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTwofishSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTwofishSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTwofishSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTwofishSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTwofishSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTwofishSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTwofishSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTwofishSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTwofishSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTwofishSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTwofishSymmetricCrypto_methods[] = {
	PHP_ME(TElTwofishSymmetricCrypto, ClassType, arginfo_TElTwofishSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElTwofishSymmetricCrypto, __construct, arginfo_TElTwofishSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTwofishSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTwofishSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTwofishSymmetricCrypto", TElTwofishSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElTwofishSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIDEASymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElIDEASymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIDEASymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIDEASymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIDEASymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElIDEASymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIDEASymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIDEASymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElIDEASymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIDEASymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIDEASymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIDEASymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElIDEASymmetricCrypto_methods[] = {
	PHP_ME(TElIDEASymmetricCrypto, ClassType, arginfo_TElIDEASymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElIDEASymmetricCrypto, __construct, arginfo_TElIDEASymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIDEASymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIDEASymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIDEASymmetricCrypto", TElIDEASymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElIDEASymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCAST128SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElCAST128SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCAST128SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCAST128SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCAST128SymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCAST128SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCAST128SymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCAST128SymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCAST128SymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCAST128SymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCAST128SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCAST128SymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCAST128SymmetricCrypto_methods[] = {
	PHP_ME(TElCAST128SymmetricCrypto, ClassType, arginfo_TElCAST128SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCAST128SymmetricCrypto, __construct, arginfo_TElCAST128SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCAST128SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCAST128SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCAST128SymmetricCrypto", TElCAST128SymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElCAST128SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRC2SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElRC2SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC2SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRC2SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC2SymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRC2SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC2SymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC2SymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRC2SymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC2SymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC2SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC2SymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRC2SymmetricCrypto_methods[] = {
	PHP_ME(TElRC2SymmetricCrypto, ClassType, arginfo_TElRC2SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRC2SymmetricCrypto, __construct, arginfo_TElRC2SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRC2SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRC2SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRC2SymmetricCrypto", TElRC2SymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElRC2SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRC4SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElRC4SymmetricCrypto, InitializeEncryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElRC4SymmetricCrypto_InitializeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRC4SymmetricCrypto, InitializeDecryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElRC4SymmetricCrypto_InitializeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRC4SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC4SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRC4SymmetricCrypto, get_SkipKeystreamBytes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRC4SymmetricCrypto_get_SkipKeystreamBytes(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRC4SymmetricCrypto, set_SkipKeystreamBytes)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRC4SymmetricCrypto_set_SkipKeystreamBytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRC4SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC4SymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRC4SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC4SymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC4SymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRC4SymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRC4SymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC4SymmetricCrypto_InitializeEncryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC4SymmetricCrypto_InitializeDecryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC4SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC4SymmetricCrypto_get_SkipKeystreamBytes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC4SymmetricCrypto_set_SkipKeystreamBytes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRC4SymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRC4SymmetricCrypto_methods[] = {
	PHP_ME(TElRC4SymmetricCrypto, InitializeEncryption, arginfo_TElRC4SymmetricCrypto_InitializeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElRC4SymmetricCrypto, InitializeDecryption, arginfo_TElRC4SymmetricCrypto_InitializeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElRC4SymmetricCrypto, ClassType, arginfo_TElRC4SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRC4SymmetricCrypto, get_SkipKeystreamBytes, arginfo_TElRC4SymmetricCrypto_get_SkipKeystreamBytes, ZEND_ACC_PUBLIC)
	PHP_ME(TElRC4SymmetricCrypto, set_SkipKeystreamBytes, arginfo_TElRC4SymmetricCrypto_set_SkipKeystreamBytes, ZEND_ACC_PUBLIC)
	PHP_ME(TElRC4SymmetricCrypto, __construct, arginfo_TElRC4SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRC4SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRC4SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRC4SymmetricCrypto", TElRC4SymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElRC4SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDESSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElDESSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDESSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDESSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDESSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDESSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDESSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDESSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDESSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDESSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDESSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDESSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElDESSymmetricCrypto_methods[] = {
	PHP_ME(TElDESSymmetricCrypto, ClassType, arginfo_TElDESSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElDESSymmetricCrypto, __construct, arginfo_TElDESSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDESSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDESSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDESSymmetricCrypto", TElDESSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElDESSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TEl3DESSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TEl3DESSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl3DESSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TEl3DESSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl3DESSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TEl3DESSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl3DESSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl3DESSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TEl3DESSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TEl3DESSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl3DESSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TEl3DESSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TEl3DESSymmetricCrypto_methods[] = {
	PHP_ME(TEl3DESSymmetricCrypto, ClassType, arginfo_TEl3DESSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TEl3DESSymmetricCrypto, __construct, arginfo_TEl3DESSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TEl3DESSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TEl3DESSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TEl3DESSymmetricCrypto", TEl3DESSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TEl3DESSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCamelliaSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElCamelliaSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCamelliaSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCamelliaSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCamelliaSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCamelliaSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCamelliaSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCamelliaSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCamelliaSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCamelliaSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCamelliaSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCamelliaSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElCamelliaSymmetricCrypto_methods[] = {
	PHP_ME(TElCamelliaSymmetricCrypto, ClassType, arginfo_TElCamelliaSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCamelliaSymmetricCrypto, __construct, arginfo_TElCamelliaSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCamelliaSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCamelliaSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCamelliaSymmetricCrypto", TElCamelliaSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElCamelliaSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSerpentSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElSerpentSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSerpentSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSerpentSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSerpentSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSerpentSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSerpentSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSerpentSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSerpentSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSerpentSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSerpentSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSerpentSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSerpentSymmetricCrypto_methods[] = {
	PHP_ME(TElSerpentSymmetricCrypto, ClassType, arginfo_TElSerpentSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSerpentSymmetricCrypto, __construct, arginfo_TElSerpentSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSerpentSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSerpentSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSerpentSymmetricCrypto", TElSerpentSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElSerpentSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSEEDSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElSEEDSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSEEDSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSEEDSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSEEDSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSEEDSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSEEDSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSEEDSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSEEDSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSEEDSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSEEDSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSEEDSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSEEDSymmetricCrypto_methods[] = {
	PHP_ME(TElSEEDSymmetricCrypto, ClassType, arginfo_TElSEEDSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSEEDSymmetricCrypto, __construct, arginfo_TElSEEDSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSEEDSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSEEDSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSEEDSymmetricCrypto", TElSEEDSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElSEEDSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElRabbitSymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElRabbitSymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRabbitSymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRabbitSymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRabbitSymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRabbitSymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRabbitSymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRabbitSymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRabbitSymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRabbitSymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRabbitSymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRabbitSymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRabbitSymmetricCrypto_methods[] = {
	PHP_ME(TElRabbitSymmetricCrypto, ClassType, arginfo_TElRabbitSymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElRabbitSymmetricCrypto, __construct, arginfo_TElRabbitSymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRabbitSymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRabbitSymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRabbitSymmetricCrypto", TElRabbitSymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElRabbitSymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGOST28147SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, InitializeEncryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST28147SymmetricCrypto_InitializeEncryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, InitializeDecryption)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGOST28147SymmetricCrypto_InitializeDecryption(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST28147SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, get_ParamSet)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST28147SymmetricCrypto_get_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(472560553, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, set_ParamSet)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST28147SymmetricCrypto_set_ParamSet(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, get_SBoxes)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGOST28147SymmetricCrypto_get_SBoxes(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-105658675, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, set_SBoxes)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST28147SymmetricCrypto_set_SBoxes(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, get_UseKeyMeshing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGOST28147SymmetricCrypto_get_UseKeyMeshing(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, set_UseKeyMeshing)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGOST28147SymmetricCrypto_set_UseKeyMeshing(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGOST28147SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST28147SymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST28147SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST28147SymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST28147SymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGOST28147SymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGOST28147SymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_InitializeEncryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_InitializeDecryption, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_get_ParamSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_set_ParamSet, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_get_SBoxes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_set_SBoxes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_get_UseKeyMeshing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto_set_UseKeyMeshing, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGOST28147SymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGOST28147SymmetricCrypto_methods[] = {
	PHP_ME(TElGOST28147SymmetricCrypto, InitializeEncryption, arginfo_TElGOST28147SymmetricCrypto_InitializeEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, InitializeDecryption, arginfo_TElGOST28147SymmetricCrypto_InitializeDecryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, ClassType, arginfo_TElGOST28147SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGOST28147SymmetricCrypto, get_ParamSet, arginfo_TElGOST28147SymmetricCrypto_get_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, set_ParamSet, arginfo_TElGOST28147SymmetricCrypto_set_ParamSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, get_SBoxes, arginfo_TElGOST28147SymmetricCrypto_get_SBoxes, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, set_SBoxes, arginfo_TElGOST28147SymmetricCrypto_set_SBoxes, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, get_UseKeyMeshing, arginfo_TElGOST28147SymmetricCrypto_get_UseKeyMeshing, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, set_UseKeyMeshing, arginfo_TElGOST28147SymmetricCrypto_set_UseKeyMeshing, ZEND_ACC_PUBLIC)
	PHP_ME(TElGOST28147SymmetricCrypto, __construct, arginfo_TElGOST28147SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGOST28147SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGOST28147SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGOST28147SymmetricCrypto", TElGOST28147SymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElGOST28147SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIdentitySymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElIdentitySymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIdentitySymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIdentitySymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIdentitySymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElIdentitySymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIdentitySymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIdentitySymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElIdentitySymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIdentitySymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIdentitySymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIdentitySymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElIdentitySymmetricCrypto_methods[] = {
	PHP_ME(TElIdentitySymmetricCrypto, ClassType, arginfo_TElIdentitySymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElIdentitySymmetricCrypto, __construct, arginfo_TElIdentitySymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIdentitySymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIdentitySymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIdentitySymmetricCrypto", TElIdentitySymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElIdentitySymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElChaCha20SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElChaCha20SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChaCha20SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChaCha20SymmetricCrypto, get_Counter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElChaCha20SymmetricCrypto_get_Counter(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChaCha20SymmetricCrypto, set_Counter)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElChaCha20SymmetricCrypto_set_Counter(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChaCha20SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChaCha20SymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChaCha20SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChaCha20SymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChaCha20SymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChaCha20SymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChaCha20SymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChaCha20SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChaCha20SymmetricCrypto_get_Counter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChaCha20SymmetricCrypto_set_Counter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChaCha20SymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElChaCha20SymmetricCrypto_methods[] = {
	PHP_ME(TElChaCha20SymmetricCrypto, ClassType, arginfo_TElChaCha20SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElChaCha20SymmetricCrypto, get_Counter, arginfo_TElChaCha20SymmetricCrypto_get_Counter, ZEND_ACC_PUBLIC)
	PHP_ME(TElChaCha20SymmetricCrypto, set_Counter, arginfo_TElChaCha20SymmetricCrypto_set_Counter, ZEND_ACC_PUBLIC)
	PHP_ME(TElChaCha20SymmetricCrypto, __construct, arginfo_TElChaCha20SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElChaCha20SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElChaCha20SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElChaCha20SymmetricCrypto", TElChaCha20SymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElChaCha20SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAEADChaCha20Poly1305SymmetricCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, get_AAD)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAEADChaCha20Poly1305SymmetricCrypto_get_AAD(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-322496856, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, set_AAD)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_set_AAD(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPoly1305Tag roOutResult;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPoly1305Tag_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPoly1305Tag) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TSBPoly1305Tag_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPoly1305Tag *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPoly1305Tag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, get_Poly1305Mode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPoly1305ModeRaw fOutResultRaw = 0;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_get_Poly1305Mode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, set_Poly1305Mode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_set_Poly1305Mode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPoly1305ModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAEADChaCha20Poly1305SymmetricCrypto, __construct)
{
	long fMode;
	long l4AlgID;
	SBArrayZValInfo aiAlgOID;
	zval *oCryptoProvider;
	zval *oManager;
	zval *zaAlgOID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4AlgID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_Create((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zaAlgOID, &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_Create_1(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fMode, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_Create_2((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!", &l4AlgID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_Create_3((int32_t)l4AlgID, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!O!", &zaAlgOID, &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_Create_4(aiAlgOID.data, aiAlgOID.len, (TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!", &fMode, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oCryptoProvider, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAEADChaCha20Poly1305SymmetricCrypto_Create_5((TSBSymmetricCryptoModeRaw)fMode, SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oCryptoProvider TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProvider) or (integer, TElCustomCryptoProvider) or (integer, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (array of byte|string|NULL, integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (integer, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_get_AAD, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_set_AAD, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TSBPoly1305Tag, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_get_Poly1305Mode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_set_Poly1305Mode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAEADChaCha20Poly1305SymmetricCrypto___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AlgID_or_AlgOID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_TYPE_INFO(0, CryptoProvider_or_Manager, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CryptoProvider, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAEADChaCha20Poly1305SymmetricCrypto_methods[] = {
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, ClassType, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, get_AAD, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_get_AAD, ZEND_ACC_PUBLIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, set_AAD, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_set_AAD, ZEND_ACC_PUBLIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, get_Tag, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, set_Tag, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, get_Poly1305Mode, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_get_Poly1305Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, set_Poly1305Mode, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto_set_Poly1305Mode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAEADChaCha20Poly1305SymmetricCrypto, __construct, arginfo_TElAEADChaCha20Poly1305SymmetricCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAEADChaCha20Poly1305SymmetricCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAEADChaCha20Poly1305SymmetricCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAEADChaCha20Poly1305SymmetricCrypto", TElAEADChaCha20Poly1305SymmetricCrypto_methods);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	TElAEADChaCha20Poly1305SymmetricCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TElSymmetricCrypto_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSymmetricCrypto_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSymmetricCryptoMode", NULL);
	TSBSymmetricCryptoMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSymmetricCryptoMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmECB", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmCBC", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmCTR", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmCFB8", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmGCM", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmCCM", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCryptoMode_ce_ptr, "cmAEADChaCha20Poly1305", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBSymmetricCipherPadding", NULL);
	TSBSymmetricCipherPadding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSymmetricCipherPadding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCipherPadding_ce_ptr, "cpNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCipherPadding_ce_ptr, "cpPKCS5", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSymmetricCipherPadding_ce_ptr, "cpANSIX923", 2)
}

void Register_SBSymmetricCrypto_Aliases(TSRMLS_D)
{
	if (NULL == TElSymmetricKeyMaterial_ce_ptr)
		Register_TElSymmetricKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElSymmetricKeyMaterial", TElSymmetricKeyMaterial_ce_ptr);
	if (NULL == TElSymmetricCrypto_ce_ptr)
		Register_TElSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElSymmetricCrypto", TElSymmetricCrypto_ce_ptr);
	if (NULL == TElSymmetricCryptoFactory_ce_ptr)
		Register_TElSymmetricCryptoFactory(TSRMLS_C);
	zend_register_class_alias("ElSymmetricCryptoFactory", TElSymmetricCryptoFactory_ce_ptr);
	if (NULL == TElAESSymmetricCrypto_ce_ptr)
		Register_TElAESSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElAESSymmetricCrypto", TElAESSymmetricCrypto_ce_ptr);
	if (NULL == TElBlowfishSymmetricCrypto_ce_ptr)
		Register_TElBlowfishSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElBlowfishSymmetricCrypto", TElBlowfishSymmetricCrypto_ce_ptr);
	if (NULL == TElTwofishSymmetricCrypto_ce_ptr)
		Register_TElTwofishSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElTwofishSymmetricCrypto", TElTwofishSymmetricCrypto_ce_ptr);
	if (NULL == TElIDEASymmetricCrypto_ce_ptr)
		Register_TElIDEASymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElIDEASymmetricCrypto", TElIDEASymmetricCrypto_ce_ptr);
	if (NULL == TElCAST128SymmetricCrypto_ce_ptr)
		Register_TElCAST128SymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElCAST128SymmetricCrypto", TElCAST128SymmetricCrypto_ce_ptr);
	if (NULL == TElRC2SymmetricCrypto_ce_ptr)
		Register_TElRC2SymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElRC2SymmetricCrypto", TElRC2SymmetricCrypto_ce_ptr);
	if (NULL == TElRC4SymmetricCrypto_ce_ptr)
		Register_TElRC4SymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElRC4SymmetricCrypto", TElRC4SymmetricCrypto_ce_ptr);
	if (NULL == TElDESSymmetricCrypto_ce_ptr)
		Register_TElDESSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElDESSymmetricCrypto", TElDESSymmetricCrypto_ce_ptr);
	if (NULL == TEl3DESSymmetricCrypto_ce_ptr)
		Register_TEl3DESSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("El3DESSymmetricCrypto", TEl3DESSymmetricCrypto_ce_ptr);
	if (NULL == TElCamelliaSymmetricCrypto_ce_ptr)
		Register_TElCamelliaSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElCamelliaSymmetricCrypto", TElCamelliaSymmetricCrypto_ce_ptr);
	if (NULL == TElSerpentSymmetricCrypto_ce_ptr)
		Register_TElSerpentSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElSerpentSymmetricCrypto", TElSerpentSymmetricCrypto_ce_ptr);
	if (NULL == TElSEEDSymmetricCrypto_ce_ptr)
		Register_TElSEEDSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElSEEDSymmetricCrypto", TElSEEDSymmetricCrypto_ce_ptr);
	if (NULL == TElRabbitSymmetricCrypto_ce_ptr)
		Register_TElRabbitSymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElRabbitSymmetricCrypto", TElRabbitSymmetricCrypto_ce_ptr);
	if (NULL == TElGOST28147SymmetricCrypto_ce_ptr)
		Register_TElGOST28147SymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElGOST28147SymmetricCrypto", TElGOST28147SymmetricCrypto_ce_ptr);
	if (NULL == TElIdentitySymmetricCrypto_ce_ptr)
		Register_TElIdentitySymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElIdentitySymmetricCrypto", TElIdentitySymmetricCrypto_ce_ptr);
	if (NULL == TElChaCha20SymmetricCrypto_ce_ptr)
		Register_TElChaCha20SymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElChaCha20SymmetricCrypto", TElChaCha20SymmetricCrypto_ce_ptr);
	if (NULL == TElAEADChaCha20Poly1305SymmetricCrypto_ce_ptr)
		Register_TElAEADChaCha20Poly1305SymmetricCrypto(TSRMLS_C);
	zend_register_class_alias("ElAEADChaCha20Poly1305SymmetricCrypto", TElAEADChaCha20Poly1305SymmetricCrypto_ce_ptr);
	TElSymmetricCryptoClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElSymmetricCryptoClass", TElSymmetricCryptoClass_ce_ptr);
	zend_register_class_alias("ElSymmetricCryptoClass", TObject_ce_ptr);
}
