#include "sbxmlades.h"

zend_class_entry *TSBXAdESVersion_ce_ptr = NULL;

zend_class_entry *TSBXAdESForm_ce_ptr = NULL;

zend_class_entry *TSBXAdESQualifierType_ce_ptr = NULL;

zend_class_entry *TSBXAdESEncodingMethod_ce_ptr = NULL;

zend_class_entry *TSBXAdESResponderIDType_ce_ptr = NULL;

zend_class_entry *TElXMLAdESElement_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLAdESElement, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLAdESElement_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAdESElement, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLAdESElement_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAdESElement, get_XAdESVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESVersionRaw fOutResultRaw = 0;
		SBCheckError(TElXMLAdESElement_get_XAdESVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAdESElement, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAdESElement_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAdESElement_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAdESElement_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAdESElement_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAdESElement_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAdESElement_get_XAdESVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAdESElement___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLAdESElement_methods[] = {
	PHP_ME(TElXMLAdESElement, Assign, arginfo_TElXMLAdESElement_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAdESElement, IsEmpty, arginfo_TElXMLAdESElement_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAdESElement, get_XAdESVersion, arginfo_TElXMLAdESElement_get_XAdESVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAdESElement, __construct, arginfo_TElXMLAdESElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLAdESElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLAdESElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLAdESElement", TElXMLAdESElement_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLAdESElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLAnyType_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLAnyType, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLAnyType_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLAnyType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLAnyType_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLAnyType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyType_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, set_Value)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLAnyType_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyType, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyType_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyType_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyType_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType_set_Value, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyType___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLAnyType_methods[] = {
	PHP_ME(TElXMLAnyType, Assign, arginfo_TElXMLAnyType_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, Clear, arginfo_TElXMLAnyType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, IsEmpty, arginfo_TElXMLAnyType_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, LoadFromXML, arginfo_TElXMLAnyType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, SaveToXML, arginfo_TElXMLAnyType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, get_Value, arginfo_TElXMLAnyType_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, set_Value, arginfo_TElXMLAnyType_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyType, __construct, arginfo_TElXMLAnyType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLAnyType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLAnyType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLAnyType", TElXMLAnyType_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLAnyType_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLAnyTypeList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLAnyTypeList, Assign)
{
	long fAVersion;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oSource, TElXMLAnyTypeList_ce_ptr, &fAVersion) == SUCCESS)
	{
		SBCheckError(TElXMLAnyTypeList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (TSBXAdESVersionRaw)fAVersion) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAnyTypeList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, Add)
{
	zval *oAItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAItem, TElXMLAnyType_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLAnyTypeList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAItem TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAnyType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, Insert)
{
	long l4Index;
	zval *oAItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAItem, TElXMLAnyType_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLAnyTypeList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLAnyType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLAnyTypeList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLAnyTypeList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLAnyTypeList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, get_Item)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyTypeList_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLAnyTypeList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLAnyTypeList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_Assign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAnyTypeList, 1)
	ZEND_ARG_INFO(0, AVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AItem, TElXMLAnyType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AItem, TElXMLAnyType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLAnyTypeList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLAnyTypeList_methods[] = {
	PHP_ME(TElXMLAnyTypeList, Assign, arginfo_TElXMLAnyTypeList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, Add, arginfo_TElXMLAnyTypeList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, Insert, arginfo_TElXMLAnyTypeList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, Delete, arginfo_TElXMLAnyTypeList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, Clear, arginfo_TElXMLAnyTypeList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, get_Count, arginfo_TElXMLAnyTypeList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, get_Item, arginfo_TElXMLAnyTypeList_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLAnyTypeList, __construct, arginfo_TElXMLAnyTypeList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLAnyTypeList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLAnyTypeList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLAnyTypeList", TElXMLAnyTypeList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLAnyTypeList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLObjectIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLObjectIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLObjectIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLObjectIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLObjectIdentifier_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLObjectIdentifier_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLObjectIdentifier_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLObjectIdentifier_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLObjectIdentifier_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-185012644, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLObjectIdentifier_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, get_DocumentationReferences)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLObjectIdentifier_get_DocumentationReferences(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, get_Identifier)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLObjectIdentifier_get_Identifier(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1840984911, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, set_Identifier)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLObjectIdentifier_set_Identifier(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, get_IdentifierQualifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESQualifierTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLObjectIdentifier_get_IdentifierQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, set_IdentifierQualifier)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLObjectIdentifier_set_IdentifierQualifier(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESQualifierTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLObjectIdentifier, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLObjectIdentifier_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLObjectIdentifier_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLObjectIdentifier_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_get_DocumentationReferences, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_get_Identifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_set_Identifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_get_IdentifierQualifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier_set_IdentifierQualifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLObjectIdentifier___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLObjectIdentifier_methods[] = {
	PHP_ME(TElXMLObjectIdentifier, Assign, arginfo_TElXMLObjectIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, Clear, arginfo_TElXMLObjectIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, IsEmpty, arginfo_TElXMLObjectIdentifier_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, LoadFromXML, arginfo_TElXMLObjectIdentifier_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, SaveToXML, arginfo_TElXMLObjectIdentifier_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, get_Description, arginfo_TElXMLObjectIdentifier_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, set_Description, arginfo_TElXMLObjectIdentifier_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, get_DocumentationReferences, arginfo_TElXMLObjectIdentifier_get_DocumentationReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, get_Identifier, arginfo_TElXMLObjectIdentifier_get_Identifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, set_Identifier, arginfo_TElXMLObjectIdentifier_set_Identifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, get_IdentifierQualifier, arginfo_TElXMLObjectIdentifier_get_IdentifierQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, set_IdentifierQualifier, arginfo_TElXMLObjectIdentifier_set_IdentifierQualifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLObjectIdentifier, __construct, arginfo_TElXMLObjectIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLObjectIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLObjectIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLObjectIdentifier", TElXMLObjectIdentifier_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLObjectIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncapsulatedPKIData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIData_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIData_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLEncapsulatedPKIData_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIData_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIData_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIData_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLEncapsulatedPKIData_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-659652681, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, set_Data)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLEncapsulatedPKIData_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLEncapsulatedPKIData_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(382146332, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIData_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, get_Encoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESEncodingMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLEncapsulatedPKIData_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, set_Encoding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIData_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESEncodingMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIData, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIData_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIData_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIData_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncapsulatedPKIData_methods[] = {
	PHP_ME(TElXMLEncapsulatedPKIData, Assign, arginfo_TElXMLEncapsulatedPKIData_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, Clear, arginfo_TElXMLEncapsulatedPKIData_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, IsEmpty, arginfo_TElXMLEncapsulatedPKIData_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, LoadFromXML, arginfo_TElXMLEncapsulatedPKIData_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, SaveToXML, arginfo_TElXMLEncapsulatedPKIData_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, get_Data, arginfo_TElXMLEncapsulatedPKIData_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, set_Data, arginfo_TElXMLEncapsulatedPKIData_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, get_ID, arginfo_TElXMLEncapsulatedPKIData_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, set_ID, arginfo_TElXMLEncapsulatedPKIData_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, get_Encoding, arginfo_TElXMLEncapsulatedPKIData_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, set_Encoding, arginfo_TElXMLEncapsulatedPKIData_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIData, __construct, arginfo_TElXMLEncapsulatedPKIData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncapsulatedPKIData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncapsulatedPKIData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncapsulatedPKIData", TElXMLEncapsulatedPKIData_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLEncapsulatedPKIData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncapsulatedPKIDataList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, Assign)
{
	long fAVersion;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oSource, TElXMLEncapsulatedPKIDataList_ce_ptr, &fAVersion) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIDataList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (TSBXAdESVersionRaw)fAVersion) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncapsulatedPKIDataList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, Add)
{
	zval *oAPKIData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPKIData, TElXMLEncapsulatedPKIData_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLEncapsulatedPKIDataList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAPKIData TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncapsulatedPKIData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, Insert)
{
	long l4Index;
	zval *oAPKIData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAPKIData, TElXMLEncapsulatedPKIData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIDataList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAPKIData TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLEncapsulatedPKIData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIDataList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedPKIDataList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLEncapsulatedPKIDataList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, get_PKIData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIDataList_get_PKIData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncapsulatedPKIData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedPKIDataList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedPKIDataList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_Assign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLEncapsulatedPKIDataList, 1)
	ZEND_ARG_INFO(0, AVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, APKIData, TElXMLEncapsulatedPKIData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, APKIData, TElXMLEncapsulatedPKIData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList_get_PKIData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedPKIDataList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncapsulatedPKIDataList_methods[] = {
	PHP_ME(TElXMLEncapsulatedPKIDataList, Assign, arginfo_TElXMLEncapsulatedPKIDataList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, Add, arginfo_TElXMLEncapsulatedPKIDataList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, Insert, arginfo_TElXMLEncapsulatedPKIDataList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, Delete, arginfo_TElXMLEncapsulatedPKIDataList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, Clear, arginfo_TElXMLEncapsulatedPKIDataList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, get_Count, arginfo_TElXMLEncapsulatedPKIDataList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, get_PKIData, arginfo_TElXMLEncapsulatedPKIDataList_get_PKIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedPKIDataList, __construct, arginfo_TElXMLEncapsulatedPKIDataList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncapsulatedPKIDataList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncapsulatedPKIDataList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncapsulatedPKIDataList", TElXMLEncapsulatedPKIDataList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLEncapsulatedPKIDataList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLHashDataInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLHashDataInfo, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfo_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLHashDataInfo_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfo_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, GetHashData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLHashDataInfo_GetHashData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-356156926, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, get_TransformChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_get_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTransformChain_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, set_TransformChain)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLTransformChain_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfo_set_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLTransformChain)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLHashDataInfo_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-699568962, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfo_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, get_URIData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLHashDataInfo_get_URIData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1165832699, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, set_URIData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLHashDataInfo_set_URIData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, get_URINode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_get_URINode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, set_URINode)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfo_set_URINode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfo, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfo_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_GetHashData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_get_TransformChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_set_TransformChain, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLTransformChain, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_get_URIData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_set_URIData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_get_URINode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo_set_URINode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfo___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLHashDataInfo_methods[] = {
	PHP_ME(TElXMLHashDataInfo, Clear, arginfo_TElXMLHashDataInfo_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, IsEmpty, arginfo_TElXMLHashDataInfo_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, LoadFromXML, arginfo_TElXMLHashDataInfo_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, SaveToXML, arginfo_TElXMLHashDataInfo_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, GetHashData, arginfo_TElXMLHashDataInfo_GetHashData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, get_TransformChain, arginfo_TElXMLHashDataInfo_get_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, set_TransformChain, arginfo_TElXMLHashDataInfo_set_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, get_URI, arginfo_TElXMLHashDataInfo_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, set_URI, arginfo_TElXMLHashDataInfo_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, get_URIData, arginfo_TElXMLHashDataInfo_get_URIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, set_URIData, arginfo_TElXMLHashDataInfo_set_URIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, get_URINode, arginfo_TElXMLHashDataInfo_get_URINode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, set_URINode, arginfo_TElXMLHashDataInfo_set_URINode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfo, __construct, arginfo_TElXMLHashDataInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLHashDataInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLHashDataInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLHashDataInfo", TElXMLHashDataInfo_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLHashDataInfo_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLHashDataInfoList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLHashDataInfoList, Add)
{
	zval *oAHashDataInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAHashDataInfo, TElXMLHashDataInfo_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLHashDataInfoList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAHashDataInfo TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLHashDataInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfoList, Insert)
{
	long l4Index;
	zval *oAHashDataInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAHashDataInfo, TElXMLHashDataInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfoList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAHashDataInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLHashDataInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfoList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfoList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfoList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLHashDataInfoList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfoList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLHashDataInfoList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfoList, get_HashDataInfo)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfoList_get_HashDataInfo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLHashDataInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLHashDataInfoList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLHashDataInfoList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AHashDataInfo, TElXMLHashDataInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AHashDataInfo, TElXMLHashDataInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList_get_HashDataInfo, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLHashDataInfoList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLHashDataInfoList_methods[] = {
	PHP_ME(TElXMLHashDataInfoList, Add, arginfo_TElXMLHashDataInfoList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfoList, Insert, arginfo_TElXMLHashDataInfoList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfoList, Delete, arginfo_TElXMLHashDataInfoList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfoList, Clear, arginfo_TElXMLHashDataInfoList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfoList, get_Count, arginfo_TElXMLHashDataInfoList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfoList, get_HashDataInfo, arginfo_TElXMLHashDataInfoList_get_HashDataInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLHashDataInfoList, __construct, arginfo_TElXMLHashDataInfoList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLHashDataInfoList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLHashDataInfoList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLHashDataInfoList", TElXMLHashDataInfoList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLHashDataInfoList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCustomTimestamp_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCustomTimestamp, GetTimestampInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomTimestamp_GetTimestampInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestamp, CheckTimestamp)
{
	zval *oInfo;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInfo, TElClientTSPInfo_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCustomTimestamp_CheckTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oInfo, TElClientTSPInfo_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCustomTimestamp_CheckTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientTSPInfo) or (TElClientTSPInfo, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestamp, Timestamp)
{
	zval *oManager;
	zval *oProv;
	zval *oTSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomTimestamp_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oTSPClient, TElCustomTSPClient_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomTimestamp_Timestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (TElCustomTSPClient, TElCustomCryptoProviderManager, TElCustomCryptoProvider)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestamp, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomTimestamp_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomTimestamp_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomTimestamp_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestamp_GetTimestampInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestamp_CheckTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Info, TElClientTSPInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestamp_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestamp___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCustomTimestamp_methods[] = {
	PHP_ME(TElXMLCustomTimestamp, GetTimestampInfo, arginfo_TElXMLCustomTimestamp_GetTimestampInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestamp, CheckTimestamp, arginfo_TElXMLCustomTimestamp_CheckTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestamp, Timestamp, arginfo_TElXMLCustomTimestamp_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestamp, __construct, arginfo_TElXMLCustomTimestamp___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCustomTimestamp(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCustomTimestamp_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCustomTimestamp", TElXMLCustomTimestamp_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCustomTimestamp_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCustomTimestampList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCustomTimestampList, Add)
{
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATimestamp, TElXMLCustomTimestamp_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomTimestampList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATimestamp TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCustomTimestamp)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestampList, Insert)
{
	long l4Index;
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oATimestamp, TElXMLCustomTimestamp_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomTimestampList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oATimestamp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLCustomTimestamp)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestampList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLCustomTimestampList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestampList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCustomTimestampList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestampList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCustomTimestampList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestampList, get_Timestamp)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomTimestampList_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestamp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomTimestampList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomTimestampList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList_get_Timestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomTimestampList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCustomTimestampList_methods[] = {
	PHP_ME(TElXMLCustomTimestampList, Add, arginfo_TElXMLCustomTimestampList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestampList, Insert, arginfo_TElXMLCustomTimestampList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestampList, Delete, arginfo_TElXMLCustomTimestampList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestampList, Clear, arginfo_TElXMLCustomTimestampList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestampList, get_Count, arginfo_TElXMLCustomTimestampList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestampList, get_Timestamp, arginfo_TElXMLCustomTimestampList_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomTimestampList, __construct, arginfo_TElXMLCustomTimestampList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCustomTimestampList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCustomTimestampList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCustomTimestampList", TElXMLCustomTimestampList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCustomTimestampList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLTimestamp_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLTimestamp, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, GetTimestampInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_GetTimestampInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, CheckTimestamp)
{
	zval *oInfo;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oInfo, TElClientTSPInfo_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_CheckTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInfo, TElClientTSPInfo_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_CheckTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientTSPInfo, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElClientTSPInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, Timestamp)
{
	zval *oManager;
	zval *oProv;
	zval *oTSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oTSPClient, TElCustomTSPClient_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_Timestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, get_HashDataInfos)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_get_HashDataInfos(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLHashDataInfoList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, get_EncapsulatedTimestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_get_EncapsulatedTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncapsulatedPKIData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, set_EncapsulatedTimestamp)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLEncapsulatedPKIData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_set_EncapsulatedTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncapsulatedPKIData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, get_XMLTimestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_get_XMLTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, set_XMLTimestamp)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLAnyType_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_set_XMLTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAnyType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_GetTimestampInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_CheckTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Info, TElClientTSPInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_get_HashDataInfos, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_get_EncapsulatedTimestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_set_EncapsulatedTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLEncapsulatedPKIData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_get_XMLTimestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_set_XMLTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLAnyType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLTimestamp_methods[] = {
	PHP_ME(TElXMLTimestamp, Clear, arginfo_TElXMLTimestamp_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, IsEmpty, arginfo_TElXMLTimestamp_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, LoadFromXML, arginfo_TElXMLTimestamp_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, SaveToXML, arginfo_TElXMLTimestamp_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, GetTimestampInfo, arginfo_TElXMLTimestamp_GetTimestampInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, CheckTimestamp, arginfo_TElXMLTimestamp_CheckTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, Timestamp, arginfo_TElXMLTimestamp_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, get_HashDataInfos, arginfo_TElXMLTimestamp_get_HashDataInfos, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, get_EncapsulatedTimestamp, arginfo_TElXMLTimestamp_get_EncapsulatedTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, set_EncapsulatedTimestamp, arginfo_TElXMLTimestamp_set_EncapsulatedTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, get_XMLTimestamp, arginfo_TElXMLTimestamp_get_XMLTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, set_XMLTimestamp, arginfo_TElXMLTimestamp_set_XMLTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp, __construct, arginfo_TElXMLTimestamp___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLTimestamp(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLTimestamp_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLTimestamp", TElXMLTimestamp_methods);
	if (NULL == TElXMLCustomTimestamp_ce_ptr)
		Register_TElXMLCustomTimestamp(TSRMLS_C);
	TElXMLTimestamp_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomTimestamp_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLTimestampList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLTimestampList, Add)
{
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATimestamp, TElXMLTimestamp_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimestampList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATimestamp TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLTimestamp)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestampList, Insert)
{
	long l4Index;
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oATimestamp, TElXMLTimestamp_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestampList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oATimestamp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLTimestamp)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestampList, get_Timestamp_TElXMLTimestamp)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestampList_get_Timestamp_TElXMLTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTimestamp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestampList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestampList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_get_Timestamp_TElXMLTimestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLTimestampList_methods[] = {
	PHP_ME(TElXMLTimestampList, Add, arginfo_TElXMLTimestampList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestampList, Insert, arginfo_TElXMLTimestampList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestampList, get_Timestamp_TElXMLTimestamp, arginfo_TElXMLTimestampList_get_Timestamp_TElXMLTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestampList, __construct, arginfo_TElXMLTimestampList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLTimestampList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLTimestampList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLTimestampList", TElXMLTimestampList_methods);
	if (NULL == TElXMLCustomTimestampList_ce_ptr)
		Register_TElXMLCustomTimestampList(TSRMLS_C);
	TElXMLTimestampList_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomTimestampList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLInclude_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLInclude, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLInclude_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLInclude_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLInclude_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, ProcessIncludeData)
{
	long fCanonicalizationMethod;
	zval *oHashFunc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fCanonicalizationMethod, &oHashFunc, TElHashFunction_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLInclude_ProcessIncludeData(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fCanonicalizationMethod, SBGetObjectHandle(oHashFunc TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElHashFunction)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, get_ReferencedData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLInclude_get_ReferencedData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, set_ReferencedData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLInclude_set_ReferencedData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLInclude_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1475280180, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLInclude_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, get_URIData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLInclude_get_URIData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-618523135, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, set_URIData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLInclude_set_URIData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, get_URINode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_get_URINode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, set_URINode)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLInclude_set_URINode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, get_URIReference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_get_URIReference(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, set_URIReference)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLReference_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLInclude_set_URIReference(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLInclude, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLInclude_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_ProcessIncludeData, 0, 0, 2)
	ZEND_ARG_INFO(0, CanonicalizationMethod)
	ZEND_ARG_OBJ_INFO(0, HashFunc, TElHashFunction, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_get_ReferencedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_set_ReferencedData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_get_URIData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_set_URIData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_get_URINode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_set_URINode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_get_URIReference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude_set_URIReference, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLInclude___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLInclude_methods[] = {
	PHP_ME(TElXMLInclude, Clear, arginfo_TElXMLInclude_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, IsEmpty, arginfo_TElXMLInclude_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, LoadFromXML, arginfo_TElXMLInclude_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, SaveToXML, arginfo_TElXMLInclude_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, ProcessIncludeData, arginfo_TElXMLInclude_ProcessIncludeData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, get_ReferencedData, arginfo_TElXMLInclude_get_ReferencedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, set_ReferencedData, arginfo_TElXMLInclude_set_ReferencedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, get_URI, arginfo_TElXMLInclude_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, set_URI, arginfo_TElXMLInclude_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, get_URIData, arginfo_TElXMLInclude_get_URIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, set_URIData, arginfo_TElXMLInclude_set_URIData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, get_URINode, arginfo_TElXMLInclude_get_URINode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, set_URINode, arginfo_TElXMLInclude_set_URINode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, get_URIReference, arginfo_TElXMLInclude_get_URIReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, set_URIReference, arginfo_TElXMLInclude_set_URIReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLInclude, __construct, arginfo_TElXMLInclude___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLInclude(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLInclude_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLInclude", TElXMLInclude_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLInclude_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLIncludeList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLIncludeList, Add)
{
	zval *oAInclude;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAInclude, TElXMLInclude_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLIncludeList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAInclude TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLInclude)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIncludeList, Insert)
{
	long l4Index;
	zval *oAInclude;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAInclude, TElXMLInclude_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLIncludeList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAInclude TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLInclude)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIncludeList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLIncludeList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIncludeList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLIncludeList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIncludeList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLIncludeList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIncludeList, get_Includes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIncludeList_get_Includes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLInclude_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLIncludeList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLIncludeList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AInclude, TElXMLInclude, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AInclude, TElXMLInclude, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList_get_Includes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLIncludeList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLIncludeList_methods[] = {
	PHP_ME(TElXMLIncludeList, Add, arginfo_TElXMLIncludeList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIncludeList, Insert, arginfo_TElXMLIncludeList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIncludeList, Delete, arginfo_TElXMLIncludeList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIncludeList, Clear, arginfo_TElXMLIncludeList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIncludeList, get_Count, arginfo_TElXMLIncludeList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIncludeList, get_Includes, arginfo_TElXMLIncludeList_get_Includes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLIncludeList, __construct, arginfo_TElXMLIncludeList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLIncludeList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLIncludeList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLIncludeList", TElXMLIncludeList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLIncludeList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLTimestamp_v1_2_2_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_v1_2_2_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_v1_2_2_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_v1_2_2_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, GetTimestampInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_GetTimestampInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, CheckTimestamp)
{
	zval *oInfo;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oInfo, TElClientTSPInfo_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_v1_2_2_CheckTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInfo, TElClientTSPInfo_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_v1_2_2_CheckTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientTSPInfo, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElClientTSPInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, Timestamp)
{
	zval *oManager;
	zval *oProv;
	zval *oTSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oTSPClient, TElCustomTSPClient_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_v1_2_2_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_v1_2_2_Timestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLTimestamp_v1_2_2_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1794272793, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_v1_2_2_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, get_CanonicalizationMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLCanonicalizationMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLTimestamp_v1_2_2_get_CanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, set_CanonicalizationMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_v1_2_2_set_CanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, get_EncapsulatedTimestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_get_EncapsulatedTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncapsulatedPKIData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, set_EncapsulatedTimestamp)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLEncapsulatedPKIData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_v1_2_2_set_EncapsulatedTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLEncapsulatedPKIData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, get_XMLTimestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_get_XMLTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, set_XMLTimestamp)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLAnyType_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestamp_v1_2_2_set_XMLTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAnyType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, get_Includes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_get_Includes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLIncludeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestamp_v1_2_2, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestamp_v1_2_2_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_GetTimestampInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_CheckTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Info, TElClientTSPInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_get_CanonicalizationMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_set_CanonicalizationMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_get_EncapsulatedTimestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_set_EncapsulatedTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLEncapsulatedPKIData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_get_XMLTimestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_set_XMLTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLAnyType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2_get_Includes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestamp_v1_2_2___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLTimestamp_v1_2_2_methods[] = {
	PHP_ME(TElXMLTimestamp_v1_2_2, Clear, arginfo_TElXMLTimestamp_v1_2_2_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, IsEmpty, arginfo_TElXMLTimestamp_v1_2_2_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, LoadFromXML, arginfo_TElXMLTimestamp_v1_2_2_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, SaveToXML, arginfo_TElXMLTimestamp_v1_2_2_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, GetTimestampInfo, arginfo_TElXMLTimestamp_v1_2_2_GetTimestampInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, CheckTimestamp, arginfo_TElXMLTimestamp_v1_2_2_CheckTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, Timestamp, arginfo_TElXMLTimestamp_v1_2_2_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, get_ID, arginfo_TElXMLTimestamp_v1_2_2_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, set_ID, arginfo_TElXMLTimestamp_v1_2_2_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, get_CanonicalizationMethod, arginfo_TElXMLTimestamp_v1_2_2_get_CanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, set_CanonicalizationMethod, arginfo_TElXMLTimestamp_v1_2_2_set_CanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, get_EncapsulatedTimestamp, arginfo_TElXMLTimestamp_v1_2_2_get_EncapsulatedTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, set_EncapsulatedTimestamp, arginfo_TElXMLTimestamp_v1_2_2_set_EncapsulatedTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, get_XMLTimestamp, arginfo_TElXMLTimestamp_v1_2_2_get_XMLTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, set_XMLTimestamp, arginfo_TElXMLTimestamp_v1_2_2_set_XMLTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, get_Includes, arginfo_TElXMLTimestamp_v1_2_2_get_Includes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestamp_v1_2_2, __construct, arginfo_TElXMLTimestamp_v1_2_2___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLTimestamp_v1_2_2(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLTimestamp_v1_2_2_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLTimestamp_v1_2_2", TElXMLTimestamp_v1_2_2_methods);
	if (NULL == TElXMLCustomTimestamp_ce_ptr)
		Register_TElXMLCustomTimestamp(TSRMLS_C);
	TElXMLTimestamp_v1_2_2_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomTimestamp_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLTimestampList_v1_2_2_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLTimestampList_v1_2_2, Add)
{
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATimestamp, TElXMLTimestamp_v1_2_2_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimestampList_v1_2_2_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATimestamp TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLTimestamp_v1_2_2)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestampList_v1_2_2, Insert)
{
	long l4Index;
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oATimestamp, TElXMLTimestamp_v1_2_2_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimestampList_v1_2_2_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oATimestamp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLTimestamp_v1_2_2)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestampList_v1_2_2, get_Timestamp_TElXMLTimestamp_v1_2_2)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestampList_v1_2_2_get_Timestamp_TElXMLTimestamp_v1_2_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTimestamp_v1_2_2_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimestampList_v1_2_2, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimestampList_v1_2_2_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_v1_2_2_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_v1_2_2_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_v1_2_2_get_Timestamp_TElXMLTimestamp_v1_2_2, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimestampList_v1_2_2___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLTimestampList_v1_2_2_methods[] = {
	PHP_ME(TElXMLTimestampList_v1_2_2, Add, arginfo_TElXMLTimestampList_v1_2_2_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestampList_v1_2_2, Insert, arginfo_TElXMLTimestampList_v1_2_2_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestampList_v1_2_2, get_Timestamp_TElXMLTimestamp_v1_2_2, arginfo_TElXMLTimestampList_v1_2_2_get_Timestamp_TElXMLTimestamp_v1_2_2, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimestampList_v1_2_2, __construct, arginfo_TElXMLTimestampList_v1_2_2___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLTimestampList_v1_2_2(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLTimestampList_v1_2_2_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLTimestampList_v1_2_2", TElXMLTimestampList_v1_2_2_methods);
	if (NULL == TElXMLCustomTimestampList_ce_ptr)
		Register_TElXMLCustomTimestampList(TSRMLS_C);
	TElXMLTimestampList_v1_2_2_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomTimestampList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomTSPClientList_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomTSPClientList, Add)
{
	zval *oATSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomTSPClientList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, Insert)
{
	long l4Index;
	zval *oATSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClientList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oATSPClient TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElCustomTSPClientList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomTSPClientList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomTSPClientList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, get_OwnItems)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomTSPClientList_get_OwnItems(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, get_TSPClients)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPClientList_get_TSPClients(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomTSPClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomTSPClientList, __construct)
{
	zend_bool bAOwnItems;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnItems) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomTSPClientList_Create((int8_t)bAOwnItems, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_get_OwnItems, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList_get_TSPClients, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomTSPClientList___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AOwnItems)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomTSPClientList_methods[] = {
	PHP_ME(TElCustomTSPClientList, Add, arginfo_TElCustomTSPClientList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, Insert, arginfo_TElCustomTSPClientList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, Delete, arginfo_TElCustomTSPClientList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, Clear, arginfo_TElCustomTSPClientList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, get_Count, arginfo_TElCustomTSPClientList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, get_OwnItems, arginfo_TElCustomTSPClientList_get_OwnItems, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, get_TSPClients, arginfo_TElCustomTSPClientList_get_TSPClients, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomTSPClientList, __construct, arginfo_TElCustomTSPClientList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomTSPClientList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomTSPClientList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomTSPClientList", TElCustomTSPClientList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomTSPClientList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLGenericTimestamp_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLGenericTimestamp, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, GetTimestampInfo)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_GetTimestampInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_GetTimestampInfo_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, AddTimestampData)
{
	SBArrayZValInfo aiData;
	zval *oNode;
	zval *oRef;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLGenericTimestamp_AddTimestampData(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_AddTimestampData_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRef, TElXMLReference_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_AddTimestampData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRef TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TElXMLDOMNode) or (TElXMLReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, StartTimestampCheck)
{
	zval *oInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInfo, TElClientTSPInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_StartTimestampCheck(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientTSPInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, FinishTimestampCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_FinishTimestampCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, CheckTimestamp)
{
	zval *oInfo;
	zval *oManager;
	zval *oProv;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oInfo, TElClientTSPInfo_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_CheckTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInfo, TElClientTSPInfo_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_CheckTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientTSPInfo, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElClientTSPInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, Timestamp)
{
	zval *oManager;
	zval *oProv;
	zval *oTSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oTSPClient, TElCustomTSPClient_ce_ptr, &oManager, TElCustomCryptoProviderManager_ce_ptr, &oProv, TElCustomCryptoProvider_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_Timestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), SBGetObjectHandle(oManager TSRMLS_CC), SBGetObjectHandle(oProv TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_Timestamp_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElCustomTSPClient, TElCustomCryptoProviderManager, TElCustomCryptoProvider) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_TimestampInfoCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_get_TimestampInfoCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_TSPClients)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_get_TSPClients(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomTSPClientList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLGenericTimestamp_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1089527174, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_CanonicalizationMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLCanonicalizationMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestamp_get_CanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, set_CanonicalizationMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestamp_set_CanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_EncapsulatedTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_get_EncapsulatedTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncapsulatedPKIDataList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_XMLTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_get_XMLTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, get_Includes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_get_Includes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLIncludeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestamp, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestamp_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_GetTimestampInfo, 0, 0, 0)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_AddTimestampData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_Node_or_Ref, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_StartTimestampCheck, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Info, TElClientTSPInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_FinishTimestampCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_CheckTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Info, TElClientTSPInfo, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_Timestamp, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, TSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Manager, TElCustomCryptoProviderManager, 1)
	ZEND_ARG_OBJ_INFO(0, Prov, TElCustomCryptoProvider, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_TimestampInfoCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_TSPClients, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_CanonicalizationMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_set_CanonicalizationMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_EncapsulatedTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_XMLTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp_get_Includes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestamp___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLGenericTimestamp_methods[] = {
	PHP_ME(TElXMLGenericTimestamp, Clear, arginfo_TElXMLGenericTimestamp_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, IsEmpty, arginfo_TElXMLGenericTimestamp_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, LoadFromXML, arginfo_TElXMLGenericTimestamp_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, SaveToXML, arginfo_TElXMLGenericTimestamp_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, GetTimestampInfo, arginfo_TElXMLGenericTimestamp_GetTimestampInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, AddTimestampData, arginfo_TElXMLGenericTimestamp_AddTimestampData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, StartTimestampCheck, arginfo_TElXMLGenericTimestamp_StartTimestampCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, FinishTimestampCheck, arginfo_TElXMLGenericTimestamp_FinishTimestampCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, CheckTimestamp, arginfo_TElXMLGenericTimestamp_CheckTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, Timestamp, arginfo_TElXMLGenericTimestamp_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_TimestampInfoCount, arginfo_TElXMLGenericTimestamp_get_TimestampInfoCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_TSPClients, arginfo_TElXMLGenericTimestamp_get_TSPClients, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_CryptoProviderManager, arginfo_TElXMLGenericTimestamp_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, set_CryptoProviderManager, arginfo_TElXMLGenericTimestamp_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_ID, arginfo_TElXMLGenericTimestamp_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, set_ID, arginfo_TElXMLGenericTimestamp_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_CanonicalizationMethod, arginfo_TElXMLGenericTimestamp_get_CanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, set_CanonicalizationMethod, arginfo_TElXMLGenericTimestamp_set_CanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_EncapsulatedTimestamps, arginfo_TElXMLGenericTimestamp_get_EncapsulatedTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_XMLTimestamps, arginfo_TElXMLGenericTimestamp_get_XMLTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, get_Includes, arginfo_TElXMLGenericTimestamp_get_Includes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestamp, __construct, arginfo_TElXMLGenericTimestamp___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLGenericTimestamp(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLGenericTimestamp_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLGenericTimestamp", TElXMLGenericTimestamp_methods);
	if (NULL == TElXMLCustomTimestamp_ce_ptr)
		Register_TElXMLCustomTimestamp(TSRMLS_C);
	TElXMLGenericTimestamp_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomTimestamp_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLGenericTimestampList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLGenericTimestampList, Add)
{
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATimestamp, TElXMLGenericTimestamp_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLGenericTimestampList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATimestamp TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLGenericTimestamp)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestampList, Insert)
{
	long l4Index;
	zval *oATimestamp;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oATimestamp, TElXMLGenericTimestamp_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLGenericTimestampList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oATimestamp TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLGenericTimestamp)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestampList, get_Timestamp_TElXMLGenericTimestamp)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestampList_get_Timestamp_TElXMLGenericTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLGenericTimestamp_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLGenericTimestampList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLGenericTimestampList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestampList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestampList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, ATimestamp, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestampList_get_Timestamp_TElXMLGenericTimestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLGenericTimestampList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLGenericTimestampList_methods[] = {
	PHP_ME(TElXMLGenericTimestampList, Add, arginfo_TElXMLGenericTimestampList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestampList, Insert, arginfo_TElXMLGenericTimestampList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestampList, get_Timestamp_TElXMLGenericTimestamp, arginfo_TElXMLGenericTimestampList_get_Timestamp_TElXMLGenericTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLGenericTimestampList, __construct, arginfo_TElXMLGenericTimestampList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLGenericTimestampList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLGenericTimestampList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLGenericTimestampList", TElXMLGenericTimestampList_methods);
	if (NULL == TElXMLCustomTimestampList_ce_ptr)
		Register_TElXMLCustomTimestampList(TSRMLS_C);
	TElXMLGenericTimestampList_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomTimestampList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDigestAlgAndValue_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDigestAlgAndValue, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDigestAlgAndValue_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDigestAlgAndValue_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDigestAlgAndValue_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDigestAlgAndValue_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDigestAlgAndValue_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDigestAlgAndValue_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, get_DigestMethod)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDigestAlgAndValue_get_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1020954402, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, set_DigestMethod)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDigestAlgAndValue_set_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, get_DigestValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLDigestAlgAndValue_get_DigestValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1287501134, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, set_DigestValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLDigestAlgAndValue_set_DigestValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDigestAlgAndValue, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDigestAlgAndValue_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDigestAlgAndValue_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDigestAlgAndValue_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_get_DigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_set_DigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_get_DigestValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue_set_DigestValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDigestAlgAndValue___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDigestAlgAndValue_methods[] = {
	PHP_ME(TElXMLDigestAlgAndValue, Assign, arginfo_TElXMLDigestAlgAndValue_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, Clear, arginfo_TElXMLDigestAlgAndValue_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, IsEmpty, arginfo_TElXMLDigestAlgAndValue_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, LoadFromXML, arginfo_TElXMLDigestAlgAndValue_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, SaveToXML, arginfo_TElXMLDigestAlgAndValue_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, get_DigestMethod, arginfo_TElXMLDigestAlgAndValue_get_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, set_DigestMethod, arginfo_TElXMLDigestAlgAndValue_set_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, get_DigestValue, arginfo_TElXMLDigestAlgAndValue_get_DigestValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, set_DigestValue, arginfo_TElXMLDigestAlgAndValue_set_DigestValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDigestAlgAndValue, __construct, arginfo_TElXMLDigestAlgAndValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDigestAlgAndValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDigestAlgAndValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDigestAlgAndValue", TElXMLDigestAlgAndValue_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLDigestAlgAndValue_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCertID_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCertID, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCertID_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCertID_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCertID_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, IsMatch)
{
	zend_bool bLiberalMode;
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCertID_IsMatch(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oCert, TElX509Certificate_ce_ptr, &bLiberalMode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCertID_IsMatch_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC), (int8_t)bLiberalMode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate) or (TElX509Certificate, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, get_CertDigest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_get_CertDigest(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDigestAlgAndValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, set_CertDigest)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDigestAlgAndValue_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCertID_set_CertDigest(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDigestAlgAndValue)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, get_IssuerSerial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_get_IssuerSerial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLIssuerSerial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, set_IssuerSerial)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLIssuerSerial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCertID_set_IssuerSerial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLIssuerSerial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCertID_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-894692377, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCertID_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertID, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertID_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_IsMatch, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, LiberalMode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_get_CertDigest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_set_CertDigest, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDigestAlgAndValue, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_get_IssuerSerial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_set_IssuerSerial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLIssuerSerial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertID___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCertID_methods[] = {
	PHP_ME(TElXMLCertID, Clear, arginfo_TElXMLCertID_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, IsEmpty, arginfo_TElXMLCertID_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, LoadFromXML, arginfo_TElXMLCertID_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, SaveToXML, arginfo_TElXMLCertID_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, IsMatch, arginfo_TElXMLCertID_IsMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, get_CertDigest, arginfo_TElXMLCertID_get_CertDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, set_CertDigest, arginfo_TElXMLCertID_set_CertDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, get_IssuerSerial, arginfo_TElXMLCertID_get_IssuerSerial, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, set_IssuerSerial, arginfo_TElXMLCertID_set_IssuerSerial, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, get_URI, arginfo_TElXMLCertID_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, set_URI, arginfo_TElXMLCertID_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertID, __construct, arginfo_TElXMLCertID___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCertID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCertID_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCertID", TElXMLCertID_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCertID_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCertIDList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCertIDList, HasCertificate)
{
	zval *oACertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCertIDList_HasCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACertificate TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, AddCertificate)
{
	long fAXAdESVersion;
	long fDigestMethod;
	zend_bool bHexSerialNumber;
	zval *oACertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oACertificate, TElX509Certificate_ce_ptr, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCertIDList_AddCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACertificate TSRMLS_CC), (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oACertificate, TElX509Certificate_ce_ptr, &fDigestMethod, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCertIDList_AddCertificate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACertificate TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbl", &oACertificate, TElX509Certificate_ce_ptr, &fDigestMethod, &bHexSerialNumber, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCertIDList_AddCertificate_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACertificate TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, (int8_t)bHexSerialNumber, (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer) or (TElX509Certificate, integer, integer) or (TElX509Certificate, integer, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, Add)
{
	zval *oACertID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACertID, TElXMLCertID_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCertIDList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACertID TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCertID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, Insert)
{
	long l4Index;
	zval *oACertID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oACertID, TElXMLCertID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCertIDList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oACertID TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLCertID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLCertIDList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCertIDList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCertIDList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, get_CertIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertIDList_get_CertIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertIDList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertIDList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_HasCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACertificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_AddCertificate, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ACertificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, AXAdESVersion_or_DigestMethod)
	ZEND_ARG_INFO(0, AXAdESVersion_or_HexSerialNumber)
	ZEND_ARG_INFO(0, AXAdESVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACertID, TElXMLCertID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ACertID, TElXMLCertID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList_get_CertIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertIDList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCertIDList_methods[] = {
	PHP_ME(TElXMLCertIDList, HasCertificate, arginfo_TElXMLCertIDList_HasCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, AddCertificate, arginfo_TElXMLCertIDList_AddCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, Add, arginfo_TElXMLCertIDList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, Insert, arginfo_TElXMLCertIDList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, Delete, arginfo_TElXMLCertIDList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, Clear, arginfo_TElXMLCertIDList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, get_Count, arginfo_TElXMLCertIDList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, get_CertIDs, arginfo_TElXMLCertIDList_get_CertIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertIDList, __construct, arginfo_TElXMLCertIDList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCertIDList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCertIDList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCertIDList", TElXMLCertIDList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCertIDList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLNoticeReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLNoticeReference, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLNoticeReference_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLNoticeReference_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLNoticeReference_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNoticeReference_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNoticeReference_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, get_Organization)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLNoticeReference_get_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(733670047, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, set_Organization)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLNoticeReference_set_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, get_NoticeNumbers)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBArrayZValInfo aiOutResult;
		SBInitArrayZValInfo(&aiOutResult);
		_err = TElXMLNoticeReference_get_NoticeNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), aiOutResult.data, &aiOutResult.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			aiOutResult.data = emalloc(aiOutResult.len);
			SBCheckError(SBGetLastReturnBuffer(-235971907, 1, aiOutResult.data, &aiOutResult.len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutResult);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetInt32ArrayToZVal(&aiOutResult, return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, set_NoticeNumbers)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetInt32ArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLNoticeReference_set_NoticeNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of int32|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNoticeReference, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNoticeReference_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNoticeReference_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNoticeReference_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_get_Organization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_set_Organization, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_get_NoticeNumbers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference_set_NoticeNumbers, 0, 0, 1)
	ZEND_ARG_ARRAY_INFO(0, Value, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNoticeReference___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLNoticeReference_methods[] = {
	PHP_ME(TElXMLNoticeReference, Clear, arginfo_TElXMLNoticeReference_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, IsEmpty, arginfo_TElXMLNoticeReference_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, LoadFromXML, arginfo_TElXMLNoticeReference_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, SaveToXML, arginfo_TElXMLNoticeReference_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, get_Organization, arginfo_TElXMLNoticeReference_get_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, set_Organization, arginfo_TElXMLNoticeReference_set_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, get_NoticeNumbers, arginfo_TElXMLNoticeReference_get_NoticeNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, set_NoticeNumbers, arginfo_TElXMLNoticeReference_set_NoticeNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNoticeReference, __construct, arginfo_TElXMLNoticeReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLNoticeReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLNoticeReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLNoticeReference", TElXMLNoticeReference_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLNoticeReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSPUserNotice_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSPUserNotice, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSPUserNotice_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSPUserNotice_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSPUserNotice_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPUserNotice_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPUserNotice_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, get_NoticeRef)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPUserNotice_get_NoticeRef(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLNoticeReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, set_NoticeRef)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLNoticeReference_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSPUserNotice_set_NoticeRef(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLNoticeReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, get_ExplicitTex)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSPUserNotice_get_ExplicitTex(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-805293162, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, set_ExplicitTex)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSPUserNotice_set_ExplicitTex(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPUserNotice, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPUserNotice_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPUserNotice_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPUserNotice_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_get_NoticeRef, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_set_NoticeRef, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLNoticeReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_get_ExplicitTex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice_set_ExplicitTex, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPUserNotice___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSPUserNotice_methods[] = {
	PHP_ME(TElXMLSPUserNotice, Clear, arginfo_TElXMLSPUserNotice_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, IsEmpty, arginfo_TElXMLSPUserNotice_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, LoadFromXML, arginfo_TElXMLSPUserNotice_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, SaveToXML, arginfo_TElXMLSPUserNotice_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, get_NoticeRef, arginfo_TElXMLSPUserNotice_get_NoticeRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, set_NoticeRef, arginfo_TElXMLSPUserNotice_set_NoticeRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, get_ExplicitTex, arginfo_TElXMLSPUserNotice_get_ExplicitTex, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, set_ExplicitTex, arginfo_TElXMLSPUserNotice_set_ExplicitTex, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPUserNotice, __construct, arginfo_TElXMLSPUserNotice___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSPUserNotice(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSPUserNotice_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSPUserNotice", TElXMLSPUserNotice_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSPUserNotice_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSPURI_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSPURI, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSPURI_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPURI, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSPURI_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPURI, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSPURI_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPURI, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPURI_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPURI_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPURI, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSPURI_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-54001001, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPURI, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSPURI_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSPURI, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPURI_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPURI_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSPURI_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSPURI___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSPURI_methods[] = {
	PHP_ME(TElXMLSPURI, Clear, arginfo_TElXMLSPURI_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPURI, IsEmpty, arginfo_TElXMLSPURI_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPURI, LoadFromXML, arginfo_TElXMLSPURI_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPURI, SaveToXML, arginfo_TElXMLSPURI_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPURI, get_URI, arginfo_TElXMLSPURI_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPURI, set_URI, arginfo_TElXMLSPURI_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSPURI, __construct, arginfo_TElXMLSPURI___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSPURI(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSPURI_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSPURI", TElXMLSPURI_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSPURI_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSigPolicyQualifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSigPolicyQualifier, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSigPolicyQualifier_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSigPolicyQualifier_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSigPolicyQualifier_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSigPolicyQualifier___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSigPolicyQualifier_methods[] = {
	PHP_ME(TElXMLSigPolicyQualifier, __construct, arginfo_TElXMLSigPolicyQualifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSigPolicyQualifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSigPolicyQualifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSigPolicyQualifier", TElXMLSigPolicyQualifier_methods);
	if (NULL == TElXMLAnyType_ce_ptr)
		Register_TElXMLAnyType(TSRMLS_C);
	TElXMLSigPolicyQualifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAnyType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignaturePolicyId_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignaturePolicyId, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyId_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyId_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignaturePolicyId_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyId_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, get_SigPolicyId)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_get_SigPolicyId(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLObjectIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, get_SigPolicyHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_get_SigPolicyHash(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDigestAlgAndValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, get_SigPolicyQualifiers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_get_SigPolicyQualifiers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, get_TransformChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_get_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTransformChain_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyId, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyId_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_get_SigPolicyId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_get_SigPolicyHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_get_SigPolicyQualifiers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId_get_TransformChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyId___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignaturePolicyId_methods[] = {
	PHP_ME(TElXMLSignaturePolicyId, Assign, arginfo_TElXMLSignaturePolicyId_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, Clear, arginfo_TElXMLSignaturePolicyId_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, IsEmpty, arginfo_TElXMLSignaturePolicyId_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, LoadFromXML, arginfo_TElXMLSignaturePolicyId_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, SaveToXML, arginfo_TElXMLSignaturePolicyId_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, get_SigPolicyId, arginfo_TElXMLSignaturePolicyId_get_SigPolicyId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, get_SigPolicyHash, arginfo_TElXMLSignaturePolicyId_get_SigPolicyHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, get_SigPolicyQualifiers, arginfo_TElXMLSignaturePolicyId_get_SigPolicyQualifiers, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, get_TransformChain, arginfo_TElXMLSignaturePolicyId_get_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyId, __construct, arginfo_TElXMLSignaturePolicyId___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignaturePolicyId(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignaturePolicyId_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignaturePolicyId", TElXMLSignaturePolicyId_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignaturePolicyId_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignaturePolicyIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyIdentifier_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignaturePolicyIdentifier_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyIdentifier_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyIdentifier_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyIdentifier_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, get_SignaturePolicyId)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyIdentifier_get_SignaturePolicyId(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignaturePolicyId_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, set_SignaturePolicyId)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignaturePolicyId_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyIdentifier_set_SignaturePolicyId(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignaturePolicyId)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, get_SignaturePolicyImplied)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignaturePolicyIdentifier_get_SignaturePolicyImplied(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, set_SignaturePolicyImplied)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLSignaturePolicyIdentifier_set_SignaturePolicyImplied(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignaturePolicyIdentifier, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyIdentifier_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyIdentifier_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignaturePolicyIdentifier_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_get_SignaturePolicyId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_set_SignaturePolicyId, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignaturePolicyId, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_get_SignaturePolicyImplied, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier_set_SignaturePolicyImplied, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignaturePolicyIdentifier___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignaturePolicyIdentifier_methods[] = {
	PHP_ME(TElXMLSignaturePolicyIdentifier, Assign, arginfo_TElXMLSignaturePolicyIdentifier_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, Clear, arginfo_TElXMLSignaturePolicyIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, IsEmpty, arginfo_TElXMLSignaturePolicyIdentifier_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, LoadFromXML, arginfo_TElXMLSignaturePolicyIdentifier_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, SaveToXML, arginfo_TElXMLSignaturePolicyIdentifier_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, get_SignaturePolicyId, arginfo_TElXMLSignaturePolicyIdentifier_get_SignaturePolicyId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, set_SignaturePolicyId, arginfo_TElXMLSignaturePolicyIdentifier_set_SignaturePolicyId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, get_SignaturePolicyImplied, arginfo_TElXMLSignaturePolicyIdentifier_get_SignaturePolicyImplied, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, set_SignaturePolicyImplied, arginfo_TElXMLSignaturePolicyIdentifier_set_SignaturePolicyImplied, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignaturePolicyIdentifier, __construct, arginfo_TElXMLSignaturePolicyIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignaturePolicyIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignaturePolicyIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignaturePolicyIdentifier", TElXMLSignaturePolicyIdentifier_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignaturePolicyIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCounterSignature_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCounterSignature, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCounterSignature_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignature, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCounterSignature_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignature, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCounterSignature_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignature, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignature_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignature_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignature, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignature_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignature, set_Signature)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCounterSignature_set_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignature, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignature_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignature_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignature_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature_set_Signature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignature___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCounterSignature_methods[] = {
	PHP_ME(TElXMLCounterSignature, Clear, arginfo_TElXMLCounterSignature_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignature, IsEmpty, arginfo_TElXMLCounterSignature_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignature, LoadFromXML, arginfo_TElXMLCounterSignature_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignature, SaveToXML, arginfo_TElXMLCounterSignature_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignature, get_Signature, arginfo_TElXMLCounterSignature_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignature, set_Signature, arginfo_TElXMLCounterSignature_set_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignature, __construct, arginfo_TElXMLCounterSignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCounterSignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCounterSignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCounterSignature", TElXMLCounterSignature_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCounterSignature_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCounterSignatureList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCounterSignatureList, Add)
{
	zval *oACounterSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACounterSignature, TElXMLCounterSignature_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCounterSignatureList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACounterSignature TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCounterSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignatureList, Insert)
{
	long l4Index;
	zval *oACounterSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oACounterSignature, TElXMLCounterSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCounterSignatureList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oACounterSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLCounterSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignatureList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLCounterSignatureList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignatureList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCounterSignatureList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignatureList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCounterSignatureList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignatureList, get_CounterSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignatureList_get_CounterSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCounterSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCounterSignatureList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCounterSignatureList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACounterSignature, TElXMLCounterSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ACounterSignature, TElXMLCounterSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList_get_CounterSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCounterSignatureList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCounterSignatureList_methods[] = {
	PHP_ME(TElXMLCounterSignatureList, Add, arginfo_TElXMLCounterSignatureList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignatureList, Insert, arginfo_TElXMLCounterSignatureList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignatureList, Delete, arginfo_TElXMLCounterSignatureList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignatureList, Clear, arginfo_TElXMLCounterSignatureList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignatureList, get_Count, arginfo_TElXMLCounterSignatureList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignatureList, get_CounterSignature, arginfo_TElXMLCounterSignatureList_get_CounterSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCounterSignatureList, __construct, arginfo_TElXMLCounterSignatureList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCounterSignatureList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCounterSignatureList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCounterSignatureList", TElXMLCounterSignatureList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCounterSignatureList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDataObjectFormat_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDataObjectFormat, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDataObjectFormat_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormat_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormat_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDataObjectFormat_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(305403976, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, get_ObjectIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormat_get_ObjectIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLObjectIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, set_ObjectIdentifier)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLObjectIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_set_ObjectIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLObjectIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, get_MimeType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDataObjectFormat_get_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(39474603, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, set_MimeType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_set_MimeType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, get_Encoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDataObjectFormat_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1293939613, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, set_Encoding)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, get_ObjectReference)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDataObjectFormat_get_ObjectReference(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(232057390, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, set_ObjectReference)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormat_set_ObjectReference(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormat, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormat_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormat_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormat_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_get_ObjectIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_set_ObjectIdentifier, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLObjectIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_get_MimeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_set_MimeType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_get_ObjectReference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat_set_ObjectReference, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormat___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDataObjectFormat_methods[] = {
	PHP_ME(TElXMLDataObjectFormat, Clear, arginfo_TElXMLDataObjectFormat_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, IsEmpty, arginfo_TElXMLDataObjectFormat_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, LoadFromXML, arginfo_TElXMLDataObjectFormat_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, SaveToXML, arginfo_TElXMLDataObjectFormat_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, get_Description, arginfo_TElXMLDataObjectFormat_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, set_Description, arginfo_TElXMLDataObjectFormat_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, get_ObjectIdentifier, arginfo_TElXMLDataObjectFormat_get_ObjectIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, set_ObjectIdentifier, arginfo_TElXMLDataObjectFormat_set_ObjectIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, get_MimeType, arginfo_TElXMLDataObjectFormat_get_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, set_MimeType, arginfo_TElXMLDataObjectFormat_set_MimeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, get_Encoding, arginfo_TElXMLDataObjectFormat_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, set_Encoding, arginfo_TElXMLDataObjectFormat_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, get_ObjectReference, arginfo_TElXMLDataObjectFormat_get_ObjectReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, set_ObjectReference, arginfo_TElXMLDataObjectFormat_set_ObjectReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormat, __construct, arginfo_TElXMLDataObjectFormat___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDataObjectFormat(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDataObjectFormat_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDataObjectFormat", TElXMLDataObjectFormat_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLDataObjectFormat_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDataObjectFormatList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDataObjectFormatList, Add)
{
	zval *oADataObjectFormat;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oADataObjectFormat, TElXMLDataObjectFormat_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDataObjectFormatList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oADataObjectFormat TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDataObjectFormat)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormatList, Insert)
{
	long l4Index;
	zval *oADataObjectFormat;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oADataObjectFormat, TElXMLDataObjectFormat_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormatList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oADataObjectFormat TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLDataObjectFormat)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormatList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormatList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormatList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDataObjectFormatList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormatList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDataObjectFormatList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormatList, get_DataObjectFormat)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormatList_get_DataObjectFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDataObjectFormat_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDataObjectFormatList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDataObjectFormatList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ADataObjectFormat, TElXMLDataObjectFormat, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ADataObjectFormat, TElXMLDataObjectFormat, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList_get_DataObjectFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDataObjectFormatList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDataObjectFormatList_methods[] = {
	PHP_ME(TElXMLDataObjectFormatList, Add, arginfo_TElXMLDataObjectFormatList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormatList, Insert, arginfo_TElXMLDataObjectFormatList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormatList, Delete, arginfo_TElXMLDataObjectFormatList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormatList, Clear, arginfo_TElXMLDataObjectFormatList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormatList, get_Count, arginfo_TElXMLDataObjectFormatList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormatList, get_DataObjectFormat, arginfo_TElXMLDataObjectFormatList_get_DataObjectFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDataObjectFormatList, __construct, arginfo_TElXMLDataObjectFormatList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDataObjectFormatList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDataObjectFormatList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDataObjectFormatList", TElXMLDataObjectFormatList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLDataObjectFormatList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCommitmentTypeQualifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCommitmentTypeQualifier, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeQualifier_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeQualifier_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeQualifier_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeQualifier___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCommitmentTypeQualifier_methods[] = {
	PHP_ME(TElXMLCommitmentTypeQualifier, __construct, arginfo_TElXMLCommitmentTypeQualifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCommitmentTypeQualifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCommitmentTypeQualifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCommitmentTypeQualifier", TElXMLCommitmentTypeQualifier_methods);
	if (NULL == TElXMLAnyType_ce_ptr)
		Register_TElXMLAnyType(TSRMLS_C);
	TElXMLCommitmentTypeQualifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAnyType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCommitmentTypeIndication_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCommitmentTypeIndication_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCommitmentTypeIndication_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCommitmentTypeIndication_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, get_AllSignedDataObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCommitmentTypeIndication_get_AllSignedDataObjects(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, set_AllSignedDataObjects)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLCommitmentTypeIndication_set_AllSignedDataObjects(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, get_CommitmentTypeId)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_get_CommitmentTypeId(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLObjectIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, get_CommitmentTypeQualifiers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_get_CommitmentTypeQualifiers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, get_ObjectReference)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_get_ObjectReference(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndication, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndication_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_get_AllSignedDataObjects, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_set_AllSignedDataObjects, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_get_CommitmentTypeId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_get_CommitmentTypeQualifiers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication_get_ObjectReference, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndication___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCommitmentTypeIndication_methods[] = {
	PHP_ME(TElXMLCommitmentTypeIndication, Clear, arginfo_TElXMLCommitmentTypeIndication_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, IsEmpty, arginfo_TElXMLCommitmentTypeIndication_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, LoadFromXML, arginfo_TElXMLCommitmentTypeIndication_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, SaveToXML, arginfo_TElXMLCommitmentTypeIndication_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, get_AllSignedDataObjects, arginfo_TElXMLCommitmentTypeIndication_get_AllSignedDataObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, set_AllSignedDataObjects, arginfo_TElXMLCommitmentTypeIndication_set_AllSignedDataObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, get_CommitmentTypeId, arginfo_TElXMLCommitmentTypeIndication_get_CommitmentTypeId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, get_CommitmentTypeQualifiers, arginfo_TElXMLCommitmentTypeIndication_get_CommitmentTypeQualifiers, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, get_ObjectReference, arginfo_TElXMLCommitmentTypeIndication_get_ObjectReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndication, __construct, arginfo_TElXMLCommitmentTypeIndication___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCommitmentTypeIndication(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCommitmentTypeIndication_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCommitmentTypeIndication", TElXMLCommitmentTypeIndication_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCommitmentTypeIndication_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCommitmentTypeIndicationList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, Add)
{
	zval *oACommitmentTypeIndication;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACommitmentTypeIndication, TElXMLCommitmentTypeIndication_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCommitmentTypeIndicationList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACommitmentTypeIndication TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCommitmentTypeIndication)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, Insert)
{
	long l4Index;
	zval *oACommitmentTypeIndication;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oACommitmentTypeIndication, TElXMLCommitmentTypeIndication_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCommitmentTypeIndicationList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oACommitmentTypeIndication TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLCommitmentTypeIndication)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLCommitmentTypeIndicationList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCommitmentTypeIndicationList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCommitmentTypeIndicationList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, get_CommitmentTypeIndication)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndicationList_get_CommitmentTypeIndication(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCommitmentTypeIndication_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCommitmentTypeIndicationList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCommitmentTypeIndicationList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACommitmentTypeIndication, TElXMLCommitmentTypeIndication, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ACommitmentTypeIndication, TElXMLCommitmentTypeIndication, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList_get_CommitmentTypeIndication, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCommitmentTypeIndicationList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCommitmentTypeIndicationList_methods[] = {
	PHP_ME(TElXMLCommitmentTypeIndicationList, Add, arginfo_TElXMLCommitmentTypeIndicationList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndicationList, Insert, arginfo_TElXMLCommitmentTypeIndicationList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndicationList, Delete, arginfo_TElXMLCommitmentTypeIndicationList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndicationList, Clear, arginfo_TElXMLCommitmentTypeIndicationList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndicationList, get_Count, arginfo_TElXMLCommitmentTypeIndicationList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndicationList, get_CommitmentTypeIndication, arginfo_TElXMLCommitmentTypeIndicationList_get_CommitmentTypeIndication, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCommitmentTypeIndicationList, __construct, arginfo_TElXMLCommitmentTypeIndicationList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCommitmentTypeIndicationList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCommitmentTypeIndicationList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCommitmentTypeIndicationList", TElXMLCommitmentTypeIndicationList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCommitmentTypeIndicationList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignatureProductionPlace_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignatureProductionPlace, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignatureProductionPlace_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignatureProductionPlace_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignatureProductionPlace_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, get_City)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignatureProductionPlace_get_City(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1831244117, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, set_City)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_set_City(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, get_StateOrProvince)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignatureProductionPlace_get_StateOrProvince(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2042757021, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, set_StateOrProvince)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_set_StateOrProvince(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, get_PostalCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignatureProductionPlace_get_PostalCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-924118332, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, set_PostalCode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_set_PostalCode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, get_CountryName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignatureProductionPlace_get_CountryName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(962297554, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, set_CountryName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignatureProductionPlace_set_CountryName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignatureProductionPlace, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignatureProductionPlace_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignatureProductionPlace_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignatureProductionPlace_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_get_City, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_set_City, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_get_StateOrProvince, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_set_StateOrProvince, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_get_PostalCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_set_PostalCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_get_CountryName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace_set_CountryName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignatureProductionPlace___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignatureProductionPlace_methods[] = {
	PHP_ME(TElXMLSignatureProductionPlace, Assign, arginfo_TElXMLSignatureProductionPlace_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, Clear, arginfo_TElXMLSignatureProductionPlace_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, IsEmpty, arginfo_TElXMLSignatureProductionPlace_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, LoadFromXML, arginfo_TElXMLSignatureProductionPlace_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, SaveToXML, arginfo_TElXMLSignatureProductionPlace_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, get_City, arginfo_TElXMLSignatureProductionPlace_get_City, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, set_City, arginfo_TElXMLSignatureProductionPlace_set_City, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, get_StateOrProvince, arginfo_TElXMLSignatureProductionPlace_get_StateOrProvince, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, set_StateOrProvince, arginfo_TElXMLSignatureProductionPlace_set_StateOrProvince, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, get_PostalCode, arginfo_TElXMLSignatureProductionPlace_get_PostalCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, set_PostalCode, arginfo_TElXMLSignatureProductionPlace_set_PostalCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, get_CountryName, arginfo_TElXMLSignatureProductionPlace_get_CountryName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, set_CountryName, arginfo_TElXMLSignatureProductionPlace_set_CountryName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignatureProductionPlace, __construct, arginfo_TElXMLSignatureProductionPlace___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignatureProductionPlace(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignatureProductionPlace_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignatureProductionPlace", TElXMLSignatureProductionPlace_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignatureProductionPlace_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncapsulatedX509Certificates_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncapsulatedX509Certificates, AddCertificate)
{
	long fAXAdESVersion;
	zval *oACert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oACert, TElX509Certificate_ce_ptr, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLEncapsulatedX509Certificates_AddCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACert TSRMLS_CC), (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedX509Certificates, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLEncapsulatedX509Certificates_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedX509Certificates, get_Certificates)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedX509Certificates_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLEncapsulatedX509Certificates, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedX509Certificates_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedX509Certificates_AddCertificate, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ACert, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, AXAdESVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedX509Certificates_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedX509Certificates_get_Certificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedX509Certificates___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncapsulatedX509Certificates_methods[] = {
	PHP_ME(TElXMLEncapsulatedX509Certificates, AddCertificate, arginfo_TElXMLEncapsulatedX509Certificates_AddCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedX509Certificates, Clear, arginfo_TElXMLEncapsulatedX509Certificates_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedX509Certificates, get_Certificates, arginfo_TElXMLEncapsulatedX509Certificates_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLEncapsulatedX509Certificates, __construct, arginfo_TElXMLEncapsulatedX509Certificates___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncapsulatedX509Certificates(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncapsulatedX509Certificates_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncapsulatedX509Certificates", TElXMLEncapsulatedX509Certificates_methods);
	if (NULL == TElXMLEncapsulatedPKIDataList_ce_ptr)
		Register_TElXMLEncapsulatedPKIDataList(TSRMLS_C);
	TElXMLEncapsulatedX509Certificates_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedPKIDataList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCertifiedRole_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCertifiedRole, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertifiedRole_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertifiedRole_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertifiedRole_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertifiedRole___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCertifiedRole_methods[] = {
	PHP_ME(TElXMLCertifiedRole, __construct, arginfo_TElXMLCertifiedRole___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCertifiedRole(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCertifiedRole_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCertifiedRole", TElXMLCertifiedRole_methods);
	if (NULL == TElXMLEncapsulatedPKIData_ce_ptr)
		Register_TElXMLEncapsulatedPKIData(TSRMLS_C);
	TElXMLCertifiedRole_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedPKIData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCertifiedRolesList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCertifiedRolesList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertifiedRolesList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertifiedRolesList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCertifiedRolesList_methods[] = {
	PHP_ME(TElXMLCertifiedRolesList, __construct, arginfo_TElXMLCertifiedRolesList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCertifiedRolesList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCertifiedRolesList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCertifiedRolesList", TElXMLCertifiedRolesList_methods);
	if (NULL == TElXMLEncapsulatedX509Certificates_ce_ptr)
		Register_TElXMLEncapsulatedX509Certificates(TSRMLS_C);
	TElXMLCertifiedRolesList_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedX509Certificates_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLClaimedRole_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLClaimedRole, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLClaimedRole_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLClaimedRole_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLClaimedRole_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLClaimedRole___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLClaimedRole_methods[] = {
	PHP_ME(TElXMLClaimedRole, __construct, arginfo_TElXMLClaimedRole___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLClaimedRole(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLClaimedRole_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLClaimedRole", TElXMLClaimedRole_methods);
	if (NULL == TElXMLAnyType_ce_ptr)
		Register_TElXMLAnyType(TSRMLS_C);
	TElXMLClaimedRole_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAnyType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLClaimedRolesList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLClaimedRolesList, AddText)
{
	char *sText;
	int sText_len;
	long fAVersion;
	zval *oOwnerDocument;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!s", &fAVersion, &oOwnerDocument, TElXMLDOMDocument_ce_ptr, &sText, &sText_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLClaimedRolesList_AddText(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESVersionRaw)fAVersion, SBGetObjectHandle(oOwnerDocument TSRMLS_CC), sText, (int32_t)sText_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLDOMDocument, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLClaimedRolesList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLClaimedRolesList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLClaimedRolesList_AddText, 0, 0, 3)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_OBJ_INFO(0, OwnerDocument, TElXMLDOMDocument, 1)
	ZEND_ARG_INFO(0, Text)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLClaimedRolesList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLClaimedRolesList_methods[] = {
	PHP_ME(TElXMLClaimedRolesList, AddText, arginfo_TElXMLClaimedRolesList_AddText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLClaimedRolesList, __construct, arginfo_TElXMLClaimedRolesList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLClaimedRolesList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLClaimedRolesList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLClaimedRolesList", TElXMLClaimedRolesList_methods);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	TElXMLClaimedRolesList_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAnyTypeList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignerRole_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignerRole, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElXMLAdESElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignerRole_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLAdESElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignerRole_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignerRole_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignerRole_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, get_ClaimedRoles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_get_ClaimedRoles(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLClaimedRolesList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, get_CertifiedRoles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_get_CertifiedRoles(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertifiedRolesList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignerRole, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignerRole_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElXMLAdESElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_get_ClaimedRoles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole_get_CertifiedRoles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignerRole___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignerRole_methods[] = {
	PHP_ME(TElXMLSignerRole, Assign, arginfo_TElXMLSignerRole_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, Clear, arginfo_TElXMLSignerRole_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, IsEmpty, arginfo_TElXMLSignerRole_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, LoadFromXML, arginfo_TElXMLSignerRole_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, SaveToXML, arginfo_TElXMLSignerRole_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, get_ClaimedRoles, arginfo_TElXMLSignerRole_get_ClaimedRoles, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, get_CertifiedRoles, arginfo_TElXMLSignerRole_get_CertifiedRoles, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignerRole, __construct, arginfo_TElXMLSignerRole___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignerRole(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignerRole_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignerRole", TElXMLSignerRole_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignerRole_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCompleteCertificateRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCompleteCertificateRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCompleteCertificateRefs_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCompleteCertificateRefs_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteCertificateRefs_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteCertificateRefs_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCompleteCertificateRefs_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(381049014, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCompleteCertificateRefs_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, get_CertRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteCertificateRefs_get_CertRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertIDList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteCertificateRefs, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteCertificateRefs_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteCertificateRefs_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteCertificateRefs_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs_get_CertRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteCertificateRefs___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCompleteCertificateRefs_methods[] = {
	PHP_ME(TElXMLCompleteCertificateRefs, Clear, arginfo_TElXMLCompleteCertificateRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, IsEmpty, arginfo_TElXMLCompleteCertificateRefs_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, LoadFromXML, arginfo_TElXMLCompleteCertificateRefs_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, SaveToXML, arginfo_TElXMLCompleteCertificateRefs_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, get_ID, arginfo_TElXMLCompleteCertificateRefs_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, set_ID, arginfo_TElXMLCompleteCertificateRefs_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, get_CertRefs, arginfo_TElXMLCompleteCertificateRefs_get_CertRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteCertificateRefs, __construct, arginfo_TElXMLCompleteCertificateRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCompleteCertificateRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCompleteCertificateRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCompleteCertificateRefs", TElXMLCompleteCertificateRefs_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCompleteCertificateRefs_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCRLIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCRLIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCRLIdentifier_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLIdentifier_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLIdentifier_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, get_Issuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCRLIdentifier_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(542193400, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, set_Issuer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_set_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, get_IssueTime)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCRLIdentifier_get_IssueTime(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(24334895, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, set_IssueTime)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_set_IssueTime(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, get_IssueTimeUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLCRLIdentifier_get_IssueTimeUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, set_IssueTimeUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_set_IssueTimeUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, get_Number)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCRLIdentifier_get_Number(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, set_Number)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_set_Number(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCRLIdentifier_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1846533471, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCRLIdentifier_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLIdentifier, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLIdentifier_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLIdentifier_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLIdentifier_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_set_Issuer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_get_IssueTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_set_IssueTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_get_IssueTimeUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_set_IssueTimeUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_get_Number, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_set_Number, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLIdentifier___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCRLIdentifier_methods[] = {
	PHP_ME(TElXMLCRLIdentifier, Clear, arginfo_TElXMLCRLIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, IsEmpty, arginfo_TElXMLCRLIdentifier_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, LoadFromXML, arginfo_TElXMLCRLIdentifier_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, SaveToXML, arginfo_TElXMLCRLIdentifier_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, get_Issuer, arginfo_TElXMLCRLIdentifier_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, set_Issuer, arginfo_TElXMLCRLIdentifier_set_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, get_IssueTime, arginfo_TElXMLCRLIdentifier_get_IssueTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, set_IssueTime, arginfo_TElXMLCRLIdentifier_set_IssueTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, get_IssueTimeUTC, arginfo_TElXMLCRLIdentifier_get_IssueTimeUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, set_IssueTimeUTC, arginfo_TElXMLCRLIdentifier_set_IssueTimeUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, get_Number, arginfo_TElXMLCRLIdentifier_get_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, set_Number, arginfo_TElXMLCRLIdentifier_set_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, get_URI, arginfo_TElXMLCRLIdentifier_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, set_URI, arginfo_TElXMLCRLIdentifier_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLIdentifier, __construct, arginfo_TElXMLCRLIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCRLIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCRLIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCRLIdentifier", TElXMLCRLIdentifier_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCRLIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCRLRef_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCRLRef, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCRLRef_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCRLRef_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, IsMatch)
{
	zval *oACRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACRL, TElCertificateRevocationList_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCRLRef_IsMatch(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACRL TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCRLRef_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, get_DigestAlgAndValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_get_DigestAlgAndValue(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDigestAlgAndValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, get_CRLIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_get_CRLIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCRLIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, set_CRLIdentifier)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCRLIdentifier_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCRLRef_set_CRLIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCRLIdentifier)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRef, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRef_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_IsMatch, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACRL, TElCertificateRevocationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_get_DigestAlgAndValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_get_CRLIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef_set_CRLIdentifier, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCRLIdentifier, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRef___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCRLRef_methods[] = {
	PHP_ME(TElXMLCRLRef, Clear, arginfo_TElXMLCRLRef_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, IsEmpty, arginfo_TElXMLCRLRef_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, IsMatch, arginfo_TElXMLCRLRef_IsMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, LoadFromXML, arginfo_TElXMLCRLRef_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, SaveToXML, arginfo_TElXMLCRLRef_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, get_DigestAlgAndValue, arginfo_TElXMLCRLRef_get_DigestAlgAndValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, get_CRLIdentifier, arginfo_TElXMLCRLRef_get_CRLIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, set_CRLIdentifier, arginfo_TElXMLCRLRef_set_CRLIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRef, __construct, arginfo_TElXMLCRLRef___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCRLRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCRLRef_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCRLRef", TElXMLCRLRef_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCRLRef_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCRLRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCRLRefs, AddCRL)
{
	long fAXAdESVersion;
	long fDigestMethod;
	zval *oACRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oACRL, TElCertificateRevocationList_ce_ptr, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCRLRefs_AddCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACRL TSRMLS_CC), (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ll", &oACRL, TElCertificateRevocationList_ce_ptr, &fDigestMethod, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCRLRefs_AddCRL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACRL TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList, integer) or (TElCertificateRevocationList, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, Add)
{
	zval *oACRLRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oACRLRef, TElXMLCRLRef_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCRLRefs_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACRLRef TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCRLRef)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, Insert)
{
	long l4Index;
	zval *oACRLRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oACRLRef, TElXMLCRLRef_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCRLRefs_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oACRLRef TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLCRLRef)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLCRLRefs_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCRLRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCRLRefs_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, get_CRLRef)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRefs_get_CRLRef(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCRLRef_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLRefs, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLRefs_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_AddCRL, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ACRL, TElCertificateRevocationList, 1)
	ZEND_ARG_INFO(0, AXAdESVersion_or_DigestMethod)
	ZEND_ARG_INFO(0, AXAdESVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ACRLRef, TElXMLCRLRef, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ACRLRef, TElXMLCRLRef, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs_get_CRLRef, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLRefs___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCRLRefs_methods[] = {
	PHP_ME(TElXMLCRLRefs, AddCRL, arginfo_TElXMLCRLRefs_AddCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, Add, arginfo_TElXMLCRLRefs_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, Insert, arginfo_TElXMLCRLRefs_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, Delete, arginfo_TElXMLCRLRefs_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, Clear, arginfo_TElXMLCRLRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, get_Count, arginfo_TElXMLCRLRefs_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, get_CRLRef, arginfo_TElXMLCRLRefs_get_CRLRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLRefs, __construct, arginfo_TElXMLCRLRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCRLRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCRLRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCRLRefs", TElXMLCRLRefs_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCRLRefs_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLOCSPIdentifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLOCSPIdentifier, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLOCSPIdentifier_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPIdentifier_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPIdentifier_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, get_ResponderID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLOCSPIdentifier_get_ResponderID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1898241385, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, set_ResponderID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_set_ResponderID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, get_ProducedAt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLOCSPIdentifier_get_ProducedAt(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1373027837, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, set_ProducedAt)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_set_ProducedAt(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, get_ProducedAtUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLOCSPIdentifier_get_ProducedAtUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, set_ProducedAtUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_set_ProducedAtUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLOCSPIdentifier_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(124981417, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, get_ResponderIDType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESResponderIDTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLOCSPIdentifier_get_ResponderIDType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, set_ResponderIDType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPIdentifier_set_ResponderIDType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESResponderIDTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPIdentifier, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPIdentifier_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPIdentifier_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPIdentifier_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_get_ResponderID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_set_ResponderID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_get_ProducedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_set_ProducedAt, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_get_ProducedAtUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_set_ProducedAtUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_get_ResponderIDType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier_set_ResponderIDType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPIdentifier___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLOCSPIdentifier_methods[] = {
	PHP_ME(TElXMLOCSPIdentifier, Clear, arginfo_TElXMLOCSPIdentifier_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, IsEmpty, arginfo_TElXMLOCSPIdentifier_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, LoadFromXML, arginfo_TElXMLOCSPIdentifier_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, SaveToXML, arginfo_TElXMLOCSPIdentifier_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, get_ResponderID, arginfo_TElXMLOCSPIdentifier_get_ResponderID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, set_ResponderID, arginfo_TElXMLOCSPIdentifier_set_ResponderID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, get_ProducedAt, arginfo_TElXMLOCSPIdentifier_get_ProducedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, set_ProducedAt, arginfo_TElXMLOCSPIdentifier_set_ProducedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, get_ProducedAtUTC, arginfo_TElXMLOCSPIdentifier_get_ProducedAtUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, set_ProducedAtUTC, arginfo_TElXMLOCSPIdentifier_set_ProducedAtUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, get_URI, arginfo_TElXMLOCSPIdentifier_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, set_URI, arginfo_TElXMLOCSPIdentifier_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, get_ResponderIDType, arginfo_TElXMLOCSPIdentifier_get_ResponderIDType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, set_ResponderIDType, arginfo_TElXMLOCSPIdentifier_set_ResponderIDType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPIdentifier, __construct, arginfo_TElXMLOCSPIdentifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLOCSPIdentifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLOCSPIdentifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLOCSPIdentifier", TElXMLOCSPIdentifier_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLOCSPIdentifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLOCSPRef_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLOCSPRef, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLOCSPRef_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLOCSPRef_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPRef_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, IsMatch)
{
	zval *oOCSPResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOCSPResponse, TElOCSPResponse_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLOCSPRef_IsMatch(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOCSPResponse TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, get_DigestAlgAndValue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_get_DigestAlgAndValue(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDigestAlgAndValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, set_DigestAlgAndValue)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDigestAlgAndValue_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPRef_set_DigestAlgAndValue(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDigestAlgAndValue)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, get_OCSPIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_get_OCSPIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLOCSPIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRef, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRef_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_IsMatch, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponse, TElOCSPResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_get_DigestAlgAndValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_set_DigestAlgAndValue, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDigestAlgAndValue, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef_get_OCSPIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRef___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLOCSPRef_methods[] = {
	PHP_ME(TElXMLOCSPRef, Clear, arginfo_TElXMLOCSPRef_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, IsEmpty, arginfo_TElXMLOCSPRef_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, LoadFromXML, arginfo_TElXMLOCSPRef_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, SaveToXML, arginfo_TElXMLOCSPRef_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, IsMatch, arginfo_TElXMLOCSPRef_IsMatch, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, get_DigestAlgAndValue, arginfo_TElXMLOCSPRef_get_DigestAlgAndValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, set_DigestAlgAndValue, arginfo_TElXMLOCSPRef_set_DigestAlgAndValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, get_OCSPIdentifier, arginfo_TElXMLOCSPRef_get_OCSPIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRef, __construct, arginfo_TElXMLOCSPRef___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLOCSPRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLOCSPRef_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLOCSPRef", TElXMLOCSPRef_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLOCSPRef_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLOCSPRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLOCSPRefs, AddOCSP)
{
	long fAXAdESVersion;
	long fDigestMethod;
	zend_bool bByKey;
	zval *oOCSPResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bl", &oOCSPResponse, TElOCSPResponse_ce_ptr, &bByKey, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLOCSPRefs_AddOCSP(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOCSPResponse TSRMLS_CC), (int8_t)bByKey, (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bll", &oOCSPResponse, TElOCSPResponse_ce_ptr, &bByKey, &fDigestMethod, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLOCSPRefs_AddOCSP_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOCSPResponse TSRMLS_CC), (int8_t)bByKey, (TElXMLDigestMethodRaw)fDigestMethod, (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse, bool, integer) or (TElOCSPResponse, bool, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, Add)
{
	zval *oAOCSPRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOCSPRef, TElXMLOCSPRef_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLOCSPRefs_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAOCSPRef TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLOCSPRef)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, Insert)
{
	long l4Index;
	zval *oAOCSPRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAOCSPRef, TElXMLOCSPRef_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPRefs_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAOCSPRef TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLOCSPRef)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLOCSPRefs_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLOCSPRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLOCSPRefs_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, get_OCSPRef)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRefs_get_OCSPRef(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLOCSPRef_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPRefs, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPRefs_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_AddOCSP, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, OCSPResponse, TElOCSPResponse, 1)
	ZEND_ARG_INFO(0, ByKey)
	ZEND_ARG_INFO(0, AXAdESVersion_or_DigestMethod)
	ZEND_ARG_INFO(0, AXAdESVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOCSPRef, TElXMLOCSPRef, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AOCSPRef, TElXMLOCSPRef, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs_get_OCSPRef, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPRefs___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLOCSPRefs_methods[] = {
	PHP_ME(TElXMLOCSPRefs, AddOCSP, arginfo_TElXMLOCSPRefs_AddOCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, Add, arginfo_TElXMLOCSPRefs_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, Insert, arginfo_TElXMLOCSPRefs_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, Delete, arginfo_TElXMLOCSPRefs_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, Clear, arginfo_TElXMLOCSPRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, get_Count, arginfo_TElXMLOCSPRefs_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, get_OCSPRef, arginfo_TElXMLOCSPRefs_get_OCSPRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPRefs, __construct, arginfo_TElXMLOCSPRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLOCSPRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLOCSPRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLOCSPRefs", TElXMLOCSPRefs_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLOCSPRefs_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLOtherRef_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLOtherRef, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOtherRef_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOtherRef_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOtherRef_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOtherRef___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLOtherRef_methods[] = {
	PHP_ME(TElXMLOtherRef, __construct, arginfo_TElXMLOtherRef___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLOtherRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLOtherRef_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLOtherRef", TElXMLOtherRef_methods);
	if (NULL == TElXMLAnyType_ce_ptr)
		Register_TElXMLAnyType(TSRMLS_C);
	TElXMLOtherRef_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAnyType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCompleteRevocationRefs_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCompleteRevocationRefs_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCompleteRevocationRefs_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCompleteRevocationRefs_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCompleteRevocationRefs_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1520742958, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCompleteRevocationRefs_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, get_CRLRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_get_CRLRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCRLRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, get_OCSPRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_get_OCSPRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLOCSPRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, get_OtherRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_get_OtherRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCompleteRevocationRefs, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCompleteRevocationRefs_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_get_CRLRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_get_OCSPRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs_get_OtherRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCompleteRevocationRefs___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCompleteRevocationRefs_methods[] = {
	PHP_ME(TElXMLCompleteRevocationRefs, Clear, arginfo_TElXMLCompleteRevocationRefs_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, IsEmpty, arginfo_TElXMLCompleteRevocationRefs_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, LoadFromXML, arginfo_TElXMLCompleteRevocationRefs_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, SaveToXML, arginfo_TElXMLCompleteRevocationRefs_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, get_ID, arginfo_TElXMLCompleteRevocationRefs_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, set_ID, arginfo_TElXMLCompleteRevocationRefs_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, get_CRLRefs, arginfo_TElXMLCompleteRevocationRefs_get_CRLRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, get_OCSPRefs, arginfo_TElXMLCompleteRevocationRefs_get_OCSPRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, get_OtherRefs, arginfo_TElXMLCompleteRevocationRefs_get_OtherRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCompleteRevocationRefs, __construct, arginfo_TElXMLCompleteRevocationRefs___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCompleteRevocationRefs(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCompleteRevocationRefs_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCompleteRevocationRefs", TElXMLCompleteRevocationRefs_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCompleteRevocationRefs_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCertificateValues_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCertificateValues, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCertificateValues_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLCertificateValues_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCertificateValues_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLCertificateValues_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(497084481, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLCertificateValues_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, get_EncapsulatedX509Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_get_EncapsulatedX509Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLEncapsulatedX509Certificates_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, get_OtherCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_get_OtherCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCertificateValues, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCertificateValues_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_get_EncapsulatedX509Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues_get_OtherCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCertificateValues___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCertificateValues_methods[] = {
	PHP_ME(TElXMLCertificateValues, Clear, arginfo_TElXMLCertificateValues_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, IsEmpty, arginfo_TElXMLCertificateValues_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, LoadFromXML, arginfo_TElXMLCertificateValues_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, SaveToXML, arginfo_TElXMLCertificateValues_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, get_ID, arginfo_TElXMLCertificateValues_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, set_ID, arginfo_TElXMLCertificateValues_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, get_EncapsulatedX509Certificates, arginfo_TElXMLCertificateValues_get_EncapsulatedX509Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, get_OtherCertificates, arginfo_TElXMLCertificateValues_get_OtherCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCertificateValues, __construct, arginfo_TElXMLCertificateValues___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCertificateValues(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCertificateValues_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCertificateValues", TElXMLCertificateValues_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLCertificateValues_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncapsulatedCRLValue_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncapsulatedCRLValue, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedCRLValue_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedCRLValue_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedCRLValue_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedCRLValue___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncapsulatedCRLValue_methods[] = {
	PHP_ME(TElXMLEncapsulatedCRLValue, __construct, arginfo_TElXMLEncapsulatedCRLValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncapsulatedCRLValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncapsulatedCRLValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncapsulatedCRLValue", TElXMLEncapsulatedCRLValue_methods);
	if (NULL == TElXMLEncapsulatedPKIData_ce_ptr)
		Register_TElXMLEncapsulatedPKIData(TSRMLS_C);
	TElXMLEncapsulatedCRLValue_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedPKIData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCRLValues_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCRLValues, AddCRL)
{
	long fAXAdESVersion;
	zval *oACRL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oACRL, TElCertificateRevocationList_ce_ptr, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLCRLValues_AddCRL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oACRL TSRMLS_CC), (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCertificateRevocationList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLValues, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCRLValues_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLValues, get_CRLs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLValues_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCertificateRevocationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCRLValues, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCRLValues_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLValues_AddCRL, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, ACRL, TElCertificateRevocationList, 1)
	ZEND_ARG_INFO(0, AXAdESVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLValues_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLValues_get_CRLs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCRLValues___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCRLValues_methods[] = {
	PHP_ME(TElXMLCRLValues, AddCRL, arginfo_TElXMLCRLValues_AddCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLValues, Clear, arginfo_TElXMLCRLValues_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLValues, get_CRLs, arginfo_TElXMLCRLValues_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCRLValues, __construct, arginfo_TElXMLCRLValues___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCRLValues(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCRLValues_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCRLValues", TElXMLCRLValues_methods);
	if (NULL == TElXMLEncapsulatedPKIDataList_ce_ptr)
		Register_TElXMLEncapsulatedPKIDataList(TSRMLS_C);
	TElXMLCRLValues_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedPKIDataList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLEncapsulatedOCSPValue_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLEncapsulatedOCSPValue, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedOCSPValue_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedOCSPValue_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLEncapsulatedOCSPValue_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLEncapsulatedOCSPValue___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLEncapsulatedOCSPValue_methods[] = {
	PHP_ME(TElXMLEncapsulatedOCSPValue, __construct, arginfo_TElXMLEncapsulatedOCSPValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLEncapsulatedOCSPValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLEncapsulatedOCSPValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLEncapsulatedOCSPValue", TElXMLEncapsulatedOCSPValue_methods);
	if (NULL == TElXMLEncapsulatedPKIData_ce_ptr)
		Register_TElXMLEncapsulatedPKIData(TSRMLS_C);
	TElXMLEncapsulatedOCSPValue_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedPKIData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLOCSPValues_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLOCSPValues, AddOCSPResponse)
{
	long fAXAdESVersion;
	zval *oAOCSPResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oAOCSPResponse, TElOCSPResponse_ce_ptr, &fAXAdESVersion) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLOCSPValues_AddOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAOCSPResponse TSRMLS_CC), (TSBXAdESVersionRaw)fAXAdESVersion, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOCSPResponse, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPValues, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLOCSPValues_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPValues, get_OCSPResponses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPValues_get_OCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOCSPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLOCSPValues, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLOCSPValues_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPValues_AddOCSPResponse, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, AOCSPResponse, TElOCSPResponse, 1)
	ZEND_ARG_INFO(0, AXAdESVersion)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPValues_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPValues_get_OCSPResponses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLOCSPValues___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLOCSPValues_methods[] = {
	PHP_ME(TElXMLOCSPValues, AddOCSPResponse, arginfo_TElXMLOCSPValues_AddOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPValues, Clear, arginfo_TElXMLOCSPValues_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPValues, get_OCSPResponses, arginfo_TElXMLOCSPValues_get_OCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLOCSPValues, __construct, arginfo_TElXMLOCSPValues___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLOCSPValues(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLOCSPValues_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLOCSPValues", TElXMLOCSPValues_methods);
	if (NULL == TElXMLEncapsulatedPKIDataList_ce_ptr)
		Register_TElXMLEncapsulatedPKIDataList(TSRMLS_C);
	TElXMLOCSPValues_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLEncapsulatedPKIDataList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLRevocationValues_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLRevocationValues, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLRevocationValues_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLRevocationValues_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLRevocationValues_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLRevocationValues_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(186450251, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLRevocationValues_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, get_CRLValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_get_CRLValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCRLValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, get_OCSPValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_get_OCSPValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLOCSPValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, get_OtherValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_get_OtherValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLRevocationValues, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLRevocationValues_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_get_CRLValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_get_OCSPValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues_get_OtherValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLRevocationValues___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLRevocationValues_methods[] = {
	PHP_ME(TElXMLRevocationValues, Clear, arginfo_TElXMLRevocationValues_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, IsEmpty, arginfo_TElXMLRevocationValues_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, LoadFromXML, arginfo_TElXMLRevocationValues_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, SaveToXML, arginfo_TElXMLRevocationValues_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, get_ID, arginfo_TElXMLRevocationValues_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, set_ID, arginfo_TElXMLRevocationValues_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, get_CRLValues, arginfo_TElXMLRevocationValues_get_CRLValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, get_OCSPValues, arginfo_TElXMLRevocationValues_get_OCSPValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, get_OtherValues, arginfo_TElXMLRevocationValues_get_OtherValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLRevocationValues, __construct, arginfo_TElXMLRevocationValues___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLRevocationValues(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLRevocationValues_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLRevocationValues", TElXMLRevocationValues_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLRevocationValues_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLTimeStampValidationData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLTimeStampValidationData, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationData_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLTimeStampValidationData_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationData_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLTimeStampValidationData_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1589131858, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationData_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLTimeStampValidationData_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(929816541, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationData_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, get_CertificateValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_get_CertificateValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertificateValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, set_CertificateValues)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCertificateValues_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationData_set_CertificateValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCertificateValues)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, get_RevocationValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_get_RevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLRevocationValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, set_RevocationValues)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLRevocationValues_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationData_set_RevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLRevocationValues)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationData, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationData_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_get_CertificateValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_set_CertificateValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCertificateValues, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_get_RevocationValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData_set_RevocationValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLRevocationValues, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationData___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLTimeStampValidationData_methods[] = {
	PHP_ME(TElXMLTimeStampValidationData, Clear, arginfo_TElXMLTimeStampValidationData_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, IsEmpty, arginfo_TElXMLTimeStampValidationData_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, LoadFromXML, arginfo_TElXMLTimeStampValidationData_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, SaveToXML, arginfo_TElXMLTimeStampValidationData_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, get_ID, arginfo_TElXMLTimeStampValidationData_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, set_ID, arginfo_TElXMLTimeStampValidationData_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, get_URI, arginfo_TElXMLTimeStampValidationData_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, set_URI, arginfo_TElXMLTimeStampValidationData_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, get_CertificateValues, arginfo_TElXMLTimeStampValidationData_get_CertificateValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, set_CertificateValues, arginfo_TElXMLTimeStampValidationData_set_CertificateValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, get_RevocationValues, arginfo_TElXMLTimeStampValidationData_get_RevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, set_RevocationValues, arginfo_TElXMLTimeStampValidationData_set_RevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationData, __construct, arginfo_TElXMLTimeStampValidationData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLTimeStampValidationData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLTimeStampValidationData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLTimeStampValidationData", TElXMLTimeStampValidationData_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLTimeStampValidationData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLTimeStampValidationDataList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, Add)
{
	zval *oATSPValidationData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPValidationData, TElXMLTimeStampValidationData_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimeStampValidationDataList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPValidationData TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLTimeStampValidationData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, Insert)
{
	long l4Index;
	zval *oATSPValidationData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oATSPValidationData, TElXMLTimeStampValidationData_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationDataList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oATSPValidationData TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLTimeStampValidationData)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationDataList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLTimeStampValidationDataList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLTimeStampValidationDataList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, get_TimeStampValidationData)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationDataList_get_TimeStampValidationData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTimeStampValidationData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLTimeStampValidationDataList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLTimeStampValidationDataList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPValidationData, TElXMLTimeStampValidationData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ATSPValidationData, TElXMLTimeStampValidationData, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList_get_TimeStampValidationData, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLTimeStampValidationDataList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLTimeStampValidationDataList_methods[] = {
	PHP_ME(TElXMLTimeStampValidationDataList, Add, arginfo_TElXMLTimeStampValidationDataList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationDataList, Insert, arginfo_TElXMLTimeStampValidationDataList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationDataList, Delete, arginfo_TElXMLTimeStampValidationDataList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationDataList, Clear, arginfo_TElXMLTimeStampValidationDataList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationDataList, get_Count, arginfo_TElXMLTimeStampValidationDataList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationDataList, get_TimeStampValidationData, arginfo_TElXMLTimeStampValidationDataList_get_TimeStampValidationData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLTimeStampValidationDataList, __construct, arginfo_TElXMLTimeStampValidationDataList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLTimeStampValidationDataList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLTimeStampValidationDataList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLTimeStampValidationDataList", TElXMLTimeStampValidationDataList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLTimeStampValidationDataList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignedDataObjectProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignedDataObjectProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignedDataObjectProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedDataObjectProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, get_DataObjectFormats)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_get_DataObjectFormats(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDataObjectFormatList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, get_CommitmentTypeIndications)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_get_CommitmentTypeIndications(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCommitmentTypeIndicationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, get_AllDataObjectsTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_get_AllDataObjectsTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, get_IndividualDataObjectsTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_get_IndividualDataObjectsTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignedDataObjectProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(14823178, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignedDataObjectProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedDataObjectProperties, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedDataObjectProperties_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_get_DataObjectFormats, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_get_CommitmentTypeIndications, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_get_AllDataObjectsTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_get_IndividualDataObjectsTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedDataObjectProperties___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignedDataObjectProperties_methods[] = {
	PHP_ME(TElXMLSignedDataObjectProperties, Clear, arginfo_TElXMLSignedDataObjectProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, IsEmpty, arginfo_TElXMLSignedDataObjectProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, LoadFromXML, arginfo_TElXMLSignedDataObjectProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, SaveToXML, arginfo_TElXMLSignedDataObjectProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, get_DataObjectFormats, arginfo_TElXMLSignedDataObjectProperties_get_DataObjectFormats, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, get_CommitmentTypeIndications, arginfo_TElXMLSignedDataObjectProperties_get_CommitmentTypeIndications, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, get_AllDataObjectsTimestamps, arginfo_TElXMLSignedDataObjectProperties_get_AllDataObjectsTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, get_IndividualDataObjectsTimestamps, arginfo_TElXMLSignedDataObjectProperties_get_IndividualDataObjectsTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, get_ID, arginfo_TElXMLSignedDataObjectProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, set_ID, arginfo_TElXMLSignedDataObjectProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedDataObjectProperties, __construct, arginfo_TElXMLSignedDataObjectProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignedDataObjectProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignedDataObjectProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignedDataObjectProperties", TElXMLSignedDataObjectProperties_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignedDataObjectProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLUnsignedDataObjectProperty_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLUnsignedDataObjectProperty, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedDataObjectProperty_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedDataObjectProperty_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedDataObjectProperty_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedDataObjectProperty___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLUnsignedDataObjectProperty_methods[] = {
	PHP_ME(TElXMLUnsignedDataObjectProperty, __construct, arginfo_TElXMLUnsignedDataObjectProperty___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLUnsignedDataObjectProperty(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLUnsignedDataObjectProperty_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLUnsignedDataObjectProperty", TElXMLUnsignedDataObjectProperty_methods);
	if (NULL == TElXMLAnyType_ce_ptr)
		Register_TElXMLAnyType(TSRMLS_C);
	TElXMLUnsignedDataObjectProperty_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAnyType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignedSignatureProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignedSignatureProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignedSignatureProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_SignedTime)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignedSignatureProperties_get_SignedTime(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-562584946, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, set_SignedTime)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_set_SignedTime(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_SignedTimeUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLSignedSignatureProperties_get_SignedTimeUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, set_SignedTimeUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_set_SignedTimeUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_SigningCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_get_SigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertIDList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_SignaturePolicyIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_get_SignaturePolicyIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignaturePolicyIdentifier_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_SignatureProductionPlace)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_get_SignatureProductionPlace(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignatureProductionPlace_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, set_SignatureProductionPlace)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignatureProductionPlace_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_set_SignatureProductionPlace(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignatureProductionPlace)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_SignerRole)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_get_SignerRole(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignerRole_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, set_SignerRole)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignerRole_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_set_SignerRole(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignerRole)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignedSignatureProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2067825072, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignedSignatureProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedSignatureProperties, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedSignatureProperties_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_SignedTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_set_SignedTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_SignedTimeUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_set_SignedTimeUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_SigningCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_SignaturePolicyIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_SignatureProductionPlace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_set_SignatureProductionPlace, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignatureProductionPlace, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_SignerRole, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_set_SignerRole, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignerRole, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedSignatureProperties___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignedSignatureProperties_methods[] = {
	PHP_ME(TElXMLSignedSignatureProperties, Clear, arginfo_TElXMLSignedSignatureProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, IsEmpty, arginfo_TElXMLSignedSignatureProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, LoadFromXML, arginfo_TElXMLSignedSignatureProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, SaveToXML, arginfo_TElXMLSignedSignatureProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_SignedTime, arginfo_TElXMLSignedSignatureProperties_get_SignedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, set_SignedTime, arginfo_TElXMLSignedSignatureProperties_set_SignedTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_SignedTimeUTC, arginfo_TElXMLSignedSignatureProperties_get_SignedTimeUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, set_SignedTimeUTC, arginfo_TElXMLSignedSignatureProperties_set_SignedTimeUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_SigningCertificate, arginfo_TElXMLSignedSignatureProperties_get_SigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_SignaturePolicyIdentifier, arginfo_TElXMLSignedSignatureProperties_get_SignaturePolicyIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_SignatureProductionPlace, arginfo_TElXMLSignedSignatureProperties_get_SignatureProductionPlace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, set_SignatureProductionPlace, arginfo_TElXMLSignedSignatureProperties_set_SignatureProductionPlace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_SignerRole, arginfo_TElXMLSignedSignatureProperties_get_SignerRole, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, set_SignerRole, arginfo_TElXMLSignedSignatureProperties_set_SignerRole, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, get_ID, arginfo_TElXMLSignedSignatureProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, set_ID, arginfo_TElXMLSignedSignatureProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedSignatureProperties, __construct, arginfo_TElXMLSignedSignatureProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignedSignatureProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignedSignatureProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignedSignatureProperties", TElXMLSignedSignatureProperties_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignedSignatureProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLUnsignedSignatureProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLUnsignedSignatureProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_XAdESForm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESFormRaw fOutResultRaw = 0;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_XAdESForm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_XAdESForm)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_XAdESForm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESFormRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLUnsignedSignatureProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2131752683, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_CounterSignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_CounterSignatures(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCounterSignatureList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_SignatureTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_SignatureTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_CompleteCertificateRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_CompleteCertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCompleteCertificateRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_CompleteCertificateRefs)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCompleteCertificateRefs_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_CompleteCertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCompleteCertificateRefs)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_CompleteRevocationRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_CompleteRevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCompleteRevocationRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_CompleteRevocationRefs)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCompleteRevocationRefs_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_CompleteRevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCompleteRevocationRefs)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_AttributeCertificateRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_AttributeCertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCompleteCertificateRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_AttributeCertificateRefs)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCompleteCertificateRefs_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_AttributeCertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCompleteCertificateRefs)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_AttributeRevocationRefs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_AttributeRevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCompleteRevocationRefs_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_AttributeRevocationRefs)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCompleteRevocationRefs_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_AttributeRevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCompleteRevocationRefs)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_SigAndRefsTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_SigAndRefsTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_RefsOnlyTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_RefsOnlyTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_CertificateValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_CertificateValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertificateValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_CertificateValues)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCertificateValues_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_CertificateValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCertificateValues)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_RevocationValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_RevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLRevocationValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_RevocationValues)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLRevocationValues_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_RevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLRevocationValues)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_AttrAuthoritiesCertValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_AttrAuthoritiesCertValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertificateValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_AttrAuthoritiesCertValues)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCertificateValues_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_AttrAuthoritiesCertValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCertificateValues)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_AttributeRevocationValues)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_AttributeRevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLRevocationValues_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, set_AttributeRevocationValues)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLRevocationValues_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedSignatureProperties_set_AttributeRevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLRevocationValues)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_ArchiveTimestamps)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_ArchiveTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_ArchiveTimestampsV141)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_ArchiveTimestampsV141(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCustomTimestampList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, get_TimeStampValidationDataList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_get_TimeStampValidationDataList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTimeStampValidationDataList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedSignatureProperties, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedSignatureProperties_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_XAdESForm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_XAdESForm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_CounterSignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_SignatureTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_CompleteCertificateRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_CompleteCertificateRefs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCompleteCertificateRefs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_CompleteRevocationRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_CompleteRevocationRefs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCompleteRevocationRefs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_AttributeCertificateRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_AttributeCertificateRefs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCompleteCertificateRefs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_AttributeRevocationRefs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_AttributeRevocationRefs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCompleteRevocationRefs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_SigAndRefsTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_RefsOnlyTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_CertificateValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_CertificateValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCertificateValues, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_RevocationValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_RevocationValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLRevocationValues, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_AttrAuthoritiesCertValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_AttrAuthoritiesCertValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCertificateValues, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_AttributeRevocationValues, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_set_AttributeRevocationValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLRevocationValues, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_ArchiveTimestamps, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_ArchiveTimestampsV141, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties_get_TimeStampValidationDataList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedSignatureProperties___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLUnsignedSignatureProperties_methods[] = {
	PHP_ME(TElXMLUnsignedSignatureProperties, Clear, arginfo_TElXMLUnsignedSignatureProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, IsEmpty, arginfo_TElXMLUnsignedSignatureProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, LoadFromXML, arginfo_TElXMLUnsignedSignatureProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, SaveToXML, arginfo_TElXMLUnsignedSignatureProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_XAdESForm, arginfo_TElXMLUnsignedSignatureProperties_get_XAdESForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_XAdESForm, arginfo_TElXMLUnsignedSignatureProperties_set_XAdESForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_ID, arginfo_TElXMLUnsignedSignatureProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_ID, arginfo_TElXMLUnsignedSignatureProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_CounterSignatures, arginfo_TElXMLUnsignedSignatureProperties_get_CounterSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_SignatureTimestamps, arginfo_TElXMLUnsignedSignatureProperties_get_SignatureTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_CompleteCertificateRefs, arginfo_TElXMLUnsignedSignatureProperties_get_CompleteCertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_CompleteCertificateRefs, arginfo_TElXMLUnsignedSignatureProperties_set_CompleteCertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_CompleteRevocationRefs, arginfo_TElXMLUnsignedSignatureProperties_get_CompleteRevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_CompleteRevocationRefs, arginfo_TElXMLUnsignedSignatureProperties_set_CompleteRevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_AttributeCertificateRefs, arginfo_TElXMLUnsignedSignatureProperties_get_AttributeCertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_AttributeCertificateRefs, arginfo_TElXMLUnsignedSignatureProperties_set_AttributeCertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_AttributeRevocationRefs, arginfo_TElXMLUnsignedSignatureProperties_get_AttributeRevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_AttributeRevocationRefs, arginfo_TElXMLUnsignedSignatureProperties_set_AttributeRevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_SigAndRefsTimestamps, arginfo_TElXMLUnsignedSignatureProperties_get_SigAndRefsTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_RefsOnlyTimestamps, arginfo_TElXMLUnsignedSignatureProperties_get_RefsOnlyTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_CertificateValues, arginfo_TElXMLUnsignedSignatureProperties_get_CertificateValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_CertificateValues, arginfo_TElXMLUnsignedSignatureProperties_set_CertificateValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_RevocationValues, arginfo_TElXMLUnsignedSignatureProperties_get_RevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_RevocationValues, arginfo_TElXMLUnsignedSignatureProperties_set_RevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_AttrAuthoritiesCertValues, arginfo_TElXMLUnsignedSignatureProperties_get_AttrAuthoritiesCertValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_AttrAuthoritiesCertValues, arginfo_TElXMLUnsignedSignatureProperties_set_AttrAuthoritiesCertValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_AttributeRevocationValues, arginfo_TElXMLUnsignedSignatureProperties_get_AttributeRevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, set_AttributeRevocationValues, arginfo_TElXMLUnsignedSignatureProperties_set_AttributeRevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_ArchiveTimestamps, arginfo_TElXMLUnsignedSignatureProperties_get_ArchiveTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_ArchiveTimestampsV141, arginfo_TElXMLUnsignedSignatureProperties_get_ArchiveTimestampsV141, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, get_TimeStampValidationDataList, arginfo_TElXMLUnsignedSignatureProperties_get_TimeStampValidationDataList, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedSignatureProperties, __construct, arginfo_TElXMLUnsignedSignatureProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLUnsignedSignatureProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLUnsignedSignatureProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLUnsignedSignatureProperties", TElXMLUnsignedSignatureProperties_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLUnsignedSignatureProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSignedProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSignedProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSignedProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSignedProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSignedProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(421465504, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSignedProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, get_SignedSignatureProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_get_SignedSignatureProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignedSignatureProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, set_SignedSignatureProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignedSignatureProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedProperties_set_SignedSignatureProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignedSignatureProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, get_SignedDataObjectProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_get_SignedDataObjectProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignedDataObjectProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, set_SignedDataObjectProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignedDataObjectProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSignedProperties_set_SignedDataObjectProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignedDataObjectProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSignedProperties, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSignedProperties_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_get_SignedSignatureProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_set_SignedSignatureProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignedSignatureProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_get_SignedDataObjectProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties_set_SignedDataObjectProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignedDataObjectProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSignedProperties___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSignedProperties_methods[] = {
	PHP_ME(TElXMLSignedProperties, Clear, arginfo_TElXMLSignedProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, IsEmpty, arginfo_TElXMLSignedProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, LoadFromXML, arginfo_TElXMLSignedProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, SaveToXML, arginfo_TElXMLSignedProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, get_ID, arginfo_TElXMLSignedProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, set_ID, arginfo_TElXMLSignedProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, get_SignedSignatureProperties, arginfo_TElXMLSignedProperties_get_SignedSignatureProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, set_SignedSignatureProperties, arginfo_TElXMLSignedProperties_set_SignedSignatureProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, get_SignedDataObjectProperties, arginfo_TElXMLSignedProperties_get_SignedDataObjectProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, set_SignedDataObjectProperties, arginfo_TElXMLSignedProperties_set_SignedDataObjectProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSignedProperties, __construct, arginfo_TElXMLSignedProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSignedProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSignedProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSignedProperties", TElXMLSignedProperties_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLSignedProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLUnsignedProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLUnsignedProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLUnsignedProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLUnsignedProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(223308992, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, get_UnsignedSignatureProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_get_UnsignedSignatureProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLUnsignedSignatureProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, set_UnsignedSignatureProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLUnsignedSignatureProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLUnsignedProperties_set_UnsignedSignatureProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLUnsignedSignatureProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, get_UnsignedDataObjectProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_get_UnsignedDataObjectProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLAnyTypeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLUnsignedProperties, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLUnsignedProperties_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_get_UnsignedSignatureProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_set_UnsignedSignatureProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLUnsignedSignatureProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties_get_UnsignedDataObjectProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLUnsignedProperties___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLUnsignedProperties_methods[] = {
	PHP_ME(TElXMLUnsignedProperties, Clear, arginfo_TElXMLUnsignedProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, IsEmpty, arginfo_TElXMLUnsignedProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, LoadFromXML, arginfo_TElXMLUnsignedProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, SaveToXML, arginfo_TElXMLUnsignedProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, get_ID, arginfo_TElXMLUnsignedProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, set_ID, arginfo_TElXMLUnsignedProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, get_UnsignedSignatureProperties, arginfo_TElXMLUnsignedProperties_get_UnsignedSignatureProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, set_UnsignedSignatureProperties, arginfo_TElXMLUnsignedProperties_set_UnsignedSignatureProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, get_UnsignedDataObjectProperties, arginfo_TElXMLUnsignedProperties_get_UnsignedDataObjectProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLUnsignedProperties, __construct, arginfo_TElXMLUnsignedProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLUnsignedProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLUnsignedProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLUnsignedProperties", TElXMLUnsignedProperties_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLUnsignedProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLQualifyingProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLQualifyingProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLQualifyingProperties_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, get_XAdESPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLQualifyingProperties_get_XAdESPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-244257356, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, set_XAdESPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_set_XAdESPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, get_XAdESv141Prefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLQualifyingProperties_get_XAdESv141Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-812933391, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, set_XAdESv141Prefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_set_XAdESv141Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLQualifyingProperties_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1294132056, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, get_Target)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLQualifyingProperties_get_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2145852669, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, set_Target)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_set_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, get_SignedProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_get_SignedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignedProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, set_SignedProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignedProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_set_SignedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignedProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, get_UnsignedProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_get_UnsignedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLUnsignedProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, set_UnsignedProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLUnsignedProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingProperties_set_UnsignedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLUnsignedProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingProperties, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingProperties_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_get_XAdESPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_set_XAdESPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_get_XAdESv141Prefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_set_XAdESv141Prefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_get_Target, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_set_Target, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_get_SignedProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_set_SignedProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignedProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_get_UnsignedProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties_set_UnsignedProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLUnsignedProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingProperties___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLQualifyingProperties_methods[] = {
	PHP_ME(TElXMLQualifyingProperties, Clear, arginfo_TElXMLQualifyingProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, IsEmpty, arginfo_TElXMLQualifyingProperties_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, LoadFromXML, arginfo_TElXMLQualifyingProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, SaveToXML, arginfo_TElXMLQualifyingProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, get_XAdESPrefix, arginfo_TElXMLQualifyingProperties_get_XAdESPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, set_XAdESPrefix, arginfo_TElXMLQualifyingProperties_set_XAdESPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, get_XAdESv141Prefix, arginfo_TElXMLQualifyingProperties_get_XAdESv141Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, set_XAdESv141Prefix, arginfo_TElXMLQualifyingProperties_set_XAdESv141Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, get_ID, arginfo_TElXMLQualifyingProperties_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, set_ID, arginfo_TElXMLQualifyingProperties_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, get_Target, arginfo_TElXMLQualifyingProperties_get_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, set_Target, arginfo_TElXMLQualifyingProperties_set_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, get_SignedProperties, arginfo_TElXMLQualifyingProperties_get_SignedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, set_SignedProperties, arginfo_TElXMLQualifyingProperties_set_SignedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, get_UnsignedProperties, arginfo_TElXMLQualifyingProperties_get_UnsignedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, set_UnsignedProperties, arginfo_TElXMLQualifyingProperties_set_UnsignedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingProperties, __construct, arginfo_TElXMLQualifyingProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLQualifyingProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLQualifyingProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLQualifyingProperties", TElXMLQualifyingProperties_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLQualifyingProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLQualifyingPropertiesReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReference_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLQualifyingPropertiesReference_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReference_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLQualifyingPropertiesReference_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1301779987, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReference_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLQualifyingPropertiesReference_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2108178241, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, set_URI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReference_set_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, get_TransformChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_get_TransformChain(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTransformChain_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, get_QualifyingProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_get_QualifyingProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, set_QualifyingProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReference_set_QualifyingProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReference, __construct)
{
	char *sAName;
	int sAName_len;
	long fAVersion;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAVersion) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_Create((TSBXAdESVersionRaw)fAVersion, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_Create_1((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsb", &fAVersion, &sAName, &sAName_len, &bSupportedV141) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReference_Create_2((TSBXAdESVersionRaw)fAVersion, sAName, (int32_t)sAName_len, (int8_t)bSupportedV141, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_set_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_get_TransformChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_get_QualifyingProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference_set_QualifyingProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReference___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AVersion)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, SupportedV141)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLQualifyingPropertiesReference_methods[] = {
	PHP_ME(TElXMLQualifyingPropertiesReference, Clear, arginfo_TElXMLQualifyingPropertiesReference_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, IsEmpty, arginfo_TElXMLQualifyingPropertiesReference_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, LoadFromXML, arginfo_TElXMLQualifyingPropertiesReference_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, SaveToXML, arginfo_TElXMLQualifyingPropertiesReference_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, get_ID, arginfo_TElXMLQualifyingPropertiesReference_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, set_ID, arginfo_TElXMLQualifyingPropertiesReference_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, get_URI, arginfo_TElXMLQualifyingPropertiesReference_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, set_URI, arginfo_TElXMLQualifyingPropertiesReference_set_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, get_TransformChain, arginfo_TElXMLQualifyingPropertiesReference_get_TransformChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, get_QualifyingProperties, arginfo_TElXMLQualifyingPropertiesReference_get_QualifyingProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, set_QualifyingProperties, arginfo_TElXMLQualifyingPropertiesReference_set_QualifyingProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReference, __construct, arginfo_TElXMLQualifyingPropertiesReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLQualifyingPropertiesReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLQualifyingPropertiesReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLQualifyingPropertiesReference", TElXMLQualifyingPropertiesReference_methods);
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	TElXMLQualifyingPropertiesReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLAdESElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLQualifyingPropertiesReferenceList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, Add)
{
	zval *oAQualifyingPropertiesRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAQualifyingPropertiesRef, TElXMLQualifyingPropertiesReference_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAQualifyingPropertiesRef TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLQualifyingPropertiesReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, Insert)
{
	long l4Index;
	zval *oAQualifyingPropertiesRef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAQualifyingPropertiesRef, TElXMLQualifyingPropertiesReference_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAQualifyingPropertiesRef TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLQualifyingPropertiesReference)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, get_QualifyingPropertiesReference)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_get_QualifyingPropertiesReference(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLQualifyingPropertiesReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLQualifyingPropertiesReferenceList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLQualifyingPropertiesReferenceList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AQualifyingPropertiesRef, TElXMLQualifyingPropertiesReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AQualifyingPropertiesRef, TElXMLQualifyingPropertiesReference, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList_get_QualifyingPropertiesReference, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLQualifyingPropertiesReferenceList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLQualifyingPropertiesReferenceList_methods[] = {
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, Add, arginfo_TElXMLQualifyingPropertiesReferenceList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, Insert, arginfo_TElXMLQualifyingPropertiesReferenceList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, Delete, arginfo_TElXMLQualifyingPropertiesReferenceList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, Clear, arginfo_TElXMLQualifyingPropertiesReferenceList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, get_Count, arginfo_TElXMLQualifyingPropertiesReferenceList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, get_QualifyingPropertiesReference, arginfo_TElXMLQualifyingPropertiesReferenceList_get_QualifyingPropertiesReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLQualifyingPropertiesReferenceList, __construct, arginfo_TElXMLQualifyingPropertiesReferenceList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLQualifyingPropertiesReferenceList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLQualifyingPropertiesReferenceList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLQualifyingPropertiesReferenceList", TElXMLQualifyingPropertiesReferenceList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLQualifyingPropertiesReferenceList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLAdES, GetXAdESVersion)
{
	char *sNamespaceURI;
	int sNamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sNamespaceURI, &sNamespaceURI_len) == SUCCESS)
	{
		TSBXAdESVersionRaw fOutResultRaw = 0;
		SBCheckError(SBXMLAdES_GetXAdESVersion(sNamespaceURI, (int32_t)sNamespaceURI_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLAdES, GetXAdESNamespaceURI)
{
	long fVersion;
	uint32_t _err;
	zend_bool bSupportedV141;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fVersion) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLAdES_GetXAdESNamespaceURI((TSBXAdESVersionRaw)fVersion, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1707148730, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &fVersion, &bSupportedV141) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLAdES_GetXAdESNamespaceURI_1((TSBXAdESVersionRaw)fVersion, (int8_t)bSupportedV141, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1088482806, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLAdES, GetXAdESReferenceType)
{
	long fVersion;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fVersion) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLAdES_GetXAdESReferenceType((TSBXAdESVersionRaw)fVersion, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1396467214, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLAdES, XAdESVersionToString)
{
	long fXAdESVersion;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fXAdESVersion) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLAdES_XAdESVersionToString((TSBXAdESVersionRaw)fXAdESVersion, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1391028805, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLAdES, XAdESFormToString)
{
	long fXAdESForm;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fXAdESForm) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLAdES_XAdESFormToString((TSBXAdESFormRaw)fXAdESForm, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(639363606, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBXMLAdES_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlPKIDataEncodingDER, SB_xmlPKIDataEncodingDER, SB_xmlPKIDataEncodingDER);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlPKIDataEncodingBER, SB_xmlPKIDataEncodingBER, SB_xmlPKIDataEncodingBER);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlPKIDataEncodingCER, SB_xmlPKIDataEncodingCER, SB_xmlPKIDataEncodingCER);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlPKIDataEncodingPER, SB_xmlPKIDataEncodingPER, SB_xmlPKIDataEncodingPER);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlPKIDataEncodingXER, SB_xmlPKIDataEncodingXER, SB_xmlPKIDataEncodingXER);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlCTIProofOfOrigin, SB_xmlCTIProofOfOrigin, SB_xmlCTIProofOfOrigin);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlCTIProofOfReceipt, SB_xmlCTIProofOfReceipt, SB_xmlCTIProofOfReceipt);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlCTIProofOfDelivery, SB_xmlCTIProofOfDelivery, SB_xmlCTIProofOfDelivery);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlCTIProofOfSender, SB_xmlCTIProofOfSender, SB_xmlCTIProofOfSender);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlCTIProofOfApproval, SB_xmlCTIProofOfApproval, SB_xmlCTIProofOfApproval);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, xmlCTIProofOfCreation, SB_xmlCTIProofOfCreation, SB_xmlCTIProofOfCreation);
	SB_REGISTER_STRING_CONSTANT(SBXMLAdES, SXMLUnsupportedXAdESForm, SB_SXMLUnsupportedXAdESForm, SB_SXMLUnsupportedXAdESForm);
}

void Register_SBXMLAdES_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBXAdESVersion", NULL);
	TSBXAdESVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESVersion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESVersion_ce_ptr, "XAdES_v1_1_1", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESVersion_ce_ptr, "XAdES_v1_2_2", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESVersion_ce_ptr, "XAdES_v1_3_2", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESVersion_ce_ptr, "XAdES_v1_4_1", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESForm", NULL);
	TSBXAdESForm_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESForm_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_BES", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_EPES", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_T", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_C", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_X", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_X_L", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESForm_ce_ptr, "XAdES_A", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESQualifierType", NULL);
	TSBXAdESQualifierType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESQualifierType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESQualifierType_ce_ptr, "xqtNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESQualifierType_ce_ptr, "xqtOIDAsURN", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESQualifierType_ce_ptr, "xqtOIDAsURI", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESEncodingMethod", NULL);
	TSBXAdESEncodingMethod_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESEncodingMethod_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESEncodingMethod_ce_ptr, "xemDER", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESEncodingMethod_ce_ptr, "xemCER", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESEncodingMethod_ce_ptr, "xemBER", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESEncodingMethod_ce_ptr, "xemPER", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESEncodingMethod_ce_ptr, "xemXER", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESResponderIDType", NULL);
	TSBXAdESResponderIDType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESResponderIDType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESResponderIDType_ce_ptr, "xrtByName", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESResponderIDType_ce_ptr, "xrtByKey", 1)
}

void Register_SBXMLAdES_Aliases(TSRMLS_D)
{
	if (NULL == TElXMLAdESElement_ce_ptr)
		Register_TElXMLAdESElement(TSRMLS_C);
	zend_register_class_alias("ElXMLAdESElement", TElXMLAdESElement_ce_ptr);
	if (NULL == TElXMLAnyType_ce_ptr)
		Register_TElXMLAnyType(TSRMLS_C);
	zend_register_class_alias("ElXMLAnyType", TElXMLAnyType_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("ElXMLAnyTypeList", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLObjectIdentifier_ce_ptr)
		Register_TElXMLObjectIdentifier(TSRMLS_C);
	zend_register_class_alias("ElXMLObjectIdentifier", TElXMLObjectIdentifier_ce_ptr);
	if (NULL == TElXMLEncapsulatedPKIData_ce_ptr)
		Register_TElXMLEncapsulatedPKIData(TSRMLS_C);
	zend_register_class_alias("ElXMLEncapsulatedPKIData", TElXMLEncapsulatedPKIData_ce_ptr);
	if (NULL == TElXMLEncapsulatedPKIDataList_ce_ptr)
		Register_TElXMLEncapsulatedPKIDataList(TSRMLS_C);
	zend_register_class_alias("ElXMLEncapsulatedPKIDataList", TElXMLEncapsulatedPKIDataList_ce_ptr);
	if (NULL == TElXMLHashDataInfo_ce_ptr)
		Register_TElXMLHashDataInfo(TSRMLS_C);
	zend_register_class_alias("ElXMLHashDataInfo", TElXMLHashDataInfo_ce_ptr);
	if (NULL == TElXMLHashDataInfoList_ce_ptr)
		Register_TElXMLHashDataInfoList(TSRMLS_C);
	zend_register_class_alias("ElXMLHashDataInfoList", TElXMLHashDataInfoList_ce_ptr);
	if (NULL == TElXMLCustomTimestamp_ce_ptr)
		Register_TElXMLCustomTimestamp(TSRMLS_C);
	zend_register_class_alias("ElXMLCustomTimestamp", TElXMLCustomTimestamp_ce_ptr);
	if (NULL == TElXMLCustomTimestampList_ce_ptr)
		Register_TElXMLCustomTimestampList(TSRMLS_C);
	zend_register_class_alias("ElXMLCustomTimestampList", TElXMLCustomTimestampList_ce_ptr);
	if (NULL == TElXMLTimestamp_ce_ptr)
		Register_TElXMLTimestamp(TSRMLS_C);
	zend_register_class_alias("ElXMLTimestamp", TElXMLTimestamp_ce_ptr);
	if (NULL == TElXMLTimestampList_ce_ptr)
		Register_TElXMLTimestampList(TSRMLS_C);
	zend_register_class_alias("ElXMLTimestampList", TElXMLTimestampList_ce_ptr);
	if (NULL == TElXMLInclude_ce_ptr)
		Register_TElXMLInclude(TSRMLS_C);
	zend_register_class_alias("ElXMLInclude", TElXMLInclude_ce_ptr);
	if (NULL == TElXMLIncludeList_ce_ptr)
		Register_TElXMLIncludeList(TSRMLS_C);
	zend_register_class_alias("ElXMLIncludeList", TElXMLIncludeList_ce_ptr);
	if (NULL == TElXMLTimestamp_v1_2_2_ce_ptr)
		Register_TElXMLTimestamp_v1_2_2(TSRMLS_C);
	zend_register_class_alias("ElXMLTimestamp_v1_2_2", TElXMLTimestamp_v1_2_2_ce_ptr);
	if (NULL == TElXMLTimestampList_v1_2_2_ce_ptr)
		Register_TElXMLTimestampList_v1_2_2(TSRMLS_C);
	zend_register_class_alias("ElXMLTimestampList_v1_2_2", TElXMLTimestampList_v1_2_2_ce_ptr);
	if (NULL == TElCustomTSPClientList_ce_ptr)
		Register_TElCustomTSPClientList(TSRMLS_C);
	zend_register_class_alias("ElCustomTSPClientList", TElCustomTSPClientList_ce_ptr);
	if (NULL == TElXMLGenericTimestamp_ce_ptr)
		Register_TElXMLGenericTimestamp(TSRMLS_C);
	zend_register_class_alias("ElXMLGenericTimestamp", TElXMLGenericTimestamp_ce_ptr);
	if (NULL == TElXMLGenericTimestampList_ce_ptr)
		Register_TElXMLGenericTimestampList(TSRMLS_C);
	zend_register_class_alias("ElXMLGenericTimestampList", TElXMLGenericTimestampList_ce_ptr);
	if (NULL == TElXMLGenericTimestamp_ce_ptr)
		Register_TElXMLGenericTimestamp(TSRMLS_C);
	zend_register_class_alias("TElXMLAdESTimestamp", TElXMLGenericTimestamp_ce_ptr);
	if (NULL == TElXMLGenericTimestamp_ce_ptr)
		Register_TElXMLGenericTimestamp(TSRMLS_C);
	zend_register_class_alias("ElXMLXAdESTimestamp", TElXMLGenericTimestamp_ce_ptr);
	if (NULL == TElXMLGenericTimestampList_ce_ptr)
		Register_TElXMLGenericTimestampList(TSRMLS_C);
	zend_register_class_alias("TElXMLAdESTimestampList", TElXMLGenericTimestampList_ce_ptr);
	if (NULL == TElXMLGenericTimestampList_ce_ptr)
		Register_TElXMLGenericTimestampList(TSRMLS_C);
	zend_register_class_alias("ElXMLXAdESTimestampList", TElXMLGenericTimestampList_ce_ptr);
	if (NULL == TElXMLDigestAlgAndValue_ce_ptr)
		Register_TElXMLDigestAlgAndValue(TSRMLS_C);
	zend_register_class_alias("ElXMLDigestAlgAndValue", TElXMLDigestAlgAndValue_ce_ptr);
	if (NULL == TElXMLCertID_ce_ptr)
		Register_TElXMLCertID(TSRMLS_C);
	zend_register_class_alias("ElXMLCertID", TElXMLCertID_ce_ptr);
	if (NULL == TElXMLCertIDList_ce_ptr)
		Register_TElXMLCertIDList(TSRMLS_C);
	zend_register_class_alias("ElXMLCertIDList", TElXMLCertIDList_ce_ptr);
	if (NULL == TElXMLNoticeReference_ce_ptr)
		Register_TElXMLNoticeReference(TSRMLS_C);
	zend_register_class_alias("ElXMLNoticeReference", TElXMLNoticeReference_ce_ptr);
	if (NULL == TElXMLSPUserNotice_ce_ptr)
		Register_TElXMLSPUserNotice(TSRMLS_C);
	zend_register_class_alias("ElXMLSPUserNotice", TElXMLSPUserNotice_ce_ptr);
	if (NULL == TElXMLSPURI_ce_ptr)
		Register_TElXMLSPURI(TSRMLS_C);
	zend_register_class_alias("ElXMLSPURI", TElXMLSPURI_ce_ptr);
	if (NULL == TElXMLSigPolicyQualifier_ce_ptr)
		Register_TElXMLSigPolicyQualifier(TSRMLS_C);
	zend_register_class_alias("ElXMLSigPolicyQualifier", TElXMLSigPolicyQualifier_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("TElXMLSigPolicyQualifierList", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("ElXMLSigPolicyQualifierList", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLSignaturePolicyId_ce_ptr)
		Register_TElXMLSignaturePolicyId(TSRMLS_C);
	zend_register_class_alias("ElXMLSignaturePolicyId", TElXMLSignaturePolicyId_ce_ptr);
	if (NULL == TElXMLSignaturePolicyIdentifier_ce_ptr)
		Register_TElXMLSignaturePolicyIdentifier(TSRMLS_C);
	zend_register_class_alias("ElXMLSignaturePolicyIdentifier", TElXMLSignaturePolicyIdentifier_ce_ptr);
	if (NULL == TElXMLCounterSignature_ce_ptr)
		Register_TElXMLCounterSignature(TSRMLS_C);
	zend_register_class_alias("ElXMLCounterSignature", TElXMLCounterSignature_ce_ptr);
	if (NULL == TElXMLCounterSignatureList_ce_ptr)
		Register_TElXMLCounterSignatureList(TSRMLS_C);
	zend_register_class_alias("ElXMLCounterSignatureList", TElXMLCounterSignatureList_ce_ptr);
	if (NULL == TElXMLDataObjectFormat_ce_ptr)
		Register_TElXMLDataObjectFormat(TSRMLS_C);
	zend_register_class_alias("ElXMLDataObjectFormat", TElXMLDataObjectFormat_ce_ptr);
	if (NULL == TElXMLDataObjectFormatList_ce_ptr)
		Register_TElXMLDataObjectFormatList(TSRMLS_C);
	zend_register_class_alias("ElXMLDataObjectFormatList", TElXMLDataObjectFormatList_ce_ptr);
	if (NULL == TElXMLCommitmentTypeQualifier_ce_ptr)
		Register_TElXMLCommitmentTypeQualifier(TSRMLS_C);
	zend_register_class_alias("ElXMLCommitmentTypeQualifier", TElXMLCommitmentTypeQualifier_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("TElXMLCommitmentTypeQualifierList", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("ElXMLCommitmentTypeQualifierList", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLCommitmentTypeIndication_ce_ptr)
		Register_TElXMLCommitmentTypeIndication(TSRMLS_C);
	zend_register_class_alias("ElXMLCommitmentTypeIndication", TElXMLCommitmentTypeIndication_ce_ptr);
	if (NULL == TElXMLCommitmentTypeIndicationList_ce_ptr)
		Register_TElXMLCommitmentTypeIndicationList(TSRMLS_C);
	zend_register_class_alias("ElXMLCommitmentTypeIndicationList", TElXMLCommitmentTypeIndicationList_ce_ptr);
	if (NULL == TElXMLSignatureProductionPlace_ce_ptr)
		Register_TElXMLSignatureProductionPlace(TSRMLS_C);
	zend_register_class_alias("ElXMLSignatureProductionPlace", TElXMLSignatureProductionPlace_ce_ptr);
	if (NULL == TElXMLEncapsulatedX509Certificates_ce_ptr)
		Register_TElXMLEncapsulatedX509Certificates(TSRMLS_C);
	zend_register_class_alias("ElXMLEncapsulatedX509Certificates", TElXMLEncapsulatedX509Certificates_ce_ptr);
	if (NULL == TElXMLCertifiedRole_ce_ptr)
		Register_TElXMLCertifiedRole(TSRMLS_C);
	zend_register_class_alias("ElXMLCertifiedRole", TElXMLCertifiedRole_ce_ptr);
	if (NULL == TElXMLCertifiedRolesList_ce_ptr)
		Register_TElXMLCertifiedRolesList(TSRMLS_C);
	zend_register_class_alias("ElXMLCertifiedRolesList", TElXMLCertifiedRolesList_ce_ptr);
	if (NULL == TElXMLClaimedRole_ce_ptr)
		Register_TElXMLClaimedRole(TSRMLS_C);
	zend_register_class_alias("ElXMLClaimedRole", TElXMLClaimedRole_ce_ptr);
	if (NULL == TElXMLClaimedRolesList_ce_ptr)
		Register_TElXMLClaimedRolesList(TSRMLS_C);
	zend_register_class_alias("ElXMLClaimedRolesList", TElXMLClaimedRolesList_ce_ptr);
	if (NULL == TElXMLSignerRole_ce_ptr)
		Register_TElXMLSignerRole(TSRMLS_C);
	zend_register_class_alias("ElXMLSignerRole", TElXMLSignerRole_ce_ptr);
	if (NULL == TElXMLCompleteCertificateRefs_ce_ptr)
		Register_TElXMLCompleteCertificateRefs(TSRMLS_C);
	zend_register_class_alias("ElXMLCompleteCertificateRefs", TElXMLCompleteCertificateRefs_ce_ptr);
	if (NULL == TElXMLCRLIdentifier_ce_ptr)
		Register_TElXMLCRLIdentifier(TSRMLS_C);
	zend_register_class_alias("ElXMLCRLIdentifier", TElXMLCRLIdentifier_ce_ptr);
	if (NULL == TElXMLCRLRef_ce_ptr)
		Register_TElXMLCRLRef(TSRMLS_C);
	zend_register_class_alias("ElXMLCRLRef", TElXMLCRLRef_ce_ptr);
	if (NULL == TElXMLCRLRefs_ce_ptr)
		Register_TElXMLCRLRefs(TSRMLS_C);
	zend_register_class_alias("ElXMLCRLRefs", TElXMLCRLRefs_ce_ptr);
	if (NULL == TElXMLOCSPIdentifier_ce_ptr)
		Register_TElXMLOCSPIdentifier(TSRMLS_C);
	zend_register_class_alias("ElXMLOCSPIdentifier", TElXMLOCSPIdentifier_ce_ptr);
	if (NULL == TElXMLOCSPRef_ce_ptr)
		Register_TElXMLOCSPRef(TSRMLS_C);
	zend_register_class_alias("ElXMLOCSPRef", TElXMLOCSPRef_ce_ptr);
	if (NULL == TElXMLOCSPRefs_ce_ptr)
		Register_TElXMLOCSPRefs(TSRMLS_C);
	zend_register_class_alias("ElXMLOCSPRefs", TElXMLOCSPRefs_ce_ptr);
	if (NULL == TElXMLOtherRef_ce_ptr)
		Register_TElXMLOtherRef(TSRMLS_C);
	zend_register_class_alias("ElXMLOtherRef", TElXMLOtherRef_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("TElXMLOtherCertStatusRefs", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("ElXMLOtherCertStatusRefs", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLCompleteRevocationRefs_ce_ptr)
		Register_TElXMLCompleteRevocationRefs(TSRMLS_C);
	zend_register_class_alias("ElXMLCompleteRevocationRefs", TElXMLCompleteRevocationRefs_ce_ptr);
	if (NULL == TElXMLCertificateValues_ce_ptr)
		Register_TElXMLCertificateValues(TSRMLS_C);
	zend_register_class_alias("ElXMLCertificateValues", TElXMLCertificateValues_ce_ptr);
	if (NULL == TElXMLEncapsulatedCRLValue_ce_ptr)
		Register_TElXMLEncapsulatedCRLValue(TSRMLS_C);
	zend_register_class_alias("ElXMLEncapsulatedCRLValue", TElXMLEncapsulatedCRLValue_ce_ptr);
	if (NULL == TElXMLCRLValues_ce_ptr)
		Register_TElXMLCRLValues(TSRMLS_C);
	zend_register_class_alias("ElXMLCRLValues", TElXMLCRLValues_ce_ptr);
	if (NULL == TElXMLEncapsulatedOCSPValue_ce_ptr)
		Register_TElXMLEncapsulatedOCSPValue(TSRMLS_C);
	zend_register_class_alias("ElXMLEncapsulatedOCSPValue", TElXMLEncapsulatedOCSPValue_ce_ptr);
	if (NULL == TElXMLOCSPValues_ce_ptr)
		Register_TElXMLOCSPValues(TSRMLS_C);
	zend_register_class_alias("ElXMLOCSPValues", TElXMLOCSPValues_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("TElXMLOtherCertStatusValues", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("ElXMLOtherCertStatusValues", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLRevocationValues_ce_ptr)
		Register_TElXMLRevocationValues(TSRMLS_C);
	zend_register_class_alias("ElXMLRevocationValues", TElXMLRevocationValues_ce_ptr);
	if (NULL == TElXMLTimeStampValidationData_ce_ptr)
		Register_TElXMLTimeStampValidationData(TSRMLS_C);
	zend_register_class_alias("ElXMLTimeStampValidationData", TElXMLTimeStampValidationData_ce_ptr);
	if (NULL == TElXMLTimeStampValidationDataList_ce_ptr)
		Register_TElXMLTimeStampValidationDataList(TSRMLS_C);
	zend_register_class_alias("ElXMLTimeStampValidationDataList", TElXMLTimeStampValidationDataList_ce_ptr);
	if (NULL == TElXMLSignedDataObjectProperties_ce_ptr)
		Register_TElXMLSignedDataObjectProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLSignedDataObjectProperties", TElXMLSignedDataObjectProperties_ce_ptr);
	if (NULL == TElXMLUnsignedDataObjectProperty_ce_ptr)
		Register_TElXMLUnsignedDataObjectProperty(TSRMLS_C);
	zend_register_class_alias("ElXMLUnsignedDataObjectProperty", TElXMLUnsignedDataObjectProperty_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("TElXMLUnsignedDataObjectProperties", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLAnyTypeList_ce_ptr)
		Register_TElXMLAnyTypeList(TSRMLS_C);
	zend_register_class_alias("ElXMLUnsignedDataObjectProperties", TElXMLAnyTypeList_ce_ptr);
	if (NULL == TElXMLSignedSignatureProperties_ce_ptr)
		Register_TElXMLSignedSignatureProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLSignedSignatureProperties", TElXMLSignedSignatureProperties_ce_ptr);
	if (NULL == TElXMLUnsignedSignatureProperties_ce_ptr)
		Register_TElXMLUnsignedSignatureProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLUnsignedSignatureProperties", TElXMLUnsignedSignatureProperties_ce_ptr);
	if (NULL == TElXMLSignedProperties_ce_ptr)
		Register_TElXMLSignedProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLSignedProperties", TElXMLSignedProperties_ce_ptr);
	if (NULL == TElXMLUnsignedProperties_ce_ptr)
		Register_TElXMLUnsignedProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLUnsignedProperties", TElXMLUnsignedProperties_ce_ptr);
	if (NULL == TElXMLQualifyingProperties_ce_ptr)
		Register_TElXMLQualifyingProperties(TSRMLS_C);
	zend_register_class_alias("ElXMLQualifyingProperties", TElXMLQualifyingProperties_ce_ptr);
	if (NULL == TElXMLQualifyingPropertiesReference_ce_ptr)
		Register_TElXMLQualifyingPropertiesReference(TSRMLS_C);
	zend_register_class_alias("ElXMLQualifyingPropertiesReference", TElXMLQualifyingPropertiesReference_ce_ptr);
	if (NULL == TElXMLQualifyingPropertiesReferenceList_ce_ptr)
		Register_TElXMLQualifyingPropertiesReferenceList(TSRMLS_C);
	zend_register_class_alias("ElXMLQualifyingPropertiesReferenceList", TElXMLQualifyingPropertiesReferenceList_ce_ptr);
}

