#include "sbxmlcore.h"

zend_class_entry *TElXMLDelayLoadModeType_ce_ptr = NULL;

zend_class_entry *TElXMLDelayLoadMode_ce_ptr = NULL;

zend_class_entry *TElXMLDOMImplementation_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMImplementation, HasFeature)
{
	char *sFeature;
	char *sVersion;
	int sFeature_len;
	int sVersion_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFeature, &sFeature_len, &sVersion, &sVersion_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMImplementation_HasFeature(SBGetObjectHandle(getThis() TSRMLS_CC), sFeature, (int32_t)sFeature_len, sVersion, (int32_t)sVersion_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMImplementation, CreateDocumentType)
{
	char *sInternalSubset;
	char *sPublicID;
	char *sQualifiedName;
	char *sSystemID;
	int sInternalSubset_len;
	int sPublicID_len;
	int sQualifiedName_len;
	int sSystemID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sQualifiedName, &sQualifiedName_len, &sPublicID, &sPublicID_len, &sSystemID, &sSystemID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMImplementation_CreateDocumentType(SBGetObjectHandle(getThis() TSRMLS_CC), sQualifiedName, (int32_t)sQualifiedName_len, sPublicID, (int32_t)sPublicID_len, sSystemID, (int32_t)sSystemID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocumentType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssss", &sQualifiedName, &sQualifiedName_len, &sPublicID, &sPublicID_len, &sSystemID, &sSystemID_len, &sInternalSubset, &sInternalSubset_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMImplementation_CreateDocumentType_1(SBGetObjectHandle(getThis() TSRMLS_CC), sQualifiedName, (int32_t)sQualifiedName_len, sPublicID, (int32_t)sPublicID_len, sSystemID, (int32_t)sSystemID_len, sInternalSubset, (int32_t)sInternalSubset_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocumentType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string) or (string, string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMImplementation, CreateDocument)
{
	char *sNamespaceURI;
	char *sQualifiedName;
	int sNamespaceURI_len;
	int sQualifiedName_len;
	zval *oDocType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sNamespaceURI, &sNamespaceURI_len, &sQualifiedName, &sQualifiedName_len, &oDocType, TElXMLDOMDocumentType_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMImplementation_CreateDocument(SBGetObjectHandle(getThis() TSRMLS_CC), sNamespaceURI, (int32_t)sNamespaceURI_len, sQualifiedName, (int32_t)sQualifiedName_len, SBGetObjectHandle(oDocType TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElXMLDOMDocumentType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMImplementation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMImplementation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMImplementation_HasFeature, 0, 0, 2)
	ZEND_ARG_INFO(0, Feature)
	ZEND_ARG_INFO(0, Version)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMImplementation_CreateDocumentType, 0, 0, 3)
	ZEND_ARG_INFO(0, QualifiedName)
	ZEND_ARG_INFO(0, PublicID)
	ZEND_ARG_INFO(0, SystemID)
	ZEND_ARG_INFO(0, InternalSubset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMImplementation_CreateDocument, 0, 0, 3)
	ZEND_ARG_INFO(0, NamespaceURI)
	ZEND_ARG_INFO(0, QualifiedName)
	ZEND_ARG_OBJ_INFO(0, DocType, TElXMLDOMDocumentType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMImplementation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMImplementation_methods[] = {
	PHP_ME(TElXMLDOMImplementation, HasFeature, arginfo_TElXMLDOMImplementation_HasFeature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMImplementation, CreateDocumentType, arginfo_TElXMLDOMImplementation_CreateDocumentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMImplementation, CreateDocument, arginfo_TElXMLDOMImplementation_CreateDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMImplementation, __construct, arginfo_TElXMLDOMImplementation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMImplementation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMImplementation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMImplementation", TElXMLDOMImplementation_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLDOMImplementation_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMNode_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMNode, ReloadData)
{
	long fLoadedData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fLoadedData) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_ReloadData(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDelayLoadModeRaw)fLoadedData, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, UnloadData)
{
	long fDataToUnload;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDataToUnload) == SUCCESS)
	{
		SBCheckError(TElXMLDOMNode_UnloadData(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDelayLoadModeRaw)fDataToUnload) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, GetOuterXMLCanonical)
{
	char *sInclNSPrefixList;
	int sInclNSPrefixList_len;
	long faMethod;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &faMethod) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_GetOuterXMLCanonical(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(31459282, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &faMethod, &sInclNSPrefixList, &sInclNSPrefixList_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_GetOuterXMLCanonical_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, sInclNSPrefixList, (int32_t)sInclNSPrefixList_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-637201611, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, SelectNodes)
{
	char *sXPath;
	int sXPath_len;
	zval *oNSMap;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sXPath, &sXPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_SelectNodes(SBGetObjectHandle(getThis() TSRMLS_CC), sXPath, (int32_t)sXPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLNodeSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sXPath, &sXPath_len, &oNSMap, TElXMLNamespaceMap_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_SelectNodes_1(SBGetObjectHandle(getThis() TSRMLS_CC), sXPath, (int32_t)sXPath_len, SBGetObjectHandle(oNSMap TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLNodeSet_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, TElXMLNamespaceMap)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, InsertBefore)
{
	zval *oNewChild;
	zval *oRefChild;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oNewChild, TElXMLDOMNode_ce_ptr, &oRefChild, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_InsertBefore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewChild TSRMLS_CC), SBGetObjectHandle(oRefChild TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, ReplaceChild)
{
	zval *oNewChild;
	zval *oOldChild;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oNewChild, TElXMLDOMNode_ce_ptr, &oOldChild, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_ReplaceChild(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewChild TSRMLS_CC), SBGetObjectHandle(oOldChild TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, RemoveChild)
{
	zval *oOldChild;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOldChild, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDOMNode_RemoveChild(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOldChild TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, AppendChild)
{
	zend_bool bDisablePrefixUpdate;
	zval *oNewChild;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewChild, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_AppendChild(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewChild TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oNewChild, TElXMLDOMNode_ce_ptr, &bDisablePrefixUpdate) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_AppendChild_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewChild TSRMLS_CC), (int8_t)bDisablePrefixUpdate, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode) or (TElXMLDOMNode, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, HasChildNodes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_HasChildNodes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (bool, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, Normalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDOMNode_Normalize(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, HasAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_HasAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, isSupported)
{
	char *sFeature;
	char *sVersion;
	int sFeature_len;
	int sVersion_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFeature, &sFeature_len, &sVersion, &sVersion_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_isSupported(SBGetObjectHandle(getThis() TSRMLS_CC), sFeature, (int32_t)sFeature_len, sVersion, (int32_t)sVersion_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, FindNode)
{
	char *saNodeName;
	int saNodeName_len;
	zend_bool bDeep;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saNodeName, &saNodeName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_FindNode(SBGetObjectHandle(getThis() TSRMLS_CC), saNodeName, (int32_t)saNodeName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &saNodeName, &saNodeName_len, &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_FindNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), saNodeName, (int32_t)saNodeName_len, (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_RelativeIndex)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_get_RelativeIndex(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_NodeName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_get_NodeName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1415144006, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_NodeValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_get_NodeValue(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(223858173, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, set_NodeValue)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMNode_set_NodeValue(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_NodeType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_get_NodeType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_ParentNode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_ParentNode(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_FirstChild)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_FirstChild(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_LastChild)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_LastChild(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_ChildNodes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_ChildNodes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_PreviousSibling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_PreviousSibling(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_NextSibling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_NextSibling(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNamedNodeMap_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_OwnerDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_get_OwnerDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_RawData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLDOMNode_get_RawData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-553059733, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_RawDataLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_get_RawDataLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_Loaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMNode_get_Loaded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_OuterXML)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_get_OuterXML(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-519734793, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_NamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_get_NamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1457466651, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_LocalName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_get_LocalName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-460026458, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, get_Prefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNode_get_Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(36384557, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNode, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNode_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_ReloadData, 0, 0, 1)
	ZEND_ARG_INFO(0, LoadedData)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_UnloadData, 0, 0, 1)
	ZEND_ARG_INFO(0, DataToUnload)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_GetOuterXMLCanonical, 0, 0, 1)
	ZEND_ARG_INFO(0, aMethod)
	ZEND_ARG_INFO(0, InclNSPrefixList)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_SelectNodes, 0, 0, 1)
	ZEND_ARG_INFO(0, XPath)
	ZEND_ARG_OBJ_INFO(0, NSMap, TElXMLNamespaceMap, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_InsertBefore, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, NewChild, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, RefChild, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_ReplaceChild, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, NewChild, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, OldChild, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_RemoveChild, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OldChild, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_AppendChild, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewChild, TElXMLDOMNode, 1)
	ZEND_ARG_INFO(0, DisablePrefixUpdate)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_HasChildNodes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_Normalize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_HasAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_isSupported, 0, 0, 2)
	ZEND_ARG_INFO(0, Feature)
	ZEND_ARG_INFO(0, Version)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_FindNode, 0, 0, 1)
	ZEND_ARG_INFO(0, aNodeName)
	ZEND_ARG_INFO(0, Deep)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_RelativeIndex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_NodeName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_NodeValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_set_NodeValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_NodeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_ParentNode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_FirstChild, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_LastChild, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_ChildNodes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_PreviousSibling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_NextSibling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_OwnerDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_RawData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_RawDataLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_Loaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_OuterXML, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_NamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_LocalName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode_get_Prefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNode___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMNode_methods[] = {
	PHP_ME(TElXMLDOMNode, ReloadData, arginfo_TElXMLDOMNode_ReloadData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, UnloadData, arginfo_TElXMLDOMNode_UnloadData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, GetOuterXMLCanonical, arginfo_TElXMLDOMNode_GetOuterXMLCanonical, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, SelectNodes, arginfo_TElXMLDOMNode_SelectNodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, InsertBefore, arginfo_TElXMLDOMNode_InsertBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, ReplaceChild, arginfo_TElXMLDOMNode_ReplaceChild, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, RemoveChild, arginfo_TElXMLDOMNode_RemoveChild, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, AppendChild, arginfo_TElXMLDOMNode_AppendChild, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, HasChildNodes, arginfo_TElXMLDOMNode_HasChildNodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, CloneNode, arginfo_TElXMLDOMNode_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, Normalize, arginfo_TElXMLDOMNode_Normalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, HasAttributes, arginfo_TElXMLDOMNode_HasAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, isSupported, arginfo_TElXMLDOMNode_isSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, FindNode, arginfo_TElXMLDOMNode_FindNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_RelativeIndex, arginfo_TElXMLDOMNode_get_RelativeIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_NodeName, arginfo_TElXMLDOMNode_get_NodeName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_NodeValue, arginfo_TElXMLDOMNode_get_NodeValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, set_NodeValue, arginfo_TElXMLDOMNode_set_NodeValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_NodeType, arginfo_TElXMLDOMNode_get_NodeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_ParentNode, arginfo_TElXMLDOMNode_get_ParentNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_FirstChild, arginfo_TElXMLDOMNode_get_FirstChild, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_LastChild, arginfo_TElXMLDOMNode_get_LastChild, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_ChildNodes, arginfo_TElXMLDOMNode_get_ChildNodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_PreviousSibling, arginfo_TElXMLDOMNode_get_PreviousSibling, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_NextSibling, arginfo_TElXMLDOMNode_get_NextSibling, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_Attributes, arginfo_TElXMLDOMNode_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_OwnerDocument, arginfo_TElXMLDOMNode_get_OwnerDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_RawData, arginfo_TElXMLDOMNode_get_RawData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_RawDataLength, arginfo_TElXMLDOMNode_get_RawDataLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_Loaded, arginfo_TElXMLDOMNode_get_Loaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_OuterXML, arginfo_TElXMLDOMNode_get_OuterXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_NamespaceURI, arginfo_TElXMLDOMNode_get_NamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_LocalName, arginfo_TElXMLDOMNode_get_LocalName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, get_Prefix, arginfo_TElXMLDOMNode_get_Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNode, __construct, arginfo_TElXMLDOMNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMNode", TElXMLDOMNode_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLDOMNode_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMDocument, LoadFromStream)
{
	char *sDefaultEncoding;
	int sDefaultEncoding_len;
	long fDataToLoad;
	zend_bool bNormalizeNEL;
	zend_bool bOwnStream;
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oaStream, TStream_ce_ptr, &sDefaultEncoding, &sDefaultEncoding_len, &bNormalizeNEL) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC), sDefaultEncoding, (int32_t)sDefaultEncoding_len, (int8_t)bNormalizeNEL) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bl", &oaStream, TStream_ce_ptr, &bOwnStream, &fDataToLoad) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromStream_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC), (int8_t)bOwnStream, (TElXMLDelayLoadModeRaw)fDataToLoad) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!blsb", &oaStream, TStream_ce_ptr, &bOwnStream, &fDataToLoad, &sDefaultEncoding, &sDefaultEncoding_len, &bNormalizeNEL) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromStream_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC), (int8_t)bOwnStream, (TElXMLDelayLoadModeRaw)fDataToLoad, sDefaultEncoding, (int32_t)sDefaultEncoding_len, (int8_t)bNormalizeNEL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, string, bool) or (TStream, bool, integer) or (TStream, bool, integer, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, SaveToStream)
{
	char *saCharset;
	int saCharset_len;
	long faMethod;
	zval *oaEncoding;
	zval *oaStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oaStream, TStream_ce_ptr, &faMethod, &oaEncoding, TElXMLCodec_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_SaveToStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, SBGetObjectHandle(oaEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oaStream, TStream_ce_ptr, &faMethod, &saCharset, &saCharset_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_SaveToStream_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaStream TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, saCharset, (int32_t)saCharset_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, integer, TElXMLCodec) or (TStream, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, LoadFromFile)
{
	char *saFileName;
	char *sDefaultEncoding;
	int saFileName_len;
	int sDefaultEncoding_len;
	long fDataToLoad;
	zend_bool bNormalizeNEL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saFileName, &saFileName_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), saFileName, (int32_t)saFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &saFileName, &saFileName_len, &sDefaultEncoding, &sDefaultEncoding_len, &bNormalizeNEL) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), saFileName, (int32_t)saFileName_len, sDefaultEncoding, (int32_t)sDefaultEncoding_len, (int8_t)bNormalizeNEL) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &saFileName, &saFileName_len, &fDataToLoad) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromFile_2(SBGetObjectHandle(getThis() TSRMLS_CC), saFileName, (int32_t)saFileName_len, (TElXMLDelayLoadModeRaw)fDataToLoad) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slsb", &saFileName, &saFileName_len, &fDataToLoad, &sDefaultEncoding, &sDefaultEncoding_len, &bNormalizeNEL) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_LoadFromFile_3(SBGetObjectHandle(getThis() TSRMLS_CC), saFileName, (int32_t)saFileName_len, (TElXMLDelayLoadModeRaw)fDataToLoad, sDefaultEncoding, (int32_t)sDefaultEncoding_len, (int8_t)bNormalizeNEL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string, bool) or (string, integer) or (string, integer, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, SaveToFile)
{
	char *saFileName;
	int saFileName_len;
	long faMethod;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saFileName, &saFileName_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), saFileName, (int32_t)saFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &saFileName, &saFileName_len, &faMethod) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_SaveToFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), saFileName, (int32_t)saFileName_len, (TElXMLCanonicalizationMethodRaw)faMethod) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, ReloadAll)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_ReloadAll(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, LookupEntityByRef)
{
	char *saRef;
	int saRef_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saRef, &saRef_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocument_LookupEntityByRef(SBGetObjectHandle(getThis() TSRMLS_CC), saRef, (int32_t)saRef_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1045003991, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateElement)
{
	char *sTagName;
	int sTagName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sTagName, &sTagName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateElement(SBGetObjectHandle(getThis() TSRMLS_CC), sTagName, (int32_t)sTagName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateDocumentFragment)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateDocumentFragment(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocumentFragment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateTextNode)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateTextNode(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMText_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateComment)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateComment(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateAttribute)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, GetElementsByTagName)
{
	char *sTagName;
	int sTagName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sTagName, &sTagName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_GetElementsByTagName(SBGetObjectHandle(getThis() TSRMLS_CC), sTagName, (int32_t)sTagName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, ImportNode)
{
	zend_bool bDeep;
	zval *oaNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oaNode, TElXMLDOMNode_ce_ptr, &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_ImportNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaNode TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateElementNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateElementNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateAttributeNS)
{
	char *saName;
	char *saNSURi;
	int saName_len;
	int saNSURi_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURi, &saNSURi_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateAttributeNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURi, (int32_t)saNSURi_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, GetElementsByTagNameNS)
{
	char *saName;
	char *saNSURi;
	int saName_len;
	int saNSURi_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURi, &saNSURi_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_GetElementsByTagNameNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURi, (int32_t)saNSURi_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, GetElementByID)
{
	char *saElementID;
	int saElementID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saElementID, &saElementID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_GetElementByID(SBGetObjectHandle(getThis() TSRMLS_CC), saElementID, (int32_t)saElementID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateEntity)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateEntity(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateCDATASection)
{
	char *sData;
	int sData_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateCDATASection(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMCDATASection_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateProcessingInstruction)
{
	char *sData;
	char *sTarget;
	int sData_len;
	int sTarget_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sTarget, &sTarget_len, &sData, &sData_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateProcessingInstruction(SBGetObjectHandle(getThis() TSRMLS_CC), sTarget, (int32_t)sTarget_len, sData, (int32_t)sData_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMProcessingInstruction_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, CreateEntityReference)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_CreateEntityReference(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMEntityReference_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, get_DocumentType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_get_DocumentType(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocumentType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, get_Impl)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_get_Impl(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMImplementation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, get_DocumentElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_get_DocumentElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, get_XmlNS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_get_XmlNS(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, get_OriginalEncoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocument_get_OriginalEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(932249875, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, get_Version)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocument_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-936656825, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, set_Version)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocument_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocument, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocument_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
	ZEND_ARG_INFO(0, DefaultEncoding_or_OwnStream)
	ZEND_ARG_INFO(0, NormalizeNEL_or_DataToLoad)
	ZEND_ARG_INFO(0, DefaultEncoding)
	ZEND_ARG_INFO(0, NormalizeNEL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aStream, TStream, 1)
	ZEND_ARG_INFO(0, aMethod)
	ZEND_ARG_TYPE_INFO(0, aEncoding_or_aCharset, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, aFileName)
	ZEND_ARG_INFO(0, DefaultEncoding_or_DataToLoad)
	ZEND_ARG_INFO(0, NormalizeNEL_or_DefaultEncoding)
	ZEND_ARG_INFO(0, NormalizeNEL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_SaveToFile, 0, 0, 1)
	ZEND_ARG_INFO(0, aFileName)
	ZEND_ARG_INFO(0, aMethod)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_ReloadAll, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_LookupEntityByRef, 0, 0, 1)
	ZEND_ARG_INFO(0, aRef)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateElement, 0, 0, 1)
	ZEND_ARG_INFO(0, TagName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateDocumentFragment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateTextNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateComment, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_GetElementsByTagName, 0, 0, 1)
	ZEND_ARG_INFO(0, TagName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_ImportNode, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, aNode, TElXMLDOMNode, 1)
	ZEND_ARG_INFO(0, Deep)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateElementNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateAttributeNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURi)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_GetElementsByTagNameNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURi)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_GetElementByID, 0, 0, 1)
	ZEND_ARG_INFO(0, aElementID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateEntity, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateCDATASection, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateProcessingInstruction, 0, 0, 2)
	ZEND_ARG_INFO(0, Target)
	ZEND_ARG_INFO(0, Data)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_CreateEntityReference, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_get_DocumentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_get_Impl, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_get_DocumentElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_get_XmlNS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_get_OriginalEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocument___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMDocument_methods[] = {
	PHP_ME(TElXMLDOMDocument, LoadFromStream, arginfo_TElXMLDOMDocument_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, SaveToStream, arginfo_TElXMLDOMDocument_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, LoadFromFile, arginfo_TElXMLDOMDocument_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, SaveToFile, arginfo_TElXMLDOMDocument_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, ReloadAll, arginfo_TElXMLDOMDocument_ReloadAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, LookupEntityByRef, arginfo_TElXMLDOMDocument_LookupEntityByRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateElement, arginfo_TElXMLDOMDocument_CreateElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateDocumentFragment, arginfo_TElXMLDOMDocument_CreateDocumentFragment, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateTextNode, arginfo_TElXMLDOMDocument_CreateTextNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateComment, arginfo_TElXMLDOMDocument_CreateComment, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateAttribute, arginfo_TElXMLDOMDocument_CreateAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, GetElementsByTagName, arginfo_TElXMLDOMDocument_GetElementsByTagName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, ImportNode, arginfo_TElXMLDOMDocument_ImportNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateElementNS, arginfo_TElXMLDOMDocument_CreateElementNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateAttributeNS, arginfo_TElXMLDOMDocument_CreateAttributeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, GetElementsByTagNameNS, arginfo_TElXMLDOMDocument_GetElementsByTagNameNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, GetElementByID, arginfo_TElXMLDOMDocument_GetElementByID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateEntity, arginfo_TElXMLDOMDocument_CreateEntity, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateCDATASection, arginfo_TElXMLDOMDocument_CreateCDATASection, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateProcessingInstruction, arginfo_TElXMLDOMDocument_CreateProcessingInstruction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, CreateEntityReference, arginfo_TElXMLDOMDocument_CreateEntityReference, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, get_DocumentType, arginfo_TElXMLDOMDocument_get_DocumentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, get_Impl, arginfo_TElXMLDOMDocument_get_Impl, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, get_DocumentElement, arginfo_TElXMLDOMDocument_get_DocumentElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, get_XmlNS, arginfo_TElXMLDOMDocument_get_XmlNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, get_OriginalEncoding, arginfo_TElXMLDOMDocument_get_OriginalEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, get_Version, arginfo_TElXMLDOMDocument_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, set_Version, arginfo_TElXMLDOMDocument_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocument, __construct, arginfo_TElXMLDOMDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMDocument", TElXMLDOMDocument_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMDocument_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMDocumentFragment_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMDocumentFragment, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocumentFragment_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentFragment___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMDocumentFragment_methods[] = {
	PHP_ME(TElXMLDOMDocumentFragment, __construct, arginfo_TElXMLDOMDocumentFragment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMDocumentFragment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMDocumentFragment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMDocumentFragment", TElXMLDOMDocumentFragment_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMDocumentFragment_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLNodeSet_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLNodeSet, Add)
{
	zval *oANode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oANode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLNodeSet_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oANode TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, Insert)
{
	long l4Index;
	zval *oANode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oANode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLNodeSet_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oANode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLNodeSet_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLNodeSet_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, HasNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLNodeSet_HasNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, IndexOf)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLNodeSet_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLNodeSet_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, get_Node)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNodeSet_get_Node(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, get_OwnNodes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLNodeSet_get_OwnNodes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, set_OwnNodes)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLNodeSet_set_OwnNodes(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNodeSet, __construct)
{
	zend_bool bAOwnNodes;
	zval *oNodeList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnNodes) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNodeSet_Create((int8_t)bAOwnNodes, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNodeList, TElXMLDOMNodeList_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNodeSet_Create_1(SBGetObjectHandle(oNodeList TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or (TElXMLDOMNodeList)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ANode, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ANode, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_HasNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_IndexOf, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_get_Node, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_get_OwnNodes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet_set_OwnNodes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNodeSet___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwnNodes_or_NodeList, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLNodeSet_methods[] = {
	PHP_ME(TElXMLNodeSet, Add, arginfo_TElXMLNodeSet_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, Insert, arginfo_TElXMLNodeSet_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, Delete, arginfo_TElXMLNodeSet_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, Clear, arginfo_TElXMLNodeSet_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, HasNode, arginfo_TElXMLNodeSet_HasNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, IndexOf, arginfo_TElXMLNodeSet_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, get_Count, arginfo_TElXMLNodeSet_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, get_Node, arginfo_TElXMLNodeSet_get_Node, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, get_OwnNodes, arginfo_TElXMLNodeSet_get_OwnNodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, set_OwnNodes, arginfo_TElXMLNodeSet_set_OwnNodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNodeSet, __construct, arginfo_TElXMLNodeSet___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLNodeSet(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLNodeSet_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLNodeSet", TElXMLNodeSet_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLNodeSet_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMNodeList_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMNodeList, get_Item)
{
	long l4index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNodeList_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNodeList, get_Length)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDOMNodeList_get_Length(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNodeList, __construct)
{
	char *saFilter;
	char *saNSURI;
	int saFilter_len;
	int saNSURI_len;
	zend_bool baOwnNode;
	zval *oaNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oaNode, TElXMLDOMNode_ce_ptr, &baOwnNode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNodeList_Create(SBGetObjectHandle(oaNode TSRMLS_CC), (int8_t)baOwnNode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oaNode, TElXMLDOMNode_ce_ptr, &saFilter, &saFilter_len, &baOwnNode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNodeList_Create_1(SBGetObjectHandle(oaNode TSRMLS_CC), saFilter, (int32_t)saFilter_len, (int8_t)baOwnNode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssb", &oaNode, TElXMLDOMNode_ce_ptr, &saNSURI, &saNSURI_len, &saFilter, &saFilter_len, &baOwnNode) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNodeList_Create_2(SBGetObjectHandle(oaNode TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saFilter, (int32_t)saFilter_len, (int8_t)baOwnNode, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode, bool) or (TElXMLDOMNode, string, bool) or (TElXMLDOMNode, string, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNodeList_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNodeList_get_Length, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNodeList___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, aNode, TElXMLDOMNode, 1)
	ZEND_ARG_INFO(0, aOwnNode_or_aFilter_or_aNSURI)
	ZEND_ARG_INFO(0, aOwnNode_or_aFilter)
	ZEND_ARG_INFO(0, aOwnNode)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMNodeList_methods[] = {
	PHP_ME(TElXMLDOMNodeList, get_Item, arginfo_TElXMLDOMNodeList_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNodeList, get_Length, arginfo_TElXMLDOMNodeList_get_Length, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNodeList, __construct, arginfo_TElXMLDOMNodeList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMNodeList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMNodeList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMNodeList", TElXMLDOMNodeList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLDOMNodeList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMNamedNodeMap_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLDOMNamedNodeMap_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, GetNamedItem)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_GetNamedItem(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, SetNamedItem)
{
	zval *oarg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oarg, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_SetNamedItem(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oarg TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, RemoveNamedItem)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_RemoveNamedItem(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, GetNamedItemNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_GetNamedItemNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, SetNamedItemNS)
{
	zval *oarg;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oarg, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_SetNamedItemNS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oarg TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, RemoveNamedItemNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_RemoveNamedItemNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, get_Item)
{
	long l4index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, set_Item)
{
	long l4index;
	zval *oaItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4index, &oaItem, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLDOMNamedNodeMap_set_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4index, SBGetObjectHandle(oaItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, get_Length)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDOMNamedNodeMap_get_Length(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNamedNodeMap, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNamedNodeMap_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_GetNamedItem, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_SetNamedItem, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, arg, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_RemoveNamedItem, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_GetNamedItemNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_SetNamedItemNS, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, arg, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_RemoveNamedItemNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_set_Item, 0, 0, 2)
	ZEND_ARG_INFO(0, index)
	ZEND_ARG_OBJ_INFO(0, aItem, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap_get_Length, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNamedNodeMap___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMNamedNodeMap_methods[] = {
	PHP_ME(TElXMLDOMNamedNodeMap, Clear, arginfo_TElXMLDOMNamedNodeMap_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, GetNamedItem, arginfo_TElXMLDOMNamedNodeMap_GetNamedItem, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, SetNamedItem, arginfo_TElXMLDOMNamedNodeMap_SetNamedItem, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, RemoveNamedItem, arginfo_TElXMLDOMNamedNodeMap_RemoveNamedItem, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, GetNamedItemNS, arginfo_TElXMLDOMNamedNodeMap_GetNamedItemNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, SetNamedItemNS, arginfo_TElXMLDOMNamedNodeMap_SetNamedItemNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, RemoveNamedItemNS, arginfo_TElXMLDOMNamedNodeMap_RemoveNamedItemNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, get_Item, arginfo_TElXMLDOMNamedNodeMap_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, set_Item, arginfo_TElXMLDOMNamedNodeMap_set_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, get_Length, arginfo_TElXMLDOMNamedNodeMap_get_Length, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNamedNodeMap, __construct, arginfo_TElXMLDOMNamedNodeMap___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMNamedNodeMap(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMNamedNodeMap_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMNamedNodeMap", TElXMLDOMNamedNodeMap_methods);
	if (NULL == TList_ce_ptr)
		Register_TList(TSRMLS_C);
	TElXMLDOMNamedNodeMap_ce_ptr = zend_register_internal_class_ex(&ce, TList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMCharacterData_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMCharacterData, UnloadData)
{
	long fDataToUnload;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDataToUnload) == SUCCESS)
	{
		SBCheckError(TElXMLDOMCharacterData_UnloadData(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDelayLoadModeRaw)fDataToUnload) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, SubstringData)
{
	long l4len;
	long l4ofs;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4ofs, &l4len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMCharacterData_SubstringData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ofs, (int32_t)l4len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(88213114, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, AppendData)
{
	char *sarg;
	int sarg_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sarg, &sarg_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMCharacterData_AppendData(SBGetObjectHandle(getThis() TSRMLS_CC), sarg, (int32_t)sarg_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, InsertData)
{
	char *sarg;
	int sarg_len;
	long l4ofs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4ofs, &sarg, &sarg_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMCharacterData_InsertData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ofs, sarg, (int32_t)sarg_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, DeleteData)
{
	long l4len;
	long l4ofs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4ofs, &l4len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMCharacterData_DeleteData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ofs, (int32_t)l4len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, ReplaceData)
{
	char *sarg;
	int sarg_len;
	long l4len;
	long l4ofs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lls", &l4ofs, &l4len, &sarg, &sarg_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMCharacterData_ReplaceData(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ofs, (int32_t)l4len, sarg, (int32_t)sarg_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMCharacterData_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(535713726, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, get_Length)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLDOMCharacterData_get_Length(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCharacterData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMCharacterData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_UnloadData, 0, 0, 1)
	ZEND_ARG_INFO(0, DataToUnload)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_SubstringData, 0, 0, 2)
	ZEND_ARG_INFO(0, ofs)
	ZEND_ARG_INFO(0, len)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_AppendData, 0, 0, 1)
	ZEND_ARG_INFO(0, arg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_InsertData, 0, 0, 2)
	ZEND_ARG_INFO(0, ofs)
	ZEND_ARG_INFO(0, arg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_DeleteData, 0, 0, 2)
	ZEND_ARG_INFO(0, ofs)
	ZEND_ARG_INFO(0, len)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_ReplaceData, 0, 0, 3)
	ZEND_ARG_INFO(0, ofs)
	ZEND_ARG_INFO(0, len)
	ZEND_ARG_INFO(0, arg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData_get_Length, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCharacterData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMCharacterData_methods[] = {
	PHP_ME(TElXMLDOMCharacterData, UnloadData, arginfo_TElXMLDOMCharacterData_UnloadData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, SubstringData, arginfo_TElXMLDOMCharacterData_SubstringData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, AppendData, arginfo_TElXMLDOMCharacterData_AppendData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, InsertData, arginfo_TElXMLDOMCharacterData_InsertData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, DeleteData, arginfo_TElXMLDOMCharacterData_DeleteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, ReplaceData, arginfo_TElXMLDOMCharacterData_ReplaceData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, get_Data, arginfo_TElXMLDOMCharacterData_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, get_Length, arginfo_TElXMLDOMCharacterData_get_Length, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCharacterData, __construct, arginfo_TElXMLDOMCharacterData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMCharacterData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMCharacterData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMCharacterData", TElXMLDOMCharacterData_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMCharacterData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMAttr_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMAttr, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMAttr_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMAttr_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMAttr, get_Quote)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMAttr_get_Quote(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(340860583, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMAttr, set_Quote)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMAttr_set_Quote(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMAttr, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMAttr_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1649904999, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMAttr, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMAttr_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMAttr, get_OwnerElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMAttr_get_OwnerElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMAttr, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMAttr_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr_get_Quote, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr_set_Quote, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr_get_OwnerElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMAttr___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMAttr_methods[] = {
	PHP_ME(TElXMLDOMAttr, CloneNode, arginfo_TElXMLDOMAttr_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMAttr, get_Quote, arginfo_TElXMLDOMAttr_get_Quote, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMAttr, set_Quote, arginfo_TElXMLDOMAttr_set_Quote, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMAttr, get_Value, arginfo_TElXMLDOMAttr_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMAttr, set_Value, arginfo_TElXMLDOMAttr_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMAttr, get_OwnerElement, arginfo_TElXMLDOMAttr_get_OwnerElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMAttr, __construct, arginfo_TElXMLDOMAttr___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMAttr(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMAttr_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMAttr", TElXMLDOMAttr_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMAttr_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMElement_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMElement, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, RemoveAttribute)
{
	char *saName;
	int saName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saName, &saName_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_RemoveAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetAttributeNode)
{
	char *saName;
	int saName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_GetAttributeNode(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, SetAttributeNode)
{
	zval *oaNewAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaNewAttr, TElXMLDOMAttr_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_SetAttributeNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaNewAttr TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, RemoveAttributeNode)
{
	zval *oaOldAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaOldAttr, TElXMLDOMAttr_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_RemoveAttributeNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaOldAttr TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetElementsByTagName)
{
	char *saName;
	int saName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_GetElementsByTagName(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, HasAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMElement_HasAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetOuterXMLCanonical)
{
	char *sInclNSPrefixList;
	int sInclNSPrefixList_len;
	long faMethod;
	uint32_t _err;
	zval *oReferenceNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &faMethod) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetOuterXMLCanonical(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-979734305, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &faMethod, &sInclNSPrefixList, &sInclNSPrefixList_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetOuterXMLCanonical_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, sInclNSPrefixList, (int32_t)sInclNSPrefixList_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1637498795, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &faMethod, &oReferenceNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetOuterXMLCanonical_2(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, SBGetObjectHandle(oReferenceNode TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-977352571, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsO!", &faMethod, &sInclNSPrefixList, &sInclNSPrefixList_len, &oReferenceNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetOuterXMLCanonical_3(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)faMethod, sInclNSPrefixList, (int32_t)sInclNSPrefixList_len, SBGetObjectHandle(oReferenceNode TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1584340673, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, string) or (integer, TElXMLDOMNode) or (integer, string, TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, InnerText)
{
	char *sSeparator;
	int sSeparator_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSeparator, &sSeparator_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_InnerText(SBGetObjectHandle(getThis() TSRMLS_CC), sSeparator, (int32_t)sSeparator_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1310739780, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetAttribute)
{
	char *saName;
	int saName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saName, &saName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1444231553, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, SetAttribute)
{
	char *saName;
	char *saValue;
	int saName_len;
	int saValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saName, &saName_len, &saValue, &saValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_SetAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, saValue, (int32_t)saValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetAttributeNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetAttributeNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1177147603, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, SetAttributeNS)
{
	char *saName;
	char *saNSURI;
	char *saValue;
	int saName_len;
	int saNSURI_len;
	int saValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &saNSURI, &saNSURI_len, &saName, &saName_len, &saValue, &saValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_SetAttributeNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, saValue, (int32_t)saValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, RemoveAttributeNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_RemoveAttributeNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetAttributeNodeNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_GetAttributeNodeNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, SetAttributeNodeNS)
{
	zval *oaNewAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaNewAttr, TElXMLDOMAttr_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_SetAttributeNodeNS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oaNewAttr TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetElementsByTagNameNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_GetElementsByTagNameNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNodeList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, HasAttribute)
{
	char *saName;
	int saName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saName, &saName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMElement_HasAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, HasAttributeNS)
{
	char *saName;
	char *saNSURI;
	int saName_len;
	int saNSURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saNSURI, &saNSURI_len, &saName, &saName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLDOMElement_HasAttributeNS(SBGetObjectHandle(getThis() TSRMLS_CC), saNSURI, (int32_t)saNSURI_len, saName, (int32_t)saName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, GetCurrentNSURI)
{
	char *ss;
	int ss_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &ss, &ss_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_GetCurrentNSURI(SBGetObjectHandle(getThis() TSRMLS_CC), ss, (int32_t)ss_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-413432038, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, get_TextContent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_get_TextContent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(779962570, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, set_TextContent)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_set_TextContent(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, get_InnerXML)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_get_InnerXML(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1872307175, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, set_InnerXML)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_set_InnerXML(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, get_AttribStrings)
{
	char *saName;
	int saName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saName, &saName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMElement_get_AttribStrings(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(174248822, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, set_AttribStrings)
{
	char *saName;
	char *saValue;
	int saName_len;
	int saValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &saName, &saName_len, &saValue, &saValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMElement_set_AttribStrings(SBGetObjectHandle(getThis() TSRMLS_CC), saName, (int32_t)saName_len, saValue, (int32_t)saValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_RemoveAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetAttributeNode, 0, 0, 1)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_SetAttributeNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aNewAttr, TElXMLDOMAttr, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_RemoveAttributeNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aOldAttr, TElXMLDOMAttr, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetElementsByTagName, 0, 0, 1)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_HasAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetOuterXMLCanonical, 0, 0, 1)
	ZEND_ARG_INFO(0, aMethod)
	ZEND_ARG_TYPE_INFO(0, InclNSPrefixList_or_ReferenceNode, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ReferenceNode, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_InnerText, 0, 0, 1)
	ZEND_ARG_INFO(0, Separator)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_SetAttribute, 0, 0, 2)
	ZEND_ARG_INFO(0, aName)
	ZEND_ARG_INFO(0, aValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetAttributeNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_SetAttributeNS, 0, 0, 3)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
	ZEND_ARG_INFO(0, aValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_RemoveAttributeNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetAttributeNodeNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_SetAttributeNodeNS, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aNewAttr, TElXMLDOMAttr, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetElementsByTagNameNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_HasAttribute, 0, 0, 1)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_HasAttributeNS, 0, 0, 2)
	ZEND_ARG_INFO(0, aNSURI)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_GetCurrentNSURI, 0, 0, 1)
	ZEND_ARG_INFO(0, s)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_get_TextContent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_set_TextContent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_get_InnerXML, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_set_InnerXML, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_get_AttribStrings, 0, 0, 1)
	ZEND_ARG_INFO(0, aName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement_set_AttribStrings, 0, 0, 2)
	ZEND_ARG_INFO(0, aName)
	ZEND_ARG_INFO(0, aValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMElement_methods[] = {
	PHP_ME(TElXMLDOMElement, CloneNode, arginfo_TElXMLDOMElement_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, RemoveAttribute, arginfo_TElXMLDOMElement_RemoveAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetAttributeNode, arginfo_TElXMLDOMElement_GetAttributeNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, SetAttributeNode, arginfo_TElXMLDOMElement_SetAttributeNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, RemoveAttributeNode, arginfo_TElXMLDOMElement_RemoveAttributeNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetElementsByTagName, arginfo_TElXMLDOMElement_GetElementsByTagName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, HasAttributes, arginfo_TElXMLDOMElement_HasAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetOuterXMLCanonical, arginfo_TElXMLDOMElement_GetOuterXMLCanonical, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, InnerText, arginfo_TElXMLDOMElement_InnerText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetAttribute, arginfo_TElXMLDOMElement_GetAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, SetAttribute, arginfo_TElXMLDOMElement_SetAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetAttributeNS, arginfo_TElXMLDOMElement_GetAttributeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, SetAttributeNS, arginfo_TElXMLDOMElement_SetAttributeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, RemoveAttributeNS, arginfo_TElXMLDOMElement_RemoveAttributeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetAttributeNodeNS, arginfo_TElXMLDOMElement_GetAttributeNodeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, SetAttributeNodeNS, arginfo_TElXMLDOMElement_SetAttributeNodeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetElementsByTagNameNS, arginfo_TElXMLDOMElement_GetElementsByTagNameNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, HasAttribute, arginfo_TElXMLDOMElement_HasAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, HasAttributeNS, arginfo_TElXMLDOMElement_HasAttributeNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, GetCurrentNSURI, arginfo_TElXMLDOMElement_GetCurrentNSURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, get_TextContent, arginfo_TElXMLDOMElement_get_TextContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, set_TextContent, arginfo_TElXMLDOMElement_set_TextContent, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, get_InnerXML, arginfo_TElXMLDOMElement_get_InnerXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, set_InnerXML, arginfo_TElXMLDOMElement_set_InnerXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, get_AttribStrings, arginfo_TElXMLDOMElement_get_AttribStrings, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, set_AttribStrings, arginfo_TElXMLDOMElement_set_AttribStrings, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMElement, __construct, arginfo_TElXMLDOMElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMElement", TElXMLDOMElement_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMText_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMText, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMText_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMText_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMText, SplitText)
{
	long l4ofs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4ofs) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMText_SplitText(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ofs, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMText_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMText, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMText_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMText_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMText_SplitText, 0, 0, 1)
	ZEND_ARG_INFO(0, ofs)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMText___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMText_methods[] = {
	PHP_ME(TElXMLDOMText, CloneNode, arginfo_TElXMLDOMText_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMText, SplitText, arginfo_TElXMLDOMText_SplitText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMText, __construct, arginfo_TElXMLDOMText___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMText(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMText_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMText", TElXMLDOMText_methods);
	if (NULL == TElXMLDOMCharacterData_ce_ptr)
		Register_TElXMLDOMCharacterData(TSRMLS_C);
	TElXMLDOMText_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMCharacterData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMComment_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMComment, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMComment_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMComment_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMComment, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMComment_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMComment_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMComment___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMComment_methods[] = {
	PHP_ME(TElXMLDOMComment, CloneNode, arginfo_TElXMLDOMComment_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMComment, __construct, arginfo_TElXMLDOMComment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMComment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMComment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMComment", TElXMLDOMComment_methods);
	if (NULL == TElXMLDOMCharacterData_ce_ptr)
		Register_TElXMLDOMCharacterData(TSRMLS_C);
	TElXMLDOMComment_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMCharacterData_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMCDATASection_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMCDATASection, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMCDATASection_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMCDATASection_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMCDATASection, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMCDATASection_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCDATASection_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMCDATASection___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMCDATASection_methods[] = {
	PHP_ME(TElXMLDOMCDATASection, CloneNode, arginfo_TElXMLDOMCDATASection_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMCDATASection, __construct, arginfo_TElXMLDOMCDATASection___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMCDATASection(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMCDATASection_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMCDATASection", TElXMLDOMCDATASection_methods);
	if (NULL == TElXMLDOMText_ce_ptr)
		Register_TElXMLDOMText(TSRMLS_C);
	TElXMLDOMCDATASection_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMText_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMDocumentType_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMDocumentType, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocumentType_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocumentType_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, ResolveExternalDTD)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLDOMDocumentType_ResolveExternalDTD(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocumentType_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-949583848, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, get_Entities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocumentType_get_Entities(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNamedNodeMap_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, get_Notations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocumentType_get_Notations(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNamedNodeMap_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, get_PublicID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocumentType_get_PublicID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(409733271, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, get_SystemID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocumentType_get_SystemID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1995310385, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, get_InternalSubset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMDocumentType_get_InternalSubset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1694089611, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMDocumentType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMDocumentType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_ResolveExternalDTD, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_get_Entities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_get_Notations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_get_PublicID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_get_SystemID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType_get_InternalSubset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMDocumentType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMDocumentType_methods[] = {
	PHP_ME(TElXMLDOMDocumentType, CloneNode, arginfo_TElXMLDOMDocumentType_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, ResolveExternalDTD, arginfo_TElXMLDOMDocumentType_ResolveExternalDTD, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, get_Name, arginfo_TElXMLDOMDocumentType_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, get_Entities, arginfo_TElXMLDOMDocumentType_get_Entities, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, get_Notations, arginfo_TElXMLDOMDocumentType_get_Notations, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, get_PublicID, arginfo_TElXMLDOMDocumentType_get_PublicID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, get_SystemID, arginfo_TElXMLDOMDocumentType_get_SystemID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, get_InternalSubset, arginfo_TElXMLDOMDocumentType_get_InternalSubset, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMDocumentType, __construct, arginfo_TElXMLDOMDocumentType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMDocumentType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMDocumentType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMDocumentType", TElXMLDOMDocumentType_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMDocumentType_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMNotation_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMNotation, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNotation_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNotation_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNotation, get_PublicID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNotation_get_PublicID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1798530777, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNotation, get_SystemID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMNotation_get_SystemID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-95513471, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMNotation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMNotation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNotation_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNotation_get_PublicID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNotation_get_SystemID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMNotation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMNotation_methods[] = {
	PHP_ME(TElXMLDOMNotation, CloneNode, arginfo_TElXMLDOMNotation_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNotation, get_PublicID, arginfo_TElXMLDOMNotation_get_PublicID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNotation, get_SystemID, arginfo_TElXMLDOMNotation_get_SystemID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMNotation, __construct, arginfo_TElXMLDOMNotation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMNotation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMNotation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMNotation", TElXMLDOMNotation_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMNotation_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMEntity_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMEntity, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMEntity_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMEntity_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMEntity, get_PublicID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMEntity_get_PublicID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1369956361, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMEntity, get_SystemID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMEntity_get_SystemID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1059450287, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMEntity, get_NotationName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMEntity_get_NotationName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-78150741, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMEntity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMEntity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntity_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntity_get_PublicID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntity_get_SystemID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntity_get_NotationName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMEntity_methods[] = {
	PHP_ME(TElXMLDOMEntity, CloneNode, arginfo_TElXMLDOMEntity_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMEntity, get_PublicID, arginfo_TElXMLDOMEntity_get_PublicID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMEntity, get_SystemID, arginfo_TElXMLDOMEntity_get_SystemID, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMEntity, get_NotationName, arginfo_TElXMLDOMEntity_get_NotationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMEntity, __construct, arginfo_TElXMLDOMEntity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMEntity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMEntity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMEntity", TElXMLDOMEntity_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMEntity_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMEntityReference_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMEntityReference, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMEntityReference_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMEntityReference_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMEntityReference, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMEntityReference_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntityReference_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMEntityReference___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMEntityReference_methods[] = {
	PHP_ME(TElXMLDOMEntityReference, CloneNode, arginfo_TElXMLDOMEntityReference_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMEntityReference, __construct, arginfo_TElXMLDOMEntityReference___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMEntityReference(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMEntityReference_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMEntityReference", TElXMLDOMEntityReference_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMEntityReference_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLDOMProcessingInstruction_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLDOMProcessingInstruction, CloneNode)
{
	zend_bool bDeep;
	zval *oaCloneOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bDeep, &oaCloneOwner, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMProcessingInstruction_CloneNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, SBGetObjectHandle(oaCloneOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeep) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMProcessingInstruction_CloneNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeep, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElXMLDOMDocument) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMProcessingInstruction, get_Target)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMProcessingInstruction_get_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1263917797, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMProcessingInstruction, get_Data)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLDOMProcessingInstruction_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1065500280, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLDOMProcessingInstruction, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLDOMProcessingInstruction_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMProcessingInstruction_CloneNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Deep)
	ZEND_ARG_OBJ_INFO(0, aCloneOwner, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMProcessingInstruction_get_Target, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMProcessingInstruction_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLDOMProcessingInstruction___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLDOMProcessingInstruction_methods[] = {
	PHP_ME(TElXMLDOMProcessingInstruction, CloneNode, arginfo_TElXMLDOMProcessingInstruction_CloneNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMProcessingInstruction, get_Target, arginfo_TElXMLDOMProcessingInstruction_get_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMProcessingInstruction, get_Data, arginfo_TElXMLDOMProcessingInstruction_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLDOMProcessingInstruction, __construct, arginfo_TElXMLDOMProcessingInstruction___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLDOMProcessingInstruction(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLDOMProcessingInstruction_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLDOMProcessingInstruction", TElXMLDOMProcessingInstruction_methods);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	TElXMLDOMProcessingInstruction_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLDOMNode_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLParser_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLParser, RaiseExc)
{
	char *saMsg;
	int saMsg_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saMsg, &saMsg_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_RaiseExc(SBGetObjectHandle(getThis() TSRMLS_CC), saMsg, (int32_t)saMsg_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, InitStream)
{
	char *sDefaultEncoding;
	int sDefaultEncoding_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDefaultEncoding, &sDefaultEncoding_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_InitStream(SBGetObjectHandle(getThis() TSRMLS_CC), sDefaultEncoding, (int32_t)sDefaultEncoding_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, bufInit)
{
	char *saArg;
	int32_t saArg_len;
	uint32_t _err;
	zval *zsaArg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsaArg) == SUCCESS) && PZVAL_IS_REF(zsaArg) && (IS_STRING == Z_TYPE_P(zsaArg)))
	{
		saArg = Z_STRVAL_P(zsaArg);
		saArg_len = (int32_t)Z_STRLEN_P(zsaArg);
		_err = TElXMLParser_bufInit(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, &saArg_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			saArg = emalloc(saArg_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1754624660, 1, saArg, &saArg_len) TSRMLS_CC);
			zval_dtor(zsaArg);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		saArg[saArg_len] = 0;
		ZVAL_STRINGL(zsaArg, saArg, saArg_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, bufAddChar)
{
	char *saArg;
	char *sc;
	int sc_len;
	int32_t saArg_len;
	uint32_t _err;
	zval *zsaArg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zs", &zsaArg, &sc, &sc_len) == SUCCESS) && PZVAL_IS_REF(zsaArg) && (IS_STRING == Z_TYPE_P(zsaArg)))
	{
		saArg = Z_STRVAL_P(zsaArg);
		saArg_len = (int32_t)Z_STRLEN_P(zsaArg);
		_err = TElXMLParser_bufAddChar(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, &saArg_len, sc, (int32_t)sc_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			saArg = emalloc(saArg_len + 1);
			SBCheckError(SBGetLastReturnStringA(1265710763, 1, saArg, &saArg_len) TSRMLS_CC);
			zval_dtor(zsaArg);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		saArg[saArg_len] = 0;
		ZVAL_STRINGL(zsaArg, saArg, saArg_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, bufFlush)
{
	char *saArg;
	int32_t saArg_len;
	uint32_t _err;
	zval *zsaArg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsaArg) == SUCCESS) && PZVAL_IS_REF(zsaArg) && (IS_STRING == Z_TYPE_P(zsaArg)))
	{
		saArg = Z_STRVAL_P(zsaArg);
		saArg_len = (int32_t)Z_STRLEN_P(zsaArg);
		_err = TElXMLParser_bufFlush(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, &saArg_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			saArg = emalloc(saArg_len + 1);
			SBCheckError(SBGetLastReturnStringA(-279391166, 1, saArg, &saArg_len) TSRMLS_CC);
			zval_dtor(zsaArg);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		saArg[saArg_len] = 0;
		ZVAL_STRINGL(zsaArg, saArg, saArg_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, bufFree)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLParser_bufFree(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, sEOF)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLParser_sEOF(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, NextChar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLParser_NextChar(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, PushData)
{
	char *sData;
	char *sMarker;
	int sData_len;
	int sMarker_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sData, &sData_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_PushData(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sData, &sData_len, &sMarker, &sMarker_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLParser_PushData_1(SBGetObjectHandle(getThis() TSRMLS_CC), sData, (int32_t)sData_len, sMarker, (int32_t)sMarker_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, Write)
{
	char *saArg;
	char *sc;
	int saArg_len;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saArg, &saArg_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_Write(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, (int32_t)saArg_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_Write_1(SBGetObjectHandle(getThis() TSRMLS_CC), sc, (int32_t)sc_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, SkipBlank)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLParser_SkipBlank(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, ExpectBlank)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLParser_ExpectBlank(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, ExpectString)
{
	char *saArg;
	int saArg_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saArg, &saArg_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_ExpectString(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, (int32_t)saArg_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, UntilString)
{
	char *saArg;
	int saArg_len;
	uint32_t _err;
	zend_bool bLeaveString;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &saArg, &saArg_len, &bLeaveString) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLParser_UntilString(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, (int32_t)saArg_len, (int8_t)bLeaveString, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1106973766, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, UntilStringSkip)
{
	char *saArg;
	int saArg_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &saArg, &saArg_len) == SUCCESS)
	{
		SBCheckError(TElXMLParser_UntilStringSkip(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, (int32_t)saArg_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, CheckForMulti)
{
	SBArrayZValInfo aiExpect;
	zend_bool bRecall;
	zval *zaExpect;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaExpect, &bRecall) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaExpect)) || (IS_NULL == Z_TYPE_P(zaExpect))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetInt32ArrayFromZVal(zaExpect, &aiExpect TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLParser_CheckForMulti(SBGetObjectHandle(getThis() TSRMLS_CC), aiExpect.data, aiExpect.len, (int8_t)bRecall, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiExpect);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of int32|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, CheckFor)
{
	char *saArg;
	int saArg_len;
	zend_bool bRecall;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &saArg, &saArg_len, &bRecall) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLParser_CheckFor(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, (int32_t)saArg_len, (int8_t)bRecall, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, GetWhile)
{
	long l4aCharKind;
	uint32_t _err;
	zval *zaFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaFunc) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zaFunc))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLParser_GetWhile(SBGetObjectHandle(getThis() TSRMLS_CC), NULL, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(863152122, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4aCharKind) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLParser_GetWhile_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4aCharKind, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-576565608, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, GetUntil)
{
	long l4aCharKind;
	uint32_t _err;
	zval *zaFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaFunc) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zaFunc))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLParser_GetUntil(SBGetObjectHandle(getThis() TSRMLS_CC), NULL, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-978523705, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4aCharKind) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLParser_GetUntil_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4aCharKind, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-522963717, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, GetUntilSkip)
{
	long l4aCharKind;
	zval *zaFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaFunc) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zaFunc))))
	{
		SBCheckError(TElXMLParser_GetUntilSkip(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4aCharKind) == SUCCESS)
	{
		SBCheckError(TElXMLParser_GetUntilSkip_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4aCharKind) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, GetNMtok)
{
	char *saArg;
	int32_t saArg_len;
	uint32_t _err;
	zval *zsaArg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsaArg) == SUCCESS) && PZVAL_IS_REF(zsaArg) && (IS_STRING == Z_TYPE_P(zsaArg)))
	{
		int8_t bOutResultRaw = 0;
		saArg = Z_STRVAL_P(zsaArg);
		saArg_len = (int32_t)Z_STRLEN_P(zsaArg);
		_err = TElXMLParser_GetNMtok(SBGetObjectHandle(getThis() TSRMLS_CC), saArg, &saArg_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			saArg = emalloc(saArg_len + 1);
			SBCheckError(SBGetLastReturnStringA(-626496359, 1, saArg, &saArg_len) TSRMLS_CC);
			zval_dtor(zsaArg);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		saArg[saArg_len] = 0;
		ZVAL_STRINGL(zsaArg, saArg, saArg_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, get_sPos)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLParser_get_sPos(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, set_sPos)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElXMLParser_set_sPos(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, get_LastPos)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLParser_get_LastPos(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, get_Last)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLParser_get_Last(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1001541744, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, get_NormalizeNEL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLParser_get_NormalizeNEL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, set_NormalizeNEL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLParser_set_NormalizeNEL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, get_OEnc)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLParser_get_OEnc(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCodec_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, set_OEnc)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLCodec_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLParser_set_OEnc(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCodec)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLParser, __construct)
{
	char *sDefaultEncoding;
	int sDefaultEncoding_len;
	zend_bool bDoInitStream;
	zend_bool bNormNEL;
	zval *oaDoc;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bsb", &oaDoc, TElXMLDOMDocument_ce_ptr, &bDoInitStream, &sDefaultEncoding, &sDefaultEncoding_len, &bNormNEL) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLParser_Create(SBGetObjectHandle(oaDoc TSRMLS_CC), (int8_t)bDoInitStream, sDefaultEncoding, (int32_t)sDefaultEncoding_len, (int8_t)bNormNEL, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, bool, string, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_RaiseExc, 0, 0, 1)
	ZEND_ARG_INFO(0, aMsg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_InitStream, 0, 0, 1)
	ZEND_ARG_INFO(0, DefaultEncoding)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_bufInit, 0, 0, 1)
	ZEND_ARG_INFO(1, aArg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_bufAddChar, 0, 0, 2)
	ZEND_ARG_INFO(1, aArg)
	ZEND_ARG_INFO(0, c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_bufFlush, 0, 0, 1)
	ZEND_ARG_INFO(1, aArg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_bufFree, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_sEOF, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_NextChar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_PushData, 0, 0, 1)
	ZEND_ARG_INFO(0, Data)
	ZEND_ARG_INFO(0, Marker)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_Write, 0, 0, 1)
	ZEND_ARG_INFO(0, aArg_or_c)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_SkipBlank, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_ExpectBlank, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_ExpectString, 0, 0, 1)
	ZEND_ARG_INFO(0, aArg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_UntilString, 0, 0, 2)
	ZEND_ARG_INFO(0, aArg)
	ZEND_ARG_INFO(0, LeaveString)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_UntilStringSkip, 0, 0, 1)
	ZEND_ARG_INFO(0, aArg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_CheckForMulti, 0, 0, 2)
	ZEND_ARG_ARRAY_INFO(0, Expect, 1)
	ZEND_ARG_INFO(0, Recall)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_CheckFor, 0, 0, 2)
	ZEND_ARG_INFO(0, aArg)
	ZEND_ARG_INFO(0, Recall)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_GetWhile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, aFunc_or_aCharKind, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_GetUntil, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, aFunc_or_aCharKind, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_GetUntilSkip, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, aFunc_or_aCharKind, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_GetNMtok, 0, 0, 1)
	ZEND_ARG_INFO(1, aArg)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_get_sPos, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_set_sPos, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_get_LastPos, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_get_Last, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_get_NormalizeNEL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_set_NormalizeNEL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_get_OEnc, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser_set_OEnc, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLCodec, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLParser___construct, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, aDoc, TElXMLDOMDocument, 1)
	ZEND_ARG_INFO(0, DoInitStream)
	ZEND_ARG_INFO(0, DefaultEncoding)
	ZEND_ARG_INFO(0, NormNEL)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLParser_methods[] = {
	PHP_ME(TElXMLParser, RaiseExc, arginfo_TElXMLParser_RaiseExc, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, InitStream, arginfo_TElXMLParser_InitStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, bufInit, arginfo_TElXMLParser_bufInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, bufAddChar, arginfo_TElXMLParser_bufAddChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, bufFlush, arginfo_TElXMLParser_bufFlush, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, bufFree, arginfo_TElXMLParser_bufFree, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, sEOF, arginfo_TElXMLParser_sEOF, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, NextChar, arginfo_TElXMLParser_NextChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, PushData, arginfo_TElXMLParser_PushData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, Write, arginfo_TElXMLParser_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, SkipBlank, arginfo_TElXMLParser_SkipBlank, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, ExpectBlank, arginfo_TElXMLParser_ExpectBlank, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, ExpectString, arginfo_TElXMLParser_ExpectString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, UntilString, arginfo_TElXMLParser_UntilString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, UntilStringSkip, arginfo_TElXMLParser_UntilStringSkip, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, CheckForMulti, arginfo_TElXMLParser_CheckForMulti, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, CheckFor, arginfo_TElXMLParser_CheckFor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, GetWhile, arginfo_TElXMLParser_GetWhile, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, GetUntil, arginfo_TElXMLParser_GetUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, GetUntilSkip, arginfo_TElXMLParser_GetUntilSkip, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, GetNMtok, arginfo_TElXMLParser_GetNMtok, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, get_sPos, arginfo_TElXMLParser_get_sPos, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, set_sPos, arginfo_TElXMLParser_set_sPos, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, get_LastPos, arginfo_TElXMLParser_get_LastPos, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, get_Last, arginfo_TElXMLParser_get_Last, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, get_NormalizeNEL, arginfo_TElXMLParser_get_NormalizeNEL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, set_NormalizeNEL, arginfo_TElXMLParser_set_NormalizeNEL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, get_OEnc, arginfo_TElXMLParser_get_OEnc, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, set_OEnc, arginfo_TElXMLParser_set_OEnc, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLParser, __construct, arginfo_TElXMLParser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLParser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLParser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLParser", TElXMLParser_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLParser_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLNamespaceMap_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLNamespaceMap, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLNamespaceMap_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, Add)
{
	zend_bool bOverwriteIfExists;
	zval *oNSMap;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oNSMap, TElXMLNamespaceMap_ce_ptr, &bOverwriteIfExists) == SUCCESS)
	{
		SBCheckError(TElXMLNamespaceMap_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNSMap TSRMLS_CC), (int8_t)bOverwriteIfExists) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLNamespaceMap, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, AddNamespace)
{
	char *sPrefix;
	char *sURI;
	int sPrefix_len;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPrefix, &sPrefix_len, &sURI, &sURI_len) == SUCCESS)
	{
		SBCheckError(TElXMLNamespaceMap_AddNamespace(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sURI, (int32_t)sURI_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, RemoveNamespace)
{
	char *sPrefix;
	int sPrefix_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPrefix, &sPrefix_len) == SUCCESS)
	{
		SBCheckError(TElXMLNamespaceMap_RemoveNamespace(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, FindNamespace)
{
	char *sPrefix;
	int sPrefix_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPrefix, &sPrefix_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLNamespaceMap_FindNamespace(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1713285262, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, FindPrefix)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLNamespaceMap_FindPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1691813738, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLNamespaceMap_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, get_Prefix)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLNamespaceMap_get_Prefix(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1108027799, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, get_URI)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLNamespaceMap_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-617928468, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLNamespaceMap, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLNamespaceMap_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_Add, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, NSMap, TElXMLNamespaceMap, 1)
	ZEND_ARG_INFO(0, OverwriteIfExists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_AddNamespace, 0, 0, 2)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_RemoveNamespace, 0, 0, 1)
	ZEND_ARG_INFO(0, Prefix)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_FindNamespace, 0, 0, 1)
	ZEND_ARG_INFO(0, Prefix)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_FindPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_get_Prefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap_get_URI, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLNamespaceMap___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLNamespaceMap_methods[] = {
	PHP_ME(TElXMLNamespaceMap, Clear, arginfo_TElXMLNamespaceMap_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, Add, arginfo_TElXMLNamespaceMap_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, AddNamespace, arginfo_TElXMLNamespaceMap_AddNamespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, RemoveNamespace, arginfo_TElXMLNamespaceMap_RemoveNamespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, FindNamespace, arginfo_TElXMLNamespaceMap_FindNamespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, FindPrefix, arginfo_TElXMLNamespaceMap_FindPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, get_Count, arginfo_TElXMLNamespaceMap_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, get_Prefix, arginfo_TElXMLNamespaceMap_get_Prefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, get_URI, arginfo_TElXMLNamespaceMap_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLNamespaceMap, __construct, arginfo_TElXMLNamespaceMap___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLNamespaceMap(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLNamespaceMap_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLNamespaceMap", TElXMLNamespaceMap_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLNamespaceMap_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCustomFormatter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCustomFormatter, AppendElement)
{
	zval *oChild;
	zval *oDocument;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oParent, TElXMLDOMElement_ce_ptr, &oChild, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_AppendElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oParent, TElXMLDOMElement_ce_ptr, &oChild, TElXMLCustomElement_ce_ptr, &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomFormatter_AppendElement_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMElement) or (TElXMLDOMElement, TElXMLCustomElement, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, AppendElementWithText)
{
	char *sChildText;
	int sChildText_len;
	long fChildTextType;
	zval *oChild;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sl", &oParent, TElXMLDOMElement_ce_ptr, &oChild, TElXMLDOMElement_ce_ptr, &sChildText, &sChildText_len, &fChildTextType) == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_AppendElementWithText(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC), sChildText, (int32_t)sChildText_len, (TElXMLTextTypeRaw)fChildTextType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMElement, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, AppendText)
{
	char *sText;
	int sText_len;
	long fTextType;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oParent, TElXMLDOMElement_ce_ptr, &sText, &sText_len, &fTextType) == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_AppendText(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), sText, (int32_t)sText_len, (TElXMLTextTypeRaw)fTextType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, InsertBefore)
{
	zval *oChild;
	zval *oChildRef;
	zval *oDocument;
	zval *oParent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oParent, TElXMLDOMElement_ce_ptr, &oChildRef, TElXMLDOMNode_ce_ptr, &oChild, TElXMLCustomElement_ce_ptr, &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_InsertBefore(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParent TSRMLS_CC), SBGetObjectHandle(oChildRef TSRMLS_CC), SBGetObjectHandle(oChild TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMNode, TElXMLCustomElement, TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, Push)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_Push(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, Pop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCustomFormatter_Pop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomFormatter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomFormatter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_AppendElement, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_TYPE_INFO(0, Child, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_AppendElementWithText, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, Child, TElXMLDOMElement, 1)
	ZEND_ARG_INFO(0, ChildText)
	ZEND_ARG_INFO(0, ChildTextType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_AppendText, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_INFO(0, Text)
	ZEND_ARG_INFO(0, TextType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_InsertBefore, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Parent, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, ChildRef, TElXMLDOMNode, 1)
	ZEND_ARG_OBJ_INFO(0, Child, TElXMLCustomElement, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_Push, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter_Pop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomFormatter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCustomFormatter_methods[] = {
	PHP_ME(TElXMLCustomFormatter, AppendElement, arginfo_TElXMLCustomFormatter_AppendElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, AppendElementWithText, arginfo_TElXMLCustomFormatter_AppendElementWithText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, AppendText, arginfo_TElXMLCustomFormatter_AppendText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, InsertBefore, arginfo_TElXMLCustomFormatter_InsertBefore, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, Clear, arginfo_TElXMLCustomFormatter_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, Push, arginfo_TElXMLCustomFormatter_Push, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, Pop, arginfo_TElXMLCustomFormatter_Pop, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomFormatter, __construct, arginfo_TElXMLCustomFormatter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCustomFormatter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCustomFormatter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCustomFormatter", TElXMLCustomFormatter_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCustomFormatter_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLCustomElement_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLCustomElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLCustomElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument) or (TElXMLDOMDocument, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomElement, get_XMLElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomElement_get_XMLElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomElement, set_XMLElement)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLCustomElement_set_XMLElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLCustomElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLCustomElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomElement_get_XMLElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomElement_set_XMLElement, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLCustomElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLCustomElement_methods[] = {
	PHP_ME(TElXMLCustomElement, Clear, arginfo_TElXMLCustomElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomElement, LoadFromXML, arginfo_TElXMLCustomElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomElement, SaveToXML, arginfo_TElXMLCustomElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomElement, get_XMLElement, arginfo_TElXMLCustomElement_get_XMLElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomElement, set_XMLElement, arginfo_TElXMLCustomElement_set_XMLElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLCustomElement, __construct, arginfo_TElXMLCustomElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLCustomElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLCustomElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLCustomElement", TElXMLCustomElement_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLCustomElement_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLCore, isXMLIdeographic)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBXMLCore_isXMLIdeographic(sc, (int32_t)sc_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLCore, isXMLBaseChar)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBXMLCore_isXMLBaseChar(sc, (int32_t)sc_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLCore, isXMLCombining)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBXMLCore_isXMLCombining(sc, (int32_t)sc_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLCore, isXMLDigit)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBXMLCore_isXMLDigit(sc, (int32_t)sc_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLCore, isXMLExtender)
{
	char *sc;
	int sc_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sc, &sc_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBXMLCore_isXMLExtender(sc, (int32_t)sc_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

void Register_SBXMLCore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntElement, SB_ntElement, SB_ntElement);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntAttribute, SB_ntAttribute, SB_ntAttribute);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntText, SB_ntText, SB_ntText);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntCDataSection, SB_ntCDataSection, SB_ntCDataSection);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntEntityReference, SB_ntEntityReference, SB_ntEntityReference);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntEntity, SB_ntEntity, SB_ntEntity);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntProcessingInstruction, SB_ntProcessingInstruction, SB_ntProcessingInstruction);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntComment, SB_ntComment, SB_ntComment);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntDocument, SB_ntDocument, SB_ntDocument);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntDocumentType, SB_ntDocumentType, SB_ntDocumentType);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntDocumentFragment, SB_ntDocumentFragment, SB_ntDocumentFragment);
	SB_REGISTER_LONG_CONSTANT(SBXMLCore, ntNotation, SB_ntNotation, SB_ntNotation);
}

void Register_SBXMLCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElXMLDelayLoadModeType", NULL);
	TElXMLDelayLoadModeType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXMLDelayLoadModeType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDelayLoadModeType_ce_ptr, "dlmCDATA", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDelayLoadModeType_ce_ptr, "dlmComment", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDelayLoadModeType_ce_ptr, "dlmText", 2)
	
	INIT_CLASS_ENTRY(ce, "TElXMLDelayLoadMode", NULL);
	TElXMLDelayLoadMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElXMLDelayLoadMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDelayLoadMode_ce_ptr, "dlmCDATA", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDelayLoadMode_ce_ptr, "dlmComment", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElXMLDelayLoadMode_ce_ptr, "dlmText", 4)
}

void Register_SBXMLCore_Aliases(TSRMLS_D)
{
	if (NULL == TElXMLDOMImplementation_ce_ptr)
		Register_TElXMLDOMImplementation(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMImplementation", TElXMLDOMImplementation_ce_ptr);
	if (NULL == TElXMLDOMDocumentFragment_ce_ptr)
		Register_TElXMLDOMDocumentFragment(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMDocumentFragment", TElXMLDOMDocumentFragment_ce_ptr);
	if (NULL == TElXMLDOMDocument_ce_ptr)
		Register_TElXMLDOMDocument(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMDocument", TElXMLDOMDocument_ce_ptr);
	if (NULL == TElXMLDOMNode_ce_ptr)
		Register_TElXMLDOMNode(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMNode", TElXMLDOMNode_ce_ptr);
	if (NULL == TElXMLNodeSet_ce_ptr)
		Register_TElXMLNodeSet(TSRMLS_C);
	zend_register_class_alias("ElXMLNodeSet", TElXMLNodeSet_ce_ptr);
	if (NULL == TElXMLDOMNodeList_ce_ptr)
		Register_TElXMLDOMNodeList(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMNodeList", TElXMLDOMNodeList_ce_ptr);
	if (NULL == TElXMLDOMNamedNodeMap_ce_ptr)
		Register_TElXMLDOMNamedNodeMap(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMNamedNodeMap", TElXMLDOMNamedNodeMap_ce_ptr);
	if (NULL == TElXMLDOMCharacterData_ce_ptr)
		Register_TElXMLDOMCharacterData(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMCharacterData", TElXMLDOMCharacterData_ce_ptr);
	if (NULL == TElXMLDOMAttr_ce_ptr)
		Register_TElXMLDOMAttr(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMAttr", TElXMLDOMAttr_ce_ptr);
	if (NULL == TElXMLDOMElement_ce_ptr)
		Register_TElXMLDOMElement(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMElement", TElXMLDOMElement_ce_ptr);
	if (NULL == TElXMLDOMText_ce_ptr)
		Register_TElXMLDOMText(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMText", TElXMLDOMText_ce_ptr);
	if (NULL == TElXMLDOMComment_ce_ptr)
		Register_TElXMLDOMComment(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMComment", TElXMLDOMComment_ce_ptr);
	if (NULL == TElXMLDOMCDATASection_ce_ptr)
		Register_TElXMLDOMCDATASection(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMCDATASection", TElXMLDOMCDATASection_ce_ptr);
	if (NULL == TElXMLDOMDocumentType_ce_ptr)
		Register_TElXMLDOMDocumentType(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMDocumentType", TElXMLDOMDocumentType_ce_ptr);
	if (NULL == TElXMLDOMNotation_ce_ptr)
		Register_TElXMLDOMNotation(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMNotation", TElXMLDOMNotation_ce_ptr);
	if (NULL == TElXMLDOMEntity_ce_ptr)
		Register_TElXMLDOMEntity(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMEntity", TElXMLDOMEntity_ce_ptr);
	if (NULL == TElXMLDOMEntityReference_ce_ptr)
		Register_TElXMLDOMEntityReference(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMEntityReference", TElXMLDOMEntityReference_ce_ptr);
	if (NULL == TElXMLDOMProcessingInstruction_ce_ptr)
		Register_TElXMLDOMProcessingInstruction(TSRMLS_C);
	zend_register_class_alias("ElXMLDOMProcessingInstruction", TElXMLDOMProcessingInstruction_ce_ptr);
	if (NULL == TElXMLParser_ce_ptr)
		Register_TElXMLParser(TSRMLS_C);
	zend_register_class_alias("ElXMLParser", TElXMLParser_ce_ptr);
	if (NULL == TElXMLNamespaceMap_ce_ptr)
		Register_TElXMLNamespaceMap(TSRMLS_C);
	zend_register_class_alias("ElXMLNamespaceMap", TElXMLNamespaceMap_ce_ptr);
	if (NULL == TElXMLCustomFormatter_ce_ptr)
		Register_TElXMLCustomFormatter(TSRMLS_C);
	zend_register_class_alias("ElXMLCustomFormatter", TElXMLCustomFormatter_ce_ptr);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	zend_register_class_alias("ElXMLCustomElement", TElXMLCustomElement_ce_ptr);
}

